#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 4400
#define LARGE_STATE_COUNT 865
#define SYMBOL_COUNT 359
#define ALIAS_COUNT 8
#define TOKEN_COUNT 158
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 42
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 267

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_SLASH = 48,
  sym_jsx_text = 49,
  sym_jsx_identifier = 50,
  anon_sym_DOT = 51,
  anon_sym_class = 52,
  anon_sym_async = 53,
  anon_sym_function = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_QMARK_DOT = 56,
  anon_sym_new = 57,
  anon_sym_PLUS_EQ = 58,
  anon_sym_DASH_EQ = 59,
  anon_sym_STAR_EQ = 60,
  anon_sym_SLASH_EQ = 61,
  anon_sym_PERCENT_EQ = 62,
  anon_sym_CARET_EQ = 63,
  anon_sym_AMP_EQ = 64,
  anon_sym_PIPE_EQ = 65,
  anon_sym_GT_GT_EQ = 66,
  anon_sym_GT_GT_GT_EQ = 67,
  anon_sym_LT_LT_EQ = 68,
  anon_sym_STAR_STAR_EQ = 69,
  anon_sym_AMP_AMP_EQ = 70,
  anon_sym_PIPE_PIPE_EQ = 71,
  anon_sym_QMARK_QMARK_EQ = 72,
  anon_sym_DOT_DOT_DOT = 73,
  anon_sym_AMP_AMP = 74,
  anon_sym_PIPE_PIPE = 75,
  anon_sym_GT_GT = 76,
  anon_sym_GT_GT_GT = 77,
  anon_sym_LT_LT = 78,
  anon_sym_AMP = 79,
  anon_sym_CARET = 80,
  anon_sym_PIPE = 81,
  anon_sym_PLUS = 82,
  anon_sym_DASH = 83,
  anon_sym_PERCENT = 84,
  anon_sym_STAR_STAR = 85,
  anon_sym_LT_EQ = 86,
  anon_sym_EQ_EQ = 87,
  anon_sym_EQ_EQ_EQ = 88,
  anon_sym_BANG_EQ = 89,
  anon_sym_BANG_EQ_EQ = 90,
  anon_sym_GT_EQ = 91,
  anon_sym_QMARK_QMARK = 92,
  anon_sym_instanceof = 93,
  anon_sym_TILDE = 94,
  anon_sym_void = 95,
  anon_sym_delete = 96,
  anon_sym_PLUS_PLUS = 97,
  anon_sym_DASH_DASH = 98,
  anon_sym_DQUOTE = 99,
  anon_sym_SQUOTE = 100,
  sym_unescaped_double_string_fragment = 101,
  sym_unescaped_single_string_fragment = 102,
  sym_escape_sequence = 103,
  sym_comment = 104,
  anon_sym_BQUOTE = 105,
  anon_sym_DOLLAR_LBRACE = 106,
  anon_sym_SLASH2 = 107,
  sym_regex_pattern = 108,
  sym_regex_flags = 109,
  sym_number = 110,
  sym_private_property_identifier = 111,
  anon_sym_target = 112,
  sym_this = 113,
  sym_super = 114,
  sym_true = 115,
  sym_false = 116,
  sym_null = 117,
  sym_undefined = 118,
  anon_sym_AT = 119,
  anon_sym_static = 120,
  anon_sym_readonly = 121,
  anon_sym_get = 122,
  anon_sym_set = 123,
  anon_sym_QMARK = 124,
  anon_sym_declare = 125,
  anon_sym_public = 126,
  anon_sym_private = 127,
  anon_sym_protected = 128,
  anon_sym_override = 129,
  anon_sym_module = 130,
  anon_sym_any = 131,
  anon_sym_number = 132,
  anon_sym_boolean = 133,
  anon_sym_string = 134,
  anon_sym_symbol = 135,
  anon_sym_abstract = 136,
  anon_sym_require = 137,
  anon_sym_extends = 138,
  anon_sym_implements = 139,
  anon_sym_global = 140,
  anon_sym_interface = 141,
  anon_sym_enum = 142,
  anon_sym_DASH_QMARK_COLON = 143,
  anon_sym_QMARK_COLON = 144,
  anon_sym_asserts = 145,
  anon_sym_infer = 146,
  anon_sym_is = 147,
  anon_sym_keyof = 148,
  anon_sym_unknown = 149,
  anon_sym_never = 150,
  anon_sym_object = 151,
  anon_sym_LBRACE_PIPE = 152,
  anon_sym_PIPE_RBRACE = 153,
  sym__automatic_semicolon = 154,
  sym__template_chars = 155,
  sym__ternary_qmark = 156,
  sym__function_signature_automatic_semicolon = 157,
  sym_program = 158,
  sym_export_statement = 159,
  sym_export_clause = 160,
  sym__import_export_specifier = 161,
  sym_declaration = 162,
  sym_import = 163,
  sym_import_statement = 164,
  sym_import_clause = 165,
  sym__from_clause = 166,
  sym_namespace_import_export = 167,
  sym_named_imports = 168,
  sym_expression_statement = 169,
  sym_variable_declaration = 170,
  sym_lexical_declaration = 171,
  sym_variable_declarator = 172,
  sym_statement_block = 173,
  sym_else_clause = 174,
  sym_if_statement = 175,
  sym_switch_statement = 176,
  sym_for_statement = 177,
  sym_for_in_statement = 178,
  sym__for_header = 179,
  sym_while_statement = 180,
  sym_do_statement = 181,
  sym_try_statement = 182,
  sym_with_statement = 183,
  sym_break_statement = 184,
  sym_continue_statement = 185,
  sym_debugger_statement = 186,
  sym_return_statement = 187,
  sym_throw_statement = 188,
  sym_empty_statement = 189,
  sym_labeled_statement = 190,
  sym_switch_body = 191,
  sym_switch_case = 192,
  sym_switch_default = 193,
  sym_catch_clause = 194,
  sym_finally_clause = 195,
  sym_parenthesized_expression = 196,
  sym_expression = 197,
  sym_primary_expression = 198,
  sym_yield_expression = 199,
  sym_object = 200,
  sym_object_pattern = 201,
  sym_assignment_pattern = 202,
  sym_object_assignment_pattern = 203,
  sym_array = 204,
  sym_array_pattern = 205,
  sym_jsx_element = 206,
  sym_jsx_fragment = 207,
  sym_jsx_expression = 208,
  sym_jsx_opening_element = 209,
  sym_nested_identifier = 210,
  sym_jsx_namespace_name = 211,
  sym_jsx_closing_element = 212,
  sym_jsx_self_closing_element = 213,
  sym_jsx_attribute = 214,
  sym_class = 215,
  sym_class_declaration = 216,
  sym_class_heritage = 217,
  sym_function = 218,
  sym_function_declaration = 219,
  sym_generator_function = 220,
  sym_generator_function_declaration = 221,
  sym_arrow_function = 222,
  sym__call_signature = 223,
  sym__formal_parameter = 224,
  sym_call_expression = 225,
  sym_new_expression = 226,
  sym_await_expression = 227,
  sym_member_expression = 228,
  sym_subscript_expression = 229,
  sym_assignment_expression = 230,
  sym__augmented_assignment_lhs = 231,
  sym_augmented_assignment_expression = 232,
  sym__initializer = 233,
  sym__destructuring_pattern = 234,
  sym_spread_element = 235,
  sym_ternary_expression = 236,
  sym_binary_expression = 237,
  sym_unary_expression = 238,
  sym_update_expression = 239,
  sym_sequence_expression = 240,
  sym_string = 241,
  sym_template_string = 242,
  sym_template_substitution = 243,
  sym_regex = 244,
  sym_meta_property = 245,
  sym_arguments = 246,
  sym_decorator = 247,
  sym_decorator_member_expression = 248,
  sym_decorator_call_expression = 249,
  sym_class_body = 250,
  sym_formal_parameters = 251,
  sym_pattern = 252,
  sym_rest_pattern = 253,
  sym_method_definition = 254,
  sym_pair = 255,
  sym_pair_pattern = 256,
  sym__property_name = 257,
  sym_computed_property_name = 258,
  sym_public_field_definition = 259,
  sym_non_null_expression = 260,
  sym_method_signature = 261,
  sym_abstract_method_signature = 262,
  sym_function_signature = 263,
  sym_as_expression = 264,
  sym_import_require_clause = 265,
  sym_extends_clause = 266,
  sym_implements_clause = 267,
  sym_ambient_declaration = 268,
  sym_abstract_class_declaration = 269,
  sym_module = 270,
  sym_internal_module = 271,
  sym__module = 272,
  sym_import_alias = 273,
  sym_nested_type_identifier = 274,
  sym_interface_declaration = 275,
  sym_extends_type_clause = 276,
  sym_enum_declaration = 277,
  sym_enum_body = 278,
  sym_enum_assignment = 279,
  sym_type_alias_declaration = 280,
  sym_accessibility_modifier = 281,
  sym_override_modifier = 282,
  sym_required_parameter = 283,
  sym_optional_parameter = 284,
  sym__parameter_name = 285,
  sym_omitting_type_annotation = 286,
  sym_opting_type_annotation = 287,
  sym_type_annotation = 288,
  sym_asserts = 289,
  sym__type = 290,
  sym_tuple_parameter = 291,
  sym_optional_tuple_parameter = 292,
  sym_optional_type = 293,
  sym_rest_type = 294,
  sym__tuple_type_member = 295,
  sym_constructor_type = 296,
  sym__primary_type = 297,
  sym_template_type = 298,
  sym_template_literal_type = 299,
  sym_infer_type = 300,
  sym_conditional_type = 301,
  sym_generic_type = 302,
  sym_type_predicate = 303,
  sym_type_predicate_annotation = 304,
  sym__type_query_member_expression = 305,
  sym__type_query_subscript_expression = 306,
  sym__type_query_call_expression = 307,
  sym_type_query = 308,
  sym_index_type_query = 309,
  sym_lookup_type = 310,
  sym_mapped_type_clause = 311,
  sym_literal_type = 312,
  sym__number = 313,
  sym_existential_type = 314,
  sym_flow_maybe_type = 315,
  sym_parenthesized_type = 316,
  sym_predefined_type = 317,
  sym_type_arguments = 318,
  sym_object_type = 319,
  sym_call_signature = 320,
  sym_property_signature = 321,
  sym_type_parameters = 322,
  sym_type_parameter = 323,
  sym_default_type = 324,
  sym_constraint = 325,
  sym_construct_signature = 326,
  sym_index_signature = 327,
  sym_array_type = 328,
  sym_tuple_type = 329,
  sym_readonly_type = 330,
  sym_union_type = 331,
  sym_intersection_type = 332,
  sym_function_type = 333,
  aux_sym_program_repeat1 = 334,
  aux_sym_export_statement_repeat1 = 335,
  aux_sym_export_clause_repeat1 = 336,
  aux_sym_named_imports_repeat1 = 337,
  aux_sym_variable_declaration_repeat1 = 338,
  aux_sym_switch_body_repeat1 = 339,
  aux_sym_object_repeat1 = 340,
  aux_sym_object_pattern_repeat1 = 341,
  aux_sym_array_repeat1 = 342,
  aux_sym_array_pattern_repeat1 = 343,
  aux_sym_jsx_element_repeat1 = 344,
  aux_sym_string_repeat1 = 345,
  aux_sym_string_repeat2 = 346,
  aux_sym_template_string_repeat1 = 347,
  aux_sym_class_body_repeat1 = 348,
  aux_sym_formal_parameters_repeat1 = 349,
  aux_sym__jsx_start_opening_element_repeat1 = 350,
  aux_sym_extends_clause_repeat1 = 351,
  aux_sym_implements_clause_repeat1 = 352,
  aux_sym_extends_type_clause_repeat1 = 353,
  aux_sym_enum_body_repeat1 = 354,
  aux_sym_template_literal_type_repeat1 = 355,
  aux_sym_object_type_repeat1 = 356,
  aux_sym_type_parameters_repeat1 = 357,
  aux_sym_tuple_type_repeat1 = 358,
  alias_sym_import_specifier = 359,
  alias_sym_namespace_export = 360,
  alias_sym_property_identifier = 361,
  alias_sym_shorthand_property_identifier = 362,
  alias_sym_shorthand_property_identifier_pattern = 363,
  alias_sym_statement_identifier = 364,
  alias_sym_this_type = 365,
  alias_sym_type_identifier = 366,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_abstract] = "abstract",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import_export] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym__jsx_start_opening_element_repeat1] = "_jsx_start_opening_element_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_namespace_export] = "namespace_export",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import_export] = sym_namespace_import_export,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym__jsx_start_opening_element_repeat1] = aux_sym__jsx_start_opening_element_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_namespace_export] = alias_sym_namespace_export,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import_export] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__jsx_start_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constraint = 10,
  field_constructor = 11,
  field_declaration = 12,
  field_decorator = 13,
  field_finalizer = 14,
  field_flags = 15,
  field_function = 16,
  field_handler = 17,
  field_increment = 18,
  field_index = 19,
  field_index_type = 20,
  field_initializer = 21,
  field_key = 22,
  field_kind = 23,
  field_label = 24,
  field_left = 25,
  field_module = 26,
  field_name = 27,
  field_object = 28,
  field_open_tag = 29,
  field_operator = 30,
  field_parameter = 31,
  field_parameters = 32,
  field_pattern = 33,
  field_property = 34,
  field_return_type = 35,
  field_right = 36,
  field_sign = 37,
  field_source = 38,
  field_type = 39,
  field_type_arguments = 40,
  field_type_parameters = 41,
  field_value = 42,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 1},
  [12] = {.index = 3, .length = 1},
  [13] = {.index = 12, .length = 1},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 2},
  [19] = {.index = 23, .length = 2},
  [20] = {.index = 25, .length = 1},
  [21] = {.index = 26, .length = 2},
  [22] = {.index = 28, .length = 2},
  [23] = {.index = 30, .length = 2},
  [24] = {.index = 32, .length = 2},
  [28] = {.index = 34, .length = 1},
  [29] = {.index = 35, .length = 2},
  [30] = {.index = 37, .length = 2},
  [31] = {.index = 39, .length = 1},
  [32] = {.index = 40, .length = 2},
  [33] = {.index = 42, .length = 2},
  [34] = {.index = 44, .length = 6},
  [35] = {.index = 50, .length = 1},
  [36] = {.index = 51, .length = 3},
  [37] = {.index = 54, .length = 3},
  [38] = {.index = 57, .length = 2},
  [39] = {.index = 59, .length = 2},
  [40] = {.index = 61, .length = 2},
  [41] = {.index = 63, .length = 2},
  [42] = {.index = 65, .length = 2},
  [43] = {.index = 67, .length = 1},
  [44] = {.index = 68, .length = 1},
  [45] = {.index = 69, .length = 1},
  [46] = {.index = 70, .length = 2},
  [47] = {.index = 72, .length = 2},
  [48] = {.index = 74, .length = 2},
  [49] = {.index = 76, .length = 1},
  [52] = {.index = 77, .length = 2},
  [53] = {.index = 79, .length = 1},
  [54] = {.index = 80, .length = 2},
  [55] = {.index = 82, .length = 4},
  [56] = {.index = 86, .length = 2},
  [57] = {.index = 88, .length = 2},
  [58] = {.index = 26, .length = 2},
  [59] = {.index = 30, .length = 2},
  [60] = {.index = 74, .length = 2},
  [61] = {.index = 90, .length = 3},
  [62] = {.index = 93, .length = 2},
  [63] = {.index = 93, .length = 2},
  [64] = {.index = 95, .length = 3},
  [65] = {.index = 98, .length = 2},
  [66] = {.index = 100, .length = 2},
  [67] = {.index = 102, .length = 4},
  [68] = {.index = 106, .length = 3},
  [69] = {.index = 109, .length = 2},
  [70] = {.index = 111, .length = 2},
  [71] = {.index = 113, .length = 1},
  [72] = {.index = 114, .length = 1},
  [73] = {.index = 115, .length = 2},
  [74] = {.index = 113, .length = 1},
  [75] = {.index = 26, .length = 2},
  [76] = {.index = 117, .length = 2},
  [77] = {.index = 119, .length = 5},
  [78] = {.index = 124, .length = 1},
  [79] = {.index = 115, .length = 2},
  [80] = {.index = 125, .length = 2},
  [81] = {.index = 127, .length = 3},
  [82] = {.index = 130, .length = 2},
  [83] = {.index = 132, .length = 3},
  [84] = {.index = 135, .length = 6},
  [85] = {.index = 141, .length = 1},
  [86] = {.index = 142, .length = 1},
  [87] = {.index = 143, .length = 3},
  [88] = {.index = 146, .length = 3},
  [89] = {.index = 149, .length = 4},
  [90] = {.index = 153, .length = 2},
  [91] = {.index = 155, .length = 3},
  [92] = {.index = 158, .length = 2},
  [93] = {.index = 160, .length = 2},
  [94] = {.index = 162, .length = 2},
  [95] = {.index = 164, .length = 3},
  [96] = {.index = 167, .length = 2},
  [97] = {.index = 169, .length = 4},
  [98] = {.index = 173, .length = 2},
  [99] = {.index = 175, .length = 3},
  [100] = {.index = 178, .length = 2},
  [101] = {.index = 180, .length = 3},
  [102] = {.index = 183, .length = 3},
  [103] = {.index = 186, .length = 2},
  [104] = {.index = 188, .length = 2},
  [105] = {.index = 190, .length = 2},
  [106] = {.index = 192, .length = 2},
  [108] = {.index = 192, .length = 2},
  [109] = {.index = 194, .length = 2},
  [110] = {.index = 196, .length = 2},
  [111] = {.index = 198, .length = 4},
  [112] = {.index = 196, .length = 2},
  [113] = {.index = 202, .length = 4},
  [114] = {.index = 206, .length = 4},
  [115] = {.index = 210, .length = 5},
  [116] = {.index = 215, .length = 3},
  [117] = {.index = 130, .length = 2},
  [118] = {.index = 218, .length = 1},
  [119] = {.index = 218, .length = 1},
  [120] = {.index = 219, .length = 2},
  [121] = {.index = 221, .length = 3},
  [122] = {.index = 224, .length = 2},
  [123] = {.index = 226, .length = 3},
  [124] = {.index = 229, .length = 2},
  [125] = {.index = 231, .length = 3},
  [126] = {.index = 234, .length = 1},
  [127] = {.index = 235, .length = 2},
  [128] = {.index = 237, .length = 2},
  [129] = {.index = 239, .length = 5},
  [130] = {.index = 244, .length = 1},
  [131] = {.index = 245, .length = 4},
  [132] = {.index = 249, .length = 2},
  [133] = {.index = 251, .length = 2},
  [134] = {.index = 253, .length = 3},
  [135] = {.index = 256, .length = 1},
  [136] = {.index = 257, .length = 2},
  [137] = {.index = 259, .length = 2},
  [138] = {.index = 261, .length = 2},
  [139] = {.index = 263, .length = 4},
  [140] = {.index = 267, .length = 3},
  [141] = {.index = 270, .length = 4},
  [142] = {.index = 274, .length = 4},
  [143] = {.index = 278, .length = 1},
  [144] = {.index = 279, .length = 4},
  [145] = {.index = 283, .length = 4},
  [146] = {.index = 287, .length = 2},
  [147] = {.index = 289, .length = 2},
  [148] = {.index = 291, .length = 4},
  [149] = {.index = 295, .length = 4},
  [150] = {.index = 299, .length = 5},
  [151] = {.index = 304, .length = 2},
  [152] = {.index = 306, .length = 3},
  [153] = {.index = 309, .length = 2},
  [154] = {.index = 309, .length = 2},
  [155] = {.index = 311, .length = 3},
  [156] = {.index = 314, .length = 2},
  [157] = {.index = 316, .length = 2},
  [158] = {.index = 318, .length = 3},
  [159] = {.index = 321, .length = 4},
  [160] = {.index = 325, .length = 3},
  [161] = {.index = 328, .length = 3},
  [162] = {.index = 331, .length = 2},
  [163] = {.index = 333, .length = 3},
  [164] = {.index = 336, .length = 5},
  [165] = {.index = 341, .length = 3},
  [166] = {.index = 341, .length = 3},
  [167] = {.index = 344, .length = 3},
  [168] = {.index = 347, .length = 2},
  [169] = {.index = 349, .length = 4},
  [170] = {.index = 125, .length = 2},
  [171] = {.index = 353, .length = 1},
  [172] = {.index = 354, .length = 2},
  [173] = {.index = 356, .length = 2},
  [174] = {.index = 358, .length = 2},
  [175] = {.index = 360, .length = 2},
  [176] = {.index = 362, .length = 3},
  [177] = {.index = 365, .length = 1},
  [178] = {.index = 366, .length = 3},
  [179] = {.index = 369, .length = 2},
  [180] = {.index = 371, .length = 2},
  [181] = {.index = 373, .length = 4},
  [182] = {.index = 373, .length = 4},
  [183] = {.index = 377, .length = 4},
  [184] = {.index = 377, .length = 4},
  [185] = {.index = 381, .length = 4},
  [186] = {.index = 381, .length = 4},
  [187] = {.index = 385, .length = 2},
  [188] = {.index = 387, .length = 3},
  [189] = {.index = 390, .length = 5},
  [190] = {.index = 395, .length = 3},
  [191] = {.index = 398, .length = 2},
  [192] = {.index = 400, .length = 2},
  [193] = {.index = 402, .length = 2},
  [194] = {.index = 404, .length = 1},
  [195] = {.index = 405, .length = 4},
  [196] = {.index = 409, .length = 3},
  [197] = {.index = 412, .length = 4},
  [198] = {.index = 416, .length = 5},
  [199] = {.index = 421, .length = 1},
  [200] = {.index = 422, .length = 2},
  [201] = {.index = 424, .length = 4},
  [202] = {.index = 428, .length = 4},
  [203] = {.index = 432, .length = 2},
  [204] = {.index = 434, .length = 4},
  [205] = {.index = 438, .length = 4},
  [206] = {.index = 442, .length = 2},
  [207] = {.index = 444, .length = 2},
  [208] = {.index = 446, .length = 3},
  [209] = {.index = 449, .length = 3},
  [210] = {.index = 452, .length = 2},
  [211] = {.index = 454, .length = 2},
  [212] = {.index = 456, .length = 1},
  [213] = {.index = 457, .length = 1},
  [214] = {.index = 458, .length = 3},
  [215] = {.index = 461, .length = 4},
  [216] = {.index = 465, .length = 4},
  [217] = {.index = 469, .length = 4},
  [218] = {.index = 473, .length = 3},
  [220] = {.index = 476, .length = 4},
  [221] = {.index = 480, .length = 5},
  [222] = {.index = 485, .length = 5},
  [223] = {.index = 490, .length = 5},
  [224] = {.index = 495, .length = 3},
  [225] = {.index = 498, .length = 3},
  [226] = {.index = 501, .length = 3},
  [227] = {.index = 498, .length = 3},
  [228] = {.index = 504, .length = 2},
  [229] = {.index = 506, .length = 4},
  [230] = {.index = 510, .length = 4},
  [231] = {.index = 514, .length = 3},
  [232] = {.index = 517, .length = 2},
  [233] = {.index = 519, .length = 2},
  [234] = {.index = 521, .length = 3},
  [235] = {.index = 524, .length = 2},
  [236] = {.index = 526, .length = 2},
  [237] = {.index = 528, .length = 1},
  [238] = {.index = 529, .length = 4},
  [239] = {.index = 533, .length = 4},
  [240] = {.index = 537, .length = 4},
  [241] = {.index = 541, .length = 5},
  [242] = {.index = 546, .length = 5},
  [243] = {.index = 551, .length = 4},
  [244] = {.index = 555, .length = 4},
  [245] = {.index = 559, .length = 3},
  [246] = {.index = 562, .length = 3},
  [247] = {.index = 562, .length = 3},
  [248] = {.index = 565, .length = 2},
  [249] = {.index = 567, .length = 2},
  [250] = {.index = 569, .length = 3},
  [251] = {.index = 572, .length = 2},
  [252] = {.index = 574, .length = 2},
  [253] = {.index = 576, .length = 4},
  [254] = {.index = 580, .length = 5},
  [255] = {.index = 585, .length = 5},
  [256] = {.index = 590, .length = 4},
  [257] = {.index = 590, .length = 4},
  [258] = {.index = 594, .length = 4},
  [259] = {.index = 598, .length = 3},
  [260] = {.index = 601, .length = 2},
  [261] = {.index = 603, .length = 2},
  [262] = {.index = 605, .length = 3},
  [263] = {.index = 608, .length = 4},
  [264] = {.index = 612, .length = 5},
  [265] = {.index = 617, .length = 3},
  [266] = {.index = 620, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_pattern, 0},
  [9] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [11] =
    {field_body, 1},
  [12] =
    {field_constructor, 1},
  [13] =
    {field_argument, 0},
    {field_operator, 1},
  [15] =
    {field_arguments, 1},
    {field_function, 0},
  [17] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [19] =
    {field_parameters, 0},
    {field_return_type, 1},
  [21] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [23] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [25] =
    {field_declaration, 2},
  [26] =
    {field_left, 0},
    {field_right, 2},
  [28] =
    {field_body, 2},
    {field_label, 0},
  [30] =
    {field_body, 2},
    {field_parameter, 0},
  [32] =
    {field_body, 1},
    {field_name, 0},
  [34] =
    {field_source, 1},
  [35] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [37] =
    {field_name, 0},
    {field_type, 1},
  [39] =
    {field_kind, 0},
  [40] =
    {field_condition, 1},
    {field_consequence, 2},
  [42] =
    {field_body, 2},
    {field_value, 1},
  [44] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [50] =
    {field_pattern, 1},
  [51] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [54] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [57] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [59] =
    {field_body, 2},
    {field_condition, 1},
  [61] =
    {field_body, 1},
    {field_handler, 2},
  [63] =
    {field_body, 1},
    {field_finalizer, 2},
  [65] =
    {field_body, 2},
    {field_object, 1},
  [67] =
    {field_label, 1},
  [68] =
    {field_name, 1},
  [69] =
    {field_attribute, 0},
  [70] =
    {field_name, 0},
    {field_value, 1},
  [72] =
    {field_constraint, 1},
    {field_name, 0},
  [74] =
    {field_body, 2},
    {field_name, 1},
  [76] =
    {field_value, 1},
  [77] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [79] =
    {field_body, 2},
  [80] =
    {field_body, 2},
    {field_type_parameters, 1},
  [82] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [86] =
    {field_arguments, 2},
    {field_constructor, 1},
  [88] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [90] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [93] =
    {field_object, 0},
    {field_property, 2},
  [95] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [98] =
    {field_arguments, 2},
    {field_function, 0},
  [100] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [102] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [106] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [109] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [111] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [113] =
    {field_source, 2, .inherited = true},
  [114] =
    {field_value, 2},
  [115] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [117] =
    {field_key, 0},
    {field_value, 2},
  [119] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [124] =
    {field_source, 2},
  [125] =
    {field_name, 0},
    {field_type, 2},
  [127] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [130] =
    {field_body, 3},
    {field_name, 2},
  [132] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [135] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [141] =
    {field_type, 2},
  [142] =
    {field_pattern, 2},
  [143] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [146] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [149] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [153] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [155] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [158] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [160] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [162] =
    {field_name, 1},
    {field_type_arguments, 2},
  [164] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [167] =
    {field_flags, 3},
    {field_pattern, 1},
  [169] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [173] =
    {field_body, 3},
    {field_name, 1},
  [175] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [178] =
    {field_type_arguments, 2},
    {field_value, 1},
  [180] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [183] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [186] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [188] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [190] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [192] =
    {field_name, 0},
    {field_type_arguments, 1},
  [194] =
    {field_body, 3},
    {field_type_parameters, 1},
  [196] =
    {field_body, 3},
    {field_parameter, 1},
  [198] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [202] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [206] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [210] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [215] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [218] =
    {field_type, 1},
  [219] =
    {field_index, 2},
    {field_object, 0},
  [221] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [224] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [226] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [229] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [231] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [234] =
    {field_source, 3, .inherited = true},
  [235] =
    {field_alias, 2},
    {field_name, 0},
  [237] =
    {field_name, 1},
    {field_value, 3},
  [239] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [244] =
    {field_pattern, 3},
  [245] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [249] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [251] =
    {field_body, 1},
    {field_condition, 3},
  [253] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [256] =
    {field_name, 2},
  [257] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [259] =
    {field_name, 1},
    {field_type, 2},
  [261] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [263] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [267] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [270] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [274] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [278] =
    {field_parameters, 1},
  [279] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [283] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [287] =
    {field_module, 0},
    {field_name, 2},
  [289] =
    {field_parameters, 0},
    {field_return_type, 2},
  [291] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [295] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [299] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [304] =
    {field_body, 4},
    {field_name, 2},
  [306] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [309] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [311] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [314] =
    {field_index, 3},
    {field_object, 0},
  [316] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [318] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [321] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [325] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [328] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [331] =
    {field_alias, 3},
    {field_name, 1},
  [333] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [336] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [341] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [344] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [347] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [349] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [353] =
    {field_type, 3},
  [354] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [356] =
    {field_name, 2},
    {field_type, 3},
  [358] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [360] =
    {field_name, 1},
    {field_type, 3},
  [362] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [365] =
    {field_name, 3},
  [366] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [369] =
    {field_parameters, 1},
    {field_type, 2},
  [371] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [373] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [377] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [381] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [385] =
    {field_parameters, 1},
    {field_type, 3},
  [387] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [390] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [395] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [398] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [400] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [402] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [404] =
    {field_name, 2, .inherited = true},
  [405] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [409] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [412] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [416] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [421] =
    {field_source, 4},
  [422] =
    {field_body, 3},
    {field_value, 1},
  [424] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [428] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [432] =
    {field_body, 4},
    {field_parameter, 2},
  [434] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [438] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [442] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [444] =
    {field_name, 2},
    {field_type, 4},
  [446] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [449] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [452] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [454] =
    {field_name, 3},
    {field_type, 4},
  [456] =
    {field_type, 4},
  [457] =
    {field_name, 4},
  [458] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [461] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [465] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [469] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [473] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [476] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [480] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [485] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [490] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [495] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [498] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [501] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [504] =
    {field_sign, 0},
    {field_type, 5},
  [506] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [510] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [514] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [517] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [519] =
    {field_name, 3},
    {field_type, 5},
  [521] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [524] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [526] =
    {field_name, 4},
    {field_type, 5},
  [528] =
    {field_name, 5},
  [529] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [533] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [537] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [541] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [546] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [551] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [555] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [559] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [562] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [565] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [567] =
    {field_name, 4},
    {field_type, 6},
  [569] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [572] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [574] =
    {field_name, 5},
    {field_type, 6},
  [576] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [580] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [585] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [590] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [594] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [598] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [601] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [603] =
    {field_name, 5},
    {field_type, 7},
  [605] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [608] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [612] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [617] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
  [620] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [21] = {
    [0] = sym_identifier,
  },
  [22] = {
    [0] = alias_sym_statement_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [25] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [26] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [27] = {
    [1] = sym_identifier,
  },
  [43] = {
    [1] = alias_sym_statement_identifier,
  },
  [46] = {
    [0] = alias_sym_type_identifier,
  },
  [47] = {
    [0] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [50] = {
    [0] = alias_sym_type_identifier,
  },
  [51] = {
    [0] = alias_sym_this_type,
  },
  [62] = {
    [2] = alias_sym_property_identifier,
  },
  [74] = {
    [1] = alias_sym_namespace_export,
  },
  [75] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [79] = {
    [1] = alias_sym_import_specifier,
  },
  [95] = {
    [0] = alias_sym_type_identifier,
  },
  [98] = {
    [1] = alias_sym_type_identifier,
  },
  [99] = {
    [1] = alias_sym_type_identifier,
  },
  [106] = {
    [0] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = alias_sym_type_identifier,
  },
  [110] = {
    [1] = sym_identifier,
  },
  [117] = {
    [2] = alias_sym_type_identifier,
  },
  [118] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [1] = alias_sym_type_identifier,
  },
  [140] = {
    [1] = alias_sym_type_identifier,
  },
  [146] = {
    [2] = alias_sym_type_identifier,
  },
  [151] = {
    [2] = alias_sym_type_identifier,
  },
  [152] = {
    [2] = alias_sym_type_identifier,
  },
  [153] = {
    [1] = alias_sym_type_identifier,
  },
  [158] = {
    [2] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = alias_sym_type_identifier,
  },
  [161] = {
    [3] = alias_sym_type_identifier,
  },
  [163] = {
    [1] = alias_sym_type_identifier,
  },
  [165] = {
    [1] = sym_identifier,
  },
  [170] = {
    [0] = alias_sym_type_identifier,
  },
  [181] = {
    [2] = alias_sym_property_identifier,
  },
  [183] = {
    [2] = alias_sym_property_identifier,
  },
  [185] = {
    [2] = alias_sym_property_identifier,
  },
  [190] = {
    [2] = alias_sym_type_identifier,
  },
  [195] = {
    [2] = alias_sym_type_identifier,
  },
  [196] = {
    [3] = alias_sym_type_identifier,
  },
  [197] = {
    [3] = alias_sym_type_identifier,
  },
  [219] = {
    [3] = alias_sym_property_identifier,
  },
  [220] = {
    [3] = alias_sym_type_identifier,
  },
  [225] = {
    [1] = sym_identifier,
  },
  [226] = {
    [0] = alias_sym_type_identifier,
  },
  [246] = {
    [2] = sym_identifier,
  },
  [256] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_namespace_import_export, 2,
    sym_namespace_import_export,
    alias_sym_namespace_export,
  0,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_regex_pattern_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 8192
    ? (c < 160
      ? (c < 0
        ? c == 0
        : c <= '~')
      : (c <= 160 || c == 5760))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(212);
      if (lookahead == '%') ADVANCE(161);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(155);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(159);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(197);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(100);
      if (lookahead == '?') ADVANCE(218);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(146);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(149);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(72)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(213);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(24)
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(71);
      if (sym_regex_pattern_character_set_1(lookahead)) ADVANCE(198);
      if (lookahead != 0) ADVANCE(199);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(30);
      if (lookahead == '%') ADVANCE(161);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(155);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(158);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(103);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(100);
      if (lookahead == '?') ADVANCE(218);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(146);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(149);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(2)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(213);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '%') ADVANCE(161);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(155);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(158);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(103);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(100);
      if (lookahead == '?') ADVANCE(218);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(146);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(148);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(213);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '%') ADVANCE(160);
      if (lookahead == '&') ADVANCE(144);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(111);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(98);
      if (lookahead == '=') ADVANCE(28);
      if (lookahead == '>') ADVANCE(101);
      if (lookahead == '?') ADVANCE(22);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(145);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(150);
      if (lookahead == '}') ADVANCE(87);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(200);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(213);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '%') ADVANCE(160);
      if (lookahead == '&') ADVANCE(144);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(111);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(98);
      if (lookahead == '=') ADVANCE(28);
      if (lookahead == '>') ADVANCE(101);
      if (lookahead == '?') ADVANCE(22);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(145);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(150);
      if (lookahead == '}') ADVANCE(87);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(213);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(33);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(214);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(77);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '?') ADVANCE(216);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(147);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(213);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(83);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(217);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(8)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          lookahead != '^') ADVANCE(213);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(30);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == '*') ADVANCE(77);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(156);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(197);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(216);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(87);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(213);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(30);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == '*') ADVANCE(77);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(156);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(216);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(87);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(10)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(213);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(30);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == '*') ADVANCE(77);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(156);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(44);
      if (lookahead == '}') ADVANCE(87);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(213);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == '*') ADVANCE(77);
      if (lookahead == '+') ADVANCE(153);
      if (lookahead == '-') ADVANCE(156);
      if (lookahead == '.') ADVANCE(50);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(216);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(147);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(12)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(211);
      if (lookahead != 0 &&
          lookahead > '~') ADVANCE(213);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '\\') ADVANCE(35);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(181);
      if (lookahead != 0) ADVANCE(182);
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(36);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '`') ADVANCE(195);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      END_STATE();
    case 15:
      if (lookahead == '$') ADVANCE(36);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '`') ADVANCE(195);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      END_STATE();
    case 16:
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(29);
      if (lookahead == '.') ADVANCE(111);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(27);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(147);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(16)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(211);
      if (lookahead != 0 &&
          lookahead > '~') ADVANCE(213);
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '/') ADVANCE(184);
      if (lookahead == '\\') ADVANCE(35);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(187);
      if (lookahead != 0) ADVANCE(188);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(194);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(115);
      if (lookahead == '?') ADVANCE(170);
      END_STATE();
    case 23:
      if (lookahead == '.') ADVANCE(131);
      END_STATE();
    case 24:
      if (lookahead == '/') ADVANCE(18);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(24)
      END_STATE();
    case 25:
      if (lookahead == '/') ADVANCE(105);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '{') ADVANCE(84);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(108);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(109);
      END_STATE();
    case 26:
      if (lookahead == ':') ADVANCE(220);
      END_STATE();
    case 27:
      if (lookahead == ':') ADVANCE(221);
      END_STATE();
    case 28:
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 29:
      if (lookahead == '?') ADVANCE(26);
      END_STATE();
    case 30:
      if (lookahead == '\\') ADVANCE(33);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(214);
      END_STATE();
    case 31:
      if (lookahead == '\\') ADVANCE(70);
      if (lookahead == ']') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(37);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(189);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(38);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(39);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(40);
      if (lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(192);
      if (lookahead != 0) ADVANCE(189);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(196);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 40:
      if (lookahead == '{') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(214);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(223);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 46:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 47:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(204);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(205);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(203);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(213);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(214);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(189);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(206);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(190);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(66);
      END_STATE();
    case 70:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 71:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(199);
      END_STATE();
    case 72:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(212);
      if (lookahead == '%') ADVANCE(161);
      if (lookahead == '&') ADVANCE(143);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(155);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(159);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(100);
      if (lookahead == '?') ADVANCE(218);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(146);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(85);
      if (lookahead == '|') ADVANCE(149);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(72)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(213);
      END_STATE();
    case 73:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '%') ADVANCE(160);
      if (lookahead == '&') ADVANCE(144);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(98);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == '>') ADVANCE(101);
      if (lookahead == '?') ADVANCE(219);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '^') ADVANCE(145);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(73)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(213);
      END_STATE();
    case 74:
      if (eof) ADVANCE(75);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(175);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '&') ADVANCE(142);
      if (lookahead == '\'') ADVANCE(176);
      if (lookahead == '(') ADVANCE(90);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(77);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == ',') ADVANCE(86);
      if (lookahead == '-') ADVANCE(157);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(92);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(83);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(216);
      if (lookahead == '@') ADVANCE(215);
      if (lookahead == '[') ADVANCE(94);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(95);
      if (lookahead == '`') ADVANCE(195);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(87);
      if (lookahead == '~') ADVANCE(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(74)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(213);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(163);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(162);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(165);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(222);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(141);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(140);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(169);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(169);
      if (lookahead == '>') ADVANCE(137);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(194);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(194);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '\n') ADVANCE(109);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(194);
      if (lookahead != 0) ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '/') ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(109);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(20);
      if (lookahead != 0) ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(20);
      if (lookahead != 0) ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(105);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(108);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(124);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(132);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(123);
      if (lookahead == '|') ADVANCE(135);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(123);
      if (lookahead == '|') ADVANCE(135);
      if (lookahead == '}') ADVANCE(223);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(223);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(223);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(173);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(173);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(174);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(174);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '?') ADVANCE(26);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(180);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(182);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(179);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(180);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(178);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(186);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(188);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(185);
      if (lookahead == '/') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(184);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(34);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(213);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(189);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(191);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(194);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(24)
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(71);
      if (sym_regex_pattern_character_set_1(lookahead)) ADVANCE(198);
      if (lookahead != 0) ADVANCE(199);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(34);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(200);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(213);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(210);
      if (lookahead == '0') ADVANCE(207);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(47);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(46);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(48);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(56);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(201);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(210);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(46);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(201);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(205);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(56);
      if (lookahead == 'n') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(46);
      if (lookahead == '_') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(211);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(213);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '{') ADVANCE(196);
      if (!sym_identifier_character_set_4(lookahead)) ADVANCE(213);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(34);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(213);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(115);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(115);
      if (lookahead == '?') ADVANCE(171);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(115);
      if (lookahead == '?') ADVANCE(170);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(53);
      if (lookahead == 'f') ADVANCE(54);
      if (lookahead == 'v') ADVANCE(55);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(59);
      if (lookahead == 't') ADVANCE(60);
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'w') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      if (lookahead == 'y') ADVANCE(67);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(75);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(76);
      if (lookahead == 'y') ADVANCE(77);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(85);
      if (lookahead == 'c') ADVANCE(86);
      if (lookahead == 'f') ADVANCE(87);
      if (lookahead == 'l') ADVANCE(88);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(89);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(90);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(91);
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(95);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(100);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(101);
      if (lookahead == 's') ADVANCE(102);
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(104);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(106);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'v') ADVANCE(108);
      if (lookahead == 'w') ADVANCE(109);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(110);
      if (lookahead == 'm') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'j') ADVANCE(112);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(114);
      if (lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 57:
      if (lookahead == 'b') ADVANCE(116);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == 'q') ADVANCE(118);
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(121);
      if (lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 61:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 63:
      if (lookahead == 'm') ADVANCE(125);
      END_STATE();
    case 64:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 66:
      if (lookahead == 'u') ADVANCE(129);
      if (lookahead == 'y') ADVANCE(130);
      END_STATE();
    case 67:
      if (lookahead == 'p') ADVANCE(131);
      END_STATE();
    case 68:
      if (lookahead == 'd') ADVANCE(132);
      if (lookahead == 'k') ADVANCE(133);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(134);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(136);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(141);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(144);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 82:
      if (lookahead == 'c') ADVANCE(146);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(147);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(148);
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 85:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(151);
      END_STATE();
    case 87:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 90:
      if (lookahead == 'm') ADVANCE(155);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 93:
      if (lookahead == 's') ADVANCE(158);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(159);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(160);
      END_STATE();
    case 97:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 99:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 106:
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 111:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 114:
      if (lookahead == 'v') ADVANCE(176);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 117:
      if (lookahead == 'd') ADVANCE(179);
      END_STATE();
    case 118:
      if (lookahead == 'u') ADVANCE(180);
      END_STATE();
    case 119:
      if (lookahead == 'u') ADVANCE(181);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(183);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 125:
      if (lookahead == 'b') ADVANCE(186);
      END_STATE();
    case 126:
      if (lookahead == 'g') ADVANCE(187);
      END_STATE();
    case 127:
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 128:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(190);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 133:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 135:
      if (lookahead == 'd') ADVANCE(194);
      END_STATE();
    case 136:
      if (lookahead == 'l') ADVANCE(195);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(196);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 139:
      if (lookahead == 'r') ADVANCE(198);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 141:
      if (lookahead == 'c') ADVANCE(200);
      END_STATE();
    case 142:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 144:
      if (lookahead == 'k') ADVANCE(203);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 146:
      if (lookahead == 'h') ADVANCE(204);
      END_STATE();
    case 147:
      if (lookahead == 's') ADVANCE(205);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 149:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 150:
      if (lookahead == 'g') ADVANCE(208);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(209);
      END_STATE();
    case 152:
      if (lookahead == 'u') ADVANCE(210);
      END_STATE();
    case 153:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 156:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 157:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 168:
      if (lookahead == 'f') ADVANCE(223);
      END_STATE();
    case 169:
      if (lookahead == 'l') ADVANCE(224);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 173:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(228);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 176:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 179:
      if (lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 180:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 181:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(236);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 185:
      if (lookahead == 'c') ADVANCE(239);
      END_STATE();
    case 186:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 189:
      if (lookahead == 'w') ADVANCE(242);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(243);
      END_STATE();
    case 192:
      if (lookahead == 'f') ADVANCE(244);
      END_STATE();
    case 193:
      if (lookahead == 'o') ADVANCE(245);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 195:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 197:
      if (lookahead == 'd') ADVANCE(247);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(248);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(249);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 202:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 207:
      if (lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 208:
      if (lookahead == 'g') ADVANCE(252);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 210:
      if (lookahead == 'l') ADVANCE(254);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 212:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 213:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 215:
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 217:
      if (lookahead == 'l') ADVANCE(260);
      END_STATE();
    case 218:
      if (lookahead == 'm') ADVANCE(261);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 221:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 222:
      if (lookahead == 'f') ADVANCE(264);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 225:
      if (lookahead == 'p') ADVANCE(266);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 227:
      if (lookahead == 'r') ADVANCE(267);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(269);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(271);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(272);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(273);
      END_STATE();
    case 234:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 235:
      if (lookahead == 'n') ADVANCE(275);
      END_STATE();
    case 236:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 237:
      if (lookahead == 'g') ADVANCE(277);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 239:
      if (lookahead == 'h') ADVANCE(278);
      END_STATE();
    case 240:
      if (lookahead == 'l') ADVANCE(279);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 244:
      if (lookahead == 'i') ADVANCE(282);
      END_STATE();
    case 245:
      if (lookahead == 'w') ADVANCE(283);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 248:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 249:
      if (lookahead == 's') ADVANCE(285);
      END_STATE();
    case 250:
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 251:
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 254:
      if (lookahead == 't') ADVANCE(290);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 257:
      if (lookahead == 's') ADVANCE(291);
      END_STATE();
    case 258:
      if (lookahead == 'y') ADVANCE(292);
      END_STATE();
    case 259:
      if (lookahead == 'o') ADVANCE(293);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 264:
      if (lookahead == 'a') ADVANCE(296);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 266:
      if (lookahead == 'a') ADVANCE(297);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 269:
      if (lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 273:
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 282:
      if (lookahead == 'n') ADVANCE(303);
      END_STATE();
    case 283:
      if (lookahead == 'n') ADVANCE(304);
      END_STATE();
    case 284:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(306);
      END_STATE();
    case 288:
      if (lookahead == 'r') ADVANCE(307);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 293:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 294:
      if (lookahead == 'n') ADVANCE(309);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 296:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 297:
      if (lookahead == 'c') ADVANCE(312);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 301:
      if (lookahead == 'y') ADVANCE(315);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(317);
      END_STATE();
    case 310:
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 311:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 312:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 314:
      if (lookahead == 'd') ADVANCE(321);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 316:
      if (lookahead == 'd') ADVANCE(322);
      END_STATE();
    case 317:
      if (lookahead == 's') ADVANCE(323);
      END_STATE();
    case 318:
      if (lookahead == 'f') ADVANCE(324);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 74},
  [2] = {.lex_state = 2, .external_lex_state = 2},
  [3] = {.lex_state = 2, .external_lex_state = 2},
  [4] = {.lex_state = 74},
  [5] = {.lex_state = 74},
  [6] = {.lex_state = 74},
  [7] = {.lex_state = 74},
  [8] = {.lex_state = 74},
  [9] = {.lex_state = 74},
  [10] = {.lex_state = 74},
  [11] = {.lex_state = 74},
  [12] = {.lex_state = 74},
  [13] = {.lex_state = 74},
  [14] = {.lex_state = 74},
  [15] = {.lex_state = 74},
  [16] = {.lex_state = 74},
  [17] = {.lex_state = 74},
  [18] = {.lex_state = 74},
  [19] = {.lex_state = 74},
  [20] = {.lex_state = 74},
  [21] = {.lex_state = 74},
  [22] = {.lex_state = 74},
  [23] = {.lex_state = 74},
  [24] = {.lex_state = 74},
  [25] = {.lex_state = 74},
  [26] = {.lex_state = 74},
  [27] = {.lex_state = 74},
  [28] = {.lex_state = 74},
  [29] = {.lex_state = 74},
  [30] = {.lex_state = 74},
  [31] = {.lex_state = 74},
  [32] = {.lex_state = 74},
  [33] = {.lex_state = 74},
  [34] = {.lex_state = 74},
  [35] = {.lex_state = 74},
  [36] = {.lex_state = 74},
  [37] = {.lex_state = 74},
  [38] = {.lex_state = 74},
  [39] = {.lex_state = 74},
  [40] = {.lex_state = 74},
  [41] = {.lex_state = 74},
  [42] = {.lex_state = 74},
  [43] = {.lex_state = 74},
  [44] = {.lex_state = 74},
  [45] = {.lex_state = 74},
  [46] = {.lex_state = 74},
  [47] = {.lex_state = 74},
  [48] = {.lex_state = 74},
  [49] = {.lex_state = 74},
  [50] = {.lex_state = 74},
  [51] = {.lex_state = 74},
  [52] = {.lex_state = 74},
  [53] = {.lex_state = 74},
  [54] = {.lex_state = 74},
  [55] = {.lex_state = 74},
  [56] = {.lex_state = 74},
  [57] = {.lex_state = 7},
  [58] = {.lex_state = 3, .external_lex_state = 2},
  [59] = {.lex_state = 3, .external_lex_state = 2},
  [60] = {.lex_state = 7},
  [61] = {.lex_state = 7},
  [62] = {.lex_state = 3, .external_lex_state = 2},
  [63] = {.lex_state = 7},
  [64] = {.lex_state = 7},
  [65] = {.lex_state = 7},
  [66] = {.lex_state = 3, .external_lex_state = 2},
  [67] = {.lex_state = 7},
  [68] = {.lex_state = 3, .external_lex_state = 2},
  [69] = {.lex_state = 3, .external_lex_state = 2},
  [70] = {.lex_state = 3, .external_lex_state = 2},
  [71] = {.lex_state = 3, .external_lex_state = 2},
  [72] = {.lex_state = 7},
  [73] = {.lex_state = 7},
  [74] = {.lex_state = 7},
  [75] = {.lex_state = 7},
  [76] = {.lex_state = 7},
  [77] = {.lex_state = 7},
  [78] = {.lex_state = 7},
  [79] = {.lex_state = 7},
  [80] = {.lex_state = 7},
  [81] = {.lex_state = 7},
  [82] = {.lex_state = 7},
  [83] = {.lex_state = 7},
  [84] = {.lex_state = 7},
  [85] = {.lex_state = 7},
  [86] = {.lex_state = 7},
  [87] = {.lex_state = 7},
  [88] = {.lex_state = 7},
  [89] = {.lex_state = 7},
  [90] = {.lex_state = 7},
  [91] = {.lex_state = 7},
  [92] = {.lex_state = 7},
  [93] = {.lex_state = 7},
  [94] = {.lex_state = 7},
  [95] = {.lex_state = 7},
  [96] = {.lex_state = 73, .external_lex_state = 2},
  [97] = {.lex_state = 73, .external_lex_state = 3},
  [98] = {.lex_state = 73, .external_lex_state = 3},
  [99] = {.lex_state = 73, .external_lex_state = 2},
  [100] = {.lex_state = 73, .external_lex_state = 2},
  [101] = {.lex_state = 73, .external_lex_state = 3},
  [102] = {.lex_state = 73, .external_lex_state = 2},
  [103] = {.lex_state = 73, .external_lex_state = 2},
  [104] = {.lex_state = 74},
  [105] = {.lex_state = 74},
  [106] = {.lex_state = 74},
  [107] = {.lex_state = 74},
  [108] = {.lex_state = 74},
  [109] = {.lex_state = 74},
  [110] = {.lex_state = 74},
  [111] = {.lex_state = 74},
  [112] = {.lex_state = 2, .external_lex_state = 2},
  [113] = {.lex_state = 2, .external_lex_state = 3},
  [114] = {.lex_state = 2, .external_lex_state = 3},
  [115] = {.lex_state = 2, .external_lex_state = 2},
  [116] = {.lex_state = 2, .external_lex_state = 2},
  [117] = {.lex_state = 2, .external_lex_state = 2},
  [118] = {.lex_state = 2, .external_lex_state = 2},
  [119] = {.lex_state = 2, .external_lex_state = 2},
  [120] = {.lex_state = 2, .external_lex_state = 2},
  [121] = {.lex_state = 2, .external_lex_state = 3},
  [122] = {.lex_state = 2, .external_lex_state = 2},
  [123] = {.lex_state = 2, .external_lex_state = 2},
  [124] = {.lex_state = 2, .external_lex_state = 2},
  [125] = {.lex_state = 74},
  [126] = {.lex_state = 74},
  [127] = {.lex_state = 73, .external_lex_state = 3},
  [128] = {.lex_state = 74},
  [129] = {.lex_state = 74},
  [130] = {.lex_state = 74},
  [131] = {.lex_state = 73, .external_lex_state = 3},
  [132] = {.lex_state = 73, .external_lex_state = 3},
  [133] = {.lex_state = 74},
  [134] = {.lex_state = 74},
  [135] = {.lex_state = 74},
  [136] = {.lex_state = 74},
  [137] = {.lex_state = 74},
  [138] = {.lex_state = 74},
  [139] = {.lex_state = 73, .external_lex_state = 3},
  [140] = {.lex_state = 74},
  [141] = {.lex_state = 73, .external_lex_state = 3},
  [142] = {.lex_state = 73, .external_lex_state = 3},
  [143] = {.lex_state = 74},
  [144] = {.lex_state = 74},
  [145] = {.lex_state = 73, .external_lex_state = 3},
  [146] = {.lex_state = 74},
  [147] = {.lex_state = 73, .external_lex_state = 3},
  [148] = {.lex_state = 74},
  [149] = {.lex_state = 73, .external_lex_state = 3},
  [150] = {.lex_state = 73, .external_lex_state = 3},
  [151] = {.lex_state = 73, .external_lex_state = 3},
  [152] = {.lex_state = 73, .external_lex_state = 3},
  [153] = {.lex_state = 73, .external_lex_state = 3},
  [154] = {.lex_state = 73, .external_lex_state = 3},
  [155] = {.lex_state = 73, .external_lex_state = 3},
  [156] = {.lex_state = 73, .external_lex_state = 3},
  [157] = {.lex_state = 73, .external_lex_state = 3},
  [158] = {.lex_state = 73, .external_lex_state = 3},
  [159] = {.lex_state = 74},
  [160] = {.lex_state = 74},
  [161] = {.lex_state = 73, .external_lex_state = 3},
  [162] = {.lex_state = 73, .external_lex_state = 3},
  [163] = {.lex_state = 73, .external_lex_state = 3},
  [164] = {.lex_state = 74},
  [165] = {.lex_state = 74},
  [166] = {.lex_state = 73, .external_lex_state = 3},
  [167] = {.lex_state = 74},
  [168] = {.lex_state = 74},
  [169] = {.lex_state = 73, .external_lex_state = 3},
  [170] = {.lex_state = 73, .external_lex_state = 3},
  [171] = {.lex_state = 74},
  [172] = {.lex_state = 74},
  [173] = {.lex_state = 73, .external_lex_state = 3},
  [174] = {.lex_state = 73, .external_lex_state = 3},
  [175] = {.lex_state = 73, .external_lex_state = 3},
  [176] = {.lex_state = 74},
  [177] = {.lex_state = 74, .external_lex_state = 4},
  [178] = {.lex_state = 74},
  [179] = {.lex_state = 74},
  [180] = {.lex_state = 74},
  [181] = {.lex_state = 74},
  [182] = {.lex_state = 74},
  [183] = {.lex_state = 74},
  [184] = {.lex_state = 74},
  [185] = {.lex_state = 74},
  [186] = {.lex_state = 3, .external_lex_state = 2},
  [187] = {.lex_state = 74},
  [188] = {.lex_state = 74},
  [189] = {.lex_state = 74},
  [190] = {.lex_state = 74},
  [191] = {.lex_state = 74},
  [192] = {.lex_state = 74},
  [193] = {.lex_state = 3, .external_lex_state = 2},
  [194] = {.lex_state = 3, .external_lex_state = 2},
  [195] = {.lex_state = 74},
  [196] = {.lex_state = 74},
  [197] = {.lex_state = 74},
  [198] = {.lex_state = 3, .external_lex_state = 2},
  [199] = {.lex_state = 74},
  [200] = {.lex_state = 74},
  [201] = {.lex_state = 74},
  [202] = {.lex_state = 74},
  [203] = {.lex_state = 74},
  [204] = {.lex_state = 74},
  [205] = {.lex_state = 74},
  [206] = {.lex_state = 74},
  [207] = {.lex_state = 74},
  [208] = {.lex_state = 74},
  [209] = {.lex_state = 74},
  [210] = {.lex_state = 74},
  [211] = {.lex_state = 74},
  [212] = {.lex_state = 74},
  [213] = {.lex_state = 74},
  [214] = {.lex_state = 74},
  [215] = {.lex_state = 74},
  [216] = {.lex_state = 74},
  [217] = {.lex_state = 3, .external_lex_state = 3},
  [218] = {.lex_state = 74},
  [219] = {.lex_state = 74},
  [220] = {.lex_state = 74},
  [221] = {.lex_state = 74},
  [222] = {.lex_state = 74},
  [223] = {.lex_state = 74},
  [224] = {.lex_state = 3, .external_lex_state = 3},
  [225] = {.lex_state = 3, .external_lex_state = 3},
  [226] = {.lex_state = 74},
  [227] = {.lex_state = 74},
  [228] = {.lex_state = 74},
  [229] = {.lex_state = 74},
  [230] = {.lex_state = 74},
  [231] = {.lex_state = 74},
  [232] = {.lex_state = 74},
  [233] = {.lex_state = 74, .external_lex_state = 4},
  [234] = {.lex_state = 74},
  [235] = {.lex_state = 74},
  [236] = {.lex_state = 74},
  [237] = {.lex_state = 74},
  [238] = {.lex_state = 74},
  [239] = {.lex_state = 74},
  [240] = {.lex_state = 74},
  [241] = {.lex_state = 74},
  [242] = {.lex_state = 74},
  [243] = {.lex_state = 74},
  [244] = {.lex_state = 74},
  [245] = {.lex_state = 74},
  [246] = {.lex_state = 74},
  [247] = {.lex_state = 74},
  [248] = {.lex_state = 74},
  [249] = {.lex_state = 74},
  [250] = {.lex_state = 74},
  [251] = {.lex_state = 74},
  [252] = {.lex_state = 74},
  [253] = {.lex_state = 74},
  [254] = {.lex_state = 74},
  [255] = {.lex_state = 74},
  [256] = {.lex_state = 74},
  [257] = {.lex_state = 74},
  [258] = {.lex_state = 74},
  [259] = {.lex_state = 74},
  [260] = {.lex_state = 74},
  [261] = {.lex_state = 74},
  [262] = {.lex_state = 74},
  [263] = {.lex_state = 74},
  [264] = {.lex_state = 74},
  [265] = {.lex_state = 74},
  [266] = {.lex_state = 74},
  [267] = {.lex_state = 74},
  [268] = {.lex_state = 74},
  [269] = {.lex_state = 74},
  [270] = {.lex_state = 74},
  [271] = {.lex_state = 74},
  [272] = {.lex_state = 74},
  [273] = {.lex_state = 74},
  [274] = {.lex_state = 74},
  [275] = {.lex_state = 74},
  [276] = {.lex_state = 74},
  [277] = {.lex_state = 74},
  [278] = {.lex_state = 74},
  [279] = {.lex_state = 74},
  [280] = {.lex_state = 74},
  [281] = {.lex_state = 74},
  [282] = {.lex_state = 74},
  [283] = {.lex_state = 74},
  [284] = {.lex_state = 74},
  [285] = {.lex_state = 74},
  [286] = {.lex_state = 74},
  [287] = {.lex_state = 74},
  [288] = {.lex_state = 74},
  [289] = {.lex_state = 74},
  [290] = {.lex_state = 74},
  [291] = {.lex_state = 74},
  [292] = {.lex_state = 74},
  [293] = {.lex_state = 74},
  [294] = {.lex_state = 74},
  [295] = {.lex_state = 74},
  [296] = {.lex_state = 74},
  [297] = {.lex_state = 74},
  [298] = {.lex_state = 74},
  [299] = {.lex_state = 74},
  [300] = {.lex_state = 74},
  [301] = {.lex_state = 74},
  [302] = {.lex_state = 74},
  [303] = {.lex_state = 74},
  [304] = {.lex_state = 74},
  [305] = {.lex_state = 74},
  [306] = {.lex_state = 74},
  [307] = {.lex_state = 74},
  [308] = {.lex_state = 74},
  [309] = {.lex_state = 74},
  [310] = {.lex_state = 74},
  [311] = {.lex_state = 74},
  [312] = {.lex_state = 74},
  [313] = {.lex_state = 74},
  [314] = {.lex_state = 74},
  [315] = {.lex_state = 74},
  [316] = {.lex_state = 74},
  [317] = {.lex_state = 74},
  [318] = {.lex_state = 74},
  [319] = {.lex_state = 74},
  [320] = {.lex_state = 74},
  [321] = {.lex_state = 74},
  [322] = {.lex_state = 74},
  [323] = {.lex_state = 74},
  [324] = {.lex_state = 74},
  [325] = {.lex_state = 74},
  [326] = {.lex_state = 74},
  [327] = {.lex_state = 74},
  [328] = {.lex_state = 74},
  [329] = {.lex_state = 74},
  [330] = {.lex_state = 74},
  [331] = {.lex_state = 74},
  [332] = {.lex_state = 74},
  [333] = {.lex_state = 74},
  [334] = {.lex_state = 74},
  [335] = {.lex_state = 74},
  [336] = {.lex_state = 74},
  [337] = {.lex_state = 74},
  [338] = {.lex_state = 74},
  [339] = {.lex_state = 74},
  [340] = {.lex_state = 74},
  [341] = {.lex_state = 74},
  [342] = {.lex_state = 74},
  [343] = {.lex_state = 74},
  [344] = {.lex_state = 74},
  [345] = {.lex_state = 74},
  [346] = {.lex_state = 74},
  [347] = {.lex_state = 74},
  [348] = {.lex_state = 74},
  [349] = {.lex_state = 74},
  [350] = {.lex_state = 74},
  [351] = {.lex_state = 74},
  [352] = {.lex_state = 74},
  [353] = {.lex_state = 74},
  [354] = {.lex_state = 74},
  [355] = {.lex_state = 74},
  [356] = {.lex_state = 74},
  [357] = {.lex_state = 74},
  [358] = {.lex_state = 74},
  [359] = {.lex_state = 74},
  [360] = {.lex_state = 74},
  [361] = {.lex_state = 74},
  [362] = {.lex_state = 74},
  [363] = {.lex_state = 74},
  [364] = {.lex_state = 74},
  [365] = {.lex_state = 74},
  [366] = {.lex_state = 74},
  [367] = {.lex_state = 74},
  [368] = {.lex_state = 74},
  [369] = {.lex_state = 74},
  [370] = {.lex_state = 74},
  [371] = {.lex_state = 74},
  [372] = {.lex_state = 74},
  [373] = {.lex_state = 74},
  [374] = {.lex_state = 74},
  [375] = {.lex_state = 74},
  [376] = {.lex_state = 74},
  [377] = {.lex_state = 74},
  [378] = {.lex_state = 74},
  [379] = {.lex_state = 74},
  [380] = {.lex_state = 74},
  [381] = {.lex_state = 74},
  [382] = {.lex_state = 74},
  [383] = {.lex_state = 74},
  [384] = {.lex_state = 74},
  [385] = {.lex_state = 74},
  [386] = {.lex_state = 74},
  [387] = {.lex_state = 74},
  [388] = {.lex_state = 74},
  [389] = {.lex_state = 74},
  [390] = {.lex_state = 74},
  [391] = {.lex_state = 74},
  [392] = {.lex_state = 74},
  [393] = {.lex_state = 74},
  [394] = {.lex_state = 74},
  [395] = {.lex_state = 74},
  [396] = {.lex_state = 74},
  [397] = {.lex_state = 74},
  [398] = {.lex_state = 74},
  [399] = {.lex_state = 74},
  [400] = {.lex_state = 74},
  [401] = {.lex_state = 74},
  [402] = {.lex_state = 74},
  [403] = {.lex_state = 74},
  [404] = {.lex_state = 74},
  [405] = {.lex_state = 74},
  [406] = {.lex_state = 74},
  [407] = {.lex_state = 74},
  [408] = {.lex_state = 74},
  [409] = {.lex_state = 74},
  [410] = {.lex_state = 74},
  [411] = {.lex_state = 74},
  [412] = {.lex_state = 74},
  [413] = {.lex_state = 74},
  [414] = {.lex_state = 74},
  [415] = {.lex_state = 74},
  [416] = {.lex_state = 74},
  [417] = {.lex_state = 2, .external_lex_state = 3},
  [418] = {.lex_state = 74},
  [419] = {.lex_state = 74},
  [420] = {.lex_state = 74},
  [421] = {.lex_state = 74},
  [422] = {.lex_state = 74},
  [423] = {.lex_state = 74},
  [424] = {.lex_state = 74},
  [425] = {.lex_state = 74},
  [426] = {.lex_state = 74},
  [427] = {.lex_state = 74},
  [428] = {.lex_state = 74},
  [429] = {.lex_state = 74},
  [430] = {.lex_state = 74},
  [431] = {.lex_state = 74},
  [432] = {.lex_state = 74},
  [433] = {.lex_state = 74},
  [434] = {.lex_state = 74},
  [435] = {.lex_state = 74},
  [436] = {.lex_state = 74},
  [437] = {.lex_state = 74},
  [438] = {.lex_state = 74},
  [439] = {.lex_state = 74},
  [440] = {.lex_state = 74},
  [441] = {.lex_state = 74},
  [442] = {.lex_state = 74},
  [443] = {.lex_state = 74},
  [444] = {.lex_state = 74},
  [445] = {.lex_state = 2, .external_lex_state = 3},
  [446] = {.lex_state = 74},
  [447] = {.lex_state = 74},
  [448] = {.lex_state = 74},
  [449] = {.lex_state = 74},
  [450] = {.lex_state = 74},
  [451] = {.lex_state = 74},
  [452] = {.lex_state = 74},
  [453] = {.lex_state = 74},
  [454] = {.lex_state = 74},
  [455] = {.lex_state = 74},
  [456] = {.lex_state = 74},
  [457] = {.lex_state = 74},
  [458] = {.lex_state = 74},
  [459] = {.lex_state = 74},
  [460] = {.lex_state = 74},
  [461] = {.lex_state = 74},
  [462] = {.lex_state = 74},
  [463] = {.lex_state = 74},
  [464] = {.lex_state = 74},
  [465] = {.lex_state = 74},
  [466] = {.lex_state = 74},
  [467] = {.lex_state = 74},
  [468] = {.lex_state = 74},
  [469] = {.lex_state = 74},
  [470] = {.lex_state = 74},
  [471] = {.lex_state = 74},
  [472] = {.lex_state = 74},
  [473] = {.lex_state = 74},
  [474] = {.lex_state = 74},
  [475] = {.lex_state = 74},
  [476] = {.lex_state = 2, .external_lex_state = 3},
  [477] = {.lex_state = 74},
  [478] = {.lex_state = 74},
  [479] = {.lex_state = 74},
  [480] = {.lex_state = 74},
  [481] = {.lex_state = 74},
  [482] = {.lex_state = 74},
  [483] = {.lex_state = 74},
  [484] = {.lex_state = 74},
  [485] = {.lex_state = 74},
  [486] = {.lex_state = 74},
  [487] = {.lex_state = 74},
  [488] = {.lex_state = 74},
  [489] = {.lex_state = 74},
  [490] = {.lex_state = 74},
  [491] = {.lex_state = 74},
  [492] = {.lex_state = 74},
  [493] = {.lex_state = 74},
  [494] = {.lex_state = 74},
  [495] = {.lex_state = 74},
  [496] = {.lex_state = 74},
  [497] = {.lex_state = 74},
  [498] = {.lex_state = 74},
  [499] = {.lex_state = 74},
  [500] = {.lex_state = 74},
  [501] = {.lex_state = 74},
  [502] = {.lex_state = 74},
  [503] = {.lex_state = 74},
  [504] = {.lex_state = 74},
  [505] = {.lex_state = 74},
  [506] = {.lex_state = 74},
  [507] = {.lex_state = 74},
  [508] = {.lex_state = 74},
  [509] = {.lex_state = 74},
  [510] = {.lex_state = 74},
  [511] = {.lex_state = 74},
  [512] = {.lex_state = 74},
  [513] = {.lex_state = 74},
  [514] = {.lex_state = 74},
  [515] = {.lex_state = 74},
  [516] = {.lex_state = 74},
  [517] = {.lex_state = 74},
  [518] = {.lex_state = 74},
  [519] = {.lex_state = 74},
  [520] = {.lex_state = 74},
  [521] = {.lex_state = 74},
  [522] = {.lex_state = 74},
  [523] = {.lex_state = 74},
  [524] = {.lex_state = 74},
  [525] = {.lex_state = 74},
  [526] = {.lex_state = 74},
  [527] = {.lex_state = 74},
  [528] = {.lex_state = 74},
  [529] = {.lex_state = 74},
  [530] = {.lex_state = 74},
  [531] = {.lex_state = 74},
  [532] = {.lex_state = 3, .external_lex_state = 3},
  [533] = {.lex_state = 3, .external_lex_state = 3},
  [534] = {.lex_state = 3, .external_lex_state = 3},
  [535] = {.lex_state = 2, .external_lex_state = 3},
  [536] = {.lex_state = 2, .external_lex_state = 3},
  [537] = {.lex_state = 2, .external_lex_state = 3},
  [538] = {.lex_state = 2, .external_lex_state = 3},
  [539] = {.lex_state = 2, .external_lex_state = 3},
  [540] = {.lex_state = 2, .external_lex_state = 3},
  [541] = {.lex_state = 2, .external_lex_state = 3},
  [542] = {.lex_state = 2, .external_lex_state = 3},
  [543] = {.lex_state = 2, .external_lex_state = 3},
  [544] = {.lex_state = 2, .external_lex_state = 3},
  [545] = {.lex_state = 2, .external_lex_state = 3},
  [546] = {.lex_state = 2, .external_lex_state = 3},
  [547] = {.lex_state = 2, .external_lex_state = 3},
  [548] = {.lex_state = 2, .external_lex_state = 3},
  [549] = {.lex_state = 2, .external_lex_state = 3},
  [550] = {.lex_state = 2, .external_lex_state = 3},
  [551] = {.lex_state = 2, .external_lex_state = 3},
  [552] = {.lex_state = 2, .external_lex_state = 3},
  [553] = {.lex_state = 74},
  [554] = {.lex_state = 74},
  [555] = {.lex_state = 74},
  [556] = {.lex_state = 74},
  [557] = {.lex_state = 74},
  [558] = {.lex_state = 74},
  [559] = {.lex_state = 74},
  [560] = {.lex_state = 2, .external_lex_state = 3},
  [561] = {.lex_state = 2, .external_lex_state = 3},
  [562] = {.lex_state = 2, .external_lex_state = 3},
  [563] = {.lex_state = 2, .external_lex_state = 3},
  [564] = {.lex_state = 2, .external_lex_state = 3},
  [565] = {.lex_state = 2, .external_lex_state = 3},
  [566] = {.lex_state = 2, .external_lex_state = 2},
  [567] = {.lex_state = 2, .external_lex_state = 2},
  [568] = {.lex_state = 2, .external_lex_state = 2},
  [569] = {.lex_state = 2, .external_lex_state = 2},
  [570] = {.lex_state = 2, .external_lex_state = 2},
  [571] = {.lex_state = 2, .external_lex_state = 3},
  [572] = {.lex_state = 2, .external_lex_state = 3},
  [573] = {.lex_state = 2, .external_lex_state = 3},
  [574] = {.lex_state = 2, .external_lex_state = 3},
  [575] = {.lex_state = 2, .external_lex_state = 3},
  [576] = {.lex_state = 2, .external_lex_state = 2},
  [577] = {.lex_state = 2, .external_lex_state = 3},
  [578] = {.lex_state = 2, .external_lex_state = 3},
  [579] = {.lex_state = 2, .external_lex_state = 3},
  [580] = {.lex_state = 74, .external_lex_state = 4},
  [581] = {.lex_state = 74, .external_lex_state = 4},
  [582] = {.lex_state = 3, .external_lex_state = 2},
  [583] = {.lex_state = 2, .external_lex_state = 2},
  [584] = {.lex_state = 2, .external_lex_state = 2},
  [585] = {.lex_state = 74},
  [586] = {.lex_state = 2, .external_lex_state = 2},
  [587] = {.lex_state = 3, .external_lex_state = 2},
  [588] = {.lex_state = 2, .external_lex_state = 3},
  [589] = {.lex_state = 74, .external_lex_state = 4},
  [590] = {.lex_state = 2, .external_lex_state = 3},
  [591] = {.lex_state = 74},
  [592] = {.lex_state = 2, .external_lex_state = 2},
  [593] = {.lex_state = 2, .external_lex_state = 2},
  [594] = {.lex_state = 74},
  [595] = {.lex_state = 2, .external_lex_state = 3},
  [596] = {.lex_state = 74, .external_lex_state = 4},
  [597] = {.lex_state = 74, .external_lex_state = 4},
  [598] = {.lex_state = 74, .external_lex_state = 4},
  [599] = {.lex_state = 74, .external_lex_state = 4},
  [600] = {.lex_state = 2, .external_lex_state = 2},
  [601] = {.lex_state = 2, .external_lex_state = 3},
  [602] = {.lex_state = 2, .external_lex_state = 3},
  [603] = {.lex_state = 74, .external_lex_state = 4},
  [604] = {.lex_state = 2, .external_lex_state = 2},
  [605] = {.lex_state = 74},
  [606] = {.lex_state = 2, .external_lex_state = 2},
  [607] = {.lex_state = 2, .external_lex_state = 2},
  [608] = {.lex_state = 2, .external_lex_state = 2},
  [609] = {.lex_state = 74},
  [610] = {.lex_state = 74},
  [611] = {.lex_state = 74},
  [612] = {.lex_state = 74, .external_lex_state = 4},
  [613] = {.lex_state = 74},
  [614] = {.lex_state = 74},
  [615] = {.lex_state = 74, .external_lex_state = 4},
  [616] = {.lex_state = 74, .external_lex_state = 4},
  [617] = {.lex_state = 74},
  [618] = {.lex_state = 74, .external_lex_state = 4},
  [619] = {.lex_state = 74, .external_lex_state = 4},
  [620] = {.lex_state = 2, .external_lex_state = 2},
  [621] = {.lex_state = 74, .external_lex_state = 4},
  [622] = {.lex_state = 74, .external_lex_state = 4},
  [623] = {.lex_state = 74, .external_lex_state = 4},
  [624] = {.lex_state = 74},
  [625] = {.lex_state = 74, .external_lex_state = 4},
  [626] = {.lex_state = 74, .external_lex_state = 4},
  [627] = {.lex_state = 74},
  [628] = {.lex_state = 74},
  [629] = {.lex_state = 74, .external_lex_state = 4},
  [630] = {.lex_state = 74, .external_lex_state = 4},
  [631] = {.lex_state = 74},
  [632] = {.lex_state = 74},
  [633] = {.lex_state = 74},
  [634] = {.lex_state = 74},
  [635] = {.lex_state = 74},
  [636] = {.lex_state = 74},
  [637] = {.lex_state = 74},
  [638] = {.lex_state = 74},
  [639] = {.lex_state = 74},
  [640] = {.lex_state = 74},
  [641] = {.lex_state = 74},
  [642] = {.lex_state = 74},
  [643] = {.lex_state = 74},
  [644] = {.lex_state = 74},
  [645] = {.lex_state = 74},
  [646] = {.lex_state = 74},
  [647] = {.lex_state = 74},
  [648] = {.lex_state = 74},
  [649] = {.lex_state = 74},
  [650] = {.lex_state = 74},
  [651] = {.lex_state = 74},
  [652] = {.lex_state = 74},
  [653] = {.lex_state = 74},
  [654] = {.lex_state = 74},
  [655] = {.lex_state = 74},
  [656] = {.lex_state = 74},
  [657] = {.lex_state = 74},
  [658] = {.lex_state = 74},
  [659] = {.lex_state = 74},
  [660] = {.lex_state = 74},
  [661] = {.lex_state = 74},
  [662] = {.lex_state = 74},
  [663] = {.lex_state = 74},
  [664] = {.lex_state = 74},
  [665] = {.lex_state = 74},
  [666] = {.lex_state = 74},
  [667] = {.lex_state = 74},
  [668] = {.lex_state = 74},
  [669] = {.lex_state = 74},
  [670] = {.lex_state = 74},
  [671] = {.lex_state = 74},
  [672] = {.lex_state = 74},
  [673] = {.lex_state = 74},
  [674] = {.lex_state = 74},
  [675] = {.lex_state = 74},
  [676] = {.lex_state = 74},
  [677] = {.lex_state = 74},
  [678] = {.lex_state = 74},
  [679] = {.lex_state = 74},
  [680] = {.lex_state = 74},
  [681] = {.lex_state = 74},
  [682] = {.lex_state = 74},
  [683] = {.lex_state = 74},
  [684] = {.lex_state = 74},
  [685] = {.lex_state = 74},
  [686] = {.lex_state = 74},
  [687] = {.lex_state = 74},
  [688] = {.lex_state = 74},
  [689] = {.lex_state = 74},
  [690] = {.lex_state = 74},
  [691] = {.lex_state = 74},
  [692] = {.lex_state = 74},
  [693] = {.lex_state = 74},
  [694] = {.lex_state = 74},
  [695] = {.lex_state = 74},
  [696] = {.lex_state = 74},
  [697] = {.lex_state = 74},
  [698] = {.lex_state = 74},
  [699] = {.lex_state = 74},
  [700] = {.lex_state = 74},
  [701] = {.lex_state = 74},
  [702] = {.lex_state = 74},
  [703] = {.lex_state = 74},
  [704] = {.lex_state = 74},
  [705] = {.lex_state = 74},
  [706] = {.lex_state = 74},
  [707] = {.lex_state = 74},
  [708] = {.lex_state = 74},
  [709] = {.lex_state = 74},
  [710] = {.lex_state = 74},
  [711] = {.lex_state = 74},
  [712] = {.lex_state = 74},
  [713] = {.lex_state = 74},
  [714] = {.lex_state = 74},
  [715] = {.lex_state = 74},
  [716] = {.lex_state = 74},
  [717] = {.lex_state = 74},
  [718] = {.lex_state = 74},
  [719] = {.lex_state = 74},
  [720] = {.lex_state = 74},
  [721] = {.lex_state = 74},
  [722] = {.lex_state = 74},
  [723] = {.lex_state = 74},
  [724] = {.lex_state = 74},
  [725] = {.lex_state = 74},
  [726] = {.lex_state = 74},
  [727] = {.lex_state = 74},
  [728] = {.lex_state = 74},
  [729] = {.lex_state = 74},
  [730] = {.lex_state = 74},
  [731] = {.lex_state = 74},
  [732] = {.lex_state = 74},
  [733] = {.lex_state = 74},
  [734] = {.lex_state = 74},
  [735] = {.lex_state = 74},
  [736] = {.lex_state = 74},
  [737] = {.lex_state = 74},
  [738] = {.lex_state = 74},
  [739] = {.lex_state = 74},
  [740] = {.lex_state = 74},
  [741] = {.lex_state = 74},
  [742] = {.lex_state = 74},
  [743] = {.lex_state = 74},
  [744] = {.lex_state = 74},
  [745] = {.lex_state = 74},
  [746] = {.lex_state = 74},
  [747] = {.lex_state = 74},
  [748] = {.lex_state = 74},
  [749] = {.lex_state = 74},
  [750] = {.lex_state = 74},
  [751] = {.lex_state = 74},
  [752] = {.lex_state = 74},
  [753] = {.lex_state = 74},
  [754] = {.lex_state = 74},
  [755] = {.lex_state = 74},
  [756] = {.lex_state = 74},
  [757] = {.lex_state = 74},
  [758] = {.lex_state = 74},
  [759] = {.lex_state = 74},
  [760] = {.lex_state = 74},
  [761] = {.lex_state = 74},
  [762] = {.lex_state = 74},
  [763] = {.lex_state = 74},
  [764] = {.lex_state = 74},
  [765] = {.lex_state = 74},
  [766] = {.lex_state = 74},
  [767] = {.lex_state = 74},
  [768] = {.lex_state = 74},
  [769] = {.lex_state = 74},
  [770] = {.lex_state = 74},
  [771] = {.lex_state = 74},
  [772] = {.lex_state = 74},
  [773] = {.lex_state = 74},
  [774] = {.lex_state = 74},
  [775] = {.lex_state = 74},
  [776] = {.lex_state = 74},
  [777] = {.lex_state = 9},
  [778] = {.lex_state = 9},
  [779] = {.lex_state = 9},
  [780] = {.lex_state = 9},
  [781] = {.lex_state = 9},
  [782] = {.lex_state = 9},
  [783] = {.lex_state = 9},
  [784] = {.lex_state = 9},
  [785] = {.lex_state = 9},
  [786] = {.lex_state = 9},
  [787] = {.lex_state = 9},
  [788] = {.lex_state = 9},
  [789] = {.lex_state = 9},
  [790] = {.lex_state = 9},
  [791] = {.lex_state = 9},
  [792] = {.lex_state = 74},
  [793] = {.lex_state = 74},
  [794] = {.lex_state = 74},
  [795] = {.lex_state = 74},
  [796] = {.lex_state = 74},
  [797] = {.lex_state = 74},
  [798] = {.lex_state = 74},
  [799] = {.lex_state = 74},
  [800] = {.lex_state = 74},
  [801] = {.lex_state = 74},
  [802] = {.lex_state = 74},
  [803] = {.lex_state = 74},
  [804] = {.lex_state = 9},
  [805] = {.lex_state = 74},
  [806] = {.lex_state = 8},
  [807] = {.lex_state = 8},
  [808] = {.lex_state = 8},
  [809] = {.lex_state = 2, .external_lex_state = 3},
  [810] = {.lex_state = 2, .external_lex_state = 3},
  [811] = {.lex_state = 2, .external_lex_state = 3},
  [812] = {.lex_state = 2, .external_lex_state = 3},
  [813] = {.lex_state = 2, .external_lex_state = 3},
  [814] = {.lex_state = 2, .external_lex_state = 3},
  [815] = {.lex_state = 9},
  [816] = {.lex_state = 9},
  [817] = {.lex_state = 9},
  [818] = {.lex_state = 11},
  [819] = {.lex_state = 9},
  [820] = {.lex_state = 12},
  [821] = {.lex_state = 11},
  [822] = {.lex_state = 9},
  [823] = {.lex_state = 9},
  [824] = {.lex_state = 11},
  [825] = {.lex_state = 11},
  [826] = {.lex_state = 9},
  [827] = {.lex_state = 9},
  [828] = {.lex_state = 9},
  [829] = {.lex_state = 9},
  [830] = {.lex_state = 2, .external_lex_state = 2},
  [831] = {.lex_state = 11},
  [832] = {.lex_state = 9},
  [833] = {.lex_state = 9},
  [834] = {.lex_state = 9},
  [835] = {.lex_state = 9},
  [836] = {.lex_state = 11},
  [837] = {.lex_state = 2, .external_lex_state = 2},
  [838] = {.lex_state = 9},
  [839] = {.lex_state = 9},
  [840] = {.lex_state = 9},
  [841] = {.lex_state = 9},
  [842] = {.lex_state = 9},
  [843] = {.lex_state = 9},
  [844] = {.lex_state = 11},
  [845] = {.lex_state = 9},
  [846] = {.lex_state = 9},
  [847] = {.lex_state = 9},
  [848] = {.lex_state = 9},
  [849] = {.lex_state = 9},
  [850] = {.lex_state = 9},
  [851] = {.lex_state = 9},
  [852] = {.lex_state = 9},
  [853] = {.lex_state = 11},
  [854] = {.lex_state = 11},
  [855] = {.lex_state = 9},
  [856] = {.lex_state = 2, .external_lex_state = 2},
  [857] = {.lex_state = 9},
  [858] = {.lex_state = 9},
  [859] = {.lex_state = 11},
  [860] = {.lex_state = 9},
  [861] = {.lex_state = 11},
  [862] = {.lex_state = 11},
  [863] = {.lex_state = 9},
  [864] = {.lex_state = 9},
  [865] = {.lex_state = 9},
  [866] = {.lex_state = 9},
  [867] = {.lex_state = 9},
  [868] = {.lex_state = 9},
  [869] = {.lex_state = 9},
  [870] = {.lex_state = 9},
  [871] = {.lex_state = 9},
  [872] = {.lex_state = 9},
  [873] = {.lex_state = 9},
  [874] = {.lex_state = 9},
  [875] = {.lex_state = 9},
  [876] = {.lex_state = 9},
  [877] = {.lex_state = 9},
  [878] = {.lex_state = 9},
  [879] = {.lex_state = 9},
  [880] = {.lex_state = 9},
  [881] = {.lex_state = 9},
  [882] = {.lex_state = 9},
  [883] = {.lex_state = 9},
  [884] = {.lex_state = 9},
  [885] = {.lex_state = 2, .external_lex_state = 2},
  [886] = {.lex_state = 9},
  [887] = {.lex_state = 9},
  [888] = {.lex_state = 9},
  [889] = {.lex_state = 9},
  [890] = {.lex_state = 9},
  [891] = {.lex_state = 9},
  [892] = {.lex_state = 9},
  [893] = {.lex_state = 9},
  [894] = {.lex_state = 9},
  [895] = {.lex_state = 9},
  [896] = {.lex_state = 9},
  [897] = {.lex_state = 9},
  [898] = {.lex_state = 9},
  [899] = {.lex_state = 9},
  [900] = {.lex_state = 9},
  [901] = {.lex_state = 9},
  [902] = {.lex_state = 9},
  [903] = {.lex_state = 9},
  [904] = {.lex_state = 9},
  [905] = {.lex_state = 9},
  [906] = {.lex_state = 9},
  [907] = {.lex_state = 9},
  [908] = {.lex_state = 9},
  [909] = {.lex_state = 9},
  [910] = {.lex_state = 9},
  [911] = {.lex_state = 9},
  [912] = {.lex_state = 9},
  [913] = {.lex_state = 9},
  [914] = {.lex_state = 9},
  [915] = {.lex_state = 9},
  [916] = {.lex_state = 9},
  [917] = {.lex_state = 9},
  [918] = {.lex_state = 9},
  [919] = {.lex_state = 9},
  [920] = {.lex_state = 9},
  [921] = {.lex_state = 9},
  [922] = {.lex_state = 9},
  [923] = {.lex_state = 9},
  [924] = {.lex_state = 9},
  [925] = {.lex_state = 9},
  [926] = {.lex_state = 9},
  [927] = {.lex_state = 9},
  [928] = {.lex_state = 9},
  [929] = {.lex_state = 9},
  [930] = {.lex_state = 9},
  [931] = {.lex_state = 9},
  [932] = {.lex_state = 9},
  [933] = {.lex_state = 9},
  [934] = {.lex_state = 9},
  [935] = {.lex_state = 9},
  [936] = {.lex_state = 9},
  [937] = {.lex_state = 9},
  [938] = {.lex_state = 9},
  [939] = {.lex_state = 9},
  [940] = {.lex_state = 9},
  [941] = {.lex_state = 9},
  [942] = {.lex_state = 9},
  [943] = {.lex_state = 9},
  [944] = {.lex_state = 9},
  [945] = {.lex_state = 9},
  [946] = {.lex_state = 9},
  [947] = {.lex_state = 9},
  [948] = {.lex_state = 9},
  [949] = {.lex_state = 9},
  [950] = {.lex_state = 9},
  [951] = {.lex_state = 9},
  [952] = {.lex_state = 9},
  [953] = {.lex_state = 9},
  [954] = {.lex_state = 9},
  [955] = {.lex_state = 9},
  [956] = {.lex_state = 9},
  [957] = {.lex_state = 9},
  [958] = {.lex_state = 9},
  [959] = {.lex_state = 9},
  [960] = {.lex_state = 9},
  [961] = {.lex_state = 9},
  [962] = {.lex_state = 9},
  [963] = {.lex_state = 9},
  [964] = {.lex_state = 9},
  [965] = {.lex_state = 9},
  [966] = {.lex_state = 9},
  [967] = {.lex_state = 9},
  [968] = {.lex_state = 9},
  [969] = {.lex_state = 9},
  [970] = {.lex_state = 2, .external_lex_state = 2},
  [971] = {.lex_state = 9},
  [972] = {.lex_state = 9},
  [973] = {.lex_state = 9},
  [974] = {.lex_state = 9},
  [975] = {.lex_state = 9},
  [976] = {.lex_state = 9},
  [977] = {.lex_state = 2, .external_lex_state = 2},
  [978] = {.lex_state = 2, .external_lex_state = 3},
  [979] = {.lex_state = 2, .external_lex_state = 3},
  [980] = {.lex_state = 2, .external_lex_state = 3},
  [981] = {.lex_state = 2, .external_lex_state = 3},
  [982] = {.lex_state = 2, .external_lex_state = 3},
  [983] = {.lex_state = 2, .external_lex_state = 3},
  [984] = {.lex_state = 2, .external_lex_state = 3},
  [985] = {.lex_state = 2, .external_lex_state = 3},
  [986] = {.lex_state = 2, .external_lex_state = 3},
  [987] = {.lex_state = 2, .external_lex_state = 3},
  [988] = {.lex_state = 2, .external_lex_state = 3},
  [989] = {.lex_state = 2, .external_lex_state = 3},
  [990] = {.lex_state = 3, .external_lex_state = 2},
  [991] = {.lex_state = 2, .external_lex_state = 2},
  [992] = {.lex_state = 2, .external_lex_state = 3},
  [993] = {.lex_state = 3, .external_lex_state = 2},
  [994] = {.lex_state = 2, .external_lex_state = 3},
  [995] = {.lex_state = 2, .external_lex_state = 2},
  [996] = {.lex_state = 2, .external_lex_state = 2},
  [997] = {.lex_state = 2, .external_lex_state = 3},
  [998] = {.lex_state = 3, .external_lex_state = 2},
  [999] = {.lex_state = 3, .external_lex_state = 2},
  [1000] = {.lex_state = 2, .external_lex_state = 3},
  [1001] = {.lex_state = 3, .external_lex_state = 2},
  [1002] = {.lex_state = 2, .external_lex_state = 3},
  [1003] = {.lex_state = 2, .external_lex_state = 3},
  [1004] = {.lex_state = 2, .external_lex_state = 3},
  [1005] = {.lex_state = 2, .external_lex_state = 3},
  [1006] = {.lex_state = 11},
  [1007] = {.lex_state = 2, .external_lex_state = 3},
  [1008] = {.lex_state = 2, .external_lex_state = 3},
  [1009] = {.lex_state = 3, .external_lex_state = 2},
  [1010] = {.lex_state = 3, .external_lex_state = 2},
  [1011] = {.lex_state = 2, .external_lex_state = 2},
  [1012] = {.lex_state = 2, .external_lex_state = 2},
  [1013] = {.lex_state = 2, .external_lex_state = 3},
  [1014] = {.lex_state = 11},
  [1015] = {.lex_state = 2, .external_lex_state = 3},
  [1016] = {.lex_state = 2, .external_lex_state = 2},
  [1017] = {.lex_state = 2, .external_lex_state = 3},
  [1018] = {.lex_state = 2, .external_lex_state = 3},
  [1019] = {.lex_state = 2, .external_lex_state = 2},
  [1020] = {.lex_state = 3, .external_lex_state = 2},
  [1021] = {.lex_state = 2, .external_lex_state = 2},
  [1022] = {.lex_state = 2, .external_lex_state = 2},
  [1023] = {.lex_state = 2, .external_lex_state = 3},
  [1024] = {.lex_state = 3, .external_lex_state = 2},
  [1025] = {.lex_state = 2, .external_lex_state = 2},
  [1026] = {.lex_state = 3, .external_lex_state = 2},
  [1027] = {.lex_state = 2, .external_lex_state = 3},
  [1028] = {.lex_state = 2, .external_lex_state = 2},
  [1029] = {.lex_state = 2, .external_lex_state = 2},
  [1030] = {.lex_state = 2, .external_lex_state = 2},
  [1031] = {.lex_state = 2, .external_lex_state = 2},
  [1032] = {.lex_state = 2, .external_lex_state = 3},
  [1033] = {.lex_state = 2, .external_lex_state = 2},
  [1034] = {.lex_state = 2, .external_lex_state = 2},
  [1035] = {.lex_state = 2, .external_lex_state = 2},
  [1036] = {.lex_state = 2, .external_lex_state = 2},
  [1037] = {.lex_state = 2, .external_lex_state = 2},
  [1038] = {.lex_state = 2, .external_lex_state = 2},
  [1039] = {.lex_state = 2, .external_lex_state = 2},
  [1040] = {.lex_state = 2, .external_lex_state = 2},
  [1041] = {.lex_state = 2, .external_lex_state = 3},
  [1042] = {.lex_state = 2, .external_lex_state = 2},
  [1043] = {.lex_state = 2, .external_lex_state = 2},
  [1044] = {.lex_state = 2, .external_lex_state = 3},
  [1045] = {.lex_state = 2, .external_lex_state = 2},
  [1046] = {.lex_state = 2, .external_lex_state = 3},
  [1047] = {.lex_state = 2, .external_lex_state = 2},
  [1048] = {.lex_state = 2, .external_lex_state = 3},
  [1049] = {.lex_state = 2, .external_lex_state = 2},
  [1050] = {.lex_state = 2, .external_lex_state = 3},
  [1051] = {.lex_state = 2, .external_lex_state = 2},
  [1052] = {.lex_state = 2, .external_lex_state = 3},
  [1053] = {.lex_state = 2, .external_lex_state = 2},
  [1054] = {.lex_state = 2, .external_lex_state = 2},
  [1055] = {.lex_state = 2, .external_lex_state = 2},
  [1056] = {.lex_state = 3, .external_lex_state = 2},
  [1057] = {.lex_state = 2, .external_lex_state = 3},
  [1058] = {.lex_state = 2, .external_lex_state = 2},
  [1059] = {.lex_state = 2, .external_lex_state = 3},
  [1060] = {.lex_state = 2, .external_lex_state = 2},
  [1061] = {.lex_state = 2, .external_lex_state = 2},
  [1062] = {.lex_state = 2, .external_lex_state = 2},
  [1063] = {.lex_state = 2, .external_lex_state = 2},
  [1064] = {.lex_state = 2, .external_lex_state = 2},
  [1065] = {.lex_state = 3, .external_lex_state = 2},
  [1066] = {.lex_state = 2, .external_lex_state = 3},
  [1067] = {.lex_state = 2, .external_lex_state = 2},
  [1068] = {.lex_state = 2, .external_lex_state = 3},
  [1069] = {.lex_state = 2, .external_lex_state = 2},
  [1070] = {.lex_state = 2, .external_lex_state = 3},
  [1071] = {.lex_state = 2, .external_lex_state = 3},
  [1072] = {.lex_state = 2, .external_lex_state = 2},
  [1073] = {.lex_state = 2, .external_lex_state = 2},
  [1074] = {.lex_state = 2, .external_lex_state = 3},
  [1075] = {.lex_state = 2, .external_lex_state = 2},
  [1076] = {.lex_state = 2, .external_lex_state = 3},
  [1077] = {.lex_state = 2, .external_lex_state = 2},
  [1078] = {.lex_state = 2, .external_lex_state = 3},
  [1079] = {.lex_state = 2, .external_lex_state = 3},
  [1080] = {.lex_state = 2, .external_lex_state = 3},
  [1081] = {.lex_state = 2, .external_lex_state = 2},
  [1082] = {.lex_state = 2, .external_lex_state = 3},
  [1083] = {.lex_state = 2, .external_lex_state = 3},
  [1084] = {.lex_state = 2, .external_lex_state = 3},
  [1085] = {.lex_state = 2, .external_lex_state = 3},
  [1086] = {.lex_state = 2, .external_lex_state = 3},
  [1087] = {.lex_state = 3, .external_lex_state = 2},
  [1088] = {.lex_state = 2, .external_lex_state = 3},
  [1089] = {.lex_state = 2, .external_lex_state = 3},
  [1090] = {.lex_state = 2, .external_lex_state = 3},
  [1091] = {.lex_state = 2, .external_lex_state = 2},
  [1092] = {.lex_state = 2, .external_lex_state = 3},
  [1093] = {.lex_state = 2, .external_lex_state = 3},
  [1094] = {.lex_state = 2, .external_lex_state = 3},
  [1095] = {.lex_state = 2, .external_lex_state = 3},
  [1096] = {.lex_state = 2, .external_lex_state = 3},
  [1097] = {.lex_state = 2, .external_lex_state = 2},
  [1098] = {.lex_state = 2, .external_lex_state = 3},
  [1099] = {.lex_state = 2, .external_lex_state = 3},
  [1100] = {.lex_state = 2, .external_lex_state = 3},
  [1101] = {.lex_state = 2, .external_lex_state = 2},
  [1102] = {.lex_state = 2, .external_lex_state = 3},
  [1103] = {.lex_state = 2, .external_lex_state = 2},
  [1104] = {.lex_state = 2, .external_lex_state = 3},
  [1105] = {.lex_state = 2, .external_lex_state = 3},
  [1106] = {.lex_state = 74},
  [1107] = {.lex_state = 2, .external_lex_state = 2},
  [1108] = {.lex_state = 2, .external_lex_state = 2},
  [1109] = {.lex_state = 2, .external_lex_state = 2},
  [1110] = {.lex_state = 2, .external_lex_state = 2},
  [1111] = {.lex_state = 3, .external_lex_state = 2},
  [1112] = {.lex_state = 3, .external_lex_state = 2},
  [1113] = {.lex_state = 3, .external_lex_state = 2},
  [1114] = {.lex_state = 2, .external_lex_state = 2},
  [1115] = {.lex_state = 2, .external_lex_state = 2},
  [1116] = {.lex_state = 2, .external_lex_state = 2},
  [1117] = {.lex_state = 2, .external_lex_state = 2},
  [1118] = {.lex_state = 2, .external_lex_state = 3},
  [1119] = {.lex_state = 2, .external_lex_state = 2},
  [1120] = {.lex_state = 2, .external_lex_state = 3},
  [1121] = {.lex_state = 2, .external_lex_state = 2},
  [1122] = {.lex_state = 3, .external_lex_state = 2},
  [1123] = {.lex_state = 74},
  [1124] = {.lex_state = 2, .external_lex_state = 2},
  [1125] = {.lex_state = 2, .external_lex_state = 3},
  [1126] = {.lex_state = 2, .external_lex_state = 3},
  [1127] = {.lex_state = 2, .external_lex_state = 2},
  [1128] = {.lex_state = 2, .external_lex_state = 3},
  [1129] = {.lex_state = 2, .external_lex_state = 2},
  [1130] = {.lex_state = 2, .external_lex_state = 2},
  [1131] = {.lex_state = 74},
  [1132] = {.lex_state = 3, .external_lex_state = 2},
  [1133] = {.lex_state = 74},
  [1134] = {.lex_state = 2, .external_lex_state = 3},
  [1135] = {.lex_state = 2, .external_lex_state = 3},
  [1136] = {.lex_state = 2, .external_lex_state = 3},
  [1137] = {.lex_state = 2, .external_lex_state = 2},
  [1138] = {.lex_state = 2, .external_lex_state = 2},
  [1139] = {.lex_state = 2, .external_lex_state = 2},
  [1140] = {.lex_state = 2, .external_lex_state = 2},
  [1141] = {.lex_state = 2, .external_lex_state = 2},
  [1142] = {.lex_state = 2, .external_lex_state = 3},
  [1143] = {.lex_state = 2, .external_lex_state = 2},
  [1144] = {.lex_state = 2, .external_lex_state = 2},
  [1145] = {.lex_state = 2, .external_lex_state = 2},
  [1146] = {.lex_state = 2, .external_lex_state = 2},
  [1147] = {.lex_state = 2, .external_lex_state = 2},
  [1148] = {.lex_state = 2, .external_lex_state = 3},
  [1149] = {.lex_state = 74},
  [1150] = {.lex_state = 74},
  [1151] = {.lex_state = 74},
  [1152] = {.lex_state = 2, .external_lex_state = 2},
  [1153] = {.lex_state = 2, .external_lex_state = 2},
  [1154] = {.lex_state = 2, .external_lex_state = 2},
  [1155] = {.lex_state = 2, .external_lex_state = 2},
  [1156] = {.lex_state = 2, .external_lex_state = 2},
  [1157] = {.lex_state = 2, .external_lex_state = 2},
  [1158] = {.lex_state = 2, .external_lex_state = 2},
  [1159] = {.lex_state = 2, .external_lex_state = 2},
  [1160] = {.lex_state = 2, .external_lex_state = 2},
  [1161] = {.lex_state = 2, .external_lex_state = 2},
  [1162] = {.lex_state = 9},
  [1163] = {.lex_state = 9},
  [1164] = {.lex_state = 9},
  [1165] = {.lex_state = 9},
  [1166] = {.lex_state = 9},
  [1167] = {.lex_state = 9},
  [1168] = {.lex_state = 74, .external_lex_state = 4},
  [1169] = {.lex_state = 74, .external_lex_state = 4},
  [1170] = {.lex_state = 74, .external_lex_state = 4},
  [1171] = {.lex_state = 74, .external_lex_state = 4},
  [1172] = {.lex_state = 74, .external_lex_state = 4},
  [1173] = {.lex_state = 9},
  [1174] = {.lex_state = 9},
  [1175] = {.lex_state = 9},
  [1176] = {.lex_state = 9},
  [1177] = {.lex_state = 9},
  [1178] = {.lex_state = 9},
  [1179] = {.lex_state = 9},
  [1180] = {.lex_state = 9},
  [1181] = {.lex_state = 9},
  [1182] = {.lex_state = 9},
  [1183] = {.lex_state = 9},
  [1184] = {.lex_state = 73, .external_lex_state = 3},
  [1185] = {.lex_state = 9},
  [1186] = {.lex_state = 9},
  [1187] = {.lex_state = 9},
  [1188] = {.lex_state = 9},
  [1189] = {.lex_state = 9},
  [1190] = {.lex_state = 9},
  [1191] = {.lex_state = 9},
  [1192] = {.lex_state = 74, .external_lex_state = 4},
  [1193] = {.lex_state = 74, .external_lex_state = 4},
  [1194] = {.lex_state = 73, .external_lex_state = 3},
  [1195] = {.lex_state = 9},
  [1196] = {.lex_state = 9},
  [1197] = {.lex_state = 9},
  [1198] = {.lex_state = 9},
  [1199] = {.lex_state = 9},
  [1200] = {.lex_state = 9},
  [1201] = {.lex_state = 9},
  [1202] = {.lex_state = 73, .external_lex_state = 3},
  [1203] = {.lex_state = 74},
  [1204] = {.lex_state = 74},
  [1205] = {.lex_state = 73, .external_lex_state = 2},
  [1206] = {.lex_state = 74},
  [1207] = {.lex_state = 74},
  [1208] = {.lex_state = 74},
  [1209] = {.lex_state = 74},
  [1210] = {.lex_state = 74},
  [1211] = {.lex_state = 73, .external_lex_state = 3},
  [1212] = {.lex_state = 73, .external_lex_state = 2},
  [1213] = {.lex_state = 73, .external_lex_state = 2},
  [1214] = {.lex_state = 73, .external_lex_state = 2},
  [1215] = {.lex_state = 73, .external_lex_state = 2},
  [1216] = {.lex_state = 73, .external_lex_state = 2},
  [1217] = {.lex_state = 73, .external_lex_state = 3},
  [1218] = {.lex_state = 73, .external_lex_state = 2},
  [1219] = {.lex_state = 73, .external_lex_state = 3},
  [1220] = {.lex_state = 73, .external_lex_state = 2},
  [1221] = {.lex_state = 73, .external_lex_state = 2},
  [1222] = {.lex_state = 73, .external_lex_state = 2},
  [1223] = {.lex_state = 73, .external_lex_state = 2},
  [1224] = {.lex_state = 73, .external_lex_state = 2},
  [1225] = {.lex_state = 74},
  [1226] = {.lex_state = 73, .external_lex_state = 2},
  [1227] = {.lex_state = 73, .external_lex_state = 2},
  [1228] = {.lex_state = 73, .external_lex_state = 2},
  [1229] = {.lex_state = 73, .external_lex_state = 2},
  [1230] = {.lex_state = 73, .external_lex_state = 2},
  [1231] = {.lex_state = 73, .external_lex_state = 2},
  [1232] = {.lex_state = 73, .external_lex_state = 2},
  [1233] = {.lex_state = 73, .external_lex_state = 2},
  [1234] = {.lex_state = 73, .external_lex_state = 2},
  [1235] = {.lex_state = 73, .external_lex_state = 2},
  [1236] = {.lex_state = 73, .external_lex_state = 2},
  [1237] = {.lex_state = 73, .external_lex_state = 2},
  [1238] = {.lex_state = 73, .external_lex_state = 2},
  [1239] = {.lex_state = 73, .external_lex_state = 2},
  [1240] = {.lex_state = 73, .external_lex_state = 2},
  [1241] = {.lex_state = 73, .external_lex_state = 2},
  [1242] = {.lex_state = 73, .external_lex_state = 2},
  [1243] = {.lex_state = 73, .external_lex_state = 2},
  [1244] = {.lex_state = 73, .external_lex_state = 2},
  [1245] = {.lex_state = 73, .external_lex_state = 2},
  [1246] = {.lex_state = 73, .external_lex_state = 2},
  [1247] = {.lex_state = 73, .external_lex_state = 2},
  [1248] = {.lex_state = 73, .external_lex_state = 2},
  [1249] = {.lex_state = 73, .external_lex_state = 3},
  [1250] = {.lex_state = 73, .external_lex_state = 2},
  [1251] = {.lex_state = 73, .external_lex_state = 2},
  [1252] = {.lex_state = 73, .external_lex_state = 2},
  [1253] = {.lex_state = 73, .external_lex_state = 2},
  [1254] = {.lex_state = 73, .external_lex_state = 2},
  [1255] = {.lex_state = 73, .external_lex_state = 2},
  [1256] = {.lex_state = 73, .external_lex_state = 2},
  [1257] = {.lex_state = 73, .external_lex_state = 2},
  [1258] = {.lex_state = 73, .external_lex_state = 2},
  [1259] = {.lex_state = 73, .external_lex_state = 2},
  [1260] = {.lex_state = 73, .external_lex_state = 2},
  [1261] = {.lex_state = 73, .external_lex_state = 2},
  [1262] = {.lex_state = 73, .external_lex_state = 2},
  [1263] = {.lex_state = 73, .external_lex_state = 2},
  [1264] = {.lex_state = 73, .external_lex_state = 2},
  [1265] = {.lex_state = 73, .external_lex_state = 2},
  [1266] = {.lex_state = 73, .external_lex_state = 2},
  [1267] = {.lex_state = 73, .external_lex_state = 2},
  [1268] = {.lex_state = 73, .external_lex_state = 2},
  [1269] = {.lex_state = 73, .external_lex_state = 2},
  [1270] = {.lex_state = 73, .external_lex_state = 2},
  [1271] = {.lex_state = 73, .external_lex_state = 2},
  [1272] = {.lex_state = 73, .external_lex_state = 3},
  [1273] = {.lex_state = 73, .external_lex_state = 2},
  [1274] = {.lex_state = 73, .external_lex_state = 2},
  [1275] = {.lex_state = 73, .external_lex_state = 2},
  [1276] = {.lex_state = 73, .external_lex_state = 2},
  [1277] = {.lex_state = 73, .external_lex_state = 2},
  [1278] = {.lex_state = 73, .external_lex_state = 2},
  [1279] = {.lex_state = 73, .external_lex_state = 2},
  [1280] = {.lex_state = 73, .external_lex_state = 2},
  [1281] = {.lex_state = 73, .external_lex_state = 2},
  [1282] = {.lex_state = 73, .external_lex_state = 2},
  [1283] = {.lex_state = 73, .external_lex_state = 2},
  [1284] = {.lex_state = 73, .external_lex_state = 2},
  [1285] = {.lex_state = 73, .external_lex_state = 2},
  [1286] = {.lex_state = 73, .external_lex_state = 2},
  [1287] = {.lex_state = 73, .external_lex_state = 2},
  [1288] = {.lex_state = 73, .external_lex_state = 2},
  [1289] = {.lex_state = 73, .external_lex_state = 2},
  [1290] = {.lex_state = 73, .external_lex_state = 2},
  [1291] = {.lex_state = 73, .external_lex_state = 2},
  [1292] = {.lex_state = 73, .external_lex_state = 2},
  [1293] = {.lex_state = 73, .external_lex_state = 2},
  [1294] = {.lex_state = 73, .external_lex_state = 2},
  [1295] = {.lex_state = 73, .external_lex_state = 2},
  [1296] = {.lex_state = 73, .external_lex_state = 2},
  [1297] = {.lex_state = 73, .external_lex_state = 2},
  [1298] = {.lex_state = 73, .external_lex_state = 2},
  [1299] = {.lex_state = 73, .external_lex_state = 2},
  [1300] = {.lex_state = 73, .external_lex_state = 2},
  [1301] = {.lex_state = 73, .external_lex_state = 2},
  [1302] = {.lex_state = 73, .external_lex_state = 2},
  [1303] = {.lex_state = 73, .external_lex_state = 2},
  [1304] = {.lex_state = 73, .external_lex_state = 2},
  [1305] = {.lex_state = 73, .external_lex_state = 2},
  [1306] = {.lex_state = 73, .external_lex_state = 2},
  [1307] = {.lex_state = 73, .external_lex_state = 3},
  [1308] = {.lex_state = 73, .external_lex_state = 2},
  [1309] = {.lex_state = 73, .external_lex_state = 2},
  [1310] = {.lex_state = 73, .external_lex_state = 2},
  [1311] = {.lex_state = 73, .external_lex_state = 2},
  [1312] = {.lex_state = 73, .external_lex_state = 2},
  [1313] = {.lex_state = 73, .external_lex_state = 2},
  [1314] = {.lex_state = 73, .external_lex_state = 2},
  [1315] = {.lex_state = 73, .external_lex_state = 2},
  [1316] = {.lex_state = 73, .external_lex_state = 2},
  [1317] = {.lex_state = 73, .external_lex_state = 2},
  [1318] = {.lex_state = 73, .external_lex_state = 2},
  [1319] = {.lex_state = 73, .external_lex_state = 2},
  [1320] = {.lex_state = 73, .external_lex_state = 2},
  [1321] = {.lex_state = 73, .external_lex_state = 2},
  [1322] = {.lex_state = 73, .external_lex_state = 2},
  [1323] = {.lex_state = 73, .external_lex_state = 2},
  [1324] = {.lex_state = 73, .external_lex_state = 2},
  [1325] = {.lex_state = 73, .external_lex_state = 2},
  [1326] = {.lex_state = 73, .external_lex_state = 2},
  [1327] = {.lex_state = 73, .external_lex_state = 2},
  [1328] = {.lex_state = 73, .external_lex_state = 2},
  [1329] = {.lex_state = 73, .external_lex_state = 2},
  [1330] = {.lex_state = 73, .external_lex_state = 2},
  [1331] = {.lex_state = 73, .external_lex_state = 2},
  [1332] = {.lex_state = 73, .external_lex_state = 2},
  [1333] = {.lex_state = 73, .external_lex_state = 2},
  [1334] = {.lex_state = 73, .external_lex_state = 3},
  [1335] = {.lex_state = 73, .external_lex_state = 2},
  [1336] = {.lex_state = 73, .external_lex_state = 2},
  [1337] = {.lex_state = 73, .external_lex_state = 2},
  [1338] = {.lex_state = 73, .external_lex_state = 3},
  [1339] = {.lex_state = 73, .external_lex_state = 2},
  [1340] = {.lex_state = 73, .external_lex_state = 2},
  [1341] = {.lex_state = 73, .external_lex_state = 2},
  [1342] = {.lex_state = 73, .external_lex_state = 2},
  [1343] = {.lex_state = 73, .external_lex_state = 2},
  [1344] = {.lex_state = 73, .external_lex_state = 2},
  [1345] = {.lex_state = 73, .external_lex_state = 2},
  [1346] = {.lex_state = 73, .external_lex_state = 2},
  [1347] = {.lex_state = 73, .external_lex_state = 2},
  [1348] = {.lex_state = 73, .external_lex_state = 2},
  [1349] = {.lex_state = 73, .external_lex_state = 2},
  [1350] = {.lex_state = 73, .external_lex_state = 2},
  [1351] = {.lex_state = 73, .external_lex_state = 2},
  [1352] = {.lex_state = 73, .external_lex_state = 2},
  [1353] = {.lex_state = 73, .external_lex_state = 2},
  [1354] = {.lex_state = 73, .external_lex_state = 3},
  [1355] = {.lex_state = 73, .external_lex_state = 2},
  [1356] = {.lex_state = 73, .external_lex_state = 2},
  [1357] = {.lex_state = 73, .external_lex_state = 2},
  [1358] = {.lex_state = 73, .external_lex_state = 2},
  [1359] = {.lex_state = 73, .external_lex_state = 2},
  [1360] = {.lex_state = 73, .external_lex_state = 2},
  [1361] = {.lex_state = 73, .external_lex_state = 2},
  [1362] = {.lex_state = 73, .external_lex_state = 2},
  [1363] = {.lex_state = 73, .external_lex_state = 2},
  [1364] = {.lex_state = 73, .external_lex_state = 2},
  [1365] = {.lex_state = 73, .external_lex_state = 2},
  [1366] = {.lex_state = 73, .external_lex_state = 2},
  [1367] = {.lex_state = 73, .external_lex_state = 2},
  [1368] = {.lex_state = 73, .external_lex_state = 2},
  [1369] = {.lex_state = 73, .external_lex_state = 2},
  [1370] = {.lex_state = 73, .external_lex_state = 2},
  [1371] = {.lex_state = 73, .external_lex_state = 2},
  [1372] = {.lex_state = 73, .external_lex_state = 2},
  [1373] = {.lex_state = 73, .external_lex_state = 2},
  [1374] = {.lex_state = 73, .external_lex_state = 2},
  [1375] = {.lex_state = 73, .external_lex_state = 2},
  [1376] = {.lex_state = 73, .external_lex_state = 2},
  [1377] = {.lex_state = 73, .external_lex_state = 3},
  [1378] = {.lex_state = 73, .external_lex_state = 2},
  [1379] = {.lex_state = 73, .external_lex_state = 2},
  [1380] = {.lex_state = 73, .external_lex_state = 2},
  [1381] = {.lex_state = 73, .external_lex_state = 2},
  [1382] = {.lex_state = 73, .external_lex_state = 2},
  [1383] = {.lex_state = 73, .external_lex_state = 2},
  [1384] = {.lex_state = 73, .external_lex_state = 2},
  [1385] = {.lex_state = 73, .external_lex_state = 2},
  [1386] = {.lex_state = 73, .external_lex_state = 2},
  [1387] = {.lex_state = 73, .external_lex_state = 2},
  [1388] = {.lex_state = 73, .external_lex_state = 2},
  [1389] = {.lex_state = 73, .external_lex_state = 2},
  [1390] = {.lex_state = 73, .external_lex_state = 2},
  [1391] = {.lex_state = 73, .external_lex_state = 2},
  [1392] = {.lex_state = 73, .external_lex_state = 3},
  [1393] = {.lex_state = 73, .external_lex_state = 3},
  [1394] = {.lex_state = 73, .external_lex_state = 2},
  [1395] = {.lex_state = 73, .external_lex_state = 2},
  [1396] = {.lex_state = 73, .external_lex_state = 2},
  [1397] = {.lex_state = 73, .external_lex_state = 3},
  [1398] = {.lex_state = 73, .external_lex_state = 2},
  [1399] = {.lex_state = 73, .external_lex_state = 2},
  [1400] = {.lex_state = 73, .external_lex_state = 2},
  [1401] = {.lex_state = 73, .external_lex_state = 2},
  [1402] = {.lex_state = 73, .external_lex_state = 2},
  [1403] = {.lex_state = 73, .external_lex_state = 2},
  [1404] = {.lex_state = 73, .external_lex_state = 2},
  [1405] = {.lex_state = 73, .external_lex_state = 2},
  [1406] = {.lex_state = 73, .external_lex_state = 2},
  [1407] = {.lex_state = 73, .external_lex_state = 2},
  [1408] = {.lex_state = 73, .external_lex_state = 2},
  [1409] = {.lex_state = 73, .external_lex_state = 2},
  [1410] = {.lex_state = 73, .external_lex_state = 2},
  [1411] = {.lex_state = 73, .external_lex_state = 2},
  [1412] = {.lex_state = 73, .external_lex_state = 2},
  [1413] = {.lex_state = 73, .external_lex_state = 2},
  [1414] = {.lex_state = 73, .external_lex_state = 2},
  [1415] = {.lex_state = 73, .external_lex_state = 2},
  [1416] = {.lex_state = 73, .external_lex_state = 2},
  [1417] = {.lex_state = 73, .external_lex_state = 2},
  [1418] = {.lex_state = 73, .external_lex_state = 3},
  [1419] = {.lex_state = 73, .external_lex_state = 2},
  [1420] = {.lex_state = 73, .external_lex_state = 2},
  [1421] = {.lex_state = 73, .external_lex_state = 2},
  [1422] = {.lex_state = 73, .external_lex_state = 2},
  [1423] = {.lex_state = 73, .external_lex_state = 2},
  [1424] = {.lex_state = 73, .external_lex_state = 2},
  [1425] = {.lex_state = 73, .external_lex_state = 2},
  [1426] = {.lex_state = 73, .external_lex_state = 2},
  [1427] = {.lex_state = 73, .external_lex_state = 2},
  [1428] = {.lex_state = 73, .external_lex_state = 2},
  [1429] = {.lex_state = 73, .external_lex_state = 2},
  [1430] = {.lex_state = 73, .external_lex_state = 2},
  [1431] = {.lex_state = 73, .external_lex_state = 2},
  [1432] = {.lex_state = 73, .external_lex_state = 3},
  [1433] = {.lex_state = 73, .external_lex_state = 2},
  [1434] = {.lex_state = 73, .external_lex_state = 2},
  [1435] = {.lex_state = 73, .external_lex_state = 2},
  [1436] = {.lex_state = 73, .external_lex_state = 2},
  [1437] = {.lex_state = 73, .external_lex_state = 3},
  [1438] = {.lex_state = 73, .external_lex_state = 3},
  [1439] = {.lex_state = 9},
  [1440] = {.lex_state = 73, .external_lex_state = 2},
  [1441] = {.lex_state = 73, .external_lex_state = 3},
  [1442] = {.lex_state = 73, .external_lex_state = 2},
  [1443] = {.lex_state = 73, .external_lex_state = 2},
  [1444] = {.lex_state = 73, .external_lex_state = 2},
  [1445] = {.lex_state = 73, .external_lex_state = 3},
  [1446] = {.lex_state = 73, .external_lex_state = 3},
  [1447] = {.lex_state = 73, .external_lex_state = 3},
  [1448] = {.lex_state = 73, .external_lex_state = 3},
  [1449] = {.lex_state = 73, .external_lex_state = 3},
  [1450] = {.lex_state = 73, .external_lex_state = 3},
  [1451] = {.lex_state = 73, .external_lex_state = 3},
  [1452] = {.lex_state = 73, .external_lex_state = 3},
  [1453] = {.lex_state = 73, .external_lex_state = 3},
  [1454] = {.lex_state = 73, .external_lex_state = 3},
  [1455] = {.lex_state = 73, .external_lex_state = 3},
  [1456] = {.lex_state = 74, .external_lex_state = 4},
  [1457] = {.lex_state = 73, .external_lex_state = 2},
  [1458] = {.lex_state = 73, .external_lex_state = 3},
  [1459] = {.lex_state = 9},
  [1460] = {.lex_state = 73, .external_lex_state = 2},
  [1461] = {.lex_state = 73, .external_lex_state = 2},
  [1462] = {.lex_state = 73, .external_lex_state = 3},
  [1463] = {.lex_state = 9},
  [1464] = {.lex_state = 73, .external_lex_state = 3},
  [1465] = {.lex_state = 73, .external_lex_state = 3},
  [1466] = {.lex_state = 73, .external_lex_state = 3},
  [1467] = {.lex_state = 73, .external_lex_state = 3},
  [1468] = {.lex_state = 73, .external_lex_state = 2},
  [1469] = {.lex_state = 73, .external_lex_state = 3},
  [1470] = {.lex_state = 74, .external_lex_state = 4},
  [1471] = {.lex_state = 73, .external_lex_state = 2},
  [1472] = {.lex_state = 73, .external_lex_state = 2},
  [1473] = {.lex_state = 73, .external_lex_state = 3},
  [1474] = {.lex_state = 73, .external_lex_state = 3},
  [1475] = {.lex_state = 73, .external_lex_state = 3},
  [1476] = {.lex_state = 73, .external_lex_state = 3},
  [1477] = {.lex_state = 73, .external_lex_state = 3},
  [1478] = {.lex_state = 73, .external_lex_state = 3},
  [1479] = {.lex_state = 73, .external_lex_state = 3},
  [1480] = {.lex_state = 73, .external_lex_state = 3},
  [1481] = {.lex_state = 73, .external_lex_state = 2},
  [1482] = {.lex_state = 9},
  [1483] = {.lex_state = 73, .external_lex_state = 3},
  [1484] = {.lex_state = 73, .external_lex_state = 3},
  [1485] = {.lex_state = 73, .external_lex_state = 3},
  [1486] = {.lex_state = 73, .external_lex_state = 3},
  [1487] = {.lex_state = 73, .external_lex_state = 3},
  [1488] = {.lex_state = 73, .external_lex_state = 3},
  [1489] = {.lex_state = 73, .external_lex_state = 3},
  [1490] = {.lex_state = 73, .external_lex_state = 3},
  [1491] = {.lex_state = 73, .external_lex_state = 3},
  [1492] = {.lex_state = 74, .external_lex_state = 4},
  [1493] = {.lex_state = 73, .external_lex_state = 3},
  [1494] = {.lex_state = 73, .external_lex_state = 3},
  [1495] = {.lex_state = 9},
  [1496] = {.lex_state = 9},
  [1497] = {.lex_state = 9},
  [1498] = {.lex_state = 73, .external_lex_state = 3},
  [1499] = {.lex_state = 73, .external_lex_state = 3},
  [1500] = {.lex_state = 73, .external_lex_state = 2},
  [1501] = {.lex_state = 73, .external_lex_state = 3},
  [1502] = {.lex_state = 73, .external_lex_state = 3},
  [1503] = {.lex_state = 73, .external_lex_state = 3},
  [1504] = {.lex_state = 73, .external_lex_state = 3},
  [1505] = {.lex_state = 74, .external_lex_state = 4},
  [1506] = {.lex_state = 73, .external_lex_state = 3},
  [1507] = {.lex_state = 73, .external_lex_state = 3},
  [1508] = {.lex_state = 73, .external_lex_state = 3},
  [1509] = {.lex_state = 73, .external_lex_state = 3},
  [1510] = {.lex_state = 73, .external_lex_state = 3},
  [1511] = {.lex_state = 9},
  [1512] = {.lex_state = 73, .external_lex_state = 2},
  [1513] = {.lex_state = 9},
  [1514] = {.lex_state = 73, .external_lex_state = 3},
  [1515] = {.lex_state = 73, .external_lex_state = 3},
  [1516] = {.lex_state = 73, .external_lex_state = 3},
  [1517] = {.lex_state = 73, .external_lex_state = 3},
  [1518] = {.lex_state = 73, .external_lex_state = 2},
  [1519] = {.lex_state = 9},
  [1520] = {.lex_state = 73, .external_lex_state = 3},
  [1521] = {.lex_state = 73, .external_lex_state = 3},
  [1522] = {.lex_state = 73, .external_lex_state = 2},
  [1523] = {.lex_state = 74, .external_lex_state = 4},
  [1524] = {.lex_state = 73, .external_lex_state = 3},
  [1525] = {.lex_state = 73, .external_lex_state = 3},
  [1526] = {.lex_state = 73, .external_lex_state = 3},
  [1527] = {.lex_state = 73, .external_lex_state = 3},
  [1528] = {.lex_state = 73, .external_lex_state = 3},
  [1529] = {.lex_state = 73, .external_lex_state = 3},
  [1530] = {.lex_state = 73, .external_lex_state = 3},
  [1531] = {.lex_state = 73, .external_lex_state = 3},
  [1532] = {.lex_state = 73, .external_lex_state = 3},
  [1533] = {.lex_state = 73, .external_lex_state = 3},
  [1534] = {.lex_state = 73, .external_lex_state = 3},
  [1535] = {.lex_state = 73, .external_lex_state = 3},
  [1536] = {.lex_state = 9},
  [1537] = {.lex_state = 73, .external_lex_state = 3},
  [1538] = {.lex_state = 73, .external_lex_state = 3},
  [1539] = {.lex_state = 73, .external_lex_state = 3},
  [1540] = {.lex_state = 73, .external_lex_state = 3},
  [1541] = {.lex_state = 73, .external_lex_state = 3},
  [1542] = {.lex_state = 73, .external_lex_state = 3},
  [1543] = {.lex_state = 73, .external_lex_state = 3},
  [1544] = {.lex_state = 73, .external_lex_state = 3},
  [1545] = {.lex_state = 73, .external_lex_state = 3},
  [1546] = {.lex_state = 73, .external_lex_state = 3},
  [1547] = {.lex_state = 73, .external_lex_state = 3},
  [1548] = {.lex_state = 73, .external_lex_state = 3},
  [1549] = {.lex_state = 73, .external_lex_state = 2},
  [1550] = {.lex_state = 73, .external_lex_state = 3},
  [1551] = {.lex_state = 73, .external_lex_state = 3},
  [1552] = {.lex_state = 73, .external_lex_state = 3},
  [1553] = {.lex_state = 4, .external_lex_state = 2},
  [1554] = {.lex_state = 73, .external_lex_state = 2},
  [1555] = {.lex_state = 73, .external_lex_state = 3},
  [1556] = {.lex_state = 73, .external_lex_state = 3},
  [1557] = {.lex_state = 73, .external_lex_state = 3},
  [1558] = {.lex_state = 73, .external_lex_state = 3},
  [1559] = {.lex_state = 73, .external_lex_state = 3},
  [1560] = {.lex_state = 73, .external_lex_state = 3},
  [1561] = {.lex_state = 73, .external_lex_state = 3},
  [1562] = {.lex_state = 74, .external_lex_state = 4},
  [1563] = {.lex_state = 73, .external_lex_state = 3},
  [1564] = {.lex_state = 73, .external_lex_state = 3},
  [1565] = {.lex_state = 73, .external_lex_state = 3},
  [1566] = {.lex_state = 73, .external_lex_state = 3},
  [1567] = {.lex_state = 74, .external_lex_state = 4},
  [1568] = {.lex_state = 73, .external_lex_state = 3},
  [1569] = {.lex_state = 73, .external_lex_state = 3},
  [1570] = {.lex_state = 73, .external_lex_state = 3},
  [1571] = {.lex_state = 73, .external_lex_state = 3},
  [1572] = {.lex_state = 73, .external_lex_state = 3},
  [1573] = {.lex_state = 73, .external_lex_state = 2},
  [1574] = {.lex_state = 73, .external_lex_state = 3},
  [1575] = {.lex_state = 73, .external_lex_state = 2},
  [1576] = {.lex_state = 73, .external_lex_state = 3},
  [1577] = {.lex_state = 73, .external_lex_state = 3},
  [1578] = {.lex_state = 73, .external_lex_state = 2},
  [1579] = {.lex_state = 73, .external_lex_state = 3},
  [1580] = {.lex_state = 73, .external_lex_state = 3},
  [1581] = {.lex_state = 73, .external_lex_state = 2},
  [1582] = {.lex_state = 73, .external_lex_state = 2},
  [1583] = {.lex_state = 73, .external_lex_state = 2},
  [1584] = {.lex_state = 74, .external_lex_state = 4},
  [1585] = {.lex_state = 74, .external_lex_state = 4},
  [1586] = {.lex_state = 73, .external_lex_state = 3},
  [1587] = {.lex_state = 74, .external_lex_state = 4},
  [1588] = {.lex_state = 73, .external_lex_state = 2},
  [1589] = {.lex_state = 73, .external_lex_state = 3},
  [1590] = {.lex_state = 73, .external_lex_state = 2},
  [1591] = {.lex_state = 73, .external_lex_state = 3},
  [1592] = {.lex_state = 73, .external_lex_state = 3},
  [1593] = {.lex_state = 73, .external_lex_state = 3},
  [1594] = {.lex_state = 73, .external_lex_state = 2},
  [1595] = {.lex_state = 73, .external_lex_state = 2},
  [1596] = {.lex_state = 73, .external_lex_state = 2},
  [1597] = {.lex_state = 73, .external_lex_state = 2},
  [1598] = {.lex_state = 73, .external_lex_state = 3},
  [1599] = {.lex_state = 73, .external_lex_state = 2},
  [1600] = {.lex_state = 73, .external_lex_state = 3},
  [1601] = {.lex_state = 73, .external_lex_state = 3},
  [1602] = {.lex_state = 73, .external_lex_state = 2},
  [1603] = {.lex_state = 73, .external_lex_state = 2},
  [1604] = {.lex_state = 73, .external_lex_state = 2},
  [1605] = {.lex_state = 74, .external_lex_state = 4},
  [1606] = {.lex_state = 73, .external_lex_state = 3},
  [1607] = {.lex_state = 73, .external_lex_state = 3},
  [1608] = {.lex_state = 74, .external_lex_state = 4},
  [1609] = {.lex_state = 73, .external_lex_state = 2},
  [1610] = {.lex_state = 73, .external_lex_state = 2},
  [1611] = {.lex_state = 73, .external_lex_state = 2},
  [1612] = {.lex_state = 73, .external_lex_state = 2},
  [1613] = {.lex_state = 73, .external_lex_state = 2},
  [1614] = {.lex_state = 73, .external_lex_state = 2},
  [1615] = {.lex_state = 73, .external_lex_state = 3},
  [1616] = {.lex_state = 73, .external_lex_state = 3},
  [1617] = {.lex_state = 73, .external_lex_state = 3},
  [1618] = {.lex_state = 73, .external_lex_state = 2},
  [1619] = {.lex_state = 73, .external_lex_state = 3},
  [1620] = {.lex_state = 73, .external_lex_state = 2},
  [1621] = {.lex_state = 73, .external_lex_state = 2},
  [1622] = {.lex_state = 73, .external_lex_state = 3},
  [1623] = {.lex_state = 73, .external_lex_state = 3},
  [1624] = {.lex_state = 73, .external_lex_state = 3},
  [1625] = {.lex_state = 73, .external_lex_state = 2},
  [1626] = {.lex_state = 73, .external_lex_state = 3},
  [1627] = {.lex_state = 73, .external_lex_state = 3},
  [1628] = {.lex_state = 73, .external_lex_state = 2},
  [1629] = {.lex_state = 73, .external_lex_state = 3},
  [1630] = {.lex_state = 73, .external_lex_state = 3},
  [1631] = {.lex_state = 73, .external_lex_state = 2},
  [1632] = {.lex_state = 73, .external_lex_state = 3},
  [1633] = {.lex_state = 74, .external_lex_state = 4},
  [1634] = {.lex_state = 74, .external_lex_state = 4},
  [1635] = {.lex_state = 73, .external_lex_state = 2},
  [1636] = {.lex_state = 73, .external_lex_state = 2},
  [1637] = {.lex_state = 73, .external_lex_state = 2},
  [1638] = {.lex_state = 73, .external_lex_state = 2},
  [1639] = {.lex_state = 73, .external_lex_state = 3},
  [1640] = {.lex_state = 73, .external_lex_state = 3},
  [1641] = {.lex_state = 73, .external_lex_state = 3},
  [1642] = {.lex_state = 73, .external_lex_state = 3},
  [1643] = {.lex_state = 73, .external_lex_state = 3},
  [1644] = {.lex_state = 73, .external_lex_state = 3},
  [1645] = {.lex_state = 73, .external_lex_state = 3},
  [1646] = {.lex_state = 73, .external_lex_state = 3},
  [1647] = {.lex_state = 73, .external_lex_state = 3},
  [1648] = {.lex_state = 73, .external_lex_state = 2},
  [1649] = {.lex_state = 73, .external_lex_state = 3},
  [1650] = {.lex_state = 73, .external_lex_state = 2},
  [1651] = {.lex_state = 73, .external_lex_state = 2},
  [1652] = {.lex_state = 73, .external_lex_state = 3},
  [1653] = {.lex_state = 73, .external_lex_state = 2},
  [1654] = {.lex_state = 73, .external_lex_state = 2},
  [1655] = {.lex_state = 73, .external_lex_state = 2},
  [1656] = {.lex_state = 73, .external_lex_state = 2},
  [1657] = {.lex_state = 73, .external_lex_state = 2},
  [1658] = {.lex_state = 73, .external_lex_state = 2},
  [1659] = {.lex_state = 73, .external_lex_state = 2},
  [1660] = {.lex_state = 73, .external_lex_state = 2},
  [1661] = {.lex_state = 73, .external_lex_state = 2},
  [1662] = {.lex_state = 73, .external_lex_state = 2},
  [1663] = {.lex_state = 73, .external_lex_state = 3},
  [1664] = {.lex_state = 73, .external_lex_state = 2},
  [1665] = {.lex_state = 73, .external_lex_state = 2},
  [1666] = {.lex_state = 73, .external_lex_state = 2},
  [1667] = {.lex_state = 73, .external_lex_state = 3},
  [1668] = {.lex_state = 73, .external_lex_state = 2},
  [1669] = {.lex_state = 73, .external_lex_state = 3},
  [1670] = {.lex_state = 73, .external_lex_state = 2},
  [1671] = {.lex_state = 73, .external_lex_state = 2},
  [1672] = {.lex_state = 73, .external_lex_state = 3},
  [1673] = {.lex_state = 73, .external_lex_state = 2},
  [1674] = {.lex_state = 73, .external_lex_state = 2},
  [1675] = {.lex_state = 73, .external_lex_state = 2},
  [1676] = {.lex_state = 73, .external_lex_state = 3},
  [1677] = {.lex_state = 73, .external_lex_state = 3},
  [1678] = {.lex_state = 73, .external_lex_state = 3},
  [1679] = {.lex_state = 73, .external_lex_state = 3},
  [1680] = {.lex_state = 73, .external_lex_state = 3},
  [1681] = {.lex_state = 73, .external_lex_state = 2},
  [1682] = {.lex_state = 73, .external_lex_state = 3},
  [1683] = {.lex_state = 73, .external_lex_state = 3},
  [1684] = {.lex_state = 73, .external_lex_state = 3},
  [1685] = {.lex_state = 73, .external_lex_state = 2},
  [1686] = {.lex_state = 73, .external_lex_state = 3},
  [1687] = {.lex_state = 73, .external_lex_state = 3},
  [1688] = {.lex_state = 73, .external_lex_state = 2},
  [1689] = {.lex_state = 73, .external_lex_state = 3},
  [1690] = {.lex_state = 73, .external_lex_state = 2},
  [1691] = {.lex_state = 73, .external_lex_state = 2},
  [1692] = {.lex_state = 73, .external_lex_state = 2},
  [1693] = {.lex_state = 73, .external_lex_state = 2},
  [1694] = {.lex_state = 73, .external_lex_state = 3},
  [1695] = {.lex_state = 73, .external_lex_state = 2},
  [1696] = {.lex_state = 73, .external_lex_state = 2},
  [1697] = {.lex_state = 73, .external_lex_state = 3},
  [1698] = {.lex_state = 74, .external_lex_state = 4},
  [1699] = {.lex_state = 73, .external_lex_state = 2},
  [1700] = {.lex_state = 73, .external_lex_state = 3},
  [1701] = {.lex_state = 73, .external_lex_state = 2},
  [1702] = {.lex_state = 73, .external_lex_state = 2},
  [1703] = {.lex_state = 73, .external_lex_state = 2},
  [1704] = {.lex_state = 73, .external_lex_state = 3},
  [1705] = {.lex_state = 73, .external_lex_state = 2},
  [1706] = {.lex_state = 73, .external_lex_state = 2},
  [1707] = {.lex_state = 73, .external_lex_state = 3},
  [1708] = {.lex_state = 73, .external_lex_state = 2},
  [1709] = {.lex_state = 73, .external_lex_state = 2},
  [1710] = {.lex_state = 73, .external_lex_state = 2},
  [1711] = {.lex_state = 73, .external_lex_state = 2},
  [1712] = {.lex_state = 73, .external_lex_state = 2},
  [1713] = {.lex_state = 73, .external_lex_state = 3},
  [1714] = {.lex_state = 73, .external_lex_state = 3},
  [1715] = {.lex_state = 73, .external_lex_state = 2},
  [1716] = {.lex_state = 73, .external_lex_state = 3},
  [1717] = {.lex_state = 73, .external_lex_state = 3},
  [1718] = {.lex_state = 73, .external_lex_state = 3},
  [1719] = {.lex_state = 73, .external_lex_state = 3},
  [1720] = {.lex_state = 73, .external_lex_state = 2},
  [1721] = {.lex_state = 73, .external_lex_state = 2},
  [1722] = {.lex_state = 73, .external_lex_state = 2},
  [1723] = {.lex_state = 73, .external_lex_state = 3},
  [1724] = {.lex_state = 73, .external_lex_state = 2},
  [1725] = {.lex_state = 73, .external_lex_state = 2},
  [1726] = {.lex_state = 73, .external_lex_state = 3},
  [1727] = {.lex_state = 73, .external_lex_state = 3},
  [1728] = {.lex_state = 73, .external_lex_state = 3},
  [1729] = {.lex_state = 73, .external_lex_state = 3},
  [1730] = {.lex_state = 73, .external_lex_state = 3},
  [1731] = {.lex_state = 73, .external_lex_state = 2},
  [1732] = {.lex_state = 73, .external_lex_state = 3},
  [1733] = {.lex_state = 73, .external_lex_state = 3},
  [1734] = {.lex_state = 73, .external_lex_state = 3},
  [1735] = {.lex_state = 73, .external_lex_state = 3},
  [1736] = {.lex_state = 73, .external_lex_state = 3},
  [1737] = {.lex_state = 73, .external_lex_state = 3},
  [1738] = {.lex_state = 73, .external_lex_state = 3},
  [1739] = {.lex_state = 73, .external_lex_state = 2},
  [1740] = {.lex_state = 73, .external_lex_state = 3},
  [1741] = {.lex_state = 73, .external_lex_state = 3},
  [1742] = {.lex_state = 73, .external_lex_state = 3},
  [1743] = {.lex_state = 73, .external_lex_state = 3},
  [1744] = {.lex_state = 73, .external_lex_state = 3},
  [1745] = {.lex_state = 73, .external_lex_state = 3},
  [1746] = {.lex_state = 4, .external_lex_state = 3},
  [1747] = {.lex_state = 73, .external_lex_state = 3},
  [1748] = {.lex_state = 74, .external_lex_state = 4},
  [1749] = {.lex_state = 73, .external_lex_state = 3},
  [1750] = {.lex_state = 73, .external_lex_state = 3},
  [1751] = {.lex_state = 73, .external_lex_state = 2},
  [1752] = {.lex_state = 73, .external_lex_state = 3},
  [1753] = {.lex_state = 73, .external_lex_state = 2},
  [1754] = {.lex_state = 73, .external_lex_state = 3},
  [1755] = {.lex_state = 73, .external_lex_state = 3},
  [1756] = {.lex_state = 73, .external_lex_state = 3},
  [1757] = {.lex_state = 73, .external_lex_state = 2},
  [1758] = {.lex_state = 73, .external_lex_state = 2},
  [1759] = {.lex_state = 73, .external_lex_state = 3},
  [1760] = {.lex_state = 73, .external_lex_state = 3},
  [1761] = {.lex_state = 73, .external_lex_state = 3},
  [1762] = {.lex_state = 73, .external_lex_state = 3},
  [1763] = {.lex_state = 73, .external_lex_state = 3},
  [1764] = {.lex_state = 73, .external_lex_state = 3},
  [1765] = {.lex_state = 73, .external_lex_state = 3},
  [1766] = {.lex_state = 73, .external_lex_state = 3},
  [1767] = {.lex_state = 73, .external_lex_state = 3},
  [1768] = {.lex_state = 73, .external_lex_state = 3},
  [1769] = {.lex_state = 73, .external_lex_state = 3},
  [1770] = {.lex_state = 73, .external_lex_state = 3},
  [1771] = {.lex_state = 73, .external_lex_state = 3},
  [1772] = {.lex_state = 73, .external_lex_state = 3},
  [1773] = {.lex_state = 73, .external_lex_state = 3},
  [1774] = {.lex_state = 73, .external_lex_state = 2},
  [1775] = {.lex_state = 73, .external_lex_state = 3},
  [1776] = {.lex_state = 73, .external_lex_state = 2},
  [1777] = {.lex_state = 73, .external_lex_state = 3},
  [1778] = {.lex_state = 73, .external_lex_state = 3},
  [1779] = {.lex_state = 73, .external_lex_state = 3},
  [1780] = {.lex_state = 73, .external_lex_state = 3},
  [1781] = {.lex_state = 73, .external_lex_state = 3},
  [1782] = {.lex_state = 73, .external_lex_state = 2},
  [1783] = {.lex_state = 73, .external_lex_state = 2},
  [1784] = {.lex_state = 73, .external_lex_state = 3},
  [1785] = {.lex_state = 73, .external_lex_state = 3},
  [1786] = {.lex_state = 73, .external_lex_state = 3},
  [1787] = {.lex_state = 73, .external_lex_state = 3},
  [1788] = {.lex_state = 73, .external_lex_state = 2},
  [1789] = {.lex_state = 73, .external_lex_state = 3},
  [1790] = {.lex_state = 73, .external_lex_state = 3},
  [1791] = {.lex_state = 73, .external_lex_state = 3},
  [1792] = {.lex_state = 74, .external_lex_state = 4},
  [1793] = {.lex_state = 73, .external_lex_state = 3},
  [1794] = {.lex_state = 73, .external_lex_state = 3},
  [1795] = {.lex_state = 73, .external_lex_state = 3},
  [1796] = {.lex_state = 73, .external_lex_state = 2},
  [1797] = {.lex_state = 73, .external_lex_state = 3},
  [1798] = {.lex_state = 73, .external_lex_state = 3},
  [1799] = {.lex_state = 73, .external_lex_state = 3},
  [1800] = {.lex_state = 73, .external_lex_state = 3},
  [1801] = {.lex_state = 73, .external_lex_state = 3},
  [1802] = {.lex_state = 73, .external_lex_state = 3},
  [1803] = {.lex_state = 73, .external_lex_state = 3},
  [1804] = {.lex_state = 73, .external_lex_state = 2},
  [1805] = {.lex_state = 73, .external_lex_state = 3},
  [1806] = {.lex_state = 73, .external_lex_state = 3},
  [1807] = {.lex_state = 73, .external_lex_state = 2},
  [1808] = {.lex_state = 73, .external_lex_state = 3},
  [1809] = {.lex_state = 73, .external_lex_state = 2},
  [1810] = {.lex_state = 73, .external_lex_state = 3},
  [1811] = {.lex_state = 73, .external_lex_state = 3},
  [1812] = {.lex_state = 73, .external_lex_state = 2},
  [1813] = {.lex_state = 73, .external_lex_state = 2},
  [1814] = {.lex_state = 73, .external_lex_state = 2},
  [1815] = {.lex_state = 73, .external_lex_state = 2},
  [1816] = {.lex_state = 73, .external_lex_state = 3},
  [1817] = {.lex_state = 73, .external_lex_state = 3},
  [1818] = {.lex_state = 73, .external_lex_state = 2},
  [1819] = {.lex_state = 73, .external_lex_state = 2},
  [1820] = {.lex_state = 73, .external_lex_state = 3},
  [1821] = {.lex_state = 73, .external_lex_state = 2},
  [1822] = {.lex_state = 73, .external_lex_state = 3},
  [1823] = {.lex_state = 73, .external_lex_state = 3},
  [1824] = {.lex_state = 73, .external_lex_state = 2},
  [1825] = {.lex_state = 73, .external_lex_state = 3},
  [1826] = {.lex_state = 73, .external_lex_state = 3},
  [1827] = {.lex_state = 73, .external_lex_state = 2},
  [1828] = {.lex_state = 73, .external_lex_state = 2},
  [1829] = {.lex_state = 73, .external_lex_state = 3},
  [1830] = {.lex_state = 73, .external_lex_state = 3},
  [1831] = {.lex_state = 73, .external_lex_state = 3},
  [1832] = {.lex_state = 73, .external_lex_state = 3},
  [1833] = {.lex_state = 73, .external_lex_state = 3},
  [1834] = {.lex_state = 73, .external_lex_state = 3},
  [1835] = {.lex_state = 73, .external_lex_state = 3},
  [1836] = {.lex_state = 73, .external_lex_state = 3},
  [1837] = {.lex_state = 73, .external_lex_state = 3},
  [1838] = {.lex_state = 73, .external_lex_state = 2},
  [1839] = {.lex_state = 73, .external_lex_state = 2},
  [1840] = {.lex_state = 73, .external_lex_state = 3},
  [1841] = {.lex_state = 73, .external_lex_state = 3},
  [1842] = {.lex_state = 74, .external_lex_state = 4},
  [1843] = {.lex_state = 73, .external_lex_state = 2},
  [1844] = {.lex_state = 73, .external_lex_state = 3},
  [1845] = {.lex_state = 73, .external_lex_state = 3},
  [1846] = {.lex_state = 73, .external_lex_state = 2},
  [1847] = {.lex_state = 73, .external_lex_state = 3},
  [1848] = {.lex_state = 73, .external_lex_state = 3},
  [1849] = {.lex_state = 73, .external_lex_state = 3},
  [1850] = {.lex_state = 73, .external_lex_state = 2},
  [1851] = {.lex_state = 73, .external_lex_state = 3},
  [1852] = {.lex_state = 73, .external_lex_state = 3},
  [1853] = {.lex_state = 73, .external_lex_state = 3},
  [1854] = {.lex_state = 73, .external_lex_state = 3},
  [1855] = {.lex_state = 73, .external_lex_state = 3},
  [1856] = {.lex_state = 73, .external_lex_state = 3},
  [1857] = {.lex_state = 73, .external_lex_state = 2},
  [1858] = {.lex_state = 73, .external_lex_state = 3},
  [1859] = {.lex_state = 73, .external_lex_state = 3},
  [1860] = {.lex_state = 73, .external_lex_state = 3},
  [1861] = {.lex_state = 73, .external_lex_state = 3},
  [1862] = {.lex_state = 74, .external_lex_state = 4},
  [1863] = {.lex_state = 73, .external_lex_state = 3},
  [1864] = {.lex_state = 73, .external_lex_state = 3},
  [1865] = {.lex_state = 73, .external_lex_state = 3},
  [1866] = {.lex_state = 73, .external_lex_state = 3},
  [1867] = {.lex_state = 73, .external_lex_state = 2},
  [1868] = {.lex_state = 73, .external_lex_state = 3},
  [1869] = {.lex_state = 74, .external_lex_state = 4},
  [1870] = {.lex_state = 73, .external_lex_state = 3},
  [1871] = {.lex_state = 73, .external_lex_state = 2},
  [1872] = {.lex_state = 73, .external_lex_state = 3},
  [1873] = {.lex_state = 73, .external_lex_state = 3},
  [1874] = {.lex_state = 73, .external_lex_state = 3},
  [1875] = {.lex_state = 73, .external_lex_state = 3},
  [1876] = {.lex_state = 73, .external_lex_state = 3},
  [1877] = {.lex_state = 73, .external_lex_state = 2},
  [1878] = {.lex_state = 73, .external_lex_state = 2},
  [1879] = {.lex_state = 73, .external_lex_state = 3},
  [1880] = {.lex_state = 73, .external_lex_state = 3},
  [1881] = {.lex_state = 73, .external_lex_state = 3},
  [1882] = {.lex_state = 74, .external_lex_state = 4},
  [1883] = {.lex_state = 73, .external_lex_state = 3},
  [1884] = {.lex_state = 73, .external_lex_state = 3},
  [1885] = {.lex_state = 73, .external_lex_state = 3},
  [1886] = {.lex_state = 73, .external_lex_state = 2},
  [1887] = {.lex_state = 73, .external_lex_state = 2},
  [1888] = {.lex_state = 73, .external_lex_state = 3},
  [1889] = {.lex_state = 73, .external_lex_state = 3},
  [1890] = {.lex_state = 73, .external_lex_state = 3},
  [1891] = {.lex_state = 73, .external_lex_state = 2},
  [1892] = {.lex_state = 73, .external_lex_state = 3},
  [1893] = {.lex_state = 73, .external_lex_state = 2},
  [1894] = {.lex_state = 73, .external_lex_state = 3},
  [1895] = {.lex_state = 73, .external_lex_state = 3},
  [1896] = {.lex_state = 73, .external_lex_state = 3},
  [1897] = {.lex_state = 73, .external_lex_state = 2},
  [1898] = {.lex_state = 73, .external_lex_state = 2},
  [1899] = {.lex_state = 73, .external_lex_state = 3},
  [1900] = {.lex_state = 73, .external_lex_state = 2},
  [1901] = {.lex_state = 73, .external_lex_state = 3},
  [1902] = {.lex_state = 74, .external_lex_state = 4},
  [1903] = {.lex_state = 73, .external_lex_state = 3},
  [1904] = {.lex_state = 73, .external_lex_state = 3},
  [1905] = {.lex_state = 73, .external_lex_state = 3},
  [1906] = {.lex_state = 4, .external_lex_state = 3},
  [1907] = {.lex_state = 73, .external_lex_state = 3},
  [1908] = {.lex_state = 73, .external_lex_state = 3},
  [1909] = {.lex_state = 73, .external_lex_state = 2},
  [1910] = {.lex_state = 73, .external_lex_state = 3},
  [1911] = {.lex_state = 73, .external_lex_state = 2},
  [1912] = {.lex_state = 73, .external_lex_state = 3},
  [1913] = {.lex_state = 73, .external_lex_state = 3},
  [1914] = {.lex_state = 73, .external_lex_state = 3},
  [1915] = {.lex_state = 73, .external_lex_state = 3},
  [1916] = {.lex_state = 73, .external_lex_state = 3},
  [1917] = {.lex_state = 73, .external_lex_state = 3},
  [1918] = {.lex_state = 73, .external_lex_state = 3},
  [1919] = {.lex_state = 73, .external_lex_state = 2},
  [1920] = {.lex_state = 73, .external_lex_state = 3},
  [1921] = {.lex_state = 73, .external_lex_state = 3},
  [1922] = {.lex_state = 73, .external_lex_state = 3},
  [1923] = {.lex_state = 73, .external_lex_state = 3},
  [1924] = {.lex_state = 73, .external_lex_state = 3},
  [1925] = {.lex_state = 73, .external_lex_state = 3},
  [1926] = {.lex_state = 73, .external_lex_state = 3},
  [1927] = {.lex_state = 73, .external_lex_state = 3},
  [1928] = {.lex_state = 73, .external_lex_state = 2},
  [1929] = {.lex_state = 73, .external_lex_state = 3},
  [1930] = {.lex_state = 73, .external_lex_state = 2},
  [1931] = {.lex_state = 73, .external_lex_state = 2},
  [1932] = {.lex_state = 73, .external_lex_state = 2},
  [1933] = {.lex_state = 73, .external_lex_state = 2},
  [1934] = {.lex_state = 73, .external_lex_state = 2},
  [1935] = {.lex_state = 73, .external_lex_state = 2},
  [1936] = {.lex_state = 73, .external_lex_state = 2},
  [1937] = {.lex_state = 73, .external_lex_state = 2},
  [1938] = {.lex_state = 74},
  [1939] = {.lex_state = 74},
  [1940] = {.lex_state = 73, .external_lex_state = 2},
  [1941] = {.lex_state = 74, .external_lex_state = 4},
  [1942] = {.lex_state = 73, .external_lex_state = 2},
  [1943] = {.lex_state = 73, .external_lex_state = 2},
  [1944] = {.lex_state = 73, .external_lex_state = 2},
  [1945] = {.lex_state = 73, .external_lex_state = 2},
  [1946] = {.lex_state = 73, .external_lex_state = 2},
  [1947] = {.lex_state = 73, .external_lex_state = 2},
  [1948] = {.lex_state = 73, .external_lex_state = 2},
  [1949] = {.lex_state = 73, .external_lex_state = 2},
  [1950] = {.lex_state = 74, .external_lex_state = 4},
  [1951] = {.lex_state = 74, .external_lex_state = 4},
  [1952] = {.lex_state = 73, .external_lex_state = 2},
  [1953] = {.lex_state = 73, .external_lex_state = 2},
  [1954] = {.lex_state = 73, .external_lex_state = 2},
  [1955] = {.lex_state = 73, .external_lex_state = 2},
  [1956] = {.lex_state = 73, .external_lex_state = 2},
  [1957] = {.lex_state = 73, .external_lex_state = 2},
  [1958] = {.lex_state = 73, .external_lex_state = 2},
  [1959] = {.lex_state = 73, .external_lex_state = 2},
  [1960] = {.lex_state = 73, .external_lex_state = 2},
  [1961] = {.lex_state = 73, .external_lex_state = 2},
  [1962] = {.lex_state = 73, .external_lex_state = 2},
  [1963] = {.lex_state = 73, .external_lex_state = 2},
  [1964] = {.lex_state = 73, .external_lex_state = 2},
  [1965] = {.lex_state = 73, .external_lex_state = 3},
  [1966] = {.lex_state = 73, .external_lex_state = 2},
  [1967] = {.lex_state = 73, .external_lex_state = 2},
  [1968] = {.lex_state = 74},
  [1969] = {.lex_state = 73, .external_lex_state = 2},
  [1970] = {.lex_state = 73, .external_lex_state = 2},
  [1971] = {.lex_state = 73, .external_lex_state = 2},
  [1972] = {.lex_state = 73, .external_lex_state = 2},
  [1973] = {.lex_state = 73, .external_lex_state = 2},
  [1974] = {.lex_state = 73, .external_lex_state = 2},
  [1975] = {.lex_state = 73, .external_lex_state = 2},
  [1976] = {.lex_state = 73, .external_lex_state = 2},
  [1977] = {.lex_state = 73, .external_lex_state = 2},
  [1978] = {.lex_state = 73, .external_lex_state = 2},
  [1979] = {.lex_state = 74, .external_lex_state = 4},
  [1980] = {.lex_state = 73, .external_lex_state = 2},
  [1981] = {.lex_state = 74},
  [1982] = {.lex_state = 74},
  [1983] = {.lex_state = 74, .external_lex_state = 4},
  [1984] = {.lex_state = 73, .external_lex_state = 2},
  [1985] = {.lex_state = 73, .external_lex_state = 2},
  [1986] = {.lex_state = 74, .external_lex_state = 4},
  [1987] = {.lex_state = 74},
  [1988] = {.lex_state = 73, .external_lex_state = 3},
  [1989] = {.lex_state = 73, .external_lex_state = 3},
  [1990] = {.lex_state = 73, .external_lex_state = 2},
  [1991] = {.lex_state = 4, .external_lex_state = 2},
  [1992] = {.lex_state = 74},
  [1993] = {.lex_state = 73, .external_lex_state = 2},
  [1994] = {.lex_state = 74},
  [1995] = {.lex_state = 73, .external_lex_state = 2},
  [1996] = {.lex_state = 73, .external_lex_state = 2},
  [1997] = {.lex_state = 73, .external_lex_state = 2},
  [1998] = {.lex_state = 74},
  [1999] = {.lex_state = 74, .external_lex_state = 4},
  [2000] = {.lex_state = 74, .external_lex_state = 4},
  [2001] = {.lex_state = 74, .external_lex_state = 4},
  [2002] = {.lex_state = 74},
  [2003] = {.lex_state = 74, .external_lex_state = 4},
  [2004] = {.lex_state = 74, .external_lex_state = 4},
  [2005] = {.lex_state = 74, .external_lex_state = 4},
  [2006] = {.lex_state = 73, .external_lex_state = 2},
  [2007] = {.lex_state = 73, .external_lex_state = 2},
  [2008] = {.lex_state = 73, .external_lex_state = 2},
  [2009] = {.lex_state = 73, .external_lex_state = 2},
  [2010] = {.lex_state = 73, .external_lex_state = 2},
  [2011] = {.lex_state = 73, .external_lex_state = 2},
  [2012] = {.lex_state = 73, .external_lex_state = 2},
  [2013] = {.lex_state = 74, .external_lex_state = 4},
  [2014] = {.lex_state = 74, .external_lex_state = 4},
  [2015] = {.lex_state = 73, .external_lex_state = 2},
  [2016] = {.lex_state = 74, .external_lex_state = 4},
  [2017] = {.lex_state = 74, .external_lex_state = 4},
  [2018] = {.lex_state = 74, .external_lex_state = 4},
  [2019] = {.lex_state = 73, .external_lex_state = 2},
  [2020] = {.lex_state = 74, .external_lex_state = 4},
  [2021] = {.lex_state = 73, .external_lex_state = 3},
  [2022] = {.lex_state = 74, .external_lex_state = 4},
  [2023] = {.lex_state = 73, .external_lex_state = 3},
  [2024] = {.lex_state = 73, .external_lex_state = 2},
  [2025] = {.lex_state = 73, .external_lex_state = 2},
  [2026] = {.lex_state = 73, .external_lex_state = 2},
  [2027] = {.lex_state = 73, .external_lex_state = 2},
  [2028] = {.lex_state = 74, .external_lex_state = 4},
  [2029] = {.lex_state = 74, .external_lex_state = 4},
  [2030] = {.lex_state = 73, .external_lex_state = 2},
  [2031] = {.lex_state = 73, .external_lex_state = 2},
  [2032] = {.lex_state = 74, .external_lex_state = 4},
  [2033] = {.lex_state = 74, .external_lex_state = 4},
  [2034] = {.lex_state = 74, .external_lex_state = 4},
  [2035] = {.lex_state = 74},
  [2036] = {.lex_state = 73, .external_lex_state = 2},
  [2037] = {.lex_state = 73, .external_lex_state = 2},
  [2038] = {.lex_state = 74, .external_lex_state = 4},
  [2039] = {.lex_state = 74, .external_lex_state = 4},
  [2040] = {.lex_state = 74},
  [2041] = {.lex_state = 74, .external_lex_state = 4},
  [2042] = {.lex_state = 73, .external_lex_state = 2},
  [2043] = {.lex_state = 74},
  [2044] = {.lex_state = 74, .external_lex_state = 4},
  [2045] = {.lex_state = 74, .external_lex_state = 4},
  [2046] = {.lex_state = 74},
  [2047] = {.lex_state = 74, .external_lex_state = 4},
  [2048] = {.lex_state = 74, .external_lex_state = 4},
  [2049] = {.lex_state = 73, .external_lex_state = 2},
  [2050] = {.lex_state = 74, .external_lex_state = 4},
  [2051] = {.lex_state = 73, .external_lex_state = 2},
  [2052] = {.lex_state = 73, .external_lex_state = 2},
  [2053] = {.lex_state = 73, .external_lex_state = 2},
  [2054] = {.lex_state = 73, .external_lex_state = 2},
  [2055] = {.lex_state = 73, .external_lex_state = 2},
  [2056] = {.lex_state = 73, .external_lex_state = 2},
  [2057] = {.lex_state = 73, .external_lex_state = 2},
  [2058] = {.lex_state = 73, .external_lex_state = 2},
  [2059] = {.lex_state = 73, .external_lex_state = 2},
  [2060] = {.lex_state = 74, .external_lex_state = 4},
  [2061] = {.lex_state = 73, .external_lex_state = 2},
  [2062] = {.lex_state = 73, .external_lex_state = 2},
  [2063] = {.lex_state = 73, .external_lex_state = 2},
  [2064] = {.lex_state = 74},
  [2065] = {.lex_state = 73, .external_lex_state = 2},
  [2066] = {.lex_state = 73, .external_lex_state = 2},
  [2067] = {.lex_state = 73, .external_lex_state = 3},
  [2068] = {.lex_state = 74, .external_lex_state = 4},
  [2069] = {.lex_state = 74, .external_lex_state = 4},
  [2070] = {.lex_state = 73, .external_lex_state = 2},
  [2071] = {.lex_state = 74},
  [2072] = {.lex_state = 74},
  [2073] = {.lex_state = 73, .external_lex_state = 2},
  [2074] = {.lex_state = 74, .external_lex_state = 4},
  [2075] = {.lex_state = 74, .external_lex_state = 4},
  [2076] = {.lex_state = 74, .external_lex_state = 4},
  [2077] = {.lex_state = 73, .external_lex_state = 2},
  [2078] = {.lex_state = 74},
  [2079] = {.lex_state = 74, .external_lex_state = 4},
  [2080] = {.lex_state = 74, .external_lex_state = 4},
  [2081] = {.lex_state = 74, .external_lex_state = 4},
  [2082] = {.lex_state = 74},
  [2083] = {.lex_state = 73, .external_lex_state = 2},
  [2084] = {.lex_state = 74},
  [2085] = {.lex_state = 73, .external_lex_state = 2},
  [2086] = {.lex_state = 73, .external_lex_state = 2},
  [2087] = {.lex_state = 73, .external_lex_state = 2},
  [2088] = {.lex_state = 74},
  [2089] = {.lex_state = 74},
  [2090] = {.lex_state = 73, .external_lex_state = 2},
  [2091] = {.lex_state = 73, .external_lex_state = 2},
  [2092] = {.lex_state = 74, .external_lex_state = 4},
  [2093] = {.lex_state = 74},
  [2094] = {.lex_state = 73, .external_lex_state = 2},
  [2095] = {.lex_state = 74, .external_lex_state = 4},
  [2096] = {.lex_state = 73, .external_lex_state = 2},
  [2097] = {.lex_state = 73, .external_lex_state = 2},
  [2098] = {.lex_state = 74, .external_lex_state = 4},
  [2099] = {.lex_state = 74},
  [2100] = {.lex_state = 73, .external_lex_state = 2},
  [2101] = {.lex_state = 73, .external_lex_state = 2},
  [2102] = {.lex_state = 74, .external_lex_state = 4},
  [2103] = {.lex_state = 74},
  [2104] = {.lex_state = 74, .external_lex_state = 4},
  [2105] = {.lex_state = 74, .external_lex_state = 4},
  [2106] = {.lex_state = 74, .external_lex_state = 4},
  [2107] = {.lex_state = 74, .external_lex_state = 4},
  [2108] = {.lex_state = 74, .external_lex_state = 4},
  [2109] = {.lex_state = 74},
  [2110] = {.lex_state = 74, .external_lex_state = 4},
  [2111] = {.lex_state = 74, .external_lex_state = 4},
  [2112] = {.lex_state = 74, .external_lex_state = 4},
  [2113] = {.lex_state = 74},
  [2114] = {.lex_state = 74},
  [2115] = {.lex_state = 74, .external_lex_state = 4},
  [2116] = {.lex_state = 73, .external_lex_state = 2},
  [2117] = {.lex_state = 74},
  [2118] = {.lex_state = 73, .external_lex_state = 2},
  [2119] = {.lex_state = 74, .external_lex_state = 4},
  [2120] = {.lex_state = 74, .external_lex_state = 4},
  [2121] = {.lex_state = 74, .external_lex_state = 4},
  [2122] = {.lex_state = 4, .external_lex_state = 2},
  [2123] = {.lex_state = 74},
  [2124] = {.lex_state = 74, .external_lex_state = 4},
  [2125] = {.lex_state = 74},
  [2126] = {.lex_state = 74, .external_lex_state = 4},
  [2127] = {.lex_state = 73, .external_lex_state = 2},
  [2128] = {.lex_state = 74, .external_lex_state = 4},
  [2129] = {.lex_state = 74, .external_lex_state = 4},
  [2130] = {.lex_state = 74},
  [2131] = {.lex_state = 73, .external_lex_state = 2},
  [2132] = {.lex_state = 73, .external_lex_state = 2},
  [2133] = {.lex_state = 74},
  [2134] = {.lex_state = 74, .external_lex_state = 4},
  [2135] = {.lex_state = 74, .external_lex_state = 4},
  [2136] = {.lex_state = 74, .external_lex_state = 4},
  [2137] = {.lex_state = 74, .external_lex_state = 4},
  [2138] = {.lex_state = 74, .external_lex_state = 4},
  [2139] = {.lex_state = 74, .external_lex_state = 4},
  [2140] = {.lex_state = 74, .external_lex_state = 4},
  [2141] = {.lex_state = 74},
  [2142] = {.lex_state = 74},
  [2143] = {.lex_state = 74},
  [2144] = {.lex_state = 74, .external_lex_state = 4},
  [2145] = {.lex_state = 74, .external_lex_state = 4},
  [2146] = {.lex_state = 74},
  [2147] = {.lex_state = 74},
  [2148] = {.lex_state = 74},
  [2149] = {.lex_state = 74},
  [2150] = {.lex_state = 74},
  [2151] = {.lex_state = 74},
  [2152] = {.lex_state = 74},
  [2153] = {.lex_state = 74},
  [2154] = {.lex_state = 74},
  [2155] = {.lex_state = 74},
  [2156] = {.lex_state = 74},
  [2157] = {.lex_state = 74},
  [2158] = {.lex_state = 74, .external_lex_state = 4},
  [2159] = {.lex_state = 74},
  [2160] = {.lex_state = 74},
  [2161] = {.lex_state = 74},
  [2162] = {.lex_state = 74},
  [2163] = {.lex_state = 74},
  [2164] = {.lex_state = 74, .external_lex_state = 4},
  [2165] = {.lex_state = 74},
  [2166] = {.lex_state = 74},
  [2167] = {.lex_state = 74},
  [2168] = {.lex_state = 74},
  [2169] = {.lex_state = 9},
  [2170] = {.lex_state = 74},
  [2171] = {.lex_state = 74},
  [2172] = {.lex_state = 74},
  [2173] = {.lex_state = 74},
  [2174] = {.lex_state = 74},
  [2175] = {.lex_state = 74},
  [2176] = {.lex_state = 74},
  [2177] = {.lex_state = 9, .external_lex_state = 4},
  [2178] = {.lex_state = 9},
  [2179] = {.lex_state = 9, .external_lex_state = 4},
  [2180] = {.lex_state = 9, .external_lex_state = 4},
  [2181] = {.lex_state = 9, .external_lex_state = 4},
  [2182] = {.lex_state = 74},
  [2183] = {.lex_state = 9, .external_lex_state = 4},
  [2184] = {.lex_state = 9, .external_lex_state = 4},
  [2185] = {.lex_state = 9, .external_lex_state = 4},
  [2186] = {.lex_state = 9, .external_lex_state = 4},
  [2187] = {.lex_state = 74},
  [2188] = {.lex_state = 9, .external_lex_state = 4},
  [2189] = {.lex_state = 9, .external_lex_state = 4},
  [2190] = {.lex_state = 74},
  [2191] = {.lex_state = 9, .external_lex_state = 4},
  [2192] = {.lex_state = 74},
  [2193] = {.lex_state = 9, .external_lex_state = 4},
  [2194] = {.lex_state = 9, .external_lex_state = 4},
  [2195] = {.lex_state = 74},
  [2196] = {.lex_state = 74},
  [2197] = {.lex_state = 9, .external_lex_state = 4},
  [2198] = {.lex_state = 9, .external_lex_state = 4},
  [2199] = {.lex_state = 9, .external_lex_state = 4},
  [2200] = {.lex_state = 9, .external_lex_state = 4},
  [2201] = {.lex_state = 9, .external_lex_state = 4},
  [2202] = {.lex_state = 9, .external_lex_state = 4},
  [2203] = {.lex_state = 9, .external_lex_state = 4},
  [2204] = {.lex_state = 9, .external_lex_state = 4},
  [2205] = {.lex_state = 74},
  [2206] = {.lex_state = 74},
  [2207] = {.lex_state = 9, .external_lex_state = 4},
  [2208] = {.lex_state = 74},
  [2209] = {.lex_state = 9, .external_lex_state = 4},
  [2210] = {.lex_state = 74},
  [2211] = {.lex_state = 9, .external_lex_state = 4},
  [2212] = {.lex_state = 9, .external_lex_state = 4},
  [2213] = {.lex_state = 9, .external_lex_state = 4},
  [2214] = {.lex_state = 9, .external_lex_state = 4},
  [2215] = {.lex_state = 74},
  [2216] = {.lex_state = 74},
  [2217] = {.lex_state = 74},
  [2218] = {.lex_state = 74},
  [2219] = {.lex_state = 74},
  [2220] = {.lex_state = 74},
  [2221] = {.lex_state = 74},
  [2222] = {.lex_state = 74},
  [2223] = {.lex_state = 74},
  [2224] = {.lex_state = 74},
  [2225] = {.lex_state = 74},
  [2226] = {.lex_state = 74},
  [2227] = {.lex_state = 74},
  [2228] = {.lex_state = 74},
  [2229] = {.lex_state = 74},
  [2230] = {.lex_state = 74},
  [2231] = {.lex_state = 74},
  [2232] = {.lex_state = 74},
  [2233] = {.lex_state = 74},
  [2234] = {.lex_state = 74},
  [2235] = {.lex_state = 74},
  [2236] = {.lex_state = 74},
  [2237] = {.lex_state = 74},
  [2238] = {.lex_state = 74},
  [2239] = {.lex_state = 9},
  [2240] = {.lex_state = 74},
  [2241] = {.lex_state = 74},
  [2242] = {.lex_state = 74},
  [2243] = {.lex_state = 9},
  [2244] = {.lex_state = 74},
  [2245] = {.lex_state = 74},
  [2246] = {.lex_state = 74},
  [2247] = {.lex_state = 9},
  [2248] = {.lex_state = 74},
  [2249] = {.lex_state = 9},
  [2250] = {.lex_state = 9},
  [2251] = {.lex_state = 9},
  [2252] = {.lex_state = 74},
  [2253] = {.lex_state = 74},
  [2254] = {.lex_state = 74},
  [2255] = {.lex_state = 74},
  [2256] = {.lex_state = 74},
  [2257] = {.lex_state = 74},
  [2258] = {.lex_state = 74},
  [2259] = {.lex_state = 74},
  [2260] = {.lex_state = 74},
  [2261] = {.lex_state = 74},
  [2262] = {.lex_state = 74},
  [2263] = {.lex_state = 74},
  [2264] = {.lex_state = 74},
  [2265] = {.lex_state = 74},
  [2266] = {.lex_state = 74},
  [2267] = {.lex_state = 74},
  [2268] = {.lex_state = 74},
  [2269] = {.lex_state = 74},
  [2270] = {.lex_state = 74},
  [2271] = {.lex_state = 74},
  [2272] = {.lex_state = 74},
  [2273] = {.lex_state = 74},
  [2274] = {.lex_state = 74},
  [2275] = {.lex_state = 74},
  [2276] = {.lex_state = 74},
  [2277] = {.lex_state = 74},
  [2278] = {.lex_state = 74},
  [2279] = {.lex_state = 74},
  [2280] = {.lex_state = 74},
  [2281] = {.lex_state = 74},
  [2282] = {.lex_state = 74},
  [2283] = {.lex_state = 74},
  [2284] = {.lex_state = 74},
  [2285] = {.lex_state = 74},
  [2286] = {.lex_state = 74},
  [2287] = {.lex_state = 74},
  [2288] = {.lex_state = 74},
  [2289] = {.lex_state = 74},
  [2290] = {.lex_state = 74},
  [2291] = {.lex_state = 74},
  [2292] = {.lex_state = 74},
  [2293] = {.lex_state = 74},
  [2294] = {.lex_state = 74},
  [2295] = {.lex_state = 74},
  [2296] = {.lex_state = 74},
  [2297] = {.lex_state = 74},
  [2298] = {.lex_state = 74},
  [2299] = {.lex_state = 74},
  [2300] = {.lex_state = 74},
  [2301] = {.lex_state = 74},
  [2302] = {.lex_state = 74},
  [2303] = {.lex_state = 74},
  [2304] = {.lex_state = 74},
  [2305] = {.lex_state = 8},
  [2306] = {.lex_state = 16},
  [2307] = {.lex_state = 16},
  [2308] = {.lex_state = 8},
  [2309] = {.lex_state = 8},
  [2310] = {.lex_state = 74},
  [2311] = {.lex_state = 8},
  [2312] = {.lex_state = 8},
  [2313] = {.lex_state = 8},
  [2314] = {.lex_state = 8},
  [2315] = {.lex_state = 8},
  [2316] = {.lex_state = 8},
  [2317] = {.lex_state = 8},
  [2318] = {.lex_state = 8},
  [2319] = {.lex_state = 8},
  [2320] = {.lex_state = 8},
  [2321] = {.lex_state = 8},
  [2322] = {.lex_state = 8},
  [2323] = {.lex_state = 8},
  [2324] = {.lex_state = 8},
  [2325] = {.lex_state = 8},
  [2326] = {.lex_state = 8},
  [2327] = {.lex_state = 74},
  [2328] = {.lex_state = 8},
  [2329] = {.lex_state = 8},
  [2330] = {.lex_state = 74},
  [2331] = {.lex_state = 74},
  [2332] = {.lex_state = 8},
  [2333] = {.lex_state = 8},
  [2334] = {.lex_state = 8},
  [2335] = {.lex_state = 8},
  [2336] = {.lex_state = 74},
  [2337] = {.lex_state = 8},
  [2338] = {.lex_state = 8},
  [2339] = {.lex_state = 8},
  [2340] = {.lex_state = 8},
  [2341] = {.lex_state = 8},
  [2342] = {.lex_state = 8},
  [2343] = {.lex_state = 8},
  [2344] = {.lex_state = 8},
  [2345] = {.lex_state = 8},
  [2346] = {.lex_state = 8},
  [2347] = {.lex_state = 8},
  [2348] = {.lex_state = 8},
  [2349] = {.lex_state = 8},
  [2350] = {.lex_state = 74},
  [2351] = {.lex_state = 8},
  [2352] = {.lex_state = 74},
  [2353] = {.lex_state = 8},
  [2354] = {.lex_state = 8},
  [2355] = {.lex_state = 74, .external_lex_state = 4},
  [2356] = {.lex_state = 74, .external_lex_state = 4},
  [2357] = {.lex_state = 74},
  [2358] = {.lex_state = 74},
  [2359] = {.lex_state = 8, .external_lex_state = 4},
  [2360] = {.lex_state = 2},
  [2361] = {.lex_state = 74},
  [2362] = {.lex_state = 8, .external_lex_state = 4},
  [2363] = {.lex_state = 74},
  [2364] = {.lex_state = 74},
  [2365] = {.lex_state = 74},
  [2366] = {.lex_state = 74},
  [2367] = {.lex_state = 2},
  [2368] = {.lex_state = 2},
  [2369] = {.lex_state = 74},
  [2370] = {.lex_state = 74},
  [2371] = {.lex_state = 74},
  [2372] = {.lex_state = 74},
  [2373] = {.lex_state = 74},
  [2374] = {.lex_state = 2},
  [2375] = {.lex_state = 74},
  [2376] = {.lex_state = 74},
  [2377] = {.lex_state = 74},
  [2378] = {.lex_state = 8, .external_lex_state = 4},
  [2379] = {.lex_state = 74},
  [2380] = {.lex_state = 74},
  [2381] = {.lex_state = 74},
  [2382] = {.lex_state = 2},
  [2383] = {.lex_state = 74},
  [2384] = {.lex_state = 74},
  [2385] = {.lex_state = 2},
  [2386] = {.lex_state = 74},
  [2387] = {.lex_state = 74},
  [2388] = {.lex_state = 2},
  [2389] = {.lex_state = 74},
  [2390] = {.lex_state = 74},
  [2391] = {.lex_state = 74},
  [2392] = {.lex_state = 74},
  [2393] = {.lex_state = 74},
  [2394] = {.lex_state = 74},
  [2395] = {.lex_state = 74, .external_lex_state = 4},
  [2396] = {.lex_state = 74},
  [2397] = {.lex_state = 2},
  [2398] = {.lex_state = 74},
  [2399] = {.lex_state = 74},
  [2400] = {.lex_state = 74},
  [2401] = {.lex_state = 74},
  [2402] = {.lex_state = 74},
  [2403] = {.lex_state = 74},
  [2404] = {.lex_state = 74, .external_lex_state = 4},
  [2405] = {.lex_state = 74, .external_lex_state = 4},
  [2406] = {.lex_state = 74},
  [2407] = {.lex_state = 74},
  [2408] = {.lex_state = 74},
  [2409] = {.lex_state = 74, .external_lex_state = 4},
  [2410] = {.lex_state = 74},
  [2411] = {.lex_state = 74},
  [2412] = {.lex_state = 74},
  [2413] = {.lex_state = 74},
  [2414] = {.lex_state = 74},
  [2415] = {.lex_state = 74},
  [2416] = {.lex_state = 74, .external_lex_state = 4},
  [2417] = {.lex_state = 16},
  [2418] = {.lex_state = 74},
  [2419] = {.lex_state = 74},
  [2420] = {.lex_state = 74},
  [2421] = {.lex_state = 8, .external_lex_state = 4},
  [2422] = {.lex_state = 8, .external_lex_state = 4},
  [2423] = {.lex_state = 8, .external_lex_state = 4},
  [2424] = {.lex_state = 8, .external_lex_state = 4},
  [2425] = {.lex_state = 8, .external_lex_state = 4},
  [2426] = {.lex_state = 8, .external_lex_state = 4},
  [2427] = {.lex_state = 8, .external_lex_state = 4},
  [2428] = {.lex_state = 8, .external_lex_state = 4},
  [2429] = {.lex_state = 8, .external_lex_state = 4},
  [2430] = {.lex_state = 8, .external_lex_state = 4},
  [2431] = {.lex_state = 8, .external_lex_state = 4},
  [2432] = {.lex_state = 8, .external_lex_state = 4},
  [2433] = {.lex_state = 8, .external_lex_state = 4},
  [2434] = {.lex_state = 8, .external_lex_state = 4},
  [2435] = {.lex_state = 74},
  [2436] = {.lex_state = 74},
  [2437] = {.lex_state = 74},
  [2438] = {.lex_state = 74},
  [2439] = {.lex_state = 74},
  [2440] = {.lex_state = 74},
  [2441] = {.lex_state = 74},
  [2442] = {.lex_state = 74},
  [2443] = {.lex_state = 74},
  [2444] = {.lex_state = 74},
  [2445] = {.lex_state = 8, .external_lex_state = 4},
  [2446] = {.lex_state = 8, .external_lex_state = 4},
  [2447] = {.lex_state = 8, .external_lex_state = 4},
  [2448] = {.lex_state = 8, .external_lex_state = 4},
  [2449] = {.lex_state = 8, .external_lex_state = 4},
  [2450] = {.lex_state = 8, .external_lex_state = 4},
  [2451] = {.lex_state = 8, .external_lex_state = 4},
  [2452] = {.lex_state = 8, .external_lex_state = 4},
  [2453] = {.lex_state = 8, .external_lex_state = 4},
  [2454] = {.lex_state = 8, .external_lex_state = 4},
  [2455] = {.lex_state = 74},
  [2456] = {.lex_state = 74},
  [2457] = {.lex_state = 74},
  [2458] = {.lex_state = 8, .external_lex_state = 4},
  [2459] = {.lex_state = 8, .external_lex_state = 4},
  [2460] = {.lex_state = 8, .external_lex_state = 4},
  [2461] = {.lex_state = 8, .external_lex_state = 4},
  [2462] = {.lex_state = 8, .external_lex_state = 4},
  [2463] = {.lex_state = 8, .external_lex_state = 4},
  [2464] = {.lex_state = 8, .external_lex_state = 4},
  [2465] = {.lex_state = 8, .external_lex_state = 4},
  [2466] = {.lex_state = 8, .external_lex_state = 4},
  [2467] = {.lex_state = 8, .external_lex_state = 4},
  [2468] = {.lex_state = 74, .external_lex_state = 4},
  [2469] = {.lex_state = 74},
  [2470] = {.lex_state = 74},
  [2471] = {.lex_state = 74},
  [2472] = {.lex_state = 74},
  [2473] = {.lex_state = 74},
  [2474] = {.lex_state = 74},
  [2475] = {.lex_state = 74},
  [2476] = {.lex_state = 74, .external_lex_state = 4},
  [2477] = {.lex_state = 74},
  [2478] = {.lex_state = 74},
  [2479] = {.lex_state = 74, .external_lex_state = 4},
  [2480] = {.lex_state = 74},
  [2481] = {.lex_state = 74},
  [2482] = {.lex_state = 74},
  [2483] = {.lex_state = 74, .external_lex_state = 4},
  [2484] = {.lex_state = 74},
  [2485] = {.lex_state = 74},
  [2486] = {.lex_state = 74},
  [2487] = {.lex_state = 74},
  [2488] = {.lex_state = 74, .external_lex_state = 4},
  [2489] = {.lex_state = 74, .external_lex_state = 4},
  [2490] = {.lex_state = 74, .external_lex_state = 4},
  [2491] = {.lex_state = 74, .external_lex_state = 4},
  [2492] = {.lex_state = 16},
  [2493] = {.lex_state = 74, .external_lex_state = 4},
  [2494] = {.lex_state = 8, .external_lex_state = 5},
  [2495] = {.lex_state = 74, .external_lex_state = 4},
  [2496] = {.lex_state = 8, .external_lex_state = 5},
  [2497] = {.lex_state = 74, .external_lex_state = 5},
  [2498] = {.lex_state = 8, .external_lex_state = 4},
  [2499] = {.lex_state = 8, .external_lex_state = 4},
  [2500] = {.lex_state = 8, .external_lex_state = 4},
  [2501] = {.lex_state = 74, .external_lex_state = 4},
  [2502] = {.lex_state = 8, .external_lex_state = 4},
  [2503] = {.lex_state = 8, .external_lex_state = 5},
  [2504] = {.lex_state = 8, .external_lex_state = 4},
  [2505] = {.lex_state = 8, .external_lex_state = 4},
  [2506] = {.lex_state = 16},
  [2507] = {.lex_state = 74, .external_lex_state = 4},
  [2508] = {.lex_state = 74, .external_lex_state = 4},
  [2509] = {.lex_state = 74, .external_lex_state = 4},
  [2510] = {.lex_state = 8, .external_lex_state = 4},
  [2511] = {.lex_state = 74, .external_lex_state = 4},
  [2512] = {.lex_state = 74, .external_lex_state = 4},
  [2513] = {.lex_state = 16},
  [2514] = {.lex_state = 74, .external_lex_state = 4},
  [2515] = {.lex_state = 8, .external_lex_state = 5},
  [2516] = {.lex_state = 8, .external_lex_state = 5},
  [2517] = {.lex_state = 74, .external_lex_state = 4},
  [2518] = {.lex_state = 16},
  [2519] = {.lex_state = 8, .external_lex_state = 5},
  [2520] = {.lex_state = 8, .external_lex_state = 5},
  [2521] = {.lex_state = 8, .external_lex_state = 5},
  [2522] = {.lex_state = 16},
  [2523] = {.lex_state = 8, .external_lex_state = 5},
  [2524] = {.lex_state = 8, .external_lex_state = 5},
  [2525] = {.lex_state = 74},
  [2526] = {.lex_state = 8, .external_lex_state = 5},
  [2527] = {.lex_state = 74, .external_lex_state = 4},
  [2528] = {.lex_state = 74, .external_lex_state = 4},
  [2529] = {.lex_state = 8, .external_lex_state = 5},
  [2530] = {.lex_state = 8, .external_lex_state = 5},
  [2531] = {.lex_state = 8, .external_lex_state = 5},
  [2532] = {.lex_state = 8, .external_lex_state = 5},
  [2533] = {.lex_state = 8, .external_lex_state = 5},
  [2534] = {.lex_state = 74, .external_lex_state = 4},
  [2535] = {.lex_state = 8, .external_lex_state = 5},
  [2536] = {.lex_state = 8, .external_lex_state = 5},
  [2537] = {.lex_state = 8, .external_lex_state = 5},
  [2538] = {.lex_state = 74, .external_lex_state = 4},
  [2539] = {.lex_state = 8, .external_lex_state = 5},
  [2540] = {.lex_state = 74, .external_lex_state = 4},
  [2541] = {.lex_state = 8, .external_lex_state = 5},
  [2542] = {.lex_state = 74, .external_lex_state = 4},
  [2543] = {.lex_state = 8, .external_lex_state = 5},
  [2544] = {.lex_state = 74, .external_lex_state = 4},
  [2545] = {.lex_state = 74, .external_lex_state = 4},
  [2546] = {.lex_state = 8, .external_lex_state = 5},
  [2547] = {.lex_state = 16},
  [2548] = {.lex_state = 8, .external_lex_state = 5},
  [2549] = {.lex_state = 74, .external_lex_state = 4},
  [2550] = {.lex_state = 74, .external_lex_state = 5},
  [2551] = {.lex_state = 74, .external_lex_state = 4},
  [2552] = {.lex_state = 8, .external_lex_state = 5},
  [2553] = {.lex_state = 74, .external_lex_state = 4},
  [2554] = {.lex_state = 8, .external_lex_state = 5},
  [2555] = {.lex_state = 74, .external_lex_state = 4},
  [2556] = {.lex_state = 74, .external_lex_state = 4},
  [2557] = {.lex_state = 8, .external_lex_state = 5},
  [2558] = {.lex_state = 8, .external_lex_state = 5},
  [2559] = {.lex_state = 8, .external_lex_state = 5},
  [2560] = {.lex_state = 8, .external_lex_state = 5},
  [2561] = {.lex_state = 8, .external_lex_state = 5},
  [2562] = {.lex_state = 8, .external_lex_state = 5},
  [2563] = {.lex_state = 74, .external_lex_state = 4},
  [2564] = {.lex_state = 8, .external_lex_state = 5},
  [2565] = {.lex_state = 8, .external_lex_state = 5},
  [2566] = {.lex_state = 8, .external_lex_state = 5},
  [2567] = {.lex_state = 74, .external_lex_state = 4},
  [2568] = {.lex_state = 74, .external_lex_state = 4},
  [2569] = {.lex_state = 8, .external_lex_state = 5},
  [2570] = {.lex_state = 8, .external_lex_state = 5},
  [2571] = {.lex_state = 74, .external_lex_state = 4},
  [2572] = {.lex_state = 74, .external_lex_state = 4},
  [2573] = {.lex_state = 74, .external_lex_state = 4},
  [2574] = {.lex_state = 74, .external_lex_state = 4},
  [2575] = {.lex_state = 74, .external_lex_state = 4},
  [2576] = {.lex_state = 74, .external_lex_state = 4},
  [2577] = {.lex_state = 74, .external_lex_state = 4},
  [2578] = {.lex_state = 74, .external_lex_state = 4},
  [2579] = {.lex_state = 74, .external_lex_state = 4},
  [2580] = {.lex_state = 74, .external_lex_state = 4},
  [2581] = {.lex_state = 8, .external_lex_state = 5},
  [2582] = {.lex_state = 74, .external_lex_state = 4},
  [2583] = {.lex_state = 74, .external_lex_state = 4},
  [2584] = {.lex_state = 74, .external_lex_state = 4},
  [2585] = {.lex_state = 74, .external_lex_state = 4},
  [2586] = {.lex_state = 74, .external_lex_state = 4},
  [2587] = {.lex_state = 74, .external_lex_state = 4},
  [2588] = {.lex_state = 74, .external_lex_state = 4},
  [2589] = {.lex_state = 74, .external_lex_state = 4},
  [2590] = {.lex_state = 74, .external_lex_state = 4},
  [2591] = {.lex_state = 74, .external_lex_state = 4},
  [2592] = {.lex_state = 74, .external_lex_state = 4},
  [2593] = {.lex_state = 8, .external_lex_state = 5},
  [2594] = {.lex_state = 74, .external_lex_state = 4},
  [2595] = {.lex_state = 74, .external_lex_state = 4},
  [2596] = {.lex_state = 74, .external_lex_state = 4},
  [2597] = {.lex_state = 74, .external_lex_state = 4},
  [2598] = {.lex_state = 74, .external_lex_state = 4},
  [2599] = {.lex_state = 74, .external_lex_state = 4},
  [2600] = {.lex_state = 74, .external_lex_state = 4},
  [2601] = {.lex_state = 74, .external_lex_state = 4},
  [2602] = {.lex_state = 74, .external_lex_state = 4},
  [2603] = {.lex_state = 8, .external_lex_state = 5},
  [2604] = {.lex_state = 8, .external_lex_state = 5},
  [2605] = {.lex_state = 8, .external_lex_state = 5},
  [2606] = {.lex_state = 8, .external_lex_state = 5},
  [2607] = {.lex_state = 74, .external_lex_state = 5},
  [2608] = {.lex_state = 74, .external_lex_state = 4},
  [2609] = {.lex_state = 74, .external_lex_state = 4},
  [2610] = {.lex_state = 74, .external_lex_state = 4},
  [2611] = {.lex_state = 74, .external_lex_state = 4},
  [2612] = {.lex_state = 74, .external_lex_state = 4},
  [2613] = {.lex_state = 74, .external_lex_state = 4},
  [2614] = {.lex_state = 74, .external_lex_state = 4},
  [2615] = {.lex_state = 74, .external_lex_state = 4},
  [2616] = {.lex_state = 74, .external_lex_state = 4},
  [2617] = {.lex_state = 74, .external_lex_state = 4},
  [2618] = {.lex_state = 74, .external_lex_state = 4},
  [2619] = {.lex_state = 74, .external_lex_state = 4},
  [2620] = {.lex_state = 74, .external_lex_state = 5},
  [2621] = {.lex_state = 8, .external_lex_state = 5},
  [2622] = {.lex_state = 74, .external_lex_state = 4},
  [2623] = {.lex_state = 74, .external_lex_state = 4},
  [2624] = {.lex_state = 74, .external_lex_state = 4},
  [2625] = {.lex_state = 74, .external_lex_state = 4},
  [2626] = {.lex_state = 74, .external_lex_state = 4},
  [2627] = {.lex_state = 74, .external_lex_state = 4},
  [2628] = {.lex_state = 74, .external_lex_state = 4},
  [2629] = {.lex_state = 74, .external_lex_state = 4},
  [2630] = {.lex_state = 74},
  [2631] = {.lex_state = 8},
  [2632] = {.lex_state = 74, .external_lex_state = 4},
  [2633] = {.lex_state = 8},
  [2634] = {.lex_state = 74},
  [2635] = {.lex_state = 16},
  [2636] = {.lex_state = 25},
  [2637] = {.lex_state = 74},
  [2638] = {.lex_state = 74, .external_lex_state = 4},
  [2639] = {.lex_state = 74},
  [2640] = {.lex_state = 74},
  [2641] = {.lex_state = 74, .external_lex_state = 4},
  [2642] = {.lex_state = 74},
  [2643] = {.lex_state = 25},
  [2644] = {.lex_state = 74, .external_lex_state = 4},
  [2645] = {.lex_state = 16},
  [2646] = {.lex_state = 74, .external_lex_state = 5},
  [2647] = {.lex_state = 74, .external_lex_state = 4},
  [2648] = {.lex_state = 74},
  [2649] = {.lex_state = 25},
  [2650] = {.lex_state = 74},
  [2651] = {.lex_state = 16},
  [2652] = {.lex_state = 74},
  [2653] = {.lex_state = 74},
  [2654] = {.lex_state = 25},
  [2655] = {.lex_state = 8},
  [2656] = {.lex_state = 25},
  [2657] = {.lex_state = 74, .external_lex_state = 4},
  [2658] = {.lex_state = 25},
  [2659] = {.lex_state = 74},
  [2660] = {.lex_state = 74},
  [2661] = {.lex_state = 74},
  [2662] = {.lex_state = 16},
  [2663] = {.lex_state = 74},
  [2664] = {.lex_state = 25},
  [2665] = {.lex_state = 25},
  [2666] = {.lex_state = 74},
  [2667] = {.lex_state = 16},
  [2668] = {.lex_state = 74, .external_lex_state = 5},
  [2669] = {.lex_state = 16},
  [2670] = {.lex_state = 16},
  [2671] = {.lex_state = 25},
  [2672] = {.lex_state = 25},
  [2673] = {.lex_state = 74},
  [2674] = {.lex_state = 16},
  [2675] = {.lex_state = 16},
  [2676] = {.lex_state = 74},
  [2677] = {.lex_state = 74, .external_lex_state = 5},
  [2678] = {.lex_state = 16},
  [2679] = {.lex_state = 16},
  [2680] = {.lex_state = 74, .external_lex_state = 5},
  [2681] = {.lex_state = 74, .external_lex_state = 5},
  [2682] = {.lex_state = 74, .external_lex_state = 5},
  [2683] = {.lex_state = 74, .external_lex_state = 5},
  [2684] = {.lex_state = 74, .external_lex_state = 5},
  [2685] = {.lex_state = 74, .external_lex_state = 5},
  [2686] = {.lex_state = 74, .external_lex_state = 5},
  [2687] = {.lex_state = 74, .external_lex_state = 5},
  [2688] = {.lex_state = 74, .external_lex_state = 5},
  [2689] = {.lex_state = 74, .external_lex_state = 5},
  [2690] = {.lex_state = 74},
  [2691] = {.lex_state = 16},
  [2692] = {.lex_state = 16},
  [2693] = {.lex_state = 16},
  [2694] = {.lex_state = 16},
  [2695] = {.lex_state = 74},
  [2696] = {.lex_state = 25},
  [2697] = {.lex_state = 74, .external_lex_state = 5},
  [2698] = {.lex_state = 74, .external_lex_state = 5},
  [2699] = {.lex_state = 74, .external_lex_state = 5},
  [2700] = {.lex_state = 74, .external_lex_state = 5},
  [2701] = {.lex_state = 74, .external_lex_state = 5},
  [2702] = {.lex_state = 74, .external_lex_state = 5},
  [2703] = {.lex_state = 74, .external_lex_state = 5},
  [2704] = {.lex_state = 74, .external_lex_state = 4},
  [2705] = {.lex_state = 74, .external_lex_state = 5},
  [2706] = {.lex_state = 16},
  [2707] = {.lex_state = 74, .external_lex_state = 5},
  [2708] = {.lex_state = 74, .external_lex_state = 5},
  [2709] = {.lex_state = 74, .external_lex_state = 5},
  [2710] = {.lex_state = 74, .external_lex_state = 5},
  [2711] = {.lex_state = 74, .external_lex_state = 5},
  [2712] = {.lex_state = 16},
  [2713] = {.lex_state = 74},
  [2714] = {.lex_state = 74, .external_lex_state = 5},
  [2715] = {.lex_state = 74, .external_lex_state = 5},
  [2716] = {.lex_state = 74, .external_lex_state = 5},
  [2717] = {.lex_state = 25},
  [2718] = {.lex_state = 16},
  [2719] = {.lex_state = 16},
  [2720] = {.lex_state = 74, .external_lex_state = 5},
  [2721] = {.lex_state = 74, .external_lex_state = 5},
  [2722] = {.lex_state = 74},
  [2723] = {.lex_state = 74},
  [2724] = {.lex_state = 74, .external_lex_state = 5},
  [2725] = {.lex_state = 74},
  [2726] = {.lex_state = 74},
  [2727] = {.lex_state = 74, .external_lex_state = 4},
  [2728] = {.lex_state = 74},
  [2729] = {.lex_state = 25},
  [2730] = {.lex_state = 16},
  [2731] = {.lex_state = 74, .external_lex_state = 5},
  [2732] = {.lex_state = 74, .external_lex_state = 5},
  [2733] = {.lex_state = 74},
  [2734] = {.lex_state = 74, .external_lex_state = 5},
  [2735] = {.lex_state = 74, .external_lex_state = 5},
  [2736] = {.lex_state = 74, .external_lex_state = 5},
  [2737] = {.lex_state = 74, .external_lex_state = 5},
  [2738] = {.lex_state = 16},
  [2739] = {.lex_state = 25},
  [2740] = {.lex_state = 74},
  [2741] = {.lex_state = 74, .external_lex_state = 4},
  [2742] = {.lex_state = 74, .external_lex_state = 5},
  [2743] = {.lex_state = 16},
  [2744] = {.lex_state = 74},
  [2745] = {.lex_state = 74},
  [2746] = {.lex_state = 74, .external_lex_state = 4},
  [2747] = {.lex_state = 16},
  [2748] = {.lex_state = 74, .external_lex_state = 5},
  [2749] = {.lex_state = 74, .external_lex_state = 5},
  [2750] = {.lex_state = 74, .external_lex_state = 5},
  [2751] = {.lex_state = 74, .external_lex_state = 5},
  [2752] = {.lex_state = 16},
  [2753] = {.lex_state = 74},
  [2754] = {.lex_state = 25},
  [2755] = {.lex_state = 74, .external_lex_state = 5},
  [2756] = {.lex_state = 16},
  [2757] = {.lex_state = 16},
  [2758] = {.lex_state = 74},
  [2759] = {.lex_state = 74},
  [2760] = {.lex_state = 25},
  [2761] = {.lex_state = 74},
  [2762] = {.lex_state = 74},
  [2763] = {.lex_state = 74, .external_lex_state = 5},
  [2764] = {.lex_state = 74},
  [2765] = {.lex_state = 74},
  [2766] = {.lex_state = 74},
  [2767] = {.lex_state = 16},
  [2768] = {.lex_state = 74},
  [2769] = {.lex_state = 16},
  [2770] = {.lex_state = 25},
  [2771] = {.lex_state = 74},
  [2772] = {.lex_state = 74, .external_lex_state = 5},
  [2773] = {.lex_state = 74},
  [2774] = {.lex_state = 74},
  [2775] = {.lex_state = 74, .external_lex_state = 4},
  [2776] = {.lex_state = 74},
  [2777] = {.lex_state = 16},
  [2778] = {.lex_state = 74},
  [2779] = {.lex_state = 74, .external_lex_state = 4},
  [2780] = {.lex_state = 74},
  [2781] = {.lex_state = 74, .external_lex_state = 4},
  [2782] = {.lex_state = 74},
  [2783] = {.lex_state = 74},
  [2784] = {.lex_state = 74, .external_lex_state = 5},
  [2785] = {.lex_state = 74, .external_lex_state = 5},
  [2786] = {.lex_state = 16},
  [2787] = {.lex_state = 16},
  [2788] = {.lex_state = 16},
  [2789] = {.lex_state = 16},
  [2790] = {.lex_state = 74},
  [2791] = {.lex_state = 8},
  [2792] = {.lex_state = 14, .external_lex_state = 6},
  [2793] = {.lex_state = 74},
  [2794] = {.lex_state = 74, .external_lex_state = 5},
  [2795] = {.lex_state = 74, .external_lex_state = 4},
  [2796] = {.lex_state = 74, .external_lex_state = 4},
  [2797] = {.lex_state = 74, .external_lex_state = 4},
  [2798] = {.lex_state = 74, .external_lex_state = 4},
  [2799] = {.lex_state = 14, .external_lex_state = 6},
  [2800] = {.lex_state = 74},
  [2801] = {.lex_state = 14, .external_lex_state = 6},
  [2802] = {.lex_state = 14, .external_lex_state = 6},
  [2803] = {.lex_state = 14, .external_lex_state = 6},
  [2804] = {.lex_state = 16},
  [2805] = {.lex_state = 14, .external_lex_state = 6},
  [2806] = {.lex_state = 8},
  [2807] = {.lex_state = 14, .external_lex_state = 6},
  [2808] = {.lex_state = 8},
  [2809] = {.lex_state = 14, .external_lex_state = 6},
  [2810] = {.lex_state = 74},
  [2811] = {.lex_state = 74, .external_lex_state = 4},
  [2812] = {.lex_state = 74},
  [2813] = {.lex_state = 16},
  [2814] = {.lex_state = 74},
  [2815] = {.lex_state = 74, .external_lex_state = 4},
  [2816] = {.lex_state = 74},
  [2817] = {.lex_state = 74},
  [2818] = {.lex_state = 74},
  [2819] = {.lex_state = 74},
  [2820] = {.lex_state = 0, .external_lex_state = 4},
  [2821] = {.lex_state = 74},
  [2822] = {.lex_state = 74},
  [2823] = {.lex_state = 0, .external_lex_state = 4},
  [2824] = {.lex_state = 74, .external_lex_state = 4},
  [2825] = {.lex_state = 74},
  [2826] = {.lex_state = 74, .external_lex_state = 4},
  [2827] = {.lex_state = 74},
  [2828] = {.lex_state = 74},
  [2829] = {.lex_state = 7},
  [2830] = {.lex_state = 74},
  [2831] = {.lex_state = 0, .external_lex_state = 4},
  [2832] = {.lex_state = 74},
  [2833] = {.lex_state = 74},
  [2834] = {.lex_state = 74},
  [2835] = {.lex_state = 0, .external_lex_state = 4},
  [2836] = {.lex_state = 74},
  [2837] = {.lex_state = 74},
  [2838] = {.lex_state = 74},
  [2839] = {.lex_state = 16},
  [2840] = {.lex_state = 74},
  [2841] = {.lex_state = 74},
  [2842] = {.lex_state = 74},
  [2843] = {.lex_state = 74},
  [2844] = {.lex_state = 74},
  [2845] = {.lex_state = 74},
  [2846] = {.lex_state = 16},
  [2847] = {.lex_state = 74, .external_lex_state = 4},
  [2848] = {.lex_state = 74},
  [2849] = {.lex_state = 74},
  [2850] = {.lex_state = 74},
  [2851] = {.lex_state = 0, .external_lex_state = 4},
  [2852] = {.lex_state = 74},
  [2853] = {.lex_state = 74, .external_lex_state = 4},
  [2854] = {.lex_state = 74, .external_lex_state = 4},
  [2855] = {.lex_state = 74, .external_lex_state = 4},
  [2856] = {.lex_state = 74, .external_lex_state = 4},
  [2857] = {.lex_state = 74},
  [2858] = {.lex_state = 74},
  [2859] = {.lex_state = 74},
  [2860] = {.lex_state = 74},
  [2861] = {.lex_state = 74},
  [2862] = {.lex_state = 74, .external_lex_state = 4},
  [2863] = {.lex_state = 74},
  [2864] = {.lex_state = 74, .external_lex_state = 4},
  [2865] = {.lex_state = 74},
  [2866] = {.lex_state = 0, .external_lex_state = 4},
  [2867] = {.lex_state = 0, .external_lex_state = 4},
  [2868] = {.lex_state = 0, .external_lex_state = 4},
  [2869] = {.lex_state = 74},
  [2870] = {.lex_state = 74},
  [2871] = {.lex_state = 74, .external_lex_state = 4},
  [2872] = {.lex_state = 74, .external_lex_state = 4},
  [2873] = {.lex_state = 74, .external_lex_state = 4},
  [2874] = {.lex_state = 74},
  [2875] = {.lex_state = 74},
  [2876] = {.lex_state = 74},
  [2877] = {.lex_state = 74, .external_lex_state = 4},
  [2878] = {.lex_state = 74, .external_lex_state = 4},
  [2879] = {.lex_state = 74},
  [2880] = {.lex_state = 74},
  [2881] = {.lex_state = 74},
  [2882] = {.lex_state = 74},
  [2883] = {.lex_state = 74, .external_lex_state = 4},
  [2884] = {.lex_state = 74, .external_lex_state = 4},
  [2885] = {.lex_state = 16},
  [2886] = {.lex_state = 7},
  [2887] = {.lex_state = 74},
  [2888] = {.lex_state = 74},
  [2889] = {.lex_state = 74, .external_lex_state = 4},
  [2890] = {.lex_state = 74, .external_lex_state = 4},
  [2891] = {.lex_state = 74, .external_lex_state = 4},
  [2892] = {.lex_state = 74, .external_lex_state = 4},
  [2893] = {.lex_state = 74, .external_lex_state = 4},
  [2894] = {.lex_state = 74},
  [2895] = {.lex_state = 74},
  [2896] = {.lex_state = 74, .external_lex_state = 4},
  [2897] = {.lex_state = 74, .external_lex_state = 4},
  [2898] = {.lex_state = 74},
  [2899] = {.lex_state = 74, .external_lex_state = 4},
  [2900] = {.lex_state = 0, .external_lex_state = 4},
  [2901] = {.lex_state = 74, .external_lex_state = 4},
  [2902] = {.lex_state = 74},
  [2903] = {.lex_state = 7},
  [2904] = {.lex_state = 74, .external_lex_state = 4},
  [2905] = {.lex_state = 74, .external_lex_state = 4},
  [2906] = {.lex_state = 74, .external_lex_state = 4},
  [2907] = {.lex_state = 74, .external_lex_state = 4},
  [2908] = {.lex_state = 74},
  [2909] = {.lex_state = 74, .external_lex_state = 4},
  [2910] = {.lex_state = 74},
  [2911] = {.lex_state = 74},
  [2912] = {.lex_state = 74, .external_lex_state = 4},
  [2913] = {.lex_state = 74},
  [2914] = {.lex_state = 74, .external_lex_state = 4},
  [2915] = {.lex_state = 74},
  [2916] = {.lex_state = 74},
  [2917] = {.lex_state = 74, .external_lex_state = 4},
  [2918] = {.lex_state = 74, .external_lex_state = 4},
  [2919] = {.lex_state = 74},
  [2920] = {.lex_state = 74, .external_lex_state = 4},
  [2921] = {.lex_state = 74},
  [2922] = {.lex_state = 74},
  [2923] = {.lex_state = 74, .external_lex_state = 5},
  [2924] = {.lex_state = 12},
  [2925] = {.lex_state = 74},
  [2926] = {.lex_state = 14, .external_lex_state = 6},
  [2927] = {.lex_state = 0, .external_lex_state = 4},
  [2928] = {.lex_state = 74},
  [2929] = {.lex_state = 7},
  [2930] = {.lex_state = 74},
  [2931] = {.lex_state = 74},
  [2932] = {.lex_state = 74, .external_lex_state = 5},
  [2933] = {.lex_state = 74},
  [2934] = {.lex_state = 74},
  [2935] = {.lex_state = 16},
  [2936] = {.lex_state = 12},
  [2937] = {.lex_state = 74},
  [2938] = {.lex_state = 12},
  [2939] = {.lex_state = 74, .external_lex_state = 5},
  [2940] = {.lex_state = 74},
  [2941] = {.lex_state = 12},
  [2942] = {.lex_state = 74},
  [2943] = {.lex_state = 74},
  [2944] = {.lex_state = 74},
  [2945] = {.lex_state = 74},
  [2946] = {.lex_state = 74},
  [2947] = {.lex_state = 0, .external_lex_state = 4},
  [2948] = {.lex_state = 74},
  [2949] = {.lex_state = 74, .external_lex_state = 5},
  [2950] = {.lex_state = 12},
  [2951] = {.lex_state = 74},
  [2952] = {.lex_state = 74},
  [2953] = {.lex_state = 0, .external_lex_state = 4},
  [2954] = {.lex_state = 74},
  [2955] = {.lex_state = 74},
  [2956] = {.lex_state = 16},
  [2957] = {.lex_state = 74},
  [2958] = {.lex_state = 16},
  [2959] = {.lex_state = 14, .external_lex_state = 6},
  [2960] = {.lex_state = 74},
  [2961] = {.lex_state = 74},
  [2962] = {.lex_state = 0, .external_lex_state = 4},
  [2963] = {.lex_state = 74, .external_lex_state = 5},
  [2964] = {.lex_state = 74, .external_lex_state = 5},
  [2965] = {.lex_state = 12},
  [2966] = {.lex_state = 74},
  [2967] = {.lex_state = 74},
  [2968] = {.lex_state = 74},
  [2969] = {.lex_state = 74, .external_lex_state = 5},
  [2970] = {.lex_state = 74, .external_lex_state = 5},
  [2971] = {.lex_state = 74, .external_lex_state = 5},
  [2972] = {.lex_state = 0, .external_lex_state = 4},
  [2973] = {.lex_state = 74},
  [2974] = {.lex_state = 74},
  [2975] = {.lex_state = 0, .external_lex_state = 4},
  [2976] = {.lex_state = 74},
  [2977] = {.lex_state = 7},
  [2978] = {.lex_state = 74},
  [2979] = {.lex_state = 12},
  [2980] = {.lex_state = 74},
  [2981] = {.lex_state = 74},
  [2982] = {.lex_state = 74},
  [2983] = {.lex_state = 16},
  [2984] = {.lex_state = 16},
  [2985] = {.lex_state = 14, .external_lex_state = 6},
  [2986] = {.lex_state = 74, .external_lex_state = 5},
  [2987] = {.lex_state = 74},
  [2988] = {.lex_state = 74},
  [2989] = {.lex_state = 74},
  [2990] = {.lex_state = 74},
  [2991] = {.lex_state = 74},
  [2992] = {.lex_state = 16},
  [2993] = {.lex_state = 74},
  [2994] = {.lex_state = 74, .external_lex_state = 5},
  [2995] = {.lex_state = 74},
  [2996] = {.lex_state = 74},
  [2997] = {.lex_state = 74, .external_lex_state = 5},
  [2998] = {.lex_state = 74, .external_lex_state = 5},
  [2999] = {.lex_state = 12},
  [3000] = {.lex_state = 16},
  [3001] = {.lex_state = 74},
  [3002] = {.lex_state = 74},
  [3003] = {.lex_state = 12},
  [3004] = {.lex_state = 74},
  [3005] = {.lex_state = 74, .external_lex_state = 5},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 74, .external_lex_state = 5},
  [3008] = {.lex_state = 74},
  [3009] = {.lex_state = 74},
  [3010] = {.lex_state = 74},
  [3011] = {.lex_state = 74},
  [3012] = {.lex_state = 74},
  [3013] = {.lex_state = 74},
  [3014] = {.lex_state = 74, .external_lex_state = 5},
  [3015] = {.lex_state = 74},
  [3016] = {.lex_state = 74},
  [3017] = {.lex_state = 12},
  [3018] = {.lex_state = 16},
  [3019] = {.lex_state = 74},
  [3020] = {.lex_state = 74},
  [3021] = {.lex_state = 74, .external_lex_state = 5},
  [3022] = {.lex_state = 74},
  [3023] = {.lex_state = 74},
  [3024] = {.lex_state = 0, .external_lex_state = 4},
  [3025] = {.lex_state = 74},
  [3026] = {.lex_state = 74},
  [3027] = {.lex_state = 16},
  [3028] = {.lex_state = 12},
  [3029] = {.lex_state = 16},
  [3030] = {.lex_state = 74, .external_lex_state = 5},
  [3031] = {.lex_state = 74, .external_lex_state = 5},
  [3032] = {.lex_state = 74},
  [3033] = {.lex_state = 14, .external_lex_state = 6},
  [3034] = {.lex_state = 74, .external_lex_state = 5},
  [3035] = {.lex_state = 74},
  [3036] = {.lex_state = 74},
  [3037] = {.lex_state = 74, .external_lex_state = 5},
  [3038] = {.lex_state = 74, .external_lex_state = 5},
  [3039] = {.lex_state = 74},
  [3040] = {.lex_state = 74},
  [3041] = {.lex_state = 74},
  [3042] = {.lex_state = 74, .external_lex_state = 5},
  [3043] = {.lex_state = 16},
  [3044] = {.lex_state = 74, .external_lex_state = 5},
  [3045] = {.lex_state = 74, .external_lex_state = 4},
  [3046] = {.lex_state = 0, .external_lex_state = 4},
  [3047] = {.lex_state = 0, .external_lex_state = 4},
  [3048] = {.lex_state = 0, .external_lex_state = 4},
  [3049] = {.lex_state = 0, .external_lex_state = 4},
  [3050] = {.lex_state = 74},
  [3051] = {.lex_state = 74},
  [3052] = {.lex_state = 74, .external_lex_state = 5},
  [3053] = {.lex_state = 74},
  [3054] = {.lex_state = 74},
  [3055] = {.lex_state = 74},
  [3056] = {.lex_state = 74},
  [3057] = {.lex_state = 74},
  [3058] = {.lex_state = 74},
  [3059] = {.lex_state = 0, .external_lex_state = 4},
  [3060] = {.lex_state = 74},
  [3061] = {.lex_state = 74, .external_lex_state = 5},
  [3062] = {.lex_state = 12},
  [3063] = {.lex_state = 0, .external_lex_state = 4},
  [3064] = {.lex_state = 0, .external_lex_state = 4},
  [3065] = {.lex_state = 74},
  [3066] = {.lex_state = 0, .external_lex_state = 4},
  [3067] = {.lex_state = 74, .external_lex_state = 5},
  [3068] = {.lex_state = 74},
  [3069] = {.lex_state = 74},
  [3070] = {.lex_state = 0, .external_lex_state = 4},
  [3071] = {.lex_state = 0, .external_lex_state = 4},
  [3072] = {.lex_state = 74},
  [3073] = {.lex_state = 74},
  [3074] = {.lex_state = 74},
  [3075] = {.lex_state = 0, .external_lex_state = 4},
  [3076] = {.lex_state = 74},
  [3077] = {.lex_state = 12},
  [3078] = {.lex_state = 0, .external_lex_state = 4},
  [3079] = {.lex_state = 74},
  [3080] = {.lex_state = 0, .external_lex_state = 4},
  [3081] = {.lex_state = 74},
  [3082] = {.lex_state = 74},
  [3083] = {.lex_state = 74},
  [3084] = {.lex_state = 74},
  [3085] = {.lex_state = 74},
  [3086] = {.lex_state = 0, .external_lex_state = 4},
  [3087] = {.lex_state = 14, .external_lex_state = 6},
  [3088] = {.lex_state = 0, .external_lex_state = 4},
  [3089] = {.lex_state = 74},
  [3090] = {.lex_state = 74, .external_lex_state = 4},
  [3091] = {.lex_state = 0, .external_lex_state = 4},
  [3092] = {.lex_state = 0, .external_lex_state = 4},
  [3093] = {.lex_state = 74},
  [3094] = {.lex_state = 0, .external_lex_state = 4},
  [3095] = {.lex_state = 12},
  [3096] = {.lex_state = 74},
  [3097] = {.lex_state = 74, .external_lex_state = 4},
  [3098] = {.lex_state = 74, .external_lex_state = 4},
  [3099] = {.lex_state = 0, .external_lex_state = 4},
  [3100] = {.lex_state = 74},
  [3101] = {.lex_state = 0, .external_lex_state = 4},
  [3102] = {.lex_state = 0, .external_lex_state = 4},
  [3103] = {.lex_state = 14, .external_lex_state = 6},
  [3104] = {.lex_state = 74},
  [3105] = {.lex_state = 74, .external_lex_state = 5},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 74, .external_lex_state = 5},
  [3110] = {.lex_state = 0, .external_lex_state = 4},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 74, .external_lex_state = 4},
  [3113] = {.lex_state = 12},
  [3114] = {.lex_state = 74},
  [3115] = {.lex_state = 74},
  [3116] = {.lex_state = 74},
  [3117] = {.lex_state = 74, .external_lex_state = 5},
  [3118] = {.lex_state = 74, .external_lex_state = 4},
  [3119] = {.lex_state = 74},
  [3120] = {.lex_state = 74},
  [3121] = {.lex_state = 74},
  [3122] = {.lex_state = 74},
  [3123] = {.lex_state = 74, .external_lex_state = 4},
  [3124] = {.lex_state = 74, .external_lex_state = 4},
  [3125] = {.lex_state = 74},
  [3126] = {.lex_state = 74},
  [3127] = {.lex_state = 74},
  [3128] = {.lex_state = 74},
  [3129] = {.lex_state = 74},
  [3130] = {.lex_state = 74},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 74},
  [3133] = {.lex_state = 74},
  [3134] = {.lex_state = 16},
  [3135] = {.lex_state = 16},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 74},
  [3138] = {.lex_state = 74},
  [3139] = {.lex_state = 74},
  [3140] = {.lex_state = 74},
  [3141] = {.lex_state = 0, .external_lex_state = 4},
  [3142] = {.lex_state = 74},
  [3143] = {.lex_state = 0, .external_lex_state = 4},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 74, .external_lex_state = 5},
  [3146] = {.lex_state = 0, .external_lex_state = 4},
  [3147] = {.lex_state = 0, .external_lex_state = 4},
  [3148] = {.lex_state = 74},
  [3149] = {.lex_state = 74},
  [3150] = {.lex_state = 0, .external_lex_state = 4},
  [3151] = {.lex_state = 0, .external_lex_state = 4},
  [3152] = {.lex_state = 74},
  [3153] = {.lex_state = 74},
  [3154] = {.lex_state = 14, .external_lex_state = 6},
  [3155] = {.lex_state = 0},
  [3156] = {.lex_state = 74},
  [3157] = {.lex_state = 74},
  [3158] = {.lex_state = 14, .external_lex_state = 6},
  [3159] = {.lex_state = 74},
  [3160] = {.lex_state = 74},
  [3161] = {.lex_state = 74},
  [3162] = {.lex_state = 0, .external_lex_state = 4},
  [3163] = {.lex_state = 74},
  [3164] = {.lex_state = 0, .external_lex_state = 4},
  [3165] = {.lex_state = 0, .external_lex_state = 4},
  [3166] = {.lex_state = 74},
  [3167] = {.lex_state = 74},
  [3168] = {.lex_state = 0, .external_lex_state = 4},
  [3169] = {.lex_state = 0, .external_lex_state = 4},
  [3170] = {.lex_state = 0, .external_lex_state = 4},
  [3171] = {.lex_state = 0, .external_lex_state = 4},
  [3172] = {.lex_state = 0, .external_lex_state = 4},
  [3173] = {.lex_state = 74, .external_lex_state = 4},
  [3174] = {.lex_state = 0, .external_lex_state = 4},
  [3175] = {.lex_state = 0, .external_lex_state = 4},
  [3176] = {.lex_state = 74},
  [3177] = {.lex_state = 0, .external_lex_state = 4},
  [3178] = {.lex_state = 74},
  [3179] = {.lex_state = 74},
  [3180] = {.lex_state = 74},
  [3181] = {.lex_state = 74, .external_lex_state = 4},
  [3182] = {.lex_state = 7},
  [3183] = {.lex_state = 74},
  [3184] = {.lex_state = 74},
  [3185] = {.lex_state = 12},
  [3186] = {.lex_state = 74},
  [3187] = {.lex_state = 74},
  [3188] = {.lex_state = 74},
  [3189] = {.lex_state = 0, .external_lex_state = 4},
  [3190] = {.lex_state = 0, .external_lex_state = 4},
  [3191] = {.lex_state = 74},
  [3192] = {.lex_state = 74},
  [3193] = {.lex_state = 74},
  [3194] = {.lex_state = 0, .external_lex_state = 4},
  [3195] = {.lex_state = 74},
  [3196] = {.lex_state = 74},
  [3197] = {.lex_state = 74, .external_lex_state = 4},
  [3198] = {.lex_state = 74},
  [3199] = {.lex_state = 74},
  [3200] = {.lex_state = 0, .external_lex_state = 4},
  [3201] = {.lex_state = 74},
  [3202] = {.lex_state = 0, .external_lex_state = 4},
  [3203] = {.lex_state = 74, .external_lex_state = 4},
  [3204] = {.lex_state = 74, .external_lex_state = 5},
  [3205] = {.lex_state = 0, .external_lex_state = 4},
  [3206] = {.lex_state = 0, .external_lex_state = 4},
  [3207] = {.lex_state = 0, .external_lex_state = 4},
  [3208] = {.lex_state = 0, .external_lex_state = 4},
  [3209] = {.lex_state = 0, .external_lex_state = 4},
  [3210] = {.lex_state = 74, .external_lex_state = 5},
  [3211] = {.lex_state = 74},
  [3212] = {.lex_state = 0},
  [3213] = {.lex_state = 74},
  [3214] = {.lex_state = 74},
  [3215] = {.lex_state = 74},
  [3216] = {.lex_state = 2},
  [3217] = {.lex_state = 74},
  [3218] = {.lex_state = 0, .external_lex_state = 4},
  [3219] = {.lex_state = 74, .external_lex_state = 5},
  [3220] = {.lex_state = 74},
  [3221] = {.lex_state = 0, .external_lex_state = 4},
  [3222] = {.lex_state = 0, .external_lex_state = 4},
  [3223] = {.lex_state = 74},
  [3224] = {.lex_state = 0, .external_lex_state = 4},
  [3225] = {.lex_state = 14, .external_lex_state = 6},
  [3226] = {.lex_state = 74},
  [3227] = {.lex_state = 74},
  [3228] = {.lex_state = 0, .external_lex_state = 4},
  [3229] = {.lex_state = 0, .external_lex_state = 4},
  [3230] = {.lex_state = 74},
  [3231] = {.lex_state = 74},
  [3232] = {.lex_state = 0, .external_lex_state = 4},
  [3233] = {.lex_state = 0, .external_lex_state = 4},
  [3234] = {.lex_state = 74},
  [3235] = {.lex_state = 74},
  [3236] = {.lex_state = 74},
  [3237] = {.lex_state = 0, .external_lex_state = 4},
  [3238] = {.lex_state = 0},
  [3239] = {.lex_state = 0, .external_lex_state = 4},
  [3240] = {.lex_state = 0, .external_lex_state = 4},
  [3241] = {.lex_state = 74},
  [3242] = {.lex_state = 74},
  [3243] = {.lex_state = 0, .external_lex_state = 4},
  [3244] = {.lex_state = 0, .external_lex_state = 4},
  [3245] = {.lex_state = 0, .external_lex_state = 4},
  [3246] = {.lex_state = 0, .external_lex_state = 4},
  [3247] = {.lex_state = 0, .external_lex_state = 4},
  [3248] = {.lex_state = 74},
  [3249] = {.lex_state = 0, .external_lex_state = 4},
  [3250] = {.lex_state = 74},
  [3251] = {.lex_state = 0, .external_lex_state = 4},
  [3252] = {.lex_state = 0, .external_lex_state = 4},
  [3253] = {.lex_state = 0, .external_lex_state = 4},
  [3254] = {.lex_state = 0, .external_lex_state = 4},
  [3255] = {.lex_state = 0, .external_lex_state = 4},
  [3256] = {.lex_state = 0, .external_lex_state = 4},
  [3257] = {.lex_state = 0, .external_lex_state = 4},
  [3258] = {.lex_state = 74},
  [3259] = {.lex_state = 0, .external_lex_state = 4},
  [3260] = {.lex_state = 74},
  [3261] = {.lex_state = 0, .external_lex_state = 4},
  [3262] = {.lex_state = 0, .external_lex_state = 4},
  [3263] = {.lex_state = 0, .external_lex_state = 4},
  [3264] = {.lex_state = 0, .external_lex_state = 4},
  [3265] = {.lex_state = 74},
  [3266] = {.lex_state = 0, .external_lex_state = 4},
  [3267] = {.lex_state = 0, .external_lex_state = 4},
  [3268] = {.lex_state = 0, .external_lex_state = 4},
  [3269] = {.lex_state = 0, .external_lex_state = 4},
  [3270] = {.lex_state = 0, .external_lex_state = 4},
  [3271] = {.lex_state = 0, .external_lex_state = 4},
  [3272] = {.lex_state = 74, .external_lex_state = 5},
  [3273] = {.lex_state = 0, .external_lex_state = 4},
  [3274] = {.lex_state = 0, .external_lex_state = 4},
  [3275] = {.lex_state = 74},
  [3276] = {.lex_state = 74},
  [3277] = {.lex_state = 0, .external_lex_state = 4},
  [3278] = {.lex_state = 0, .external_lex_state = 4},
  [3279] = {.lex_state = 0, .external_lex_state = 4},
  [3280] = {.lex_state = 0, .external_lex_state = 4},
  [3281] = {.lex_state = 0, .external_lex_state = 4},
  [3282] = {.lex_state = 0, .external_lex_state = 4},
  [3283] = {.lex_state = 16},
  [3284] = {.lex_state = 74, .external_lex_state = 5},
  [3285] = {.lex_state = 74, .external_lex_state = 5},
  [3286] = {.lex_state = 0, .external_lex_state = 4},
  [3287] = {.lex_state = 0, .external_lex_state = 4},
  [3288] = {.lex_state = 14, .external_lex_state = 6},
  [3289] = {.lex_state = 0, .external_lex_state = 4},
  [3290] = {.lex_state = 0, .external_lex_state = 4},
  [3291] = {.lex_state = 74, .external_lex_state = 5},
  [3292] = {.lex_state = 0, .external_lex_state = 4},
  [3293] = {.lex_state = 0, .external_lex_state = 4},
  [3294] = {.lex_state = 0, .external_lex_state = 4},
  [3295] = {.lex_state = 0, .external_lex_state = 4},
  [3296] = {.lex_state = 0, .external_lex_state = 4},
  [3297] = {.lex_state = 0, .external_lex_state = 4},
  [3298] = {.lex_state = 74},
  [3299] = {.lex_state = 0, .external_lex_state = 4},
  [3300] = {.lex_state = 0, .external_lex_state = 4},
  [3301] = {.lex_state = 0, .external_lex_state = 4},
  [3302] = {.lex_state = 0, .external_lex_state = 4},
  [3303] = {.lex_state = 74},
  [3304] = {.lex_state = 0, .external_lex_state = 4},
  [3305] = {.lex_state = 0, .external_lex_state = 4},
  [3306] = {.lex_state = 0, .external_lex_state = 4},
  [3307] = {.lex_state = 0, .external_lex_state = 4},
  [3308] = {.lex_state = 0, .external_lex_state = 4},
  [3309] = {.lex_state = 0, .external_lex_state = 4},
  [3310] = {.lex_state = 74, .external_lex_state = 5},
  [3311] = {.lex_state = 0, .external_lex_state = 4},
  [3312] = {.lex_state = 0, .external_lex_state = 4},
  [3313] = {.lex_state = 0, .external_lex_state = 4},
  [3314] = {.lex_state = 0},
  [3315] = {.lex_state = 2},
  [3316] = {.lex_state = 14, .external_lex_state = 6},
  [3317] = {.lex_state = 0, .external_lex_state = 4},
  [3318] = {.lex_state = 0, .external_lex_state = 4},
  [3319] = {.lex_state = 7},
  [3320] = {.lex_state = 74, .external_lex_state = 5},
  [3321] = {.lex_state = 74, .external_lex_state = 5},
  [3322] = {.lex_state = 74},
  [3323] = {.lex_state = 74},
  [3324] = {.lex_state = 0, .external_lex_state = 4},
  [3325] = {.lex_state = 0, .external_lex_state = 4},
  [3326] = {.lex_state = 0, .external_lex_state = 4},
  [3327] = {.lex_state = 74},
  [3328] = {.lex_state = 0, .external_lex_state = 4},
  [3329] = {.lex_state = 0, .external_lex_state = 4},
  [3330] = {.lex_state = 0, .external_lex_state = 4},
  [3331] = {.lex_state = 0, .external_lex_state = 4},
  [3332] = {.lex_state = 0, .external_lex_state = 4},
  [3333] = {.lex_state = 74},
  [3334] = {.lex_state = 74},
  [3335] = {.lex_state = 16},
  [3336] = {.lex_state = 16},
  [3337] = {.lex_state = 14, .external_lex_state = 6},
  [3338] = {.lex_state = 0, .external_lex_state = 4},
  [3339] = {.lex_state = 0, .external_lex_state = 4},
  [3340] = {.lex_state = 0, .external_lex_state = 4},
  [3341] = {.lex_state = 0, .external_lex_state = 4},
  [3342] = {.lex_state = 0, .external_lex_state = 4},
  [3343] = {.lex_state = 0, .external_lex_state = 4},
  [3344] = {.lex_state = 14, .external_lex_state = 6},
  [3345] = {.lex_state = 16},
  [3346] = {.lex_state = 14, .external_lex_state = 6},
  [3347] = {.lex_state = 0, .external_lex_state = 4},
  [3348] = {.lex_state = 0, .external_lex_state = 4},
  [3349] = {.lex_state = 16},
  [3350] = {.lex_state = 0, .external_lex_state = 4},
  [3351] = {.lex_state = 0, .external_lex_state = 4},
  [3352] = {.lex_state = 0, .external_lex_state = 4},
  [3353] = {.lex_state = 0, .external_lex_state = 4},
  [3354] = {.lex_state = 0, .external_lex_state = 4},
  [3355] = {.lex_state = 0, .external_lex_state = 4},
  [3356] = {.lex_state = 0, .external_lex_state = 4},
  [3357] = {.lex_state = 0, .external_lex_state = 4},
  [3358] = {.lex_state = 74},
  [3359] = {.lex_state = 0, .external_lex_state = 4},
  [3360] = {.lex_state = 0, .external_lex_state = 4},
  [3361] = {.lex_state = 74},
  [3362] = {.lex_state = 16},
  [3363] = {.lex_state = 0, .external_lex_state = 4},
  [3364] = {.lex_state = 0, .external_lex_state = 4},
  [3365] = {.lex_state = 16},
  [3366] = {.lex_state = 0, .external_lex_state = 4},
  [3367] = {.lex_state = 74},
  [3368] = {.lex_state = 0, .external_lex_state = 4},
  [3369] = {.lex_state = 0, .external_lex_state = 4},
  [3370] = {.lex_state = 0},
  [3371] = {.lex_state = 0, .external_lex_state = 4},
  [3372] = {.lex_state = 0, .external_lex_state = 4},
  [3373] = {.lex_state = 74},
  [3374] = {.lex_state = 0, .external_lex_state = 4},
  [3375] = {.lex_state = 74},
  [3376] = {.lex_state = 0, .external_lex_state = 4},
  [3377] = {.lex_state = 16},
  [3378] = {.lex_state = 16},
  [3379] = {.lex_state = 16},
  [3380] = {.lex_state = 16},
  [3381] = {.lex_state = 16},
  [3382] = {.lex_state = 16},
  [3383] = {.lex_state = 16},
  [3384] = {.lex_state = 16},
  [3385] = {.lex_state = 16},
  [3386] = {.lex_state = 14, .external_lex_state = 6},
  [3387] = {.lex_state = 16},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 0, .external_lex_state = 4},
  [3390] = {.lex_state = 0},
  [3391] = {.lex_state = 14, .external_lex_state = 6},
  [3392] = {.lex_state = 0, .external_lex_state = 4},
  [3393] = {.lex_state = 0},
  [3394] = {.lex_state = 74},
  [3395] = {.lex_state = 74},
  [3396] = {.lex_state = 74},
  [3397] = {.lex_state = 74},
  [3398] = {.lex_state = 12},
  [3399] = {.lex_state = 13},
  [3400] = {.lex_state = 17},
  [3401] = {.lex_state = 74},
  [3402] = {.lex_state = 14, .external_lex_state = 6},
  [3403] = {.lex_state = 0},
  [3404] = {.lex_state = 74},
  [3405] = {.lex_state = 14, .external_lex_state = 6},
  [3406] = {.lex_state = 74},
  [3407] = {.lex_state = 12},
  [3408] = {.lex_state = 74},
  [3409] = {.lex_state = 74},
  [3410] = {.lex_state = 74},
  [3411] = {.lex_state = 74},
  [3412] = {.lex_state = 74},
  [3413] = {.lex_state = 74},
  [3414] = {.lex_state = 74},
  [3415] = {.lex_state = 74},
  [3416] = {.lex_state = 74},
  [3417] = {.lex_state = 0},
  [3418] = {.lex_state = 0},
  [3419] = {.lex_state = 0},
  [3420] = {.lex_state = 74},
  [3421] = {.lex_state = 0},
  [3422] = {.lex_state = 74},
  [3423] = {.lex_state = 0, .external_lex_state = 4},
  [3424] = {.lex_state = 17},
  [3425] = {.lex_state = 13},
  [3426] = {.lex_state = 0, .external_lex_state = 4},
  [3427] = {.lex_state = 13},
  [3428] = {.lex_state = 74},
  [3429] = {.lex_state = 74},
  [3430] = {.lex_state = 17},
  [3431] = {.lex_state = 74},
  [3432] = {.lex_state = 0, .external_lex_state = 4},
  [3433] = {.lex_state = 74},
  [3434] = {.lex_state = 74},
  [3435] = {.lex_state = 74},
  [3436] = {.lex_state = 74},
  [3437] = {.lex_state = 74},
  [3438] = {.lex_state = 74},
  [3439] = {.lex_state = 74},
  [3440] = {.lex_state = 74, .external_lex_state = 4},
  [3441] = {.lex_state = 0},
  [3442] = {.lex_state = 0},
  [3443] = {.lex_state = 74},
  [3444] = {.lex_state = 74},
  [3445] = {.lex_state = 74},
  [3446] = {.lex_state = 74},
  [3447] = {.lex_state = 74},
  [3448] = {.lex_state = 74},
  [3449] = {.lex_state = 12},
  [3450] = {.lex_state = 0, .external_lex_state = 4},
  [3451] = {.lex_state = 74},
  [3452] = {.lex_state = 74},
  [3453] = {.lex_state = 74},
  [3454] = {.lex_state = 74},
  [3455] = {.lex_state = 74},
  [3456] = {.lex_state = 0, .external_lex_state = 4},
  [3457] = {.lex_state = 0, .external_lex_state = 4},
  [3458] = {.lex_state = 13},
  [3459] = {.lex_state = 17},
  [3460] = {.lex_state = 13},
  [3461] = {.lex_state = 74},
  [3462] = {.lex_state = 74, .external_lex_state = 4},
  [3463] = {.lex_state = 0},
  [3464] = {.lex_state = 74},
  [3465] = {.lex_state = 0},
  [3466] = {.lex_state = 74},
  [3467] = {.lex_state = 17},
  [3468] = {.lex_state = 74},
  [3469] = {.lex_state = 13},
  [3470] = {.lex_state = 0},
  [3471] = {.lex_state = 13},
  [3472] = {.lex_state = 17},
  [3473] = {.lex_state = 0},
  [3474] = {.lex_state = 17},
  [3475] = {.lex_state = 13},
  [3476] = {.lex_state = 17},
  [3477] = {.lex_state = 0},
  [3478] = {.lex_state = 13},
  [3479] = {.lex_state = 0, .external_lex_state = 4},
  [3480] = {.lex_state = 0, .external_lex_state = 4},
  [3481] = {.lex_state = 17},
  [3482] = {.lex_state = 13},
  [3483] = {.lex_state = 74},
  [3484] = {.lex_state = 17},
  [3485] = {.lex_state = 13},
  [3486] = {.lex_state = 74, .external_lex_state = 4},
  [3487] = {.lex_state = 74},
  [3488] = {.lex_state = 0},
  [3489] = {.lex_state = 12},
  [3490] = {.lex_state = 13},
  [3491] = {.lex_state = 17},
  [3492] = {.lex_state = 13},
  [3493] = {.lex_state = 17},
  [3494] = {.lex_state = 17},
  [3495] = {.lex_state = 17},
  [3496] = {.lex_state = 13},
  [3497] = {.lex_state = 74},
  [3498] = {.lex_state = 0},
  [3499] = {.lex_state = 13},
  [3500] = {.lex_state = 17},
  [3501] = {.lex_state = 17},
  [3502] = {.lex_state = 0, .external_lex_state = 5},
  [3503] = {.lex_state = 13},
  [3504] = {.lex_state = 74},
  [3505] = {.lex_state = 74},
  [3506] = {.lex_state = 74},
  [3507] = {.lex_state = 0, .external_lex_state = 4},
  [3508] = {.lex_state = 74, .external_lex_state = 4},
  [3509] = {.lex_state = 74},
  [3510] = {.lex_state = 74},
  [3511] = {.lex_state = 74},
  [3512] = {.lex_state = 17},
  [3513] = {.lex_state = 13},
  [3514] = {.lex_state = 74},
  [3515] = {.lex_state = 74},
  [3516] = {.lex_state = 0, .external_lex_state = 4},
  [3517] = {.lex_state = 0, .external_lex_state = 4},
  [3518] = {.lex_state = 74},
  [3519] = {.lex_state = 0, .external_lex_state = 4},
  [3520] = {.lex_state = 0},
  [3521] = {.lex_state = 74},
  [3522] = {.lex_state = 0},
  [3523] = {.lex_state = 74},
  [3524] = {.lex_state = 74},
  [3525] = {.lex_state = 25},
  [3526] = {.lex_state = 74},
  [3527] = {.lex_state = 0},
  [3528] = {.lex_state = 25},
  [3529] = {.lex_state = 0},
  [3530] = {.lex_state = 0},
  [3531] = {.lex_state = 74},
  [3532] = {.lex_state = 0},
  [3533] = {.lex_state = 25},
  [3534] = {.lex_state = 2},
  [3535] = {.lex_state = 25},
  [3536] = {.lex_state = 74},
  [3537] = {.lex_state = 74},
  [3538] = {.lex_state = 74},
  [3539] = {.lex_state = 74},
  [3540] = {.lex_state = 74},
  [3541] = {.lex_state = 74},
  [3542] = {.lex_state = 74},
  [3543] = {.lex_state = 74},
  [3544] = {.lex_state = 0},
  [3545] = {.lex_state = 0},
  [3546] = {.lex_state = 0},
  [3547] = {.lex_state = 74},
  [3548] = {.lex_state = 0},
  [3549] = {.lex_state = 74},
  [3550] = {.lex_state = 74},
  [3551] = {.lex_state = 25},
  [3552] = {.lex_state = 0},
  [3553] = {.lex_state = 74},
  [3554] = {.lex_state = 0},
  [3555] = {.lex_state = 74},
  [3556] = {.lex_state = 25},
  [3557] = {.lex_state = 0},
  [3558] = {.lex_state = 74},
  [3559] = {.lex_state = 0},
  [3560] = {.lex_state = 74, .external_lex_state = 4},
  [3561] = {.lex_state = 74},
  [3562] = {.lex_state = 74},
  [3563] = {.lex_state = 0},
  [3564] = {.lex_state = 0},
  [3565] = {.lex_state = 74, .external_lex_state = 4},
  [3566] = {.lex_state = 0},
  [3567] = {.lex_state = 0},
  [3568] = {.lex_state = 0},
  [3569] = {.lex_state = 74},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 0, .external_lex_state = 4},
  [3572] = {.lex_state = 74},
  [3573] = {.lex_state = 0},
  [3574] = {.lex_state = 25},
  [3575] = {.lex_state = 25},
  [3576] = {.lex_state = 0},
  [3577] = {.lex_state = 0},
  [3578] = {.lex_state = 0},
  [3579] = {.lex_state = 0},
  [3580] = {.lex_state = 74, .external_lex_state = 4},
  [3581] = {.lex_state = 25},
  [3582] = {.lex_state = 74},
  [3583] = {.lex_state = 25},
  [3584] = {.lex_state = 74},
  [3585] = {.lex_state = 25},
  [3586] = {.lex_state = 0},
  [3587] = {.lex_state = 0},
  [3588] = {.lex_state = 74},
  [3589] = {.lex_state = 0},
  [3590] = {.lex_state = 0},
  [3591] = {.lex_state = 25},
  [3592] = {.lex_state = 2},
  [3593] = {.lex_state = 74},
  [3594] = {.lex_state = 0},
  [3595] = {.lex_state = 74},
  [3596] = {.lex_state = 74},
  [3597] = {.lex_state = 74},
  [3598] = {.lex_state = 74},
  [3599] = {.lex_state = 25},
  [3600] = {.lex_state = 74},
  [3601] = {.lex_state = 74},
  [3602] = {.lex_state = 0},
  [3603] = {.lex_state = 0},
  [3604] = {.lex_state = 0},
  [3605] = {.lex_state = 0},
  [3606] = {.lex_state = 0},
  [3607] = {.lex_state = 74},
  [3608] = {.lex_state = 0},
  [3609] = {.lex_state = 0},
  [3610] = {.lex_state = 74},
  [3611] = {.lex_state = 0},
  [3612] = {.lex_state = 74},
  [3613] = {.lex_state = 0},
  [3614] = {.lex_state = 0},
  [3615] = {.lex_state = 0},
  [3616] = {.lex_state = 0},
  [3617] = {.lex_state = 0},
  [3618] = {.lex_state = 25},
  [3619] = {.lex_state = 0},
  [3620] = {.lex_state = 0},
  [3621] = {.lex_state = 25},
  [3622] = {.lex_state = 74},
  [3623] = {.lex_state = 0},
  [3624] = {.lex_state = 25},
  [3625] = {.lex_state = 0},
  [3626] = {.lex_state = 0},
  [3627] = {.lex_state = 0},
  [3628] = {.lex_state = 74},
  [3629] = {.lex_state = 2},
  [3630] = {.lex_state = 74},
  [3631] = {.lex_state = 0},
  [3632] = {.lex_state = 0},
  [3633] = {.lex_state = 74},
  [3634] = {.lex_state = 74},
  [3635] = {.lex_state = 0},
  [3636] = {.lex_state = 0},
  [3637] = {.lex_state = 0},
  [3638] = {.lex_state = 0},
  [3639] = {.lex_state = 0, .external_lex_state = 4},
  [3640] = {.lex_state = 0},
  [3641] = {.lex_state = 0},
  [3642] = {.lex_state = 0},
  [3643] = {.lex_state = 74},
  [3644] = {.lex_state = 74},
  [3645] = {.lex_state = 0, .external_lex_state = 4},
  [3646] = {.lex_state = 0, .external_lex_state = 4},
  [3647] = {.lex_state = 74},
  [3648] = {.lex_state = 0},
  [3649] = {.lex_state = 0},
  [3650] = {.lex_state = 0, .external_lex_state = 4},
  [3651] = {.lex_state = 0},
  [3652] = {.lex_state = 0, .external_lex_state = 4},
  [3653] = {.lex_state = 0, .external_lex_state = 4},
  [3654] = {.lex_state = 0},
  [3655] = {.lex_state = 0, .external_lex_state = 4},
  [3656] = {.lex_state = 0, .external_lex_state = 4},
  [3657] = {.lex_state = 25},
  [3658] = {.lex_state = 0},
  [3659] = {.lex_state = 74},
  [3660] = {.lex_state = 74},
  [3661] = {.lex_state = 25},
  [3662] = {.lex_state = 0},
  [3663] = {.lex_state = 74},
  [3664] = {.lex_state = 74},
  [3665] = {.lex_state = 74},
  [3666] = {.lex_state = 0, .external_lex_state = 4},
  [3667] = {.lex_state = 74},
  [3668] = {.lex_state = 0, .external_lex_state = 4},
  [3669] = {.lex_state = 0, .external_lex_state = 4},
  [3670] = {.lex_state = 74},
  [3671] = {.lex_state = 0},
  [3672] = {.lex_state = 74},
  [3673] = {.lex_state = 74},
  [3674] = {.lex_state = 74},
  [3675] = {.lex_state = 25},
  [3676] = {.lex_state = 0},
  [3677] = {.lex_state = 0},
  [3678] = {.lex_state = 0},
  [3679] = {.lex_state = 0, .external_lex_state = 4},
  [3680] = {.lex_state = 0},
  [3681] = {.lex_state = 74},
  [3682] = {.lex_state = 74, .external_lex_state = 4},
  [3683] = {.lex_state = 25},
  [3684] = {.lex_state = 74, .external_lex_state = 4},
  [3685] = {.lex_state = 0},
  [3686] = {.lex_state = 74},
  [3687] = {.lex_state = 0, .external_lex_state = 4},
  [3688] = {.lex_state = 0, .external_lex_state = 4},
  [3689] = {.lex_state = 0, .external_lex_state = 4},
  [3690] = {.lex_state = 0, .external_lex_state = 4},
  [3691] = {.lex_state = 0, .external_lex_state = 4},
  [3692] = {.lex_state = 0, .external_lex_state = 4},
  [3693] = {.lex_state = 0, .external_lex_state = 4},
  [3694] = {.lex_state = 0},
  [3695] = {.lex_state = 0, .external_lex_state = 4},
  [3696] = {.lex_state = 0},
  [3697] = {.lex_state = 74},
  [3698] = {.lex_state = 0},
  [3699] = {.lex_state = 0, .external_lex_state = 4},
  [3700] = {.lex_state = 0, .external_lex_state = 4},
  [3701] = {.lex_state = 0, .external_lex_state = 4},
  [3702] = {.lex_state = 0},
  [3703] = {.lex_state = 0},
  [3704] = {.lex_state = 0, .external_lex_state = 4},
  [3705] = {.lex_state = 0},
  [3706] = {.lex_state = 74},
  [3707] = {.lex_state = 0, .external_lex_state = 4},
  [3708] = {.lex_state = 0, .external_lex_state = 4},
  [3709] = {.lex_state = 0, .external_lex_state = 4},
  [3710] = {.lex_state = 0},
  [3711] = {.lex_state = 0},
  [3712] = {.lex_state = 0},
  [3713] = {.lex_state = 0, .external_lex_state = 4},
  [3714] = {.lex_state = 0, .external_lex_state = 4},
  [3715] = {.lex_state = 0},
  [3716] = {.lex_state = 74},
  [3717] = {.lex_state = 74},
  [3718] = {.lex_state = 74},
  [3719] = {.lex_state = 0, .external_lex_state = 4},
  [3720] = {.lex_state = 25},
  [3721] = {.lex_state = 0},
  [3722] = {.lex_state = 0, .external_lex_state = 4},
  [3723] = {.lex_state = 0, .external_lex_state = 4},
  [3724] = {.lex_state = 74},
  [3725] = {.lex_state = 0},
  [3726] = {.lex_state = 0, .external_lex_state = 4},
  [3727] = {.lex_state = 74},
  [3728] = {.lex_state = 0, .external_lex_state = 4},
  [3729] = {.lex_state = 0, .external_lex_state = 4},
  [3730] = {.lex_state = 0, .external_lex_state = 4},
  [3731] = {.lex_state = 0, .external_lex_state = 4},
  [3732] = {.lex_state = 74},
  [3733] = {.lex_state = 74},
  [3734] = {.lex_state = 74},
  [3735] = {.lex_state = 0},
  [3736] = {.lex_state = 74},
  [3737] = {.lex_state = 0},
  [3738] = {.lex_state = 0},
  [3739] = {.lex_state = 0, .external_lex_state = 4},
  [3740] = {.lex_state = 74},
  [3741] = {.lex_state = 0},
  [3742] = {.lex_state = 74},
  [3743] = {.lex_state = 74},
  [3744] = {.lex_state = 74, .external_lex_state = 4},
  [3745] = {.lex_state = 0},
  [3746] = {.lex_state = 74, .external_lex_state = 4},
  [3747] = {.lex_state = 0},
  [3748] = {.lex_state = 0},
  [3749] = {.lex_state = 14, .external_lex_state = 6},
  [3750] = {.lex_state = 74},
  [3751] = {.lex_state = 0},
  [3752] = {.lex_state = 0},
  [3753] = {.lex_state = 74},
  [3754] = {.lex_state = 74},
  [3755] = {.lex_state = 74},
  [3756] = {.lex_state = 74},
  [3757] = {.lex_state = 0},
  [3758] = {.lex_state = 0},
  [3759] = {.lex_state = 0},
  [3760] = {.lex_state = 0},
  [3761] = {.lex_state = 0},
  [3762] = {.lex_state = 74, .external_lex_state = 4},
  [3763] = {.lex_state = 0, .external_lex_state = 4},
  [3764] = {.lex_state = 0, .external_lex_state = 4},
  [3765] = {.lex_state = 0, .external_lex_state = 4},
  [3766] = {.lex_state = 0, .external_lex_state = 4},
  [3767] = {.lex_state = 0, .external_lex_state = 4},
  [3768] = {.lex_state = 0},
  [3769] = {.lex_state = 74},
  [3770] = {.lex_state = 74},
  [3771] = {.lex_state = 0, .external_lex_state = 4},
  [3772] = {.lex_state = 0, .external_lex_state = 4},
  [3773] = {.lex_state = 0, .external_lex_state = 4},
  [3774] = {.lex_state = 0},
  [3775] = {.lex_state = 74},
  [3776] = {.lex_state = 0},
  [3777] = {.lex_state = 0},
  [3778] = {.lex_state = 0, .external_lex_state = 4},
  [3779] = {.lex_state = 0, .external_lex_state = 4},
  [3780] = {.lex_state = 0, .external_lex_state = 4},
  [3781] = {.lex_state = 74},
  [3782] = {.lex_state = 0},
  [3783] = {.lex_state = 0},
  [3784] = {.lex_state = 74},
  [3785] = {.lex_state = 0, .external_lex_state = 4},
  [3786] = {.lex_state = 0, .external_lex_state = 4},
  [3787] = {.lex_state = 0},
  [3788] = {.lex_state = 74},
  [3789] = {.lex_state = 74},
  [3790] = {.lex_state = 74},
  [3791] = {.lex_state = 0},
  [3792] = {.lex_state = 0},
  [3793] = {.lex_state = 74},
  [3794] = {.lex_state = 74},
  [3795] = {.lex_state = 74},
  [3796] = {.lex_state = 0, .external_lex_state = 4},
  [3797] = {.lex_state = 74},
  [3798] = {.lex_state = 74},
  [3799] = {.lex_state = 74},
  [3800] = {.lex_state = 74},
  [3801] = {.lex_state = 74},
  [3802] = {.lex_state = 0, .external_lex_state = 4},
  [3803] = {.lex_state = 0},
  [3804] = {.lex_state = 0},
  [3805] = {.lex_state = 74},
  [3806] = {.lex_state = 0},
  [3807] = {.lex_state = 74},
  [3808] = {.lex_state = 0, .external_lex_state = 4},
  [3809] = {.lex_state = 0},
  [3810] = {.lex_state = 74},
  [3811] = {.lex_state = 0},
  [3812] = {.lex_state = 74},
  [3813] = {.lex_state = 74},
  [3814] = {.lex_state = 0},
  [3815] = {.lex_state = 74},
  [3816] = {.lex_state = 74},
  [3817] = {.lex_state = 74},
  [3818] = {.lex_state = 74},
  [3819] = {.lex_state = 0},
  [3820] = {.lex_state = 0},
  [3821] = {.lex_state = 74},
  [3822] = {.lex_state = 74},
  [3823] = {.lex_state = 74},
  [3824] = {.lex_state = 0, .external_lex_state = 4},
  [3825] = {.lex_state = 74},
  [3826] = {.lex_state = 0},
  [3827] = {.lex_state = 74},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 0},
  [3830] = {.lex_state = 0},
  [3831] = {.lex_state = 0, .external_lex_state = 4},
  [3832] = {.lex_state = 74},
  [3833] = {.lex_state = 74},
  [3834] = {.lex_state = 74},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 0},
  [3837] = {.lex_state = 0},
  [3838] = {.lex_state = 74},
  [3839] = {.lex_state = 74},
  [3840] = {.lex_state = 74},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 74},
  [3843] = {.lex_state = 0, .external_lex_state = 4},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 74},
  [3846] = {.lex_state = 74},
  [3847] = {.lex_state = 74},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 0, .external_lex_state = 4},
  [3850] = {.lex_state = 74},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 0, .external_lex_state = 4},
  [3853] = {.lex_state = 0, .external_lex_state = 4},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 74},
  [3856] = {.lex_state = 74},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 74},
  [3859] = {.lex_state = 74},
  [3860] = {.lex_state = 0, .external_lex_state = 4},
  [3861] = {.lex_state = 0},
  [3862] = {.lex_state = 0, .external_lex_state = 4},
  [3863] = {.lex_state = 0},
  [3864] = {.lex_state = 74},
  [3865] = {.lex_state = 0},
  [3866] = {.lex_state = 74},
  [3867] = {.lex_state = 74},
  [3868] = {.lex_state = 0},
  [3869] = {.lex_state = 0, .external_lex_state = 4},
  [3870] = {.lex_state = 0, .external_lex_state = 4},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 74},
  [3873] = {.lex_state = 74},
  [3874] = {.lex_state = 74},
  [3875] = {.lex_state = 0, .external_lex_state = 4},
  [3876] = {.lex_state = 0},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 0},
  [3879] = {.lex_state = 74},
  [3880] = {.lex_state = 0},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 0},
  [3884] = {.lex_state = 74},
  [3885] = {.lex_state = 74},
  [3886] = {.lex_state = 0, .external_lex_state = 4},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 74},
  [3889] = {.lex_state = 74},
  [3890] = {.lex_state = 74},
  [3891] = {.lex_state = 0},
  [3892] = {.lex_state = 74},
  [3893] = {.lex_state = 74},
  [3894] = {.lex_state = 0},
  [3895] = {.lex_state = 0},
  [3896] = {.lex_state = 0},
  [3897] = {.lex_state = 0},
  [3898] = {.lex_state = 0, .external_lex_state = 4},
  [3899] = {.lex_state = 74},
  [3900] = {.lex_state = 74},
  [3901] = {.lex_state = 0},
  [3902] = {.lex_state = 74},
  [3903] = {.lex_state = 0},
  [3904] = {.lex_state = 0},
  [3905] = {.lex_state = 0, .external_lex_state = 4},
  [3906] = {.lex_state = 74},
  [3907] = {.lex_state = 74},
  [3908] = {.lex_state = 74},
  [3909] = {.lex_state = 74},
  [3910] = {.lex_state = 0},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 0},
  [3913] = {.lex_state = 0},
  [3914] = {.lex_state = 74},
  [3915] = {.lex_state = 74},
  [3916] = {.lex_state = 0, .external_lex_state = 4},
  [3917] = {.lex_state = 74},
  [3918] = {.lex_state = 74},
  [3919] = {.lex_state = 74},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 74},
  [3922] = {.lex_state = 74},
  [3923] = {.lex_state = 74},
  [3924] = {.lex_state = 74},
  [3925] = {.lex_state = 0},
  [3926] = {.lex_state = 74},
  [3927] = {.lex_state = 74},
  [3928] = {.lex_state = 74},
  [3929] = {.lex_state = 74},
  [3930] = {.lex_state = 74},
  [3931] = {.lex_state = 0},
  [3932] = {.lex_state = 74},
  [3933] = {.lex_state = 0},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 74},
  [3936] = {.lex_state = 0},
  [3937] = {.lex_state = 74},
  [3938] = {.lex_state = 74},
  [3939] = {.lex_state = 0},
  [3940] = {.lex_state = 74},
  [3941] = {.lex_state = 0},
  [3942] = {.lex_state = 74},
  [3943] = {.lex_state = 12},
  [3944] = {.lex_state = 74},
  [3945] = {.lex_state = 0, .external_lex_state = 4},
  [3946] = {.lex_state = 0, .external_lex_state = 4},
  [3947] = {.lex_state = 74},
  [3948] = {.lex_state = 74},
  [3949] = {.lex_state = 74},
  [3950] = {.lex_state = 0},
  [3951] = {.lex_state = 0},
  [3952] = {.lex_state = 74},
  [3953] = {.lex_state = 0},
  [3954] = {.lex_state = 0},
  [3955] = {.lex_state = 0, .external_lex_state = 4},
  [3956] = {.lex_state = 74},
  [3957] = {.lex_state = 74},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 0},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 0, .external_lex_state = 4},
  [3962] = {.lex_state = 74},
  [3963] = {.lex_state = 74},
  [3964] = {.lex_state = 0},
  [3965] = {.lex_state = 74},
  [3966] = {.lex_state = 74},
  [3967] = {.lex_state = 74},
  [3968] = {.lex_state = 74},
  [3969] = {.lex_state = 74},
  [3970] = {.lex_state = 74},
  [3971] = {.lex_state = 0},
  [3972] = {.lex_state = 0},
  [3973] = {.lex_state = 74},
  [3974] = {.lex_state = 74},
  [3975] = {.lex_state = 74},
  [3976] = {.lex_state = 0},
  [3977] = {.lex_state = 74},
  [3978] = {.lex_state = 74},
  [3979] = {.lex_state = 74},
  [3980] = {.lex_state = 74},
  [3981] = {.lex_state = 74},
  [3982] = {.lex_state = 74},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 74},
  [3985] = {.lex_state = 74},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 74},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 74},
  [3990] = {.lex_state = 74},
  [3991] = {.lex_state = 74},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 74},
  [3994] = {.lex_state = 74},
  [3995] = {.lex_state = 0, .external_lex_state = 4},
  [3996] = {.lex_state = 74},
  [3997] = {.lex_state = 0},
  [3998] = {.lex_state = 74},
  [3999] = {.lex_state = 0},
  [4000] = {.lex_state = 74},
  [4001] = {.lex_state = 74},
  [4002] = {.lex_state = 74},
  [4003] = {.lex_state = 74},
  [4004] = {.lex_state = 0},
  [4005] = {.lex_state = 74},
  [4006] = {.lex_state = 74},
  [4007] = {.lex_state = 74},
  [4008] = {.lex_state = 74},
  [4009] = {.lex_state = 74},
  [4010] = {.lex_state = 74},
  [4011] = {.lex_state = 74},
  [4012] = {.lex_state = 74},
  [4013] = {.lex_state = 0},
  [4014] = {.lex_state = 74},
  [4015] = {.lex_state = 0},
  [4016] = {.lex_state = 0, .external_lex_state = 4},
  [4017] = {.lex_state = 74},
  [4018] = {.lex_state = 74},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 74},
  [4021] = {.lex_state = 74},
  [4022] = {.lex_state = 74},
  [4023] = {.lex_state = 74},
  [4024] = {.lex_state = 0, .external_lex_state = 4},
  [4025] = {.lex_state = 74},
  [4026] = {.lex_state = 74},
  [4027] = {.lex_state = 74},
  [4028] = {.lex_state = 74},
  [4029] = {.lex_state = 74},
  [4030] = {.lex_state = 74},
  [4031] = {.lex_state = 74},
  [4032] = {.lex_state = 74},
  [4033] = {.lex_state = 0},
  [4034] = {.lex_state = 74},
  [4035] = {.lex_state = 0},
  [4036] = {.lex_state = 0, .external_lex_state = 4},
  [4037] = {.lex_state = 74},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 74},
  [4040] = {.lex_state = 0},
  [4041] = {.lex_state = 74},
  [4042] = {.lex_state = 74},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 74},
  [4046] = {.lex_state = 74},
  [4047] = {.lex_state = 74},
  [4048] = {.lex_state = 74},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 0},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 0},
  [4053] = {.lex_state = 1},
  [4054] = {.lex_state = 0},
  [4055] = {.lex_state = 0},
  [4056] = {.lex_state = 0},
  [4057] = {.lex_state = 0},
  [4058] = {.lex_state = 0},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 0},
  [4061] = {.lex_state = 74},
  [4062] = {.lex_state = 74},
  [4063] = {.lex_state = 0},
  [4064] = {.lex_state = 74},
  [4065] = {.lex_state = 74},
  [4066] = {.lex_state = 0},
  [4067] = {.lex_state = 74},
  [4068] = {.lex_state = 74},
  [4069] = {.lex_state = 74},
  [4070] = {.lex_state = 74},
  [4071] = {.lex_state = 0},
  [4072] = {.lex_state = 74},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 0},
  [4075] = {.lex_state = 74},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 74},
  [4078] = {.lex_state = 0},
  [4079] = {.lex_state = 74},
  [4080] = {.lex_state = 74},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 1},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 0},
  [4088] = {.lex_state = 0},
  [4089] = {.lex_state = 74},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 0},
  [4094] = {.lex_state = 0},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 1},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 74},
  [4104] = {.lex_state = 0},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 74},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 74},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 74},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 0},
  [4122] = {.lex_state = 0},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 74},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 74},
  [4130] = {.lex_state = 0},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 0},
  [4133] = {.lex_state = 0},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 74},
  [4136] = {.lex_state = 74},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 0},
  [4139] = {.lex_state = 0},
  [4140] = {.lex_state = 74},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 0},
  [4144] = {.lex_state = 1},
  [4145] = {.lex_state = 74},
  [4146] = {.lex_state = 74},
  [4147] = {.lex_state = 74},
  [4148] = {.lex_state = 74},
  [4149] = {.lex_state = 74},
  [4150] = {.lex_state = 74},
  [4151] = {.lex_state = 74},
  [4152] = {.lex_state = 74},
  [4153] = {.lex_state = 0},
  [4154] = {.lex_state = 74},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 0},
  [4157] = {.lex_state = 0},
  [4158] = {.lex_state = 0},
  [4159] = {.lex_state = 74},
  [4160] = {.lex_state = 74},
  [4161] = {.lex_state = 74},
  [4162] = {.lex_state = 74},
  [4163] = {.lex_state = 0},
  [4164] = {.lex_state = 0},
  [4165] = {.lex_state = 0},
  [4166] = {.lex_state = 0},
  [4167] = {.lex_state = 0},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 0},
  [4170] = {.lex_state = 0},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 0},
  [4175] = {.lex_state = 74},
  [4176] = {.lex_state = 74},
  [4177] = {.lex_state = 0},
  [4178] = {.lex_state = 0},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 0},
  [4187] = {.lex_state = 0},
  [4188] = {.lex_state = 0},
  [4189] = {.lex_state = 0},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 0},
  [4192] = {.lex_state = 74},
  [4193] = {.lex_state = 74},
  [4194] = {.lex_state = 0},
  [4195] = {.lex_state = 0},
  [4196] = {.lex_state = 0},
  [4197] = {.lex_state = 74},
  [4198] = {.lex_state = 0},
  [4199] = {.lex_state = 0},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 74},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 74},
  [4204] = {.lex_state = 74},
  [4205] = {.lex_state = 9},
  [4206] = {.lex_state = 0},
  [4207] = {.lex_state = 0},
  [4208] = {.lex_state = 0},
  [4209] = {.lex_state = 0},
  [4210] = {.lex_state = 0},
  [4211] = {.lex_state = 74},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 0},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 0},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 0},
  [4218] = {.lex_state = 0},
  [4219] = {.lex_state = 0},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 0},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 0},
  [4224] = {.lex_state = 0},
  [4225] = {.lex_state = 0},
  [4226] = {.lex_state = 0},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 74},
  [4229] = {.lex_state = 0},
  [4230] = {.lex_state = 74},
  [4231] = {.lex_state = 74},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 74},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 74},
  [4237] = {.lex_state = 74},
  [4238] = {.lex_state = 74},
  [4239] = {.lex_state = 0},
  [4240] = {.lex_state = 74},
  [4241] = {.lex_state = 74},
  [4242] = {.lex_state = 0},
  [4243] = {.lex_state = 0},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 74},
  [4246] = {.lex_state = 0},
  [4247] = {.lex_state = 74},
  [4248] = {.lex_state = 0},
  [4249] = {.lex_state = 74},
  [4250] = {.lex_state = 0},
  [4251] = {.lex_state = 74},
  [4252] = {.lex_state = 9},
  [4253] = {.lex_state = 0},
  [4254] = {.lex_state = 0},
  [4255] = {.lex_state = 0},
  [4256] = {.lex_state = 0},
  [4257] = {.lex_state = 0},
  [4258] = {.lex_state = 0},
  [4259] = {.lex_state = 0},
  [4260] = {.lex_state = 0},
  [4261] = {.lex_state = 0},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 0},
  [4265] = {.lex_state = 0},
  [4266] = {.lex_state = 0},
  [4267] = {.lex_state = 0},
  [4268] = {.lex_state = 74},
  [4269] = {.lex_state = 0},
  [4270] = {.lex_state = 0},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 0},
  [4273] = {.lex_state = 74},
  [4274] = {.lex_state = 0},
  [4275] = {.lex_state = 0},
  [4276] = {.lex_state = 0},
  [4277] = {.lex_state = 74},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 0},
  [4280] = {.lex_state = 74},
  [4281] = {.lex_state = 0},
  [4282] = {.lex_state = 0},
  [4283] = {.lex_state = 0},
  [4284] = {.lex_state = 74},
  [4285] = {.lex_state = 74},
  [4286] = {.lex_state = 0},
  [4287] = {.lex_state = 0},
  [4288] = {.lex_state = 74},
  [4289] = {.lex_state = 74},
  [4290] = {.lex_state = 74},
  [4291] = {.lex_state = 74},
  [4292] = {.lex_state = 74},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 74},
  [4295] = {.lex_state = 0},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 74},
  [4298] = {.lex_state = 74},
  [4299] = {.lex_state = 74},
  [4300] = {.lex_state = 74},
  [4301] = {.lex_state = 74},
  [4302] = {.lex_state = 74},
  [4303] = {.lex_state = 74},
  [4304] = {.lex_state = 74},
  [4305] = {.lex_state = 74},
  [4306] = {.lex_state = 0},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 0},
  [4309] = {.lex_state = 0},
  [4310] = {.lex_state = 0},
  [4311] = {.lex_state = 74},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 74},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 74},
  [4317] = {.lex_state = 9},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 0},
  [4320] = {.lex_state = 74},
  [4321] = {.lex_state = 9},
  [4322] = {.lex_state = 9},
  [4323] = {.lex_state = 0},
  [4324] = {.lex_state = 0},
  [4325] = {.lex_state = 0},
  [4326] = {.lex_state = 0},
  [4327] = {.lex_state = 0},
  [4328] = {.lex_state = 74},
  [4329] = {.lex_state = 74},
  [4330] = {.lex_state = 74},
  [4331] = {.lex_state = 0},
  [4332] = {.lex_state = 0},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 0},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 74},
  [4338] = {.lex_state = 0},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 74},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 0},
  [4343] = {.lex_state = 74},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 0},
  [4346] = {.lex_state = 74},
  [4347] = {.lex_state = 74},
  [4348] = {.lex_state = 74},
  [4349] = {.lex_state = 74},
  [4350] = {.lex_state = 74},
  [4351] = {.lex_state = 74},
  [4352] = {.lex_state = 74},
  [4353] = {.lex_state = 0},
  [4354] = {.lex_state = 0},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 0},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 0},
  [4359] = {.lex_state = 0},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 0},
  [4363] = {.lex_state = 0},
  [4364] = {.lex_state = 0},
  [4365] = {.lex_state = 74},
  [4366] = {.lex_state = 74},
  [4367] = {.lex_state = 74},
  [4368] = {.lex_state = 74},
  [4369] = {.lex_state = 0},
  [4370] = {.lex_state = 74},
  [4371] = {.lex_state = 0},
  [4372] = {.lex_state = 0},
  [4373] = {.lex_state = 0},
  [4374] = {.lex_state = 74},
  [4375] = {.lex_state = 74},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 0},
  [4378] = {.lex_state = 0},
  [4379] = {.lex_state = 74},
  [4380] = {.lex_state = 74},
  [4381] = {.lex_state = 74},
  [4382] = {.lex_state = 0},
  [4383] = {.lex_state = 0},
  [4384] = {.lex_state = 74},
  [4385] = {.lex_state = 74},
  [4386] = {.lex_state = 74},
  [4387] = {.lex_state = 0},
  [4388] = {.lex_state = 0},
  [4389] = {.lex_state = 0},
  [4390] = {.lex_state = 1},
  [4391] = {.lex_state = 0},
  [4392] = {.lex_state = 0},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 74},
  [4395] = {.lex_state = 0},
  [4396] = {.lex_state = 0},
  [4397] = {.lex_state = 74},
  [4398] = {.lex_state = 74},
  [4399] = {.lex_state = 74},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(4382),
    [sym_export_statement] = STATE(24),
    [sym_declaration] = STATE(24),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [2] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3375),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(181),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(189),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [3] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3375),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(181),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(189),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [4] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4357),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4357),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4357),
    [sym_spread_element] = STATE(3603),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1803),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2888),
    [sym_computed_property_name] = STATE(2888),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_accessibility_modifier] = STATE(2244),
    [sym_override_modifier] = STATE(2266),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(211),
    [anon_sym_export] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(219),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(227),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(235),
    [anon_sym_readonly] = ACTIONS(237),
    [anon_sym_get] = ACTIONS(239),
    [anon_sym_set] = ACTIONS(239),
    [anon_sym_declare] = ACTIONS(241),
    [anon_sym_public] = ACTIONS(243),
    [anon_sym_private] = ACTIONS(243),
    [anon_sym_protected] = ACTIONS(243),
    [anon_sym_override] = ACTIONS(245),
    [anon_sym_module] = ACTIONS(247),
    [anon_sym_any] = ACTIONS(249),
    [anon_sym_number] = ACTIONS(249),
    [anon_sym_boolean] = ACTIONS(249),
    [anon_sym_string] = ACTIONS(249),
    [anon_sym_symbol] = ACTIONS(249),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [5] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4357),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4357),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4357),
    [sym_spread_element] = STATE(3759),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1803),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3759),
    [sym_pair] = STATE(3759),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2888),
    [sym_computed_property_name] = STATE(2888),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_accessibility_modifier] = STATE(2244),
    [sym_override_modifier] = STATE(2266),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [aux_sym_object_repeat1] = STATE(3760),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_export] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_namespace] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_override] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_any] = ACTIONS(277),
    [anon_sym_number] = ACTIONS(277),
    [anon_sym_boolean] = ACTIONS(277),
    [anon_sym_string] = ACTIONS(277),
    [anon_sym_symbol] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [6] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4357),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4357),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4357),
    [sym_spread_element] = STATE(3759),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1803),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3759),
    [sym_pair] = STATE(3759),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2888),
    [sym_computed_property_name] = STATE(2888),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_accessibility_modifier] = STATE(2244),
    [sym_override_modifier] = STATE(2266),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [aux_sym_object_repeat1] = STATE(3760),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_export] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_namespace] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_override] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_any] = ACTIONS(277),
    [anon_sym_number] = ACTIONS(277),
    [anon_sym_boolean] = ACTIONS(277),
    [anon_sym_string] = ACTIONS(277),
    [anon_sym_symbol] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [7] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4357),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4357),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4357),
    [sym_spread_element] = STATE(3603),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1803),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2888),
    [sym_computed_property_name] = STATE(2888),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_accessibility_modifier] = STATE(2244),
    [sym_override_modifier] = STATE(2266),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(281),
    [anon_sym_export] = ACTIONS(283),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(289),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(291),
    [anon_sym_readonly] = ACTIONS(293),
    [anon_sym_get] = ACTIONS(295),
    [anon_sym_set] = ACTIONS(295),
    [anon_sym_declare] = ACTIONS(297),
    [anon_sym_public] = ACTIONS(299),
    [anon_sym_private] = ACTIONS(299),
    [anon_sym_protected] = ACTIONS(299),
    [anon_sym_override] = ACTIONS(301),
    [anon_sym_module] = ACTIONS(303),
    [anon_sym_any] = ACTIONS(305),
    [anon_sym_number] = ACTIONS(305),
    [anon_sym_boolean] = ACTIONS(305),
    [anon_sym_string] = ACTIONS(305),
    [anon_sym_symbol] = ACTIONS(305),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [8] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4357),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4357),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4357),
    [sym_spread_element] = STATE(3759),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1803),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3759),
    [sym_pair] = STATE(3759),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2888),
    [sym_computed_property_name] = STATE(2888),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_accessibility_modifier] = STATE(2244),
    [sym_override_modifier] = STATE(2266),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [aux_sym_object_repeat1] = STATE(3760),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_export] = ACTIONS(253),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_type] = ACTIONS(255),
    [anon_sym_namespace] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_COMMA] = ACTIONS(221),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(225),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(261),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(231),
    [sym_private_property_identifier] = ACTIONS(233),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(263),
    [anon_sym_readonly] = ACTIONS(265),
    [anon_sym_get] = ACTIONS(267),
    [anon_sym_set] = ACTIONS(267),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(271),
    [anon_sym_private] = ACTIONS(271),
    [anon_sym_protected] = ACTIONS(271),
    [anon_sym_override] = ACTIONS(273),
    [anon_sym_module] = ACTIONS(275),
    [anon_sym_any] = ACTIONS(277),
    [anon_sym_number] = ACTIONS(277),
    [anon_sym_boolean] = ACTIONS(277),
    [anon_sym_string] = ACTIONS(277),
    [anon_sym_symbol] = ACTIONS(277),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [9] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [ts_builtin_sym_end] = ACTIONS(309),
    [sym_identifier] = ACTIONS(311),
    [anon_sym_export] = ACTIONS(314),
    [anon_sym_default] = ACTIONS(317),
    [anon_sym_type] = ACTIONS(319),
    [anon_sym_namespace] = ACTIONS(322),
    [anon_sym_LBRACE] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_typeof] = ACTIONS(328),
    [anon_sym_import] = ACTIONS(331),
    [anon_sym_var] = ACTIONS(334),
    [anon_sym_let] = ACTIONS(337),
    [anon_sym_const] = ACTIONS(340),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(349),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_await] = ACTIONS(358),
    [anon_sym_while] = ACTIONS(361),
    [anon_sym_do] = ACTIONS(364),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_with] = ACTIONS(370),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_continue] = ACTIONS(376),
    [anon_sym_debugger] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_throw] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(388),
    [anon_sym_case] = ACTIONS(317),
    [anon_sym_yield] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(394),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(400),
    [anon_sym_class] = ACTIONS(403),
    [anon_sym_async] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(409),
    [anon_sym_new] = ACTIONS(412),
    [anon_sym_PLUS] = ACTIONS(328),
    [anon_sym_DASH] = ACTIONS(328),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_void] = ACTIONS(328),
    [anon_sym_delete] = ACTIONS(328),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [anon_sym_SQUOTE] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(424),
    [sym_number] = ACTIONS(427),
    [sym_this] = ACTIONS(430),
    [sym_super] = ACTIONS(430),
    [sym_true] = ACTIONS(430),
    [sym_false] = ACTIONS(430),
    [sym_null] = ACTIONS(430),
    [sym_undefined] = ACTIONS(433),
    [anon_sym_AT] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_readonly] = ACTIONS(439),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
    [anon_sym_declare] = ACTIONS(442),
    [anon_sym_public] = ACTIONS(439),
    [anon_sym_private] = ACTIONS(439),
    [anon_sym_protected] = ACTIONS(439),
    [anon_sym_override] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(445),
    [anon_sym_any] = ACTIONS(439),
    [anon_sym_number] = ACTIONS(439),
    [anon_sym_boolean] = ACTIONS(439),
    [anon_sym_string] = ACTIONS(439),
    [anon_sym_symbol] = ACTIONS(439),
    [anon_sym_abstract] = ACTIONS(448),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(454),
  },
  [10] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(457),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [11] = {
    [sym_export_statement] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(13),
    [sym_expression_statement] = STATE(13),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_switch_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_for_in_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_do_statement] = STATE(13),
    [sym_try_statement] = STATE(13),
    [sym_with_statement] = STATE(13),
    [sym_break_statement] = STATE(13),
    [sym_continue_statement] = STATE(13),
    [sym_debugger_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_throw_statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym_labeled_statement] = STATE(13),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(13),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(461),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [12] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(465),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(465),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [13] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(469),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(469),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [14] = {
    [sym_export_statement] = STATE(21),
    [sym_declaration] = STATE(21),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [15] = {
    [sym_export_statement] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(27),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [ts_builtin_sym_end] = ACTIONS(475),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [16] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [17] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [18] = {
    [sym_export_statement] = STATE(20),
    [sym_declaration] = STATE(20),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [19] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [20] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [21] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [22] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [23] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [24] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [ts_builtin_sym_end] = ACTIONS(475),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [25] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [26] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [27] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [ts_builtin_sym_end] = ACTIONS(497),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [28] = {
    [sym_export_statement] = STATE(9),
    [sym_declaration] = STATE(9),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [29] = {
    [sym_export_statement] = STATE(736),
    [sym_declaration] = STATE(736),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(736),
    [sym_expression_statement] = STATE(736),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(736),
    [sym_if_statement] = STATE(736),
    [sym_switch_statement] = STATE(736),
    [sym_for_statement] = STATE(736),
    [sym_for_in_statement] = STATE(736),
    [sym_while_statement] = STATE(736),
    [sym_do_statement] = STATE(736),
    [sym_try_statement] = STATE(736),
    [sym_with_statement] = STATE(736),
    [sym_break_statement] = STATE(736),
    [sym_continue_statement] = STATE(736),
    [sym_debugger_statement] = STATE(736),
    [sym_return_statement] = STATE(736),
    [sym_throw_statement] = STATE(736),
    [sym_empty_statement] = STATE(736),
    [sym_labeled_statement] = STATE(736),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [30] = {
    [sym_export_statement] = STATE(735),
    [sym_declaration] = STATE(735),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(735),
    [sym_expression_statement] = STATE(735),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(735),
    [sym_if_statement] = STATE(735),
    [sym_switch_statement] = STATE(735),
    [sym_for_statement] = STATE(735),
    [sym_for_in_statement] = STATE(735),
    [sym_while_statement] = STATE(735),
    [sym_do_statement] = STATE(735),
    [sym_try_statement] = STATE(735),
    [sym_with_statement] = STATE(735),
    [sym_break_statement] = STATE(735),
    [sym_continue_statement] = STATE(735),
    [sym_debugger_statement] = STATE(735),
    [sym_return_statement] = STATE(735),
    [sym_throw_statement] = STATE(735),
    [sym_empty_statement] = STATE(735),
    [sym_labeled_statement] = STATE(735),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [31] = {
    [sym_export_statement] = STATE(763),
    [sym_declaration] = STATE(764),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(765),
    [sym_expression_statement] = STATE(767),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(769),
    [sym_if_statement] = STATE(772),
    [sym_switch_statement] = STATE(703),
    [sym_for_statement] = STATE(758),
    [sym_for_in_statement] = STATE(757),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(755),
    [sym_try_statement] = STATE(754),
    [sym_with_statement] = STATE(753),
    [sym_break_statement] = STATE(750),
    [sym_continue_statement] = STATE(749),
    [sym_debugger_statement] = STATE(748),
    [sym_return_statement] = STATE(747),
    [sym_throw_statement] = STATE(746),
    [sym_empty_statement] = STATE(745),
    [sym_labeled_statement] = STATE(743),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [32] = {
    [sym_export_statement] = STATE(736),
    [sym_declaration] = STATE(736),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(736),
    [sym_expression_statement] = STATE(736),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(736),
    [sym_if_statement] = STATE(736),
    [sym_switch_statement] = STATE(736),
    [sym_for_statement] = STATE(736),
    [sym_for_in_statement] = STATE(736),
    [sym_while_statement] = STATE(736),
    [sym_do_statement] = STATE(736),
    [sym_try_statement] = STATE(736),
    [sym_with_statement] = STATE(736),
    [sym_break_statement] = STATE(736),
    [sym_continue_statement] = STATE(736),
    [sym_debugger_statement] = STATE(736),
    [sym_return_statement] = STATE(736),
    [sym_throw_statement] = STATE(736),
    [sym_empty_statement] = STATE(736),
    [sym_labeled_statement] = STATE(736),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [33] = {
    [sym_export_statement] = STATE(672),
    [sym_declaration] = STATE(672),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(672),
    [sym_expression_statement] = STATE(672),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(672),
    [sym_if_statement] = STATE(672),
    [sym_switch_statement] = STATE(672),
    [sym_for_statement] = STATE(672),
    [sym_for_in_statement] = STATE(672),
    [sym_while_statement] = STATE(672),
    [sym_do_statement] = STATE(672),
    [sym_try_statement] = STATE(672),
    [sym_with_statement] = STATE(672),
    [sym_break_statement] = STATE(672),
    [sym_continue_statement] = STATE(672),
    [sym_debugger_statement] = STATE(672),
    [sym_return_statement] = STATE(672),
    [sym_throw_statement] = STATE(672),
    [sym_empty_statement] = STATE(672),
    [sym_labeled_statement] = STATE(672),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [34] = {
    [sym_export_statement] = STATE(736),
    [sym_declaration] = STATE(736),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(736),
    [sym_expression_statement] = STATE(736),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(736),
    [sym_if_statement] = STATE(736),
    [sym_switch_statement] = STATE(736),
    [sym_for_statement] = STATE(736),
    [sym_for_in_statement] = STATE(736),
    [sym_while_statement] = STATE(736),
    [sym_do_statement] = STATE(736),
    [sym_try_statement] = STATE(736),
    [sym_with_statement] = STATE(736),
    [sym_break_statement] = STATE(736),
    [sym_continue_statement] = STATE(736),
    [sym_debugger_statement] = STATE(736),
    [sym_return_statement] = STATE(736),
    [sym_throw_statement] = STATE(736),
    [sym_empty_statement] = STATE(736),
    [sym_labeled_statement] = STATE(736),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [35] = {
    [sym_export_statement] = STATE(642),
    [sym_declaration] = STATE(642),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_for_in_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_with_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_debugger_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_throw_statement] = STATE(642),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [36] = {
    [sym_export_statement] = STATE(735),
    [sym_declaration] = STATE(735),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(735),
    [sym_expression_statement] = STATE(735),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(735),
    [sym_if_statement] = STATE(735),
    [sym_switch_statement] = STATE(735),
    [sym_for_statement] = STATE(735),
    [sym_for_in_statement] = STATE(735),
    [sym_while_statement] = STATE(735),
    [sym_do_statement] = STATE(735),
    [sym_try_statement] = STATE(735),
    [sym_with_statement] = STATE(735),
    [sym_break_statement] = STATE(735),
    [sym_continue_statement] = STATE(735),
    [sym_debugger_statement] = STATE(735),
    [sym_return_statement] = STATE(735),
    [sym_throw_statement] = STATE(735),
    [sym_empty_statement] = STATE(735),
    [sym_labeled_statement] = STATE(735),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [37] = {
    [sym_export_statement] = STATE(3717),
    [sym_declaration] = STATE(3717),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(3717),
    [sym_expression_statement] = STATE(3717),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(3717),
    [sym_if_statement] = STATE(3717),
    [sym_switch_statement] = STATE(3717),
    [sym_for_statement] = STATE(3717),
    [sym_for_in_statement] = STATE(3717),
    [sym_while_statement] = STATE(3717),
    [sym_do_statement] = STATE(3717),
    [sym_try_statement] = STATE(3717),
    [sym_with_statement] = STATE(3717),
    [sym_break_statement] = STATE(3717),
    [sym_continue_statement] = STATE(3717),
    [sym_debugger_statement] = STATE(3717),
    [sym_return_statement] = STATE(3717),
    [sym_throw_statement] = STATE(3717),
    [sym_empty_statement] = STATE(3717),
    [sym_labeled_statement] = STATE(3717),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [38] = {
    [sym_export_statement] = STATE(709),
    [sym_declaration] = STATE(708),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(707),
    [sym_expression_statement] = STATE(706),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(705),
    [sym_if_statement] = STATE(704),
    [sym_switch_statement] = STATE(631),
    [sym_for_statement] = STATE(702),
    [sym_for_in_statement] = STATE(697),
    [sym_while_statement] = STATE(696),
    [sym_do_statement] = STATE(695),
    [sym_try_statement] = STATE(694),
    [sym_with_statement] = STATE(693),
    [sym_break_statement] = STATE(692),
    [sym_continue_statement] = STATE(691),
    [sym_debugger_statement] = STATE(690),
    [sym_return_statement] = STATE(687),
    [sym_throw_statement] = STATE(686),
    [sym_empty_statement] = STATE(683),
    [sym_labeled_statement] = STATE(682),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [39] = {
    [sym_export_statement] = STATE(669),
    [sym_declaration] = STATE(669),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(669),
    [sym_expression_statement] = STATE(669),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(669),
    [sym_if_statement] = STATE(669),
    [sym_switch_statement] = STATE(669),
    [sym_for_statement] = STATE(669),
    [sym_for_in_statement] = STATE(669),
    [sym_while_statement] = STATE(669),
    [sym_do_statement] = STATE(669),
    [sym_try_statement] = STATE(669),
    [sym_with_statement] = STATE(669),
    [sym_break_statement] = STATE(669),
    [sym_continue_statement] = STATE(669),
    [sym_debugger_statement] = STATE(669),
    [sym_return_statement] = STATE(669),
    [sym_throw_statement] = STATE(669),
    [sym_empty_statement] = STATE(669),
    [sym_labeled_statement] = STATE(669),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [40] = {
    [sym_export_statement] = STATE(672),
    [sym_declaration] = STATE(672),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(672),
    [sym_expression_statement] = STATE(672),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(672),
    [sym_if_statement] = STATE(672),
    [sym_switch_statement] = STATE(672),
    [sym_for_statement] = STATE(672),
    [sym_for_in_statement] = STATE(672),
    [sym_while_statement] = STATE(672),
    [sym_do_statement] = STATE(672),
    [sym_try_statement] = STATE(672),
    [sym_with_statement] = STATE(672),
    [sym_break_statement] = STATE(672),
    [sym_continue_statement] = STATE(672),
    [sym_debugger_statement] = STATE(672),
    [sym_return_statement] = STATE(672),
    [sym_throw_statement] = STATE(672),
    [sym_empty_statement] = STATE(672),
    [sym_labeled_statement] = STATE(672),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [41] = {
    [sym_export_statement] = STATE(3628),
    [sym_declaration] = STATE(3628),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(3628),
    [sym_expression_statement] = STATE(3628),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(3628),
    [sym_if_statement] = STATE(3628),
    [sym_switch_statement] = STATE(3628),
    [sym_for_statement] = STATE(3628),
    [sym_for_in_statement] = STATE(3628),
    [sym_while_statement] = STATE(3628),
    [sym_do_statement] = STATE(3628),
    [sym_try_statement] = STATE(3628),
    [sym_with_statement] = STATE(3628),
    [sym_break_statement] = STATE(3628),
    [sym_continue_statement] = STATE(3628),
    [sym_debugger_statement] = STATE(3628),
    [sym_return_statement] = STATE(3628),
    [sym_throw_statement] = STATE(3628),
    [sym_empty_statement] = STATE(3628),
    [sym_labeled_statement] = STATE(3628),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [42] = {
    [sym_export_statement] = STATE(4330),
    [sym_declaration] = STATE(4330),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(4330),
    [sym_expression_statement] = STATE(4330),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(4330),
    [sym_if_statement] = STATE(4330),
    [sym_switch_statement] = STATE(4330),
    [sym_for_statement] = STATE(4330),
    [sym_for_in_statement] = STATE(4330),
    [sym_while_statement] = STATE(4330),
    [sym_do_statement] = STATE(4330),
    [sym_try_statement] = STATE(4330),
    [sym_with_statement] = STATE(4330),
    [sym_break_statement] = STATE(4330),
    [sym_continue_statement] = STATE(4330),
    [sym_debugger_statement] = STATE(4330),
    [sym_return_statement] = STATE(4330),
    [sym_throw_statement] = STATE(4330),
    [sym_empty_statement] = STATE(4330),
    [sym_labeled_statement] = STATE(4330),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [43] = {
    [sym_export_statement] = STATE(709),
    [sym_declaration] = STATE(708),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(707),
    [sym_expression_statement] = STATE(706),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(705),
    [sym_if_statement] = STATE(704),
    [sym_switch_statement] = STATE(631),
    [sym_for_statement] = STATE(702),
    [sym_for_in_statement] = STATE(697),
    [sym_while_statement] = STATE(696),
    [sym_do_statement] = STATE(695),
    [sym_try_statement] = STATE(694),
    [sym_with_statement] = STATE(693),
    [sym_break_statement] = STATE(692),
    [sym_continue_statement] = STATE(691),
    [sym_debugger_statement] = STATE(690),
    [sym_return_statement] = STATE(687),
    [sym_throw_statement] = STATE(686),
    [sym_empty_statement] = STATE(683),
    [sym_labeled_statement] = STATE(682),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [44] = {
    [sym_export_statement] = STATE(642),
    [sym_declaration] = STATE(642),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_for_in_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_with_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_debugger_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_throw_statement] = STATE(642),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [45] = {
    [sym_export_statement] = STATE(733),
    [sym_declaration] = STATE(733),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym_switch_statement] = STATE(733),
    [sym_for_statement] = STATE(733),
    [sym_for_in_statement] = STATE(733),
    [sym_while_statement] = STATE(733),
    [sym_do_statement] = STATE(733),
    [sym_try_statement] = STATE(733),
    [sym_with_statement] = STATE(733),
    [sym_break_statement] = STATE(733),
    [sym_continue_statement] = STATE(733),
    [sym_debugger_statement] = STATE(733),
    [sym_return_statement] = STATE(733),
    [sym_throw_statement] = STATE(733),
    [sym_empty_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [46] = {
    [sym_export_statement] = STATE(735),
    [sym_declaration] = STATE(735),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(735),
    [sym_expression_statement] = STATE(735),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(735),
    [sym_if_statement] = STATE(735),
    [sym_switch_statement] = STATE(735),
    [sym_for_statement] = STATE(735),
    [sym_for_in_statement] = STATE(735),
    [sym_while_statement] = STATE(735),
    [sym_do_statement] = STATE(735),
    [sym_try_statement] = STATE(735),
    [sym_with_statement] = STATE(735),
    [sym_break_statement] = STATE(735),
    [sym_continue_statement] = STATE(735),
    [sym_debugger_statement] = STATE(735),
    [sym_return_statement] = STATE(735),
    [sym_throw_statement] = STATE(735),
    [sym_empty_statement] = STATE(735),
    [sym_labeled_statement] = STATE(735),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [47] = {
    [sym_export_statement] = STATE(669),
    [sym_declaration] = STATE(669),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(669),
    [sym_expression_statement] = STATE(669),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(669),
    [sym_if_statement] = STATE(669),
    [sym_switch_statement] = STATE(669),
    [sym_for_statement] = STATE(669),
    [sym_for_in_statement] = STATE(669),
    [sym_while_statement] = STATE(669),
    [sym_do_statement] = STATE(669),
    [sym_try_statement] = STATE(669),
    [sym_with_statement] = STATE(669),
    [sym_break_statement] = STATE(669),
    [sym_continue_statement] = STATE(669),
    [sym_debugger_statement] = STATE(669),
    [sym_return_statement] = STATE(669),
    [sym_throw_statement] = STATE(669),
    [sym_empty_statement] = STATE(669),
    [sym_labeled_statement] = STATE(669),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [48] = {
    [sym_export_statement] = STATE(763),
    [sym_declaration] = STATE(764),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(765),
    [sym_expression_statement] = STATE(767),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(769),
    [sym_if_statement] = STATE(772),
    [sym_switch_statement] = STATE(703),
    [sym_for_statement] = STATE(758),
    [sym_for_in_statement] = STATE(757),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(755),
    [sym_try_statement] = STATE(754),
    [sym_with_statement] = STATE(753),
    [sym_break_statement] = STATE(750),
    [sym_continue_statement] = STATE(749),
    [sym_debugger_statement] = STATE(748),
    [sym_return_statement] = STATE(747),
    [sym_throw_statement] = STATE(746),
    [sym_empty_statement] = STATE(745),
    [sym_labeled_statement] = STATE(743),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [49] = {
    [sym_export_statement] = STATE(642),
    [sym_declaration] = STATE(642),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(642),
    [sym_expression_statement] = STATE(642),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(642),
    [sym_if_statement] = STATE(642),
    [sym_switch_statement] = STATE(642),
    [sym_for_statement] = STATE(642),
    [sym_for_in_statement] = STATE(642),
    [sym_while_statement] = STATE(642),
    [sym_do_statement] = STATE(642),
    [sym_try_statement] = STATE(642),
    [sym_with_statement] = STATE(642),
    [sym_break_statement] = STATE(642),
    [sym_continue_statement] = STATE(642),
    [sym_debugger_statement] = STATE(642),
    [sym_return_statement] = STATE(642),
    [sym_throw_statement] = STATE(642),
    [sym_empty_statement] = STATE(642),
    [sym_labeled_statement] = STATE(642),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [50] = {
    [sym_export_statement] = STATE(733),
    [sym_declaration] = STATE(733),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym_switch_statement] = STATE(733),
    [sym_for_statement] = STATE(733),
    [sym_for_in_statement] = STATE(733),
    [sym_while_statement] = STATE(733),
    [sym_do_statement] = STATE(733),
    [sym_try_statement] = STATE(733),
    [sym_with_statement] = STATE(733),
    [sym_break_statement] = STATE(733),
    [sym_continue_statement] = STATE(733),
    [sym_debugger_statement] = STATE(733),
    [sym_return_statement] = STATE(733),
    [sym_throw_statement] = STATE(733),
    [sym_empty_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [51] = {
    [sym_export_statement] = STATE(627),
    [sym_declaration] = STATE(627),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(627),
    [sym_expression_statement] = STATE(627),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(627),
    [sym_if_statement] = STATE(627),
    [sym_switch_statement] = STATE(627),
    [sym_for_statement] = STATE(627),
    [sym_for_in_statement] = STATE(627),
    [sym_while_statement] = STATE(627),
    [sym_do_statement] = STATE(627),
    [sym_try_statement] = STATE(627),
    [sym_with_statement] = STATE(627),
    [sym_break_statement] = STATE(627),
    [sym_continue_statement] = STATE(627),
    [sym_debugger_statement] = STATE(627),
    [sym_return_statement] = STATE(627),
    [sym_throw_statement] = STATE(627),
    [sym_empty_statement] = STATE(627),
    [sym_labeled_statement] = STATE(627),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3084),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_namespace] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(41),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(71),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(93),
    [anon_sym_readonly] = ACTIONS(93),
    [anon_sym_get] = ACTIONS(93),
    [anon_sym_set] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(95),
    [anon_sym_public] = ACTIONS(93),
    [anon_sym_private] = ACTIONS(93),
    [anon_sym_protected] = ACTIONS(93),
    [anon_sym_override] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(97),
    [anon_sym_any] = ACTIONS(93),
    [anon_sym_number] = ACTIONS(93),
    [anon_sym_boolean] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(93),
    [anon_sym_symbol] = ACTIONS(93),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [52] = {
    [sym_export_statement] = STATE(733),
    [sym_declaration] = STATE(733),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(733),
    [sym_expression_statement] = STATE(733),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(733),
    [sym_if_statement] = STATE(733),
    [sym_switch_statement] = STATE(733),
    [sym_for_statement] = STATE(733),
    [sym_for_in_statement] = STATE(733),
    [sym_while_statement] = STATE(733),
    [sym_do_statement] = STATE(733),
    [sym_try_statement] = STATE(733),
    [sym_with_statement] = STATE(733),
    [sym_break_statement] = STATE(733),
    [sym_continue_statement] = STATE(733),
    [sym_debugger_statement] = STATE(733),
    [sym_return_statement] = STATE(733),
    [sym_throw_statement] = STATE(733),
    [sym_empty_statement] = STATE(733),
    [sym_labeled_statement] = STATE(733),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3040),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(535),
    [anon_sym_namespace] = ACTIONS(537),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(545),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(549),
    [anon_sym_readonly] = ACTIONS(549),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
    [anon_sym_declare] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(549),
    [anon_sym_private] = ACTIONS(549),
    [anon_sym_protected] = ACTIONS(549),
    [anon_sym_override] = ACTIONS(549),
    [anon_sym_module] = ACTIONS(553),
    [anon_sym_any] = ACTIONS(549),
    [anon_sym_number] = ACTIONS(549),
    [anon_sym_boolean] = ACTIONS(549),
    [anon_sym_string] = ACTIONS(549),
    [anon_sym_symbol] = ACTIONS(549),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [53] = {
    [sym_export_statement] = STATE(763),
    [sym_declaration] = STATE(764),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(765),
    [sym_expression_statement] = STATE(767),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(769),
    [sym_if_statement] = STATE(772),
    [sym_switch_statement] = STATE(703),
    [sym_for_statement] = STATE(758),
    [sym_for_in_statement] = STATE(757),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(755),
    [sym_try_statement] = STATE(754),
    [sym_with_statement] = STATE(753),
    [sym_break_statement] = STATE(750),
    [sym_continue_statement] = STATE(749),
    [sym_debugger_statement] = STATE(748),
    [sym_return_statement] = STATE(747),
    [sym_throw_statement] = STATE(746),
    [sym_empty_statement] = STATE(745),
    [sym_labeled_statement] = STATE(743),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [54] = {
    [sym_export_statement] = STATE(669),
    [sym_declaration] = STATE(669),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(669),
    [sym_expression_statement] = STATE(669),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(669),
    [sym_if_statement] = STATE(669),
    [sym_switch_statement] = STATE(669),
    [sym_for_statement] = STATE(669),
    [sym_for_in_statement] = STATE(669),
    [sym_while_statement] = STATE(669),
    [sym_do_statement] = STATE(669),
    [sym_try_statement] = STATE(669),
    [sym_with_statement] = STATE(669),
    [sym_break_statement] = STATE(669),
    [sym_continue_statement] = STATE(669),
    [sym_debugger_statement] = STATE(669),
    [sym_return_statement] = STATE(669),
    [sym_throw_statement] = STATE(669),
    [sym_empty_statement] = STATE(669),
    [sym_labeled_statement] = STATE(669),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [55] = {
    [sym_export_statement] = STATE(672),
    [sym_declaration] = STATE(672),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(672),
    [sym_expression_statement] = STATE(672),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(672),
    [sym_if_statement] = STATE(672),
    [sym_switch_statement] = STATE(672),
    [sym_for_statement] = STATE(672),
    [sym_for_in_statement] = STATE(672),
    [sym_while_statement] = STATE(672),
    [sym_do_statement] = STATE(672),
    [sym_try_statement] = STATE(672),
    [sym_with_statement] = STATE(672),
    [sym_break_statement] = STATE(672),
    [sym_continue_statement] = STATE(672),
    [sym_debugger_statement] = STATE(672),
    [sym_return_statement] = STATE(672),
    [sym_throw_statement] = STATE(672),
    [sym_empty_statement] = STATE(672),
    [sym_labeled_statement] = STATE(672),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [56] = {
    [sym_export_statement] = STATE(709),
    [sym_declaration] = STATE(708),
    [sym_import] = STATE(1762),
    [sym_import_statement] = STATE(707),
    [sym_expression_statement] = STATE(706),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_statement_block] = STATE(705),
    [sym_if_statement] = STATE(704),
    [sym_switch_statement] = STATE(631),
    [sym_for_statement] = STATE(702),
    [sym_for_in_statement] = STATE(697),
    [sym_while_statement] = STATE(696),
    [sym_do_statement] = STATE(695),
    [sym_try_statement] = STATE(694),
    [sym_with_statement] = STATE(693),
    [sym_break_statement] = STATE(692),
    [sym_continue_statement] = STATE(691),
    [sym_debugger_statement] = STATE(690),
    [sym_return_statement] = STATE(687),
    [sym_throw_statement] = STATE(686),
    [sym_empty_statement] = STATE(683),
    [sym_labeled_statement] = STATE(682),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3039),
    [sym_identifier] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(505),
    [anon_sym_namespace] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(511),
    [anon_sym_switch] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_while] = ACTIONS(515),
    [anon_sym_do] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(49),
    [anon_sym_continue] = ACTIONS(51),
    [anon_sym_debugger] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_throw] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_readonly] = ACTIONS(525),
    [anon_sym_get] = ACTIONS(525),
    [anon_sym_set] = ACTIONS(525),
    [anon_sym_declare] = ACTIONS(527),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_override] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_any] = ACTIONS(525),
    [anon_sym_number] = ACTIONS(525),
    [anon_sym_boolean] = ACTIONS(525),
    [anon_sym_string] = ACTIONS(525),
    [anon_sym_symbol] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [57] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1594),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3658),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3649),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [58] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3157),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(631),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [59] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3160),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [60] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1594),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3658),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3649),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [61] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3573),
    [sym_optional_tuple_parameter] = STATE(3573),
    [sym_optional_type] = STATE(3573),
    [sym_rest_type] = STATE(3573),
    [sym__tuple_type_member] = STATE(3573),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(643),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [62] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3129),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(645),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [63] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [64] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(649),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [65] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(651),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [66] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3375),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(653),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [67] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(655),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [68] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3375),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(653),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [69] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3133),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(657),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [70] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3127),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [71] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3152),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(621),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(170),
    [anon_sym_DASH_DASH] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(661),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [72] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [73] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(665),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [74] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(3107),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(555),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(563),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(605),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(609),
    [anon_sym_number] = ACTIONS(609),
    [anon_sym_boolean] = ACTIONS(609),
    [anon_sym_string] = ACTIONS(609),
    [anon_sym_symbol] = ACTIONS(609),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [75] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1472),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4332),
    [sym_string] = STATE(1753),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3397),
    [sym_constructor_type] = STATE(3397),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3397),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3397),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3397),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(673),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_undefined] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(691),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(697),
    [anon_sym_number] = ACTIONS(697),
    [anon_sym_boolean] = ACTIONS(697),
    [anon_sym_string] = ACTIONS(697),
    [anon_sym_symbol] = ACTIONS(697),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [76] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4323),
    [sym_string] = STATE(1753),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3504),
    [sym_constructor_type] = STATE(3504),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3504),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3504),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3504),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(673),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_undefined] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(691),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(697),
    [anon_sym_number] = ACTIONS(697),
    [anon_sym_boolean] = ACTIONS(697),
    [anon_sym_string] = ACTIONS(697),
    [anon_sym_symbol] = ACTIONS(697),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [77] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4323),
    [sym_string] = STATE(1753),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3397),
    [sym_constructor_type] = STATE(3397),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3397),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3397),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3397),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(669),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(671),
    [anon_sym_typeof] = ACTIONS(673),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [sym_this] = ACTIONS(685),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_undefined] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(691),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(697),
    [anon_sym_number] = ACTIONS(697),
    [anon_sym_boolean] = ACTIONS(697),
    [anon_sym_string] = ACTIONS(697),
    [anon_sym_symbol] = ACTIONS(697),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [78] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3394),
    [sym_constructor_type] = STATE(3394),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3394),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3394),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3394),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(703),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [79] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3429),
    [sym_constructor_type] = STATE(3429),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3429),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3429),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3429),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(703),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [80] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3504),
    [sym_constructor_type] = STATE(3504),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3504),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3504),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3504),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(703),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [81] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3436),
    [sym_constructor_type] = STATE(3436),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3436),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3436),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3436),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(703),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [82] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym__type] = STATE(3397),
    [sym_constructor_type] = STATE(3397),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3397),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3397),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3397),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(118),
    [anon_sym_typeof] = ACTIONS(122),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(187),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(703),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(193),
    [anon_sym_number] = ACTIONS(193),
    [anon_sym_boolean] = ACTIONS(193),
    [anon_sym_string] = ACTIONS(193),
    [anon_sym_symbol] = ACTIONS(193),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [83] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1757),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4078),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1576),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3212),
    [sym_pattern] = STATE(3761),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2501),
    [sym__type] = STATE(2647),
    [sym_constructor_type] = STATE(2647),
    [sym__primary_type] = STATE(2624),
    [sym_template_literal_type] = STATE(2576),
    [sym_infer_type] = STATE(2647),
    [sym_conditional_type] = STATE(2576),
    [sym_generic_type] = STATE(2576),
    [sym_type_query] = STATE(2576),
    [sym_index_type_query] = STATE(2576),
    [sym_lookup_type] = STATE(2576),
    [sym_literal_type] = STATE(2576),
    [sym__number] = STATE(2623),
    [sym_existential_type] = STATE(2576),
    [sym_flow_maybe_type] = STATE(2576),
    [sym_parenthesized_type] = STATE(2576),
    [sym_predefined_type] = STATE(2576),
    [sym_object_type] = STATE(2576),
    [sym_type_parameters] = STATE(3814),
    [sym_array_type] = STATE(2576),
    [sym_tuple_type] = STATE(2576),
    [sym_readonly_type] = STATE(2647),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2647),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(709),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(713),
    [anon_sym_typeof] = ACTIONS(715),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(717),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(729),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(731),
    [sym_number] = ACTIONS(733),
    [sym_this] = ACTIONS(735),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(737),
    [sym_false] = ACTIONS(737),
    [sym_null] = ACTIONS(737),
    [sym_undefined] = ACTIONS(739),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(741),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(745),
    [anon_sym_number] = ACTIONS(745),
    [anon_sym_boolean] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_symbol] = ACTIONS(745),
    [anon_sym_infer] = ACTIONS(747),
    [anon_sym_keyof] = ACTIONS(749),
    [anon_sym_unknown] = ACTIONS(751),
    [anon_sym_never] = ACTIONS(751),
    [anon_sym_object] = ACTIONS(751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(753),
  },
  [84] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1812),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4177),
    [sym_string] = STATE(1753),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3537),
    [sym_constructor_type] = STATE(3537),
    [sym__primary_type] = STATE(3153),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3537),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3537),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(755),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_typeof] = ACTIONS(673),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [sym_this] = ACTIONS(767),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_null] = ACTIONS(687),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(771),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(773),
    [anon_sym_number] = ACTIONS(773),
    [anon_sym_boolean] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_symbol] = ACTIONS(773),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [85] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1781),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1989),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(775),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(781),
    [anon_sym_typeof] = ACTIONS(783),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(807),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [sym_number] = ACTIONS(815),
    [sym_this] = ACTIONS(817),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(819),
    [sym_false] = ACTIONS(819),
    [sym_null] = ACTIONS(819),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(825),
    [anon_sym_number] = ACTIONS(825),
    [anon_sym_boolean] = ACTIONS(825),
    [anon_sym_string] = ACTIONS(825),
    [anon_sym_symbol] = ACTIONS(825),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [86] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1520),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(827),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_typeof] = ACTIONS(835),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(845),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [sym_number] = ACTIONS(849),
    [sym_this] = ACTIONS(851),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(853),
    [sym_false] = ACTIONS(853),
    [sym_null] = ACTIONS(853),
    [sym_undefined] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(859),
    [anon_sym_number] = ACTIONS(859),
    [anon_sym_boolean] = ACTIONS(859),
    [anon_sym_string] = ACTIONS(859),
    [anon_sym_symbol] = ACTIONS(859),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [87] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1468),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(3370),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(3370),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1108),
    [sym_subscript_expression] = STATE(1108),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(3370),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1788),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1108),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3149),
    [sym_constructor_type] = STATE(3149),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3149),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3149),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3149),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(861),
    [anon_sym_export] = ACTIONS(863),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(863),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(867),
    [anon_sym_typeof] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(869),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(593),
    [anon_sym_DASH] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(177),
    [sym_number] = ACTIONS(179),
    [sym_this] = ACTIONS(601),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(185),
    [sym_false] = ACTIONS(185),
    [sym_null] = ACTIONS(185),
    [sym_undefined] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(863),
    [anon_sym_readonly] = ACTIONS(873),
    [anon_sym_get] = ACTIONS(863),
    [anon_sym_set] = ACTIONS(863),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_private] = ACTIONS(863),
    [anon_sym_protected] = ACTIONS(863),
    [anon_sym_override] = ACTIONS(863),
    [anon_sym_module] = ACTIONS(863),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [88] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1462),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_typeof] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_DASH] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(899),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(847),
    [sym_number] = ACTIONS(849),
    [sym_this] = ACTIONS(851),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(853),
    [sym_false] = ACTIONS(853),
    [sym_null] = ACTIONS(853),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(907),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(909),
    [anon_sym_number] = ACTIONS(909),
    [anon_sym_boolean] = ACTIONS(909),
    [anon_sym_string] = ACTIONS(909),
    [anon_sym_symbol] = ACTIONS(909),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [89] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1955),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1588),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(911),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_typeof] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(933),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(937),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(943),
    [sym_number] = ACTIONS(945),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(949),
    [sym_undefined] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(953),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(955),
    [anon_sym_number] = ACTIONS(955),
    [anon_sym_boolean] = ACTIONS(955),
    [anon_sym_string] = ACTIONS(955),
    [anon_sym_symbol] = ACTIONS(955),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [90] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1330),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1382),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(957),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_typeof] = ACTIONS(961),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(965),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(595),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [sym_number] = ACTIONS(969),
    [sym_this] = ACTIONS(971),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(973),
    [sym_false] = ACTIONS(973),
    [sym_null] = ACTIONS(973),
    [sym_undefined] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(771),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(977),
    [anon_sym_number] = ACTIONS(977),
    [anon_sym_boolean] = ACTIONS(977),
    [anon_sym_string] = ACTIONS(977),
    [anon_sym_symbol] = ACTIONS(977),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [91] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2830),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2830),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1159),
    [sym_subscript_expression] = STATE(1159),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2830),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(2077),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1159),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3149),
    [sym_constructor_type] = STATE(3149),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3149),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3149),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3149),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(979),
    [anon_sym_export] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(981),
    [anon_sym_namespace] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_typeof] = ACTIONS(987),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [sym_number] = ACTIONS(997),
    [sym_this] = ACTIONS(999),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(1001),
    [sym_false] = ACTIONS(1001),
    [sym_null] = ACTIONS(1001),
    [sym_undefined] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(981),
    [anon_sym_readonly] = ACTIONS(1005),
    [anon_sym_get] = ACTIONS(981),
    [anon_sym_set] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(981),
    [anon_sym_public] = ACTIONS(981),
    [anon_sym_private] = ACTIONS(981),
    [anon_sym_protected] = ACTIONS(981),
    [anon_sym_override] = ACTIONS(981),
    [anon_sym_module] = ACTIONS(981),
    [anon_sym_any] = ACTIONS(1007),
    [anon_sym_number] = ACTIONS(1007),
    [anon_sym_boolean] = ACTIONS(1007),
    [anon_sym_string] = ACTIONS(1007),
    [anon_sym_symbol] = ACTIONS(1007),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [92] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1690),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1382),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_typeof] = ACTIONS(1015),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [sym_number] = ACTIONS(969),
    [sym_this] = ACTIONS(971),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(973),
    [sym_false] = ACTIONS(973),
    [sym_null] = ACTIONS(973),
    [sym_undefined] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1039),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [93] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1690),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1382),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3089),
    [sym_constructor_type] = STATE(3089),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3089),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3089),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3089),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_typeof] = ACTIONS(1015),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(963),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(967),
    [sym_number] = ACTIONS(969),
    [sym_this] = ACTIONS(971),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(973),
    [sym_false] = ACTIONS(973),
    [sym_null] = ACTIONS(973),
    [sym_undefined] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1039),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1041),
    [anon_sym_number] = ACTIONS(1041),
    [anon_sym_boolean] = ACTIONS(1041),
    [anon_sym_string] = ACTIONS(1041),
    [anon_sym_symbol] = ACTIONS(1041),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [94] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1588),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_typeof] = ACTIONS(1049),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(152),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(166),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(943),
    [sym_number] = ACTIONS(945),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(949),
    [sym_undefined] = ACTIONS(1055),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1057),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1059),
    [anon_sym_number] = ACTIONS(1059),
    [anon_sym_boolean] = ACTIONS(1059),
    [anon_sym_string] = ACTIONS(1059),
    [anon_sym_symbol] = ACTIONS(1059),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [95] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1648),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_nested_identifier] = STATE(4196),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1588),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3314),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2981),
    [sym_constructor_type] = STATE(2981),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2981),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(3988),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2981),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2981),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_typeof] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1083),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(943),
    [sym_number] = ACTIONS(945),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(949),
    [sym_undefined] = ACTIONS(1089),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1091),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1093),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_boolean] = ACTIONS(1093),
    [anon_sym_string] = ACTIONS(1093),
    [anon_sym_symbol] = ACTIONS(1093),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [96] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1411),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [97] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1478),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
    [sym__automatic_semicolon] = ACTIONS(1103),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [98] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1504),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_STAR] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_of] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
    [sym__automatic_semicolon] = ACTIONS(1103),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [99] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1603),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [100] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1141),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
    [anon_sym_implements] = ACTIONS(1099),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [101] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1749),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_STAR] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [sym__automatic_semicolon] = ACTIONS(1103),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [102] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1964),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_of] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [103] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2024),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1099),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(168),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(137),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_QMARK_DOT] = ACTIONS(1103),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_QMARK_QMARK] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
    [sym__ternary_qmark] = ACTIONS(1103),
  },
  [104] = {
    [sym_declaration] = STATE(643),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1848),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3236),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1179),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [105] = {
    [sym_declaration] = STATE(643),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1848),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3236),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [106] = {
    [sym_declaration] = STATE(643),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1848),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3333),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [107] = {
    [sym_declaration] = STATE(3311),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(3268),
    [sym_lexical_declaration] = STATE(3268),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1864),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(3268),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(3268),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(3268),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(3268),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(3268),
    [sym_abstract_class_declaration] = STATE(3268),
    [sym_module] = STATE(3268),
    [sym_internal_module] = STATE(1763),
    [sym_import_alias] = STATE(3268),
    [sym_interface_declaration] = STATE(3268),
    [sym_enum_declaration] = STATE(3268),
    [sym_type_alias_declaration] = STATE(3268),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3139),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1193),
    [anon_sym_var] = ACTIONS(1195),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1209),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1215),
  },
  [108] = {
    [sym_declaration] = STATE(674),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3236),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [109] = {
    [sym_declaration] = STATE(3273),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(3268),
    [sym_lexical_declaration] = STATE(3268),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1775),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(3268),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(3268),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(3268),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(3268),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(3268),
    [sym_abstract_class_declaration] = STATE(3268),
    [sym_module] = STATE(3268),
    [sym_internal_module] = STATE(1763),
    [sym_import_alias] = STATE(3268),
    [sym_interface_declaration] = STATE(3268),
    [sym_enum_declaration] = STATE(3268),
    [sym_type_alias_declaration] = STATE(3268),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3139),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1193),
    [anon_sym_var] = ACTIONS(1195),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1207),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1209),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1213),
    [anon_sym_enum] = ACTIONS(1215),
  },
  [110] = {
    [sym_declaration] = STATE(674),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(1784),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3236),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1179),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [111] = {
    [sym_declaration] = STATE(674),
    [sym_import] = STATE(1762),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_class_declaration] = STATE(651),
    [sym_function] = STATE(1762),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function] = STATE(1762),
    [sym_generator_function_declaration] = STATE(651),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(651),
    [sym_as_expression] = STATE(1777),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(163),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3333),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_async] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(73),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(1185),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_interface] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(103),
  },
  [112] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [113] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1251),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [114] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [115] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [116] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1261),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [117] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [118] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [119] = {
    [sym_nested_identifier] = STATE(4078),
    [sym_string] = STATE(2626),
    [sym_formal_parameters] = STATE(4312),
    [sym_nested_type_identifier] = STATE(2501),
    [sym__type] = STATE(2612),
    [sym_constructor_type] = STATE(2612),
    [sym__primary_type] = STATE(2624),
    [sym_template_literal_type] = STATE(2576),
    [sym_infer_type] = STATE(2612),
    [sym_conditional_type] = STATE(2576),
    [sym_generic_type] = STATE(2576),
    [sym_type_query] = STATE(2576),
    [sym_index_type_query] = STATE(2576),
    [sym_lookup_type] = STATE(2576),
    [sym_literal_type] = STATE(2576),
    [sym__number] = STATE(2623),
    [sym_existential_type] = STATE(2576),
    [sym_flow_maybe_type] = STATE(2576),
    [sym_parenthesized_type] = STATE(2576),
    [sym_predefined_type] = STATE(2576),
    [sym_object_type] = STATE(2576),
    [sym_type_parameters] = STATE(3950),
    [sym_array_type] = STATE(2576),
    [sym_tuple_type] = STATE(2576),
    [sym_readonly_type] = STATE(2612),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2612),
    [sym_identifier] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1268),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1272),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(1280),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(1294),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_null] = ACTIONS(1296),
    [sym_undefined] = ACTIONS(1296),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_QMARK] = ACTIONS(1300),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
    [anon_sym_infer] = ACTIONS(747),
    [anon_sym_keyof] = ACTIONS(749),
    [anon_sym_unknown] = ACTIONS(751),
    [anon_sym_never] = ACTIONS(751),
    [anon_sym_object] = ACTIONS(751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(753),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [120] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1304),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_implements] = ACTIONS(114),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [121] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [122] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [123] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1312),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(1314),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [124] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2403),
    [sym_constructor_type] = STATE(2403),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2403),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2403),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2403),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(158),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(1233),
    [anon_sym_DASH] = ACTIONS(1233),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(191),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [125] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1472),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4332),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(1322),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [126] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1518),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4323),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1318),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(1322),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_override] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [127] = {
    [sym_statement_block] = STATE(150),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_export] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_as] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_COMMA] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_typeof] = ACTIONS(1326),
    [anon_sym_import] = ACTIONS(1326),
    [anon_sym_var] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_await] = ACTIONS(1326),
    [anon_sym_in] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [anon_sym_with] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_debugger] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_throw] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(1330),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_function] = ACTIONS(1326),
    [anon_sym_QMARK_DOT] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_GT_GT_GT] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1326),
    [anon_sym_CARET] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1324),
    [anon_sym_STAR_STAR] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_QMARK_QMARK] = ACTIONS(1324),
    [anon_sym_instanceof] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_void] = ACTIONS(1326),
    [anon_sym_delete] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [sym_number] = ACTIONS(1324),
    [sym_this] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [sym_null] = ACTIONS(1326),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_readonly] = ACTIONS(1326),
    [anon_sym_get] = ACTIONS(1326),
    [anon_sym_set] = ACTIONS(1326),
    [anon_sym_declare] = ACTIONS(1326),
    [anon_sym_public] = ACTIONS(1326),
    [anon_sym_private] = ACTIONS(1326),
    [anon_sym_protected] = ACTIONS(1326),
    [anon_sym_override] = ACTIONS(1326),
    [anon_sym_module] = ACTIONS(1326),
    [anon_sym_any] = ACTIONS(1326),
    [anon_sym_number] = ACTIONS(1326),
    [anon_sym_boolean] = ACTIONS(1326),
    [anon_sym_string] = ACTIONS(1326),
    [anon_sym_symbol] = ACTIONS(1326),
    [anon_sym_abstract] = ACTIONS(1326),
    [anon_sym_interface] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [sym__automatic_semicolon] = ACTIONS(1324),
    [sym__ternary_qmark] = ACTIONS(1324),
  },
  [128] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [129] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1340),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [130] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [131] = {
    [sym_statement_block] = STATE(150),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_export] = ACTIONS(1326),
    [anon_sym_STAR] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_as] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_COMMA] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_typeof] = ACTIONS(1326),
    [anon_sym_import] = ACTIONS(1326),
    [anon_sym_var] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1326),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_await] = ACTIONS(1326),
    [anon_sym_in] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [anon_sym_with] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_debugger] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_throw] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1326),
    [anon_sym_GT] = ACTIONS(1326),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(1326),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_function] = ACTIONS(1326),
    [anon_sym_QMARK_DOT] = ACTIONS(1324),
    [anon_sym_new] = ACTIONS(1326),
    [anon_sym_AMP_AMP] = ACTIONS(1324),
    [anon_sym_PIPE_PIPE] = ACTIONS(1324),
    [anon_sym_GT_GT] = ACTIONS(1326),
    [anon_sym_GT_GT_GT] = ACTIONS(1324),
    [anon_sym_LT_LT] = ACTIONS(1324),
    [anon_sym_AMP] = ACTIONS(1326),
    [anon_sym_CARET] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_PERCENT] = ACTIONS(1324),
    [anon_sym_STAR_STAR] = ACTIONS(1324),
    [anon_sym_LT_EQ] = ACTIONS(1324),
    [anon_sym_EQ_EQ] = ACTIONS(1326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1324),
    [anon_sym_BANG_EQ] = ACTIONS(1326),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1324),
    [anon_sym_GT_EQ] = ACTIONS(1324),
    [anon_sym_QMARK_QMARK] = ACTIONS(1324),
    [anon_sym_instanceof] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_void] = ACTIONS(1326),
    [anon_sym_delete] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [sym_number] = ACTIONS(1324),
    [sym_this] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [sym_null] = ACTIONS(1326),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_readonly] = ACTIONS(1326),
    [anon_sym_get] = ACTIONS(1326),
    [anon_sym_set] = ACTIONS(1326),
    [anon_sym_declare] = ACTIONS(1326),
    [anon_sym_public] = ACTIONS(1326),
    [anon_sym_private] = ACTIONS(1326),
    [anon_sym_protected] = ACTIONS(1326),
    [anon_sym_override] = ACTIONS(1326),
    [anon_sym_module] = ACTIONS(1326),
    [anon_sym_any] = ACTIONS(1326),
    [anon_sym_number] = ACTIONS(1326),
    [anon_sym_boolean] = ACTIONS(1326),
    [anon_sym_string] = ACTIONS(1326),
    [anon_sym_symbol] = ACTIONS(1326),
    [anon_sym_abstract] = ACTIONS(1326),
    [anon_sym_interface] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
    [sym__automatic_semicolon] = ACTIONS(1324),
    [sym__ternary_qmark] = ACTIONS(1324),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1348),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1348),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1348),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_QMARK_DOT] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1352),
    [anon_sym_PIPE_PIPE] = ACTIONS(1352),
    [anon_sym_GT_GT] = ACTIONS(1348),
    [anon_sym_GT_GT_GT] = ACTIONS(1352),
    [anon_sym_LT_LT] = ACTIONS(1352),
    [anon_sym_AMP] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1352),
    [anon_sym_PIPE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1352),
    [anon_sym_STAR_STAR] = ACTIONS(1352),
    [anon_sym_LT_EQ] = ACTIONS(1352),
    [anon_sym_EQ_EQ] = ACTIONS(1348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1348),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1352),
    [anon_sym_GT_EQ] = ACTIONS(1352),
    [anon_sym_QMARK_QMARK] = ACTIONS(1352),
    [anon_sym_instanceof] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1354),
    [sym__ternary_qmark] = ACTIONS(1352),
  },
  [133] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1356),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [134] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1358),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [135] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3721),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3721),
    [sym_optional_parameter] = STATE(3721),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(675),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [136] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [137] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3619),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3619),
    [sym_optional_parameter] = STATE(3619),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1362),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [138] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3654),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3654),
    [sym_optional_parameter] = STATE(3654),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1364),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_STAR] = ACTIONS(1370),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_as] = ACTIONS(1370),
    [anon_sym_namespace] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_COMMA] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(1368),
    [anon_sym_var] = ACTIONS(1368),
    [anon_sym_let] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_else] = ACTIONS(1368),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_switch] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_await] = ACTIONS(1368),
    [anon_sym_in] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1368),
    [anon_sym_do] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [anon_sym_with] = ACTIONS(1368),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_debugger] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_throw] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1368),
    [anon_sym_GT] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_DOT] = ACTIONS(1370),
    [anon_sym_class] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(1368),
    [anon_sym_QMARK_DOT] = ACTIONS(1372),
    [anon_sym_new] = ACTIONS(1368),
    [anon_sym_AMP_AMP] = ACTIONS(1372),
    [anon_sym_PIPE_PIPE] = ACTIONS(1372),
    [anon_sym_GT_GT] = ACTIONS(1370),
    [anon_sym_GT_GT_GT] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1372),
    [anon_sym_AMP] = ACTIONS(1370),
    [anon_sym_CARET] = ACTIONS(1372),
    [anon_sym_PIPE] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_PERCENT] = ACTIONS(1372),
    [anon_sym_STAR_STAR] = ACTIONS(1372),
    [anon_sym_LT_EQ] = ACTIONS(1372),
    [anon_sym_EQ_EQ] = ACTIONS(1370),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1372),
    [anon_sym_BANG_EQ] = ACTIONS(1370),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1372),
    [anon_sym_GT_EQ] = ACTIONS(1372),
    [anon_sym_QMARK_QMARK] = ACTIONS(1372),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_void] = ACTIONS(1368),
    [anon_sym_delete] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [sym_number] = ACTIONS(1366),
    [sym_this] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_true] = ACTIONS(1368),
    [sym_false] = ACTIONS(1368),
    [sym_null] = ACTIONS(1368),
    [sym_undefined] = ACTIONS(1368),
    [anon_sym_AT] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_abstract] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [sym__automatic_semicolon] = ACTIONS(1374),
    [sym__ternary_qmark] = ACTIONS(1372),
  },
  [140] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1594),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3658),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3649),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(1380),
    [sym_identifier] = ACTIONS(1382),
    [anon_sym_export] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_type] = ACTIONS(1382),
    [anon_sym_as] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_COMMA] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_typeof] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(1382),
    [anon_sym_var] = ACTIONS(1382),
    [anon_sym_let] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_LPAREN] = ACTIONS(1380),
    [anon_sym_await] = ACTIONS(1382),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_try] = ACTIONS(1382),
    [anon_sym_with] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_debugger] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_throw] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_yield] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1382),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_SLASH] = ACTIONS(1382),
    [anon_sym_DOT] = ACTIONS(1382),
    [anon_sym_class] = ACTIONS(1382),
    [anon_sym_async] = ACTIONS(1382),
    [anon_sym_function] = ACTIONS(1382),
    [anon_sym_QMARK_DOT] = ACTIONS(1380),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_GT_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1382),
    [anon_sym_CARET] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_PERCENT] = ACTIONS(1380),
    [anon_sym_STAR_STAR] = ACTIONS(1380),
    [anon_sym_LT_EQ] = ACTIONS(1380),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1380),
    [anon_sym_GT_EQ] = ACTIONS(1380),
    [anon_sym_QMARK_QMARK] = ACTIONS(1380),
    [anon_sym_instanceof] = ACTIONS(1382),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_void] = ACTIONS(1382),
    [anon_sym_delete] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [sym_number] = ACTIONS(1380),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1382),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1380),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_readonly] = ACTIONS(1382),
    [anon_sym_get] = ACTIONS(1382),
    [anon_sym_set] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1382),
    [anon_sym_public] = ACTIONS(1382),
    [anon_sym_private] = ACTIONS(1382),
    [anon_sym_protected] = ACTIONS(1382),
    [anon_sym_override] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_any] = ACTIONS(1382),
    [anon_sym_number] = ACTIONS(1382),
    [anon_sym_boolean] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [anon_sym_symbol] = ACTIONS(1382),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_interface] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
    [sym__automatic_semicolon] = ACTIONS(1380),
    [sym__ternary_qmark] = ACTIONS(1380),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_export] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1388),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(1388),
    [anon_sym_namespace] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_COMMA] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_typeof] = ACTIONS(1386),
    [anon_sym_import] = ACTIONS(1386),
    [anon_sym_var] = ACTIONS(1386),
    [anon_sym_let] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1386),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_await] = ACTIONS(1386),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_try] = ACTIONS(1386),
    [anon_sym_with] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_debugger] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_throw] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_yield] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1386),
    [anon_sym_GT] = ACTIONS(1388),
    [anon_sym_SLASH] = ACTIONS(1386),
    [anon_sym_DOT] = ACTIONS(1388),
    [anon_sym_class] = ACTIONS(1386),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(1386),
    [anon_sym_QMARK_DOT] = ACTIONS(1390),
    [anon_sym_new] = ACTIONS(1386),
    [anon_sym_AMP_AMP] = ACTIONS(1390),
    [anon_sym_PIPE_PIPE] = ACTIONS(1390),
    [anon_sym_GT_GT] = ACTIONS(1388),
    [anon_sym_GT_GT_GT] = ACTIONS(1390),
    [anon_sym_LT_LT] = ACTIONS(1390),
    [anon_sym_AMP] = ACTIONS(1388),
    [anon_sym_CARET] = ACTIONS(1390),
    [anon_sym_PIPE] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1390),
    [anon_sym_LT_EQ] = ACTIONS(1390),
    [anon_sym_EQ_EQ] = ACTIONS(1388),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1390),
    [anon_sym_BANG_EQ] = ACTIONS(1388),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1390),
    [anon_sym_GT_EQ] = ACTIONS(1390),
    [anon_sym_QMARK_QMARK] = ACTIONS(1390),
    [anon_sym_instanceof] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_void] = ACTIONS(1386),
    [anon_sym_delete] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(1386),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(1386),
    [anon_sym_set] = ACTIONS(1386),
    [anon_sym_declare] = ACTIONS(1386),
    [anon_sym_public] = ACTIONS(1386),
    [anon_sym_private] = ACTIONS(1386),
    [anon_sym_protected] = ACTIONS(1386),
    [anon_sym_override] = ACTIONS(1386),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_any] = ACTIONS(1386),
    [anon_sym_number] = ACTIONS(1386),
    [anon_sym_boolean] = ACTIONS(1386),
    [anon_sym_string] = ACTIONS(1386),
    [anon_sym_symbol] = ACTIONS(1386),
    [anon_sym_abstract] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [sym__automatic_semicolon] = ACTIONS(1392),
    [sym__ternary_qmark] = ACTIONS(1390),
  },
  [143] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1394),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [144] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1595),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3658),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3649),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_type] = ACTIONS(1398),
    [anon_sym_as] = ACTIONS(1400),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_COMMA] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_typeof] = ACTIONS(1398),
    [anon_sym_import] = ACTIONS(1398),
    [anon_sym_var] = ACTIONS(1398),
    [anon_sym_let] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_await] = ACTIONS(1398),
    [anon_sym_in] = ACTIONS(1400),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_try] = ACTIONS(1398),
    [anon_sym_with] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_debugger] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_throw] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_yield] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1398),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_SLASH] = ACTIONS(1398),
    [anon_sym_DOT] = ACTIONS(1400),
    [anon_sym_class] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_function] = ACTIONS(1398),
    [anon_sym_QMARK_DOT] = ACTIONS(1402),
    [anon_sym_new] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1402),
    [anon_sym_PIPE_PIPE] = ACTIONS(1402),
    [anon_sym_GT_GT] = ACTIONS(1400),
    [anon_sym_GT_GT_GT] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1402),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_PERCENT] = ACTIONS(1402),
    [anon_sym_STAR_STAR] = ACTIONS(1402),
    [anon_sym_LT_EQ] = ACTIONS(1402),
    [anon_sym_EQ_EQ] = ACTIONS(1400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1402),
    [anon_sym_BANG_EQ] = ACTIONS(1400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1402),
    [anon_sym_GT_EQ] = ACTIONS(1402),
    [anon_sym_QMARK_QMARK] = ACTIONS(1402),
    [anon_sym_instanceof] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1398),
    [anon_sym_delete] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1396),
    [sym_number] = ACTIONS(1396),
    [sym_this] = ACTIONS(1398),
    [sym_super] = ACTIONS(1398),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [sym_null] = ACTIONS(1398),
    [sym_undefined] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_readonly] = ACTIONS(1398),
    [anon_sym_get] = ACTIONS(1398),
    [anon_sym_set] = ACTIONS(1398),
    [anon_sym_declare] = ACTIONS(1398),
    [anon_sym_public] = ACTIONS(1398),
    [anon_sym_private] = ACTIONS(1398),
    [anon_sym_protected] = ACTIONS(1398),
    [anon_sym_override] = ACTIONS(1398),
    [anon_sym_module] = ACTIONS(1398),
    [anon_sym_any] = ACTIONS(1398),
    [anon_sym_number] = ACTIONS(1398),
    [anon_sym_boolean] = ACTIONS(1398),
    [anon_sym_string] = ACTIONS(1398),
    [anon_sym_symbol] = ACTIONS(1398),
    [anon_sym_abstract] = ACTIONS(1398),
    [anon_sym_interface] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [sym__automatic_semicolon] = ACTIONS(1404),
    [sym__ternary_qmark] = ACTIONS(1402),
  },
  [146] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1594),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3658),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3649),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1406),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_export] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1412),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_type] = ACTIONS(1410),
    [anon_sym_as] = ACTIONS(1412),
    [anon_sym_namespace] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_COMMA] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_typeof] = ACTIONS(1410),
    [anon_sym_import] = ACTIONS(1410),
    [anon_sym_var] = ACTIONS(1410),
    [anon_sym_let] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1410),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_await] = ACTIONS(1410),
    [anon_sym_in] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_try] = ACTIONS(1410),
    [anon_sym_with] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_debugger] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_throw] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1410),
    [anon_sym_GT] = ACTIONS(1412),
    [anon_sym_SLASH] = ACTIONS(1410),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_class] = ACTIONS(1410),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_function] = ACTIONS(1410),
    [anon_sym_QMARK_DOT] = ACTIONS(1414),
    [anon_sym_new] = ACTIONS(1410),
    [anon_sym_AMP_AMP] = ACTIONS(1414),
    [anon_sym_PIPE_PIPE] = ACTIONS(1414),
    [anon_sym_GT_GT] = ACTIONS(1412),
    [anon_sym_GT_GT_GT] = ACTIONS(1414),
    [anon_sym_LT_LT] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(1412),
    [anon_sym_CARET] = ACTIONS(1414),
    [anon_sym_PIPE] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_PERCENT] = ACTIONS(1414),
    [anon_sym_STAR_STAR] = ACTIONS(1414),
    [anon_sym_LT_EQ] = ACTIONS(1414),
    [anon_sym_EQ_EQ] = ACTIONS(1412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1414),
    [anon_sym_BANG_EQ] = ACTIONS(1412),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1414),
    [anon_sym_GT_EQ] = ACTIONS(1414),
    [anon_sym_QMARK_QMARK] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_readonly] = ACTIONS(1410),
    [anon_sym_get] = ACTIONS(1410),
    [anon_sym_set] = ACTIONS(1410),
    [anon_sym_declare] = ACTIONS(1410),
    [anon_sym_public] = ACTIONS(1410),
    [anon_sym_private] = ACTIONS(1410),
    [anon_sym_protected] = ACTIONS(1410),
    [anon_sym_override] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(1410),
    [anon_sym_any] = ACTIONS(1410),
    [anon_sym_number] = ACTIONS(1410),
    [anon_sym_boolean] = ACTIONS(1410),
    [anon_sym_string] = ACTIONS(1410),
    [anon_sym_symbol] = ACTIONS(1410),
    [anon_sym_abstract] = ACTIONS(1410),
    [anon_sym_interface] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [sym__automatic_semicolon] = ACTIONS(1416),
    [sym__ternary_qmark] = ACTIONS(1414),
  },
  [148] = {
    [sym_import] = STATE(1762),
    [sym_expression_statement] = STATE(208),
    [sym_variable_declaration] = STATE(208),
    [sym_lexical_declaration] = STATE(208),
    [sym_empty_statement] = STATE(208),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(3736),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(3736),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1128),
    [sym_subscript_expression] = STATE(1128),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(3736),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_var] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_readonly] = ACTIONS(1420),
    [anon_sym_get] = ACTIONS(1420),
    [anon_sym_set] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1420),
    [anon_sym_private] = ACTIONS(1420),
    [anon_sym_protected] = ACTIONS(1420),
    [anon_sym_override] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_any] = ACTIONS(1420),
    [anon_sym_number] = ACTIONS(1420),
    [anon_sym_boolean] = ACTIONS(1420),
    [anon_sym_string] = ACTIONS(1420),
    [anon_sym_symbol] = ACTIONS(1420),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_identifier] = ACTIONS(1438),
    [anon_sym_export] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1440),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_type] = ACTIONS(1438),
    [anon_sym_as] = ACTIONS(1440),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_import] = ACTIONS(1438),
    [anon_sym_var] = ACTIONS(1438),
    [anon_sym_let] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [anon_sym_await] = ACTIONS(1438),
    [anon_sym_in] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(1438),
    [anon_sym_with] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_debugger] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_throw] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_yield] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1438),
    [anon_sym_GT] = ACTIONS(1440),
    [anon_sym_SLASH] = ACTIONS(1438),
    [anon_sym_DOT] = ACTIONS(1440),
    [anon_sym_class] = ACTIONS(1438),
    [anon_sym_async] = ACTIONS(1438),
    [anon_sym_function] = ACTIONS(1438),
    [anon_sym_QMARK_DOT] = ACTIONS(1442),
    [anon_sym_new] = ACTIONS(1438),
    [anon_sym_AMP_AMP] = ACTIONS(1442),
    [anon_sym_PIPE_PIPE] = ACTIONS(1442),
    [anon_sym_GT_GT] = ACTIONS(1440),
    [anon_sym_GT_GT_GT] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(1442),
    [anon_sym_AMP] = ACTIONS(1440),
    [anon_sym_CARET] = ACTIONS(1442),
    [anon_sym_PIPE] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_PERCENT] = ACTIONS(1442),
    [anon_sym_STAR_STAR] = ACTIONS(1442),
    [anon_sym_LT_EQ] = ACTIONS(1442),
    [anon_sym_EQ_EQ] = ACTIONS(1440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1442),
    [anon_sym_BANG_EQ] = ACTIONS(1440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1442),
    [anon_sym_GT_EQ] = ACTIONS(1442),
    [anon_sym_QMARK_QMARK] = ACTIONS(1442),
    [anon_sym_instanceof] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1438),
    [anon_sym_delete] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [sym_number] = ACTIONS(1436),
    [sym_this] = ACTIONS(1438),
    [sym_super] = ACTIONS(1438),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [sym_null] = ACTIONS(1438),
    [sym_undefined] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_readonly] = ACTIONS(1438),
    [anon_sym_get] = ACTIONS(1438),
    [anon_sym_set] = ACTIONS(1438),
    [anon_sym_declare] = ACTIONS(1438),
    [anon_sym_public] = ACTIONS(1438),
    [anon_sym_private] = ACTIONS(1438),
    [anon_sym_protected] = ACTIONS(1438),
    [anon_sym_override] = ACTIONS(1438),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_any] = ACTIONS(1438),
    [anon_sym_number] = ACTIONS(1438),
    [anon_sym_boolean] = ACTIONS(1438),
    [anon_sym_string] = ACTIONS(1438),
    [anon_sym_symbol] = ACTIONS(1438),
    [anon_sym_abstract] = ACTIONS(1438),
    [anon_sym_interface] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [sym__automatic_semicolon] = ACTIONS(1444),
    [sym__ternary_qmark] = ACTIONS(1442),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_STAR] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_as] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_COMMA] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_typeof] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(1448),
    [anon_sym_var] = ACTIONS(1448),
    [anon_sym_let] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_else] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_switch] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1448),
    [anon_sym_in] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_do] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [anon_sym_with] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_debugger] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_throw] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1448),
    [anon_sym_GT] = ACTIONS(1448),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_DOT] = ACTIONS(1448),
    [anon_sym_class] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_function] = ACTIONS(1448),
    [anon_sym_QMARK_DOT] = ACTIONS(1446),
    [anon_sym_new] = ACTIONS(1448),
    [anon_sym_AMP_AMP] = ACTIONS(1446),
    [anon_sym_PIPE_PIPE] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1448),
    [anon_sym_GT_GT_GT] = ACTIONS(1446),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_AMP] = ACTIONS(1448),
    [anon_sym_CARET] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_PERCENT] = ACTIONS(1446),
    [anon_sym_STAR_STAR] = ACTIONS(1446),
    [anon_sym_LT_EQ] = ACTIONS(1446),
    [anon_sym_EQ_EQ] = ACTIONS(1448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1446),
    [anon_sym_BANG_EQ] = ACTIONS(1448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1446),
    [anon_sym_GT_EQ] = ACTIONS(1446),
    [anon_sym_QMARK_QMARK] = ACTIONS(1446),
    [anon_sym_instanceof] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1448),
    [anon_sym_delete] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [sym_number] = ACTIONS(1446),
    [sym_this] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_true] = ACTIONS(1448),
    [sym_false] = ACTIONS(1448),
    [sym_null] = ACTIONS(1448),
    [sym_undefined] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_readonly] = ACTIONS(1448),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_override] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [anon_sym_abstract] = ACTIONS(1448),
    [anon_sym_interface] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
    [sym__automatic_semicolon] = ACTIONS(1446),
    [sym__ternary_qmark] = ACTIONS(1446),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_export] = ACTIONS(1452),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(1454),
    [anon_sym_namespace] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_COMMA] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_typeof] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_var] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_else] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_switch] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_await] = ACTIONS(1452),
    [anon_sym_in] = ACTIONS(1454),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_do] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_with] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_debugger] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_throw] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_LT] = ACTIONS(1452),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_DOT] = ACTIONS(1454),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(1452),
    [anon_sym_QMARK_DOT] = ACTIONS(1456),
    [anon_sym_new] = ACTIONS(1452),
    [anon_sym_AMP_AMP] = ACTIONS(1456),
    [anon_sym_PIPE_PIPE] = ACTIONS(1456),
    [anon_sym_GT_GT] = ACTIONS(1454),
    [anon_sym_GT_GT_GT] = ACTIONS(1456),
    [anon_sym_LT_LT] = ACTIONS(1456),
    [anon_sym_AMP] = ACTIONS(1454),
    [anon_sym_CARET] = ACTIONS(1456),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_PERCENT] = ACTIONS(1456),
    [anon_sym_STAR_STAR] = ACTIONS(1456),
    [anon_sym_LT_EQ] = ACTIONS(1456),
    [anon_sym_EQ_EQ] = ACTIONS(1454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1456),
    [anon_sym_BANG_EQ] = ACTIONS(1454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1456),
    [anon_sym_GT_EQ] = ACTIONS(1456),
    [anon_sym_QMARK_QMARK] = ACTIONS(1456),
    [anon_sym_instanceof] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_void] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_number] = ACTIONS(1450),
    [sym_this] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_readonly] = ACTIONS(1452),
    [anon_sym_get] = ACTIONS(1452),
    [anon_sym_set] = ACTIONS(1452),
    [anon_sym_declare] = ACTIONS(1452),
    [anon_sym_public] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym_protected] = ACTIONS(1452),
    [anon_sym_override] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(1452),
    [anon_sym_any] = ACTIONS(1452),
    [anon_sym_number] = ACTIONS(1452),
    [anon_sym_boolean] = ACTIONS(1452),
    [anon_sym_string] = ACTIONS(1452),
    [anon_sym_symbol] = ACTIONS(1452),
    [anon_sym_abstract] = ACTIONS(1452),
    [anon_sym_interface] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [sym__automatic_semicolon] = ACTIONS(1458),
    [sym__ternary_qmark] = ACTIONS(1456),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1464),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_as] = ACTIONS(1464),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_COMMA] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1460),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_in] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_with] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LT] = ACTIONS(1462),
    [anon_sym_GT] = ACTIONS(1464),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [anon_sym_QMARK_DOT] = ACTIONS(1466),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_AMP_AMP] = ACTIONS(1466),
    [anon_sym_PIPE_PIPE] = ACTIONS(1466),
    [anon_sym_GT_GT] = ACTIONS(1464),
    [anon_sym_GT_GT_GT] = ACTIONS(1466),
    [anon_sym_LT_LT] = ACTIONS(1466),
    [anon_sym_AMP] = ACTIONS(1464),
    [anon_sym_CARET] = ACTIONS(1466),
    [anon_sym_PIPE] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_PERCENT] = ACTIONS(1466),
    [anon_sym_STAR_STAR] = ACTIONS(1466),
    [anon_sym_LT_EQ] = ACTIONS(1466),
    [anon_sym_EQ_EQ] = ACTIONS(1464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1466),
    [anon_sym_BANG_EQ] = ACTIONS(1464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1466),
    [anon_sym_GT_EQ] = ACTIONS(1466),
    [anon_sym_QMARK_QMARK] = ACTIONS(1466),
    [anon_sym_instanceof] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [sym_number] = ACTIONS(1460),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_readonly] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_override] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [sym__automatic_semicolon] = ACTIONS(1468),
    [sym__ternary_qmark] = ACTIONS(1466),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(1472),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_as] = ACTIONS(1474),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_in] = ACTIONS(1474),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_debugger] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1472),
    [anon_sym_GT] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_DOT] = ACTIONS(1474),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_QMARK_DOT] = ACTIONS(1476),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_AMP_AMP] = ACTIONS(1476),
    [anon_sym_PIPE_PIPE] = ACTIONS(1476),
    [anon_sym_GT_GT] = ACTIONS(1474),
    [anon_sym_GT_GT_GT] = ACTIONS(1476),
    [anon_sym_LT_LT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1474),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_PERCENT] = ACTIONS(1476),
    [anon_sym_STAR_STAR] = ACTIONS(1476),
    [anon_sym_LT_EQ] = ACTIONS(1476),
    [anon_sym_EQ_EQ] = ACTIONS(1474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1476),
    [anon_sym_BANG_EQ] = ACTIONS(1474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1476),
    [anon_sym_GT_EQ] = ACTIONS(1476),
    [anon_sym_QMARK_QMARK] = ACTIONS(1476),
    [anon_sym_instanceof] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1472),
    [anon_sym_delete] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1470),
    [sym_number] = ACTIONS(1470),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_readonly] = ACTIONS(1472),
    [anon_sym_get] = ACTIONS(1472),
    [anon_sym_set] = ACTIONS(1472),
    [anon_sym_declare] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1472),
    [anon_sym_number] = ACTIONS(1472),
    [anon_sym_boolean] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(1472),
    [anon_sym_symbol] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [sym__automatic_semicolon] = ACTIONS(1478),
    [sym__ternary_qmark] = ACTIONS(1476),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_DOT] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_QMARK_DOT] = ACTIONS(1344),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1344),
    [anon_sym_PIPE_PIPE] = ACTIONS(1344),
    [anon_sym_GT_GT] = ACTIONS(1346),
    [anon_sym_GT_GT_GT] = ACTIONS(1344),
    [anon_sym_LT_LT] = ACTIONS(1344),
    [anon_sym_AMP] = ACTIONS(1346),
    [anon_sym_CARET] = ACTIONS(1344),
    [anon_sym_PIPE] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1344),
    [anon_sym_STAR_STAR] = ACTIONS(1344),
    [anon_sym_LT_EQ] = ACTIONS(1344),
    [anon_sym_EQ_EQ] = ACTIONS(1346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1344),
    [anon_sym_BANG_EQ] = ACTIONS(1346),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1344),
    [anon_sym_GT_EQ] = ACTIONS(1344),
    [anon_sym_QMARK_QMARK] = ACTIONS(1344),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1480),
    [sym__ternary_qmark] = ACTIONS(1344),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_export] = ACTIONS(1484),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_type] = ACTIONS(1484),
    [anon_sym_as] = ACTIONS(1484),
    [anon_sym_namespace] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_COMMA] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_import] = ACTIONS(1484),
    [anon_sym_var] = ACTIONS(1484),
    [anon_sym_let] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [anon_sym_await] = ACTIONS(1484),
    [anon_sym_in] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_try] = ACTIONS(1484),
    [anon_sym_with] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_debugger] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_yield] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1484),
    [anon_sym_GT] = ACTIONS(1484),
    [anon_sym_SLASH] = ACTIONS(1484),
    [anon_sym_DOT] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1484),
    [anon_sym_async] = ACTIONS(1484),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_QMARK_DOT] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1484),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_GT_GT] = ACTIONS(1484),
    [anon_sym_GT_GT_GT] = ACTIONS(1482),
    [anon_sym_LT_LT] = ACTIONS(1482),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_CARET] = ACTIONS(1482),
    [anon_sym_PIPE] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_PERCENT] = ACTIONS(1482),
    [anon_sym_STAR_STAR] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1482),
    [anon_sym_BANG_EQ] = ACTIONS(1484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_QMARK_QMARK] = ACTIONS(1482),
    [anon_sym_instanceof] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_void] = ACTIONS(1484),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1482),
    [sym_number] = ACTIONS(1482),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_undefined] = ACTIONS(1484),
    [anon_sym_AT] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_readonly] = ACTIONS(1484),
    [anon_sym_get] = ACTIONS(1484),
    [anon_sym_set] = ACTIONS(1484),
    [anon_sym_declare] = ACTIONS(1484),
    [anon_sym_public] = ACTIONS(1484),
    [anon_sym_private] = ACTIONS(1484),
    [anon_sym_protected] = ACTIONS(1484),
    [anon_sym_override] = ACTIONS(1484),
    [anon_sym_module] = ACTIONS(1484),
    [anon_sym_any] = ACTIONS(1484),
    [anon_sym_number] = ACTIONS(1484),
    [anon_sym_boolean] = ACTIONS(1484),
    [anon_sym_string] = ACTIONS(1484),
    [anon_sym_symbol] = ACTIONS(1484),
    [anon_sym_abstract] = ACTIONS(1484),
    [anon_sym_interface] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
    [sym__automatic_semicolon] = ACTIONS(1482),
    [sym__ternary_qmark] = ACTIONS(1482),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_type] = ACTIONS(1488),
    [anon_sym_as] = ACTIONS(1488),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [anon_sym_let] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1488),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_debugger] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_DOT] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_QMARK_DOT] = ACTIONS(1486),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_GT_GT] = ACTIONS(1488),
    [anon_sym_GT_GT_GT] = ACTIONS(1486),
    [anon_sym_LT_LT] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PERCENT] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1486),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_QMARK_QMARK] = ACTIONS(1486),
    [anon_sym_instanceof] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1488),
    [anon_sym_delete] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1488),
    [sym_super] = ACTIONS(1488),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [sym_null] = ACTIONS(1488),
    [sym_undefined] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_readonly] = ACTIONS(1488),
    [anon_sym_get] = ACTIONS(1488),
    [anon_sym_set] = ACTIONS(1488),
    [anon_sym_declare] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_protected] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_module] = ACTIONS(1488),
    [anon_sym_any] = ACTIONS(1488),
    [anon_sym_number] = ACTIONS(1488),
    [anon_sym_boolean] = ACTIONS(1488),
    [anon_sym_string] = ACTIONS(1488),
    [anon_sym_symbol] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [sym__automatic_semicolon] = ACTIONS(1486),
    [sym__ternary_qmark] = ACTIONS(1486),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1492),
    [anon_sym_STAR] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(1492),
    [anon_sym_as] = ACTIONS(1492),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_var] = ACTIONS(1492),
    [anon_sym_let] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(1492),
    [anon_sym_in] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_debugger] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_throw] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_LT] = ACTIONS(1492),
    [anon_sym_GT] = ACTIONS(1492),
    [anon_sym_SLASH] = ACTIONS(1492),
    [anon_sym_DOT] = ACTIONS(1492),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_QMARK_DOT] = ACTIONS(1490),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_AMP_AMP] = ACTIONS(1490),
    [anon_sym_PIPE_PIPE] = ACTIONS(1490),
    [anon_sym_GT_GT] = ACTIONS(1492),
    [anon_sym_GT_GT_GT] = ACTIONS(1490),
    [anon_sym_LT_LT] = ACTIONS(1490),
    [anon_sym_AMP] = ACTIONS(1492),
    [anon_sym_CARET] = ACTIONS(1490),
    [anon_sym_PIPE] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_PERCENT] = ACTIONS(1490),
    [anon_sym_STAR_STAR] = ACTIONS(1490),
    [anon_sym_LT_EQ] = ACTIONS(1490),
    [anon_sym_EQ_EQ] = ACTIONS(1492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1490),
    [anon_sym_BANG_EQ] = ACTIONS(1492),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1490),
    [anon_sym_GT_EQ] = ACTIONS(1490),
    [anon_sym_QMARK_QMARK] = ACTIONS(1490),
    [anon_sym_instanceof] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_void] = ACTIONS(1492),
    [anon_sym_delete] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [sym_number] = ACTIONS(1490),
    [sym_this] = ACTIONS(1492),
    [sym_super] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_undefined] = ACTIONS(1492),
    [anon_sym_AT] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_readonly] = ACTIONS(1492),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_declare] = ACTIONS(1492),
    [anon_sym_public] = ACTIONS(1492),
    [anon_sym_private] = ACTIONS(1492),
    [anon_sym_protected] = ACTIONS(1492),
    [anon_sym_override] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(1492),
    [anon_sym_any] = ACTIONS(1492),
    [anon_sym_number] = ACTIONS(1492),
    [anon_sym_boolean] = ACTIONS(1492),
    [anon_sym_string] = ACTIONS(1492),
    [anon_sym_symbol] = ACTIONS(1492),
    [anon_sym_abstract] = ACTIONS(1492),
    [anon_sym_interface] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [sym__automatic_semicolon] = ACTIONS(1490),
    [sym__ternary_qmark] = ACTIONS(1490),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1496),
    [anon_sym_export] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_type] = ACTIONS(1496),
    [anon_sym_as] = ACTIONS(1496),
    [anon_sym_namespace] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [anon_sym_typeof] = ACTIONS(1496),
    [anon_sym_import] = ACTIONS(1496),
    [anon_sym_var] = ACTIONS(1496),
    [anon_sym_let] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1496),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1496),
    [anon_sym_in] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_try] = ACTIONS(1496),
    [anon_sym_with] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_debugger] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_throw] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1496),
    [anon_sym_GT] = ACTIONS(1496),
    [anon_sym_SLASH] = ACTIONS(1496),
    [anon_sym_DOT] = ACTIONS(1496),
    [anon_sym_class] = ACTIONS(1496),
    [anon_sym_async] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(1496),
    [anon_sym_QMARK_DOT] = ACTIONS(1494),
    [anon_sym_new] = ACTIONS(1496),
    [anon_sym_AMP_AMP] = ACTIONS(1494),
    [anon_sym_PIPE_PIPE] = ACTIONS(1494),
    [anon_sym_GT_GT] = ACTIONS(1496),
    [anon_sym_GT_GT_GT] = ACTIONS(1494),
    [anon_sym_LT_LT] = ACTIONS(1494),
    [anon_sym_AMP] = ACTIONS(1496),
    [anon_sym_CARET] = ACTIONS(1494),
    [anon_sym_PIPE] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_PERCENT] = ACTIONS(1494),
    [anon_sym_STAR_STAR] = ACTIONS(1494),
    [anon_sym_LT_EQ] = ACTIONS(1494),
    [anon_sym_EQ_EQ] = ACTIONS(1496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1494),
    [anon_sym_BANG_EQ] = ACTIONS(1496),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1494),
    [anon_sym_GT_EQ] = ACTIONS(1494),
    [anon_sym_QMARK_QMARK] = ACTIONS(1494),
    [anon_sym_instanceof] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1496),
    [anon_sym_delete] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [sym_number] = ACTIONS(1494),
    [sym_this] = ACTIONS(1496),
    [sym_super] = ACTIONS(1496),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [sym_null] = ACTIONS(1496),
    [sym_undefined] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_readonly] = ACTIONS(1496),
    [anon_sym_get] = ACTIONS(1496),
    [anon_sym_set] = ACTIONS(1496),
    [anon_sym_declare] = ACTIONS(1496),
    [anon_sym_public] = ACTIONS(1496),
    [anon_sym_private] = ACTIONS(1496),
    [anon_sym_protected] = ACTIONS(1496),
    [anon_sym_override] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1496),
    [anon_sym_number] = ACTIONS(1496),
    [anon_sym_boolean] = ACTIONS(1496),
    [anon_sym_string] = ACTIONS(1496),
    [anon_sym_symbol] = ACTIONS(1496),
    [anon_sym_abstract] = ACTIONS(1496),
    [anon_sym_interface] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [sym__automatic_semicolon] = ACTIONS(1494),
    [sym__ternary_qmark] = ACTIONS(1494),
  },
  [159] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1498),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [160] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_type] = ACTIONS(1488),
    [anon_sym_as] = ACTIONS(1488),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [anon_sym_let] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1488),
    [anon_sym_in] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_debugger] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1488),
    [anon_sym_GT] = ACTIONS(1488),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_DOT] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_QMARK_DOT] = ACTIONS(1486),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_AMP_AMP] = ACTIONS(1486),
    [anon_sym_PIPE_PIPE] = ACTIONS(1486),
    [anon_sym_GT_GT] = ACTIONS(1488),
    [anon_sym_GT_GT_GT] = ACTIONS(1486),
    [anon_sym_LT_LT] = ACTIONS(1486),
    [anon_sym_AMP] = ACTIONS(1488),
    [anon_sym_CARET] = ACTIONS(1486),
    [anon_sym_PIPE] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_PERCENT] = ACTIONS(1486),
    [anon_sym_STAR_STAR] = ACTIONS(1486),
    [anon_sym_LT_EQ] = ACTIONS(1486),
    [anon_sym_EQ_EQ] = ACTIONS(1488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1486),
    [anon_sym_GT_EQ] = ACTIONS(1486),
    [anon_sym_QMARK_QMARK] = ACTIONS(1486),
    [anon_sym_instanceof] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1488),
    [anon_sym_delete] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1488),
    [sym_super] = ACTIONS(1488),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [sym_null] = ACTIONS(1488),
    [sym_undefined] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_readonly] = ACTIONS(1488),
    [anon_sym_get] = ACTIONS(1488),
    [anon_sym_set] = ACTIONS(1488),
    [anon_sym_declare] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_protected] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_module] = ACTIONS(1488),
    [anon_sym_any] = ACTIONS(1488),
    [anon_sym_number] = ACTIONS(1488),
    [anon_sym_boolean] = ACTIONS(1488),
    [anon_sym_string] = ACTIONS(1488),
    [anon_sym_symbol] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [sym__automatic_semicolon] = ACTIONS(1502),
    [sym__ternary_qmark] = ACTIONS(1486),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(1504),
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_export] = ACTIONS(1506),
    [anon_sym_STAR] = ACTIONS(1508),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_as] = ACTIONS(1508),
    [anon_sym_namespace] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(1506),
    [anon_sym_var] = ACTIONS(1506),
    [anon_sym_let] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_await] = ACTIONS(1506),
    [anon_sym_in] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1506),
    [anon_sym_with] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_debugger] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_throw] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_yield] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_LT] = ACTIONS(1506),
    [anon_sym_GT] = ACTIONS(1508),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_DOT] = ACTIONS(1508),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1506),
    [anon_sym_QMARK_DOT] = ACTIONS(1510),
    [anon_sym_new] = ACTIONS(1506),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_GT_GT] = ACTIONS(1508),
    [anon_sym_GT_GT_GT] = ACTIONS(1510),
    [anon_sym_LT_LT] = ACTIONS(1510),
    [anon_sym_AMP] = ACTIONS(1508),
    [anon_sym_CARET] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1508),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1508),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1510),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_QMARK_QMARK] = ACTIONS(1510),
    [anon_sym_instanceof] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [sym_number] = ACTIONS(1504),
    [sym_this] = ACTIONS(1506),
    [sym_super] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [sym_undefined] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_readonly] = ACTIONS(1506),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_declare] = ACTIONS(1506),
    [anon_sym_public] = ACTIONS(1506),
    [anon_sym_private] = ACTIONS(1506),
    [anon_sym_protected] = ACTIONS(1506),
    [anon_sym_override] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [anon_sym_any] = ACTIONS(1506),
    [anon_sym_number] = ACTIONS(1506),
    [anon_sym_boolean] = ACTIONS(1506),
    [anon_sym_string] = ACTIONS(1506),
    [anon_sym_symbol] = ACTIONS(1506),
    [anon_sym_abstract] = ACTIONS(1506),
    [anon_sym_interface] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [sym__automatic_semicolon] = ACTIONS(1512),
    [sym__ternary_qmark] = ACTIONS(1510),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_export] = ACTIONS(1516),
    [anon_sym_STAR] = ACTIONS(1518),
    [anon_sym_default] = ACTIONS(1516),
    [anon_sym_type] = ACTIONS(1516),
    [anon_sym_as] = ACTIONS(1518),
    [anon_sym_namespace] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_COMMA] = ACTIONS(1520),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_typeof] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1516),
    [anon_sym_var] = ACTIONS(1516),
    [anon_sym_let] = ACTIONS(1516),
    [anon_sym_const] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1516),
    [anon_sym_else] = ACTIONS(1516),
    [anon_sym_if] = ACTIONS(1516),
    [anon_sym_switch] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [anon_sym_await] = ACTIONS(1516),
    [anon_sym_in] = ACTIONS(1518),
    [anon_sym_while] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(1516),
    [anon_sym_with] = ACTIONS(1516),
    [anon_sym_break] = ACTIONS(1516),
    [anon_sym_continue] = ACTIONS(1516),
    [anon_sym_debugger] = ACTIONS(1516),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_throw] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1516),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1516),
    [anon_sym_GT] = ACTIONS(1518),
    [anon_sym_SLASH] = ACTIONS(1516),
    [anon_sym_DOT] = ACTIONS(1518),
    [anon_sym_class] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(1516),
    [anon_sym_QMARK_DOT] = ACTIONS(1520),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_AMP_AMP] = ACTIONS(1520),
    [anon_sym_PIPE_PIPE] = ACTIONS(1520),
    [anon_sym_GT_GT] = ACTIONS(1518),
    [anon_sym_GT_GT_GT] = ACTIONS(1520),
    [anon_sym_LT_LT] = ACTIONS(1520),
    [anon_sym_AMP] = ACTIONS(1518),
    [anon_sym_CARET] = ACTIONS(1520),
    [anon_sym_PIPE] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_PERCENT] = ACTIONS(1520),
    [anon_sym_STAR_STAR] = ACTIONS(1520),
    [anon_sym_LT_EQ] = ACTIONS(1520),
    [anon_sym_EQ_EQ] = ACTIONS(1518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1520),
    [anon_sym_BANG_EQ] = ACTIONS(1518),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1520),
    [anon_sym_GT_EQ] = ACTIONS(1520),
    [anon_sym_QMARK_QMARK] = ACTIONS(1520),
    [anon_sym_instanceof] = ACTIONS(1518),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_void] = ACTIONS(1516),
    [anon_sym_delete] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1514),
    [sym_number] = ACTIONS(1514),
    [sym_this] = ACTIONS(1516),
    [sym_super] = ACTIONS(1516),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_null] = ACTIONS(1516),
    [sym_undefined] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1516),
    [anon_sym_readonly] = ACTIONS(1516),
    [anon_sym_get] = ACTIONS(1516),
    [anon_sym_set] = ACTIONS(1516),
    [anon_sym_declare] = ACTIONS(1516),
    [anon_sym_public] = ACTIONS(1516),
    [anon_sym_private] = ACTIONS(1516),
    [anon_sym_protected] = ACTIONS(1516),
    [anon_sym_override] = ACTIONS(1516),
    [anon_sym_module] = ACTIONS(1516),
    [anon_sym_any] = ACTIONS(1516),
    [anon_sym_number] = ACTIONS(1516),
    [anon_sym_boolean] = ACTIONS(1516),
    [anon_sym_string] = ACTIONS(1516),
    [anon_sym_symbol] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1516),
    [anon_sym_interface] = ACTIONS(1516),
    [anon_sym_enum] = ACTIONS(1516),
    [sym__automatic_semicolon] = ACTIONS(1520),
    [sym__ternary_qmark] = ACTIONS(1520),
  },
  [164] = {
    [sym_import] = STATE(1762),
    [sym_expression_statement] = STATE(213),
    [sym_variable_declaration] = STATE(213),
    [sym_lexical_declaration] = STATE(213),
    [sym_empty_statement] = STATE(213),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(3736),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(3736),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1128),
    [sym_subscript_expression] = STATE(1128),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(3736),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_var] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_readonly] = ACTIONS(1420),
    [anon_sym_get] = ACTIONS(1420),
    [anon_sym_set] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1420),
    [anon_sym_private] = ACTIONS(1420),
    [anon_sym_protected] = ACTIONS(1420),
    [anon_sym_override] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_any] = ACTIONS(1420),
    [anon_sym_number] = ACTIONS(1420),
    [anon_sym_boolean] = ACTIONS(1420),
    [anon_sym_string] = ACTIONS(1420),
    [anon_sym_symbol] = ACTIONS(1420),
  },
  [165] = {
    [sym_import] = STATE(1762),
    [sym_expression_statement] = STATE(212),
    [sym_variable_declaration] = STATE(212),
    [sym_lexical_declaration] = STATE(212),
    [sym_empty_statement] = STATE(212),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(3736),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(3736),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1128),
    [sym_subscript_expression] = STATE(1128),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(3736),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_type] = ACTIONS(1420),
    [anon_sym_namespace] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_var] = ACTIONS(1426),
    [anon_sym_let] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1420),
    [anon_sym_readonly] = ACTIONS(1420),
    [anon_sym_get] = ACTIONS(1420),
    [anon_sym_set] = ACTIONS(1420),
    [anon_sym_declare] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1420),
    [anon_sym_private] = ACTIONS(1420),
    [anon_sym_protected] = ACTIONS(1420),
    [anon_sym_override] = ACTIONS(1420),
    [anon_sym_module] = ACTIONS(1420),
    [anon_sym_any] = ACTIONS(1420),
    [anon_sym_number] = ACTIONS(1420),
    [anon_sym_boolean] = ACTIONS(1420),
    [anon_sym_string] = ACTIONS(1420),
    [anon_sym_symbol] = ACTIONS(1420),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_as] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_in] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1524),
    [anon_sym_GT] = ACTIONS(1524),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_DOT] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_QMARK_DOT] = ACTIONS(1522),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP_AMP] = ACTIONS(1522),
    [anon_sym_PIPE_PIPE] = ACTIONS(1522),
    [anon_sym_GT_GT] = ACTIONS(1524),
    [anon_sym_GT_GT_GT] = ACTIONS(1522),
    [anon_sym_LT_LT] = ACTIONS(1522),
    [anon_sym_AMP] = ACTIONS(1524),
    [anon_sym_CARET] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_PERCENT] = ACTIONS(1522),
    [anon_sym_STAR_STAR] = ACTIONS(1522),
    [anon_sym_LT_EQ] = ACTIONS(1522),
    [anon_sym_EQ_EQ] = ACTIONS(1524),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1522),
    [anon_sym_BANG_EQ] = ACTIONS(1524),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1522),
    [anon_sym_GT_EQ] = ACTIONS(1522),
    [anon_sym_QMARK_QMARK] = ACTIONS(1522),
    [anon_sym_instanceof] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [sym_number] = ACTIONS(1522),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
    [sym__automatic_semicolon] = ACTIONS(1522),
    [sym__ternary_qmark] = ACTIONS(1522),
  },
  [167] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [168] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1549),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3635),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3637),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1376),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(1530),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_export] = ACTIONS(1532),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_default] = ACTIONS(1532),
    [anon_sym_type] = ACTIONS(1532),
    [anon_sym_as] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [anon_sym_typeof] = ACTIONS(1532),
    [anon_sym_import] = ACTIONS(1532),
    [anon_sym_var] = ACTIONS(1532),
    [anon_sym_let] = ACTIONS(1532),
    [anon_sym_const] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1532),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_if] = ACTIONS(1532),
    [anon_sym_switch] = ACTIONS(1532),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_await] = ACTIONS(1532),
    [anon_sym_in] = ACTIONS(1534),
    [anon_sym_while] = ACTIONS(1532),
    [anon_sym_do] = ACTIONS(1532),
    [anon_sym_try] = ACTIONS(1532),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_break] = ACTIONS(1532),
    [anon_sym_continue] = ACTIONS(1532),
    [anon_sym_debugger] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1532),
    [anon_sym_throw] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1532),
    [anon_sym_yield] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1530),
    [anon_sym_LT] = ACTIONS(1532),
    [anon_sym_GT] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1534),
    [anon_sym_class] = ACTIONS(1532),
    [anon_sym_async] = ACTIONS(1532),
    [anon_sym_function] = ACTIONS(1532),
    [anon_sym_QMARK_DOT] = ACTIONS(1536),
    [anon_sym_new] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1536),
    [anon_sym_PIPE_PIPE] = ACTIONS(1536),
    [anon_sym_GT_GT] = ACTIONS(1534),
    [anon_sym_GT_GT_GT] = ACTIONS(1536),
    [anon_sym_LT_LT] = ACTIONS(1536),
    [anon_sym_AMP] = ACTIONS(1534),
    [anon_sym_CARET] = ACTIONS(1536),
    [anon_sym_PIPE] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_PERCENT] = ACTIONS(1536),
    [anon_sym_STAR_STAR] = ACTIONS(1536),
    [anon_sym_LT_EQ] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1534),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1536),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1536),
    [anon_sym_GT_EQ] = ACTIONS(1536),
    [anon_sym_QMARK_QMARK] = ACTIONS(1536),
    [anon_sym_instanceof] = ACTIONS(1534),
    [anon_sym_TILDE] = ACTIONS(1530),
    [anon_sym_void] = ACTIONS(1532),
    [anon_sym_delete] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1530),
    [anon_sym_DQUOTE] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1530),
    [sym_number] = ACTIONS(1530),
    [sym_this] = ACTIONS(1532),
    [sym_super] = ACTIONS(1532),
    [sym_true] = ACTIONS(1532),
    [sym_false] = ACTIONS(1532),
    [sym_null] = ACTIONS(1532),
    [sym_undefined] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1532),
    [anon_sym_readonly] = ACTIONS(1532),
    [anon_sym_get] = ACTIONS(1532),
    [anon_sym_set] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1532),
    [anon_sym_public] = ACTIONS(1532),
    [anon_sym_private] = ACTIONS(1532),
    [anon_sym_protected] = ACTIONS(1532),
    [anon_sym_override] = ACTIONS(1532),
    [anon_sym_module] = ACTIONS(1532),
    [anon_sym_any] = ACTIONS(1532),
    [anon_sym_number] = ACTIONS(1532),
    [anon_sym_boolean] = ACTIONS(1532),
    [anon_sym_string] = ACTIONS(1532),
    [anon_sym_symbol] = ACTIONS(1532),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_interface] = ACTIONS(1532),
    [anon_sym_enum] = ACTIONS(1532),
    [sym__automatic_semicolon] = ACTIONS(1538),
    [sym__ternary_qmark] = ACTIONS(1536),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(1540),
    [sym_identifier] = ACTIONS(1542),
    [anon_sym_export] = ACTIONS(1542),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_default] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1542),
    [anon_sym_as] = ACTIONS(1544),
    [anon_sym_namespace] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_COMMA] = ACTIONS(1546),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_typeof] = ACTIONS(1542),
    [anon_sym_import] = ACTIONS(1542),
    [anon_sym_var] = ACTIONS(1542),
    [anon_sym_let] = ACTIONS(1542),
    [anon_sym_const] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_if] = ACTIONS(1542),
    [anon_sym_switch] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_while] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1542),
    [anon_sym_try] = ACTIONS(1542),
    [anon_sym_with] = ACTIONS(1542),
    [anon_sym_break] = ACTIONS(1542),
    [anon_sym_continue] = ACTIONS(1542),
    [anon_sym_debugger] = ACTIONS(1542),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_throw] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_case] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1544),
    [anon_sym_class] = ACTIONS(1542),
    [anon_sym_async] = ACTIONS(1542),
    [anon_sym_function] = ACTIONS(1542),
    [anon_sym_QMARK_DOT] = ACTIONS(1546),
    [anon_sym_new] = ACTIONS(1542),
    [anon_sym_AMP_AMP] = ACTIONS(1546),
    [anon_sym_PIPE_PIPE] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_GT_GT_GT] = ACTIONS(1546),
    [anon_sym_LT_LT] = ACTIONS(1546),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_CARET] = ACTIONS(1546),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_PERCENT] = ACTIONS(1546),
    [anon_sym_STAR_STAR] = ACTIONS(1546),
    [anon_sym_LT_EQ] = ACTIONS(1546),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1546),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1546),
    [anon_sym_GT_EQ] = ACTIONS(1546),
    [anon_sym_QMARK_QMARK] = ACTIONS(1546),
    [anon_sym_instanceof] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1542),
    [anon_sym_delete] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [sym_number] = ACTIONS(1540),
    [sym_this] = ACTIONS(1542),
    [sym_super] = ACTIONS(1542),
    [sym_true] = ACTIONS(1542),
    [sym_false] = ACTIONS(1542),
    [sym_null] = ACTIONS(1542),
    [sym_undefined] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1540),
    [anon_sym_static] = ACTIONS(1542),
    [anon_sym_readonly] = ACTIONS(1542),
    [anon_sym_get] = ACTIONS(1542),
    [anon_sym_set] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1542),
    [anon_sym_public] = ACTIONS(1542),
    [anon_sym_private] = ACTIONS(1542),
    [anon_sym_protected] = ACTIONS(1542),
    [anon_sym_override] = ACTIONS(1542),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_any] = ACTIONS(1542),
    [anon_sym_number] = ACTIONS(1542),
    [anon_sym_boolean] = ACTIONS(1542),
    [anon_sym_string] = ACTIONS(1542),
    [anon_sym_symbol] = ACTIONS(1542),
    [anon_sym_abstract] = ACTIONS(1542),
    [anon_sym_interface] = ACTIONS(1542),
    [anon_sym_enum] = ACTIONS(1542),
    [sym__automatic_semicolon] = ACTIONS(1548),
    [sym__ternary_qmark] = ACTIONS(1546),
  },
  [171] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_QMARK] = ACTIONS(1550),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [172] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym__formal_parameter] = STATE(3871),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3230),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(210),
    [sym_override_modifier] = STATE(235),
    [sym_required_parameter] = STATE(3871),
    [sym_optional_parameter] = STATE(3871),
    [sym__parameter_name] = STATE(2857),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(188),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1336),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1338),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_export] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_default] = ACTIONS(1556),
    [anon_sym_type] = ACTIONS(1556),
    [anon_sym_as] = ACTIONS(1556),
    [anon_sym_namespace] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_COMMA] = ACTIONS(1554),
    [anon_sym_RBRACE] = ACTIONS(1554),
    [anon_sym_typeof] = ACTIONS(1556),
    [anon_sym_import] = ACTIONS(1556),
    [anon_sym_var] = ACTIONS(1556),
    [anon_sym_let] = ACTIONS(1556),
    [anon_sym_const] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1556),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_if] = ACTIONS(1556),
    [anon_sym_switch] = ACTIONS(1556),
    [anon_sym_for] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_await] = ACTIONS(1556),
    [anon_sym_in] = ACTIONS(1556),
    [anon_sym_while] = ACTIONS(1556),
    [anon_sym_do] = ACTIONS(1556),
    [anon_sym_try] = ACTIONS(1556),
    [anon_sym_with] = ACTIONS(1556),
    [anon_sym_break] = ACTIONS(1556),
    [anon_sym_continue] = ACTIONS(1556),
    [anon_sym_debugger] = ACTIONS(1556),
    [anon_sym_return] = ACTIONS(1556),
    [anon_sym_throw] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1554),
    [anon_sym_case] = ACTIONS(1556),
    [anon_sym_yield] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_LT] = ACTIONS(1556),
    [anon_sym_GT] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_DOT] = ACTIONS(1556),
    [anon_sym_class] = ACTIONS(1556),
    [anon_sym_async] = ACTIONS(1556),
    [anon_sym_function] = ACTIONS(1556),
    [anon_sym_QMARK_DOT] = ACTIONS(1554),
    [anon_sym_new] = ACTIONS(1556),
    [anon_sym_AMP_AMP] = ACTIONS(1554),
    [anon_sym_PIPE_PIPE] = ACTIONS(1554),
    [anon_sym_GT_GT] = ACTIONS(1556),
    [anon_sym_GT_GT_GT] = ACTIONS(1554),
    [anon_sym_LT_LT] = ACTIONS(1554),
    [anon_sym_AMP] = ACTIONS(1556),
    [anon_sym_CARET] = ACTIONS(1554),
    [anon_sym_PIPE] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_PERCENT] = ACTIONS(1554),
    [anon_sym_STAR_STAR] = ACTIONS(1554),
    [anon_sym_LT_EQ] = ACTIONS(1554),
    [anon_sym_EQ_EQ] = ACTIONS(1556),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1554),
    [anon_sym_BANG_EQ] = ACTIONS(1556),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1554),
    [anon_sym_GT_EQ] = ACTIONS(1554),
    [anon_sym_QMARK_QMARK] = ACTIONS(1554),
    [anon_sym_instanceof] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1556),
    [anon_sym_delete] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1554),
    [anon_sym_DASH_DASH] = ACTIONS(1554),
    [anon_sym_DQUOTE] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1554),
    [sym_number] = ACTIONS(1554),
    [sym_this] = ACTIONS(1556),
    [sym_super] = ACTIONS(1556),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1556),
    [anon_sym_readonly] = ACTIONS(1556),
    [anon_sym_get] = ACTIONS(1556),
    [anon_sym_set] = ACTIONS(1556),
    [anon_sym_declare] = ACTIONS(1556),
    [anon_sym_public] = ACTIONS(1556),
    [anon_sym_private] = ACTIONS(1556),
    [anon_sym_protected] = ACTIONS(1556),
    [anon_sym_override] = ACTIONS(1556),
    [anon_sym_module] = ACTIONS(1556),
    [anon_sym_any] = ACTIONS(1556),
    [anon_sym_number] = ACTIONS(1556),
    [anon_sym_boolean] = ACTIONS(1556),
    [anon_sym_string] = ACTIONS(1556),
    [anon_sym_symbol] = ACTIONS(1556),
    [anon_sym_abstract] = ACTIONS(1556),
    [anon_sym_interface] = ACTIONS(1556),
    [anon_sym_enum] = ACTIONS(1556),
    [sym__automatic_semicolon] = ACTIONS(1554),
    [sym__ternary_qmark] = ACTIONS(1554),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1562),
    [anon_sym_default] = ACTIONS(1560),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_as] = ACTIONS(1562),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_typeof] = ACTIONS(1560),
    [anon_sym_import] = ACTIONS(1560),
    [anon_sym_var] = ACTIONS(1560),
    [anon_sym_let] = ACTIONS(1560),
    [anon_sym_const] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1560),
    [anon_sym_else] = ACTIONS(1560),
    [anon_sym_if] = ACTIONS(1560),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_for] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1558),
    [anon_sym_await] = ACTIONS(1560),
    [anon_sym_in] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(1560),
    [anon_sym_do] = ACTIONS(1560),
    [anon_sym_try] = ACTIONS(1560),
    [anon_sym_with] = ACTIONS(1560),
    [anon_sym_break] = ACTIONS(1560),
    [anon_sym_continue] = ACTIONS(1560),
    [anon_sym_debugger] = ACTIONS(1560),
    [anon_sym_return] = ACTIONS(1560),
    [anon_sym_throw] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1558),
    [anon_sym_case] = ACTIONS(1560),
    [anon_sym_yield] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1560),
    [anon_sym_GT] = ACTIONS(1562),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_DOT] = ACTIONS(1562),
    [anon_sym_class] = ACTIONS(1560),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_function] = ACTIONS(1560),
    [anon_sym_QMARK_DOT] = ACTIONS(1564),
    [anon_sym_new] = ACTIONS(1560),
    [anon_sym_AMP_AMP] = ACTIONS(1564),
    [anon_sym_PIPE_PIPE] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1562),
    [anon_sym_GT_GT_GT] = ACTIONS(1564),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_AMP] = ACTIONS(1562),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1562),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_STAR_STAR] = ACTIONS(1564),
    [anon_sym_LT_EQ] = ACTIONS(1564),
    [anon_sym_EQ_EQ] = ACTIONS(1562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1564),
    [anon_sym_BANG_EQ] = ACTIONS(1562),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1564),
    [anon_sym_GT_EQ] = ACTIONS(1564),
    [anon_sym_QMARK_QMARK] = ACTIONS(1564),
    [anon_sym_instanceof] = ACTIONS(1562),
    [anon_sym_TILDE] = ACTIONS(1558),
    [anon_sym_void] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(1560),
    [anon_sym_PLUS_PLUS] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1558),
    [anon_sym_DQUOTE] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [sym_number] = ACTIONS(1558),
    [sym_this] = ACTIONS(1560),
    [sym_super] = ACTIONS(1560),
    [sym_true] = ACTIONS(1560),
    [sym_false] = ACTIONS(1560),
    [sym_null] = ACTIONS(1560),
    [sym_undefined] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1558),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [anon_sym_abstract] = ACTIONS(1560),
    [anon_sym_interface] = ACTIONS(1560),
    [anon_sym_enum] = ACTIONS(1560),
    [sym__automatic_semicolon] = ACTIONS(1566),
    [sym__ternary_qmark] = ACTIONS(1564),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(1568),
    [sym_identifier] = ACTIONS(1570),
    [anon_sym_export] = ACTIONS(1570),
    [anon_sym_STAR] = ACTIONS(1570),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_type] = ACTIONS(1570),
    [anon_sym_as] = ACTIONS(1570),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1568),
    [anon_sym_COMMA] = ACTIONS(1568),
    [anon_sym_RBRACE] = ACTIONS(1568),
    [anon_sym_typeof] = ACTIONS(1570),
    [anon_sym_import] = ACTIONS(1570),
    [anon_sym_var] = ACTIONS(1570),
    [anon_sym_let] = ACTIONS(1570),
    [anon_sym_const] = ACTIONS(1570),
    [anon_sym_BANG] = ACTIONS(1570),
    [anon_sym_else] = ACTIONS(1570),
    [anon_sym_if] = ACTIONS(1570),
    [anon_sym_switch] = ACTIONS(1570),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(1568),
    [anon_sym_await] = ACTIONS(1570),
    [anon_sym_in] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1570),
    [anon_sym_do] = ACTIONS(1570),
    [anon_sym_try] = ACTIONS(1570),
    [anon_sym_with] = ACTIONS(1570),
    [anon_sym_break] = ACTIONS(1570),
    [anon_sym_continue] = ACTIONS(1570),
    [anon_sym_debugger] = ACTIONS(1570),
    [anon_sym_return] = ACTIONS(1570),
    [anon_sym_throw] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1568),
    [anon_sym_case] = ACTIONS(1570),
    [anon_sym_yield] = ACTIONS(1570),
    [anon_sym_LBRACK] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(1570),
    [anon_sym_GT] = ACTIONS(1570),
    [anon_sym_SLASH] = ACTIONS(1570),
    [anon_sym_DOT] = ACTIONS(1570),
    [anon_sym_class] = ACTIONS(1570),
    [anon_sym_async] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1570),
    [anon_sym_QMARK_DOT] = ACTIONS(1568),
    [anon_sym_new] = ACTIONS(1570),
    [anon_sym_AMP_AMP] = ACTIONS(1568),
    [anon_sym_PIPE_PIPE] = ACTIONS(1568),
    [anon_sym_GT_GT] = ACTIONS(1570),
    [anon_sym_GT_GT_GT] = ACTIONS(1568),
    [anon_sym_LT_LT] = ACTIONS(1568),
    [anon_sym_AMP] = ACTIONS(1570),
    [anon_sym_CARET] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1570),
    [anon_sym_PERCENT] = ACTIONS(1568),
    [anon_sym_STAR_STAR] = ACTIONS(1568),
    [anon_sym_LT_EQ] = ACTIONS(1568),
    [anon_sym_EQ_EQ] = ACTIONS(1570),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1568),
    [anon_sym_BANG_EQ] = ACTIONS(1570),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1568),
    [anon_sym_GT_EQ] = ACTIONS(1568),
    [anon_sym_QMARK_QMARK] = ACTIONS(1568),
    [anon_sym_instanceof] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1568),
    [anon_sym_void] = ACTIONS(1570),
    [anon_sym_delete] = ACTIONS(1570),
    [anon_sym_PLUS_PLUS] = ACTIONS(1568),
    [anon_sym_DASH_DASH] = ACTIONS(1568),
    [anon_sym_DQUOTE] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1568),
    [sym_number] = ACTIONS(1568),
    [sym_this] = ACTIONS(1570),
    [sym_super] = ACTIONS(1570),
    [sym_true] = ACTIONS(1570),
    [sym_false] = ACTIONS(1570),
    [sym_null] = ACTIONS(1570),
    [sym_undefined] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(1568),
    [anon_sym_static] = ACTIONS(1570),
    [anon_sym_readonly] = ACTIONS(1570),
    [anon_sym_get] = ACTIONS(1570),
    [anon_sym_set] = ACTIONS(1570),
    [anon_sym_declare] = ACTIONS(1570),
    [anon_sym_public] = ACTIONS(1570),
    [anon_sym_private] = ACTIONS(1570),
    [anon_sym_protected] = ACTIONS(1570),
    [anon_sym_override] = ACTIONS(1570),
    [anon_sym_module] = ACTIONS(1570),
    [anon_sym_any] = ACTIONS(1570),
    [anon_sym_number] = ACTIONS(1570),
    [anon_sym_boolean] = ACTIONS(1570),
    [anon_sym_string] = ACTIONS(1570),
    [anon_sym_symbol] = ACTIONS(1570),
    [anon_sym_abstract] = ACTIONS(1570),
    [anon_sym_interface] = ACTIONS(1570),
    [anon_sym_enum] = ACTIONS(1570),
    [sym__automatic_semicolon] = ACTIONS(1568),
    [sym__ternary_qmark] = ACTIONS(1568),
  },
  [176] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1957),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(3725),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(3725),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1146),
    [sym_subscript_expression] = STATE(1146),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(3725),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1146),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_mapped_type_clause] = STATE(4060),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1572),
    [anon_sym_export] = ACTIONS(1574),
    [anon_sym_type] = ACTIONS(1574),
    [anon_sym_namespace] = ACTIONS(1576),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1586),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1574),
    [anon_sym_readonly] = ACTIONS(1574),
    [anon_sym_get] = ACTIONS(1574),
    [anon_sym_set] = ACTIONS(1574),
    [anon_sym_declare] = ACTIONS(1574),
    [anon_sym_public] = ACTIONS(1574),
    [anon_sym_private] = ACTIONS(1574),
    [anon_sym_protected] = ACTIONS(1574),
    [anon_sym_override] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [anon_sym_any] = ACTIONS(1574),
    [anon_sym_number] = ACTIONS(1574),
    [anon_sym_boolean] = ACTIONS(1574),
    [anon_sym_string] = ACTIONS(1574),
    [anon_sym_symbol] = ACTIONS(1574),
  },
  [177] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
    [anon_sym_extends] = ACTIONS(1552),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1550),
    [sym__automatic_semicolon] = ACTIONS(1550),
  },
  [178] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(4019),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3651),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3641),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1590),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [179] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(4019),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3651),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3641),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1593),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [180] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(4019),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_spread_element] = STATE(3651),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3641),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_RBRACK] = ACTIONS(1597),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [181] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_assignment_pattern] = STATE(3632),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3473),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_pattern_repeat1] = STATE(3638),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_RBRACK] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [182] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(3725),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(3725),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1146),
    [sym_subscript_expression] = STATE(1146),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(3725),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1146),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(1603),
    [anon_sym_export] = ACTIONS(1605),
    [anon_sym_type] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1582),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1605),
    [anon_sym_readonly] = ACTIONS(1605),
    [anon_sym_get] = ACTIONS(1605),
    [anon_sym_set] = ACTIONS(1605),
    [anon_sym_declare] = ACTIONS(1605),
    [anon_sym_public] = ACTIONS(1605),
    [anon_sym_private] = ACTIONS(1605),
    [anon_sym_protected] = ACTIONS(1605),
    [anon_sym_override] = ACTIONS(1605),
    [anon_sym_module] = ACTIONS(1605),
    [anon_sym_any] = ACTIONS(1605),
    [anon_sym_number] = ACTIONS(1605),
    [anon_sym_boolean] = ACTIONS(1605),
    [anon_sym_string] = ACTIONS(1605),
    [anon_sym_symbol] = ACTIONS(1605),
  },
  [183] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [184] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_assignment_pattern] = STATE(3662),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3470),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_pattern_repeat1] = STATE(3648),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_RBRACK] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [185] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_assignment_pattern] = STATE(4019),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3641),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_RBRACK] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [186] = {
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1615),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1613),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(1613),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1613),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(1613),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1615),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1615),
    [anon_sym_void] = ACTIONS(1613),
    [anon_sym_delete] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1615),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [sym_number] = ACTIONS(1615),
    [sym_this] = ACTIONS(1613),
    [sym_super] = ACTIONS(1613),
    [sym_true] = ACTIONS(1613),
    [sym_false] = ACTIONS(1613),
    [sym_null] = ACTIONS(1613),
    [sym_undefined] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [187] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [188] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3367),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_accessibility_modifier] = STATE(209),
    [sym_override_modifier] = STATE(223),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(1131),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1619),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1621),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [189] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1693),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [190] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1614),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3614),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3615),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1625),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [191] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1581),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3559),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3557),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1629),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [192] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1696),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3745),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3751),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1631),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [193] = {
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1633),
    [anon_sym_import] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1633),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1633),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_void] = ACTIONS(1633),
    [anon_sym_delete] = ACTIONS(1633),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1635),
    [sym_number] = ACTIONS(1635),
    [sym_this] = ACTIONS(1633),
    [sym_super] = ACTIONS(1633),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [sym_null] = ACTIONS(1633),
    [sym_undefined] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_readonly] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_override] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [194] = {
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_typeof] = ACTIONS(1633),
    [anon_sym_import] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1635),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_await] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_yield] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1633),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_function] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1633),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1635),
    [anon_sym_void] = ACTIONS(1633),
    [anon_sym_delete] = ACTIONS(1633),
    [anon_sym_PLUS_PLUS] = ACTIONS(1635),
    [anon_sym_DASH_DASH] = ACTIONS(1635),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1635),
    [sym_number] = ACTIONS(1635),
    [sym_this] = ACTIONS(1633),
    [sym_super] = ACTIONS(1633),
    [sym_true] = ACTIONS(1633),
    [sym_false] = ACTIONS(1633),
    [sym_null] = ACTIONS(1633),
    [sym_undefined] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_readonly] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_override] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [195] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1573),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3566),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3568),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1637),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [196] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1721),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3586),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3587),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [197] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [198] = {
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1615),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_typeof] = ACTIONS(1613),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1615),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_await] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_yield] = ACTIONS(1613),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(1613),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_class] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(1613),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_new] = ACTIONS(1613),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1615),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(1615),
    [anon_sym_void] = ACTIONS(1613),
    [anon_sym_delete] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1615),
    [anon_sym_DASH_DASH] = ACTIONS(1615),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1615),
    [sym_number] = ACTIONS(1615),
    [sym_this] = ACTIONS(1613),
    [sym_super] = ACTIONS(1613),
    [sym_true] = ACTIONS(1613),
    [sym_false] = ACTIONS(1613),
    [sym_null] = ACTIONS(1613),
    [sym_undefined] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [199] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1613),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [200] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3651),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [201] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1710),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3676),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3677),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1643),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [202] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1635),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(3605),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [aux_sym_array_repeat1] = STATE(3604),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1645),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [203] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1752),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [204] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1467),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_GT] = ACTIONS(1550),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_AMP] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
    [anon_sym_extends] = ACTIONS(1552),
  },
  [205] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1757),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2863),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2863),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1054),
    [sym_subscript_expression] = STATE(1054),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2863),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3761),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1054),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(557),
    [anon_sym_type] = ACTIONS(557),
    [anon_sym_namespace] = ACTIONS(561),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(583),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(557),
    [anon_sym_readonly] = ACTIONS(557),
    [anon_sym_get] = ACTIONS(557),
    [anon_sym_set] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(557),
    [anon_sym_public] = ACTIONS(557),
    [anon_sym_private] = ACTIONS(557),
    [anon_sym_protected] = ACTIONS(557),
    [anon_sym_override] = ACTIONS(557),
    [anon_sym_module] = ACTIONS(557),
    [anon_sym_any] = ACTIONS(557),
    [anon_sym_number] = ACTIONS(557),
    [anon_sym_boolean] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_symbol] = ACTIONS(557),
  },
  [206] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_assignment_pattern] = STATE(3792),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3761),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [207] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1928),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(4158),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4158),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1647),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [208] = {
    [sym_import] = STATE(1762),
    [sym_expression_statement] = STATE(238),
    [sym_empty_statement] = STATE(238),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [209] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3142),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_override_modifier] = STATE(216),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1651),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1653),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [210] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3375),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_override_modifier] = STATE(214),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(653),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1655),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(707),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [211] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1919),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_spread_element] = STATE(4345),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4345),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1649),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [212] = {
    [sym_import] = STATE(1762),
    [sym_expression_statement] = STATE(236),
    [sym_empty_statement] = STATE(236),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [213] = {
    [sym_import] = STATE(1762),
    [sym_expression_statement] = STATE(237),
    [sym_empty_statement] = STATE(237),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1687),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3853),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [214] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3157),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(631),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1659),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [215] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1661),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [216] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3130),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1663),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1665),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [217] = {
    [sym_export_clause] = STATE(3440),
    [sym_declaration] = STATE(654),
    [sym_namespace_import_export] = STATE(3816),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1669),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1710),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [218] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1718),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [219] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1720),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [220] = {
    [sym_import] = STATE(1574),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1752),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [221] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1724),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [222] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1726),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [223] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3137),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(1728),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1730),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [224] = {
    [sym_export_clause] = STATE(3440),
    [sym_declaration] = STATE(654),
    [sym_namespace_import_export] = STATE(3816),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1669),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1710),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [225] = {
    [sym_export_clause] = STATE(3440),
    [sym_declaration] = STATE(654),
    [sym_namespace_import_export] = STATE(3816),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1669),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1673),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1710),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [226] = {
    [sym_import] = STATE(2066),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2359),
    [sym__type_query_subscript_expression] = STATE(2378),
    [sym__type_query_call_expression] = STATE(2510),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1736),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [227] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1738),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [228] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1740),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [229] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1613),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1742),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [230] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1693),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1744),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [231] = {
    [sym_import] = STATE(1574),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1746),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [232] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1158),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(3630),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(3630),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1158),
    [sym_subscript_expression] = STATE(1158),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(3630),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1158),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1748),
    [anon_sym_export] = ACTIONS(1750),
    [anon_sym_type] = ACTIONS(1750),
    [anon_sym_namespace] = ACTIONS(1752),
    [anon_sym_LBRACE] = ACTIONS(1754),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_var] = ACTIONS(1756),
    [anon_sym_let] = ACTIONS(1758),
    [anon_sym_const] = ACTIONS(1758),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1762),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1750),
    [anon_sym_readonly] = ACTIONS(1750),
    [anon_sym_get] = ACTIONS(1750),
    [anon_sym_set] = ACTIONS(1750),
    [anon_sym_declare] = ACTIONS(1750),
    [anon_sym_public] = ACTIONS(1750),
    [anon_sym_private] = ACTIONS(1750),
    [anon_sym_protected] = ACTIONS(1750),
    [anon_sym_override] = ACTIONS(1750),
    [anon_sym_module] = ACTIONS(1750),
    [anon_sym_any] = ACTIONS(1750),
    [anon_sym_number] = ACTIONS(1750),
    [anon_sym_boolean] = ACTIONS(1750),
    [anon_sym_string] = ACTIONS(1750),
    [anon_sym_symbol] = ACTIONS(1750),
  },
  [233] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1601),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3916),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(1766),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
    [sym__automatic_semicolon] = ACTIONS(1766),
  },
  [234] = {
    [sym_import] = STATE(1574),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1467),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym__type_query_member_expression] = STATE(2326),
    [sym__type_query_subscript_expression] = STATE(2325),
    [sym__type_query_call_expression] = STATE(2349),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1768),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [235] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2919),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2919),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1058),
    [sym_subscript_expression] = STATE(1058),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2919),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_pattern] = STATE(3375),
    [sym_rest_pattern] = STATE(2859),
    [sym_non_null_expression] = STATE(1058),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(611),
    [anon_sym_export] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_namespace] = ACTIONS(116),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(653),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_readonly] = ACTIONS(1655),
    [anon_sym_get] = ACTIONS(107),
    [anon_sym_set] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(107),
    [anon_sym_public] = ACTIONS(107),
    [anon_sym_private] = ACTIONS(107),
    [anon_sym_protected] = ACTIONS(107),
    [anon_sym_override] = ACTIONS(107),
    [anon_sym_module] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(107),
    [anon_sym_number] = ACTIONS(107),
    [anon_sym_boolean] = ACTIONS(107),
    [anon_sym_string] = ACTIONS(107),
    [anon_sym_symbol] = ACTIONS(107),
  },
  [236] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1886),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4318),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1770),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [237] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1911),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4119),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1772),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [238] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1814),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4076),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [239] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1812),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4177),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [240] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1770),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1445),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [241] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1464),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [242] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1498),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1778),
    [anon_sym_export] = ACTIONS(1780),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_namespace] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1786),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_readonly] = ACTIONS(1780),
    [anon_sym_get] = ACTIONS(1780),
    [anon_sym_set] = ACTIONS(1780),
    [anon_sym_declare] = ACTIONS(1780),
    [anon_sym_public] = ACTIONS(1780),
    [anon_sym_private] = ACTIONS(1780),
    [anon_sym_protected] = ACTIONS(1780),
    [anon_sym_override] = ACTIONS(1780),
    [anon_sym_module] = ACTIONS(1780),
    [anon_sym_any] = ACTIONS(1780),
    [anon_sym_number] = ACTIONS(1780),
    [anon_sym_boolean] = ACTIONS(1780),
    [anon_sym_string] = ACTIONS(1780),
    [anon_sym_symbol] = ACTIONS(1780),
  },
  [243] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [244] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1850),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4063),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [245] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1927),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1926),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [246] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1481),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4315),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [247] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4344),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [248] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1761),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [249] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1498),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_readonly] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_override] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
  },
  [250] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1615),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(3995),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [251] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1512),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4253),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [252] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1453),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [253] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1770),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1907),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [254] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1857),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4165),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [255] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1894),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1823),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [256] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1498),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1794),
    [anon_sym_export] = ACTIONS(1796),
    [anon_sym_type] = ACTIONS(1796),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1800),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1796),
    [anon_sym_readonly] = ACTIONS(1796),
    [anon_sym_get] = ACTIONS(1796),
    [anon_sym_set] = ACTIONS(1796),
    [anon_sym_declare] = ACTIONS(1796),
    [anon_sym_public] = ACTIONS(1796),
    [anon_sym_private] = ACTIONS(1796),
    [anon_sym_protected] = ACTIONS(1796),
    [anon_sym_override] = ACTIONS(1796),
    [anon_sym_module] = ACTIONS(1796),
    [anon_sym_any] = ACTIONS(1796),
    [anon_sym_number] = ACTIONS(1796),
    [anon_sym_boolean] = ACTIONS(1796),
    [anon_sym_string] = ACTIONS(1796),
    [anon_sym_symbol] = ACTIONS(1796),
  },
  [257] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [258] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1531),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [259] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1534),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [260] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1790),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [261] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1894),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1535),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [262] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1802),
    [anon_sym_export] = ACTIONS(1804),
    [anon_sym_type] = ACTIONS(1804),
    [anon_sym_namespace] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1808),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1804),
    [anon_sym_readonly] = ACTIONS(1804),
    [anon_sym_get] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1804),
    [anon_sym_declare] = ACTIONS(1804),
    [anon_sym_public] = ACTIONS(1804),
    [anon_sym_private] = ACTIONS(1804),
    [anon_sym_protected] = ACTIONS(1804),
    [anon_sym_override] = ACTIONS(1804),
    [anon_sym_module] = ACTIONS(1804),
    [anon_sym_any] = ACTIONS(1804),
    [anon_sym_number] = ACTIONS(1804),
    [anon_sym_boolean] = ACTIONS(1804),
    [anon_sym_string] = ACTIONS(1804),
    [anon_sym_symbol] = ACTIONS(1804),
  },
  [263] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [264] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1498),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1810),
    [anon_sym_export] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_namespace] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_readonly] = ACTIONS(1812),
    [anon_sym_get] = ACTIONS(1812),
    [anon_sym_set] = ACTIONS(1812),
    [anon_sym_declare] = ACTIONS(1812),
    [anon_sym_public] = ACTIONS(1812),
    [anon_sym_private] = ACTIONS(1812),
    [anon_sym_protected] = ACTIONS(1812),
    [anon_sym_override] = ACTIONS(1812),
    [anon_sym_module] = ACTIONS(1812),
    [anon_sym_any] = ACTIONS(1812),
    [anon_sym_number] = ACTIONS(1812),
    [anon_sym_boolean] = ACTIONS(1812),
    [anon_sym_string] = ACTIONS(1812),
    [anon_sym_symbol] = ACTIONS(1812),
  },
  [265] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1413),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1711),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [266] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1770),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1521),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [267] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1701),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [268] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1498),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1810),
    [anon_sym_export] = ACTIONS(1812),
    [anon_sym_type] = ACTIONS(1812),
    [anon_sym_namespace] = ACTIONS(1814),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1816),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1812),
    [anon_sym_readonly] = ACTIONS(1812),
    [anon_sym_get] = ACTIONS(1812),
    [anon_sym_set] = ACTIONS(1812),
    [anon_sym_declare] = ACTIONS(1812),
    [anon_sym_public] = ACTIONS(1812),
    [anon_sym_private] = ACTIONS(1812),
    [anon_sym_protected] = ACTIONS(1812),
    [anon_sym_override] = ACTIONS(1812),
    [anon_sym_module] = ACTIONS(1812),
    [anon_sym_any] = ACTIONS(1812),
    [anon_sym_number] = ACTIONS(1812),
    [anon_sym_boolean] = ACTIONS(1812),
    [anon_sym_string] = ACTIONS(1812),
    [anon_sym_symbol] = ACTIONS(1812),
  },
  [269] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_export] = ACTIONS(1822),
    [anon_sym_type] = ACTIONS(1822),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1822),
    [anon_sym_readonly] = ACTIONS(1822),
    [anon_sym_get] = ACTIONS(1822),
    [anon_sym_set] = ACTIONS(1822),
    [anon_sym_declare] = ACTIONS(1822),
    [anon_sym_public] = ACTIONS(1822),
    [anon_sym_private] = ACTIONS(1822),
    [anon_sym_protected] = ACTIONS(1822),
    [anon_sym_override] = ACTIONS(1822),
    [anon_sym_module] = ACTIONS(1822),
    [anon_sym_any] = ACTIONS(1822),
    [anon_sym_number] = ACTIONS(1822),
    [anon_sym_boolean] = ACTIONS(1822),
    [anon_sym_string] = ACTIONS(1822),
    [anon_sym_symbol] = ACTIONS(1822),
  },
  [270] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1413),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1405),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [271] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1821),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4071),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [272] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1927),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1502),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [273] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1818),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4073),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [274] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1957),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_mapped_type_clause] = STATE(4060),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1828),
    [anon_sym_export] = ACTIONS(1830),
    [anon_sym_type] = ACTIONS(1830),
    [anon_sym_namespace] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1834),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1830),
    [anon_sym_readonly] = ACTIONS(1830),
    [anon_sym_get] = ACTIONS(1830),
    [anon_sym_set] = ACTIONS(1830),
    [anon_sym_declare] = ACTIONS(1830),
    [anon_sym_public] = ACTIONS(1830),
    [anon_sym_private] = ACTIONS(1830),
    [anon_sym_protected] = ACTIONS(1830),
    [anon_sym_override] = ACTIONS(1830),
    [anon_sym_module] = ACTIONS(1830),
    [anon_sym_any] = ACTIONS(1830),
    [anon_sym_number] = ACTIONS(1830),
    [anon_sym_boolean] = ACTIONS(1830),
    [anon_sym_string] = ACTIONS(1830),
    [anon_sym_symbol] = ACTIONS(1830),
  },
  [275] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3131),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3913),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_export] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_readonly] = ACTIONS(1838),
    [anon_sym_get] = ACTIONS(1838),
    [anon_sym_set] = ACTIONS(1838),
    [anon_sym_declare] = ACTIONS(1838),
    [anon_sym_public] = ACTIONS(1838),
    [anon_sym_private] = ACTIONS(1838),
    [anon_sym_protected] = ACTIONS(1838),
    [anon_sym_override] = ACTIONS(1838),
    [anon_sym_module] = ACTIONS(1838),
    [anon_sym_any] = ACTIONS(1838),
    [anon_sym_number] = ACTIONS(1838),
    [anon_sym_boolean] = ACTIONS(1838),
    [anon_sym_string] = ACTIONS(1838),
    [anon_sym_symbol] = ACTIONS(1838),
  },
  [276] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1927),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1508),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [277] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1871),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4334),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [278] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1360),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1658),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [279] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1815),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4074),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [280] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1638),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [281] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1894),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1539),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [282] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1637),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [283] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1636),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [284] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_export] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_readonly] = ACTIONS(1838),
    [anon_sym_get] = ACTIONS(1838),
    [anon_sym_set] = ACTIONS(1838),
    [anon_sym_declare] = ACTIONS(1838),
    [anon_sym_public] = ACTIONS(1838),
    [anon_sym_private] = ACTIONS(1838),
    [anon_sym_protected] = ACTIONS(1838),
    [anon_sym_override] = ACTIONS(1838),
    [anon_sym_module] = ACTIONS(1838),
    [anon_sym_any] = ACTIONS(1838),
    [anon_sym_number] = ACTIONS(1838),
    [anon_sym_boolean] = ACTIONS(1838),
    [anon_sym_string] = ACTIONS(1838),
    [anon_sym_symbol] = ACTIONS(1838),
  },
  [285] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1413),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2097),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [286] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1948),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [287] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1900),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4120),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [288] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1944),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [289] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1890),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1537),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [290] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1937),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [291] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1360),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1934),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [292] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_expression] = STATE(2052),
    [sym_primary_expression] = STATE(1498),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1100),
    [sym_subscript_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1100),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1778),
    [anon_sym_export] = ACTIONS(1780),
    [anon_sym_type] = ACTIONS(1780),
    [anon_sym_namespace] = ACTIONS(1782),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1784),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(1786),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1780),
    [anon_sym_readonly] = ACTIONS(1780),
    [anon_sym_get] = ACTIONS(1780),
    [anon_sym_set] = ACTIONS(1780),
    [anon_sym_declare] = ACTIONS(1780),
    [anon_sym_public] = ACTIONS(1780),
    [anon_sym_private] = ACTIONS(1780),
    [anon_sym_protected] = ACTIONS(1780),
    [anon_sym_override] = ACTIONS(1780),
    [anon_sym_module] = ACTIONS(1780),
    [anon_sym_any] = ACTIONS(1780),
    [anon_sym_number] = ACTIONS(1780),
    [anon_sym_boolean] = ACTIONS(1780),
    [anon_sym_string] = ACTIONS(1780),
    [anon_sym_symbol] = ACTIONS(1780),
  },
  [293] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_export] = ACTIONS(1848),
    [anon_sym_type] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_declare] = ACTIONS(1848),
    [anon_sym_public] = ACTIONS(1848),
    [anon_sym_private] = ACTIONS(1848),
    [anon_sym_protected] = ACTIONS(1848),
    [anon_sym_override] = ACTIONS(1848),
    [anon_sym_module] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
  },
  [294] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1898),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4121),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [295] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1962),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [296] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1897),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4122),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [297] = {
    [sym_import] = STATE(1762),
    [sym_statement_block] = STATE(1888),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1533),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1776),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [298] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1957),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_mapped_type_clause] = STATE(4081),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(1856),
    [anon_sym_type] = ACTIONS(1856),
    [anon_sym_namespace] = ACTIONS(1858),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1860),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1856),
    [anon_sym_readonly] = ACTIONS(1856),
    [anon_sym_get] = ACTIONS(1856),
    [anon_sym_set] = ACTIONS(1856),
    [anon_sym_declare] = ACTIONS(1856),
    [anon_sym_public] = ACTIONS(1856),
    [anon_sym_private] = ACTIONS(1856),
    [anon_sym_protected] = ACTIONS(1856),
    [anon_sym_override] = ACTIONS(1856),
    [anon_sym_module] = ACTIONS(1856),
    [anon_sym_any] = ACTIONS(1856),
    [anon_sym_number] = ACTIONS(1856),
    [anon_sym_boolean] = ACTIONS(1856),
    [anon_sym_string] = ACTIONS(1856),
    [anon_sym_symbol] = ACTIONS(1856),
  },
  [299] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1893),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4124),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [300] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1413),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1972),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [301] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1836),
    [anon_sym_export] = ACTIONS(1838),
    [anon_sym_type] = ACTIONS(1838),
    [anon_sym_namespace] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1842),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1838),
    [anon_sym_readonly] = ACTIONS(1838),
    [anon_sym_get] = ACTIONS(1838),
    [anon_sym_set] = ACTIONS(1838),
    [anon_sym_declare] = ACTIONS(1838),
    [anon_sym_public] = ACTIONS(1838),
    [anon_sym_private] = ACTIONS(1838),
    [anon_sym_protected] = ACTIONS(1838),
    [anon_sym_override] = ACTIONS(1838),
    [anon_sym_module] = ACTIONS(1838),
    [anon_sym_any] = ACTIONS(1838),
    [anon_sym_number] = ACTIONS(1838),
    [anon_sym_boolean] = ACTIONS(1838),
    [anon_sym_string] = ACTIONS(1838),
    [anon_sym_symbol] = ACTIONS(1838),
  },
  [302] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1887),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(4097),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [303] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1600),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_sequence_expression] = STATE(4024),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [304] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1332),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [305] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1820),
    [anon_sym_export] = ACTIONS(1822),
    [anon_sym_type] = ACTIONS(1822),
    [anon_sym_namespace] = ACTIONS(1824),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1826),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1822),
    [anon_sym_readonly] = ACTIONS(1822),
    [anon_sym_get] = ACTIONS(1822),
    [anon_sym_set] = ACTIONS(1822),
    [anon_sym_declare] = ACTIONS(1822),
    [anon_sym_public] = ACTIONS(1822),
    [anon_sym_private] = ACTIONS(1822),
    [anon_sym_protected] = ACTIONS(1822),
    [anon_sym_override] = ACTIONS(1822),
    [anon_sym_module] = ACTIONS(1822),
    [anon_sym_any] = ACTIONS(1822),
    [anon_sym_number] = ACTIONS(1822),
    [anon_sym_boolean] = ACTIONS(1822),
    [anon_sym_string] = ACTIONS(1822),
    [anon_sym_symbol] = ACTIONS(1822),
  },
  [306] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1380),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_sequence_expression] = STATE(3498),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [307] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1413),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1590),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [308] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [309] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1618),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [310] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1360),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1361),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [311] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1360),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1695),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [312] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2090),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [313] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1322),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [314] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2091),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [315] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2087),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [316] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1360),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [317] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1378),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [318] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1396),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [319] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1398),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1720),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [320] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1335),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2057),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [321] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1722),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [322] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1331),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1724),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [323] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_export] = ACTIONS(1848),
    [anon_sym_type] = ACTIONS(1848),
    [anon_sym_namespace] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1848),
    [anon_sym_readonly] = ACTIONS(1848),
    [anon_sym_get] = ACTIONS(1848),
    [anon_sym_set] = ACTIONS(1848),
    [anon_sym_declare] = ACTIONS(1848),
    [anon_sym_public] = ACTIONS(1848),
    [anon_sym_private] = ACTIONS(1848),
    [anon_sym_protected] = ACTIONS(1848),
    [anon_sym_override] = ACTIONS(1848),
    [anon_sym_module] = ACTIONS(1848),
    [anon_sym_any] = ACTIONS(1848),
    [anon_sym_number] = ACTIONS(1848),
    [anon_sym_boolean] = ACTIONS(1848),
    [anon_sym_string] = ACTIONS(1848),
    [anon_sym_symbol] = ACTIONS(1848),
  },
  [324] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1212),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3111),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(4015),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1802),
    [anon_sym_export] = ACTIONS(1804),
    [anon_sym_type] = ACTIONS(1804),
    [anon_sym_namespace] = ACTIONS(1806),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(1792),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1808),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1804),
    [anon_sym_readonly] = ACTIONS(1804),
    [anon_sym_get] = ACTIONS(1804),
    [anon_sym_set] = ACTIONS(1804),
    [anon_sym_declare] = ACTIONS(1804),
    [anon_sym_public] = ACTIONS(1804),
    [anon_sym_private] = ACTIONS(1804),
    [anon_sym_protected] = ACTIONS(1804),
    [anon_sym_override] = ACTIONS(1804),
    [anon_sym_module] = ACTIONS(1804),
    [anon_sym_any] = ACTIONS(1804),
    [anon_sym_number] = ACTIONS(1804),
    [anon_sym_boolean] = ACTIONS(1804),
    [anon_sym_string] = ACTIONS(1804),
    [anon_sym_symbol] = ACTIONS(1804),
  },
  [325] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1349),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [326] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1493),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [327] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2086),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [328] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [329] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2070),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [330] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1685),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [331] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1362),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [332] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1963),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [333] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1447),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [334] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2059),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [335] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1467),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [336] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1956),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [337] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1996),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [338] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1474),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [339] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2058),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [340] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2053),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [341] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2042),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [342] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1651),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [343] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1657),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [344] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1656),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [345] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1655),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [346] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1703),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [347] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2094),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [348] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1693),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [349] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [350] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1654),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [351] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1653),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [352] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1554),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [353] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2100),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [354] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1650),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [355] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2101),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [356] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2065),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [357] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2061),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [358] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1489),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [359] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2049),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [360] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2006),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [361] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1967),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [362] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1949),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [363] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1975),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [364] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [365] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2008),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [366] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2026),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [367] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1446),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [368] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2027),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [369] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1420),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [370] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2051),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [371] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1475),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [372] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1648),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [373] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1467),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1862),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [374] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1625),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [375] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1980),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [376] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1973),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [377] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [378] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1794),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [379] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1612),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [380] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [381] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1466),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [382] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1499),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [383] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2063),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [384] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1468),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [385] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1866),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [386] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1353),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [387] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1868),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [388] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1621),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [389] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1611),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [390] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [391] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2015),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [392] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1351),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [393] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1348),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [394] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1347),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [395] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1345),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [396] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1343),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [397] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1340),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [398] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1935),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [399] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1932),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [400] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1757),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [401] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1339),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [402] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1441),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [403] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1336),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [404] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1604),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [405] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [406] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1933),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [407] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1936),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [408] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1752),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1862),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [409] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1966),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [410] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1330),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [411] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1520),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [412] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1417),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [413] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1337),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [414] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1940),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [415] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1942),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [416] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1494),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [417] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1874),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [418] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1525),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [419] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1433),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [420] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1943),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [421] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1946),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [422] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1990),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [423] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1509),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [424] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(1862),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [425] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1838),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [426] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1839),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [427] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1947),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [428] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1528),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [429] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1952),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [430] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1954),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [431] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1955),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [432] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1455),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [433] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1958),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [434] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1530),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [435] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1969),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [436] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1597),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [437] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1437),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [438] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1712),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [439] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1370),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [440] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1970),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [441] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1752),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [442] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1750),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [443] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_expression] = STATE(1971),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4361),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4361),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4090),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1160),
    [sym_subscript_expression] = STATE(1160),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4361),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1160),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(913),
    [anon_sym_type] = ACTIONS(913),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(923),
    [anon_sym_yield] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(931),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_void] = ACTIONS(939),
    [anon_sym_delete] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(913),
    [anon_sym_readonly] = ACTIONS(913),
    [anon_sym_get] = ACTIONS(913),
    [anon_sym_set] = ACTIONS(913),
    [anon_sym_declare] = ACTIONS(913),
    [anon_sym_public] = ACTIONS(913),
    [anon_sym_private] = ACTIONS(913),
    [anon_sym_protected] = ACTIONS(913),
    [anon_sym_override] = ACTIONS(913),
    [anon_sym_module] = ACTIONS(913),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
  },
  [444] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1468),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(3370),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(3370),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1108),
    [sym_subscript_expression] = STATE(1108),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(3370),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1108),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1878),
    [anon_sym_export] = ACTIONS(863),
    [anon_sym_type] = ACTIONS(863),
    [anon_sym_namespace] = ACTIONS(865),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(869),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1880),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(863),
    [anon_sym_readonly] = ACTIONS(863),
    [anon_sym_get] = ACTIONS(863),
    [anon_sym_set] = ACTIONS(863),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_private] = ACTIONS(863),
    [anon_sym_protected] = ACTIONS(863),
    [anon_sym_override] = ACTIONS(863),
    [anon_sym_module] = ACTIONS(863),
    [anon_sym_any] = ACTIONS(863),
    [anon_sym_number] = ACTIONS(863),
    [anon_sym_boolean] = ACTIONS(863),
    [anon_sym_string] = ACTIONS(863),
    [anon_sym_symbol] = ACTIONS(863),
  },
  [445] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1874),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [446] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1613),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [447] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1756),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [448] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1501),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [449] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1458),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [450] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1692),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [451] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1532),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [452] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [453] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1985),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [454] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1516),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [455] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1503),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [456] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [457] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1693),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [458] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1514),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [459] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1957),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [460] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1708),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [461] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1506),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [462] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1882),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [463] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1925),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [464] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [465] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1789),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [466] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1863),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [467] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1854),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [468] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1853),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [469] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1852),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [470] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1836),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [471] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2019),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4307),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4307),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1024),
    [sym_subscript_expression] = STATE(1024),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4307),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1024),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_export] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1882),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1171),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_readonly] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_override] = ACTIONS(1045),
    [anon_sym_module] = ACTIONS(1045),
    [anon_sym_any] = ACTIONS(1045),
    [anon_sym_number] = ACTIONS(1045),
    [anon_sym_boolean] = ACTIONS(1045),
    [anon_sym_string] = ACTIONS(1045),
    [anon_sym_symbol] = ACTIONS(1045),
  },
  [472] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [473] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1715),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [474] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1811),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [475] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1805),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [476] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1874),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [477] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1440),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [478] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1024),
    [sym_expression] = STATE(2062),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(2830),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(2830),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4088),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1061),
    [sym_subscript_expression] = STATE(1061),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2388),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(2830),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1061),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1884),
    [anon_sym_export] = ACTIONS(1886),
    [anon_sym_type] = ACTIONS(1886),
    [anon_sym_namespace] = ACTIONS(1888),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_typeof] = ACTIONS(168),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1890),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_DASH] = ACTIONS(168),
    [anon_sym_TILDE] = ACTIONS(164),
    [anon_sym_void] = ACTIONS(168),
    [anon_sym_delete] = ACTIONS(168),
    [anon_sym_PLUS_PLUS] = ACTIONS(699),
    [anon_sym_DASH_DASH] = ACTIONS(699),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1886),
    [anon_sym_readonly] = ACTIONS(1886),
    [anon_sym_get] = ACTIONS(1886),
    [anon_sym_set] = ACTIONS(1886),
    [anon_sym_declare] = ACTIONS(1886),
    [anon_sym_public] = ACTIONS(1886),
    [anon_sym_private] = ACTIONS(1886),
    [anon_sym_protected] = ACTIONS(1886),
    [anon_sym_override] = ACTIONS(1886),
    [anon_sym_module] = ACTIONS(1886),
    [anon_sym_any] = ACTIONS(1886),
    [anon_sym_number] = ACTIONS(1886),
    [anon_sym_boolean] = ACTIONS(1886),
    [anon_sym_string] = ACTIONS(1886),
    [anon_sym_symbol] = ACTIONS(1886),
  },
  [479] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1706),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [480] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1959),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [481] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1702),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [482] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1688),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [483] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1448),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [484] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1517),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [485] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1781),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [486] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1766),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [487] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1995),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [488] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1491),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [489] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1449),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [490] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1402),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [491] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1760),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [492] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1924),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [493] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [494] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1671),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [495] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1548),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [496] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1452),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [497] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1490),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [498] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1659),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [499] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1660),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [500] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1662),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [501] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1976),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [502] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1664),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [503] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1527),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [504] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1699),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [505] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1755),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [506] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1454),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [507] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1725),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [508] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1434),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(1866),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [509] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1148),
    [sym_expression] = STATE(1759),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4139),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4139),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4137),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1148),
    [sym_subscript_expression] = STATE(1148),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2360),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4139),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1148),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1147),
    [anon_sym_export] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(777),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(791),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_readonly] = ACTIONS(777),
    [anon_sym_get] = ACTIONS(777),
    [anon_sym_set] = ACTIONS(777),
    [anon_sym_declare] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_override] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_any] = ACTIONS(777),
    [anon_sym_number] = ACTIONS(777),
    [anon_sym_boolean] = ACTIONS(777),
    [anon_sym_string] = ACTIONS(777),
    [anon_sym_symbol] = ACTIONS(777),
  },
  [510] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1665),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [511] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1666),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [512] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1610),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [513] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1462),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [514] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1469),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [515] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1668),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [516] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1739),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [517] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [518] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1510),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [519] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_expression] = STATE(1613),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4263),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4263),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4051),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1143),
    [sym_subscript_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2397),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4263),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1143),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1131),
    [anon_sym_export] = ACTIONS(1063),
    [anon_sym_type] = ACTIONS(1063),
    [anon_sym_namespace] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_delete] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(1087),
    [anon_sym_DASH_DASH] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_readonly] = ACTIONS(1063),
    [anon_sym_get] = ACTIONS(1063),
    [anon_sym_set] = ACTIONS(1063),
    [anon_sym_declare] = ACTIONS(1063),
    [anon_sym_public] = ACTIONS(1063),
    [anon_sym_private] = ACTIONS(1063),
    [anon_sym_protected] = ACTIONS(1063),
    [anon_sym_override] = ACTIONS(1063),
    [anon_sym_module] = ACTIONS(1063),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
  },
  [520] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1451),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [521] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_expression] = STATE(1507),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4377),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4377),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4378),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1126),
    [sym_subscript_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2385),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4377),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1126),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(829),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(67),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(19),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_void] = ACTIONS(19),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(77),
    [anon_sym_DASH_DASH] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(829),
    [anon_sym_readonly] = ACTIONS(829),
    [anon_sym_get] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(829),
    [anon_sym_declare] = ACTIONS(829),
    [anon_sym_public] = ACTIONS(829),
    [anon_sym_private] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(829),
    [anon_sym_override] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(829),
    [anon_sym_number] = ACTIONS(829),
    [anon_sym_boolean] = ACTIONS(829),
    [anon_sym_string] = ACTIONS(829),
    [anon_sym_symbol] = ACTIONS(829),
  },
  [522] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1488),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [523] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1675),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [524] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_expression] = STATE(1326),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4087),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4087),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4306),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1097),
    [sym_subscript_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2367),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4087),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1097),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(597),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(581),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(597),
    [anon_sym_DASH] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_void] = ACTIONS(597),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(599),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1113),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_readonly] = ACTIONS(757),
    [anon_sym_get] = ACTIONS(757),
    [anon_sym_set] = ACTIONS(757),
    [anon_sym_declare] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_override] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_any] = ACTIONS(757),
    [anon_sym_number] = ACTIONS(757),
    [anon_sym_boolean] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_symbol] = ACTIONS(757),
  },
  [525] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_expression] = STATE(1690),
    [sym_primary_expression] = STATE(1368),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1346),
    [sym_object_pattern] = STATE(4326),
    [sym_array] = STATE(1346),
    [sym_array_pattern] = STATE(4326),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2649),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1346),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(4261),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(1132),
    [sym_subscript_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1369),
    [sym__augmented_assignment_lhs] = STATE(2374),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym__destructuring_pattern] = STATE(4326),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3468),
    [sym_identifier] = ACTIONS(1139),
    [anon_sym_export] = ACTIONS(1011),
    [anon_sym_type] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1013),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_await] = ACTIONS(1019),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(579),
    [anon_sym_SLASH] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(142),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(146),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_void] = ACTIONS(1033),
    [anon_sym_delete] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1035),
    [anon_sym_DASH_DASH] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1111),
    [sym_number] = ACTIONS(629),
    [sym_this] = ACTIONS(183),
    [sym_super] = ACTIONS(183),
    [sym_true] = ACTIONS(183),
    [sym_false] = ACTIONS(183),
    [sym_null] = ACTIONS(183),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_readonly] = ACTIONS(1011),
    [anon_sym_get] = ACTIONS(1011),
    [anon_sym_set] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_override] = ACTIONS(1011),
    [anon_sym_module] = ACTIONS(1011),
    [anon_sym_any] = ACTIONS(1011),
    [anon_sym_number] = ACTIONS(1011),
    [anon_sym_boolean] = ACTIONS(1011),
    [anon_sym_string] = ACTIONS(1011),
    [anon_sym_symbol] = ACTIONS(1011),
  },
  [526] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1438),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [527] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1476),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [528] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1477),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [529] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1479),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [530] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1480),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [531] = {
    [sym_import] = STATE(1762),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_expression] = STATE(1483),
    [sym_primary_expression] = STATE(1773),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1762),
    [sym_object_pattern] = STATE(4335),
    [sym_array] = STATE(1762),
    [sym_array_pattern] = STATE(4335),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(2654),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_class] = STATE(1762),
    [sym_function] = STATE(1762),
    [sym_generator_function] = STATE(1762),
    [sym_arrow_function] = STATE(1762),
    [sym__call_signature] = STATE(4333),
    [sym_call_expression] = STATE(1762),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1125),
    [sym_subscript_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1777),
    [sym__augmented_assignment_lhs] = STATE(2368),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym__destructuring_pattern] = STATE(4335),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1762),
    [sym_template_string] = STATE(1762),
    [sym_regex] = STATE(1762),
    [sym_meta_property] = STATE(1762),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(3085),
    [sym_non_null_expression] = STATE(1125),
    [sym_as_expression] = STATE(1777),
    [sym_internal_module] = STATE(1777),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_export_statement_repeat1] = STATE(3443),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(901),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_LPAREN] = ACTIONS(37),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(889),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_LT] = ACTIONS(65),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(797),
    [anon_sym_async] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_void] = ACTIONS(901),
    [anon_sym_delete] = ACTIONS(901),
    [anon_sym_PLUS_PLUS] = ACTIONS(903),
    [anon_sym_DASH_DASH] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(83),
    [sym_number] = ACTIONS(85),
    [sym_this] = ACTIONS(87),
    [sym_super] = ACTIONS(87),
    [sym_true] = ACTIONS(87),
    [sym_false] = ACTIONS(87),
    [sym_null] = ACTIONS(87),
    [sym_undefined] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_readonly] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_override] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
  },
  [532] = {
    [sym_export_clause] = STATE(3440),
    [sym_declaration] = STATE(654),
    [sym_namespace_import_export] = STATE(3816),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1894),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1898),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1904),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [533] = {
    [sym_export_clause] = STATE(3440),
    [sym_declaration] = STATE(654),
    [sym_namespace_import_export] = STATE(3816),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1669),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1906),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1710),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [534] = {
    [sym_export_clause] = STATE(3440),
    [sym_declaration] = STATE(654),
    [sym_namespace_import_export] = STATE(3816),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1908),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1896),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1910),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1710),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [535] = {
    [sym__call_signature] = STATE(4308),
    [sym_string] = STATE(3022),
    [sym_formal_parameters] = STATE(3085),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_export] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1914),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_readonly] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1934),
    [anon_sym_set] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1914),
    [anon_sym_public] = ACTIONS(1914),
    [anon_sym_private] = ACTIONS(1914),
    [anon_sym_protected] = ACTIONS(1914),
    [anon_sym_override] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1914),
    [anon_sym_any] = ACTIONS(1914),
    [anon_sym_number] = ACTIONS(1914),
    [anon_sym_boolean] = ACTIONS(1914),
    [anon_sym_string] = ACTIONS(1914),
    [anon_sym_symbol] = ACTIONS(1914),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [536] = {
    [sym__call_signature] = STATE(4308),
    [sym_string] = STATE(3022),
    [sym_formal_parameters] = STATE(3085),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_export] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1914),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_readonly] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1934),
    [anon_sym_set] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1914),
    [anon_sym_public] = ACTIONS(1914),
    [anon_sym_private] = ACTIONS(1914),
    [anon_sym_protected] = ACTIONS(1914),
    [anon_sym_override] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1914),
    [anon_sym_any] = ACTIONS(1914),
    [anon_sym_number] = ACTIONS(1914),
    [anon_sym_boolean] = ACTIONS(1914),
    [anon_sym_string] = ACTIONS(1914),
    [anon_sym_symbol] = ACTIONS(1914),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [537] = {
    [sym__call_signature] = STATE(4308),
    [sym_string] = STATE(3022),
    [sym_formal_parameters] = STATE(3085),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [sym_type_parameters] = STATE(3851),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_export] = ACTIONS(1914),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1914),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1919),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1914),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_readonly] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1934),
    [anon_sym_set] = ACTIONS(1934),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1914),
    [anon_sym_public] = ACTIONS(1914),
    [anon_sym_private] = ACTIONS(1914),
    [anon_sym_protected] = ACTIONS(1914),
    [anon_sym_override] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1914),
    [anon_sym_any] = ACTIONS(1914),
    [anon_sym_number] = ACTIONS(1914),
    [anon_sym_boolean] = ACTIONS(1914),
    [anon_sym_string] = ACTIONS(1914),
    [anon_sym_symbol] = ACTIONS(1914),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [538] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1936),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [539] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1910),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1874),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [540] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1906),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1874),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [541] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [sym_override_modifier] = STATE(2263),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1942),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1946),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [542] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [sym_override_modifier] = STATE(2263),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1942),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1946),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [543] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [sym_override_modifier] = STATE(2263),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1942),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1946),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [544] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1898),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1902),
    [anon_sym_module] = ACTIONS(1936),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [545] = {
    [sym_declaration] = STATE(632),
    [sym_variable_declaration] = STATE(651),
    [sym_lexical_declaration] = STATE(651),
    [sym_class_declaration] = STATE(651),
    [sym_function_declaration] = STATE(651),
    [sym_generator_function_declaration] = STATE(651),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(651),
    [sym_ambient_declaration] = STATE(651),
    [sym_abstract_class_declaration] = STATE(651),
    [sym_module] = STATE(651),
    [sym_internal_module] = STATE(653),
    [sym_import_alias] = STATE(651),
    [sym_interface_declaration] = STATE(651),
    [sym_enum_declaration] = STATE(651),
    [sym_type_alias_declaration] = STATE(651),
    [aux_sym_export_statement_repeat1] = STATE(3183),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1677),
    [anon_sym_import] = ACTIONS(1683),
    [anon_sym_var] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1687),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1702),
    [anon_sym_function] = ACTIONS(1704),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1708),
    [anon_sym_module] = ACTIONS(1874),
    [anon_sym_abstract] = ACTIONS(1712),
    [anon_sym_global] = ACTIONS(1876),
    [anon_sym_interface] = ACTIONS(1714),
    [anon_sym_enum] = ACTIONS(1716),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [546] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [547] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [548] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1938),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1938),
    [anon_sym_set] = ACTIONS(1938),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [549] = {
    [sym_declaration] = STATE(3277),
    [sym_variable_declaration] = STATE(3268),
    [sym_lexical_declaration] = STATE(3268),
    [sym_class_declaration] = STATE(3268),
    [sym_function_declaration] = STATE(3268),
    [sym_generator_function_declaration] = STATE(3268),
    [sym_decorator] = STATE(1150),
    [sym_function_signature] = STATE(3268),
    [sym_ambient_declaration] = STATE(3268),
    [sym_abstract_class_declaration] = STATE(3268),
    [sym_module] = STATE(3268),
    [sym_internal_module] = STATE(3270),
    [sym_import_alias] = STATE(3268),
    [sym_interface_declaration] = STATE(3268),
    [sym_enum_declaration] = STATE(3268),
    [sym_type_alias_declaration] = STATE(3268),
    [aux_sym_export_statement_repeat1] = STATE(3235),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_import] = ACTIONS(1952),
    [anon_sym_var] = ACTIONS(1954),
    [anon_sym_let] = ACTIONS(1956),
    [anon_sym_const] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_class] = ACTIONS(1960),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(1964),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(150),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1968),
    [anon_sym_abstract] = ACTIONS(1970),
    [anon_sym_global] = ACTIONS(1972),
    [anon_sym_interface] = ACTIONS(1974),
    [anon_sym_enum] = ACTIONS(1976),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [550] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1938),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1938),
    [anon_sym_set] = ACTIONS(1938),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [551] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1938),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1938),
    [anon_sym_set] = ACTIONS(1938),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [552] = {
    [sym_string] = STATE(3022),
    [sym__property_name] = STATE(3022),
    [sym_computed_property_name] = STATE(3022),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1938),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_STAR] = ACTIONS(1916),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1938),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1940),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1932),
    [sym_private_property_identifier] = ACTIONS(1932),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1944),
    [anon_sym_set] = ACTIONS(1944),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1978),
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_export] = ACTIONS(1980),
    [anon_sym_default] = ACTIONS(1980),
    [anon_sym_type] = ACTIONS(1980),
    [anon_sym_EQ] = ACTIONS(1980),
    [anon_sym_namespace] = ACTIONS(1980),
    [anon_sym_LBRACE] = ACTIONS(1978),
    [anon_sym_COMMA] = ACTIONS(1978),
    [anon_sym_RBRACE] = ACTIONS(1978),
    [anon_sym_typeof] = ACTIONS(1980),
    [anon_sym_import] = ACTIONS(1980),
    [anon_sym_var] = ACTIONS(1980),
    [anon_sym_let] = ACTIONS(1980),
    [anon_sym_const] = ACTIONS(1980),
    [anon_sym_BANG] = ACTIONS(1978),
    [anon_sym_else] = ACTIONS(1980),
    [anon_sym_if] = ACTIONS(1980),
    [anon_sym_switch] = ACTIONS(1980),
    [anon_sym_for] = ACTIONS(1980),
    [anon_sym_LPAREN] = ACTIONS(1978),
    [anon_sym_RPAREN] = ACTIONS(1978),
    [anon_sym_await] = ACTIONS(1980),
    [anon_sym_while] = ACTIONS(1980),
    [anon_sym_do] = ACTIONS(1980),
    [anon_sym_try] = ACTIONS(1980),
    [anon_sym_with] = ACTIONS(1980),
    [anon_sym_break] = ACTIONS(1980),
    [anon_sym_continue] = ACTIONS(1980),
    [anon_sym_debugger] = ACTIONS(1980),
    [anon_sym_return] = ACTIONS(1980),
    [anon_sym_throw] = ACTIONS(1980),
    [anon_sym_SEMI] = ACTIONS(1978),
    [anon_sym_COLON] = ACTIONS(1978),
    [anon_sym_case] = ACTIONS(1980),
    [anon_sym_yield] = ACTIONS(1980),
    [anon_sym_LBRACK] = ACTIONS(1978),
    [anon_sym_RBRACK] = ACTIONS(1978),
    [anon_sym_LT] = ACTIONS(1978),
    [anon_sym_GT] = ACTIONS(1978),
    [anon_sym_SLASH] = ACTIONS(1980),
    [anon_sym_class] = ACTIONS(1980),
    [anon_sym_async] = ACTIONS(1980),
    [anon_sym_function] = ACTIONS(1980),
    [anon_sym_EQ_GT] = ACTIONS(1978),
    [anon_sym_new] = ACTIONS(1980),
    [anon_sym_AMP] = ACTIONS(1978),
    [anon_sym_PIPE] = ACTIONS(1978),
    [anon_sym_PLUS] = ACTIONS(1980),
    [anon_sym_DASH] = ACTIONS(1980),
    [anon_sym_TILDE] = ACTIONS(1978),
    [anon_sym_void] = ACTIONS(1980),
    [anon_sym_delete] = ACTIONS(1980),
    [anon_sym_PLUS_PLUS] = ACTIONS(1978),
    [anon_sym_DASH_DASH] = ACTIONS(1978),
    [anon_sym_DQUOTE] = ACTIONS(1978),
    [anon_sym_SQUOTE] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1978),
    [sym_number] = ACTIONS(1978),
    [sym_this] = ACTIONS(1980),
    [sym_super] = ACTIONS(1980),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [sym_null] = ACTIONS(1980),
    [sym_undefined] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(1978),
    [anon_sym_static] = ACTIONS(1980),
    [anon_sym_readonly] = ACTIONS(1980),
    [anon_sym_get] = ACTIONS(1980),
    [anon_sym_set] = ACTIONS(1980),
    [anon_sym_QMARK] = ACTIONS(1978),
    [anon_sym_declare] = ACTIONS(1980),
    [anon_sym_public] = ACTIONS(1980),
    [anon_sym_private] = ACTIONS(1980),
    [anon_sym_protected] = ACTIONS(1980),
    [anon_sym_override] = ACTIONS(1980),
    [anon_sym_module] = ACTIONS(1980),
    [anon_sym_any] = ACTIONS(1980),
    [anon_sym_number] = ACTIONS(1980),
    [anon_sym_boolean] = ACTIONS(1980),
    [anon_sym_string] = ACTIONS(1980),
    [anon_sym_symbol] = ACTIONS(1980),
    [anon_sym_abstract] = ACTIONS(1980),
    [anon_sym_extends] = ACTIONS(1980),
    [anon_sym_interface] = ACTIONS(1980),
    [anon_sym_enum] = ACTIONS(1980),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_identifier] = ACTIONS(1524),
    [anon_sym_export] = ACTIONS(1524),
    [anon_sym_default] = ACTIONS(1524),
    [anon_sym_type] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1524),
    [anon_sym_namespace] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_COMMA] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [anon_sym_typeof] = ACTIONS(1524),
    [anon_sym_import] = ACTIONS(1524),
    [anon_sym_var] = ACTIONS(1524),
    [anon_sym_let] = ACTIONS(1524),
    [anon_sym_const] = ACTIONS(1524),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_else] = ACTIONS(1524),
    [anon_sym_if] = ACTIONS(1524),
    [anon_sym_switch] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [anon_sym_RPAREN] = ACTIONS(1522),
    [anon_sym_await] = ACTIONS(1524),
    [anon_sym_while] = ACTIONS(1524),
    [anon_sym_do] = ACTIONS(1524),
    [anon_sym_try] = ACTIONS(1524),
    [anon_sym_with] = ACTIONS(1524),
    [anon_sym_break] = ACTIONS(1524),
    [anon_sym_continue] = ACTIONS(1524),
    [anon_sym_debugger] = ACTIONS(1524),
    [anon_sym_return] = ACTIONS(1524),
    [anon_sym_throw] = ACTIONS(1524),
    [anon_sym_SEMI] = ACTIONS(1522),
    [anon_sym_COLON] = ACTIONS(1522),
    [anon_sym_case] = ACTIONS(1524),
    [anon_sym_yield] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_RBRACK] = ACTIONS(1522),
    [anon_sym_LT] = ACTIONS(1522),
    [anon_sym_GT] = ACTIONS(1522),
    [anon_sym_SLASH] = ACTIONS(1524),
    [anon_sym_class] = ACTIONS(1524),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_function] = ACTIONS(1524),
    [anon_sym_EQ_GT] = ACTIONS(1522),
    [anon_sym_new] = ACTIONS(1524),
    [anon_sym_AMP] = ACTIONS(1522),
    [anon_sym_PIPE] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_void] = ACTIONS(1524),
    [anon_sym_delete] = ACTIONS(1524),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [sym_number] = ACTIONS(1522),
    [sym_this] = ACTIONS(1524),
    [sym_super] = ACTIONS(1524),
    [sym_true] = ACTIONS(1524),
    [sym_false] = ACTIONS(1524),
    [sym_null] = ACTIONS(1524),
    [sym_undefined] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1522),
    [anon_sym_static] = ACTIONS(1524),
    [anon_sym_readonly] = ACTIONS(1524),
    [anon_sym_get] = ACTIONS(1524),
    [anon_sym_set] = ACTIONS(1524),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_declare] = ACTIONS(1524),
    [anon_sym_public] = ACTIONS(1524),
    [anon_sym_private] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(1524),
    [anon_sym_override] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(1524),
    [anon_sym_any] = ACTIONS(1524),
    [anon_sym_number] = ACTIONS(1524),
    [anon_sym_boolean] = ACTIONS(1524),
    [anon_sym_string] = ACTIONS(1524),
    [anon_sym_symbol] = ACTIONS(1524),
    [anon_sym_abstract] = ACTIONS(1524),
    [anon_sym_extends] = ACTIONS(1524),
    [anon_sym_interface] = ACTIONS(1524),
    [anon_sym_enum] = ACTIONS(1524),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(1984),
    [anon_sym_export] = ACTIONS(1984),
    [anon_sym_default] = ACTIONS(1984),
    [anon_sym_type] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1982),
    [anon_sym_COMMA] = ACTIONS(1982),
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_typeof] = ACTIONS(1984),
    [anon_sym_import] = ACTIONS(1984),
    [anon_sym_var] = ACTIONS(1984),
    [anon_sym_let] = ACTIONS(1984),
    [anon_sym_const] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1982),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1982),
    [anon_sym_await] = ACTIONS(1984),
    [anon_sym_while] = ACTIONS(1984),
    [anon_sym_do] = ACTIONS(1984),
    [anon_sym_try] = ACTIONS(1984),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_break] = ACTIONS(1984),
    [anon_sym_continue] = ACTIONS(1984),
    [anon_sym_debugger] = ACTIONS(1984),
    [anon_sym_return] = ACTIONS(1984),
    [anon_sym_throw] = ACTIONS(1984),
    [anon_sym_SEMI] = ACTIONS(1982),
    [anon_sym_COLON] = ACTIONS(1982),
    [anon_sym_case] = ACTIONS(1984),
    [anon_sym_yield] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1982),
    [anon_sym_RBRACK] = ACTIONS(1982),
    [anon_sym_LT] = ACTIONS(1982),
    [anon_sym_GT] = ACTIONS(1982),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_class] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_function] = ACTIONS(1984),
    [anon_sym_EQ_GT] = ACTIONS(1982),
    [anon_sym_new] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1982),
    [anon_sym_PIPE] = ACTIONS(1982),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_TILDE] = ACTIONS(1982),
    [anon_sym_void] = ACTIONS(1984),
    [anon_sym_delete] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1982),
    [anon_sym_DASH_DASH] = ACTIONS(1982),
    [anon_sym_DQUOTE] = ACTIONS(1982),
    [anon_sym_SQUOTE] = ACTIONS(1982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1982),
    [sym_number] = ACTIONS(1982),
    [sym_this] = ACTIONS(1984),
    [sym_super] = ACTIONS(1984),
    [sym_true] = ACTIONS(1984),
    [sym_false] = ACTIONS(1984),
    [sym_null] = ACTIONS(1984),
    [sym_undefined] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1982),
    [anon_sym_static] = ACTIONS(1984),
    [anon_sym_readonly] = ACTIONS(1984),
    [anon_sym_get] = ACTIONS(1984),
    [anon_sym_set] = ACTIONS(1984),
    [anon_sym_QMARK] = ACTIONS(1982),
    [anon_sym_declare] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(1984),
    [anon_sym_private] = ACTIONS(1984),
    [anon_sym_protected] = ACTIONS(1984),
    [anon_sym_override] = ACTIONS(1984),
    [anon_sym_module] = ACTIONS(1984),
    [anon_sym_any] = ACTIONS(1984),
    [anon_sym_number] = ACTIONS(1984),
    [anon_sym_boolean] = ACTIONS(1984),
    [anon_sym_string] = ACTIONS(1984),
    [anon_sym_symbol] = ACTIONS(1984),
    [anon_sym_abstract] = ACTIONS(1984),
    [anon_sym_extends] = ACTIONS(1984),
    [anon_sym_interface] = ACTIONS(1984),
    [anon_sym_enum] = ACTIONS(1984),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1986),
    [sym_identifier] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1988),
    [anon_sym_default] = ACTIONS(1988),
    [anon_sym_type] = ACTIONS(1988),
    [anon_sym_EQ] = ACTIONS(1988),
    [anon_sym_namespace] = ACTIONS(1988),
    [anon_sym_LBRACE] = ACTIONS(1986),
    [anon_sym_COMMA] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_typeof] = ACTIONS(1988),
    [anon_sym_import] = ACTIONS(1988),
    [anon_sym_var] = ACTIONS(1988),
    [anon_sym_let] = ACTIONS(1988),
    [anon_sym_const] = ACTIONS(1988),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_switch] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(1986),
    [anon_sym_RPAREN] = ACTIONS(1986),
    [anon_sym_await] = ACTIONS(1988),
    [anon_sym_while] = ACTIONS(1988),
    [anon_sym_do] = ACTIONS(1988),
    [anon_sym_try] = ACTIONS(1988),
    [anon_sym_with] = ACTIONS(1988),
    [anon_sym_break] = ACTIONS(1988),
    [anon_sym_continue] = ACTIONS(1988),
    [anon_sym_debugger] = ACTIONS(1988),
    [anon_sym_return] = ACTIONS(1988),
    [anon_sym_throw] = ACTIONS(1988),
    [anon_sym_SEMI] = ACTIONS(1986),
    [anon_sym_COLON] = ACTIONS(1986),
    [anon_sym_case] = ACTIONS(1988),
    [anon_sym_yield] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(1986),
    [anon_sym_RBRACK] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1988),
    [anon_sym_class] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_EQ_GT] = ACTIONS(1986),
    [anon_sym_new] = ACTIONS(1988),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_PLUS] = ACTIONS(1988),
    [anon_sym_DASH] = ACTIONS(1988),
    [anon_sym_TILDE] = ACTIONS(1986),
    [anon_sym_void] = ACTIONS(1988),
    [anon_sym_delete] = ACTIONS(1988),
    [anon_sym_PLUS_PLUS] = ACTIONS(1986),
    [anon_sym_DASH_DASH] = ACTIONS(1986),
    [anon_sym_DQUOTE] = ACTIONS(1986),
    [anon_sym_SQUOTE] = ACTIONS(1986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1986),
    [sym_number] = ACTIONS(1986),
    [sym_this] = ACTIONS(1988),
    [sym_super] = ACTIONS(1988),
    [sym_true] = ACTIONS(1988),
    [sym_false] = ACTIONS(1988),
    [sym_null] = ACTIONS(1988),
    [sym_undefined] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_static] = ACTIONS(1988),
    [anon_sym_readonly] = ACTIONS(1988),
    [anon_sym_get] = ACTIONS(1988),
    [anon_sym_set] = ACTIONS(1988),
    [anon_sym_QMARK] = ACTIONS(1986),
    [anon_sym_declare] = ACTIONS(1988),
    [anon_sym_public] = ACTIONS(1988),
    [anon_sym_private] = ACTIONS(1988),
    [anon_sym_protected] = ACTIONS(1988),
    [anon_sym_override] = ACTIONS(1988),
    [anon_sym_module] = ACTIONS(1988),
    [anon_sym_any] = ACTIONS(1988),
    [anon_sym_number] = ACTIONS(1988),
    [anon_sym_boolean] = ACTIONS(1988),
    [anon_sym_string] = ACTIONS(1988),
    [anon_sym_symbol] = ACTIONS(1988),
    [anon_sym_abstract] = ACTIONS(1988),
    [anon_sym_extends] = ACTIONS(1988),
    [anon_sym_interface] = ACTIONS(1988),
    [anon_sym_enum] = ACTIONS(1988),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1568),
    [sym_identifier] = ACTIONS(1570),
    [anon_sym_export] = ACTIONS(1570),
    [anon_sym_default] = ACTIONS(1570),
    [anon_sym_type] = ACTIONS(1570),
    [anon_sym_EQ] = ACTIONS(1570),
    [anon_sym_namespace] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1568),
    [anon_sym_COMMA] = ACTIONS(1568),
    [anon_sym_RBRACE] = ACTIONS(1568),
    [anon_sym_typeof] = ACTIONS(1570),
    [anon_sym_import] = ACTIONS(1570),
    [anon_sym_var] = ACTIONS(1570),
    [anon_sym_let] = ACTIONS(1570),
    [anon_sym_const] = ACTIONS(1570),
    [anon_sym_BANG] = ACTIONS(1568),
    [anon_sym_else] = ACTIONS(1570),
    [anon_sym_if] = ACTIONS(1570),
    [anon_sym_switch] = ACTIONS(1570),
    [anon_sym_for] = ACTIONS(1570),
    [anon_sym_LPAREN] = ACTIONS(1568),
    [anon_sym_RPAREN] = ACTIONS(1568),
    [anon_sym_await] = ACTIONS(1570),
    [anon_sym_while] = ACTIONS(1570),
    [anon_sym_do] = ACTIONS(1570),
    [anon_sym_try] = ACTIONS(1570),
    [anon_sym_with] = ACTIONS(1570),
    [anon_sym_break] = ACTIONS(1570),
    [anon_sym_continue] = ACTIONS(1570),
    [anon_sym_debugger] = ACTIONS(1570),
    [anon_sym_return] = ACTIONS(1570),
    [anon_sym_throw] = ACTIONS(1570),
    [anon_sym_SEMI] = ACTIONS(1568),
    [anon_sym_COLON] = ACTIONS(1568),
    [anon_sym_case] = ACTIONS(1570),
    [anon_sym_yield] = ACTIONS(1570),
    [anon_sym_LBRACK] = ACTIONS(1568),
    [anon_sym_RBRACK] = ACTIONS(1568),
    [anon_sym_LT] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1568),
    [anon_sym_SLASH] = ACTIONS(1570),
    [anon_sym_class] = ACTIONS(1570),
    [anon_sym_async] = ACTIONS(1570),
    [anon_sym_function] = ACTIONS(1570),
    [anon_sym_EQ_GT] = ACTIONS(1568),
    [anon_sym_new] = ACTIONS(1570),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1568),
    [anon_sym_PLUS] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1570),
    [anon_sym_TILDE] = ACTIONS(1568),
    [anon_sym_void] = ACTIONS(1570),
    [anon_sym_delete] = ACTIONS(1570),
    [anon_sym_PLUS_PLUS] = ACTIONS(1568),
    [anon_sym_DASH_DASH] = ACTIONS(1568),
    [anon_sym_DQUOTE] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1568),
    [sym_number] = ACTIONS(1568),
    [sym_this] = ACTIONS(1570),
    [sym_super] = ACTIONS(1570),
    [sym_true] = ACTIONS(1570),
    [sym_false] = ACTIONS(1570),
    [sym_null] = ACTIONS(1570),
    [sym_undefined] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(1568),
    [anon_sym_static] = ACTIONS(1570),
    [anon_sym_readonly] = ACTIONS(1570),
    [anon_sym_get] = ACTIONS(1570),
    [anon_sym_set] = ACTIONS(1570),
    [anon_sym_QMARK] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1570),
    [anon_sym_public] = ACTIONS(1570),
    [anon_sym_private] = ACTIONS(1570),
    [anon_sym_protected] = ACTIONS(1570),
    [anon_sym_override] = ACTIONS(1570),
    [anon_sym_module] = ACTIONS(1570),
    [anon_sym_any] = ACTIONS(1570),
    [anon_sym_number] = ACTIONS(1570),
    [anon_sym_boolean] = ACTIONS(1570),
    [anon_sym_string] = ACTIONS(1570),
    [anon_sym_symbol] = ACTIONS(1570),
    [anon_sym_abstract] = ACTIONS(1570),
    [anon_sym_extends] = ACTIONS(1570),
    [anon_sym_interface] = ACTIONS(1570),
    [anon_sym_enum] = ACTIONS(1570),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1990),
    [sym_identifier] = ACTIONS(1992),
    [anon_sym_export] = ACTIONS(1992),
    [anon_sym_default] = ACTIONS(1992),
    [anon_sym_type] = ACTIONS(1992),
    [anon_sym_EQ] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1990),
    [anon_sym_COMMA] = ACTIONS(1990),
    [anon_sym_RBRACE] = ACTIONS(1990),
    [anon_sym_typeof] = ACTIONS(1992),
    [anon_sym_import] = ACTIONS(1992),
    [anon_sym_var] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1992),
    [anon_sym_const] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1990),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1990),
    [anon_sym_RPAREN] = ACTIONS(1990),
    [anon_sym_await] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_do] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1992),
    [anon_sym_with] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1992),
    [anon_sym_continue] = ACTIONS(1992),
    [anon_sym_debugger] = ACTIONS(1992),
    [anon_sym_return] = ACTIONS(1992),
    [anon_sym_throw] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1990),
    [anon_sym_COLON] = ACTIONS(1990),
    [anon_sym_case] = ACTIONS(1992),
    [anon_sym_yield] = ACTIONS(1992),
    [anon_sym_LBRACK] = ACTIONS(1990),
    [anon_sym_RBRACK] = ACTIONS(1990),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_SLASH] = ACTIONS(1992),
    [anon_sym_class] = ACTIONS(1992),
    [anon_sym_async] = ACTIONS(1992),
    [anon_sym_function] = ACTIONS(1992),
    [anon_sym_EQ_GT] = ACTIONS(1990),
    [anon_sym_new] = ACTIONS(1992),
    [anon_sym_AMP] = ACTIONS(1990),
    [anon_sym_PIPE] = ACTIONS(1990),
    [anon_sym_PLUS] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1992),
    [anon_sym_TILDE] = ACTIONS(1990),
    [anon_sym_void] = ACTIONS(1992),
    [anon_sym_delete] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1990),
    [anon_sym_DASH_DASH] = ACTIONS(1990),
    [anon_sym_DQUOTE] = ACTIONS(1990),
    [anon_sym_SQUOTE] = ACTIONS(1990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [sym_number] = ACTIONS(1990),
    [sym_this] = ACTIONS(1992),
    [sym_super] = ACTIONS(1992),
    [sym_true] = ACTIONS(1992),
    [sym_false] = ACTIONS(1992),
    [sym_null] = ACTIONS(1992),
    [sym_undefined] = ACTIONS(1992),
    [anon_sym_AT] = ACTIONS(1990),
    [anon_sym_static] = ACTIONS(1992),
    [anon_sym_readonly] = ACTIONS(1992),
    [anon_sym_get] = ACTIONS(1992),
    [anon_sym_set] = ACTIONS(1992),
    [anon_sym_QMARK] = ACTIONS(1990),
    [anon_sym_declare] = ACTIONS(1992),
    [anon_sym_public] = ACTIONS(1992),
    [anon_sym_private] = ACTIONS(1992),
    [anon_sym_protected] = ACTIONS(1992),
    [anon_sym_override] = ACTIONS(1992),
    [anon_sym_module] = ACTIONS(1992),
    [anon_sym_any] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1992),
    [anon_sym_boolean] = ACTIONS(1992),
    [anon_sym_string] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1992),
    [anon_sym_abstract] = ACTIONS(1992),
    [anon_sym_extends] = ACTIONS(1992),
    [anon_sym_interface] = ACTIONS(1992),
    [anon_sym_enum] = ACTIONS(1992),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1994),
    [sym_identifier] = ACTIONS(1996),
    [anon_sym_export] = ACTIONS(1996),
    [anon_sym_default] = ACTIONS(1996),
    [anon_sym_type] = ACTIONS(1996),
    [anon_sym_EQ] = ACTIONS(1996),
    [anon_sym_namespace] = ACTIONS(1996),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_COMMA] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1996),
    [anon_sym_import] = ACTIONS(1996),
    [anon_sym_var] = ACTIONS(1996),
    [anon_sym_let] = ACTIONS(1996),
    [anon_sym_const] = ACTIONS(1996),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_else] = ACTIONS(1996),
    [anon_sym_if] = ACTIONS(1996),
    [anon_sym_switch] = ACTIONS(1996),
    [anon_sym_for] = ACTIONS(1996),
    [anon_sym_LPAREN] = ACTIONS(1994),
    [anon_sym_RPAREN] = ACTIONS(1994),
    [anon_sym_await] = ACTIONS(1996),
    [anon_sym_while] = ACTIONS(1996),
    [anon_sym_do] = ACTIONS(1996),
    [anon_sym_try] = ACTIONS(1996),
    [anon_sym_with] = ACTIONS(1996),
    [anon_sym_break] = ACTIONS(1996),
    [anon_sym_continue] = ACTIONS(1996),
    [anon_sym_debugger] = ACTIONS(1996),
    [anon_sym_return] = ACTIONS(1996),
    [anon_sym_throw] = ACTIONS(1996),
    [anon_sym_SEMI] = ACTIONS(1994),
    [anon_sym_COLON] = ACTIONS(1994),
    [anon_sym_case] = ACTIONS(1996),
    [anon_sym_yield] = ACTIONS(1996),
    [anon_sym_LBRACK] = ACTIONS(1994),
    [anon_sym_RBRACK] = ACTIONS(1994),
    [anon_sym_LT] = ACTIONS(1994),
    [anon_sym_GT] = ACTIONS(1994),
    [anon_sym_SLASH] = ACTIONS(1996),
    [anon_sym_class] = ACTIONS(1996),
    [anon_sym_async] = ACTIONS(1996),
    [anon_sym_function] = ACTIONS(1996),
    [anon_sym_EQ_GT] = ACTIONS(1994),
    [anon_sym_new] = ACTIONS(1996),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1996),
    [anon_sym_DASH] = ACTIONS(1996),
    [anon_sym_TILDE] = ACTIONS(1994),
    [anon_sym_void] = ACTIONS(1996),
    [anon_sym_delete] = ACTIONS(1996),
    [anon_sym_PLUS_PLUS] = ACTIONS(1994),
    [anon_sym_DASH_DASH] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1994),
    [sym_number] = ACTIONS(1994),
    [sym_this] = ACTIONS(1996),
    [sym_super] = ACTIONS(1996),
    [sym_true] = ACTIONS(1996),
    [sym_false] = ACTIONS(1996),
    [sym_null] = ACTIONS(1996),
    [sym_undefined] = ACTIONS(1996),
    [anon_sym_AT] = ACTIONS(1994),
    [anon_sym_static] = ACTIONS(1996),
    [anon_sym_readonly] = ACTIONS(1996),
    [anon_sym_get] = ACTIONS(1996),
    [anon_sym_set] = ACTIONS(1996),
    [anon_sym_QMARK] = ACTIONS(1994),
    [anon_sym_declare] = ACTIONS(1996),
    [anon_sym_public] = ACTIONS(1996),
    [anon_sym_private] = ACTIONS(1996),
    [anon_sym_protected] = ACTIONS(1996),
    [anon_sym_override] = ACTIONS(1996),
    [anon_sym_module] = ACTIONS(1996),
    [anon_sym_any] = ACTIONS(1996),
    [anon_sym_number] = ACTIONS(1996),
    [anon_sym_boolean] = ACTIONS(1996),
    [anon_sym_string] = ACTIONS(1996),
    [anon_sym_symbol] = ACTIONS(1996),
    [anon_sym_abstract] = ACTIONS(1996),
    [anon_sym_extends] = ACTIONS(1996),
    [anon_sym_interface] = ACTIONS(1996),
    [anon_sym_enum] = ACTIONS(1996),
  },
  [560] = {
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1615),
    [sym_private_property_identifier] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [561] = {
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1615),
    [sym_private_property_identifier] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [562] = {
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1633),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1635),
    [sym_private_property_identifier] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_readonly] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_override] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [563] = {
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1633),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1635),
    [sym_private_property_identifier] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_readonly] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_override] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [564] = {
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1615),
    [sym_private_property_identifier] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [565] = {
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_export] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1633),
    [anon_sym_type] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(114),
    [anon_sym_async] = ACTIONS(1633),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [sym_number] = ACTIONS(1635),
    [sym_private_property_identifier] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1633),
    [anon_sym_readonly] = ACTIONS(1633),
    [anon_sym_get] = ACTIONS(1633),
    [anon_sym_set] = ACTIONS(1633),
    [anon_sym_QMARK] = ACTIONS(1706),
    [anon_sym_declare] = ACTIONS(1633),
    [anon_sym_public] = ACTIONS(1633),
    [anon_sym_private] = ACTIONS(1633),
    [anon_sym_protected] = ACTIONS(1633),
    [anon_sym_override] = ACTIONS(1633),
    [anon_sym_module] = ACTIONS(1633),
    [anon_sym_any] = ACTIONS(1633),
    [anon_sym_number] = ACTIONS(1633),
    [anon_sym_boolean] = ACTIONS(1633),
    [anon_sym_string] = ACTIONS(1633),
    [anon_sym_symbol] = ACTIONS(1633),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [566] = {
    [sym__call_signature] = STATE(4327),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_export] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2000),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(206),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_readonly] = ACTIONS(2000),
    [anon_sym_get] = ACTIONS(2000),
    [anon_sym_set] = ACTIONS(2000),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(2000),
    [anon_sym_public] = ACTIONS(2000),
    [anon_sym_private] = ACTIONS(2000),
    [anon_sym_protected] = ACTIONS(2000),
    [anon_sym_override] = ACTIONS(2000),
    [anon_sym_module] = ACTIONS(2000),
    [anon_sym_any] = ACTIONS(2000),
    [anon_sym_number] = ACTIONS(2000),
    [anon_sym_boolean] = ACTIONS(2000),
    [anon_sym_string] = ACTIONS(2000),
    [anon_sym_symbol] = ACTIONS(2000),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [567] = {
    [sym__call_signature] = STATE(4084),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_RBRACE] = ACTIONS(1264),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(2014),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [568] = {
    [sym__call_signature] = STATE(4084),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_QMARK] = ACTIONS(635),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [569] = {
    [sym__call_signature] = STATE(4327),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_export] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2000),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_readonly] = ACTIONS(2000),
    [anon_sym_get] = ACTIONS(2000),
    [anon_sym_set] = ACTIONS(2000),
    [anon_sym_declare] = ACTIONS(2000),
    [anon_sym_public] = ACTIONS(2000),
    [anon_sym_private] = ACTIONS(2000),
    [anon_sym_protected] = ACTIONS(2000),
    [anon_sym_override] = ACTIONS(2000),
    [anon_sym_module] = ACTIONS(2000),
    [anon_sym_any] = ACTIONS(2000),
    [anon_sym_number] = ACTIONS(2000),
    [anon_sym_boolean] = ACTIONS(2000),
    [anon_sym_string] = ACTIONS(2000),
    [anon_sym_symbol] = ACTIONS(2000),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [570] = {
    [sym__call_signature] = STATE(4327),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_export] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2000),
    [anon_sym_EQ] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_readonly] = ACTIONS(2000),
    [anon_sym_get] = ACTIONS(2000),
    [anon_sym_set] = ACTIONS(2000),
    [anon_sym_declare] = ACTIONS(2000),
    [anon_sym_public] = ACTIONS(2000),
    [anon_sym_private] = ACTIONS(2000),
    [anon_sym_protected] = ACTIONS(2000),
    [anon_sym_override] = ACTIONS(2000),
    [anon_sym_module] = ACTIONS(2000),
    [anon_sym_any] = ACTIONS(2000),
    [anon_sym_number] = ACTIONS(2000),
    [anon_sym_boolean] = ACTIONS(2000),
    [anon_sym_string] = ACTIONS(2000),
    [anon_sym_symbol] = ACTIONS(2000),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [571] = {
    [sym__call_signature] = STATE(4308),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(2020),
    [anon_sym_of] = ACTIONS(2023),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_override] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [572] = {
    [sym__call_signature] = STATE(4308),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2027),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_override] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [573] = {
    [sym__call_signature] = STATE(4308),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1906),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_override] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [574] = {
    [sym__call_signature] = STATE(4342),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1251),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [575] = {
    [sym__call_signature] = STATE(4342),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2031),
    [anon_sym_EQ] = ACTIONS(1249),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1251),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_readonly] = ACTIONS(2031),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
    [anon_sym_declare] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_override] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_any] = ACTIONS(2031),
    [anon_sym_number] = ACTIONS(2031),
    [anon_sym_boolean] = ACTIONS(2031),
    [anon_sym_string] = ACTIONS(2031),
    [anon_sym_symbol] = ACTIONS(2031),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [576] = {
    [sym__call_signature] = STATE(4327),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_export] = ACTIONS(2000),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2000),
    [anon_sym_EQ] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2000),
    [anon_sym_COMMA] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2000),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2000),
    [anon_sym_readonly] = ACTIONS(2000),
    [anon_sym_get] = ACTIONS(2000),
    [anon_sym_set] = ACTIONS(2000),
    [anon_sym_declare] = ACTIONS(2000),
    [anon_sym_public] = ACTIONS(2000),
    [anon_sym_private] = ACTIONS(2000),
    [anon_sym_protected] = ACTIONS(2000),
    [anon_sym_override] = ACTIONS(2000),
    [anon_sym_module] = ACTIONS(2000),
    [anon_sym_any] = ACTIONS(2000),
    [anon_sym_number] = ACTIONS(2000),
    [anon_sym_boolean] = ACTIONS(2000),
    [anon_sym_string] = ACTIONS(2000),
    [anon_sym_symbol] = ACTIONS(2000),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [577] = {
    [sym__call_signature] = STATE(4308),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_override] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [578] = {
    [sym__call_signature] = STATE(4308),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_override] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [579] = {
    [sym__call_signature] = STATE(4308),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2016),
    [anon_sym_export] = ACTIONS(2018),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2018),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2018),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1910),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2018),
    [anon_sym_function] = ACTIONS(2027),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2018),
    [anon_sym_readonly] = ACTIONS(2018),
    [anon_sym_get] = ACTIONS(2018),
    [anon_sym_set] = ACTIONS(2018),
    [anon_sym_declare] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(2018),
    [anon_sym_private] = ACTIONS(2018),
    [anon_sym_protected] = ACTIONS(2018),
    [anon_sym_override] = ACTIONS(2018),
    [anon_sym_module] = ACTIONS(2018),
    [anon_sym_any] = ACTIONS(2018),
    [anon_sym_number] = ACTIONS(2018),
    [anon_sym_boolean] = ACTIONS(2018),
    [anon_sym_string] = ACTIONS(2018),
    [anon_sym_symbol] = ACTIONS(2018),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_type] = ACTIONS(1488),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [anon_sym_let] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_debugger] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_finally] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1488),
    [anon_sym_delete] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1488),
    [sym_super] = ACTIONS(1488),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [sym_null] = ACTIONS(1488),
    [sym_undefined] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_readonly] = ACTIONS(1488),
    [anon_sym_get] = ACTIONS(1488),
    [anon_sym_set] = ACTIONS(1488),
    [anon_sym_declare] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_protected] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_module] = ACTIONS(1488),
    [anon_sym_any] = ACTIONS(1488),
    [anon_sym_number] = ACTIONS(1488),
    [anon_sym_boolean] = ACTIONS(1488),
    [anon_sym_string] = ACTIONS(1488),
    [anon_sym_symbol] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [sym__automatic_semicolon] = ACTIONS(2033),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_catch] = ACTIONS(1346),
    [anon_sym_finally] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1354),
  },
  [582] = {
    [sym__call_signature] = STATE(4271),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_export] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2037),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1304),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2037),
    [anon_sym_readonly] = ACTIONS(2037),
    [anon_sym_get] = ACTIONS(2037),
    [anon_sym_set] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2037),
    [anon_sym_public] = ACTIONS(2037),
    [anon_sym_private] = ACTIONS(2037),
    [anon_sym_protected] = ACTIONS(2037),
    [anon_sym_override] = ACTIONS(2037),
    [anon_sym_module] = ACTIONS(2037),
    [anon_sym_any] = ACTIONS(2037),
    [anon_sym_number] = ACTIONS(2037),
    [anon_sym_boolean] = ACTIONS(2037),
    [anon_sym_string] = ACTIONS(2037),
    [anon_sym_symbol] = ACTIONS(2037),
    [anon_sym_implements] = ACTIONS(114),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [583] = {
    [sym__call_signature] = STATE(4050),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_readonly] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_override] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [584] = {
    [sym__call_signature] = STATE(4050),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_RBRACE] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_readonly] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_override] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [585] = {
    [sym_catch_clause] = STATE(605),
    [sym_finally_clause] = STATE(671),
    [ts_builtin_sym_end] = ACTIONS(2043),
    [sym_identifier] = ACTIONS(2045),
    [anon_sym_export] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2045),
    [anon_sym_type] = ACTIONS(2045),
    [anon_sym_namespace] = ACTIONS(2045),
    [anon_sym_LBRACE] = ACTIONS(2043),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_typeof] = ACTIONS(2045),
    [anon_sym_import] = ACTIONS(2045),
    [anon_sym_var] = ACTIONS(2045),
    [anon_sym_let] = ACTIONS(2045),
    [anon_sym_const] = ACTIONS(2045),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_else] = ACTIONS(2045),
    [anon_sym_if] = ACTIONS(2045),
    [anon_sym_switch] = ACTIONS(2045),
    [anon_sym_for] = ACTIONS(2045),
    [anon_sym_LPAREN] = ACTIONS(2043),
    [anon_sym_await] = ACTIONS(2045),
    [anon_sym_while] = ACTIONS(2045),
    [anon_sym_do] = ACTIONS(2045),
    [anon_sym_try] = ACTIONS(2045),
    [anon_sym_with] = ACTIONS(2045),
    [anon_sym_break] = ACTIONS(2045),
    [anon_sym_continue] = ACTIONS(2045),
    [anon_sym_debugger] = ACTIONS(2045),
    [anon_sym_return] = ACTIONS(2045),
    [anon_sym_throw] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2043),
    [anon_sym_case] = ACTIONS(2045),
    [anon_sym_catch] = ACTIONS(2047),
    [anon_sym_finally] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2045),
    [anon_sym_LBRACK] = ACTIONS(2043),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_SLASH] = ACTIONS(2045),
    [anon_sym_class] = ACTIONS(2045),
    [anon_sym_async] = ACTIONS(2045),
    [anon_sym_function] = ACTIONS(2045),
    [anon_sym_new] = ACTIONS(2045),
    [anon_sym_PLUS] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2043),
    [anon_sym_void] = ACTIONS(2045),
    [anon_sym_delete] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2043),
    [anon_sym_DASH_DASH] = ACTIONS(2043),
    [anon_sym_DQUOTE] = ACTIONS(2043),
    [anon_sym_SQUOTE] = ACTIONS(2043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2043),
    [sym_number] = ACTIONS(2043),
    [sym_this] = ACTIONS(2045),
    [sym_super] = ACTIONS(2045),
    [sym_true] = ACTIONS(2045),
    [sym_false] = ACTIONS(2045),
    [sym_null] = ACTIONS(2045),
    [sym_undefined] = ACTIONS(2045),
    [anon_sym_AT] = ACTIONS(2043),
    [anon_sym_static] = ACTIONS(2045),
    [anon_sym_readonly] = ACTIONS(2045),
    [anon_sym_get] = ACTIONS(2045),
    [anon_sym_set] = ACTIONS(2045),
    [anon_sym_declare] = ACTIONS(2045),
    [anon_sym_public] = ACTIONS(2045),
    [anon_sym_private] = ACTIONS(2045),
    [anon_sym_protected] = ACTIONS(2045),
    [anon_sym_override] = ACTIONS(2045),
    [anon_sym_module] = ACTIONS(2045),
    [anon_sym_any] = ACTIONS(2045),
    [anon_sym_number] = ACTIONS(2045),
    [anon_sym_boolean] = ACTIONS(2045),
    [anon_sym_string] = ACTIONS(2045),
    [anon_sym_symbol] = ACTIONS(2045),
    [anon_sym_abstract] = ACTIONS(2045),
    [anon_sym_interface] = ACTIONS(2045),
    [anon_sym_enum] = ACTIONS(2045),
  },
  [586] = {
    [sym__call_signature] = STATE(4050),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_readonly] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_override] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [587] = {
    [sym__call_signature] = STATE(4271),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_export] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2037),
    [anon_sym_EQ] = ACTIONS(1302),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2037),
    [anon_sym_LBRACE] = ACTIONS(150),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2037),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1304),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2037),
    [anon_sym_readonly] = ACTIONS(2037),
    [anon_sym_get] = ACTIONS(2037),
    [anon_sym_set] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2037),
    [anon_sym_public] = ACTIONS(2037),
    [anon_sym_private] = ACTIONS(2037),
    [anon_sym_protected] = ACTIONS(2037),
    [anon_sym_override] = ACTIONS(2037),
    [anon_sym_module] = ACTIONS(2037),
    [anon_sym_any] = ACTIONS(2037),
    [anon_sym_number] = ACTIONS(2037),
    [anon_sym_boolean] = ACTIONS(2037),
    [anon_sym_string] = ACTIONS(2037),
    [anon_sym_symbol] = ACTIONS(2037),
    [anon_sym_implements] = ACTIONS(114),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [588] = {
    [sym__call_signature] = STATE(4156),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2058),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_readonly] = ACTIONS(2058),
    [anon_sym_get] = ACTIONS(2058),
    [anon_sym_set] = ACTIONS(2058),
    [anon_sym_declare] = ACTIONS(2058),
    [anon_sym_public] = ACTIONS(2058),
    [anon_sym_private] = ACTIONS(2058),
    [anon_sym_protected] = ACTIONS(2058),
    [anon_sym_override] = ACTIONS(2058),
    [anon_sym_module] = ACTIONS(2058),
    [anon_sym_any] = ACTIONS(2058),
    [anon_sym_number] = ACTIONS(2058),
    [anon_sym_boolean] = ACTIONS(2058),
    [anon_sym_string] = ACTIONS(2058),
    [anon_sym_symbol] = ACTIONS(2058),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_type] = ACTIONS(1488),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [anon_sym_let] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_debugger] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1488),
    [anon_sym_delete] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1488),
    [sym_super] = ACTIONS(1488),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [sym_null] = ACTIONS(1488),
    [sym_undefined] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_readonly] = ACTIONS(1488),
    [anon_sym_get] = ACTIONS(1488),
    [anon_sym_set] = ACTIONS(1488),
    [anon_sym_declare] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_protected] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_module] = ACTIONS(1488),
    [anon_sym_any] = ACTIONS(1488),
    [anon_sym_number] = ACTIONS(1488),
    [anon_sym_boolean] = ACTIONS(1488),
    [anon_sym_string] = ACTIONS(1488),
    [anon_sym_symbol] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1486),
    [sym__automatic_semicolon] = ACTIONS(2060),
  },
  [590] = {
    [sym__call_signature] = STATE(4156),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2058),
    [anon_sym_function] = ACTIONS(2062),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_readonly] = ACTIONS(2058),
    [anon_sym_get] = ACTIONS(2058),
    [anon_sym_set] = ACTIONS(2058),
    [anon_sym_declare] = ACTIONS(2058),
    [anon_sym_public] = ACTIONS(2058),
    [anon_sym_private] = ACTIONS(2058),
    [anon_sym_protected] = ACTIONS(2058),
    [anon_sym_override] = ACTIONS(2058),
    [anon_sym_module] = ACTIONS(2058),
    [anon_sym_any] = ACTIONS(2058),
    [anon_sym_number] = ACTIONS(2058),
    [anon_sym_boolean] = ACTIONS(2058),
    [anon_sym_string] = ACTIONS(2058),
    [anon_sym_symbol] = ACTIONS(2058),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_type] = ACTIONS(1488),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [anon_sym_let] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_debugger] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_catch] = ACTIONS(1488),
    [anon_sym_finally] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1488),
    [anon_sym_delete] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1488),
    [sym_super] = ACTIONS(1488),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [sym_null] = ACTIONS(1488),
    [sym_undefined] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_readonly] = ACTIONS(1488),
    [anon_sym_get] = ACTIONS(1488),
    [anon_sym_set] = ACTIONS(1488),
    [anon_sym_declare] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_protected] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_module] = ACTIONS(1488),
    [anon_sym_any] = ACTIONS(1488),
    [anon_sym_number] = ACTIONS(1488),
    [anon_sym_boolean] = ACTIONS(1488),
    [anon_sym_string] = ACTIONS(1488),
    [anon_sym_symbol] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
  },
  [592] = {
    [sym__call_signature] = STATE(4050),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_readonly] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_override] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [593] = {
    [sym__call_signature] = STATE(4050),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_readonly] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_override] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(1492),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_var] = ACTIONS(1492),
    [anon_sym_let] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_debugger] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_throw] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_catch] = ACTIONS(1492),
    [anon_sym_finally] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_LT] = ACTIONS(1490),
    [anon_sym_SLASH] = ACTIONS(1492),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_void] = ACTIONS(1492),
    [anon_sym_delete] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [sym_number] = ACTIONS(1490),
    [sym_this] = ACTIONS(1492),
    [sym_super] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_undefined] = ACTIONS(1492),
    [anon_sym_AT] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_readonly] = ACTIONS(1492),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_declare] = ACTIONS(1492),
    [anon_sym_public] = ACTIONS(1492),
    [anon_sym_private] = ACTIONS(1492),
    [anon_sym_protected] = ACTIONS(1492),
    [anon_sym_override] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(1492),
    [anon_sym_any] = ACTIONS(1492),
    [anon_sym_number] = ACTIONS(1492),
    [anon_sym_boolean] = ACTIONS(1492),
    [anon_sym_string] = ACTIONS(1492),
    [anon_sym_symbol] = ACTIONS(1492),
    [anon_sym_abstract] = ACTIONS(1492),
    [anon_sym_interface] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
  },
  [595] = {
    [sym__call_signature] = STATE(4156),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2058),
    [anon_sym_function] = ACTIONS(1930),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_readonly] = ACTIONS(2058),
    [anon_sym_get] = ACTIONS(2058),
    [anon_sym_set] = ACTIONS(2058),
    [anon_sym_declare] = ACTIONS(2058),
    [anon_sym_public] = ACTIONS(2058),
    [anon_sym_private] = ACTIONS(2058),
    [anon_sym_protected] = ACTIONS(2058),
    [anon_sym_override] = ACTIONS(2058),
    [anon_sym_module] = ACTIONS(2058),
    [anon_sym_any] = ACTIONS(2058),
    [anon_sym_number] = ACTIONS(2058),
    [anon_sym_boolean] = ACTIONS(2058),
    [anon_sym_string] = ACTIONS(2058),
    [anon_sym_symbol] = ACTIONS(2058),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_export] = ACTIONS(1556),
    [anon_sym_default] = ACTIONS(1556),
    [anon_sym_type] = ACTIONS(1556),
    [anon_sym_namespace] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_COMMA] = ACTIONS(1554),
    [anon_sym_RBRACE] = ACTIONS(1554),
    [anon_sym_typeof] = ACTIONS(1556),
    [anon_sym_import] = ACTIONS(1556),
    [anon_sym_var] = ACTIONS(1556),
    [anon_sym_let] = ACTIONS(1556),
    [anon_sym_const] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1554),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_if] = ACTIONS(1556),
    [anon_sym_switch] = ACTIONS(1556),
    [anon_sym_for] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_await] = ACTIONS(1556),
    [anon_sym_while] = ACTIONS(1556),
    [anon_sym_do] = ACTIONS(1556),
    [anon_sym_try] = ACTIONS(1556),
    [anon_sym_with] = ACTIONS(1556),
    [anon_sym_break] = ACTIONS(1556),
    [anon_sym_continue] = ACTIONS(1556),
    [anon_sym_debugger] = ACTIONS(1556),
    [anon_sym_return] = ACTIONS(1556),
    [anon_sym_throw] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1554),
    [anon_sym_case] = ACTIONS(1556),
    [anon_sym_yield] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_LT] = ACTIONS(1554),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_class] = ACTIONS(1556),
    [anon_sym_async] = ACTIONS(1556),
    [anon_sym_function] = ACTIONS(1556),
    [anon_sym_new] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1556),
    [anon_sym_delete] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1554),
    [anon_sym_DASH_DASH] = ACTIONS(1554),
    [anon_sym_DQUOTE] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1554),
    [sym_number] = ACTIONS(1554),
    [sym_this] = ACTIONS(1556),
    [sym_super] = ACTIONS(1556),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1556),
    [anon_sym_readonly] = ACTIONS(1556),
    [anon_sym_get] = ACTIONS(1556),
    [anon_sym_set] = ACTIONS(1556),
    [anon_sym_declare] = ACTIONS(1556),
    [anon_sym_public] = ACTIONS(1556),
    [anon_sym_private] = ACTIONS(1556),
    [anon_sym_protected] = ACTIONS(1556),
    [anon_sym_override] = ACTIONS(1556),
    [anon_sym_module] = ACTIONS(1556),
    [anon_sym_any] = ACTIONS(1556),
    [anon_sym_number] = ACTIONS(1556),
    [anon_sym_boolean] = ACTIONS(1556),
    [anon_sym_string] = ACTIONS(1556),
    [anon_sym_symbol] = ACTIONS(1556),
    [anon_sym_abstract] = ACTIONS(1556),
    [anon_sym_interface] = ACTIONS(1556),
    [anon_sym_enum] = ACTIONS(1556),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1554),
    [sym__automatic_semicolon] = ACTIONS(1554),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_export] = ACTIONS(1346),
    [anon_sym_default] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_typeof] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_var] = ACTIONS(1346),
    [anon_sym_let] = ACTIONS(1346),
    [anon_sym_const] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_switch] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_do] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_debugger] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_throw] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1344),
    [anon_sym_case] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_LT] = ACTIONS(1344),
    [anon_sym_SLASH] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1346),
    [anon_sym_new] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_void] = ACTIONS(1346),
    [anon_sym_delete] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [sym_number] = ACTIONS(1344),
    [sym_this] = ACTIONS(1346),
    [sym_super] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_null] = ACTIONS(1346),
    [sym_undefined] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_static] = ACTIONS(1346),
    [anon_sym_readonly] = ACTIONS(1346),
    [anon_sym_get] = ACTIONS(1346),
    [anon_sym_set] = ACTIONS(1346),
    [anon_sym_declare] = ACTIONS(1346),
    [anon_sym_public] = ACTIONS(1346),
    [anon_sym_private] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1346),
    [anon_sym_override] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [anon_sym_any] = ACTIONS(1346),
    [anon_sym_number] = ACTIONS(1346),
    [anon_sym_boolean] = ACTIONS(1346),
    [anon_sym_string] = ACTIONS(1346),
    [anon_sym_symbol] = ACTIONS(1346),
    [anon_sym_abstract] = ACTIONS(1346),
    [anon_sym_interface] = ACTIONS(1346),
    [anon_sym_enum] = ACTIONS(1346),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1344),
    [sym__automatic_semicolon] = ACTIONS(2066),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1496),
    [anon_sym_export] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_type] = ACTIONS(1496),
    [anon_sym_namespace] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_COMMA] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [anon_sym_typeof] = ACTIONS(1496),
    [anon_sym_import] = ACTIONS(1496),
    [anon_sym_var] = ACTIONS(1496),
    [anon_sym_let] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_try] = ACTIONS(1496),
    [anon_sym_with] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_debugger] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_throw] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_SLASH] = ACTIONS(1496),
    [anon_sym_class] = ACTIONS(1496),
    [anon_sym_async] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(1496),
    [anon_sym_new] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1496),
    [anon_sym_delete] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [sym_number] = ACTIONS(1494),
    [sym_this] = ACTIONS(1496),
    [sym_super] = ACTIONS(1496),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [sym_null] = ACTIONS(1496),
    [sym_undefined] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_readonly] = ACTIONS(1496),
    [anon_sym_get] = ACTIONS(1496),
    [anon_sym_set] = ACTIONS(1496),
    [anon_sym_declare] = ACTIONS(1496),
    [anon_sym_public] = ACTIONS(1496),
    [anon_sym_private] = ACTIONS(1496),
    [anon_sym_protected] = ACTIONS(1496),
    [anon_sym_override] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1496),
    [anon_sym_number] = ACTIONS(1496),
    [anon_sym_boolean] = ACTIONS(1496),
    [anon_sym_string] = ACTIONS(1496),
    [anon_sym_symbol] = ACTIONS(1496),
    [anon_sym_abstract] = ACTIONS(1496),
    [anon_sym_interface] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1494),
    [sym__automatic_semicolon] = ACTIONS(1494),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1492),
    [anon_sym_default] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(1492),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_var] = ACTIONS(1492),
    [anon_sym_let] = ACTIONS(1492),
    [anon_sym_const] = ACTIONS(1492),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_else] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_switch] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_await] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_do] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_debugger] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_throw] = ACTIONS(1492),
    [anon_sym_SEMI] = ACTIONS(1490),
    [anon_sym_case] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_LT] = ACTIONS(1490),
    [anon_sym_SLASH] = ACTIONS(1492),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_function] = ACTIONS(1492),
    [anon_sym_new] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_void] = ACTIONS(1492),
    [anon_sym_delete] = ACTIONS(1492),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [sym_number] = ACTIONS(1490),
    [sym_this] = ACTIONS(1492),
    [sym_super] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_null] = ACTIONS(1492),
    [sym_undefined] = ACTIONS(1492),
    [anon_sym_AT] = ACTIONS(1490),
    [anon_sym_static] = ACTIONS(1492),
    [anon_sym_readonly] = ACTIONS(1492),
    [anon_sym_get] = ACTIONS(1492),
    [anon_sym_set] = ACTIONS(1492),
    [anon_sym_declare] = ACTIONS(1492),
    [anon_sym_public] = ACTIONS(1492),
    [anon_sym_private] = ACTIONS(1492),
    [anon_sym_protected] = ACTIONS(1492),
    [anon_sym_override] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(1492),
    [anon_sym_any] = ACTIONS(1492),
    [anon_sym_number] = ACTIONS(1492),
    [anon_sym_boolean] = ACTIONS(1492),
    [anon_sym_string] = ACTIONS(1492),
    [anon_sym_symbol] = ACTIONS(1492),
    [anon_sym_abstract] = ACTIONS(1492),
    [anon_sym_interface] = ACTIONS(1492),
    [anon_sym_enum] = ACTIONS(1492),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1490),
    [sym__automatic_semicolon] = ACTIONS(1490),
  },
  [600] = {
    [sym__call_signature] = STATE(4050),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_export] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(1257),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(2054),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2041),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1259),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2041),
    [anon_sym_readonly] = ACTIONS(2041),
    [anon_sym_get] = ACTIONS(2041),
    [anon_sym_set] = ACTIONS(2041),
    [anon_sym_declare] = ACTIONS(2041),
    [anon_sym_public] = ACTIONS(2041),
    [anon_sym_private] = ACTIONS(2041),
    [anon_sym_protected] = ACTIONS(2041),
    [anon_sym_override] = ACTIONS(2041),
    [anon_sym_module] = ACTIONS(2041),
    [anon_sym_any] = ACTIONS(2041),
    [anon_sym_number] = ACTIONS(2041),
    [anon_sym_boolean] = ACTIONS(2041),
    [anon_sym_string] = ACTIONS(2041),
    [anon_sym_symbol] = ACTIONS(2041),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [601] = {
    [sym__call_signature] = STATE(4156),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_EQ] = ACTIONS(1306),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2058),
    [anon_sym_function] = ACTIONS(2027),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_readonly] = ACTIONS(2058),
    [anon_sym_get] = ACTIONS(2058),
    [anon_sym_set] = ACTIONS(2058),
    [anon_sym_declare] = ACTIONS(2058),
    [anon_sym_public] = ACTIONS(2058),
    [anon_sym_private] = ACTIONS(2058),
    [anon_sym_protected] = ACTIONS(2058),
    [anon_sym_override] = ACTIONS(2058),
    [anon_sym_module] = ACTIONS(2058),
    [anon_sym_any] = ACTIONS(2058),
    [anon_sym_number] = ACTIONS(2058),
    [anon_sym_boolean] = ACTIONS(2058),
    [anon_sym_string] = ACTIONS(2058),
    [anon_sym_symbol] = ACTIONS(2058),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [602] = {
    [sym__call_signature] = STATE(4156),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2056),
    [anon_sym_export] = ACTIONS(2058),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2058),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2058),
    [anon_sym_function] = ACTIONS(2025),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_readonly] = ACTIONS(2058),
    [anon_sym_get] = ACTIONS(2058),
    [anon_sym_set] = ACTIONS(2058),
    [anon_sym_declare] = ACTIONS(2058),
    [anon_sym_public] = ACTIONS(2058),
    [anon_sym_private] = ACTIONS(2058),
    [anon_sym_protected] = ACTIONS(2058),
    [anon_sym_override] = ACTIONS(2058),
    [anon_sym_module] = ACTIONS(2058),
    [anon_sym_any] = ACTIONS(2058),
    [anon_sym_number] = ACTIONS(2058),
    [anon_sym_boolean] = ACTIONS(2058),
    [anon_sym_string] = ACTIONS(2058),
    [anon_sym_symbol] = ACTIONS(2058),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1488),
    [anon_sym_default] = ACTIONS(1488),
    [anon_sym_type] = ACTIONS(1488),
    [anon_sym_namespace] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_COMMA] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [anon_sym_typeof] = ACTIONS(1488),
    [anon_sym_import] = ACTIONS(1488),
    [anon_sym_var] = ACTIONS(1488),
    [anon_sym_let] = ACTIONS(1488),
    [anon_sym_const] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_else] = ACTIONS(1488),
    [anon_sym_if] = ACTIONS(1488),
    [anon_sym_switch] = ACTIONS(1488),
    [anon_sym_for] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [anon_sym_await] = ACTIONS(1488),
    [anon_sym_while] = ACTIONS(1488),
    [anon_sym_do] = ACTIONS(1488),
    [anon_sym_try] = ACTIONS(1488),
    [anon_sym_with] = ACTIONS(1488),
    [anon_sym_break] = ACTIONS(1488),
    [anon_sym_continue] = ACTIONS(1488),
    [anon_sym_debugger] = ACTIONS(1488),
    [anon_sym_return] = ACTIONS(1488),
    [anon_sym_throw] = ACTIONS(1488),
    [anon_sym_SEMI] = ACTIONS(1486),
    [anon_sym_case] = ACTIONS(1488),
    [anon_sym_yield] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_SLASH] = ACTIONS(1488),
    [anon_sym_class] = ACTIONS(1488),
    [anon_sym_async] = ACTIONS(1488),
    [anon_sym_function] = ACTIONS(1488),
    [anon_sym_new] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_void] = ACTIONS(1488),
    [anon_sym_delete] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [sym_number] = ACTIONS(1486),
    [sym_this] = ACTIONS(1488),
    [sym_super] = ACTIONS(1488),
    [sym_true] = ACTIONS(1488),
    [sym_false] = ACTIONS(1488),
    [sym_null] = ACTIONS(1488),
    [sym_undefined] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1486),
    [anon_sym_static] = ACTIONS(1488),
    [anon_sym_readonly] = ACTIONS(1488),
    [anon_sym_get] = ACTIONS(1488),
    [anon_sym_set] = ACTIONS(1488),
    [anon_sym_declare] = ACTIONS(1488),
    [anon_sym_public] = ACTIONS(1488),
    [anon_sym_private] = ACTIONS(1488),
    [anon_sym_protected] = ACTIONS(1488),
    [anon_sym_override] = ACTIONS(1488),
    [anon_sym_module] = ACTIONS(1488),
    [anon_sym_any] = ACTIONS(1488),
    [anon_sym_number] = ACTIONS(1488),
    [anon_sym_boolean] = ACTIONS(1488),
    [anon_sym_string] = ACTIONS(1488),
    [anon_sym_symbol] = ACTIONS(1488),
    [anon_sym_abstract] = ACTIONS(1488),
    [anon_sym_interface] = ACTIONS(1488),
    [anon_sym_enum] = ACTIONS(1488),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1486),
    [sym__automatic_semicolon] = ACTIONS(1486),
  },
  [604] = {
    [sym__call_signature] = STATE(4084),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [605] = {
    [sym_finally_clause] = STATE(731),
    [ts_builtin_sym_end] = ACTIONS(2068),
    [sym_identifier] = ACTIONS(2070),
    [anon_sym_export] = ACTIONS(2070),
    [anon_sym_default] = ACTIONS(2070),
    [anon_sym_type] = ACTIONS(2070),
    [anon_sym_namespace] = ACTIONS(2070),
    [anon_sym_LBRACE] = ACTIONS(2068),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_typeof] = ACTIONS(2070),
    [anon_sym_import] = ACTIONS(2070),
    [anon_sym_var] = ACTIONS(2070),
    [anon_sym_let] = ACTIONS(2070),
    [anon_sym_const] = ACTIONS(2070),
    [anon_sym_BANG] = ACTIONS(2068),
    [anon_sym_else] = ACTIONS(2070),
    [anon_sym_if] = ACTIONS(2070),
    [anon_sym_switch] = ACTIONS(2070),
    [anon_sym_for] = ACTIONS(2070),
    [anon_sym_LPAREN] = ACTIONS(2068),
    [anon_sym_await] = ACTIONS(2070),
    [anon_sym_while] = ACTIONS(2070),
    [anon_sym_do] = ACTIONS(2070),
    [anon_sym_try] = ACTIONS(2070),
    [anon_sym_with] = ACTIONS(2070),
    [anon_sym_break] = ACTIONS(2070),
    [anon_sym_continue] = ACTIONS(2070),
    [anon_sym_debugger] = ACTIONS(2070),
    [anon_sym_return] = ACTIONS(2070),
    [anon_sym_throw] = ACTIONS(2070),
    [anon_sym_SEMI] = ACTIONS(2068),
    [anon_sym_case] = ACTIONS(2070),
    [anon_sym_finally] = ACTIONS(2049),
    [anon_sym_yield] = ACTIONS(2070),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_SLASH] = ACTIONS(2070),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_async] = ACTIONS(2070),
    [anon_sym_function] = ACTIONS(2070),
    [anon_sym_new] = ACTIONS(2070),
    [anon_sym_PLUS] = ACTIONS(2070),
    [anon_sym_DASH] = ACTIONS(2070),
    [anon_sym_TILDE] = ACTIONS(2068),
    [anon_sym_void] = ACTIONS(2070),
    [anon_sym_delete] = ACTIONS(2070),
    [anon_sym_PLUS_PLUS] = ACTIONS(2068),
    [anon_sym_DASH_DASH] = ACTIONS(2068),
    [anon_sym_DQUOTE] = ACTIONS(2068),
    [anon_sym_SQUOTE] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2068),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(2070),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(2068),
    [anon_sym_static] = ACTIONS(2070),
    [anon_sym_readonly] = ACTIONS(2070),
    [anon_sym_get] = ACTIONS(2070),
    [anon_sym_set] = ACTIONS(2070),
    [anon_sym_declare] = ACTIONS(2070),
    [anon_sym_public] = ACTIONS(2070),
    [anon_sym_private] = ACTIONS(2070),
    [anon_sym_protected] = ACTIONS(2070),
    [anon_sym_override] = ACTIONS(2070),
    [anon_sym_module] = ACTIONS(2070),
    [anon_sym_any] = ACTIONS(2070),
    [anon_sym_number] = ACTIONS(2070),
    [anon_sym_boolean] = ACTIONS(2070),
    [anon_sym_string] = ACTIONS(2070),
    [anon_sym_symbol] = ACTIONS(2070),
    [anon_sym_abstract] = ACTIONS(2070),
    [anon_sym_interface] = ACTIONS(2070),
    [anon_sym_enum] = ACTIONS(2070),
  },
  [606] = {
    [sym__call_signature] = STATE(4094),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2074),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2074),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1314),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2074),
    [anon_sym_readonly] = ACTIONS(2074),
    [anon_sym_get] = ACTIONS(2074),
    [anon_sym_set] = ACTIONS(2074),
    [anon_sym_declare] = ACTIONS(2074),
    [anon_sym_public] = ACTIONS(2074),
    [anon_sym_private] = ACTIONS(2074),
    [anon_sym_protected] = ACTIONS(2074),
    [anon_sym_override] = ACTIONS(2074),
    [anon_sym_module] = ACTIONS(2074),
    [anon_sym_any] = ACTIONS(2074),
    [anon_sym_number] = ACTIONS(2074),
    [anon_sym_boolean] = ACTIONS(2074),
    [anon_sym_string] = ACTIONS(2074),
    [anon_sym_symbol] = ACTIONS(2074),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [607] = {
    [sym__call_signature] = STATE(4084),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(2020),
    [anon_sym_of] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [608] = {
    [sym__call_signature] = STATE(4094),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2072),
    [anon_sym_export] = ACTIONS(2074),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2074),
    [anon_sym_EQ] = ACTIONS(1312),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2074),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_of] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2074),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(1314),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2074),
    [anon_sym_readonly] = ACTIONS(2074),
    [anon_sym_get] = ACTIONS(2074),
    [anon_sym_set] = ACTIONS(2074),
    [anon_sym_declare] = ACTIONS(2074),
    [anon_sym_public] = ACTIONS(2074),
    [anon_sym_private] = ACTIONS(2074),
    [anon_sym_protected] = ACTIONS(2074),
    [anon_sym_override] = ACTIONS(2074),
    [anon_sym_module] = ACTIONS(2074),
    [anon_sym_any] = ACTIONS(2074),
    [anon_sym_number] = ACTIONS(2074),
    [anon_sym_boolean] = ACTIONS(2074),
    [anon_sym_string] = ACTIONS(2074),
    [anon_sym_symbol] = ACTIONS(2074),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [609] = {
    [sym_statement_block] = STATE(652),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_export] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(2076),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_typeof] = ACTIONS(1326),
    [anon_sym_import] = ACTIONS(1326),
    [anon_sym_var] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_await] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [anon_sym_with] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_debugger] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_throw] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_DOT] = ACTIONS(2078),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_function] = ACTIONS(1326),
    [anon_sym_new] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_void] = ACTIONS(1326),
    [anon_sym_delete] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [sym_number] = ACTIONS(1324),
    [sym_this] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [sym_null] = ACTIONS(1326),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_readonly] = ACTIONS(1326),
    [anon_sym_get] = ACTIONS(1326),
    [anon_sym_set] = ACTIONS(1326),
    [anon_sym_declare] = ACTIONS(1326),
    [anon_sym_public] = ACTIONS(1326),
    [anon_sym_private] = ACTIONS(1326),
    [anon_sym_protected] = ACTIONS(1326),
    [anon_sym_override] = ACTIONS(1326),
    [anon_sym_module] = ACTIONS(1326),
    [anon_sym_any] = ACTIONS(1326),
    [anon_sym_number] = ACTIONS(1326),
    [anon_sym_boolean] = ACTIONS(1326),
    [anon_sym_string] = ACTIONS(1326),
    [anon_sym_symbol] = ACTIONS(1326),
    [anon_sym_abstract] = ACTIONS(1326),
    [anon_sym_interface] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(2080),
    [sym_identifier] = ACTIONS(2082),
    [anon_sym_export] = ACTIONS(2082),
    [anon_sym_default] = ACTIONS(2082),
    [anon_sym_type] = ACTIONS(2082),
    [anon_sym_namespace] = ACTIONS(2082),
    [anon_sym_LBRACE] = ACTIONS(2080),
    [anon_sym_RBRACE] = ACTIONS(2080),
    [anon_sym_typeof] = ACTIONS(2082),
    [anon_sym_import] = ACTIONS(2082),
    [anon_sym_var] = ACTIONS(2082),
    [anon_sym_let] = ACTIONS(2082),
    [anon_sym_const] = ACTIONS(2082),
    [anon_sym_BANG] = ACTIONS(2080),
    [anon_sym_else] = ACTIONS(2082),
    [anon_sym_if] = ACTIONS(2082),
    [anon_sym_switch] = ACTIONS(2082),
    [anon_sym_for] = ACTIONS(2082),
    [anon_sym_LPAREN] = ACTIONS(2080),
    [anon_sym_RPAREN] = ACTIONS(2080),
    [anon_sym_await] = ACTIONS(2082),
    [anon_sym_while] = ACTIONS(2082),
    [anon_sym_do] = ACTIONS(2082),
    [anon_sym_try] = ACTIONS(2082),
    [anon_sym_with] = ACTIONS(2082),
    [anon_sym_break] = ACTIONS(2082),
    [anon_sym_continue] = ACTIONS(2082),
    [anon_sym_debugger] = ACTIONS(2082),
    [anon_sym_return] = ACTIONS(2082),
    [anon_sym_throw] = ACTIONS(2082),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_case] = ACTIONS(2082),
    [anon_sym_yield] = ACTIONS(2082),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_LT] = ACTIONS(2080),
    [anon_sym_SLASH] = ACTIONS(2082),
    [anon_sym_class] = ACTIONS(2082),
    [anon_sym_async] = ACTIONS(2082),
    [anon_sym_function] = ACTIONS(2082),
    [anon_sym_new] = ACTIONS(2082),
    [anon_sym_PLUS] = ACTIONS(2082),
    [anon_sym_DASH] = ACTIONS(2082),
    [anon_sym_TILDE] = ACTIONS(2080),
    [anon_sym_void] = ACTIONS(2082),
    [anon_sym_delete] = ACTIONS(2082),
    [anon_sym_PLUS_PLUS] = ACTIONS(2080),
    [anon_sym_DASH_DASH] = ACTIONS(2080),
    [anon_sym_DQUOTE] = ACTIONS(2080),
    [anon_sym_SQUOTE] = ACTIONS(2080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2080),
    [sym_number] = ACTIONS(2080),
    [sym_this] = ACTIONS(2082),
    [sym_super] = ACTIONS(2082),
    [sym_true] = ACTIONS(2082),
    [sym_false] = ACTIONS(2082),
    [sym_null] = ACTIONS(2082),
    [sym_undefined] = ACTIONS(2082),
    [anon_sym_AT] = ACTIONS(2080),
    [anon_sym_static] = ACTIONS(2082),
    [anon_sym_readonly] = ACTIONS(2082),
    [anon_sym_get] = ACTIONS(2082),
    [anon_sym_set] = ACTIONS(2082),
    [anon_sym_declare] = ACTIONS(2082),
    [anon_sym_public] = ACTIONS(2082),
    [anon_sym_private] = ACTIONS(2082),
    [anon_sym_protected] = ACTIONS(2082),
    [anon_sym_override] = ACTIONS(2082),
    [anon_sym_module] = ACTIONS(2082),
    [anon_sym_any] = ACTIONS(2082),
    [anon_sym_number] = ACTIONS(2082),
    [anon_sym_boolean] = ACTIONS(2082),
    [anon_sym_string] = ACTIONS(2082),
    [anon_sym_symbol] = ACTIONS(2082),
    [anon_sym_abstract] = ACTIONS(2082),
    [anon_sym_interface] = ACTIONS(2082),
    [anon_sym_enum] = ACTIONS(2082),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(1380),
    [sym_identifier] = ACTIONS(1382),
    [anon_sym_export] = ACTIONS(1382),
    [anon_sym_default] = ACTIONS(1382),
    [anon_sym_type] = ACTIONS(1382),
    [anon_sym_namespace] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [anon_sym_typeof] = ACTIONS(1382),
    [anon_sym_import] = ACTIONS(1382),
    [anon_sym_var] = ACTIONS(1382),
    [anon_sym_let] = ACTIONS(1382),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_if] = ACTIONS(1382),
    [anon_sym_switch] = ACTIONS(1382),
    [anon_sym_for] = ACTIONS(1382),
    [anon_sym_LPAREN] = ACTIONS(1380),
    [anon_sym_await] = ACTIONS(1382),
    [anon_sym_while] = ACTIONS(1382),
    [anon_sym_do] = ACTIONS(1382),
    [anon_sym_try] = ACTIONS(1382),
    [anon_sym_with] = ACTIONS(1382),
    [anon_sym_break] = ACTIONS(1382),
    [anon_sym_continue] = ACTIONS(1382),
    [anon_sym_debugger] = ACTIONS(1382),
    [anon_sym_return] = ACTIONS(1382),
    [anon_sym_throw] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_case] = ACTIONS(1382),
    [anon_sym_yield] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_SLASH] = ACTIONS(1382),
    [anon_sym_DOT] = ACTIONS(1382),
    [anon_sym_class] = ACTIONS(1382),
    [anon_sym_async] = ACTIONS(1382),
    [anon_sym_function] = ACTIONS(1382),
    [anon_sym_new] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_void] = ACTIONS(1382),
    [anon_sym_delete] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [sym_number] = ACTIONS(1380),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1382),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1380),
    [anon_sym_static] = ACTIONS(1382),
    [anon_sym_readonly] = ACTIONS(1382),
    [anon_sym_get] = ACTIONS(1382),
    [anon_sym_set] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1382),
    [anon_sym_public] = ACTIONS(1382),
    [anon_sym_private] = ACTIONS(1382),
    [anon_sym_protected] = ACTIONS(1382),
    [anon_sym_override] = ACTIONS(1382),
    [anon_sym_module] = ACTIONS(1382),
    [anon_sym_any] = ACTIONS(1382),
    [anon_sym_number] = ACTIONS(1382),
    [anon_sym_boolean] = ACTIONS(1382),
    [anon_sym_string] = ACTIONS(1382),
    [anon_sym_symbol] = ACTIONS(1382),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_interface] = ACTIONS(1382),
    [anon_sym_enum] = ACTIONS(1382),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1462),
    [anon_sym_export] = ACTIONS(1462),
    [anon_sym_default] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(1462),
    [anon_sym_namespace] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1462),
    [anon_sym_import] = ACTIONS(1462),
    [anon_sym_var] = ACTIONS(1462),
    [anon_sym_let] = ACTIONS(1462),
    [anon_sym_const] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_else] = ACTIONS(1462),
    [anon_sym_if] = ACTIONS(1462),
    [anon_sym_switch] = ACTIONS(1462),
    [anon_sym_for] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1460),
    [anon_sym_await] = ACTIONS(1462),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1462),
    [anon_sym_try] = ACTIONS(1462),
    [anon_sym_with] = ACTIONS(1462),
    [anon_sym_break] = ACTIONS(1462),
    [anon_sym_continue] = ACTIONS(1462),
    [anon_sym_debugger] = ACTIONS(1462),
    [anon_sym_return] = ACTIONS(1462),
    [anon_sym_throw] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_case] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(1462),
    [anon_sym_class] = ACTIONS(1462),
    [anon_sym_async] = ACTIONS(1462),
    [anon_sym_function] = ACTIONS(1462),
    [anon_sym_new] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_void] = ACTIONS(1462),
    [anon_sym_delete] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [sym_number] = ACTIONS(1460),
    [sym_this] = ACTIONS(1462),
    [sym_super] = ACTIONS(1462),
    [sym_true] = ACTIONS(1462),
    [sym_false] = ACTIONS(1462),
    [sym_null] = ACTIONS(1462),
    [sym_undefined] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1460),
    [anon_sym_static] = ACTIONS(1462),
    [anon_sym_readonly] = ACTIONS(1462),
    [anon_sym_get] = ACTIONS(1462),
    [anon_sym_set] = ACTIONS(1462),
    [anon_sym_declare] = ACTIONS(1462),
    [anon_sym_public] = ACTIONS(1462),
    [anon_sym_private] = ACTIONS(1462),
    [anon_sym_protected] = ACTIONS(1462),
    [anon_sym_override] = ACTIONS(1462),
    [anon_sym_module] = ACTIONS(1462),
    [anon_sym_any] = ACTIONS(1462),
    [anon_sym_number] = ACTIONS(1462),
    [anon_sym_boolean] = ACTIONS(1462),
    [anon_sym_string] = ACTIONS(1462),
    [anon_sym_symbol] = ACTIONS(1462),
    [anon_sym_abstract] = ACTIONS(1462),
    [anon_sym_interface] = ACTIONS(1462),
    [anon_sym_enum] = ACTIONS(1462),
    [sym__automatic_semicolon] = ACTIONS(1468),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(2084),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_export] = ACTIONS(2086),
    [anon_sym_default] = ACTIONS(2086),
    [anon_sym_type] = ACTIONS(2086),
    [anon_sym_namespace] = ACTIONS(2086),
    [anon_sym_LBRACE] = ACTIONS(2084),
    [anon_sym_RBRACE] = ACTIONS(2084),
    [anon_sym_typeof] = ACTIONS(2086),
    [anon_sym_import] = ACTIONS(2086),
    [anon_sym_var] = ACTIONS(2086),
    [anon_sym_let] = ACTIONS(2086),
    [anon_sym_const] = ACTIONS(2086),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_else] = ACTIONS(2086),
    [anon_sym_if] = ACTIONS(2086),
    [anon_sym_switch] = ACTIONS(2086),
    [anon_sym_for] = ACTIONS(2086),
    [anon_sym_LPAREN] = ACTIONS(2084),
    [anon_sym_RPAREN] = ACTIONS(2084),
    [anon_sym_await] = ACTIONS(2086),
    [anon_sym_while] = ACTIONS(2086),
    [anon_sym_do] = ACTIONS(2086),
    [anon_sym_try] = ACTIONS(2086),
    [anon_sym_with] = ACTIONS(2086),
    [anon_sym_break] = ACTIONS(2086),
    [anon_sym_continue] = ACTIONS(2086),
    [anon_sym_debugger] = ACTIONS(2086),
    [anon_sym_return] = ACTIONS(2086),
    [anon_sym_throw] = ACTIONS(2086),
    [anon_sym_SEMI] = ACTIONS(2084),
    [anon_sym_case] = ACTIONS(2086),
    [anon_sym_yield] = ACTIONS(2086),
    [anon_sym_LBRACK] = ACTIONS(2084),
    [anon_sym_LT] = ACTIONS(2084),
    [anon_sym_SLASH] = ACTIONS(2086),
    [anon_sym_class] = ACTIONS(2086),
    [anon_sym_async] = ACTIONS(2086),
    [anon_sym_function] = ACTIONS(2086),
    [anon_sym_new] = ACTIONS(2086),
    [anon_sym_PLUS] = ACTIONS(2086),
    [anon_sym_DASH] = ACTIONS(2086),
    [anon_sym_TILDE] = ACTIONS(2084),
    [anon_sym_void] = ACTIONS(2086),
    [anon_sym_delete] = ACTIONS(2086),
    [anon_sym_PLUS_PLUS] = ACTIONS(2084),
    [anon_sym_DASH_DASH] = ACTIONS(2084),
    [anon_sym_DQUOTE] = ACTIONS(2084),
    [anon_sym_SQUOTE] = ACTIONS(2084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2084),
    [sym_number] = ACTIONS(2084),
    [sym_this] = ACTIONS(2086),
    [sym_super] = ACTIONS(2086),
    [sym_true] = ACTIONS(2086),
    [sym_false] = ACTIONS(2086),
    [sym_null] = ACTIONS(2086),
    [sym_undefined] = ACTIONS(2086),
    [anon_sym_AT] = ACTIONS(2084),
    [anon_sym_static] = ACTIONS(2086),
    [anon_sym_readonly] = ACTIONS(2086),
    [anon_sym_get] = ACTIONS(2086),
    [anon_sym_set] = ACTIONS(2086),
    [anon_sym_declare] = ACTIONS(2086),
    [anon_sym_public] = ACTIONS(2086),
    [anon_sym_private] = ACTIONS(2086),
    [anon_sym_protected] = ACTIONS(2086),
    [anon_sym_override] = ACTIONS(2086),
    [anon_sym_module] = ACTIONS(2086),
    [anon_sym_any] = ACTIONS(2086),
    [anon_sym_number] = ACTIONS(2086),
    [anon_sym_boolean] = ACTIONS(2086),
    [anon_sym_string] = ACTIONS(2086),
    [anon_sym_symbol] = ACTIONS(2086),
    [anon_sym_abstract] = ACTIONS(2086),
    [anon_sym_interface] = ACTIONS(2086),
    [anon_sym_enum] = ACTIONS(2086),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(2088),
    [sym_identifier] = ACTIONS(2090),
    [anon_sym_export] = ACTIONS(2090),
    [anon_sym_default] = ACTIONS(2090),
    [anon_sym_type] = ACTIONS(2090),
    [anon_sym_namespace] = ACTIONS(2090),
    [anon_sym_LBRACE] = ACTIONS(2088),
    [anon_sym_RBRACE] = ACTIONS(2088),
    [anon_sym_typeof] = ACTIONS(2090),
    [anon_sym_import] = ACTIONS(2090),
    [anon_sym_var] = ACTIONS(2090),
    [anon_sym_let] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_else] = ACTIONS(2090),
    [anon_sym_if] = ACTIONS(2090),
    [anon_sym_switch] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2090),
    [anon_sym_LPAREN] = ACTIONS(2088),
    [anon_sym_await] = ACTIONS(2090),
    [anon_sym_while] = ACTIONS(2090),
    [anon_sym_do] = ACTIONS(2090),
    [anon_sym_try] = ACTIONS(2090),
    [anon_sym_with] = ACTIONS(2090),
    [anon_sym_break] = ACTIONS(2090),
    [anon_sym_continue] = ACTIONS(2090),
    [anon_sym_debugger] = ACTIONS(2090),
    [anon_sym_return] = ACTIONS(2090),
    [anon_sym_throw] = ACTIONS(2090),
    [anon_sym_SEMI] = ACTIONS(2088),
    [anon_sym_case] = ACTIONS(2090),
    [anon_sym_finally] = ACTIONS(2090),
    [anon_sym_yield] = ACTIONS(2090),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_LT] = ACTIONS(2088),
    [anon_sym_SLASH] = ACTIONS(2090),
    [anon_sym_class] = ACTIONS(2090),
    [anon_sym_async] = ACTIONS(2090),
    [anon_sym_function] = ACTIONS(2090),
    [anon_sym_new] = ACTIONS(2090),
    [anon_sym_PLUS] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(2090),
    [anon_sym_TILDE] = ACTIONS(2088),
    [anon_sym_void] = ACTIONS(2090),
    [anon_sym_delete] = ACTIONS(2090),
    [anon_sym_PLUS_PLUS] = ACTIONS(2088),
    [anon_sym_DASH_DASH] = ACTIONS(2088),
    [anon_sym_DQUOTE] = ACTIONS(2088),
    [anon_sym_SQUOTE] = ACTIONS(2088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2088),
    [sym_number] = ACTIONS(2088),
    [sym_this] = ACTIONS(2090),
    [sym_super] = ACTIONS(2090),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [sym_null] = ACTIONS(2090),
    [sym_undefined] = ACTIONS(2090),
    [anon_sym_AT] = ACTIONS(2088),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_readonly] = ACTIONS(2090),
    [anon_sym_get] = ACTIONS(2090),
    [anon_sym_set] = ACTIONS(2090),
    [anon_sym_declare] = ACTIONS(2090),
    [anon_sym_public] = ACTIONS(2090),
    [anon_sym_private] = ACTIONS(2090),
    [anon_sym_protected] = ACTIONS(2090),
    [anon_sym_override] = ACTIONS(2090),
    [anon_sym_module] = ACTIONS(2090),
    [anon_sym_any] = ACTIONS(2090),
    [anon_sym_number] = ACTIONS(2090),
    [anon_sym_boolean] = ACTIONS(2090),
    [anon_sym_string] = ACTIONS(2090),
    [anon_sym_symbol] = ACTIONS(2090),
    [anon_sym_abstract] = ACTIONS(2090),
    [anon_sym_interface] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(1540),
    [sym_identifier] = ACTIONS(1542),
    [anon_sym_export] = ACTIONS(1542),
    [anon_sym_default] = ACTIONS(1542),
    [anon_sym_type] = ACTIONS(1542),
    [anon_sym_namespace] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_typeof] = ACTIONS(1542),
    [anon_sym_import] = ACTIONS(1542),
    [anon_sym_var] = ACTIONS(1542),
    [anon_sym_let] = ACTIONS(1542),
    [anon_sym_const] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_else] = ACTIONS(1542),
    [anon_sym_if] = ACTIONS(1542),
    [anon_sym_switch] = ACTIONS(1542),
    [anon_sym_for] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [anon_sym_await] = ACTIONS(1542),
    [anon_sym_while] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1542),
    [anon_sym_try] = ACTIONS(1542),
    [anon_sym_with] = ACTIONS(1542),
    [anon_sym_break] = ACTIONS(1542),
    [anon_sym_continue] = ACTIONS(1542),
    [anon_sym_debugger] = ACTIONS(1542),
    [anon_sym_return] = ACTIONS(1542),
    [anon_sym_throw] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_case] = ACTIONS(1542),
    [anon_sym_yield] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1542),
    [anon_sym_class] = ACTIONS(1542),
    [anon_sym_async] = ACTIONS(1542),
    [anon_sym_function] = ACTIONS(1542),
    [anon_sym_new] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_void] = ACTIONS(1542),
    [anon_sym_delete] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [sym_number] = ACTIONS(1540),
    [sym_this] = ACTIONS(1542),
    [sym_super] = ACTIONS(1542),
    [sym_true] = ACTIONS(1542),
    [sym_false] = ACTIONS(1542),
    [sym_null] = ACTIONS(1542),
    [sym_undefined] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1540),
    [anon_sym_static] = ACTIONS(1542),
    [anon_sym_readonly] = ACTIONS(1542),
    [anon_sym_get] = ACTIONS(1542),
    [anon_sym_set] = ACTIONS(1542),
    [anon_sym_declare] = ACTIONS(1542),
    [anon_sym_public] = ACTIONS(1542),
    [anon_sym_private] = ACTIONS(1542),
    [anon_sym_protected] = ACTIONS(1542),
    [anon_sym_override] = ACTIONS(1542),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_any] = ACTIONS(1542),
    [anon_sym_number] = ACTIONS(1542),
    [anon_sym_boolean] = ACTIONS(1542),
    [anon_sym_string] = ACTIONS(1542),
    [anon_sym_symbol] = ACTIONS(1542),
    [anon_sym_abstract] = ACTIONS(1542),
    [anon_sym_interface] = ACTIONS(1542),
    [anon_sym_enum] = ACTIONS(1542),
    [sym__automatic_semicolon] = ACTIONS(1548),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_identifier] = ACTIONS(1398),
    [anon_sym_export] = ACTIONS(1398),
    [anon_sym_default] = ACTIONS(1398),
    [anon_sym_type] = ACTIONS(1398),
    [anon_sym_namespace] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_typeof] = ACTIONS(1398),
    [anon_sym_import] = ACTIONS(1398),
    [anon_sym_var] = ACTIONS(1398),
    [anon_sym_let] = ACTIONS(1398),
    [anon_sym_const] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_else] = ACTIONS(1398),
    [anon_sym_if] = ACTIONS(1398),
    [anon_sym_switch] = ACTIONS(1398),
    [anon_sym_for] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_await] = ACTIONS(1398),
    [anon_sym_while] = ACTIONS(1398),
    [anon_sym_do] = ACTIONS(1398),
    [anon_sym_try] = ACTIONS(1398),
    [anon_sym_with] = ACTIONS(1398),
    [anon_sym_break] = ACTIONS(1398),
    [anon_sym_continue] = ACTIONS(1398),
    [anon_sym_debugger] = ACTIONS(1398),
    [anon_sym_return] = ACTIONS(1398),
    [anon_sym_throw] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1396),
    [anon_sym_case] = ACTIONS(1398),
    [anon_sym_yield] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_LT] = ACTIONS(1396),
    [anon_sym_SLASH] = ACTIONS(1398),
    [anon_sym_class] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_function] = ACTIONS(1398),
    [anon_sym_new] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_void] = ACTIONS(1398),
    [anon_sym_delete] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1396),
    [sym_number] = ACTIONS(1396),
    [sym_this] = ACTIONS(1398),
    [sym_super] = ACTIONS(1398),
    [sym_true] = ACTIONS(1398),
    [sym_false] = ACTIONS(1398),
    [sym_null] = ACTIONS(1398),
    [sym_undefined] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1396),
    [anon_sym_static] = ACTIONS(1398),
    [anon_sym_readonly] = ACTIONS(1398),
    [anon_sym_get] = ACTIONS(1398),
    [anon_sym_set] = ACTIONS(1398),
    [anon_sym_declare] = ACTIONS(1398),
    [anon_sym_public] = ACTIONS(1398),
    [anon_sym_private] = ACTIONS(1398),
    [anon_sym_protected] = ACTIONS(1398),
    [anon_sym_override] = ACTIONS(1398),
    [anon_sym_module] = ACTIONS(1398),
    [anon_sym_any] = ACTIONS(1398),
    [anon_sym_number] = ACTIONS(1398),
    [anon_sym_boolean] = ACTIONS(1398),
    [anon_sym_string] = ACTIONS(1398),
    [anon_sym_symbol] = ACTIONS(1398),
    [anon_sym_abstract] = ACTIONS(1398),
    [anon_sym_interface] = ACTIONS(1398),
    [anon_sym_enum] = ACTIONS(1398),
    [sym__automatic_semicolon] = ACTIONS(1404),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(2092),
    [sym_identifier] = ACTIONS(2094),
    [anon_sym_export] = ACTIONS(2094),
    [anon_sym_default] = ACTIONS(2094),
    [anon_sym_type] = ACTIONS(2094),
    [anon_sym_namespace] = ACTIONS(2094),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [anon_sym_typeof] = ACTIONS(2094),
    [anon_sym_import] = ACTIONS(2094),
    [anon_sym_var] = ACTIONS(2094),
    [anon_sym_let] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_BANG] = ACTIONS(2092),
    [anon_sym_else] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(2094),
    [anon_sym_switch] = ACTIONS(2094),
    [anon_sym_for] = ACTIONS(2094),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [anon_sym_await] = ACTIONS(2094),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_do] = ACTIONS(2094),
    [anon_sym_try] = ACTIONS(2094),
    [anon_sym_with] = ACTIONS(2094),
    [anon_sym_break] = ACTIONS(2094),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_debugger] = ACTIONS(2094),
    [anon_sym_return] = ACTIONS(2094),
    [anon_sym_throw] = ACTIONS(2094),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym_case] = ACTIONS(2094),
    [anon_sym_finally] = ACTIONS(2094),
    [anon_sym_yield] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2092),
    [anon_sym_LT] = ACTIONS(2092),
    [anon_sym_SLASH] = ACTIONS(2094),
    [anon_sym_class] = ACTIONS(2094),
    [anon_sym_async] = ACTIONS(2094),
    [anon_sym_function] = ACTIONS(2094),
    [anon_sym_new] = ACTIONS(2094),
    [anon_sym_PLUS] = ACTIONS(2094),
    [anon_sym_DASH] = ACTIONS(2094),
    [anon_sym_TILDE] = ACTIONS(2092),
    [anon_sym_void] = ACTIONS(2094),
    [anon_sym_delete] = ACTIONS(2094),
    [anon_sym_PLUS_PLUS] = ACTIONS(2092),
    [anon_sym_DASH_DASH] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [anon_sym_SQUOTE] = ACTIONS(2092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2092),
    [sym_number] = ACTIONS(2092),
    [sym_this] = ACTIONS(2094),
    [sym_super] = ACTIONS(2094),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [sym_null] = ACTIONS(2094),
    [sym_undefined] = ACTIONS(2094),
    [anon_sym_AT] = ACTIONS(2092),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_readonly] = ACTIONS(2094),
    [anon_sym_get] = ACTIONS(2094),
    [anon_sym_set] = ACTIONS(2094),
    [anon_sym_declare] = ACTIONS(2094),
    [anon_sym_public] = ACTIONS(2094),
    [anon_sym_private] = ACTIONS(2094),
    [anon_sym_protected] = ACTIONS(2094),
    [anon_sym_override] = ACTIONS(2094),
    [anon_sym_module] = ACTIONS(2094),
    [anon_sym_any] = ACTIONS(2094),
    [anon_sym_number] = ACTIONS(2094),
    [anon_sym_boolean] = ACTIONS(2094),
    [anon_sym_string] = ACTIONS(2094),
    [anon_sym_symbol] = ACTIONS(2094),
    [anon_sym_abstract] = ACTIONS(2094),
    [anon_sym_interface] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(1530),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_export] = ACTIONS(1532),
    [anon_sym_default] = ACTIONS(1532),
    [anon_sym_type] = ACTIONS(1532),
    [anon_sym_namespace] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [anon_sym_typeof] = ACTIONS(1532),
    [anon_sym_import] = ACTIONS(1532),
    [anon_sym_var] = ACTIONS(1532),
    [anon_sym_let] = ACTIONS(1532),
    [anon_sym_const] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_else] = ACTIONS(1532),
    [anon_sym_if] = ACTIONS(1532),
    [anon_sym_switch] = ACTIONS(1532),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [anon_sym_await] = ACTIONS(1532),
    [anon_sym_while] = ACTIONS(1532),
    [anon_sym_do] = ACTIONS(1532),
    [anon_sym_try] = ACTIONS(1532),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_break] = ACTIONS(1532),
    [anon_sym_continue] = ACTIONS(1532),
    [anon_sym_debugger] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1532),
    [anon_sym_throw] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1530),
    [anon_sym_case] = ACTIONS(1532),
    [anon_sym_yield] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1530),
    [anon_sym_LT] = ACTIONS(1530),
    [anon_sym_SLASH] = ACTIONS(1532),
    [anon_sym_class] = ACTIONS(1532),
    [anon_sym_async] = ACTIONS(1532),
    [anon_sym_function] = ACTIONS(1532),
    [anon_sym_new] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1530),
    [anon_sym_void] = ACTIONS(1532),
    [anon_sym_delete] = ACTIONS(1532),
    [anon_sym_PLUS_PLUS] = ACTIONS(1530),
    [anon_sym_DASH_DASH] = ACTIONS(1530),
    [anon_sym_DQUOTE] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1530),
    [sym_number] = ACTIONS(1530),
    [sym_this] = ACTIONS(1532),
    [sym_super] = ACTIONS(1532),
    [sym_true] = ACTIONS(1532),
    [sym_false] = ACTIONS(1532),
    [sym_null] = ACTIONS(1532),
    [sym_undefined] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(1530),
    [anon_sym_static] = ACTIONS(1532),
    [anon_sym_readonly] = ACTIONS(1532),
    [anon_sym_get] = ACTIONS(1532),
    [anon_sym_set] = ACTIONS(1532),
    [anon_sym_declare] = ACTIONS(1532),
    [anon_sym_public] = ACTIONS(1532),
    [anon_sym_private] = ACTIONS(1532),
    [anon_sym_protected] = ACTIONS(1532),
    [anon_sym_override] = ACTIONS(1532),
    [anon_sym_module] = ACTIONS(1532),
    [anon_sym_any] = ACTIONS(1532),
    [anon_sym_number] = ACTIONS(1532),
    [anon_sym_boolean] = ACTIONS(1532),
    [anon_sym_string] = ACTIONS(1532),
    [anon_sym_symbol] = ACTIONS(1532),
    [anon_sym_abstract] = ACTIONS(1532),
    [anon_sym_interface] = ACTIONS(1532),
    [anon_sym_enum] = ACTIONS(1532),
    [sym__automatic_semicolon] = ACTIONS(1538),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_identifier] = ACTIONS(1386),
    [anon_sym_export] = ACTIONS(1386),
    [anon_sym_default] = ACTIONS(1386),
    [anon_sym_type] = ACTIONS(1386),
    [anon_sym_namespace] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [anon_sym_typeof] = ACTIONS(1386),
    [anon_sym_import] = ACTIONS(1386),
    [anon_sym_var] = ACTIONS(1386),
    [anon_sym_let] = ACTIONS(1386),
    [anon_sym_const] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_else] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1386),
    [anon_sym_switch] = ACTIONS(1386),
    [anon_sym_for] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [anon_sym_await] = ACTIONS(1386),
    [anon_sym_while] = ACTIONS(1386),
    [anon_sym_do] = ACTIONS(1386),
    [anon_sym_try] = ACTIONS(1386),
    [anon_sym_with] = ACTIONS(1386),
    [anon_sym_break] = ACTIONS(1386),
    [anon_sym_continue] = ACTIONS(1386),
    [anon_sym_debugger] = ACTIONS(1386),
    [anon_sym_return] = ACTIONS(1386),
    [anon_sym_throw] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_case] = ACTIONS(1386),
    [anon_sym_yield] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1386),
    [anon_sym_class] = ACTIONS(1386),
    [anon_sym_async] = ACTIONS(1386),
    [anon_sym_function] = ACTIONS(1386),
    [anon_sym_new] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_void] = ACTIONS(1386),
    [anon_sym_delete] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [sym_number] = ACTIONS(1384),
    [sym_this] = ACTIONS(1386),
    [sym_super] = ACTIONS(1386),
    [sym_true] = ACTIONS(1386),
    [sym_false] = ACTIONS(1386),
    [sym_null] = ACTIONS(1386),
    [sym_undefined] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1384),
    [anon_sym_static] = ACTIONS(1386),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(1386),
    [anon_sym_set] = ACTIONS(1386),
    [anon_sym_declare] = ACTIONS(1386),
    [anon_sym_public] = ACTIONS(1386),
    [anon_sym_private] = ACTIONS(1386),
    [anon_sym_protected] = ACTIONS(1386),
    [anon_sym_override] = ACTIONS(1386),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_any] = ACTIONS(1386),
    [anon_sym_number] = ACTIONS(1386),
    [anon_sym_boolean] = ACTIONS(1386),
    [anon_sym_string] = ACTIONS(1386),
    [anon_sym_symbol] = ACTIONS(1386),
    [anon_sym_abstract] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1386),
    [anon_sym_enum] = ACTIONS(1386),
    [sym__automatic_semicolon] = ACTIONS(1392),
  },
  [620] = {
    [sym__call_signature] = STATE(4084),
    [sym_formal_parameters] = STATE(3085),
    [sym_type_parameters] = STATE(3851),
    [sym_identifier] = ACTIONS(2010),
    [anon_sym_export] = ACTIONS(2012),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_type] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_namespace] = ACTIONS(2012),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(2002),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_async] = ACTIONS(2012),
    [anon_sym_function] = ACTIONS(2008),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_static] = ACTIONS(2012),
    [anon_sym_readonly] = ACTIONS(2012),
    [anon_sym_get] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(2012),
    [anon_sym_declare] = ACTIONS(2012),
    [anon_sym_public] = ACTIONS(2012),
    [anon_sym_private] = ACTIONS(2012),
    [anon_sym_protected] = ACTIONS(2012),
    [anon_sym_override] = ACTIONS(2012),
    [anon_sym_module] = ACTIONS(2012),
    [anon_sym_any] = ACTIONS(2012),
    [anon_sym_number] = ACTIONS(2012),
    [anon_sym_boolean] = ACTIONS(2012),
    [anon_sym_string] = ACTIONS(2012),
    [anon_sym_symbol] = ACTIONS(2012),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [621] = {
    [ts_builtin_sym_end] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1560),
    [anon_sym_export] = ACTIONS(1560),
    [anon_sym_default] = ACTIONS(1560),
    [anon_sym_type] = ACTIONS(1560),
    [anon_sym_namespace] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_typeof] = ACTIONS(1560),
    [anon_sym_import] = ACTIONS(1560),
    [anon_sym_var] = ACTIONS(1560),
    [anon_sym_let] = ACTIONS(1560),
    [anon_sym_const] = ACTIONS(1560),
    [anon_sym_BANG] = ACTIONS(1558),
    [anon_sym_else] = ACTIONS(1560),
    [anon_sym_if] = ACTIONS(1560),
    [anon_sym_switch] = ACTIONS(1560),
    [anon_sym_for] = ACTIONS(1560),
    [anon_sym_LPAREN] = ACTIONS(1558),
    [anon_sym_await] = ACTIONS(1560),
    [anon_sym_while] = ACTIONS(1560),
    [anon_sym_do] = ACTIONS(1560),
    [anon_sym_try] = ACTIONS(1560),
    [anon_sym_with] = ACTIONS(1560),
    [anon_sym_break] = ACTIONS(1560),
    [anon_sym_continue] = ACTIONS(1560),
    [anon_sym_debugger] = ACTIONS(1560),
    [anon_sym_return] = ACTIONS(1560),
    [anon_sym_throw] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1558),
    [anon_sym_case] = ACTIONS(1560),
    [anon_sym_yield] = ACTIONS(1560),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_LT] = ACTIONS(1558),
    [anon_sym_SLASH] = ACTIONS(1560),
    [anon_sym_class] = ACTIONS(1560),
    [anon_sym_async] = ACTIONS(1560),
    [anon_sym_function] = ACTIONS(1560),
    [anon_sym_new] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_TILDE] = ACTIONS(1558),
    [anon_sym_void] = ACTIONS(1560),
    [anon_sym_delete] = ACTIONS(1560),
    [anon_sym_PLUS_PLUS] = ACTIONS(1558),
    [anon_sym_DASH_DASH] = ACTIONS(1558),
    [anon_sym_DQUOTE] = ACTIONS(1558),
    [anon_sym_SQUOTE] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [sym_number] = ACTIONS(1558),
    [sym_this] = ACTIONS(1560),
    [sym_super] = ACTIONS(1560),
    [sym_true] = ACTIONS(1560),
    [sym_false] = ACTIONS(1560),
    [sym_null] = ACTIONS(1560),
    [sym_undefined] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1558),
    [anon_sym_static] = ACTIONS(1560),
    [anon_sym_readonly] = ACTIONS(1560),
    [anon_sym_get] = ACTIONS(1560),
    [anon_sym_set] = ACTIONS(1560),
    [anon_sym_declare] = ACTIONS(1560),
    [anon_sym_public] = ACTIONS(1560),
    [anon_sym_private] = ACTIONS(1560),
    [anon_sym_protected] = ACTIONS(1560),
    [anon_sym_override] = ACTIONS(1560),
    [anon_sym_module] = ACTIONS(1560),
    [anon_sym_any] = ACTIONS(1560),
    [anon_sym_number] = ACTIONS(1560),
    [anon_sym_boolean] = ACTIONS(1560),
    [anon_sym_string] = ACTIONS(1560),
    [anon_sym_symbol] = ACTIONS(1560),
    [anon_sym_abstract] = ACTIONS(1560),
    [anon_sym_interface] = ACTIONS(1560),
    [anon_sym_enum] = ACTIONS(1560),
    [sym__automatic_semicolon] = ACTIONS(1566),
  },
  [622] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1368),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_default] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_namespace] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_typeof] = ACTIONS(1368),
    [anon_sym_import] = ACTIONS(1368),
    [anon_sym_var] = ACTIONS(1368),
    [anon_sym_let] = ACTIONS(1368),
    [anon_sym_const] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_else] = ACTIONS(1368),
    [anon_sym_if] = ACTIONS(1368),
    [anon_sym_switch] = ACTIONS(1368),
    [anon_sym_for] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [anon_sym_await] = ACTIONS(1368),
    [anon_sym_while] = ACTIONS(1368),
    [anon_sym_do] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(1368),
    [anon_sym_with] = ACTIONS(1368),
    [anon_sym_break] = ACTIONS(1368),
    [anon_sym_continue] = ACTIONS(1368),
    [anon_sym_debugger] = ACTIONS(1368),
    [anon_sym_return] = ACTIONS(1368),
    [anon_sym_throw] = ACTIONS(1368),
    [anon_sym_SEMI] = ACTIONS(1366),
    [anon_sym_case] = ACTIONS(1368),
    [anon_sym_yield] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_LT] = ACTIONS(1366),
    [anon_sym_SLASH] = ACTIONS(1368),
    [anon_sym_class] = ACTIONS(1368),
    [anon_sym_async] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(1368),
    [anon_sym_new] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_void] = ACTIONS(1368),
    [anon_sym_delete] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [sym_number] = ACTIONS(1366),
    [sym_this] = ACTIONS(1368),
    [sym_super] = ACTIONS(1368),
    [sym_true] = ACTIONS(1368),
    [sym_false] = ACTIONS(1368),
    [sym_null] = ACTIONS(1368),
    [sym_undefined] = ACTIONS(1368),
    [anon_sym_AT] = ACTIONS(1366),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_abstract] = ACTIONS(1368),
    [anon_sym_interface] = ACTIONS(1368),
    [anon_sym_enum] = ACTIONS(1368),
    [sym__automatic_semicolon] = ACTIONS(1374),
  },
  [623] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_export] = ACTIONS(1472),
    [anon_sym_default] = ACTIONS(1472),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_var] = ACTIONS(1472),
    [anon_sym_let] = ACTIONS(1472),
    [anon_sym_const] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_else] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_switch] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_do] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_debugger] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_throw] = ACTIONS(1472),
    [anon_sym_SEMI] = ACTIONS(1470),
    [anon_sym_case] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1470),
    [anon_sym_SLASH] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_function] = ACTIONS(1472),
    [anon_sym_new] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_void] = ACTIONS(1472),
    [anon_sym_delete] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1470),
    [sym_number] = ACTIONS(1470),
    [sym_this] = ACTIONS(1472),
    [sym_super] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_null] = ACTIONS(1472),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1470),
    [anon_sym_static] = ACTIONS(1472),
    [anon_sym_readonly] = ACTIONS(1472),
    [anon_sym_get] = ACTIONS(1472),
    [anon_sym_set] = ACTIONS(1472),
    [anon_sym_declare] = ACTIONS(1472),
    [anon_sym_public] = ACTIONS(1472),
    [anon_sym_private] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1472),
    [anon_sym_override] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1472),
    [anon_sym_number] = ACTIONS(1472),
    [anon_sym_boolean] = ACTIONS(1472),
    [anon_sym_string] = ACTIONS(1472),
    [anon_sym_symbol] = ACTIONS(1472),
    [anon_sym_abstract] = ACTIONS(1472),
    [anon_sym_interface] = ACTIONS(1472),
    [anon_sym_enum] = ACTIONS(1472),
    [sym__automatic_semicolon] = ACTIONS(1478),
  },
  [624] = {
    [sym_statement_block] = STATE(652),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_export] = ACTIONS(1326),
    [anon_sym_default] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(2076),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [anon_sym_typeof] = ACTIONS(1326),
    [anon_sym_import] = ACTIONS(1326),
    [anon_sym_var] = ACTIONS(1326),
    [anon_sym_let] = ACTIONS(1326),
    [anon_sym_const] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_else] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_switch] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_await] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_do] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [anon_sym_with] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_debugger] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_throw] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1324),
    [anon_sym_case] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1324),
    [anon_sym_SLASH] = ACTIONS(1326),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_function] = ACTIONS(1326),
    [anon_sym_new] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_void] = ACTIONS(1326),
    [anon_sym_delete] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [sym_number] = ACTIONS(1324),
    [sym_this] = ACTIONS(1326),
    [sym_super] = ACTIONS(1326),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [sym_null] = ACTIONS(1326),
    [sym_undefined] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_static] = ACTIONS(1326),
    [anon_sym_readonly] = ACTIONS(1326),
    [anon_sym_get] = ACTIONS(1326),
    [anon_sym_set] = ACTIONS(1326),
    [anon_sym_declare] = ACTIONS(1326),
    [anon_sym_public] = ACTIONS(1326),
    [anon_sym_private] = ACTIONS(1326),
    [anon_sym_protected] = ACTIONS(1326),
    [anon_sym_override] = ACTIONS(1326),
    [anon_sym_module] = ACTIONS(1326),
    [anon_sym_any] = ACTIONS(1326),
    [anon_sym_number] = ACTIONS(1326),
    [anon_sym_boolean] = ACTIONS(1326),
    [anon_sym_string] = ACTIONS(1326),
    [anon_sym_symbol] = ACTIONS(1326),
    [anon_sym_abstract] = ACTIONS(1326),
    [anon_sym_interface] = ACTIONS(1326),
    [anon_sym_enum] = ACTIONS(1326),
  },
  [625] = {
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_export] = ACTIONS(1452),
    [anon_sym_default] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_namespace] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [anon_sym_typeof] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_var] = ACTIONS(1452),
    [anon_sym_let] = ACTIONS(1452),
    [anon_sym_const] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_else] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_switch] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_await] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_do] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_with] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_debugger] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_throw] = ACTIONS(1452),
    [anon_sym_SEMI] = ACTIONS(1450),
    [anon_sym_case] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_LT] = ACTIONS(1450),
    [anon_sym_SLASH] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_function] = ACTIONS(1452),
    [anon_sym_new] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_void] = ACTIONS(1452),
    [anon_sym_delete] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_number] = ACTIONS(1450),
    [sym_this] = ACTIONS(1452),
    [sym_super] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_null] = ACTIONS(1452),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1450),
    [anon_sym_static] = ACTIONS(1452),
    [anon_sym_readonly] = ACTIONS(1452),
    [anon_sym_get] = ACTIONS(1452),
    [anon_sym_set] = ACTIONS(1452),
    [anon_sym_declare] = ACTIONS(1452),
    [anon_sym_public] = ACTIONS(1452),
    [anon_sym_private] = ACTIONS(1452),
    [anon_sym_protected] = ACTIONS(1452),
    [anon_sym_override] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(1452),
    [anon_sym_any] = ACTIONS(1452),
    [anon_sym_number] = ACTIONS(1452),
    [anon_sym_boolean] = ACTIONS(1452),
    [anon_sym_string] = ACTIONS(1452),
    [anon_sym_symbol] = ACTIONS(1452),
    [anon_sym_abstract] = ACTIONS(1452),
    [anon_sym_interface] = ACTIONS(1452),
    [anon_sym_enum] = ACTIONS(1452),
    [sym__automatic_semicolon] = ACTIONS(1458),
  },
  [626] = {
    [ts_builtin_sym_end] = ACTIONS(1504),
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_export] = ACTIONS(1506),
    [anon_sym_default] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_namespace] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [anon_sym_typeof] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(1506),
    [anon_sym_var] = ACTIONS(1506),
    [anon_sym_let] = ACTIONS(1506),
    [anon_sym_const] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1504),
    [anon_sym_else] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_switch] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_await] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_do] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1506),
    [anon_sym_with] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_debugger] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_throw] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1504),
    [anon_sym_case] = ACTIONS(1506),
    [anon_sym_yield] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_LT] = ACTIONS(1504),
    [anon_sym_SLASH] = ACTIONS(1506),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_function] = ACTIONS(1506),
    [anon_sym_new] = ACTIONS(1506),
    [anon_sym_PLUS] = ACTIONS(1506),
    [anon_sym_DASH] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_void] = ACTIONS(1506),
    [anon_sym_delete] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(1504),
    [anon_sym_SQUOTE] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [sym_number] = ACTIONS(1504),
    [sym_this] = ACTIONS(1506),
    [sym_super] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [sym_undefined] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_static] = ACTIONS(1506),
    [anon_sym_readonly] = ACTIONS(1506),
    [anon_sym_get] = ACTIONS(1506),
    [anon_sym_set] = ACTIONS(1506),
    [anon_sym_declare] = ACTIONS(1506),
    [anon_sym_public] = ACTIONS(1506),
    [anon_sym_private] = ACTIONS(1506),
    [anon_sym_protected] = ACTIONS(1506),
    [anon_sym_override] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [anon_sym_any] = ACTIONS(1506),
    [anon_sym_number] = ACTIONS(1506),
    [anon_sym_boolean] = ACTIONS(1506),
    [anon_sym_string] = ACTIONS(1506),
    [anon_sym_symbol] = ACTIONS(1506),
    [anon_sym_abstract] = ACTIONS(1506),
    [anon_sym_interface] = ACTIONS(1506),
    [anon_sym_enum] = ACTIONS(1506),
    [sym__automatic_semicolon] = ACTIONS(1512),
  },
  [627] = {
    [sym_else_clause] = STATE(773),
    [ts_builtin_sym_end] = ACTIONS(2096),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_export] = ACTIONS(2098),
    [anon_sym_default] = ACTIONS(2098),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_namespace] = ACTIONS(2098),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_typeof] = ACTIONS(2098),
    [anon_sym_import] = ACTIONS(2098),
    [anon_sym_var] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_const] = ACTIONS(2098),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_else] = ACTIONS(2100),
    [anon_sym_if] = ACTIONS(2098),
    [anon_sym_switch] = ACTIONS(2098),
    [anon_sym_for] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2096),
    [anon_sym_await] = ACTIONS(2098),
    [anon_sym_while] = ACTIONS(2098),
    [anon_sym_do] = ACTIONS(2098),
    [anon_sym_try] = ACTIONS(2098),
    [anon_sym_with] = ACTIONS(2098),
    [anon_sym_break] = ACTIONS(2098),
    [anon_sym_continue] = ACTIONS(2098),
    [anon_sym_debugger] = ACTIONS(2098),
    [anon_sym_return] = ACTIONS(2098),
    [anon_sym_throw] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_case] = ACTIONS(2098),
    [anon_sym_yield] = ACTIONS(2098),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(2096),
    [anon_sym_SLASH] = ACTIONS(2098),
    [anon_sym_class] = ACTIONS(2098),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_function] = ACTIONS(2098),
    [anon_sym_new] = ACTIONS(2098),
    [anon_sym_PLUS] = ACTIONS(2098),
    [anon_sym_DASH] = ACTIONS(2098),
    [anon_sym_TILDE] = ACTIONS(2096),
    [anon_sym_void] = ACTIONS(2098),
    [anon_sym_delete] = ACTIONS(2098),
    [anon_sym_PLUS_PLUS] = ACTIONS(2096),
    [anon_sym_DASH_DASH] = ACTIONS(2096),
    [anon_sym_DQUOTE] = ACTIONS(2096),
    [anon_sym_SQUOTE] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2096),
    [sym_number] = ACTIONS(2096),
    [sym_this] = ACTIONS(2098),
    [sym_super] = ACTIONS(2098),
    [sym_true] = ACTIONS(2098),
    [sym_false] = ACTIONS(2098),
    [sym_null] = ACTIONS(2098),
    [sym_undefined] = ACTIONS(2098),
    [anon_sym_AT] = ACTIONS(2096),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_readonly] = ACTIONS(2098),
    [anon_sym_get] = ACTIONS(2098),
    [anon_sym_set] = ACTIONS(2098),
    [anon_sym_declare] = ACTIONS(2098),
    [anon_sym_public] = ACTIONS(2098),
    [anon_sym_private] = ACTIONS(2098),
    [anon_sym_protected] = ACTIONS(2098),
    [anon_sym_override] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2098),
    [anon_sym_any] = ACTIONS(2098),
    [anon_sym_number] = ACTIONS(2098),
    [anon_sym_boolean] = ACTIONS(2098),
    [anon_sym_string] = ACTIONS(2098),
    [anon_sym_symbol] = ACTIONS(2098),
    [anon_sym_abstract] = ACTIONS(2098),
    [anon_sym_interface] = ACTIONS(2098),
    [anon_sym_enum] = ACTIONS(2098),
  },
  [628] = {
    [ts_builtin_sym_end] = ACTIONS(2102),
    [sym_identifier] = ACTIONS(2104),
    [anon_sym_export] = ACTIONS(2104),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_type] = ACTIONS(2104),
    [anon_sym_namespace] = ACTIONS(2104),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_typeof] = ACTIONS(2104),
    [anon_sym_import] = ACTIONS(2104),
    [anon_sym_var] = ACTIONS(2104),
    [anon_sym_let] = ACTIONS(2104),
    [anon_sym_const] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2102),
    [anon_sym_else] = ACTIONS(2104),
    [anon_sym_if] = ACTIONS(2104),
    [anon_sym_switch] = ACTIONS(2104),
    [anon_sym_for] = ACTIONS(2104),
    [anon_sym_LPAREN] = ACTIONS(2102),
    [anon_sym_await] = ACTIONS(2104),
    [anon_sym_while] = ACTIONS(2104),
    [anon_sym_do] = ACTIONS(2104),
    [anon_sym_try] = ACTIONS(2104),
    [anon_sym_with] = ACTIONS(2104),
    [anon_sym_break] = ACTIONS(2104),
    [anon_sym_continue] = ACTIONS(2104),
    [anon_sym_debugger] = ACTIONS(2104),
    [anon_sym_return] = ACTIONS(2104),
    [anon_sym_throw] = ACTIONS(2104),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_case] = ACTIONS(2104),
    [anon_sym_finally] = ACTIONS(2104),
    [anon_sym_yield] = ACTIONS(2104),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2102),
    [anon_sym_SLASH] = ACTIONS(2104),
    [anon_sym_class] = ACTIONS(2104),
    [anon_sym_async] = ACTIONS(2104),
    [anon_sym_function] = ACTIONS(2104),
    [anon_sym_new] = ACTIONS(2104),
    [anon_sym_PLUS] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2104),
    [anon_sym_TILDE] = ACTIONS(2102),
    [anon_sym_void] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2104),
    [anon_sym_PLUS_PLUS] = ACTIONS(2102),
    [anon_sym_DASH_DASH] = ACTIONS(2102),
    [anon_sym_DQUOTE] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2102),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(2104),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2104),
    [anon_sym_readonly] = ACTIONS(2104),
    [anon_sym_get] = ACTIONS(2104),
    [anon_sym_set] = ACTIONS(2104),
    [anon_sym_declare] = ACTIONS(2104),
    [anon_sym_public] = ACTIONS(2104),
    [anon_sym_private] = ACTIONS(2104),
    [anon_sym_protected] = ACTIONS(2104),
    [anon_sym_override] = ACTIONS(2104),
    [anon_sym_module] = ACTIONS(2104),
    [anon_sym_any] = ACTIONS(2104),
    [anon_sym_number] = ACTIONS(2104),
    [anon_sym_boolean] = ACTIONS(2104),
    [anon_sym_string] = ACTIONS(2104),
    [anon_sym_symbol] = ACTIONS(2104),
    [anon_sym_abstract] = ACTIONS(2104),
    [anon_sym_interface] = ACTIONS(2104),
    [anon_sym_enum] = ACTIONS(2104),
  },
  [629] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_export] = ACTIONS(1410),
    [anon_sym_default] = ACTIONS(1410),
    [anon_sym_type] = ACTIONS(1410),
    [anon_sym_namespace] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [anon_sym_typeof] = ACTIONS(1410),
    [anon_sym_import] = ACTIONS(1410),
    [anon_sym_var] = ACTIONS(1410),
    [anon_sym_let] = ACTIONS(1410),
    [anon_sym_const] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_else] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_switch] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_await] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_do] = ACTIONS(1410),
    [anon_sym_try] = ACTIONS(1410),
    [anon_sym_with] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_debugger] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_throw] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1408),
    [anon_sym_case] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_LT] = ACTIONS(1408),
    [anon_sym_SLASH] = ACTIONS(1410),
    [anon_sym_class] = ACTIONS(1410),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_function] = ACTIONS(1410),
    [anon_sym_new] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_delete] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [sym_number] = ACTIONS(1408),
    [sym_this] = ACTIONS(1410),
    [sym_super] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_null] = ACTIONS(1410),
    [sym_undefined] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_static] = ACTIONS(1410),
    [anon_sym_readonly] = ACTIONS(1410),
    [anon_sym_get] = ACTIONS(1410),
    [anon_sym_set] = ACTIONS(1410),
    [anon_sym_declare] = ACTIONS(1410),
    [anon_sym_public] = ACTIONS(1410),
    [anon_sym_private] = ACTIONS(1410),
    [anon_sym_protected] = ACTIONS(1410),
    [anon_sym_override] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(1410),
    [anon_sym_any] = ACTIONS(1410),
    [anon_sym_number] = ACTIONS(1410),
    [anon_sym_boolean] = ACTIONS(1410),
    [anon_sym_string] = ACTIONS(1410),
    [anon_sym_symbol] = ACTIONS(1410),
    [anon_sym_abstract] = ACTIONS(1410),
    [anon_sym_interface] = ACTIONS(1410),
    [anon_sym_enum] = ACTIONS(1410),
    [sym__automatic_semicolon] = ACTIONS(1416),
  },
  [630] = {
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_identifier] = ACTIONS(1438),
    [anon_sym_export] = ACTIONS(1438),
    [anon_sym_default] = ACTIONS(1438),
    [anon_sym_type] = ACTIONS(1438),
    [anon_sym_namespace] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_typeof] = ACTIONS(1438),
    [anon_sym_import] = ACTIONS(1438),
    [anon_sym_var] = ACTIONS(1438),
    [anon_sym_let] = ACTIONS(1438),
    [anon_sym_const] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_else] = ACTIONS(1438),
    [anon_sym_if] = ACTIONS(1438),
    [anon_sym_switch] = ACTIONS(1438),
    [anon_sym_for] = ACTIONS(1438),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [anon_sym_await] = ACTIONS(1438),
    [anon_sym_while] = ACTIONS(1438),
    [anon_sym_do] = ACTIONS(1438),
    [anon_sym_try] = ACTIONS(1438),
    [anon_sym_with] = ACTIONS(1438),
    [anon_sym_break] = ACTIONS(1438),
    [anon_sym_continue] = ACTIONS(1438),
    [anon_sym_debugger] = ACTIONS(1438),
    [anon_sym_return] = ACTIONS(1438),
    [anon_sym_throw] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_case] = ACTIONS(1438),
    [anon_sym_yield] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [anon_sym_LT] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1438),
    [anon_sym_class] = ACTIONS(1438),
    [anon_sym_async] = ACTIONS(1438),
    [anon_sym_function] = ACTIONS(1438),
    [anon_sym_new] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_void] = ACTIONS(1438),
    [anon_sym_delete] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [sym_number] = ACTIONS(1436),
    [sym_this] = ACTIONS(1438),
    [sym_super] = ACTIONS(1438),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [sym_null] = ACTIONS(1438),
    [sym_undefined] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1436),
    [anon_sym_static] = ACTIONS(1438),
    [anon_sym_readonly] = ACTIONS(1438),
    [anon_sym_get] = ACTIONS(1438),
    [anon_sym_set] = ACTIONS(1438),
    [anon_sym_declare] = ACTIONS(1438),
    [anon_sym_public] = ACTIONS(1438),
    [anon_sym_private] = ACTIONS(1438),
    [anon_sym_protected] = ACTIONS(1438),
    [anon_sym_override] = ACTIONS(1438),
    [anon_sym_module] = ACTIONS(1438),
    [anon_sym_any] = ACTIONS(1438),
    [anon_sym_number] = ACTIONS(1438),
    [anon_sym_boolean] = ACTIONS(1438),
    [anon_sym_string] = ACTIONS(1438),
    [anon_sym_symbol] = ACTIONS(1438),
    [anon_sym_abstract] = ACTIONS(1438),
    [anon_sym_interface] = ACTIONS(1438),
    [anon_sym_enum] = ACTIONS(1438),
    [sym__automatic_semicolon] = ACTIONS(1444),
  },
  [631] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [632] = {
    [ts_builtin_sym_end] = ACTIONS(2110),
    [sym_identifier] = ACTIONS(2112),
    [anon_sym_export] = ACTIONS(2112),
    [anon_sym_default] = ACTIONS(2112),
    [anon_sym_type] = ACTIONS(2112),
    [anon_sym_namespace] = ACTIONS(2112),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_typeof] = ACTIONS(2112),
    [anon_sym_import] = ACTIONS(2112),
    [anon_sym_var] = ACTIONS(2112),
    [anon_sym_let] = ACTIONS(2112),
    [anon_sym_const] = ACTIONS(2112),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_else] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(2112),
    [anon_sym_switch] = ACTIONS(2112),
    [anon_sym_for] = ACTIONS(2112),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_await] = ACTIONS(2112),
    [anon_sym_while] = ACTIONS(2112),
    [anon_sym_do] = ACTIONS(2112),
    [anon_sym_try] = ACTIONS(2112),
    [anon_sym_with] = ACTIONS(2112),
    [anon_sym_break] = ACTIONS(2112),
    [anon_sym_continue] = ACTIONS(2112),
    [anon_sym_debugger] = ACTIONS(2112),
    [anon_sym_return] = ACTIONS(2112),
    [anon_sym_throw] = ACTIONS(2112),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_yield] = ACTIONS(2112),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2110),
    [anon_sym_SLASH] = ACTIONS(2112),
    [anon_sym_class] = ACTIONS(2112),
    [anon_sym_async] = ACTIONS(2112),
    [anon_sym_function] = ACTIONS(2112),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_PLUS] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [anon_sym_TILDE] = ACTIONS(2110),
    [anon_sym_void] = ACTIONS(2112),
    [anon_sym_delete] = ACTIONS(2112),
    [anon_sym_PLUS_PLUS] = ACTIONS(2110),
    [anon_sym_DASH_DASH] = ACTIONS(2110),
    [anon_sym_DQUOTE] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2110),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(2112),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(2110),
    [anon_sym_static] = ACTIONS(2112),
    [anon_sym_readonly] = ACTIONS(2112),
    [anon_sym_get] = ACTIONS(2112),
    [anon_sym_set] = ACTIONS(2112),
    [anon_sym_declare] = ACTIONS(2112),
    [anon_sym_public] = ACTIONS(2112),
    [anon_sym_private] = ACTIONS(2112),
    [anon_sym_protected] = ACTIONS(2112),
    [anon_sym_override] = ACTIONS(2112),
    [anon_sym_module] = ACTIONS(2112),
    [anon_sym_any] = ACTIONS(2112),
    [anon_sym_number] = ACTIONS(2112),
    [anon_sym_boolean] = ACTIONS(2112),
    [anon_sym_string] = ACTIONS(2112),
    [anon_sym_symbol] = ACTIONS(2112),
    [anon_sym_abstract] = ACTIONS(2112),
    [anon_sym_interface] = ACTIONS(2112),
    [anon_sym_enum] = ACTIONS(2112),
  },
  [633] = {
    [ts_builtin_sym_end] = ACTIONS(2114),
    [sym_identifier] = ACTIONS(2116),
    [anon_sym_export] = ACTIONS(2116),
    [anon_sym_default] = ACTIONS(2116),
    [anon_sym_type] = ACTIONS(2116),
    [anon_sym_namespace] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2114),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [anon_sym_typeof] = ACTIONS(2116),
    [anon_sym_import] = ACTIONS(2116),
    [anon_sym_var] = ACTIONS(2116),
    [anon_sym_let] = ACTIONS(2116),
    [anon_sym_const] = ACTIONS(2116),
    [anon_sym_BANG] = ACTIONS(2114),
    [anon_sym_else] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(2116),
    [anon_sym_switch] = ACTIONS(2116),
    [anon_sym_for] = ACTIONS(2116),
    [anon_sym_LPAREN] = ACTIONS(2114),
    [anon_sym_await] = ACTIONS(2116),
    [anon_sym_while] = ACTIONS(2116),
    [anon_sym_do] = ACTIONS(2116),
    [anon_sym_try] = ACTIONS(2116),
    [anon_sym_with] = ACTIONS(2116),
    [anon_sym_break] = ACTIONS(2116),
    [anon_sym_continue] = ACTIONS(2116),
    [anon_sym_debugger] = ACTIONS(2116),
    [anon_sym_return] = ACTIONS(2116),
    [anon_sym_throw] = ACTIONS(2116),
    [anon_sym_SEMI] = ACTIONS(2114),
    [anon_sym_case] = ACTIONS(2116),
    [anon_sym_yield] = ACTIONS(2116),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2114),
    [anon_sym_SLASH] = ACTIONS(2116),
    [anon_sym_class] = ACTIONS(2116),
    [anon_sym_async] = ACTIONS(2116),
    [anon_sym_function] = ACTIONS(2116),
    [anon_sym_new] = ACTIONS(2116),
    [anon_sym_PLUS] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_TILDE] = ACTIONS(2114),
    [anon_sym_void] = ACTIONS(2116),
    [anon_sym_delete] = ACTIONS(2116),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_DQUOTE] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2114),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(2116),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2116),
    [anon_sym_readonly] = ACTIONS(2116),
    [anon_sym_get] = ACTIONS(2116),
    [anon_sym_set] = ACTIONS(2116),
    [anon_sym_declare] = ACTIONS(2116),
    [anon_sym_public] = ACTIONS(2116),
    [anon_sym_private] = ACTIONS(2116),
    [anon_sym_protected] = ACTIONS(2116),
    [anon_sym_override] = ACTIONS(2116),
    [anon_sym_module] = ACTIONS(2116),
    [anon_sym_any] = ACTIONS(2116),
    [anon_sym_number] = ACTIONS(2116),
    [anon_sym_boolean] = ACTIONS(2116),
    [anon_sym_string] = ACTIONS(2116),
    [anon_sym_symbol] = ACTIONS(2116),
    [anon_sym_abstract] = ACTIONS(2116),
    [anon_sym_interface] = ACTIONS(2116),
    [anon_sym_enum] = ACTIONS(2116),
  },
  [634] = {
    [ts_builtin_sym_end] = ACTIONS(2118),
    [sym_identifier] = ACTIONS(2120),
    [anon_sym_export] = ACTIONS(2120),
    [anon_sym_default] = ACTIONS(2120),
    [anon_sym_type] = ACTIONS(2120),
    [anon_sym_namespace] = ACTIONS(2120),
    [anon_sym_LBRACE] = ACTIONS(2118),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [anon_sym_typeof] = ACTIONS(2120),
    [anon_sym_import] = ACTIONS(2120),
    [anon_sym_var] = ACTIONS(2120),
    [anon_sym_let] = ACTIONS(2120),
    [anon_sym_const] = ACTIONS(2120),
    [anon_sym_BANG] = ACTIONS(2118),
    [anon_sym_else] = ACTIONS(2120),
    [anon_sym_if] = ACTIONS(2120),
    [anon_sym_switch] = ACTIONS(2120),
    [anon_sym_for] = ACTIONS(2120),
    [anon_sym_LPAREN] = ACTIONS(2118),
    [anon_sym_await] = ACTIONS(2120),
    [anon_sym_while] = ACTIONS(2120),
    [anon_sym_do] = ACTIONS(2120),
    [anon_sym_try] = ACTIONS(2120),
    [anon_sym_with] = ACTIONS(2120),
    [anon_sym_break] = ACTIONS(2120),
    [anon_sym_continue] = ACTIONS(2120),
    [anon_sym_debugger] = ACTIONS(2120),
    [anon_sym_return] = ACTIONS(2120),
    [anon_sym_throw] = ACTIONS(2120),
    [anon_sym_SEMI] = ACTIONS(2118),
    [anon_sym_case] = ACTIONS(2120),
    [anon_sym_yield] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2118),
    [anon_sym_SLASH] = ACTIONS(2120),
    [anon_sym_class] = ACTIONS(2120),
    [anon_sym_async] = ACTIONS(2120),
    [anon_sym_function] = ACTIONS(2120),
    [anon_sym_new] = ACTIONS(2120),
    [anon_sym_PLUS] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_TILDE] = ACTIONS(2118),
    [anon_sym_void] = ACTIONS(2120),
    [anon_sym_delete] = ACTIONS(2120),
    [anon_sym_PLUS_PLUS] = ACTIONS(2118),
    [anon_sym_DASH_DASH] = ACTIONS(2118),
    [anon_sym_DQUOTE] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2118),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(2120),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2120),
    [anon_sym_readonly] = ACTIONS(2120),
    [anon_sym_get] = ACTIONS(2120),
    [anon_sym_set] = ACTIONS(2120),
    [anon_sym_declare] = ACTIONS(2120),
    [anon_sym_public] = ACTIONS(2120),
    [anon_sym_private] = ACTIONS(2120),
    [anon_sym_protected] = ACTIONS(2120),
    [anon_sym_override] = ACTIONS(2120),
    [anon_sym_module] = ACTIONS(2120),
    [anon_sym_any] = ACTIONS(2120),
    [anon_sym_number] = ACTIONS(2120),
    [anon_sym_boolean] = ACTIONS(2120),
    [anon_sym_string] = ACTIONS(2120),
    [anon_sym_symbol] = ACTIONS(2120),
    [anon_sym_abstract] = ACTIONS(2120),
    [anon_sym_interface] = ACTIONS(2120),
    [anon_sym_enum] = ACTIONS(2120),
  },
  [635] = {
    [ts_builtin_sym_end] = ACTIONS(2122),
    [sym_identifier] = ACTIONS(2124),
    [anon_sym_export] = ACTIONS(2124),
    [anon_sym_default] = ACTIONS(2124),
    [anon_sym_type] = ACTIONS(2124),
    [anon_sym_namespace] = ACTIONS(2124),
    [anon_sym_LBRACE] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_typeof] = ACTIONS(2124),
    [anon_sym_import] = ACTIONS(2124),
    [anon_sym_var] = ACTIONS(2124),
    [anon_sym_let] = ACTIONS(2124),
    [anon_sym_const] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2122),
    [anon_sym_else] = ACTIONS(2124),
    [anon_sym_if] = ACTIONS(2124),
    [anon_sym_switch] = ACTIONS(2124),
    [anon_sym_for] = ACTIONS(2124),
    [anon_sym_LPAREN] = ACTIONS(2122),
    [anon_sym_await] = ACTIONS(2124),
    [anon_sym_while] = ACTIONS(2124),
    [anon_sym_do] = ACTIONS(2124),
    [anon_sym_try] = ACTIONS(2124),
    [anon_sym_with] = ACTIONS(2124),
    [anon_sym_break] = ACTIONS(2124),
    [anon_sym_continue] = ACTIONS(2124),
    [anon_sym_debugger] = ACTIONS(2124),
    [anon_sym_return] = ACTIONS(2124),
    [anon_sym_throw] = ACTIONS(2124),
    [anon_sym_SEMI] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2124),
    [anon_sym_yield] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2122),
    [anon_sym_SLASH] = ACTIONS(2124),
    [anon_sym_class] = ACTIONS(2124),
    [anon_sym_async] = ACTIONS(2124),
    [anon_sym_function] = ACTIONS(2124),
    [anon_sym_new] = ACTIONS(2124),
    [anon_sym_PLUS] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2122),
    [anon_sym_void] = ACTIONS(2124),
    [anon_sym_delete] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2122),
    [anon_sym_DQUOTE] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2122),
    [sym_number] = ACTIONS(2122),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(2124),
    [sym_true] = ACTIONS(2124),
    [sym_false] = ACTIONS(2124),
    [sym_null] = ACTIONS(2124),
    [sym_undefined] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2124),
    [anon_sym_readonly] = ACTIONS(2124),
    [anon_sym_get] = ACTIONS(2124),
    [anon_sym_set] = ACTIONS(2124),
    [anon_sym_declare] = ACTIONS(2124),
    [anon_sym_public] = ACTIONS(2124),
    [anon_sym_private] = ACTIONS(2124),
    [anon_sym_protected] = ACTIONS(2124),
    [anon_sym_override] = ACTIONS(2124),
    [anon_sym_module] = ACTIONS(2124),
    [anon_sym_any] = ACTIONS(2124),
    [anon_sym_number] = ACTIONS(2124),
    [anon_sym_boolean] = ACTIONS(2124),
    [anon_sym_string] = ACTIONS(2124),
    [anon_sym_symbol] = ACTIONS(2124),
    [anon_sym_abstract] = ACTIONS(2124),
    [anon_sym_interface] = ACTIONS(2124),
    [anon_sym_enum] = ACTIONS(2124),
  },
  [636] = {
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_export] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_namespace] = ACTIONS(2128),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2128),
    [anon_sym_import] = ACTIONS(2128),
    [anon_sym_var] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_switch] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_do] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [anon_sym_with] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_debugger] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_throw] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_class] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_function] = ACTIONS(2128),
    [anon_sym_new] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2128),
    [anon_sym_delete] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_readonly] = ACTIONS(2128),
    [anon_sym_get] = ACTIONS(2128),
    [anon_sym_set] = ACTIONS(2128),
    [anon_sym_declare] = ACTIONS(2128),
    [anon_sym_public] = ACTIONS(2128),
    [anon_sym_private] = ACTIONS(2128),
    [anon_sym_protected] = ACTIONS(2128),
    [anon_sym_override] = ACTIONS(2128),
    [anon_sym_module] = ACTIONS(2128),
    [anon_sym_any] = ACTIONS(2128),
    [anon_sym_number] = ACTIONS(2128),
    [anon_sym_boolean] = ACTIONS(2128),
    [anon_sym_string] = ACTIONS(2128),
    [anon_sym_symbol] = ACTIONS(2128),
    [anon_sym_abstract] = ACTIONS(2128),
    [anon_sym_interface] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
  },
  [637] = {
    [ts_builtin_sym_end] = ACTIONS(2130),
    [sym_identifier] = ACTIONS(2132),
    [anon_sym_export] = ACTIONS(2132),
    [anon_sym_default] = ACTIONS(2132),
    [anon_sym_type] = ACTIONS(2132),
    [anon_sym_namespace] = ACTIONS(2132),
    [anon_sym_LBRACE] = ACTIONS(2130),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_typeof] = ACTIONS(2132),
    [anon_sym_import] = ACTIONS(2132),
    [anon_sym_var] = ACTIONS(2132),
    [anon_sym_let] = ACTIONS(2132),
    [anon_sym_const] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2130),
    [anon_sym_else] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(2132),
    [anon_sym_switch] = ACTIONS(2132),
    [anon_sym_for] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_await] = ACTIONS(2132),
    [anon_sym_while] = ACTIONS(2132),
    [anon_sym_do] = ACTIONS(2132),
    [anon_sym_try] = ACTIONS(2132),
    [anon_sym_with] = ACTIONS(2132),
    [anon_sym_break] = ACTIONS(2132),
    [anon_sym_continue] = ACTIONS(2132),
    [anon_sym_debugger] = ACTIONS(2132),
    [anon_sym_return] = ACTIONS(2132),
    [anon_sym_throw] = ACTIONS(2132),
    [anon_sym_SEMI] = ACTIONS(2130),
    [anon_sym_case] = ACTIONS(2132),
    [anon_sym_yield] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2130),
    [anon_sym_SLASH] = ACTIONS(2132),
    [anon_sym_class] = ACTIONS(2132),
    [anon_sym_async] = ACTIONS(2132),
    [anon_sym_function] = ACTIONS(2132),
    [anon_sym_new] = ACTIONS(2132),
    [anon_sym_PLUS] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2132),
    [anon_sym_TILDE] = ACTIONS(2130),
    [anon_sym_void] = ACTIONS(2132),
    [anon_sym_delete] = ACTIONS(2132),
    [anon_sym_PLUS_PLUS] = ACTIONS(2130),
    [anon_sym_DASH_DASH] = ACTIONS(2130),
    [anon_sym_DQUOTE] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2130),
    [sym_number] = ACTIONS(2130),
    [sym_this] = ACTIONS(2132),
    [sym_super] = ACTIONS(2132),
    [sym_true] = ACTIONS(2132),
    [sym_false] = ACTIONS(2132),
    [sym_null] = ACTIONS(2132),
    [sym_undefined] = ACTIONS(2132),
    [anon_sym_AT] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(2132),
    [anon_sym_readonly] = ACTIONS(2132),
    [anon_sym_get] = ACTIONS(2132),
    [anon_sym_set] = ACTIONS(2132),
    [anon_sym_declare] = ACTIONS(2132),
    [anon_sym_public] = ACTIONS(2132),
    [anon_sym_private] = ACTIONS(2132),
    [anon_sym_protected] = ACTIONS(2132),
    [anon_sym_override] = ACTIONS(2132),
    [anon_sym_module] = ACTIONS(2132),
    [anon_sym_any] = ACTIONS(2132),
    [anon_sym_number] = ACTIONS(2132),
    [anon_sym_boolean] = ACTIONS(2132),
    [anon_sym_string] = ACTIONS(2132),
    [anon_sym_symbol] = ACTIONS(2132),
    [anon_sym_abstract] = ACTIONS(2132),
    [anon_sym_interface] = ACTIONS(2132),
    [anon_sym_enum] = ACTIONS(2132),
  },
  [638] = {
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_export] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_namespace] = ACTIONS(2136),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_typeof] = ACTIONS(2136),
    [anon_sym_import] = ACTIONS(2136),
    [anon_sym_var] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_else] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_switch] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_await] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_do] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [anon_sym_with] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_debugger] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_throw] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_case] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2136),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_function] = ACTIONS(2136),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2134),
    [anon_sym_void] = ACTIONS(2136),
    [anon_sym_delete] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2134),
    [anon_sym_DASH_DASH] = ACTIONS(2134),
    [anon_sym_DQUOTE] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2134),
    [sym_number] = ACTIONS(2134),
    [sym_this] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_true] = ACTIONS(2136),
    [sym_false] = ACTIONS(2136),
    [sym_null] = ACTIONS(2136),
    [sym_undefined] = ACTIONS(2136),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_readonly] = ACTIONS(2136),
    [anon_sym_get] = ACTIONS(2136),
    [anon_sym_set] = ACTIONS(2136),
    [anon_sym_declare] = ACTIONS(2136),
    [anon_sym_public] = ACTIONS(2136),
    [anon_sym_private] = ACTIONS(2136),
    [anon_sym_protected] = ACTIONS(2136),
    [anon_sym_override] = ACTIONS(2136),
    [anon_sym_module] = ACTIONS(2136),
    [anon_sym_any] = ACTIONS(2136),
    [anon_sym_number] = ACTIONS(2136),
    [anon_sym_boolean] = ACTIONS(2136),
    [anon_sym_string] = ACTIONS(2136),
    [anon_sym_symbol] = ACTIONS(2136),
    [anon_sym_abstract] = ACTIONS(2136),
    [anon_sym_interface] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
  },
  [639] = {
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2136),
    [anon_sym_export] = ACTIONS(2136),
    [anon_sym_default] = ACTIONS(2136),
    [anon_sym_type] = ACTIONS(2136),
    [anon_sym_namespace] = ACTIONS(2136),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [anon_sym_typeof] = ACTIONS(2136),
    [anon_sym_import] = ACTIONS(2136),
    [anon_sym_var] = ACTIONS(2136),
    [anon_sym_let] = ACTIONS(2136),
    [anon_sym_const] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2134),
    [anon_sym_else] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(2136),
    [anon_sym_switch] = ACTIONS(2136),
    [anon_sym_for] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_await] = ACTIONS(2136),
    [anon_sym_while] = ACTIONS(2136),
    [anon_sym_do] = ACTIONS(2136),
    [anon_sym_try] = ACTIONS(2136),
    [anon_sym_with] = ACTIONS(2136),
    [anon_sym_break] = ACTIONS(2136),
    [anon_sym_continue] = ACTIONS(2136),
    [anon_sym_debugger] = ACTIONS(2136),
    [anon_sym_return] = ACTIONS(2136),
    [anon_sym_throw] = ACTIONS(2136),
    [anon_sym_SEMI] = ACTIONS(2134),
    [anon_sym_case] = ACTIONS(2136),
    [anon_sym_yield] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2136),
    [anon_sym_class] = ACTIONS(2136),
    [anon_sym_async] = ACTIONS(2136),
    [anon_sym_function] = ACTIONS(2136),
    [anon_sym_new] = ACTIONS(2136),
    [anon_sym_PLUS] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_TILDE] = ACTIONS(2134),
    [anon_sym_void] = ACTIONS(2136),
    [anon_sym_delete] = ACTIONS(2136),
    [anon_sym_PLUS_PLUS] = ACTIONS(2134),
    [anon_sym_DASH_DASH] = ACTIONS(2134),
    [anon_sym_DQUOTE] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2134),
    [sym_number] = ACTIONS(2134),
    [sym_this] = ACTIONS(2136),
    [sym_super] = ACTIONS(2136),
    [sym_true] = ACTIONS(2136),
    [sym_false] = ACTIONS(2136),
    [sym_null] = ACTIONS(2136),
    [sym_undefined] = ACTIONS(2136),
    [anon_sym_AT] = ACTIONS(2134),
    [anon_sym_static] = ACTIONS(2136),
    [anon_sym_readonly] = ACTIONS(2136),
    [anon_sym_get] = ACTIONS(2136),
    [anon_sym_set] = ACTIONS(2136),
    [anon_sym_declare] = ACTIONS(2136),
    [anon_sym_public] = ACTIONS(2136),
    [anon_sym_private] = ACTIONS(2136),
    [anon_sym_protected] = ACTIONS(2136),
    [anon_sym_override] = ACTIONS(2136),
    [anon_sym_module] = ACTIONS(2136),
    [anon_sym_any] = ACTIONS(2136),
    [anon_sym_number] = ACTIONS(2136),
    [anon_sym_boolean] = ACTIONS(2136),
    [anon_sym_string] = ACTIONS(2136),
    [anon_sym_symbol] = ACTIONS(2136),
    [anon_sym_abstract] = ACTIONS(2136),
    [anon_sym_interface] = ACTIONS(2136),
    [anon_sym_enum] = ACTIONS(2136),
  },
  [640] = {
    [ts_builtin_sym_end] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_export] = ACTIONS(2140),
    [anon_sym_default] = ACTIONS(2140),
    [anon_sym_type] = ACTIONS(2140),
    [anon_sym_namespace] = ACTIONS(2140),
    [anon_sym_LBRACE] = ACTIONS(2138),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [anon_sym_typeof] = ACTIONS(2140),
    [anon_sym_import] = ACTIONS(2140),
    [anon_sym_var] = ACTIONS(2140),
    [anon_sym_let] = ACTIONS(2140),
    [anon_sym_const] = ACTIONS(2140),
    [anon_sym_BANG] = ACTIONS(2138),
    [anon_sym_else] = ACTIONS(2140),
    [anon_sym_if] = ACTIONS(2140),
    [anon_sym_switch] = ACTIONS(2140),
    [anon_sym_for] = ACTIONS(2140),
    [anon_sym_LPAREN] = ACTIONS(2138),
    [anon_sym_await] = ACTIONS(2140),
    [anon_sym_while] = ACTIONS(2140),
    [anon_sym_do] = ACTIONS(2140),
    [anon_sym_try] = ACTIONS(2140),
    [anon_sym_with] = ACTIONS(2140),
    [anon_sym_break] = ACTIONS(2140),
    [anon_sym_continue] = ACTIONS(2140),
    [anon_sym_debugger] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2140),
    [anon_sym_throw] = ACTIONS(2140),
    [anon_sym_SEMI] = ACTIONS(2138),
    [anon_sym_case] = ACTIONS(2140),
    [anon_sym_yield] = ACTIONS(2140),
    [anon_sym_LBRACK] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2138),
    [anon_sym_SLASH] = ACTIONS(2140),
    [anon_sym_class] = ACTIONS(2140),
    [anon_sym_async] = ACTIONS(2140),
    [anon_sym_function] = ACTIONS(2140),
    [anon_sym_new] = ACTIONS(2140),
    [anon_sym_PLUS] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2140),
    [anon_sym_TILDE] = ACTIONS(2138),
    [anon_sym_void] = ACTIONS(2140),
    [anon_sym_delete] = ACTIONS(2140),
    [anon_sym_PLUS_PLUS] = ACTIONS(2138),
    [anon_sym_DASH_DASH] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2138),
    [sym_number] = ACTIONS(2138),
    [sym_this] = ACTIONS(2140),
    [sym_super] = ACTIONS(2140),
    [sym_true] = ACTIONS(2140),
    [sym_false] = ACTIONS(2140),
    [sym_null] = ACTIONS(2140),
    [sym_undefined] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2140),
    [anon_sym_readonly] = ACTIONS(2140),
    [anon_sym_get] = ACTIONS(2140),
    [anon_sym_set] = ACTIONS(2140),
    [anon_sym_declare] = ACTIONS(2140),
    [anon_sym_public] = ACTIONS(2140),
    [anon_sym_private] = ACTIONS(2140),
    [anon_sym_protected] = ACTIONS(2140),
    [anon_sym_override] = ACTIONS(2140),
    [anon_sym_module] = ACTIONS(2140),
    [anon_sym_any] = ACTIONS(2140),
    [anon_sym_number] = ACTIONS(2140),
    [anon_sym_boolean] = ACTIONS(2140),
    [anon_sym_string] = ACTIONS(2140),
    [anon_sym_symbol] = ACTIONS(2140),
    [anon_sym_abstract] = ACTIONS(2140),
    [anon_sym_interface] = ACTIONS(2140),
    [anon_sym_enum] = ACTIONS(2140),
  },
  [641] = {
    [ts_builtin_sym_end] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2144),
    [anon_sym_export] = ACTIONS(2144),
    [anon_sym_default] = ACTIONS(2144),
    [anon_sym_type] = ACTIONS(2144),
    [anon_sym_namespace] = ACTIONS(2144),
    [anon_sym_LBRACE] = ACTIONS(2142),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [anon_sym_typeof] = ACTIONS(2144),
    [anon_sym_import] = ACTIONS(2144),
    [anon_sym_var] = ACTIONS(2144),
    [anon_sym_let] = ACTIONS(2144),
    [anon_sym_const] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2142),
    [anon_sym_else] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(2144),
    [anon_sym_switch] = ACTIONS(2144),
    [anon_sym_for] = ACTIONS(2144),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_await] = ACTIONS(2144),
    [anon_sym_while] = ACTIONS(2144),
    [anon_sym_do] = ACTIONS(2144),
    [anon_sym_try] = ACTIONS(2144),
    [anon_sym_with] = ACTIONS(2144),
    [anon_sym_break] = ACTIONS(2144),
    [anon_sym_continue] = ACTIONS(2144),
    [anon_sym_debugger] = ACTIONS(2144),
    [anon_sym_return] = ACTIONS(2144),
    [anon_sym_throw] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2142),
    [anon_sym_case] = ACTIONS(2144),
    [anon_sym_yield] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2142),
    [anon_sym_SLASH] = ACTIONS(2144),
    [anon_sym_class] = ACTIONS(2144),
    [anon_sym_async] = ACTIONS(2144),
    [anon_sym_function] = ACTIONS(2144),
    [anon_sym_new] = ACTIONS(2144),
    [anon_sym_PLUS] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2144),
    [anon_sym_TILDE] = ACTIONS(2142),
    [anon_sym_void] = ACTIONS(2144),
    [anon_sym_delete] = ACTIONS(2144),
    [anon_sym_PLUS_PLUS] = ACTIONS(2142),
    [anon_sym_DASH_DASH] = ACTIONS(2142),
    [anon_sym_DQUOTE] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2142),
    [sym_number] = ACTIONS(2142),
    [sym_this] = ACTIONS(2144),
    [sym_super] = ACTIONS(2144),
    [sym_true] = ACTIONS(2144),
    [sym_false] = ACTIONS(2144),
    [sym_null] = ACTIONS(2144),
    [sym_undefined] = ACTIONS(2144),
    [anon_sym_AT] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2144),
    [anon_sym_readonly] = ACTIONS(2144),
    [anon_sym_get] = ACTIONS(2144),
    [anon_sym_set] = ACTIONS(2144),
    [anon_sym_declare] = ACTIONS(2144),
    [anon_sym_public] = ACTIONS(2144),
    [anon_sym_private] = ACTIONS(2144),
    [anon_sym_protected] = ACTIONS(2144),
    [anon_sym_override] = ACTIONS(2144),
    [anon_sym_module] = ACTIONS(2144),
    [anon_sym_any] = ACTIONS(2144),
    [anon_sym_number] = ACTIONS(2144),
    [anon_sym_boolean] = ACTIONS(2144),
    [anon_sym_string] = ACTIONS(2144),
    [anon_sym_symbol] = ACTIONS(2144),
    [anon_sym_abstract] = ACTIONS(2144),
    [anon_sym_interface] = ACTIONS(2144),
    [anon_sym_enum] = ACTIONS(2144),
  },
  [642] = {
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_export] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_namespace] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [anon_sym_typeof] = ACTIONS(2148),
    [anon_sym_import] = ACTIONS(2148),
    [anon_sym_var] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2146),
    [anon_sym_else] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_switch] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_await] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [anon_sym_do] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2148),
    [anon_sym_with] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_debugger] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_throw] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2146),
    [anon_sym_case] = ACTIONS(2148),
    [anon_sym_yield] = ACTIONS(2148),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2148),
    [anon_sym_class] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_function] = ACTIONS(2148),
    [anon_sym_new] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2148),
    [anon_sym_TILDE] = ACTIONS(2146),
    [anon_sym_void] = ACTIONS(2148),
    [anon_sym_delete] = ACTIONS(2148),
    [anon_sym_PLUS_PLUS] = ACTIONS(2146),
    [anon_sym_DASH_DASH] = ACTIONS(2146),
    [anon_sym_DQUOTE] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2146),
    [sym_number] = ACTIONS(2146),
    [sym_this] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_true] = ACTIONS(2148),
    [sym_false] = ACTIONS(2148),
    [sym_null] = ACTIONS(2148),
    [sym_undefined] = ACTIONS(2148),
    [anon_sym_AT] = ACTIONS(2146),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_readonly] = ACTIONS(2148),
    [anon_sym_get] = ACTIONS(2148),
    [anon_sym_set] = ACTIONS(2148),
    [anon_sym_declare] = ACTIONS(2148),
    [anon_sym_public] = ACTIONS(2148),
    [anon_sym_private] = ACTIONS(2148),
    [anon_sym_protected] = ACTIONS(2148),
    [anon_sym_override] = ACTIONS(2148),
    [anon_sym_module] = ACTIONS(2148),
    [anon_sym_any] = ACTIONS(2148),
    [anon_sym_number] = ACTIONS(2148),
    [anon_sym_boolean] = ACTIONS(2148),
    [anon_sym_string] = ACTIONS(2148),
    [anon_sym_symbol] = ACTIONS(2148),
    [anon_sym_abstract] = ACTIONS(2148),
    [anon_sym_interface] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
  },
  [643] = {
    [ts_builtin_sym_end] = ACTIONS(2150),
    [sym_identifier] = ACTIONS(2152),
    [anon_sym_export] = ACTIONS(2152),
    [anon_sym_default] = ACTIONS(2152),
    [anon_sym_type] = ACTIONS(2152),
    [anon_sym_namespace] = ACTIONS(2152),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [anon_sym_typeof] = ACTIONS(2152),
    [anon_sym_import] = ACTIONS(2152),
    [anon_sym_var] = ACTIONS(2152),
    [anon_sym_let] = ACTIONS(2152),
    [anon_sym_const] = ACTIONS(2152),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_else] = ACTIONS(2152),
    [anon_sym_if] = ACTIONS(2152),
    [anon_sym_switch] = ACTIONS(2152),
    [anon_sym_for] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_await] = ACTIONS(2152),
    [anon_sym_while] = ACTIONS(2152),
    [anon_sym_do] = ACTIONS(2152),
    [anon_sym_try] = ACTIONS(2152),
    [anon_sym_with] = ACTIONS(2152),
    [anon_sym_break] = ACTIONS(2152),
    [anon_sym_continue] = ACTIONS(2152),
    [anon_sym_debugger] = ACTIONS(2152),
    [anon_sym_return] = ACTIONS(2152),
    [anon_sym_throw] = ACTIONS(2152),
    [anon_sym_SEMI] = ACTIONS(2150),
    [anon_sym_case] = ACTIONS(2152),
    [anon_sym_yield] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2152),
    [anon_sym_class] = ACTIONS(2152),
    [anon_sym_async] = ACTIONS(2152),
    [anon_sym_function] = ACTIONS(2152),
    [anon_sym_new] = ACTIONS(2152),
    [anon_sym_PLUS] = ACTIONS(2152),
    [anon_sym_DASH] = ACTIONS(2152),
    [anon_sym_TILDE] = ACTIONS(2150),
    [anon_sym_void] = ACTIONS(2152),
    [anon_sym_delete] = ACTIONS(2152),
    [anon_sym_PLUS_PLUS] = ACTIONS(2150),
    [anon_sym_DASH_DASH] = ACTIONS(2150),
    [anon_sym_DQUOTE] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2150),
    [sym_number] = ACTIONS(2150),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(2150),
    [anon_sym_static] = ACTIONS(2152),
    [anon_sym_readonly] = ACTIONS(2152),
    [anon_sym_get] = ACTIONS(2152),
    [anon_sym_set] = ACTIONS(2152),
    [anon_sym_declare] = ACTIONS(2152),
    [anon_sym_public] = ACTIONS(2152),
    [anon_sym_private] = ACTIONS(2152),
    [anon_sym_protected] = ACTIONS(2152),
    [anon_sym_override] = ACTIONS(2152),
    [anon_sym_module] = ACTIONS(2152),
    [anon_sym_any] = ACTIONS(2152),
    [anon_sym_number] = ACTIONS(2152),
    [anon_sym_boolean] = ACTIONS(2152),
    [anon_sym_string] = ACTIONS(2152),
    [anon_sym_symbol] = ACTIONS(2152),
    [anon_sym_abstract] = ACTIONS(2152),
    [anon_sym_interface] = ACTIONS(2152),
    [anon_sym_enum] = ACTIONS(2152),
  },
  [644] = {
    [ts_builtin_sym_end] = ACTIONS(2154),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_export] = ACTIONS(2156),
    [anon_sym_default] = ACTIONS(2156),
    [anon_sym_type] = ACTIONS(2156),
    [anon_sym_namespace] = ACTIONS(2156),
    [anon_sym_LBRACE] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [anon_sym_typeof] = ACTIONS(2156),
    [anon_sym_import] = ACTIONS(2156),
    [anon_sym_var] = ACTIONS(2156),
    [anon_sym_let] = ACTIONS(2156),
    [anon_sym_const] = ACTIONS(2156),
    [anon_sym_BANG] = ACTIONS(2154),
    [anon_sym_else] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(2156),
    [anon_sym_switch] = ACTIONS(2156),
    [anon_sym_for] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_await] = ACTIONS(2156),
    [anon_sym_while] = ACTIONS(2156),
    [anon_sym_do] = ACTIONS(2156),
    [anon_sym_try] = ACTIONS(2156),
    [anon_sym_with] = ACTIONS(2156),
    [anon_sym_break] = ACTIONS(2156),
    [anon_sym_continue] = ACTIONS(2156),
    [anon_sym_debugger] = ACTIONS(2156),
    [anon_sym_return] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2156),
    [anon_sym_SEMI] = ACTIONS(2154),
    [anon_sym_case] = ACTIONS(2156),
    [anon_sym_yield] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_LT] = ACTIONS(2154),
    [anon_sym_SLASH] = ACTIONS(2156),
    [anon_sym_class] = ACTIONS(2156),
    [anon_sym_async] = ACTIONS(2156),
    [anon_sym_function] = ACTIONS(2156),
    [anon_sym_new] = ACTIONS(2156),
    [anon_sym_PLUS] = ACTIONS(2156),
    [anon_sym_DASH] = ACTIONS(2156),
    [anon_sym_TILDE] = ACTIONS(2154),
    [anon_sym_void] = ACTIONS(2156),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_PLUS_PLUS] = ACTIONS(2154),
    [anon_sym_DASH_DASH] = ACTIONS(2154),
    [anon_sym_DQUOTE] = ACTIONS(2154),
    [anon_sym_SQUOTE] = ACTIONS(2154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2154),
    [sym_number] = ACTIONS(2154),
    [sym_this] = ACTIONS(2156),
    [sym_super] = ACTIONS(2156),
    [sym_true] = ACTIONS(2156),
    [sym_false] = ACTIONS(2156),
    [sym_null] = ACTIONS(2156),
    [sym_undefined] = ACTIONS(2156),
    [anon_sym_AT] = ACTIONS(2154),
    [anon_sym_static] = ACTIONS(2156),
    [anon_sym_readonly] = ACTIONS(2156),
    [anon_sym_get] = ACTIONS(2156),
    [anon_sym_set] = ACTIONS(2156),
    [anon_sym_declare] = ACTIONS(2156),
    [anon_sym_public] = ACTIONS(2156),
    [anon_sym_private] = ACTIONS(2156),
    [anon_sym_protected] = ACTIONS(2156),
    [anon_sym_override] = ACTIONS(2156),
    [anon_sym_module] = ACTIONS(2156),
    [anon_sym_any] = ACTIONS(2156),
    [anon_sym_number] = ACTIONS(2156),
    [anon_sym_boolean] = ACTIONS(2156),
    [anon_sym_string] = ACTIONS(2156),
    [anon_sym_symbol] = ACTIONS(2156),
    [anon_sym_abstract] = ACTIONS(2156),
    [anon_sym_interface] = ACTIONS(2156),
    [anon_sym_enum] = ACTIONS(2156),
  },
  [645] = {
    [ts_builtin_sym_end] = ACTIONS(2158),
    [sym_identifier] = ACTIONS(2160),
    [anon_sym_export] = ACTIONS(2160),
    [anon_sym_default] = ACTIONS(2160),
    [anon_sym_type] = ACTIONS(2160),
    [anon_sym_namespace] = ACTIONS(2160),
    [anon_sym_LBRACE] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(2158),
    [anon_sym_typeof] = ACTIONS(2160),
    [anon_sym_import] = ACTIONS(2160),
    [anon_sym_var] = ACTIONS(2160),
    [anon_sym_let] = ACTIONS(2160),
    [anon_sym_const] = ACTIONS(2160),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_else] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(2160),
    [anon_sym_switch] = ACTIONS(2160),
    [anon_sym_for] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_await] = ACTIONS(2160),
    [anon_sym_while] = ACTIONS(2160),
    [anon_sym_do] = ACTIONS(2160),
    [anon_sym_try] = ACTIONS(2160),
    [anon_sym_with] = ACTIONS(2160),
    [anon_sym_break] = ACTIONS(2160),
    [anon_sym_continue] = ACTIONS(2160),
    [anon_sym_debugger] = ACTIONS(2160),
    [anon_sym_return] = ACTIONS(2160),
    [anon_sym_throw] = ACTIONS(2160),
    [anon_sym_SEMI] = ACTIONS(2158),
    [anon_sym_case] = ACTIONS(2160),
    [anon_sym_yield] = ACTIONS(2160),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_LT] = ACTIONS(2158),
    [anon_sym_SLASH] = ACTIONS(2160),
    [anon_sym_class] = ACTIONS(2160),
    [anon_sym_async] = ACTIONS(2160),
    [anon_sym_function] = ACTIONS(2160),
    [anon_sym_new] = ACTIONS(2160),
    [anon_sym_PLUS] = ACTIONS(2160),
    [anon_sym_DASH] = ACTIONS(2160),
    [anon_sym_TILDE] = ACTIONS(2158),
    [anon_sym_void] = ACTIONS(2160),
    [anon_sym_delete] = ACTIONS(2160),
    [anon_sym_PLUS_PLUS] = ACTIONS(2158),
    [anon_sym_DASH_DASH] = ACTIONS(2158),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_SQUOTE] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2158),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(2158),
    [anon_sym_static] = ACTIONS(2160),
    [anon_sym_readonly] = ACTIONS(2160),
    [anon_sym_get] = ACTIONS(2160),
    [anon_sym_set] = ACTIONS(2160),
    [anon_sym_declare] = ACTIONS(2160),
    [anon_sym_public] = ACTIONS(2160),
    [anon_sym_private] = ACTIONS(2160),
    [anon_sym_protected] = ACTIONS(2160),
    [anon_sym_override] = ACTIONS(2160),
    [anon_sym_module] = ACTIONS(2160),
    [anon_sym_any] = ACTIONS(2160),
    [anon_sym_number] = ACTIONS(2160),
    [anon_sym_boolean] = ACTIONS(2160),
    [anon_sym_string] = ACTIONS(2160),
    [anon_sym_symbol] = ACTIONS(2160),
    [anon_sym_abstract] = ACTIONS(2160),
    [anon_sym_interface] = ACTIONS(2160),
    [anon_sym_enum] = ACTIONS(2160),
  },
  [646] = {
    [ts_builtin_sym_end] = ACTIONS(2126),
    [sym_identifier] = ACTIONS(2128),
    [anon_sym_export] = ACTIONS(2128),
    [anon_sym_default] = ACTIONS(2128),
    [anon_sym_type] = ACTIONS(2128),
    [anon_sym_namespace] = ACTIONS(2128),
    [anon_sym_LBRACE] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [anon_sym_typeof] = ACTIONS(2128),
    [anon_sym_import] = ACTIONS(2128),
    [anon_sym_var] = ACTIONS(2128),
    [anon_sym_let] = ACTIONS(2128),
    [anon_sym_const] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2126),
    [anon_sym_else] = ACTIONS(2128),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_switch] = ACTIONS(2128),
    [anon_sym_for] = ACTIONS(2128),
    [anon_sym_LPAREN] = ACTIONS(2126),
    [anon_sym_await] = ACTIONS(2128),
    [anon_sym_while] = ACTIONS(2128),
    [anon_sym_do] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2128),
    [anon_sym_with] = ACTIONS(2128),
    [anon_sym_break] = ACTIONS(2128),
    [anon_sym_continue] = ACTIONS(2128),
    [anon_sym_debugger] = ACTIONS(2128),
    [anon_sym_return] = ACTIONS(2128),
    [anon_sym_throw] = ACTIONS(2128),
    [anon_sym_SEMI] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2128),
    [anon_sym_yield] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2126),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_class] = ACTIONS(2128),
    [anon_sym_async] = ACTIONS(2128),
    [anon_sym_function] = ACTIONS(2128),
    [anon_sym_new] = ACTIONS(2128),
    [anon_sym_PLUS] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2126),
    [anon_sym_void] = ACTIONS(2128),
    [anon_sym_delete] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2126),
    [anon_sym_DQUOTE] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2126),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(2128),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2128),
    [anon_sym_readonly] = ACTIONS(2128),
    [anon_sym_get] = ACTIONS(2128),
    [anon_sym_set] = ACTIONS(2128),
    [anon_sym_declare] = ACTIONS(2128),
    [anon_sym_public] = ACTIONS(2128),
    [anon_sym_private] = ACTIONS(2128),
    [anon_sym_protected] = ACTIONS(2128),
    [anon_sym_override] = ACTIONS(2128),
    [anon_sym_module] = ACTIONS(2128),
    [anon_sym_any] = ACTIONS(2128),
    [anon_sym_number] = ACTIONS(2128),
    [anon_sym_boolean] = ACTIONS(2128),
    [anon_sym_string] = ACTIONS(2128),
    [anon_sym_symbol] = ACTIONS(2128),
    [anon_sym_abstract] = ACTIONS(2128),
    [anon_sym_interface] = ACTIONS(2128),
    [anon_sym_enum] = ACTIONS(2128),
  },
  [647] = {
    [ts_builtin_sym_end] = ACTIONS(2162),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_export] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_namespace] = ACTIONS(2164),
    [anon_sym_LBRACE] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_typeof] = ACTIONS(2164),
    [anon_sym_import] = ACTIONS(2164),
    [anon_sym_var] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_BANG] = ACTIONS(2162),
    [anon_sym_else] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_switch] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2162),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [anon_sym_do] = ACTIONS(2164),
    [anon_sym_try] = ACTIONS(2164),
    [anon_sym_with] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_debugger] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_throw] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2162),
    [anon_sym_case] = ACTIONS(2164),
    [anon_sym_yield] = ACTIONS(2164),
    [anon_sym_LBRACK] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2162),
    [anon_sym_SLASH] = ACTIONS(2164),
    [anon_sym_class] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_function] = ACTIONS(2164),
    [anon_sym_new] = ACTIONS(2164),
    [anon_sym_PLUS] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2164),
    [anon_sym_TILDE] = ACTIONS(2162),
    [anon_sym_void] = ACTIONS(2164),
    [anon_sym_delete] = ACTIONS(2164),
    [anon_sym_PLUS_PLUS] = ACTIONS(2162),
    [anon_sym_DASH_DASH] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [anon_sym_SQUOTE] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [sym_number] = ACTIONS(2162),
    [sym_this] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_undefined] = ACTIONS(2164),
    [anon_sym_AT] = ACTIONS(2162),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_readonly] = ACTIONS(2164),
    [anon_sym_get] = ACTIONS(2164),
    [anon_sym_set] = ACTIONS(2164),
    [anon_sym_declare] = ACTIONS(2164),
    [anon_sym_public] = ACTIONS(2164),
    [anon_sym_private] = ACTIONS(2164),
    [anon_sym_protected] = ACTIONS(2164),
    [anon_sym_override] = ACTIONS(2164),
    [anon_sym_module] = ACTIONS(2164),
    [anon_sym_any] = ACTIONS(2164),
    [anon_sym_number] = ACTIONS(2164),
    [anon_sym_boolean] = ACTIONS(2164),
    [anon_sym_string] = ACTIONS(2164),
    [anon_sym_symbol] = ACTIONS(2164),
    [anon_sym_abstract] = ACTIONS(2164),
    [anon_sym_interface] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
  },
  [648] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1496),
    [anon_sym_export] = ACTIONS(1496),
    [anon_sym_default] = ACTIONS(1496),
    [anon_sym_type] = ACTIONS(1496),
    [anon_sym_namespace] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [anon_sym_typeof] = ACTIONS(1496),
    [anon_sym_import] = ACTIONS(1496),
    [anon_sym_var] = ACTIONS(1496),
    [anon_sym_let] = ACTIONS(1496),
    [anon_sym_const] = ACTIONS(1496),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_else] = ACTIONS(1496),
    [anon_sym_if] = ACTIONS(1496),
    [anon_sym_switch] = ACTIONS(1496),
    [anon_sym_for] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1496),
    [anon_sym_while] = ACTIONS(1496),
    [anon_sym_do] = ACTIONS(1496),
    [anon_sym_try] = ACTIONS(1496),
    [anon_sym_with] = ACTIONS(1496),
    [anon_sym_break] = ACTIONS(1496),
    [anon_sym_continue] = ACTIONS(1496),
    [anon_sym_debugger] = ACTIONS(1496),
    [anon_sym_return] = ACTIONS(1496),
    [anon_sym_throw] = ACTIONS(1496),
    [anon_sym_SEMI] = ACTIONS(1494),
    [anon_sym_case] = ACTIONS(1496),
    [anon_sym_yield] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_LT] = ACTIONS(1494),
    [anon_sym_SLASH] = ACTIONS(1496),
    [anon_sym_class] = ACTIONS(1496),
    [anon_sym_async] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(1496),
    [anon_sym_new] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1496),
    [anon_sym_delete] = ACTIONS(1496),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [sym_number] = ACTIONS(1494),
    [sym_this] = ACTIONS(1496),
    [sym_super] = ACTIONS(1496),
    [sym_true] = ACTIONS(1496),
    [sym_false] = ACTIONS(1496),
    [sym_null] = ACTIONS(1496),
    [sym_undefined] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1494),
    [anon_sym_static] = ACTIONS(1496),
    [anon_sym_readonly] = ACTIONS(1496),
    [anon_sym_get] = ACTIONS(1496),
    [anon_sym_set] = ACTIONS(1496),
    [anon_sym_declare] = ACTIONS(1496),
    [anon_sym_public] = ACTIONS(1496),
    [anon_sym_private] = ACTIONS(1496),
    [anon_sym_protected] = ACTIONS(1496),
    [anon_sym_override] = ACTIONS(1496),
    [anon_sym_module] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1496),
    [anon_sym_number] = ACTIONS(1496),
    [anon_sym_boolean] = ACTIONS(1496),
    [anon_sym_string] = ACTIONS(1496),
    [anon_sym_symbol] = ACTIONS(1496),
    [anon_sym_abstract] = ACTIONS(1496),
    [anon_sym_interface] = ACTIONS(1496),
    [anon_sym_enum] = ACTIONS(1496),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_with] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_debugger] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_function] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_abstract] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
  },
  [650] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_export] = ACTIONS(1484),
    [anon_sym_default] = ACTIONS(1484),
    [anon_sym_type] = ACTIONS(1484),
    [anon_sym_namespace] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_import] = ACTIONS(1484),
    [anon_sym_var] = ACTIONS(1484),
    [anon_sym_let] = ACTIONS(1484),
    [anon_sym_const] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_else] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_switch] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [anon_sym_await] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_do] = ACTIONS(1484),
    [anon_sym_try] = ACTIONS(1484),
    [anon_sym_with] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_debugger] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1484),
    [anon_sym_SEMI] = ACTIONS(1482),
    [anon_sym_case] = ACTIONS(1484),
    [anon_sym_yield] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1482),
    [anon_sym_SLASH] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1484),
    [anon_sym_async] = ACTIONS(1484),
    [anon_sym_function] = ACTIONS(1484),
    [anon_sym_new] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_void] = ACTIONS(1484),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1482),
    [sym_number] = ACTIONS(1482),
    [sym_this] = ACTIONS(1484),
    [sym_super] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_null] = ACTIONS(1484),
    [sym_undefined] = ACTIONS(1484),
    [anon_sym_AT] = ACTIONS(1482),
    [anon_sym_static] = ACTIONS(1484),
    [anon_sym_readonly] = ACTIONS(1484),
    [anon_sym_get] = ACTIONS(1484),
    [anon_sym_set] = ACTIONS(1484),
    [anon_sym_declare] = ACTIONS(1484),
    [anon_sym_public] = ACTIONS(1484),
    [anon_sym_private] = ACTIONS(1484),
    [anon_sym_protected] = ACTIONS(1484),
    [anon_sym_override] = ACTIONS(1484),
    [anon_sym_module] = ACTIONS(1484),
    [anon_sym_any] = ACTIONS(1484),
    [anon_sym_number] = ACTIONS(1484),
    [anon_sym_boolean] = ACTIONS(1484),
    [anon_sym_string] = ACTIONS(1484),
    [anon_sym_symbol] = ACTIONS(1484),
    [anon_sym_abstract] = ACTIONS(1484),
    [anon_sym_interface] = ACTIONS(1484),
    [anon_sym_enum] = ACTIONS(1484),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_export] = ACTIONS(1516),
    [anon_sym_default] = ACTIONS(1516),
    [anon_sym_type] = ACTIONS(1516),
    [anon_sym_namespace] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_typeof] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1516),
    [anon_sym_var] = ACTIONS(1516),
    [anon_sym_let] = ACTIONS(1516),
    [anon_sym_const] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1514),
    [anon_sym_else] = ACTIONS(1516),
    [anon_sym_if] = ACTIONS(1516),
    [anon_sym_switch] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [anon_sym_await] = ACTIONS(1516),
    [anon_sym_while] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(1516),
    [anon_sym_with] = ACTIONS(1516),
    [anon_sym_break] = ACTIONS(1516),
    [anon_sym_continue] = ACTIONS(1516),
    [anon_sym_debugger] = ACTIONS(1516),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_throw] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1516),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(1516),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_void] = ACTIONS(1516),
    [anon_sym_delete] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1514),
    [sym_number] = ACTIONS(1514),
    [sym_this] = ACTIONS(1516),
    [sym_super] = ACTIONS(1516),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_null] = ACTIONS(1516),
    [sym_undefined] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1516),
    [anon_sym_readonly] = ACTIONS(1516),
    [anon_sym_get] = ACTIONS(1516),
    [anon_sym_set] = ACTIONS(1516),
    [anon_sym_declare] = ACTIONS(1516),
    [anon_sym_public] = ACTIONS(1516),
    [anon_sym_private] = ACTIONS(1516),
    [anon_sym_protected] = ACTIONS(1516),
    [anon_sym_override] = ACTIONS(1516),
    [anon_sym_module] = ACTIONS(1516),
    [anon_sym_any] = ACTIONS(1516),
    [anon_sym_number] = ACTIONS(1516),
    [anon_sym_boolean] = ACTIONS(1516),
    [anon_sym_string] = ACTIONS(1516),
    [anon_sym_symbol] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1516),
    [anon_sym_interface] = ACTIONS(1516),
    [anon_sym_enum] = ACTIONS(1516),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_default] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_typeof] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(1448),
    [anon_sym_var] = ACTIONS(1448),
    [anon_sym_let] = ACTIONS(1448),
    [anon_sym_const] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_switch] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_do] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [anon_sym_with] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_debugger] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_throw] = ACTIONS(1448),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_SLASH] = ACTIONS(1448),
    [anon_sym_class] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_function] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_void] = ACTIONS(1448),
    [anon_sym_delete] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [sym_number] = ACTIONS(1446),
    [sym_this] = ACTIONS(1448),
    [sym_super] = ACTIONS(1448),
    [sym_true] = ACTIONS(1448),
    [sym_false] = ACTIONS(1448),
    [sym_null] = ACTIONS(1448),
    [sym_undefined] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_readonly] = ACTIONS(1448),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_override] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [anon_sym_abstract] = ACTIONS(1448),
    [anon_sym_interface] = ACTIONS(1448),
    [anon_sym_enum] = ACTIONS(1448),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_export] = ACTIONS(1516),
    [anon_sym_default] = ACTIONS(1516),
    [anon_sym_type] = ACTIONS(1516),
    [anon_sym_namespace] = ACTIONS(1516),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [anon_sym_typeof] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1516),
    [anon_sym_var] = ACTIONS(1516),
    [anon_sym_let] = ACTIONS(1516),
    [anon_sym_const] = ACTIONS(1516),
    [anon_sym_BANG] = ACTIONS(1514),
    [anon_sym_else] = ACTIONS(1516),
    [anon_sym_if] = ACTIONS(1516),
    [anon_sym_switch] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [anon_sym_await] = ACTIONS(1516),
    [anon_sym_while] = ACTIONS(1516),
    [anon_sym_do] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(1516),
    [anon_sym_with] = ACTIONS(1516),
    [anon_sym_break] = ACTIONS(1516),
    [anon_sym_continue] = ACTIONS(1516),
    [anon_sym_debugger] = ACTIONS(1516),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_throw] = ACTIONS(1516),
    [anon_sym_SEMI] = ACTIONS(1514),
    [anon_sym_case] = ACTIONS(1516),
    [anon_sym_yield] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_LT] = ACTIONS(1514),
    [anon_sym_SLASH] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(1516),
    [anon_sym_new] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_void] = ACTIONS(1516),
    [anon_sym_delete] = ACTIONS(1516),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1514),
    [sym_number] = ACTIONS(1514),
    [sym_this] = ACTIONS(1516),
    [sym_super] = ACTIONS(1516),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_null] = ACTIONS(1516),
    [sym_undefined] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(1514),
    [anon_sym_static] = ACTIONS(1516),
    [anon_sym_readonly] = ACTIONS(1516),
    [anon_sym_get] = ACTIONS(1516),
    [anon_sym_set] = ACTIONS(1516),
    [anon_sym_declare] = ACTIONS(1516),
    [anon_sym_public] = ACTIONS(1516),
    [anon_sym_private] = ACTIONS(1516),
    [anon_sym_protected] = ACTIONS(1516),
    [anon_sym_override] = ACTIONS(1516),
    [anon_sym_module] = ACTIONS(1516),
    [anon_sym_any] = ACTIONS(1516),
    [anon_sym_number] = ACTIONS(1516),
    [anon_sym_boolean] = ACTIONS(1516),
    [anon_sym_string] = ACTIONS(1516),
    [anon_sym_symbol] = ACTIONS(1516),
    [anon_sym_abstract] = ACTIONS(1516),
    [anon_sym_interface] = ACTIONS(1516),
    [anon_sym_enum] = ACTIONS(1516),
  },
  [654] = {
    [ts_builtin_sym_end] = ACTIONS(2170),
    [sym_identifier] = ACTIONS(2172),
    [anon_sym_export] = ACTIONS(2172),
    [anon_sym_default] = ACTIONS(2172),
    [anon_sym_type] = ACTIONS(2172),
    [anon_sym_namespace] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2170),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [anon_sym_typeof] = ACTIONS(2172),
    [anon_sym_import] = ACTIONS(2172),
    [anon_sym_var] = ACTIONS(2172),
    [anon_sym_let] = ACTIONS(2172),
    [anon_sym_const] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2170),
    [anon_sym_else] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(2172),
    [anon_sym_switch] = ACTIONS(2172),
    [anon_sym_for] = ACTIONS(2172),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_await] = ACTIONS(2172),
    [anon_sym_while] = ACTIONS(2172),
    [anon_sym_do] = ACTIONS(2172),
    [anon_sym_try] = ACTIONS(2172),
    [anon_sym_with] = ACTIONS(2172),
    [anon_sym_break] = ACTIONS(2172),
    [anon_sym_continue] = ACTIONS(2172),
    [anon_sym_debugger] = ACTIONS(2172),
    [anon_sym_return] = ACTIONS(2172),
    [anon_sym_throw] = ACTIONS(2172),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_case] = ACTIONS(2172),
    [anon_sym_yield] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_SLASH] = ACTIONS(2172),
    [anon_sym_class] = ACTIONS(2172),
    [anon_sym_async] = ACTIONS(2172),
    [anon_sym_function] = ACTIONS(2172),
    [anon_sym_new] = ACTIONS(2172),
    [anon_sym_PLUS] = ACTIONS(2172),
    [anon_sym_DASH] = ACTIONS(2172),
    [anon_sym_TILDE] = ACTIONS(2170),
    [anon_sym_void] = ACTIONS(2172),
    [anon_sym_delete] = ACTIONS(2172),
    [anon_sym_PLUS_PLUS] = ACTIONS(2170),
    [anon_sym_DASH_DASH] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [sym_number] = ACTIONS(2170),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(2172),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(2170),
    [anon_sym_static] = ACTIONS(2172),
    [anon_sym_readonly] = ACTIONS(2172),
    [anon_sym_get] = ACTIONS(2172),
    [anon_sym_set] = ACTIONS(2172),
    [anon_sym_declare] = ACTIONS(2172),
    [anon_sym_public] = ACTIONS(2172),
    [anon_sym_private] = ACTIONS(2172),
    [anon_sym_protected] = ACTIONS(2172),
    [anon_sym_override] = ACTIONS(2172),
    [anon_sym_module] = ACTIONS(2172),
    [anon_sym_any] = ACTIONS(2172),
    [anon_sym_number] = ACTIONS(2172),
    [anon_sym_boolean] = ACTIONS(2172),
    [anon_sym_string] = ACTIONS(2172),
    [anon_sym_symbol] = ACTIONS(2172),
    [anon_sym_abstract] = ACTIONS(2172),
    [anon_sym_interface] = ACTIONS(2172),
    [anon_sym_enum] = ACTIONS(2172),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_identifier] = ACTIONS(2176),
    [anon_sym_export] = ACTIONS(2176),
    [anon_sym_default] = ACTIONS(2176),
    [anon_sym_type] = ACTIONS(2176),
    [anon_sym_namespace] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [anon_sym_typeof] = ACTIONS(2176),
    [anon_sym_import] = ACTIONS(2176),
    [anon_sym_var] = ACTIONS(2176),
    [anon_sym_let] = ACTIONS(2176),
    [anon_sym_const] = ACTIONS(2176),
    [anon_sym_BANG] = ACTIONS(2174),
    [anon_sym_else] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(2176),
    [anon_sym_switch] = ACTIONS(2176),
    [anon_sym_for] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_await] = ACTIONS(2176),
    [anon_sym_while] = ACTIONS(2176),
    [anon_sym_do] = ACTIONS(2176),
    [anon_sym_try] = ACTIONS(2176),
    [anon_sym_with] = ACTIONS(2176),
    [anon_sym_break] = ACTIONS(2176),
    [anon_sym_continue] = ACTIONS(2176),
    [anon_sym_debugger] = ACTIONS(2176),
    [anon_sym_return] = ACTIONS(2176),
    [anon_sym_throw] = ACTIONS(2176),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_case] = ACTIONS(2176),
    [anon_sym_yield] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2176),
    [anon_sym_class] = ACTIONS(2176),
    [anon_sym_async] = ACTIONS(2176),
    [anon_sym_function] = ACTIONS(2176),
    [anon_sym_new] = ACTIONS(2176),
    [anon_sym_PLUS] = ACTIONS(2176),
    [anon_sym_DASH] = ACTIONS(2176),
    [anon_sym_TILDE] = ACTIONS(2174),
    [anon_sym_void] = ACTIONS(2176),
    [anon_sym_delete] = ACTIONS(2176),
    [anon_sym_PLUS_PLUS] = ACTIONS(2174),
    [anon_sym_DASH_DASH] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(2174),
    [anon_sym_SQUOTE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2174),
    [sym_number] = ACTIONS(2174),
    [sym_this] = ACTIONS(2176),
    [sym_super] = ACTIONS(2176),
    [sym_true] = ACTIONS(2176),
    [sym_false] = ACTIONS(2176),
    [sym_null] = ACTIONS(2176),
    [sym_undefined] = ACTIONS(2176),
    [anon_sym_AT] = ACTIONS(2174),
    [anon_sym_static] = ACTIONS(2176),
    [anon_sym_readonly] = ACTIONS(2176),
    [anon_sym_get] = ACTIONS(2176),
    [anon_sym_set] = ACTIONS(2176),
    [anon_sym_declare] = ACTIONS(2176),
    [anon_sym_public] = ACTIONS(2176),
    [anon_sym_private] = ACTIONS(2176),
    [anon_sym_protected] = ACTIONS(2176),
    [anon_sym_override] = ACTIONS(2176),
    [anon_sym_module] = ACTIONS(2176),
    [anon_sym_any] = ACTIONS(2176),
    [anon_sym_number] = ACTIONS(2176),
    [anon_sym_boolean] = ACTIONS(2176),
    [anon_sym_string] = ACTIONS(2176),
    [anon_sym_symbol] = ACTIONS(2176),
    [anon_sym_abstract] = ACTIONS(2176),
    [anon_sym_interface] = ACTIONS(2176),
    [anon_sym_enum] = ACTIONS(2176),
  },
  [656] = {
    [ts_builtin_sym_end] = ACTIONS(2178),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_export] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_type] = ACTIONS(2180),
    [anon_sym_namespace] = ACTIONS(2180),
    [anon_sym_LBRACE] = ACTIONS(2178),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_typeof] = ACTIONS(2180),
    [anon_sym_import] = ACTIONS(2180),
    [anon_sym_var] = ACTIONS(2180),
    [anon_sym_let] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_BANG] = ACTIONS(2178),
    [anon_sym_else] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_switch] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_LPAREN] = ACTIONS(2178),
    [anon_sym_await] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [anon_sym_do] = ACTIONS(2180),
    [anon_sym_try] = ACTIONS(2180),
    [anon_sym_with] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_debugger] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_throw] = ACTIONS(2180),
    [anon_sym_SEMI] = ACTIONS(2178),
    [anon_sym_case] = ACTIONS(2180),
    [anon_sym_yield] = ACTIONS(2180),
    [anon_sym_LBRACK] = ACTIONS(2178),
    [anon_sym_LT] = ACTIONS(2178),
    [anon_sym_SLASH] = ACTIONS(2180),
    [anon_sym_class] = ACTIONS(2180),
    [anon_sym_async] = ACTIONS(2180),
    [anon_sym_function] = ACTIONS(2180),
    [anon_sym_new] = ACTIONS(2180),
    [anon_sym_PLUS] = ACTIONS(2180),
    [anon_sym_DASH] = ACTIONS(2180),
    [anon_sym_TILDE] = ACTIONS(2178),
    [anon_sym_void] = ACTIONS(2180),
    [anon_sym_delete] = ACTIONS(2180),
    [anon_sym_PLUS_PLUS] = ACTIONS(2178),
    [anon_sym_DASH_DASH] = ACTIONS(2178),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [anon_sym_SQUOTE] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2178),
    [sym_number] = ACTIONS(2178),
    [sym_this] = ACTIONS(2180),
    [sym_super] = ACTIONS(2180),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_undefined] = ACTIONS(2180),
    [anon_sym_AT] = ACTIONS(2178),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_readonly] = ACTIONS(2180),
    [anon_sym_get] = ACTIONS(2180),
    [anon_sym_set] = ACTIONS(2180),
    [anon_sym_declare] = ACTIONS(2180),
    [anon_sym_public] = ACTIONS(2180),
    [anon_sym_private] = ACTIONS(2180),
    [anon_sym_protected] = ACTIONS(2180),
    [anon_sym_override] = ACTIONS(2180),
    [anon_sym_module] = ACTIONS(2180),
    [anon_sym_any] = ACTIONS(2180),
    [anon_sym_number] = ACTIONS(2180),
    [anon_sym_boolean] = ACTIONS(2180),
    [anon_sym_string] = ACTIONS(2180),
    [anon_sym_symbol] = ACTIONS(2180),
    [anon_sym_abstract] = ACTIONS(2180),
    [anon_sym_interface] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
  },
  [657] = {
    [ts_builtin_sym_end] = ACTIONS(2182),
    [sym_identifier] = ACTIONS(2184),
    [anon_sym_export] = ACTIONS(2184),
    [anon_sym_default] = ACTIONS(2184),
    [anon_sym_type] = ACTIONS(2184),
    [anon_sym_namespace] = ACTIONS(2184),
    [anon_sym_LBRACE] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_typeof] = ACTIONS(2184),
    [anon_sym_import] = ACTIONS(2184),
    [anon_sym_var] = ACTIONS(2184),
    [anon_sym_let] = ACTIONS(2184),
    [anon_sym_const] = ACTIONS(2184),
    [anon_sym_BANG] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2184),
    [anon_sym_switch] = ACTIONS(2184),
    [anon_sym_for] = ACTIONS(2184),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_await] = ACTIONS(2184),
    [anon_sym_while] = ACTIONS(2184),
    [anon_sym_do] = ACTIONS(2184),
    [anon_sym_try] = ACTIONS(2184),
    [anon_sym_with] = ACTIONS(2184),
    [anon_sym_break] = ACTIONS(2184),
    [anon_sym_continue] = ACTIONS(2184),
    [anon_sym_debugger] = ACTIONS(2184),
    [anon_sym_return] = ACTIONS(2184),
    [anon_sym_throw] = ACTIONS(2184),
    [anon_sym_SEMI] = ACTIONS(2182),
    [anon_sym_case] = ACTIONS(2184),
    [anon_sym_yield] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2184),
    [anon_sym_class] = ACTIONS(2184),
    [anon_sym_async] = ACTIONS(2184),
    [anon_sym_function] = ACTIONS(2184),
    [anon_sym_new] = ACTIONS(2184),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_DASH] = ACTIONS(2184),
    [anon_sym_TILDE] = ACTIONS(2182),
    [anon_sym_void] = ACTIONS(2184),
    [anon_sym_delete] = ACTIONS(2184),
    [anon_sym_PLUS_PLUS] = ACTIONS(2182),
    [anon_sym_DASH_DASH] = ACTIONS(2182),
    [anon_sym_DQUOTE] = ACTIONS(2182),
    [anon_sym_SQUOTE] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2182),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2184),
    [sym_super] = ACTIONS(2184),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_undefined] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_static] = ACTIONS(2184),
    [anon_sym_readonly] = ACTIONS(2184),
    [anon_sym_get] = ACTIONS(2184),
    [anon_sym_set] = ACTIONS(2184),
    [anon_sym_declare] = ACTIONS(2184),
    [anon_sym_public] = ACTIONS(2184),
    [anon_sym_private] = ACTIONS(2184),
    [anon_sym_protected] = ACTIONS(2184),
    [anon_sym_override] = ACTIONS(2184),
    [anon_sym_module] = ACTIONS(2184),
    [anon_sym_any] = ACTIONS(2184),
    [anon_sym_number] = ACTIONS(2184),
    [anon_sym_boolean] = ACTIONS(2184),
    [anon_sym_string] = ACTIONS(2184),
    [anon_sym_symbol] = ACTIONS(2184),
    [anon_sym_abstract] = ACTIONS(2184),
    [anon_sym_interface] = ACTIONS(2184),
    [anon_sym_enum] = ACTIONS(2184),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(2186),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_export] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_namespace] = ACTIONS(2188),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_typeof] = ACTIONS(2188),
    [anon_sym_import] = ACTIONS(2188),
    [anon_sym_var] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_BANG] = ACTIONS(2186),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_switch] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [anon_sym_do] = ACTIONS(2188),
    [anon_sym_try] = ACTIONS(2188),
    [anon_sym_with] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_debugger] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_throw] = ACTIONS(2188),
    [anon_sym_SEMI] = ACTIONS(2186),
    [anon_sym_case] = ACTIONS(2188),
    [anon_sym_yield] = ACTIONS(2188),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_LT] = ACTIONS(2186),
    [anon_sym_SLASH] = ACTIONS(2188),
    [anon_sym_class] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_function] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(2188),
    [anon_sym_PLUS] = ACTIONS(2188),
    [anon_sym_DASH] = ACTIONS(2188),
    [anon_sym_TILDE] = ACTIONS(2186),
    [anon_sym_void] = ACTIONS(2188),
    [anon_sym_delete] = ACTIONS(2188),
    [anon_sym_PLUS_PLUS] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2186),
    [anon_sym_DQUOTE] = ACTIONS(2186),
    [anon_sym_SQUOTE] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2186),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(2186),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_readonly] = ACTIONS(2188),
    [anon_sym_get] = ACTIONS(2188),
    [anon_sym_set] = ACTIONS(2188),
    [anon_sym_declare] = ACTIONS(2188),
    [anon_sym_public] = ACTIONS(2188),
    [anon_sym_private] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(2188),
    [anon_sym_override] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(2188),
    [anon_sym_number] = ACTIONS(2188),
    [anon_sym_boolean] = ACTIONS(2188),
    [anon_sym_string] = ACTIONS(2188),
    [anon_sym_symbol] = ACTIONS(2188),
    [anon_sym_abstract] = ACTIONS(2188),
    [anon_sym_interface] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(2190),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_export] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_namespace] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2190),
    [anon_sym_RBRACE] = ACTIONS(2190),
    [anon_sym_typeof] = ACTIONS(2192),
    [anon_sym_import] = ACTIONS(2192),
    [anon_sym_var] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_else] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2190),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [anon_sym_do] = ACTIONS(2192),
    [anon_sym_try] = ACTIONS(2192),
    [anon_sym_with] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_debugger] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_throw] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2190),
    [anon_sym_case] = ACTIONS(2192),
    [anon_sym_yield] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2190),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_class] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_function] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_TILDE] = ACTIONS(2190),
    [anon_sym_void] = ACTIONS(2192),
    [anon_sym_delete] = ACTIONS(2192),
    [anon_sym_PLUS_PLUS] = ACTIONS(2190),
    [anon_sym_DASH_DASH] = ACTIONS(2190),
    [anon_sym_DQUOTE] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2190),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(2190),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_readonly] = ACTIONS(2192),
    [anon_sym_get] = ACTIONS(2192),
    [anon_sym_set] = ACTIONS(2192),
    [anon_sym_declare] = ACTIONS(2192),
    [anon_sym_public] = ACTIONS(2192),
    [anon_sym_private] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(2192),
    [anon_sym_override] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(2192),
    [anon_sym_number] = ACTIONS(2192),
    [anon_sym_boolean] = ACTIONS(2192),
    [anon_sym_string] = ACTIONS(2192),
    [anon_sym_symbol] = ACTIONS(2192),
    [anon_sym_abstract] = ACTIONS(2192),
    [anon_sym_interface] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
  },
  [660] = {
    [ts_builtin_sym_end] = ACTIONS(2194),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_namespace] = ACTIONS(2196),
    [anon_sym_LBRACE] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [anon_sym_typeof] = ACTIONS(2196),
    [anon_sym_import] = ACTIONS(2196),
    [anon_sym_var] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_BANG] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_switch] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [anon_sym_do] = ACTIONS(2196),
    [anon_sym_try] = ACTIONS(2196),
    [anon_sym_with] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_debugger] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_throw] = ACTIONS(2196),
    [anon_sym_SEMI] = ACTIONS(2194),
    [anon_sym_case] = ACTIONS(2196),
    [anon_sym_yield] = ACTIONS(2196),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_class] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_function] = ACTIONS(2196),
    [anon_sym_new] = ACTIONS(2196),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_TILDE] = ACTIONS(2194),
    [anon_sym_void] = ACTIONS(2196),
    [anon_sym_delete] = ACTIONS(2196),
    [anon_sym_PLUS_PLUS] = ACTIONS(2194),
    [anon_sym_DASH_DASH] = ACTIONS(2194),
    [anon_sym_DQUOTE] = ACTIONS(2194),
    [anon_sym_SQUOTE] = ACTIONS(2194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2194),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2194),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_readonly] = ACTIONS(2196),
    [anon_sym_get] = ACTIONS(2196),
    [anon_sym_set] = ACTIONS(2196),
    [anon_sym_declare] = ACTIONS(2196),
    [anon_sym_public] = ACTIONS(2196),
    [anon_sym_private] = ACTIONS(2196),
    [anon_sym_protected] = ACTIONS(2196),
    [anon_sym_override] = ACTIONS(2196),
    [anon_sym_module] = ACTIONS(2196),
    [anon_sym_any] = ACTIONS(2196),
    [anon_sym_number] = ACTIONS(2196),
    [anon_sym_boolean] = ACTIONS(2196),
    [anon_sym_string] = ACTIONS(2196),
    [anon_sym_symbol] = ACTIONS(2196),
    [anon_sym_abstract] = ACTIONS(2196),
    [anon_sym_interface] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
  },
  [661] = {
    [ts_builtin_sym_end] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1556),
    [anon_sym_export] = ACTIONS(1556),
    [anon_sym_default] = ACTIONS(1556),
    [anon_sym_type] = ACTIONS(1556),
    [anon_sym_namespace] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_RBRACE] = ACTIONS(1554),
    [anon_sym_typeof] = ACTIONS(1556),
    [anon_sym_import] = ACTIONS(1556),
    [anon_sym_var] = ACTIONS(1556),
    [anon_sym_let] = ACTIONS(1556),
    [anon_sym_const] = ACTIONS(1556),
    [anon_sym_BANG] = ACTIONS(1554),
    [anon_sym_else] = ACTIONS(1556),
    [anon_sym_if] = ACTIONS(1556),
    [anon_sym_switch] = ACTIONS(1556),
    [anon_sym_for] = ACTIONS(1556),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_await] = ACTIONS(1556),
    [anon_sym_while] = ACTIONS(1556),
    [anon_sym_do] = ACTIONS(1556),
    [anon_sym_try] = ACTIONS(1556),
    [anon_sym_with] = ACTIONS(1556),
    [anon_sym_break] = ACTIONS(1556),
    [anon_sym_continue] = ACTIONS(1556),
    [anon_sym_debugger] = ACTIONS(1556),
    [anon_sym_return] = ACTIONS(1556),
    [anon_sym_throw] = ACTIONS(1556),
    [anon_sym_SEMI] = ACTIONS(1554),
    [anon_sym_case] = ACTIONS(1556),
    [anon_sym_yield] = ACTIONS(1556),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_LT] = ACTIONS(1554),
    [anon_sym_SLASH] = ACTIONS(1556),
    [anon_sym_class] = ACTIONS(1556),
    [anon_sym_async] = ACTIONS(1556),
    [anon_sym_function] = ACTIONS(1556),
    [anon_sym_new] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_void] = ACTIONS(1556),
    [anon_sym_delete] = ACTIONS(1556),
    [anon_sym_PLUS_PLUS] = ACTIONS(1554),
    [anon_sym_DASH_DASH] = ACTIONS(1554),
    [anon_sym_DQUOTE] = ACTIONS(1554),
    [anon_sym_SQUOTE] = ACTIONS(1554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1554),
    [sym_number] = ACTIONS(1554),
    [sym_this] = ACTIONS(1556),
    [sym_super] = ACTIONS(1556),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1554),
    [anon_sym_static] = ACTIONS(1556),
    [anon_sym_readonly] = ACTIONS(1556),
    [anon_sym_get] = ACTIONS(1556),
    [anon_sym_set] = ACTIONS(1556),
    [anon_sym_declare] = ACTIONS(1556),
    [anon_sym_public] = ACTIONS(1556),
    [anon_sym_private] = ACTIONS(1556),
    [anon_sym_protected] = ACTIONS(1556),
    [anon_sym_override] = ACTIONS(1556),
    [anon_sym_module] = ACTIONS(1556),
    [anon_sym_any] = ACTIONS(1556),
    [anon_sym_number] = ACTIONS(1556),
    [anon_sym_boolean] = ACTIONS(1556),
    [anon_sym_string] = ACTIONS(1556),
    [anon_sym_symbol] = ACTIONS(1556),
    [anon_sym_abstract] = ACTIONS(1556),
    [anon_sym_interface] = ACTIONS(1556),
    [anon_sym_enum] = ACTIONS(1556),
  },
  [662] = {
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_export] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_namespace] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_typeof] = ACTIONS(2200),
    [anon_sym_import] = ACTIONS(2200),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_switch] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_await] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_do] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [anon_sym_with] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_debugger] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_throw] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2200),
    [anon_sym_class] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_function] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2200),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2200),
    [anon_sym_delete] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2198),
    [anon_sym_DQUOTE] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2198),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_readonly] = ACTIONS(2200),
    [anon_sym_get] = ACTIONS(2200),
    [anon_sym_set] = ACTIONS(2200),
    [anon_sym_declare] = ACTIONS(2200),
    [anon_sym_public] = ACTIONS(2200),
    [anon_sym_private] = ACTIONS(2200),
    [anon_sym_protected] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_module] = ACTIONS(2200),
    [anon_sym_any] = ACTIONS(2200),
    [anon_sym_number] = ACTIONS(2200),
    [anon_sym_boolean] = ACTIONS(2200),
    [anon_sym_string] = ACTIONS(2200),
    [anon_sym_symbol] = ACTIONS(2200),
    [anon_sym_abstract] = ACTIONS(2200),
    [anon_sym_interface] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
  },
  [663] = {
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_export] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_namespace] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_typeof] = ACTIONS(2200),
    [anon_sym_import] = ACTIONS(2200),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_switch] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_await] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_do] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [anon_sym_with] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_debugger] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_throw] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2200),
    [anon_sym_class] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_function] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2200),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2200),
    [anon_sym_delete] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2198),
    [anon_sym_DQUOTE] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2198),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_readonly] = ACTIONS(2200),
    [anon_sym_get] = ACTIONS(2200),
    [anon_sym_set] = ACTIONS(2200),
    [anon_sym_declare] = ACTIONS(2200),
    [anon_sym_public] = ACTIONS(2200),
    [anon_sym_private] = ACTIONS(2200),
    [anon_sym_protected] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_module] = ACTIONS(2200),
    [anon_sym_any] = ACTIONS(2200),
    [anon_sym_number] = ACTIONS(2200),
    [anon_sym_boolean] = ACTIONS(2200),
    [anon_sym_string] = ACTIONS(2200),
    [anon_sym_symbol] = ACTIONS(2200),
    [anon_sym_abstract] = ACTIONS(2200),
    [anon_sym_interface] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
  },
  [664] = {
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_export] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_namespace] = ACTIONS(2200),
    [anon_sym_LBRACE] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [anon_sym_typeof] = ACTIONS(2200),
    [anon_sym_import] = ACTIONS(2200),
    [anon_sym_var] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_BANG] = ACTIONS(2198),
    [anon_sym_else] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_switch] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2198),
    [anon_sym_await] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [anon_sym_do] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2200),
    [anon_sym_with] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_debugger] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_throw] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2198),
    [anon_sym_case] = ACTIONS(2200),
    [anon_sym_yield] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_SLASH] = ACTIONS(2200),
    [anon_sym_class] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_function] = ACTIONS(2200),
    [anon_sym_new] = ACTIONS(2200),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2200),
    [anon_sym_delete] = ACTIONS(2200),
    [anon_sym_PLUS_PLUS] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2198),
    [anon_sym_DQUOTE] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2198),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(2198),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_readonly] = ACTIONS(2200),
    [anon_sym_get] = ACTIONS(2200),
    [anon_sym_set] = ACTIONS(2200),
    [anon_sym_declare] = ACTIONS(2200),
    [anon_sym_public] = ACTIONS(2200),
    [anon_sym_private] = ACTIONS(2200),
    [anon_sym_protected] = ACTIONS(2200),
    [anon_sym_override] = ACTIONS(2200),
    [anon_sym_module] = ACTIONS(2200),
    [anon_sym_any] = ACTIONS(2200),
    [anon_sym_number] = ACTIONS(2200),
    [anon_sym_boolean] = ACTIONS(2200),
    [anon_sym_string] = ACTIONS(2200),
    [anon_sym_symbol] = ACTIONS(2200),
    [anon_sym_abstract] = ACTIONS(2200),
    [anon_sym_interface] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(2202),
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(2202),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2202),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_with] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_SLASH] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2202),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2202),
    [anon_sym_DASH_DASH] = ACTIONS(2202),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_SQUOTE] = ACTIONS(2202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2202),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2204),
    [anon_sym_readonly] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_override] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
  },
  [666] = {
    [ts_builtin_sym_end] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2208),
    [anon_sym_export] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_namespace] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_typeof] = ACTIONS(2208),
    [anon_sym_import] = ACTIONS(2208),
    [anon_sym_var] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_switch] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_do] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [anon_sym_with] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_debugger] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_throw] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_LT] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2208),
    [anon_sym_class] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_function] = ACTIONS(2208),
    [anon_sym_new] = ACTIONS(2208),
    [anon_sym_PLUS] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_void] = ACTIONS(2208),
    [anon_sym_delete] = ACTIONS(2208),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2206),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2206),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_true] = ACTIONS(2208),
    [sym_false] = ACTIONS(2208),
    [sym_null] = ACTIONS(2208),
    [sym_undefined] = ACTIONS(2208),
    [anon_sym_AT] = ACTIONS(2206),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_readonly] = ACTIONS(2208),
    [anon_sym_get] = ACTIONS(2208),
    [anon_sym_set] = ACTIONS(2208),
    [anon_sym_declare] = ACTIONS(2208),
    [anon_sym_public] = ACTIONS(2208),
    [anon_sym_private] = ACTIONS(2208),
    [anon_sym_protected] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_module] = ACTIONS(2208),
    [anon_sym_any] = ACTIONS(2208),
    [anon_sym_number] = ACTIONS(2208),
    [anon_sym_boolean] = ACTIONS(2208),
    [anon_sym_string] = ACTIONS(2208),
    [anon_sym_symbol] = ACTIONS(2208),
    [anon_sym_abstract] = ACTIONS(2208),
    [anon_sym_interface] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
  },
  [667] = {
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym_identifier] = ACTIONS(2212),
    [anon_sym_export] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_type] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_import] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_with] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_debugger] = ACTIONS(2212),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_LT] = ACTIONS(2210),
    [anon_sym_SLASH] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_function] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_TILDE] = ACTIONS(2210),
    [anon_sym_void] = ACTIONS(2212),
    [anon_sym_delete] = ACTIONS(2212),
    [anon_sym_PLUS_PLUS] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2210),
    [anon_sym_DQUOTE] = ACTIONS(2210),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2210),
    [sym_number] = ACTIONS(2210),
    [sym_this] = ACTIONS(2212),
    [sym_super] = ACTIONS(2212),
    [sym_true] = ACTIONS(2212),
    [sym_false] = ACTIONS(2212),
    [sym_null] = ACTIONS(2212),
    [sym_undefined] = ACTIONS(2212),
    [anon_sym_AT] = ACTIONS(2210),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_declare] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_module] = ACTIONS(2212),
    [anon_sym_any] = ACTIONS(2212),
    [anon_sym_number] = ACTIONS(2212),
    [anon_sym_boolean] = ACTIONS(2212),
    [anon_sym_string] = ACTIONS(2212),
    [anon_sym_symbol] = ACTIONS(2212),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
  },
  [668] = {
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_export] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_type] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_import] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_with] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_debugger] = ACTIONS(2216),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_function] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_void] = ACTIONS(2216),
    [anon_sym_delete] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2214),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(2216),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_declare] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_module] = ACTIONS(2216),
    [anon_sym_any] = ACTIONS(2216),
    [anon_sym_number] = ACTIONS(2216),
    [anon_sym_boolean] = ACTIONS(2216),
    [anon_sym_string] = ACTIONS(2216),
    [anon_sym_symbol] = ACTIONS(2216),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
  },
  [669] = {
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_export] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_namespace] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_typeof] = ACTIONS(2220),
    [anon_sym_import] = ACTIONS(2220),
    [anon_sym_var] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_await] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_do] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [anon_sym_with] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_debugger] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_throw] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2218),
    [anon_sym_SLASH] = ACTIONS(2220),
    [anon_sym_class] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_function] = ACTIONS(2220),
    [anon_sym_new] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_void] = ACTIONS(2220),
    [anon_sym_delete] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2218),
    [anon_sym_DQUOTE] = ACTIONS(2218),
    [anon_sym_SQUOTE] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2218),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_readonly] = ACTIONS(2220),
    [anon_sym_get] = ACTIONS(2220),
    [anon_sym_set] = ACTIONS(2220),
    [anon_sym_declare] = ACTIONS(2220),
    [anon_sym_public] = ACTIONS(2220),
    [anon_sym_private] = ACTIONS(2220),
    [anon_sym_protected] = ACTIONS(2220),
    [anon_sym_override] = ACTIONS(2220),
    [anon_sym_module] = ACTIONS(2220),
    [anon_sym_any] = ACTIONS(2220),
    [anon_sym_number] = ACTIONS(2220),
    [anon_sym_boolean] = ACTIONS(2220),
    [anon_sym_string] = ACTIONS(2220),
    [anon_sym_symbol] = ACTIONS(2220),
    [anon_sym_abstract] = ACTIONS(2220),
    [anon_sym_interface] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_export] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_typeof] = ACTIONS(2224),
    [anon_sym_import] = ACTIONS(2224),
    [anon_sym_var] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_await] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_with] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_debugger] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_LT] = ACTIONS(2222),
    [anon_sym_SLASH] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_function] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_void] = ACTIONS(2224),
    [anon_sym_delete] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2222),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_readonly] = ACTIONS(2224),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_declare] = ACTIONS(2224),
    [anon_sym_public] = ACTIONS(2224),
    [anon_sym_private] = ACTIONS(2224),
    [anon_sym_protected] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_module] = ACTIONS(2224),
    [anon_sym_any] = ACTIONS(2224),
    [anon_sym_number] = ACTIONS(2224),
    [anon_sym_boolean] = ACTIONS(2224),
    [anon_sym_string] = ACTIONS(2224),
    [anon_sym_symbol] = ACTIONS(2224),
    [anon_sym_abstract] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym_identifier] = ACTIONS(2228),
    [anon_sym_export] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_type] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_RBRACE] = ACTIONS(2226),
    [anon_sym_typeof] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2228),
    [anon_sym_var] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_await] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_with] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_debugger] = ACTIONS(2228),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2226),
    [anon_sym_SLASH] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_function] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_void] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(2228),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_readonly] = ACTIONS(2228),
    [anon_sym_get] = ACTIONS(2228),
    [anon_sym_set] = ACTIONS(2228),
    [anon_sym_declare] = ACTIONS(2228),
    [anon_sym_public] = ACTIONS(2228),
    [anon_sym_private] = ACTIONS(2228),
    [anon_sym_protected] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [anon_sym_module] = ACTIONS(2228),
    [anon_sym_any] = ACTIONS(2228),
    [anon_sym_number] = ACTIONS(2228),
    [anon_sym_boolean] = ACTIONS(2228),
    [anon_sym_string] = ACTIONS(2228),
    [anon_sym_symbol] = ACTIONS(2228),
    [anon_sym_abstract] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_identifier] = ACTIONS(2232),
    [anon_sym_export] = ACTIONS(2232),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_type] = ACTIONS(2232),
    [anon_sym_namespace] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2230),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_typeof] = ACTIONS(2232),
    [anon_sym_import] = ACTIONS(2232),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2232),
    [anon_sym_const] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(2232),
    [anon_sym_switch] = ACTIONS(2232),
    [anon_sym_for] = ACTIONS(2232),
    [anon_sym_LPAREN] = ACTIONS(2230),
    [anon_sym_await] = ACTIONS(2232),
    [anon_sym_while] = ACTIONS(2232),
    [anon_sym_do] = ACTIONS(2232),
    [anon_sym_try] = ACTIONS(2232),
    [anon_sym_with] = ACTIONS(2232),
    [anon_sym_break] = ACTIONS(2232),
    [anon_sym_continue] = ACTIONS(2232),
    [anon_sym_debugger] = ACTIONS(2232),
    [anon_sym_return] = ACTIONS(2232),
    [anon_sym_throw] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2232),
    [anon_sym_yield] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(2230),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_class] = ACTIONS(2232),
    [anon_sym_async] = ACTIONS(2232),
    [anon_sym_function] = ACTIONS(2232),
    [anon_sym_new] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2230),
    [anon_sym_void] = ACTIONS(2232),
    [anon_sym_delete] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2230),
    [anon_sym_DQUOTE] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2230),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(2232),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2232),
    [anon_sym_readonly] = ACTIONS(2232),
    [anon_sym_get] = ACTIONS(2232),
    [anon_sym_set] = ACTIONS(2232),
    [anon_sym_declare] = ACTIONS(2232),
    [anon_sym_public] = ACTIONS(2232),
    [anon_sym_private] = ACTIONS(2232),
    [anon_sym_protected] = ACTIONS(2232),
    [anon_sym_override] = ACTIONS(2232),
    [anon_sym_module] = ACTIONS(2232),
    [anon_sym_any] = ACTIONS(2232),
    [anon_sym_number] = ACTIONS(2232),
    [anon_sym_boolean] = ACTIONS(2232),
    [anon_sym_string] = ACTIONS(2232),
    [anon_sym_symbol] = ACTIONS(2232),
    [anon_sym_abstract] = ACTIONS(2232),
    [anon_sym_interface] = ACTIONS(2232),
    [anon_sym_enum] = ACTIONS(2232),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_export] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [anon_sym_typeof] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(2236),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_with] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_debugger] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_function] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2234),
    [anon_sym_void] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2234),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2234),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [sym_null] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_readonly] = ACTIONS(2236),
    [anon_sym_get] = ACTIONS(2236),
    [anon_sym_set] = ACTIONS(2236),
    [anon_sym_declare] = ACTIONS(2236),
    [anon_sym_public] = ACTIONS(2236),
    [anon_sym_private] = ACTIONS(2236),
    [anon_sym_protected] = ACTIONS(2236),
    [anon_sym_override] = ACTIONS(2236),
    [anon_sym_module] = ACTIONS(2236),
    [anon_sym_any] = ACTIONS(2236),
    [anon_sym_number] = ACTIONS(2236),
    [anon_sym_boolean] = ACTIONS(2236),
    [anon_sym_string] = ACTIONS(2236),
    [anon_sym_symbol] = ACTIONS(2236),
    [anon_sym_abstract] = ACTIONS(2236),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(2238),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_export] = ACTIONS(2240),
    [anon_sym_default] = ACTIONS(2240),
    [anon_sym_type] = ACTIONS(2240),
    [anon_sym_namespace] = ACTIONS(2240),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_typeof] = ACTIONS(2240),
    [anon_sym_import] = ACTIONS(2240),
    [anon_sym_var] = ACTIONS(2240),
    [anon_sym_let] = ACTIONS(2240),
    [anon_sym_const] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(2240),
    [anon_sym_switch] = ACTIONS(2240),
    [anon_sym_for] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_await] = ACTIONS(2240),
    [anon_sym_while] = ACTIONS(2240),
    [anon_sym_do] = ACTIONS(2240),
    [anon_sym_try] = ACTIONS(2240),
    [anon_sym_with] = ACTIONS(2240),
    [anon_sym_break] = ACTIONS(2240),
    [anon_sym_continue] = ACTIONS(2240),
    [anon_sym_debugger] = ACTIONS(2240),
    [anon_sym_return] = ACTIONS(2240),
    [anon_sym_throw] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2240),
    [anon_sym_yield] = ACTIONS(2240),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2240),
    [anon_sym_class] = ACTIONS(2240),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2240),
    [anon_sym_new] = ACTIONS(2240),
    [anon_sym_PLUS] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_void] = ACTIONS(2240),
    [anon_sym_delete] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2238),
    [sym_number] = ACTIONS(2238),
    [sym_this] = ACTIONS(2240),
    [sym_super] = ACTIONS(2240),
    [sym_true] = ACTIONS(2240),
    [sym_false] = ACTIONS(2240),
    [sym_null] = ACTIONS(2240),
    [sym_undefined] = ACTIONS(2240),
    [anon_sym_AT] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2240),
    [anon_sym_readonly] = ACTIONS(2240),
    [anon_sym_get] = ACTIONS(2240),
    [anon_sym_set] = ACTIONS(2240),
    [anon_sym_declare] = ACTIONS(2240),
    [anon_sym_public] = ACTIONS(2240),
    [anon_sym_private] = ACTIONS(2240),
    [anon_sym_protected] = ACTIONS(2240),
    [anon_sym_override] = ACTIONS(2240),
    [anon_sym_module] = ACTIONS(2240),
    [anon_sym_any] = ACTIONS(2240),
    [anon_sym_number] = ACTIONS(2240),
    [anon_sym_boolean] = ACTIONS(2240),
    [anon_sym_string] = ACTIONS(2240),
    [anon_sym_symbol] = ACTIONS(2240),
    [anon_sym_abstract] = ACTIONS(2240),
    [anon_sym_interface] = ACTIONS(2240),
    [anon_sym_enum] = ACTIONS(2240),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(2242),
    [sym_identifier] = ACTIONS(2244),
    [anon_sym_export] = ACTIONS(2244),
    [anon_sym_default] = ACTIONS(2244),
    [anon_sym_type] = ACTIONS(2244),
    [anon_sym_namespace] = ACTIONS(2244),
    [anon_sym_LBRACE] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2242),
    [anon_sym_typeof] = ACTIONS(2244),
    [anon_sym_import] = ACTIONS(2244),
    [anon_sym_var] = ACTIONS(2244),
    [anon_sym_let] = ACTIONS(2244),
    [anon_sym_const] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(2244),
    [anon_sym_switch] = ACTIONS(2244),
    [anon_sym_for] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2244),
    [anon_sym_while] = ACTIONS(2244),
    [anon_sym_do] = ACTIONS(2244),
    [anon_sym_try] = ACTIONS(2244),
    [anon_sym_with] = ACTIONS(2244),
    [anon_sym_break] = ACTIONS(2244),
    [anon_sym_continue] = ACTIONS(2244),
    [anon_sym_debugger] = ACTIONS(2244),
    [anon_sym_return] = ACTIONS(2244),
    [anon_sym_throw] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2244),
    [anon_sym_yield] = ACTIONS(2244),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_LT] = ACTIONS(2242),
    [anon_sym_SLASH] = ACTIONS(2244),
    [anon_sym_class] = ACTIONS(2244),
    [anon_sym_async] = ACTIONS(2244),
    [anon_sym_function] = ACTIONS(2244),
    [anon_sym_new] = ACTIONS(2244),
    [anon_sym_PLUS] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2242),
    [anon_sym_void] = ACTIONS(2244),
    [anon_sym_delete] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2242),
    [sym_number] = ACTIONS(2242),
    [sym_this] = ACTIONS(2244),
    [sym_super] = ACTIONS(2244),
    [sym_true] = ACTIONS(2244),
    [sym_false] = ACTIONS(2244),
    [sym_null] = ACTIONS(2244),
    [sym_undefined] = ACTIONS(2244),
    [anon_sym_AT] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2244),
    [anon_sym_readonly] = ACTIONS(2244),
    [anon_sym_get] = ACTIONS(2244),
    [anon_sym_set] = ACTIONS(2244),
    [anon_sym_declare] = ACTIONS(2244),
    [anon_sym_public] = ACTIONS(2244),
    [anon_sym_private] = ACTIONS(2244),
    [anon_sym_protected] = ACTIONS(2244),
    [anon_sym_override] = ACTIONS(2244),
    [anon_sym_module] = ACTIONS(2244),
    [anon_sym_any] = ACTIONS(2244),
    [anon_sym_number] = ACTIONS(2244),
    [anon_sym_boolean] = ACTIONS(2244),
    [anon_sym_string] = ACTIONS(2244),
    [anon_sym_symbol] = ACTIONS(2244),
    [anon_sym_abstract] = ACTIONS(2244),
    [anon_sym_interface] = ACTIONS(2244),
    [anon_sym_enum] = ACTIONS(2244),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_with] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_debugger] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_function] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_abstract] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(2166),
    [sym_identifier] = ACTIONS(2168),
    [anon_sym_export] = ACTIONS(2168),
    [anon_sym_default] = ACTIONS(2168),
    [anon_sym_type] = ACTIONS(2168),
    [anon_sym_namespace] = ACTIONS(2168),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_typeof] = ACTIONS(2168),
    [anon_sym_import] = ACTIONS(2168),
    [anon_sym_var] = ACTIONS(2168),
    [anon_sym_let] = ACTIONS(2168),
    [anon_sym_const] = ACTIONS(2168),
    [anon_sym_BANG] = ACTIONS(2166),
    [anon_sym_else] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(2168),
    [anon_sym_switch] = ACTIONS(2168),
    [anon_sym_for] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_await] = ACTIONS(2168),
    [anon_sym_while] = ACTIONS(2168),
    [anon_sym_do] = ACTIONS(2168),
    [anon_sym_try] = ACTIONS(2168),
    [anon_sym_with] = ACTIONS(2168),
    [anon_sym_break] = ACTIONS(2168),
    [anon_sym_continue] = ACTIONS(2168),
    [anon_sym_debugger] = ACTIONS(2168),
    [anon_sym_return] = ACTIONS(2168),
    [anon_sym_throw] = ACTIONS(2168),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_case] = ACTIONS(2168),
    [anon_sym_yield] = ACTIONS(2168),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_LT] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2168),
    [anon_sym_class] = ACTIONS(2168),
    [anon_sym_async] = ACTIONS(2168),
    [anon_sym_function] = ACTIONS(2168),
    [anon_sym_new] = ACTIONS(2168),
    [anon_sym_PLUS] = ACTIONS(2168),
    [anon_sym_DASH] = ACTIONS(2168),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_void] = ACTIONS(2168),
    [anon_sym_delete] = ACTIONS(2168),
    [anon_sym_PLUS_PLUS] = ACTIONS(2166),
    [anon_sym_DASH_DASH] = ACTIONS(2166),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(2168),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_static] = ACTIONS(2168),
    [anon_sym_readonly] = ACTIONS(2168),
    [anon_sym_get] = ACTIONS(2168),
    [anon_sym_set] = ACTIONS(2168),
    [anon_sym_declare] = ACTIONS(2168),
    [anon_sym_public] = ACTIONS(2168),
    [anon_sym_private] = ACTIONS(2168),
    [anon_sym_protected] = ACTIONS(2168),
    [anon_sym_override] = ACTIONS(2168),
    [anon_sym_module] = ACTIONS(2168),
    [anon_sym_any] = ACTIONS(2168),
    [anon_sym_number] = ACTIONS(2168),
    [anon_sym_boolean] = ACTIONS(2168),
    [anon_sym_string] = ACTIONS(2168),
    [anon_sym_symbol] = ACTIONS(2168),
    [anon_sym_abstract] = ACTIONS(2168),
    [anon_sym_interface] = ACTIONS(2168),
    [anon_sym_enum] = ACTIONS(2168),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_with] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_with] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym_identifier] = ACTIONS(2252),
    [anon_sym_export] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_type] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_import] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_with] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_debugger] = ACTIONS(2252),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_function] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_void] = ACTIONS(2252),
    [anon_sym_delete] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2250),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(2252),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_readonly] = ACTIONS(2252),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_declare] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_module] = ACTIONS(2252),
    [anon_sym_any] = ACTIONS(2252),
    [anon_sym_number] = ACTIONS(2252),
    [anon_sym_boolean] = ACTIONS(2252),
    [anon_sym_string] = ACTIONS(2252),
    [anon_sym_symbol] = ACTIONS(2252),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
  },
  [681] = {
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_type] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_import] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_with] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_debugger] = ACTIONS(2256),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_LT] = ACTIONS(2254),
    [anon_sym_SLASH] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_function] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_void] = ACTIONS(2256),
    [anon_sym_delete] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2254),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(2256),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_declare] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_module] = ACTIONS(2256),
    [anon_sym_any] = ACTIONS(2256),
    [anon_sym_number] = ACTIONS(2256),
    [anon_sym_boolean] = ACTIONS(2256),
    [anon_sym_string] = ACTIONS(2256),
    [anon_sym_symbol] = ACTIONS(2256),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym_identifier] = ACTIONS(2260),
    [anon_sym_export] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_type] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_import] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_with] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_debugger] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_function] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_void] = ACTIONS(2260),
    [anon_sym_delete] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2258),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(2260),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_declare] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_module] = ACTIONS(2260),
    [anon_sym_any] = ACTIONS(2260),
    [anon_sym_number] = ACTIONS(2260),
    [anon_sym_boolean] = ACTIONS(2260),
    [anon_sym_string] = ACTIONS(2260),
    [anon_sym_symbol] = ACTIONS(2260),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
  },
  [685] = {
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [sym_number] = ACTIONS(2262),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym_identifier] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_typeof] = ACTIONS(2268),
    [anon_sym_import] = ACTIONS(2268),
    [anon_sym_var] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_await] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_with] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_debugger] = ACTIONS(2268),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_function] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_void] = ACTIONS(2268),
    [anon_sym_delete] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2266),
    [sym_number] = ACTIONS(2266),
    [sym_this] = ACTIONS(2268),
    [sym_super] = ACTIONS(2268),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [sym_null] = ACTIONS(2268),
    [sym_undefined] = ACTIONS(2268),
    [anon_sym_AT] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_readonly] = ACTIONS(2268),
    [anon_sym_get] = ACTIONS(2268),
    [anon_sym_set] = ACTIONS(2268),
    [anon_sym_declare] = ACTIONS(2268),
    [anon_sym_public] = ACTIONS(2268),
    [anon_sym_private] = ACTIONS(2268),
    [anon_sym_protected] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_any] = ACTIONS(2268),
    [anon_sym_number] = ACTIONS(2268),
    [anon_sym_boolean] = ACTIONS(2268),
    [anon_sym_string] = ACTIONS(2268),
    [anon_sym_symbol] = ACTIONS(2268),
    [anon_sym_abstract] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2270),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_with] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(2246),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(2248),
    [anon_sym_default] = ACTIONS(2248),
    [anon_sym_type] = ACTIONS(2248),
    [anon_sym_namespace] = ACTIONS(2248),
    [anon_sym_LBRACE] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2246),
    [anon_sym_typeof] = ACTIONS(2248),
    [anon_sym_import] = ACTIONS(2248),
    [anon_sym_var] = ACTIONS(2248),
    [anon_sym_let] = ACTIONS(2248),
    [anon_sym_const] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2248),
    [anon_sym_for] = ACTIONS(2248),
    [anon_sym_LPAREN] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2248),
    [anon_sym_while] = ACTIONS(2248),
    [anon_sym_do] = ACTIONS(2248),
    [anon_sym_try] = ACTIONS(2248),
    [anon_sym_with] = ACTIONS(2248),
    [anon_sym_break] = ACTIONS(2248),
    [anon_sym_continue] = ACTIONS(2248),
    [anon_sym_debugger] = ACTIONS(2248),
    [anon_sym_return] = ACTIONS(2248),
    [anon_sym_throw] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2248),
    [anon_sym_yield] = ACTIONS(2248),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_class] = ACTIONS(2248),
    [anon_sym_async] = ACTIONS(2248),
    [anon_sym_function] = ACTIONS(2248),
    [anon_sym_new] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2246),
    [anon_sym_void] = ACTIONS(2248),
    [anon_sym_delete] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2246),
    [anon_sym_DQUOTE] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2246),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(2248),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2248),
    [anon_sym_readonly] = ACTIONS(2248),
    [anon_sym_get] = ACTIONS(2248),
    [anon_sym_set] = ACTIONS(2248),
    [anon_sym_declare] = ACTIONS(2248),
    [anon_sym_public] = ACTIONS(2248),
    [anon_sym_private] = ACTIONS(2248),
    [anon_sym_protected] = ACTIONS(2248),
    [anon_sym_override] = ACTIONS(2248),
    [anon_sym_module] = ACTIONS(2248),
    [anon_sym_any] = ACTIONS(2248),
    [anon_sym_number] = ACTIONS(2248),
    [anon_sym_boolean] = ACTIONS(2248),
    [anon_sym_string] = ACTIONS(2248),
    [anon_sym_symbol] = ACTIONS(2248),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_interface] = ACTIONS(2248),
    [anon_sym_enum] = ACTIONS(2248),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_typeof] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_await] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_with] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_debugger] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_function] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_void] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2274),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_readonly] = ACTIONS(2276),
    [anon_sym_get] = ACTIONS(2276),
    [anon_sym_set] = ACTIONS(2276),
    [anon_sym_declare] = ACTIONS(2276),
    [anon_sym_public] = ACTIONS(2276),
    [anon_sym_private] = ACTIONS(2276),
    [anon_sym_protected] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_any] = ACTIONS(2276),
    [anon_sym_number] = ACTIONS(2276),
    [anon_sym_boolean] = ACTIONS(2276),
    [anon_sym_string] = ACTIONS(2276),
    [anon_sym_symbol] = ACTIONS(2276),
    [anon_sym_abstract] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym_identifier] = ACTIONS(2276),
    [anon_sym_export] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_type] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_typeof] = ACTIONS(2276),
    [anon_sym_import] = ACTIONS(2276),
    [anon_sym_var] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_await] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_with] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_debugger] = ACTIONS(2276),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2274),
    [anon_sym_SLASH] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_function] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_void] = ACTIONS(2276),
    [anon_sym_delete] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2274),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(2276),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_readonly] = ACTIONS(2276),
    [anon_sym_get] = ACTIONS(2276),
    [anon_sym_set] = ACTIONS(2276),
    [anon_sym_declare] = ACTIONS(2276),
    [anon_sym_public] = ACTIONS(2276),
    [anon_sym_private] = ACTIONS(2276),
    [anon_sym_protected] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_module] = ACTIONS(2276),
    [anon_sym_any] = ACTIONS(2276),
    [anon_sym_number] = ACTIONS(2276),
    [anon_sym_boolean] = ACTIONS(2276),
    [anon_sym_string] = ACTIONS(2276),
    [anon_sym_symbol] = ACTIONS(2276),
    [anon_sym_abstract] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [704] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2106),
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2106),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_with] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2106),
    [anon_sym_DASH_DASH] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2108),
    [anon_sym_readonly] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_override] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_type] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_typeof] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_var] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_await] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_with] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_debugger] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_LT] = ACTIONS(2282),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_function] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_void] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2282),
    [sym_number] = ACTIONS(2282),
    [sym_this] = ACTIONS(2284),
    [sym_super] = ACTIONS(2284),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [sym_null] = ACTIONS(2284),
    [sym_undefined] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(2282),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_readonly] = ACTIONS(2284),
    [anon_sym_get] = ACTIONS(2284),
    [anon_sym_set] = ACTIONS(2284),
    [anon_sym_declare] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_any] = ACTIONS(2284),
    [anon_sym_number] = ACTIONS(2284),
    [anon_sym_boolean] = ACTIONS(2284),
    [anon_sym_string] = ACTIONS(2284),
    [anon_sym_symbol] = ACTIONS(2284),
    [anon_sym_abstract] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_type] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_with] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_debugger] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_function] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_void] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2286),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(2288),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(2286),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_declare] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(2288),
    [anon_sym_number] = ACTIONS(2288),
    [anon_sym_boolean] = ACTIONS(2288),
    [anon_sym_string] = ACTIONS(2288),
    [anon_sym_symbol] = ACTIONS(2288),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [sym_number] = ACTIONS(2290),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2290),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym_identifier] = ACTIONS(2296),
    [anon_sym_export] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_type] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_typeof] = ACTIONS(2296),
    [anon_sym_import] = ACTIONS(2296),
    [anon_sym_var] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_await] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_with] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_debugger] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_function] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_void] = ACTIONS(2296),
    [anon_sym_delete] = ACTIONS(2296),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2294),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(2296),
    [sym_super] = ACTIONS(2296),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [sym_null] = ACTIONS(2296),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(2294),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_readonly] = ACTIONS(2296),
    [anon_sym_get] = ACTIONS(2296),
    [anon_sym_set] = ACTIONS(2296),
    [anon_sym_declare] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_module] = ACTIONS(2296),
    [anon_sym_any] = ACTIONS(2296),
    [anon_sym_number] = ACTIONS(2296),
    [anon_sym_boolean] = ACTIONS(2296),
    [anon_sym_string] = ACTIONS(2296),
    [anon_sym_symbol] = ACTIONS(2296),
    [anon_sym_abstract] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym_identifier] = ACTIONS(2300),
    [anon_sym_export] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_type] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_import] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2300),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2298),
    [anon_sym_SLASH] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_function] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_void] = ACTIONS(2300),
    [anon_sym_delete] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2298),
    [sym_number] = ACTIONS(2298),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(2300),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_declare] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_module] = ACTIONS(2300),
    [anon_sym_any] = ACTIONS(2300),
    [anon_sym_number] = ACTIONS(2300),
    [anon_sym_boolean] = ACTIONS(2300),
    [anon_sym_string] = ACTIONS(2300),
    [anon_sym_symbol] = ACTIONS(2300),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym_identifier] = ACTIONS(2304),
    [anon_sym_export] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_type] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_import] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_with] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_debugger] = ACTIONS(2304),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_LT] = ACTIONS(2302),
    [anon_sym_SLASH] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_function] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_void] = ACTIONS(2304),
    [anon_sym_delete] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2302),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(2304),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_declare] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_module] = ACTIONS(2304),
    [anon_sym_any] = ACTIONS(2304),
    [anon_sym_number] = ACTIONS(2304),
    [anon_sym_boolean] = ACTIONS(2304),
    [anon_sym_string] = ACTIONS(2304),
    [anon_sym_symbol] = ACTIONS(2304),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2308),
    [anon_sym_export] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_type] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_import] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_with] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_debugger] = ACTIONS(2308),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_SLASH] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_function] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_void] = ACTIONS(2308),
    [anon_sym_delete] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2306),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(2308),
    [sym_super] = ACTIONS(2308),
    [sym_true] = ACTIONS(2308),
    [sym_false] = ACTIONS(2308),
    [sym_null] = ACTIONS(2308),
    [sym_undefined] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_declare] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_module] = ACTIONS(2308),
    [anon_sym_any] = ACTIONS(2308),
    [anon_sym_number] = ACTIONS(2308),
    [anon_sym_boolean] = ACTIONS(2308),
    [anon_sym_string] = ACTIONS(2308),
    [anon_sym_symbol] = ACTIONS(2308),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_await] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_debugger] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_LT] = ACTIONS(2310),
    [anon_sym_SLASH] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_void] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2310),
    [sym_number] = ACTIONS(2310),
    [sym_this] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [sym_true] = ACTIONS(2312),
    [sym_false] = ACTIONS(2312),
    [sym_null] = ACTIONS(2312),
    [sym_undefined] = ACTIONS(2312),
    [anon_sym_AT] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_export] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_typeof] = ACTIONS(2316),
    [anon_sym_import] = ACTIONS(2316),
    [anon_sym_var] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_await] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_with] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_debugger] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_LT] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_function] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_void] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2314),
    [sym_number] = ACTIONS(2314),
    [sym_this] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [sym_true] = ACTIONS(2316),
    [sym_false] = ACTIONS(2316),
    [sym_null] = ACTIONS(2316),
    [sym_undefined] = ACTIONS(2316),
    [anon_sym_AT] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_readonly] = ACTIONS(2316),
    [anon_sym_get] = ACTIONS(2316),
    [anon_sym_set] = ACTIONS(2316),
    [anon_sym_declare] = ACTIONS(2316),
    [anon_sym_public] = ACTIONS(2316),
    [anon_sym_private] = ACTIONS(2316),
    [anon_sym_protected] = ACTIONS(2316),
    [anon_sym_override] = ACTIONS(2316),
    [anon_sym_module] = ACTIONS(2316),
    [anon_sym_any] = ACTIONS(2316),
    [anon_sym_number] = ACTIONS(2316),
    [anon_sym_boolean] = ACTIONS(2316),
    [anon_sym_string] = ACTIONS(2316),
    [anon_sym_symbol] = ACTIONS(2316),
    [anon_sym_abstract] = ACTIONS(2316),
    [anon_sym_interface] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym_identifier] = ACTIONS(2320),
    [anon_sym_export] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_type] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_import] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_with] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_debugger] = ACTIONS(2320),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_LT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_function] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_void] = ACTIONS(2320),
    [anon_sym_delete] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [sym_this] = ACTIONS(2320),
    [sym_super] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_null] = ACTIONS(2320),
    [sym_undefined] = ACTIONS(2320),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_declare] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_module] = ACTIONS(2320),
    [anon_sym_any] = ACTIONS(2320),
    [anon_sym_number] = ACTIONS(2320),
    [anon_sym_boolean] = ACTIONS(2320),
    [anon_sym_string] = ACTIONS(2320),
    [anon_sym_symbol] = ACTIONS(2320),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym_identifier] = ACTIONS(2324),
    [anon_sym_export] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_type] = ACTIONS(2324),
    [anon_sym_namespace] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_typeof] = ACTIONS(2324),
    [anon_sym_import] = ACTIONS(2324),
    [anon_sym_var] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_await] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [anon_sym_with] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_debugger] = ACTIONS(2324),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_throw] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_LT] = ACTIONS(2322),
    [anon_sym_SLASH] = ACTIONS(2324),
    [anon_sym_class] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_function] = ACTIONS(2324),
    [anon_sym_new] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_void] = ACTIONS(2324),
    [anon_sym_delete] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2322),
    [sym_number] = ACTIONS(2322),
    [sym_this] = ACTIONS(2324),
    [sym_super] = ACTIONS(2324),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_null] = ACTIONS(2324),
    [sym_undefined] = ACTIONS(2324),
    [anon_sym_AT] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_readonly] = ACTIONS(2324),
    [anon_sym_get] = ACTIONS(2324),
    [anon_sym_set] = ACTIONS(2324),
    [anon_sym_declare] = ACTIONS(2324),
    [anon_sym_public] = ACTIONS(2324),
    [anon_sym_private] = ACTIONS(2324),
    [anon_sym_protected] = ACTIONS(2324),
    [anon_sym_override] = ACTIONS(2324),
    [anon_sym_module] = ACTIONS(2324),
    [anon_sym_any] = ACTIONS(2324),
    [anon_sym_number] = ACTIONS(2324),
    [anon_sym_boolean] = ACTIONS(2324),
    [anon_sym_string] = ACTIONS(2324),
    [anon_sym_symbol] = ACTIONS(2324),
    [anon_sym_abstract] = ACTIONS(2324),
    [anon_sym_interface] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2328),
    [anon_sym_export] = ACTIONS(2328),
    [anon_sym_default] = ACTIONS(2328),
    [anon_sym_type] = ACTIONS(2328),
    [anon_sym_namespace] = ACTIONS(2328),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(2328),
    [anon_sym_import] = ACTIONS(2328),
    [anon_sym_var] = ACTIONS(2328),
    [anon_sym_let] = ACTIONS(2328),
    [anon_sym_const] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(2328),
    [anon_sym_switch] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2326),
    [anon_sym_await] = ACTIONS(2328),
    [anon_sym_while] = ACTIONS(2328),
    [anon_sym_do] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2328),
    [anon_sym_with] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2328),
    [anon_sym_continue] = ACTIONS(2328),
    [anon_sym_debugger] = ACTIONS(2328),
    [anon_sym_return] = ACTIONS(2328),
    [anon_sym_throw] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2328),
    [anon_sym_class] = ACTIONS(2328),
    [anon_sym_async] = ACTIONS(2328),
    [anon_sym_function] = ACTIONS(2328),
    [anon_sym_new] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2326),
    [anon_sym_void] = ACTIONS(2328),
    [anon_sym_delete] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2326),
    [anon_sym_DQUOTE] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2326),
    [sym_number] = ACTIONS(2326),
    [sym_this] = ACTIONS(2328),
    [sym_super] = ACTIONS(2328),
    [sym_true] = ACTIONS(2328),
    [sym_false] = ACTIONS(2328),
    [sym_null] = ACTIONS(2328),
    [sym_undefined] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2328),
    [anon_sym_readonly] = ACTIONS(2328),
    [anon_sym_get] = ACTIONS(2328),
    [anon_sym_set] = ACTIONS(2328),
    [anon_sym_declare] = ACTIONS(2328),
    [anon_sym_public] = ACTIONS(2328),
    [anon_sym_private] = ACTIONS(2328),
    [anon_sym_protected] = ACTIONS(2328),
    [anon_sym_override] = ACTIONS(2328),
    [anon_sym_module] = ACTIONS(2328),
    [anon_sym_any] = ACTIONS(2328),
    [anon_sym_number] = ACTIONS(2328),
    [anon_sym_boolean] = ACTIONS(2328),
    [anon_sym_string] = ACTIONS(2328),
    [anon_sym_symbol] = ACTIONS(2328),
    [anon_sym_abstract] = ACTIONS(2328),
    [anon_sym_interface] = ACTIONS(2328),
    [anon_sym_enum] = ACTIONS(2328),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2332),
    [anon_sym_export] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_type] = ACTIONS(2332),
    [anon_sym_namespace] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_typeof] = ACTIONS(2332),
    [anon_sym_import] = ACTIONS(2332),
    [anon_sym_var] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_switch] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_await] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_with] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_debugger] = ACTIONS(2332),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_throw] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_SLASH] = ACTIONS(2332),
    [anon_sym_class] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_function] = ACTIONS(2332),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2330),
    [anon_sym_void] = ACTIONS(2332),
    [anon_sym_delete] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2330),
    [sym_number] = ACTIONS(2330),
    [sym_this] = ACTIONS(2332),
    [sym_super] = ACTIONS(2332),
    [sym_true] = ACTIONS(2332),
    [sym_false] = ACTIONS(2332),
    [sym_null] = ACTIONS(2332),
    [sym_undefined] = ACTIONS(2332),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_readonly] = ACTIONS(2332),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_declare] = ACTIONS(2332),
    [anon_sym_public] = ACTIONS(2332),
    [anon_sym_private] = ACTIONS(2332),
    [anon_sym_protected] = ACTIONS(2332),
    [anon_sym_override] = ACTIONS(2332),
    [anon_sym_module] = ACTIONS(2332),
    [anon_sym_any] = ACTIONS(2332),
    [anon_sym_number] = ACTIONS(2332),
    [anon_sym_boolean] = ACTIONS(2332),
    [anon_sym_string] = ACTIONS(2332),
    [anon_sym_symbol] = ACTIONS(2332),
    [anon_sym_abstract] = ACTIONS(2332),
    [anon_sym_interface] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym_identifier] = ACTIONS(2336),
    [anon_sym_export] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_type] = ACTIONS(2336),
    [anon_sym_namespace] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_typeof] = ACTIONS(2336),
    [anon_sym_import] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_switch] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_await] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_with] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_debugger] = ACTIONS(2336),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_throw] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_LT] = ACTIONS(2334),
    [anon_sym_SLASH] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_function] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_void] = ACTIONS(2336),
    [anon_sym_delete] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2334),
    [anon_sym_DQUOTE] = ACTIONS(2334),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2334),
    [sym_number] = ACTIONS(2334),
    [sym_this] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_undefined] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_declare] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_module] = ACTIONS(2336),
    [anon_sym_any] = ACTIONS(2336),
    [anon_sym_number] = ACTIONS(2336),
    [anon_sym_boolean] = ACTIONS(2336),
    [anon_sym_string] = ACTIONS(2336),
    [anon_sym_symbol] = ACTIONS(2336),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_interface] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_export] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_namespace] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_import] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_debugger] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_class] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2338),
    [anon_sym_void] = ACTIONS(2340),
    [anon_sym_delete] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [anon_sym_DQUOTE] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_readonly] = ACTIONS(2340),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_declare] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [anon_sym_module] = ACTIONS(2340),
    [anon_sym_any] = ACTIONS(2340),
    [anon_sym_number] = ACTIONS(2340),
    [anon_sym_boolean] = ACTIONS(2340),
    [anon_sym_string] = ACTIONS(2340),
    [anon_sym_symbol] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_interface] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_export] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_import] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_function] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2344),
    [anon_sym_delete] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_declare] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_module] = ACTIONS(2344),
    [anon_sym_any] = ACTIONS(2344),
    [anon_sym_number] = ACTIONS(2344),
    [anon_sym_boolean] = ACTIONS(2344),
    [anon_sym_string] = ACTIONS(2344),
    [anon_sym_symbol] = ACTIONS(2344),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_export] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_import] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_function] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2344),
    [anon_sym_delete] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_declare] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_module] = ACTIONS(2344),
    [anon_sym_any] = ACTIONS(2344),
    [anon_sym_number] = ACTIONS(2344),
    [anon_sym_boolean] = ACTIONS(2344),
    [anon_sym_string] = ACTIONS(2344),
    [anon_sym_symbol] = ACTIONS(2344),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_export] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_import] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_await] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_with] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_debugger] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_function] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2346),
    [anon_sym_void] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2346),
    [sym_number] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_readonly] = ACTIONS(2348),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_declare] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2348),
    [anon_sym_any] = ACTIONS(2348),
    [anon_sym_number] = ACTIONS(2348),
    [anon_sym_boolean] = ACTIONS(2348),
    [anon_sym_string] = ACTIONS(2348),
    [anon_sym_symbol] = ACTIONS(2348),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_interface] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_export] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_type] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_typeof] = ACTIONS(2352),
    [anon_sym_import] = ACTIONS(2352),
    [anon_sym_var] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_await] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_with] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_debugger] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_function] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_void] = ACTIONS(2352),
    [anon_sym_delete] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2350),
    [sym_number] = ACTIONS(2350),
    [sym_this] = ACTIONS(2352),
    [sym_super] = ACTIONS(2352),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_undefined] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_readonly] = ACTIONS(2352),
    [anon_sym_get] = ACTIONS(2352),
    [anon_sym_set] = ACTIONS(2352),
    [anon_sym_declare] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_override] = ACTIONS(2352),
    [anon_sym_module] = ACTIONS(2352),
    [anon_sym_any] = ACTIONS(2352),
    [anon_sym_number] = ACTIONS(2352),
    [anon_sym_boolean] = ACTIONS(2352),
    [anon_sym_string] = ACTIONS(2352),
    [anon_sym_symbol] = ACTIONS(2352),
    [anon_sym_abstract] = ACTIONS(2352),
    [anon_sym_interface] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym_identifier] = ACTIONS(2356),
    [anon_sym_export] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_type] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_import] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_with] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_debugger] = ACTIONS(2356),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_function] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_void] = ACTIONS(2356),
    [anon_sym_delete] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(2356),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_declare] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_module] = ACTIONS(2356),
    [anon_sym_any] = ACTIONS(2356),
    [anon_sym_number] = ACTIONS(2356),
    [anon_sym_boolean] = ACTIONS(2356),
    [anon_sym_string] = ACTIONS(2356),
    [anon_sym_symbol] = ACTIONS(2356),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_interface] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_export] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_type] = ACTIONS(2360),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_typeof] = ACTIONS(2360),
    [anon_sym_import] = ACTIONS(2360),
    [anon_sym_var] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_switch] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_await] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [anon_sym_do] = ACTIONS(2360),
    [anon_sym_try] = ACTIONS(2360),
    [anon_sym_with] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_debugger] = ACTIONS(2360),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_throw] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2360),
    [anon_sym_yield] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_LT] = ACTIONS(2358),
    [anon_sym_SLASH] = ACTIONS(2360),
    [anon_sym_class] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_function] = ACTIONS(2360),
    [anon_sym_new] = ACTIONS(2360),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_void] = ACTIONS(2360),
    [anon_sym_delete] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2358),
    [sym_number] = ACTIONS(2358),
    [sym_this] = ACTIONS(2360),
    [sym_super] = ACTIONS(2360),
    [sym_true] = ACTIONS(2360),
    [sym_false] = ACTIONS(2360),
    [sym_null] = ACTIONS(2360),
    [sym_undefined] = ACTIONS(2360),
    [anon_sym_AT] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_readonly] = ACTIONS(2360),
    [anon_sym_get] = ACTIONS(2360),
    [anon_sym_set] = ACTIONS(2360),
    [anon_sym_declare] = ACTIONS(2360),
    [anon_sym_public] = ACTIONS(2360),
    [anon_sym_private] = ACTIONS(2360),
    [anon_sym_protected] = ACTIONS(2360),
    [anon_sym_override] = ACTIONS(2360),
    [anon_sym_module] = ACTIONS(2360),
    [anon_sym_any] = ACTIONS(2360),
    [anon_sym_number] = ACTIONS(2360),
    [anon_sym_boolean] = ACTIONS(2360),
    [anon_sym_string] = ACTIONS(2360),
    [anon_sym_symbol] = ACTIONS(2360),
    [anon_sym_abstract] = ACTIONS(2360),
    [anon_sym_interface] = ACTIONS(2360),
    [anon_sym_enum] = ACTIONS(2360),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym_identifier] = ACTIONS(2364),
    [anon_sym_export] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_type] = ACTIONS(2364),
    [anon_sym_namespace] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_typeof] = ACTIONS(2364),
    [anon_sym_import] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_switch] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_await] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_do] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2364),
    [anon_sym_with] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_debugger] = ACTIONS(2364),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_throw] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2364),
    [anon_sym_yield] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_LT] = ACTIONS(2362),
    [anon_sym_SLASH] = ACTIONS(2364),
    [anon_sym_class] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_function] = ACTIONS(2364),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_void] = ACTIONS(2364),
    [anon_sym_delete] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2362),
    [sym_number] = ACTIONS(2362),
    [sym_this] = ACTIONS(2364),
    [sym_super] = ACTIONS(2364),
    [sym_true] = ACTIONS(2364),
    [sym_false] = ACTIONS(2364),
    [sym_null] = ACTIONS(2364),
    [sym_undefined] = ACTIONS(2364),
    [anon_sym_AT] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_readonly] = ACTIONS(2364),
    [anon_sym_get] = ACTIONS(2364),
    [anon_sym_set] = ACTIONS(2364),
    [anon_sym_declare] = ACTIONS(2364),
    [anon_sym_public] = ACTIONS(2364),
    [anon_sym_private] = ACTIONS(2364),
    [anon_sym_protected] = ACTIONS(2364),
    [anon_sym_override] = ACTIONS(2364),
    [anon_sym_module] = ACTIONS(2364),
    [anon_sym_any] = ACTIONS(2364),
    [anon_sym_number] = ACTIONS(2364),
    [anon_sym_boolean] = ACTIONS(2364),
    [anon_sym_string] = ACTIONS(2364),
    [anon_sym_symbol] = ACTIONS(2364),
    [anon_sym_abstract] = ACTIONS(2364),
    [anon_sym_interface] = ACTIONS(2364),
    [anon_sym_enum] = ACTIONS(2364),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2368),
    [anon_sym_export] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_type] = ACTIONS(2368),
    [anon_sym_namespace] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_typeof] = ACTIONS(2368),
    [anon_sym_import] = ACTIONS(2368),
    [anon_sym_var] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_do] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_with] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_debugger] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_throw] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_SLASH] = ACTIONS(2368),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_new] = ACTIONS(2368),
    [anon_sym_PLUS] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2366),
    [anon_sym_void] = ACTIONS(2368),
    [anon_sym_delete] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2366),
    [anon_sym_DQUOTE] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2366),
    [sym_number] = ACTIONS(2366),
    [sym_this] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_true] = ACTIONS(2368),
    [sym_false] = ACTIONS(2368),
    [sym_null] = ACTIONS(2368),
    [sym_undefined] = ACTIONS(2368),
    [anon_sym_AT] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_readonly] = ACTIONS(2368),
    [anon_sym_get] = ACTIONS(2368),
    [anon_sym_set] = ACTIONS(2368),
    [anon_sym_declare] = ACTIONS(2368),
    [anon_sym_public] = ACTIONS(2368),
    [anon_sym_private] = ACTIONS(2368),
    [anon_sym_protected] = ACTIONS(2368),
    [anon_sym_override] = ACTIONS(2368),
    [anon_sym_module] = ACTIONS(2368),
    [anon_sym_any] = ACTIONS(2368),
    [anon_sym_number] = ACTIONS(2368),
    [anon_sym_boolean] = ACTIONS(2368),
    [anon_sym_string] = ACTIONS(2368),
    [anon_sym_symbol] = ACTIONS(2368),
    [anon_sym_abstract] = ACTIONS(2368),
    [anon_sym_interface] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_export] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_namespace] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_typeof] = ACTIONS(2372),
    [anon_sym_import] = ACTIONS(2372),
    [anon_sym_var] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_switch] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [anon_sym_with] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_debugger] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_throw] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_SLASH] = ACTIONS(2372),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_function] = ACTIONS(2372),
    [anon_sym_new] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2370),
    [anon_sym_void] = ACTIONS(2372),
    [anon_sym_delete] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2370),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2370),
    [sym_number] = ACTIONS(2370),
    [sym_this] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_true] = ACTIONS(2372),
    [sym_false] = ACTIONS(2372),
    [sym_null] = ACTIONS(2372),
    [sym_undefined] = ACTIONS(2372),
    [anon_sym_AT] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_get] = ACTIONS(2372),
    [anon_sym_set] = ACTIONS(2372),
    [anon_sym_declare] = ACTIONS(2372),
    [anon_sym_public] = ACTIONS(2372),
    [anon_sym_private] = ACTIONS(2372),
    [anon_sym_protected] = ACTIONS(2372),
    [anon_sym_override] = ACTIONS(2372),
    [anon_sym_module] = ACTIONS(2372),
    [anon_sym_any] = ACTIONS(2372),
    [anon_sym_number] = ACTIONS(2372),
    [anon_sym_boolean] = ACTIONS(2372),
    [anon_sym_string] = ACTIONS(2372),
    [anon_sym_symbol] = ACTIONS(2372),
    [anon_sym_abstract] = ACTIONS(2372),
    [anon_sym_interface] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_export] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_typeof] = ACTIONS(2376),
    [anon_sym_import] = ACTIONS(2376),
    [anon_sym_var] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_await] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_with] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_debugger] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_LT] = ACTIONS(2374),
    [anon_sym_SLASH] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_function] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_void] = ACTIONS(2376),
    [anon_sym_delete] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2374),
    [anon_sym_DQUOTE] = ACTIONS(2374),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2374),
    [sym_number] = ACTIONS(2374),
    [sym_this] = ACTIONS(2376),
    [sym_super] = ACTIONS(2376),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [sym_null] = ACTIONS(2376),
    [sym_undefined] = ACTIONS(2376),
    [anon_sym_AT] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_readonly] = ACTIONS(2376),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_declare] = ACTIONS(2376),
    [anon_sym_public] = ACTIONS(2376),
    [anon_sym_private] = ACTIONS(2376),
    [anon_sym_protected] = ACTIONS(2376),
    [anon_sym_override] = ACTIONS(2376),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_any] = ACTIONS(2376),
    [anon_sym_number] = ACTIONS(2376),
    [anon_sym_boolean] = ACTIONS(2376),
    [anon_sym_string] = ACTIONS(2376),
    [anon_sym_symbol] = ACTIONS(2376),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_interface] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_export] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_namespace] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_typeof] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2380),
    [anon_sym_var] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [anon_sym_with] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_debugger] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_SLASH] = ACTIONS(2380),
    [anon_sym_class] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_function] = ACTIONS(2380),
    [anon_sym_new] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_void] = ACTIONS(2380),
    [anon_sym_delete] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2378),
    [sym_number] = ACTIONS(2378),
    [sym_this] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [sym_null] = ACTIONS(2380),
    [sym_undefined] = ACTIONS(2380),
    [anon_sym_AT] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_readonly] = ACTIONS(2380),
    [anon_sym_get] = ACTIONS(2380),
    [anon_sym_set] = ACTIONS(2380),
    [anon_sym_declare] = ACTIONS(2380),
    [anon_sym_public] = ACTIONS(2380),
    [anon_sym_private] = ACTIONS(2380),
    [anon_sym_protected] = ACTIONS(2380),
    [anon_sym_override] = ACTIONS(2380),
    [anon_sym_module] = ACTIONS(2380),
    [anon_sym_any] = ACTIONS(2380),
    [anon_sym_number] = ACTIONS(2380),
    [anon_sym_boolean] = ACTIONS(2380),
    [anon_sym_string] = ACTIONS(2380),
    [anon_sym_symbol] = ACTIONS(2380),
    [anon_sym_abstract] = ACTIONS(2380),
    [anon_sym_interface] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_export] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_typeof] = ACTIONS(2384),
    [anon_sym_import] = ACTIONS(2384),
    [anon_sym_var] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_with] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_debugger] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_function] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2382),
    [anon_sym_void] = ACTIONS(2384),
    [anon_sym_delete] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2382),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [sym_number] = ACTIONS(2382),
    [sym_this] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_true] = ACTIONS(2384),
    [sym_false] = ACTIONS(2384),
    [sym_null] = ACTIONS(2384),
    [sym_undefined] = ACTIONS(2384),
    [anon_sym_AT] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_readonly] = ACTIONS(2384),
    [anon_sym_get] = ACTIONS(2384),
    [anon_sym_set] = ACTIONS(2384),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_override] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2384),
    [anon_sym_any] = ACTIONS(2384),
    [anon_sym_number] = ACTIONS(2384),
    [anon_sym_boolean] = ACTIONS(2384),
    [anon_sym_string] = ACTIONS(2384),
    [anon_sym_symbol] = ACTIONS(2384),
    [anon_sym_abstract] = ACTIONS(2384),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_export] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_typeof] = ACTIONS(2388),
    [anon_sym_import] = ACTIONS(2388),
    [anon_sym_var] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_with] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_debugger] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_function] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_void] = ACTIONS(2388),
    [anon_sym_delete] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2386),
    [sym_number] = ACTIONS(2386),
    [sym_this] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_true] = ACTIONS(2388),
    [sym_false] = ACTIONS(2388),
    [sym_null] = ACTIONS(2388),
    [sym_undefined] = ACTIONS(2388),
    [anon_sym_AT] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_readonly] = ACTIONS(2388),
    [anon_sym_get] = ACTIONS(2388),
    [anon_sym_set] = ACTIONS(2388),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_override] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2388),
    [anon_sym_any] = ACTIONS(2388),
    [anon_sym_number] = ACTIONS(2388),
    [anon_sym_boolean] = ACTIONS(2388),
    [anon_sym_string] = ACTIONS(2388),
    [anon_sym_symbol] = ACTIONS(2388),
    [anon_sym_abstract] = ACTIONS(2388),
    [anon_sym_interface] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_export] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2392),
    [anon_sym_import] = ACTIONS(2392),
    [anon_sym_var] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_with] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_debugger] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_function] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_void] = ACTIONS(2392),
    [anon_sym_delete] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2390),
    [sym_number] = ACTIONS(2390),
    [sym_this] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_true] = ACTIONS(2392),
    [sym_false] = ACTIONS(2392),
    [sym_null] = ACTIONS(2392),
    [sym_undefined] = ACTIONS(2392),
    [anon_sym_AT] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_readonly] = ACTIONS(2392),
    [anon_sym_get] = ACTIONS(2392),
    [anon_sym_set] = ACTIONS(2392),
    [anon_sym_declare] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_override] = ACTIONS(2392),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_any] = ACTIONS(2392),
    [anon_sym_number] = ACTIONS(2392),
    [anon_sym_boolean] = ACTIONS(2392),
    [anon_sym_string] = ACTIONS(2392),
    [anon_sym_symbol] = ACTIONS(2392),
    [anon_sym_abstract] = ACTIONS(2392),
    [anon_sym_interface] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_export] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_import] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_debugger] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_function] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym_number] = ACTIONS(2394),
    [sym_this] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [sym_null] = ACTIONS(2396),
    [sym_undefined] = ACTIONS(2396),
    [anon_sym_AT] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_readonly] = ACTIONS(2396),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_declare] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_override] = ACTIONS(2396),
    [anon_sym_module] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(2396),
    [anon_sym_number] = ACTIONS(2396),
    [anon_sym_boolean] = ACTIONS(2396),
    [anon_sym_string] = ACTIONS(2396),
    [anon_sym_symbol] = ACTIONS(2396),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_readonly] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_override] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_with] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_debugger] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [sym_number] = ACTIONS(2402),
    [sym_this] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [sym_null] = ACTIONS(2404),
    [sym_undefined] = ACTIONS(2404),
    [anon_sym_AT] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_readonly] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_override] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_export] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_namespace] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2408),
    [anon_sym_import] = ACTIONS(2408),
    [anon_sym_var] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_switch] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_do] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [anon_sym_with] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_debugger] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_throw] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_class] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_function] = ACTIONS(2408),
    [anon_sym_new] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_void] = ACTIONS(2408),
    [anon_sym_delete] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym_number] = ACTIONS(2406),
    [sym_this] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_true] = ACTIONS(2408),
    [sym_false] = ACTIONS(2408),
    [sym_null] = ACTIONS(2408),
    [sym_undefined] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_readonly] = ACTIONS(2408),
    [anon_sym_get] = ACTIONS(2408),
    [anon_sym_set] = ACTIONS(2408),
    [anon_sym_declare] = ACTIONS(2408),
    [anon_sym_public] = ACTIONS(2408),
    [anon_sym_private] = ACTIONS(2408),
    [anon_sym_protected] = ACTIONS(2408),
    [anon_sym_override] = ACTIONS(2408),
    [anon_sym_module] = ACTIONS(2408),
    [anon_sym_any] = ACTIONS(2408),
    [anon_sym_number] = ACTIONS(2408),
    [anon_sym_boolean] = ACTIONS(2408),
    [anon_sym_string] = ACTIONS(2408),
    [anon_sym_symbol] = ACTIONS(2408),
    [anon_sym_abstract] = ACTIONS(2408),
    [anon_sym_interface] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2410),
    [sym_identifier] = ACTIONS(2412),
    [anon_sym_export] = ACTIONS(2412),
    [anon_sym_default] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2412),
    [anon_sym_namespace] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_typeof] = ACTIONS(2412),
    [anon_sym_import] = ACTIONS(2412),
    [anon_sym_var] = ACTIONS(2412),
    [anon_sym_let] = ACTIONS(2412),
    [anon_sym_const] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2412),
    [anon_sym_if] = ACTIONS(2412),
    [anon_sym_switch] = ACTIONS(2412),
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_await] = ACTIONS(2412),
    [anon_sym_while] = ACTIONS(2412),
    [anon_sym_do] = ACTIONS(2412),
    [anon_sym_try] = ACTIONS(2412),
    [anon_sym_with] = ACTIONS(2412),
    [anon_sym_break] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(2412),
    [anon_sym_debugger] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_throw] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2412),
    [anon_sym_yield] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2412),
    [anon_sym_class] = ACTIONS(2412),
    [anon_sym_async] = ACTIONS(2412),
    [anon_sym_function] = ACTIONS(2412),
    [anon_sym_new] = ACTIONS(2412),
    [anon_sym_PLUS] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2410),
    [anon_sym_void] = ACTIONS(2412),
    [anon_sym_delete] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2410),
    [anon_sym_SQUOTE] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2410),
    [sym_number] = ACTIONS(2410),
    [sym_this] = ACTIONS(2412),
    [sym_super] = ACTIONS(2412),
    [sym_true] = ACTIONS(2412),
    [sym_false] = ACTIONS(2412),
    [sym_null] = ACTIONS(2412),
    [sym_undefined] = ACTIONS(2412),
    [anon_sym_AT] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2412),
    [anon_sym_readonly] = ACTIONS(2412),
    [anon_sym_get] = ACTIONS(2412),
    [anon_sym_set] = ACTIONS(2412),
    [anon_sym_declare] = ACTIONS(2412),
    [anon_sym_public] = ACTIONS(2412),
    [anon_sym_private] = ACTIONS(2412),
    [anon_sym_protected] = ACTIONS(2412),
    [anon_sym_override] = ACTIONS(2412),
    [anon_sym_module] = ACTIONS(2412),
    [anon_sym_any] = ACTIONS(2412),
    [anon_sym_number] = ACTIONS(2412),
    [anon_sym_boolean] = ACTIONS(2412),
    [anon_sym_string] = ACTIONS(2412),
    [anon_sym_symbol] = ACTIONS(2412),
    [anon_sym_abstract] = ACTIONS(2412),
    [anon_sym_interface] = ACTIONS(2412),
    [anon_sym_enum] = ACTIONS(2412),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2414),
    [sym_identifier] = ACTIONS(2416),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_typeof] = ACTIONS(2416),
    [anon_sym_import] = ACTIONS(2416),
    [anon_sym_var] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_switch] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_await] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_do] = ACTIONS(2416),
    [anon_sym_try] = ACTIONS(2416),
    [anon_sym_with] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_debugger] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_throw] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2416),
    [anon_sym_yield] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2416),
    [anon_sym_class] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_function] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2414),
    [anon_sym_void] = ACTIONS(2416),
    [anon_sym_delete] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_DQUOTE] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2414),
    [sym_number] = ACTIONS(2414),
    [sym_this] = ACTIONS(2416),
    [sym_super] = ACTIONS(2416),
    [sym_true] = ACTIONS(2416),
    [sym_false] = ACTIONS(2416),
    [sym_null] = ACTIONS(2416),
    [sym_undefined] = ACTIONS(2416),
    [anon_sym_AT] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_readonly] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_override] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_abstract] = ACTIONS(2416),
    [anon_sym_interface] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2418),
    [sym_identifier] = ACTIONS(2420),
    [anon_sym_export] = ACTIONS(2420),
    [anon_sym_default] = ACTIONS(2420),
    [anon_sym_type] = ACTIONS(2420),
    [anon_sym_namespace] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_typeof] = ACTIONS(2420),
    [anon_sym_import] = ACTIONS(2420),
    [anon_sym_var] = ACTIONS(2420),
    [anon_sym_let] = ACTIONS(2420),
    [anon_sym_const] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2420),
    [anon_sym_if] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_await] = ACTIONS(2420),
    [anon_sym_while] = ACTIONS(2420),
    [anon_sym_do] = ACTIONS(2420),
    [anon_sym_try] = ACTIONS(2420),
    [anon_sym_with] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2420),
    [anon_sym_continue] = ACTIONS(2420),
    [anon_sym_debugger] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2420),
    [anon_sym_throw] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2420),
    [anon_sym_yield] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2420),
    [anon_sym_class] = ACTIONS(2420),
    [anon_sym_async] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2418),
    [anon_sym_void] = ACTIONS(2420),
    [anon_sym_delete] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2418),
    [anon_sym_DQUOTE] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2418),
    [sym_number] = ACTIONS(2418),
    [sym_this] = ACTIONS(2420),
    [sym_super] = ACTIONS(2420),
    [sym_true] = ACTIONS(2420),
    [sym_false] = ACTIONS(2420),
    [sym_null] = ACTIONS(2420),
    [sym_undefined] = ACTIONS(2420),
    [anon_sym_AT] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2420),
    [anon_sym_readonly] = ACTIONS(2420),
    [anon_sym_get] = ACTIONS(2420),
    [anon_sym_set] = ACTIONS(2420),
    [anon_sym_declare] = ACTIONS(2420),
    [anon_sym_public] = ACTIONS(2420),
    [anon_sym_private] = ACTIONS(2420),
    [anon_sym_protected] = ACTIONS(2420),
    [anon_sym_override] = ACTIONS(2420),
    [anon_sym_module] = ACTIONS(2420),
    [anon_sym_any] = ACTIONS(2420),
    [anon_sym_number] = ACTIONS(2420),
    [anon_sym_boolean] = ACTIONS(2420),
    [anon_sym_string] = ACTIONS(2420),
    [anon_sym_symbol] = ACTIONS(2420),
    [anon_sym_abstract] = ACTIONS(2420),
    [anon_sym_interface] = ACTIONS(2420),
    [anon_sym_enum] = ACTIONS(2420),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(2422),
    [sym_identifier] = ACTIONS(2424),
    [anon_sym_export] = ACTIONS(2424),
    [anon_sym_default] = ACTIONS(2424),
    [anon_sym_type] = ACTIONS(2424),
    [anon_sym_namespace] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_RBRACE] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2424),
    [anon_sym_var] = ACTIONS(2424),
    [anon_sym_let] = ACTIONS(2424),
    [anon_sym_const] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2424),
    [anon_sym_if] = ACTIONS(2424),
    [anon_sym_switch] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_await] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2424),
    [anon_sym_do] = ACTIONS(2424),
    [anon_sym_try] = ACTIONS(2424),
    [anon_sym_with] = ACTIONS(2424),
    [anon_sym_break] = ACTIONS(2424),
    [anon_sym_continue] = ACTIONS(2424),
    [anon_sym_debugger] = ACTIONS(2424),
    [anon_sym_return] = ACTIONS(2424),
    [anon_sym_throw] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2424),
    [anon_sym_yield] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2424),
    [anon_sym_class] = ACTIONS(2424),
    [anon_sym_async] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2422),
    [anon_sym_void] = ACTIONS(2424),
    [anon_sym_delete] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [sym_number] = ACTIONS(2422),
    [sym_this] = ACTIONS(2424),
    [sym_super] = ACTIONS(2424),
    [sym_true] = ACTIONS(2424),
    [sym_false] = ACTIONS(2424),
    [sym_null] = ACTIONS(2424),
    [sym_undefined] = ACTIONS(2424),
    [anon_sym_AT] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2424),
    [anon_sym_readonly] = ACTIONS(2424),
    [anon_sym_get] = ACTIONS(2424),
    [anon_sym_set] = ACTIONS(2424),
    [anon_sym_declare] = ACTIONS(2424),
    [anon_sym_public] = ACTIONS(2424),
    [anon_sym_private] = ACTIONS(2424),
    [anon_sym_protected] = ACTIONS(2424),
    [anon_sym_override] = ACTIONS(2424),
    [anon_sym_module] = ACTIONS(2424),
    [anon_sym_any] = ACTIONS(2424),
    [anon_sym_number] = ACTIONS(2424),
    [anon_sym_boolean] = ACTIONS(2424),
    [anon_sym_string] = ACTIONS(2424),
    [anon_sym_symbol] = ACTIONS(2424),
    [anon_sym_abstract] = ACTIONS(2424),
    [anon_sym_interface] = ACTIONS(2424),
    [anon_sym_enum] = ACTIONS(2424),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_type] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2428),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_with] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_debugger] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_yield] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_void] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2426),
    [sym_number] = ACTIONS(2426),
    [sym_this] = ACTIONS(2428),
    [sym_super] = ACTIONS(2428),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [sym_null] = ACTIONS(2428),
    [sym_undefined] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_readonly] = ACTIONS(2428),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2428),
    [anon_sym_public] = ACTIONS(2428),
    [anon_sym_private] = ACTIONS(2428),
    [anon_sym_protected] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_module] = ACTIONS(2428),
    [anon_sym_any] = ACTIONS(2428),
    [anon_sym_number] = ACTIONS(2428),
    [anon_sym_boolean] = ACTIONS(2428),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_symbol] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
  },
  [761] = {
    [ts_builtin_sym_end] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(2428),
    [anon_sym_export] = ACTIONS(2428),
    [anon_sym_default] = ACTIONS(2428),
    [anon_sym_type] = ACTIONS(2428),
    [anon_sym_namespace] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2428),
    [anon_sym_import] = ACTIONS(2428),
    [anon_sym_var] = ACTIONS(2428),
    [anon_sym_let] = ACTIONS(2428),
    [anon_sym_const] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2428),
    [anon_sym_if] = ACTIONS(2428),
    [anon_sym_switch] = ACTIONS(2428),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2428),
    [anon_sym_while] = ACTIONS(2428),
    [anon_sym_do] = ACTIONS(2428),
    [anon_sym_try] = ACTIONS(2428),
    [anon_sym_with] = ACTIONS(2428),
    [anon_sym_break] = ACTIONS(2428),
    [anon_sym_continue] = ACTIONS(2428),
    [anon_sym_debugger] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2428),
    [anon_sym_throw] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(2428),
    [anon_sym_yield] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2426),
    [anon_sym_void] = ACTIONS(2428),
    [anon_sym_delete] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2426),
    [anon_sym_DASH_DASH] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2426),
    [sym_number] = ACTIONS(2426),
    [sym_this] = ACTIONS(2428),
    [sym_super] = ACTIONS(2428),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [sym_null] = ACTIONS(2428),
    [sym_undefined] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2428),
    [anon_sym_readonly] = ACTIONS(2428),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2428),
    [anon_sym_public] = ACTIONS(2428),
    [anon_sym_private] = ACTIONS(2428),
    [anon_sym_protected] = ACTIONS(2428),
    [anon_sym_override] = ACTIONS(2428),
    [anon_sym_module] = ACTIONS(2428),
    [anon_sym_any] = ACTIONS(2428),
    [anon_sym_number] = ACTIONS(2428),
    [anon_sym_boolean] = ACTIONS(2428),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_symbol] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2428),
    [anon_sym_interface] = ACTIONS(2428),
    [anon_sym_enum] = ACTIONS(2428),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_export] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_typeof] = ACTIONS(2432),
    [anon_sym_import] = ACTIONS(2432),
    [anon_sym_var] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_switch] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_do] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_debugger] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_throw] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2432),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_function] = ACTIONS(2432),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_void] = ACTIONS(2432),
    [anon_sym_delete] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym_number] = ACTIONS(2430),
    [sym_this] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_true] = ACTIONS(2432),
    [sym_false] = ACTIONS(2432),
    [sym_null] = ACTIONS(2432),
    [sym_undefined] = ACTIONS(2432),
    [anon_sym_AT] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_readonly] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2432),
    [anon_sym_set] = ACTIONS(2432),
    [anon_sym_declare] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_override] = ACTIONS(2432),
    [anon_sym_module] = ACTIONS(2432),
    [anon_sym_any] = ACTIONS(2432),
    [anon_sym_number] = ACTIONS(2432),
    [anon_sym_boolean] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_symbol] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
  },
  [763] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [764] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [766] = {
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_identifier] = ACTIONS(2436),
    [anon_sym_export] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_typeof] = ACTIONS(2436),
    [anon_sym_import] = ACTIONS(2436),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_else] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_await] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_with] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_debugger] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_function] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_TILDE] = ACTIONS(2434),
    [anon_sym_void] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [sym_number] = ACTIONS(2434),
    [sym_this] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [sym_null] = ACTIONS(2436),
    [sym_undefined] = ACTIONS(2436),
    [anon_sym_AT] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_readonly] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2436),
    [anon_sym_set] = ACTIONS(2436),
    [anon_sym_declare] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_override] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(2436),
    [anon_sym_any] = ACTIONS(2436),
    [anon_sym_number] = ACTIONS(2436),
    [anon_sym_boolean] = ACTIONS(2436),
    [anon_sym_string] = ACTIONS(2436),
    [anon_sym_symbol] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2436),
    [anon_sym_interface] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
  },
  [767] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [768] = {
    [ts_builtin_sym_end] = ACTIONS(2438),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_export] = ACTIONS(2440),
    [anon_sym_default] = ACTIONS(2440),
    [anon_sym_type] = ACTIONS(2440),
    [anon_sym_namespace] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2438),
    [anon_sym_typeof] = ACTIONS(2440),
    [anon_sym_import] = ACTIONS(2440),
    [anon_sym_var] = ACTIONS(2440),
    [anon_sym_let] = ACTIONS(2440),
    [anon_sym_const] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_else] = ACTIONS(2440),
    [anon_sym_if] = ACTIONS(2440),
    [anon_sym_switch] = ACTIONS(2440),
    [anon_sym_for] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2438),
    [anon_sym_await] = ACTIONS(2440),
    [anon_sym_while] = ACTIONS(2440),
    [anon_sym_do] = ACTIONS(2440),
    [anon_sym_try] = ACTIONS(2440),
    [anon_sym_with] = ACTIONS(2440),
    [anon_sym_break] = ACTIONS(2440),
    [anon_sym_continue] = ACTIONS(2440),
    [anon_sym_debugger] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2440),
    [anon_sym_throw] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2438),
    [anon_sym_case] = ACTIONS(2440),
    [anon_sym_yield] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2438),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_class] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2440),
    [anon_sym_function] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_TILDE] = ACTIONS(2438),
    [anon_sym_void] = ACTIONS(2440),
    [anon_sym_delete] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2438),
    [anon_sym_DASH_DASH] = ACTIONS(2438),
    [anon_sym_DQUOTE] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [sym_number] = ACTIONS(2438),
    [sym_this] = ACTIONS(2440),
    [sym_super] = ACTIONS(2440),
    [sym_true] = ACTIONS(2440),
    [sym_false] = ACTIONS(2440),
    [sym_null] = ACTIONS(2440),
    [sym_undefined] = ACTIONS(2440),
    [anon_sym_AT] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2440),
    [anon_sym_readonly] = ACTIONS(2440),
    [anon_sym_get] = ACTIONS(2440),
    [anon_sym_set] = ACTIONS(2440),
    [anon_sym_declare] = ACTIONS(2440),
    [anon_sym_public] = ACTIONS(2440),
    [anon_sym_private] = ACTIONS(2440),
    [anon_sym_protected] = ACTIONS(2440),
    [anon_sym_override] = ACTIONS(2440),
    [anon_sym_module] = ACTIONS(2440),
    [anon_sym_any] = ACTIONS(2440),
    [anon_sym_number] = ACTIONS(2440),
    [anon_sym_boolean] = ACTIONS(2440),
    [anon_sym_string] = ACTIONS(2440),
    [anon_sym_symbol] = ACTIONS(2440),
    [anon_sym_abstract] = ACTIONS(2440),
    [anon_sym_interface] = ACTIONS(2440),
    [anon_sym_enum] = ACTIONS(2440),
  },
  [769] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [770] = {
    [ts_builtin_sym_end] = ACTIONS(2442),
    [sym_identifier] = ACTIONS(2444),
    [anon_sym_export] = ACTIONS(2444),
    [anon_sym_default] = ACTIONS(2444),
    [anon_sym_type] = ACTIONS(2444),
    [anon_sym_namespace] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_typeof] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2444),
    [anon_sym_var] = ACTIONS(2444),
    [anon_sym_let] = ACTIONS(2444),
    [anon_sym_const] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_if] = ACTIONS(2444),
    [anon_sym_switch] = ACTIONS(2444),
    [anon_sym_for] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_await] = ACTIONS(2444),
    [anon_sym_while] = ACTIONS(2444),
    [anon_sym_do] = ACTIONS(2444),
    [anon_sym_try] = ACTIONS(2444),
    [anon_sym_with] = ACTIONS(2444),
    [anon_sym_break] = ACTIONS(2444),
    [anon_sym_continue] = ACTIONS(2444),
    [anon_sym_debugger] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2444),
    [anon_sym_throw] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_case] = ACTIONS(2444),
    [anon_sym_yield] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_class] = ACTIONS(2444),
    [anon_sym_async] = ACTIONS(2444),
    [anon_sym_function] = ACTIONS(2444),
    [anon_sym_new] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2442),
    [anon_sym_void] = ACTIONS(2444),
    [anon_sym_delete] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_number] = ACTIONS(2442),
    [sym_this] = ACTIONS(2444),
    [sym_super] = ACTIONS(2444),
    [sym_true] = ACTIONS(2444),
    [sym_false] = ACTIONS(2444),
    [sym_null] = ACTIONS(2444),
    [sym_undefined] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2444),
    [anon_sym_readonly] = ACTIONS(2444),
    [anon_sym_get] = ACTIONS(2444),
    [anon_sym_set] = ACTIONS(2444),
    [anon_sym_declare] = ACTIONS(2444),
    [anon_sym_public] = ACTIONS(2444),
    [anon_sym_private] = ACTIONS(2444),
    [anon_sym_protected] = ACTIONS(2444),
    [anon_sym_override] = ACTIONS(2444),
    [anon_sym_module] = ACTIONS(2444),
    [anon_sym_any] = ACTIONS(2444),
    [anon_sym_number] = ACTIONS(2444),
    [anon_sym_boolean] = ACTIONS(2444),
    [anon_sym_string] = ACTIONS(2444),
    [anon_sym_symbol] = ACTIONS(2444),
    [anon_sym_abstract] = ACTIONS(2444),
    [anon_sym_interface] = ACTIONS(2444),
    [anon_sym_enum] = ACTIONS(2444),
  },
  [771] = {
    [ts_builtin_sym_end] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2448),
    [anon_sym_export] = ACTIONS(2448),
    [anon_sym_default] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2448),
    [anon_sym_namespace] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(2448),
    [anon_sym_import] = ACTIONS(2448),
    [anon_sym_var] = ACTIONS(2448),
    [anon_sym_let] = ACTIONS(2448),
    [anon_sym_const] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2448),
    [anon_sym_switch] = ACTIONS(2448),
    [anon_sym_for] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2448),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_do] = ACTIONS(2448),
    [anon_sym_try] = ACTIONS(2448),
    [anon_sym_with] = ACTIONS(2448),
    [anon_sym_break] = ACTIONS(2448),
    [anon_sym_continue] = ACTIONS(2448),
    [anon_sym_debugger] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2448),
    [anon_sym_throw] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_case] = ACTIONS(2448),
    [anon_sym_yield] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_class] = ACTIONS(2448),
    [anon_sym_async] = ACTIONS(2448),
    [anon_sym_function] = ACTIONS(2448),
    [anon_sym_new] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2446),
    [anon_sym_void] = ACTIONS(2448),
    [anon_sym_delete] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [anon_sym_DQUOTE] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [sym_number] = ACTIONS(2446),
    [sym_this] = ACTIONS(2448),
    [sym_super] = ACTIONS(2448),
    [sym_true] = ACTIONS(2448),
    [sym_false] = ACTIONS(2448),
    [sym_null] = ACTIONS(2448),
    [sym_undefined] = ACTIONS(2448),
    [anon_sym_AT] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2448),
    [anon_sym_readonly] = ACTIONS(2448),
    [anon_sym_get] = ACTIONS(2448),
    [anon_sym_set] = ACTIONS(2448),
    [anon_sym_declare] = ACTIONS(2448),
    [anon_sym_public] = ACTIONS(2448),
    [anon_sym_private] = ACTIONS(2448),
    [anon_sym_protected] = ACTIONS(2448),
    [anon_sym_override] = ACTIONS(2448),
    [anon_sym_module] = ACTIONS(2448),
    [anon_sym_any] = ACTIONS(2448),
    [anon_sym_number] = ACTIONS(2448),
    [anon_sym_boolean] = ACTIONS(2448),
    [anon_sym_string] = ACTIONS(2448),
    [anon_sym_symbol] = ACTIONS(2448),
    [anon_sym_abstract] = ACTIONS(2448),
    [anon_sym_interface] = ACTIONS(2448),
    [anon_sym_enum] = ACTIONS(2448),
  },
  [772] = {
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_type] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_import] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_with] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_debugger] = ACTIONS(2280),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_LT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_function] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_void] = ACTIONS(2280),
    [anon_sym_delete] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2278),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(2280),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_declare] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_module] = ACTIONS(2280),
    [anon_sym_any] = ACTIONS(2280),
    [anon_sym_number] = ACTIONS(2280),
    [anon_sym_boolean] = ACTIONS(2280),
    [anon_sym_string] = ACTIONS(2280),
    [anon_sym_symbol] = ACTIONS(2280),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
  },
  [773] = {
    [ts_builtin_sym_end] = ACTIONS(2450),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_default] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(2452),
    [anon_sym_import] = ACTIONS(2452),
    [anon_sym_var] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_const] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_else] = ACTIONS(2452),
    [anon_sym_if] = ACTIONS(2452),
    [anon_sym_switch] = ACTIONS(2452),
    [anon_sym_for] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_await] = ACTIONS(2452),
    [anon_sym_while] = ACTIONS(2452),
    [anon_sym_do] = ACTIONS(2452),
    [anon_sym_try] = ACTIONS(2452),
    [anon_sym_with] = ACTIONS(2452),
    [anon_sym_break] = ACTIONS(2452),
    [anon_sym_continue] = ACTIONS(2452),
    [anon_sym_debugger] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2452),
    [anon_sym_throw] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_case] = ACTIONS(2452),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_class] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_function] = ACTIONS(2452),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_void] = ACTIONS(2452),
    [anon_sym_delete] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [anon_sym_DQUOTE] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [sym_number] = ACTIONS(2450),
    [sym_this] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_true] = ACTIONS(2452),
    [sym_false] = ACTIONS(2452),
    [sym_null] = ACTIONS(2452),
    [sym_undefined] = ACTIONS(2452),
    [anon_sym_AT] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_readonly] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_override] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_abstract] = ACTIONS(2452),
    [anon_sym_interface] = ACTIONS(2452),
    [anon_sym_enum] = ACTIONS(2452),
  },
  [774] = {
    [ts_builtin_sym_end] = ACTIONS(2454),
    [sym_identifier] = ACTIONS(2456),
    [anon_sym_export] = ACTIONS(2456),
    [anon_sym_default] = ACTIONS(2456),
    [anon_sym_type] = ACTIONS(2456),
    [anon_sym_namespace] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(2456),
    [anon_sym_import] = ACTIONS(2456),
    [anon_sym_var] = ACTIONS(2456),
    [anon_sym_let] = ACTIONS(2456),
    [anon_sym_const] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_switch] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_await] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_do] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [anon_sym_with] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_debugger] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_throw] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_case] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_class] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_void] = ACTIONS(2456),
    [anon_sym_delete] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym_number] = ACTIONS(2454),
    [sym_this] = ACTIONS(2456),
    [sym_super] = ACTIONS(2456),
    [sym_true] = ACTIONS(2456),
    [sym_false] = ACTIONS(2456),
    [sym_null] = ACTIONS(2456),
    [sym_undefined] = ACTIONS(2456),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2456),
    [anon_sym_readonly] = ACTIONS(2456),
    [anon_sym_get] = ACTIONS(2456),
    [anon_sym_set] = ACTIONS(2456),
    [anon_sym_declare] = ACTIONS(2456),
    [anon_sym_public] = ACTIONS(2456),
    [anon_sym_private] = ACTIONS(2456),
    [anon_sym_protected] = ACTIONS(2456),
    [anon_sym_override] = ACTIONS(2456),
    [anon_sym_module] = ACTIONS(2456),
    [anon_sym_any] = ACTIONS(2456),
    [anon_sym_number] = ACTIONS(2456),
    [anon_sym_boolean] = ACTIONS(2456),
    [anon_sym_string] = ACTIONS(2456),
    [anon_sym_symbol] = ACTIONS(2456),
    [anon_sym_abstract] = ACTIONS(2456),
    [anon_sym_interface] = ACTIONS(2456),
    [anon_sym_enum] = ACTIONS(2456),
  },
  [775] = {
    [ts_builtin_sym_end] = ACTIONS(2458),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_export] = ACTIONS(2460),
    [anon_sym_default] = ACTIONS(2460),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(2460),
    [anon_sym_import] = ACTIONS(2460),
    [anon_sym_var] = ACTIONS(2460),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_else] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2460),
    [anon_sym_switch] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_await] = ACTIONS(2460),
    [anon_sym_while] = ACTIONS(2460),
    [anon_sym_do] = ACTIONS(2460),
    [anon_sym_try] = ACTIONS(2460),
    [anon_sym_with] = ACTIONS(2460),
    [anon_sym_break] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(2460),
    [anon_sym_debugger] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2460),
    [anon_sym_throw] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_case] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_class] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2460),
    [anon_sym_function] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_TILDE] = ACTIONS(2458),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_delete] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [sym_number] = ACTIONS(2458),
    [sym_this] = ACTIONS(2460),
    [sym_super] = ACTIONS(2460),
    [sym_true] = ACTIONS(2460),
    [sym_false] = ACTIONS(2460),
    [sym_null] = ACTIONS(2460),
    [sym_undefined] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2460),
    [anon_sym_readonly] = ACTIONS(2460),
    [anon_sym_get] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2460),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_public] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2460),
    [anon_sym_protected] = ACTIONS(2460),
    [anon_sym_override] = ACTIONS(2460),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_abstract] = ACTIONS(2460),
    [anon_sym_interface] = ACTIONS(2460),
    [anon_sym_enum] = ACTIONS(2460),
  },
  [776] = {
    [ts_builtin_sym_end] = ACTIONS(2462),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_default] = ACTIONS(2464),
    [anon_sym_type] = ACTIONS(2464),
    [anon_sym_namespace] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_typeof] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_var] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_switch] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_await] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [anon_sym_do] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_with] = ACTIONS(2464),
    [anon_sym_break] = ACTIONS(2464),
    [anon_sym_continue] = ACTIONS(2464),
    [anon_sym_debugger] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_throw] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_class] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2462),
    [anon_sym_void] = ACTIONS(2464),
    [anon_sym_delete] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym_number] = ACTIONS(2462),
    [sym_this] = ACTIONS(2464),
    [sym_super] = ACTIONS(2464),
    [sym_true] = ACTIONS(2464),
    [sym_false] = ACTIONS(2464),
    [sym_null] = ACTIONS(2464),
    [sym_undefined] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2464),
    [anon_sym_readonly] = ACTIONS(2464),
    [anon_sym_get] = ACTIONS(2464),
    [anon_sym_set] = ACTIONS(2464),
    [anon_sym_declare] = ACTIONS(2464),
    [anon_sym_public] = ACTIONS(2464),
    [anon_sym_private] = ACTIONS(2464),
    [anon_sym_protected] = ACTIONS(2464),
    [anon_sym_override] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_any] = ACTIONS(2464),
    [anon_sym_number] = ACTIONS(2464),
    [anon_sym_boolean] = ACTIONS(2464),
    [anon_sym_string] = ACTIONS(2464),
    [anon_sym_symbol] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_interface] = ACTIONS(2464),
    [anon_sym_enum] = ACTIONS(2464),
  },
  [777] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3522),
    [sym_optional_tuple_parameter] = STATE(3522),
    [sym_optional_type] = STATE(3522),
    [sym_rest_type] = STATE(3522),
    [sym__tuple_type_member] = STATE(3522),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [778] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3573),
    [sym_optional_tuple_parameter] = STATE(3573),
    [sym_optional_type] = STATE(3573),
    [sym_rest_type] = STATE(3573),
    [sym__tuple_type_member] = STATE(3573),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [779] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3530),
    [sym_optional_tuple_parameter] = STATE(3530),
    [sym_optional_type] = STATE(3530),
    [sym_rest_type] = STATE(3530),
    [sym__tuple_type_member] = STATE(3530),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [780] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3694),
    [sym_optional_tuple_parameter] = STATE(3694),
    [sym_optional_type] = STATE(3694),
    [sym_rest_type] = STATE(3694),
    [sym__tuple_type_member] = STATE(3694),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [781] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3735),
    [sym_optional_tuple_parameter] = STATE(3735),
    [sym_optional_type] = STATE(3735),
    [sym_rest_type] = STATE(3735),
    [sym__tuple_type_member] = STATE(3735),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [782] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [783] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [784] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [785] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [786] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [787] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [788] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [789] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [790] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2510),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [791] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [793] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_type] = ACTIONS(2518),
    [anon_sym_namespace] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_typeof] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_var] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_await] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_break] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(2518),
    [anon_sym_debugger] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_throw] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_class] = ACTIONS(2518),
    [anon_sym_async] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2518),
    [anon_sym_delete] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [sym_number] = ACTIONS(2520),
    [sym_this] = ACTIONS(2518),
    [sym_super] = ACTIONS(2518),
    [sym_true] = ACTIONS(2518),
    [sym_false] = ACTIONS(2518),
    [sym_null] = ACTIONS(2518),
    [sym_undefined] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_readonly] = ACTIONS(2518),
    [anon_sym_get] = ACTIONS(2518),
    [anon_sym_set] = ACTIONS(2518),
    [anon_sym_declare] = ACTIONS(2518),
    [anon_sym_public] = ACTIONS(2518),
    [anon_sym_private] = ACTIONS(2518),
    [anon_sym_protected] = ACTIONS(2518),
    [anon_sym_override] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_any] = ACTIONS(2518),
    [anon_sym_number] = ACTIONS(2518),
    [anon_sym_boolean] = ACTIONS(2518),
    [anon_sym_string] = ACTIONS(2518),
    [anon_sym_symbol] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_interface] = ACTIONS(2518),
    [anon_sym_enum] = ACTIONS(2518),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_type] = ACTIONS(2522),
    [anon_sym_namespace] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2524),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_debugger] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_delete] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2524),
    [sym_number] = ACTIONS(2524),
    [sym_this] = ACTIONS(2522),
    [sym_super] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_null] = ACTIONS(2522),
    [sym_undefined] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_readonly] = ACTIONS(2522),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_declare] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_override] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_interface] = ACTIONS(2522),
    [anon_sym_enum] = ACTIONS(2522),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_LBRACE] = ACTIONS(2528),
    [anon_sym_typeof] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_var] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_switch] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_await] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_with] = ACTIONS(2526),
    [anon_sym_break] = ACTIONS(2526),
    [anon_sym_continue] = ACTIONS(2526),
    [anon_sym_debugger] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_throw] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_yield] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_SLASH] = ACTIONS(2526),
    [anon_sym_class] = ACTIONS(2526),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2528),
    [anon_sym_void] = ACTIONS(2526),
    [anon_sym_delete] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2528),
    [anon_sym_DQUOTE] = ACTIONS(2528),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2528),
    [sym_number] = ACTIONS(2528),
    [sym_this] = ACTIONS(2526),
    [sym_super] = ACTIONS(2526),
    [sym_true] = ACTIONS(2526),
    [sym_false] = ACTIONS(2526),
    [sym_null] = ACTIONS(2526),
    [sym_undefined] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_interface] = ACTIONS(2526),
    [anon_sym_enum] = ACTIONS(2526),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_type] = ACTIONS(2530),
    [anon_sym_namespace] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_typeof] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_var] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_switch] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_await] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_with] = ACTIONS(2530),
    [anon_sym_break] = ACTIONS(2530),
    [anon_sym_continue] = ACTIONS(2530),
    [anon_sym_debugger] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_throw] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_yield] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(2532),
    [anon_sym_SLASH] = ACTIONS(2530),
    [anon_sym_class] = ACTIONS(2530),
    [anon_sym_async] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_new] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_void] = ACTIONS(2530),
    [anon_sym_delete] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [sym_number] = ACTIONS(2532),
    [sym_this] = ACTIONS(2530),
    [sym_super] = ACTIONS(2530),
    [sym_true] = ACTIONS(2530),
    [sym_false] = ACTIONS(2530),
    [sym_null] = ACTIONS(2530),
    [sym_undefined] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2530),
    [anon_sym_readonly] = ACTIONS(2530),
    [anon_sym_get] = ACTIONS(2530),
    [anon_sym_set] = ACTIONS(2530),
    [anon_sym_declare] = ACTIONS(2530),
    [anon_sym_public] = ACTIONS(2530),
    [anon_sym_private] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(2530),
    [anon_sym_override] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_any] = ACTIONS(2530),
    [anon_sym_number] = ACTIONS(2530),
    [anon_sym_boolean] = ACTIONS(2530),
    [anon_sym_string] = ACTIONS(2530),
    [anon_sym_symbol] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_interface] = ACTIONS(2530),
    [anon_sym_enum] = ACTIONS(2530),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [798] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [799] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [800] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [801] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [802] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [803] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [804] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_rest_pattern] = STATE(4038),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2952),
    [sym_tuple_parameter] = STATE(3819),
    [sym_optional_tuple_parameter] = STATE(3819),
    [sym_optional_type] = STATE(3819),
    [sym_rest_type] = STATE(3819),
    [sym__tuple_type_member] = STATE(3819),
    [sym_constructor_type] = STATE(2952),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2952),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2952),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2952),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [805] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_type] = ACTIONS(2534),
    [anon_sym_namespace] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2536),
    [anon_sym_typeof] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_var] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_switch] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_await] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_with] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_debugger] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_throw] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_class] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_new] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2536),
    [anon_sym_void] = ACTIONS(2534),
    [anon_sym_delete] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2536),
    [sym_number] = ACTIONS(2536),
    [sym_this] = ACTIONS(2534),
    [sym_super] = ACTIONS(2534),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2534),
    [anon_sym_get] = ACTIONS(2534),
    [anon_sym_set] = ACTIONS(2534),
    [anon_sym_declare] = ACTIONS(2534),
    [anon_sym_public] = ACTIONS(2534),
    [anon_sym_private] = ACTIONS(2534),
    [anon_sym_protected] = ACTIONS(2534),
    [anon_sym_override] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_any] = ACTIONS(2534),
    [anon_sym_number] = ACTIONS(2534),
    [anon_sym_boolean] = ACTIONS(2534),
    [anon_sym_string] = ACTIONS(2534),
    [anon_sym_symbol] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_interface] = ACTIONS(2534),
    [anon_sym_enum] = ACTIONS(2534),
  },
  [806] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_type] = ACTIONS(2538),
    [anon_sym_EQ] = ACTIONS(2538),
    [anon_sym_namespace] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_typeof] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2540),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_RPAREN] = ACTIONS(2540),
    [anon_sym_await] = ACTIONS(2538),
    [anon_sym_COLON] = ACTIONS(2540),
    [anon_sym_yield] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_RBRACK] = ACTIONS(2540),
    [anon_sym_LT] = ACTIONS(2540),
    [anon_sym_GT] = ACTIONS(2540),
    [anon_sym_SLASH] = ACTIONS(2538),
    [anon_sym_DOT] = ACTIONS(2538),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_EQ_GT] = ACTIONS(2540),
    [anon_sym_QMARK_DOT] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2540),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_PIPE] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(2540),
    [anon_sym_void] = ACTIONS(2538),
    [anon_sym_delete] = ACTIONS(2538),
    [anon_sym_PLUS_PLUS] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2540),
    [anon_sym_DQUOTE] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2540),
    [sym_number] = ACTIONS(2540),
    [sym_this] = ACTIONS(2538),
    [sym_super] = ACTIONS(2538),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [sym_null] = ACTIONS(2538),
    [sym_undefined] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2538),
    [anon_sym_readonly] = ACTIONS(2538),
    [anon_sym_get] = ACTIONS(2538),
    [anon_sym_set] = ACTIONS(2538),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_declare] = ACTIONS(2538),
    [anon_sym_public] = ACTIONS(2538),
    [anon_sym_private] = ACTIONS(2538),
    [anon_sym_protected] = ACTIONS(2538),
    [anon_sym_override] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_any] = ACTIONS(2538),
    [anon_sym_number] = ACTIONS(2538),
    [anon_sym_boolean] = ACTIONS(2538),
    [anon_sym_string] = ACTIONS(2538),
    [anon_sym_symbol] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_extends] = ACTIONS(2538),
  },
  [807] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_type] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_namespace] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_COMMA] = ACTIONS(2544),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2544),
    [anon_sym_LPAREN] = ACTIONS(2544),
    [anon_sym_RPAREN] = ACTIONS(2544),
    [anon_sym_await] = ACTIONS(2542),
    [anon_sym_COLON] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_RBRACK] = ACTIONS(2544),
    [anon_sym_LT] = ACTIONS(2544),
    [anon_sym_GT] = ACTIONS(2544),
    [anon_sym_SLASH] = ACTIONS(2542),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_class] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_EQ_GT] = ACTIONS(2544),
    [anon_sym_QMARK_DOT] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2544),
    [anon_sym_AMP] = ACTIONS(2544),
    [anon_sym_PIPE] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2544),
    [anon_sym_void] = ACTIONS(2542),
    [anon_sym_delete] = ACTIONS(2542),
    [anon_sym_PLUS_PLUS] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2544),
    [anon_sym_DQUOTE] = ACTIONS(2544),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2544),
    [sym_number] = ACTIONS(2544),
    [sym_this] = ACTIONS(2542),
    [sym_super] = ACTIONS(2542),
    [sym_true] = ACTIONS(2542),
    [sym_false] = ACTIONS(2542),
    [sym_null] = ACTIONS(2542),
    [sym_undefined] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2542),
    [anon_sym_readonly] = ACTIONS(2542),
    [anon_sym_get] = ACTIONS(2542),
    [anon_sym_set] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(2542),
    [anon_sym_declare] = ACTIONS(2542),
    [anon_sym_public] = ACTIONS(2542),
    [anon_sym_private] = ACTIONS(2542),
    [anon_sym_protected] = ACTIONS(2542),
    [anon_sym_override] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_any] = ACTIONS(2542),
    [anon_sym_number] = ACTIONS(2542),
    [anon_sym_boolean] = ACTIONS(2542),
    [anon_sym_string] = ACTIONS(2542),
    [anon_sym_symbol] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_extends] = ACTIONS(2542),
  },
  [808] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2546),
    [anon_sym_EQ] = ACTIONS(2546),
    [anon_sym_namespace] = ACTIONS(2546),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_typeof] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [anon_sym_await] = ACTIONS(2546),
    [anon_sym_COLON] = ACTIONS(2548),
    [anon_sym_yield] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_RBRACK] = ACTIONS(2548),
    [anon_sym_LT] = ACTIONS(2548),
    [anon_sym_GT] = ACTIONS(2548),
    [anon_sym_SLASH] = ACTIONS(2546),
    [anon_sym_DOT] = ACTIONS(2546),
    [anon_sym_class] = ACTIONS(2546),
    [anon_sym_async] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_EQ_GT] = ACTIONS(2548),
    [anon_sym_QMARK_DOT] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_PIPE] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2546),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2546),
    [anon_sym_delete] = ACTIONS(2546),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2548),
    [sym_number] = ACTIONS(2548),
    [sym_this] = ACTIONS(2546),
    [sym_super] = ACTIONS(2546),
    [sym_true] = ACTIONS(2546),
    [sym_false] = ACTIONS(2546),
    [sym_null] = ACTIONS(2546),
    [sym_undefined] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2546),
    [anon_sym_readonly] = ACTIONS(2546),
    [anon_sym_get] = ACTIONS(2546),
    [anon_sym_set] = ACTIONS(2546),
    [anon_sym_QMARK] = ACTIONS(2546),
    [anon_sym_declare] = ACTIONS(2546),
    [anon_sym_public] = ACTIONS(2546),
    [anon_sym_private] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(2546),
    [anon_sym_override] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_any] = ACTIONS(2546),
    [anon_sym_number] = ACTIONS(2546),
    [anon_sym_boolean] = ACTIONS(2546),
    [anon_sym_string] = ACTIONS(2546),
    [anon_sym_symbol] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_extends] = ACTIONS(2546),
  },
  [809] = {
    [sym_nested_identifier] = STATE(609),
    [sym_string] = STATE(624),
    [sym__module] = STATE(640),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [810] = {
    [sym_nested_identifier] = STATE(127),
    [sym_string] = STATE(131),
    [sym__module] = STATE(155),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [811] = {
    [sym_nested_identifier] = STATE(609),
    [sym_string] = STATE(624),
    [sym__module] = STATE(640),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [812] = {
    [sym_nested_identifier] = STATE(609),
    [sym_string] = STATE(624),
    [sym__module] = STATE(640),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [813] = {
    [sym_nested_identifier] = STATE(127),
    [sym_string] = STATE(131),
    [sym__module] = STATE(155),
    [aux_sym_object_repeat1] = STATE(3698),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [814] = {
    [sym_nested_identifier] = STATE(127),
    [sym_string] = STATE(131),
    [sym__module] = STATE(155),
    [aux_sym_object_repeat1] = STATE(3608),
    [aux_sym_object_pattern_repeat1] = STATE(3617),
    [sym_identifier] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1872),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(150),
    [anon_sym_RBRACE] = ACTIONS(1681),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_SEMI] = ACTIONS(150),
    [anon_sym_COLON] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(1255),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(1706),
    [sym__automatic_semicolon] = ACTIONS(150),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [815] = {
    [sym_nested_identifier] = STATE(4118),
    [sym_string] = STATE(2721),
    [sym_formal_parameters] = STATE(4200),
    [sym_nested_type_identifier] = STATE(2607),
    [sym__type] = STATE(2794),
    [sym_constructor_type] = STATE(2794),
    [sym__primary_type] = STATE(2701),
    [sym_template_literal_type] = STATE(2700),
    [sym_infer_type] = STATE(2794),
    [sym_conditional_type] = STATE(2700),
    [sym_generic_type] = STATE(2700),
    [sym_type_predicate] = STATE(3284),
    [sym_type_query] = STATE(2700),
    [sym_index_type_query] = STATE(2700),
    [sym_lookup_type] = STATE(2700),
    [sym_literal_type] = STATE(2700),
    [sym__number] = STATE(2699),
    [sym_existential_type] = STATE(2700),
    [sym_flow_maybe_type] = STATE(2700),
    [sym_parenthesized_type] = STATE(2700),
    [sym_predefined_type] = STATE(2700),
    [sym_object_type] = STATE(2700),
    [sym_type_parameters] = STATE(3830),
    [sym_array_type] = STATE(2700),
    [sym_tuple_type] = STATE(2700),
    [sym_readonly_type] = STATE(2794),
    [sym_union_type] = STATE(2700),
    [sym_intersection_type] = STATE(2700),
    [sym_function_type] = STATE(2794),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_typeof] = ACTIONS(2564),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_void] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2588),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_null] = ACTIONS(2590),
    [sym_undefined] = ACTIONS(2590),
    [anon_sym_readonly] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_asserts] = ACTIONS(2596),
    [anon_sym_infer] = ACTIONS(2598),
    [anon_sym_keyof] = ACTIONS(2600),
    [anon_sym_unknown] = ACTIONS(2578),
    [anon_sym_never] = ACTIONS(2578),
    [anon_sym_object] = ACTIONS(2578),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2602),
  },
  [816] = {
    [sym_nested_identifier] = STATE(4078),
    [sym_string] = STATE(2626),
    [sym_formal_parameters] = STATE(4312),
    [sym_nested_type_identifier] = STATE(2501),
    [sym__type] = STATE(2647),
    [sym_constructor_type] = STATE(2647),
    [sym__primary_type] = STATE(2624),
    [sym_template_literal_type] = STATE(2576),
    [sym_infer_type] = STATE(2647),
    [sym_conditional_type] = STATE(2576),
    [sym_generic_type] = STATE(2576),
    [sym_type_predicate] = STATE(3097),
    [sym_type_query] = STATE(2576),
    [sym_index_type_query] = STATE(2576),
    [sym_lookup_type] = STATE(2576),
    [sym_literal_type] = STATE(2576),
    [sym__number] = STATE(2623),
    [sym_existential_type] = STATE(2576),
    [sym_flow_maybe_type] = STATE(2576),
    [sym_parenthesized_type] = STATE(2576),
    [sym_predefined_type] = STATE(2576),
    [sym_object_type] = STATE(2576),
    [sym_type_parameters] = STATE(3950),
    [sym_array_type] = STATE(2576),
    [sym_tuple_type] = STATE(2576),
    [sym_readonly_type] = STATE(2647),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2647),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_typeof] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(2608),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_null] = ACTIONS(1296),
    [sym_undefined] = ACTIONS(1296),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
    [anon_sym_asserts] = ACTIONS(2610),
    [anon_sym_infer] = ACTIONS(747),
    [anon_sym_keyof] = ACTIONS(749),
    [anon_sym_unknown] = ACTIONS(751),
    [anon_sym_never] = ACTIONS(751),
    [anon_sym_object] = ACTIONS(751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(753),
  },
  [817] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2753),
    [sym_constructor_type] = STATE(2753),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2753),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_predicate] = STATE(3928),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2753),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2753),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(2614),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_asserts] = ACTIONS(2616),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [818] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3759),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3759),
    [sym_pair] = STATE(3759),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3760),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_readonly] = ACTIONS(2646),
    [anon_sym_get] = ACTIONS(2648),
    [anon_sym_set] = ACTIONS(2648),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_override] = ACTIONS(2652),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [819] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2406),
    [sym_constructor_type] = STATE(2406),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2406),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_predicate] = STATE(2390),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2406),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2406),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(2614),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [820] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2931),
    [sym_constructor_type] = STATE(2931),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2931),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2931),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2931),
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [sym_jsx_identifier] = ACTIONS(2658),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [821] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_readonly] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [822] = {
    [sym_nested_identifier] = STATE(4142),
    [sym_string] = STATE(1545),
    [sym_formal_parameters] = STATE(4338),
    [sym_nested_type_identifier] = STATE(1524),
    [sym__type] = STATE(1697),
    [sym_constructor_type] = STATE(1697),
    [sym__primary_type] = STATE(1565),
    [sym_template_literal_type] = STATE(1566),
    [sym_infer_type] = STATE(1697),
    [sym_conditional_type] = STATE(1566),
    [sym_generic_type] = STATE(1566),
    [sym_type_predicate] = STATE(1700),
    [sym_type_query] = STATE(1566),
    [sym_index_type_query] = STATE(1566),
    [sym_lookup_type] = STATE(1566),
    [sym_literal_type] = STATE(1566),
    [sym__number] = STATE(1571),
    [sym_existential_type] = STATE(1566),
    [sym_flow_maybe_type] = STATE(1566),
    [sym_parenthesized_type] = STATE(1566),
    [sym_predefined_type] = STATE(1566),
    [sym_object_type] = STATE(1566),
    [sym_type_parameters] = STATE(3841),
    [sym_array_type] = STATE(1566),
    [sym_tuple_type] = STATE(1566),
    [sym_readonly_type] = STATE(1697),
    [sym_union_type] = STATE(1566),
    [sym_intersection_type] = STATE(1566),
    [sym_function_type] = STATE(1697),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_typeof] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2702),
    [sym_this] = ACTIONS(2704),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_readonly] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2710),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2712),
    [anon_sym_keyof] = ACTIONS(2714),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2716),
  },
  [823] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3409),
    [sym_constructor_type] = STATE(3409),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3409),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3409),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3409),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [824] = {
    [sym_export_statement] = STATE(2962),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2962),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2962),
    [sym_property_signature] = STATE(2962),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2962),
    [sym_index_signature] = STATE(2962),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2720),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_readonly] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2726),
  },
  [825] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2730),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_readonly] = ACTIONS(2738),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [826] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4143),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3083),
    [sym_constructor_type] = STATE(3083),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3083),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_predicate] = STATE(2394),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4004),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3083),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3083),
    [sym_identifier] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2760),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(2762),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(2764),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(2768),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
  },
  [827] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [828] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2774),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [829] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4143),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3060),
    [sym_constructor_type] = STATE(3060),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3060),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_predicate] = STATE(2390),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4004),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3060),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3060),
    [sym_identifier] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2760),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(2762),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(2764),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(2768),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2770),
  },
  [830] = {
    [sym_nested_identifier] = STATE(1257),
    [sym_string] = STATE(1250),
    [sym__module] = STATE(1409),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_RBRACE] = ACTIONS(1264),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(2014),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [831] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2778),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2778),
    [anon_sym_namespace] = ACTIONS(2778),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2786),
    [anon_sym_readonly] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2790),
    [anon_sym_set] = ACTIONS(2790),
    [anon_sym_declare] = ACTIONS(2778),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_override] = ACTIONS(2794),
    [anon_sym_module] = ACTIONS(2778),
    [anon_sym_any] = ACTIONS(2778),
    [anon_sym_number] = ACTIONS(2778),
    [anon_sym_boolean] = ACTIONS(2778),
    [anon_sym_string] = ACTIONS(2778),
    [anon_sym_symbol] = ACTIONS(2778),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [832] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [833] = {
    [sym_nested_identifier] = STATE(4052),
    [sym_string] = STATE(1321),
    [sym_formal_parameters] = STATE(4244),
    [sym_nested_type_identifier] = STATE(1216),
    [sym__type] = STATE(1316),
    [sym_constructor_type] = STATE(1316),
    [sym__primary_type] = STATE(1251),
    [sym_template_literal_type] = STATE(1254),
    [sym_infer_type] = STATE(1316),
    [sym_conditional_type] = STATE(1254),
    [sym_generic_type] = STATE(1254),
    [sym_type_predicate] = STATE(1308),
    [sym_type_query] = STATE(1254),
    [sym_index_type_query] = STATE(1254),
    [sym_lookup_type] = STATE(1254),
    [sym_literal_type] = STATE(1254),
    [sym__number] = STATE(1255),
    [sym_existential_type] = STATE(1254),
    [sym_flow_maybe_type] = STATE(1254),
    [sym_parenthesized_type] = STATE(1254),
    [sym_predefined_type] = STATE(1254),
    [sym_object_type] = STATE(1254),
    [sym_type_parameters] = STATE(4033),
    [sym_array_type] = STATE(1254),
    [sym_tuple_type] = STATE(1254),
    [sym_readonly_type] = STATE(1316),
    [sym_union_type] = STATE(1254),
    [sym_intersection_type] = STATE(1254),
    [sym_function_type] = STATE(1316),
    [sym_identifier] = ACTIONS(2798),
    [anon_sym_STAR] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_LBRACK] = ACTIONS(2808),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2810),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_PIPE] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_void] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [sym_null] = ACTIONS(2826),
    [sym_undefined] = ACTIONS(2826),
    [anon_sym_readonly] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2830),
    [anon_sym_any] = ACTIONS(2818),
    [anon_sym_number] = ACTIONS(2818),
    [anon_sym_boolean] = ACTIONS(2818),
    [anon_sym_string] = ACTIONS(2818),
    [anon_sym_symbol] = ACTIONS(2818),
    [anon_sym_infer] = ACTIONS(2832),
    [anon_sym_keyof] = ACTIONS(2834),
    [anon_sym_unknown] = ACTIONS(2818),
    [anon_sym_never] = ACTIONS(2818),
    [anon_sym_object] = ACTIONS(2818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2836),
  },
  [834] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3461),
    [sym_constructor_type] = STATE(3461),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3461),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3461),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3461),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [835] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [836] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2730),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_readonly] = ACTIONS(2738),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [837] = {
    [sym_nested_identifier] = STATE(1257),
    [sym_string] = STATE(1250),
    [sym__module] = STATE(1409),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(206),
    [anon_sym_RBRACE] = ACTIONS(206),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(206),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(206),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(209),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(635),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [838] = {
    [sym_nested_identifier] = STATE(4078),
    [sym_string] = STATE(2626),
    [sym_formal_parameters] = STATE(4312),
    [sym_nested_type_identifier] = STATE(2501),
    [sym__type] = STATE(2598),
    [sym_constructor_type] = STATE(2598),
    [sym__primary_type] = STATE(2624),
    [sym_template_literal_type] = STATE(2576),
    [sym_infer_type] = STATE(2598),
    [sym_conditional_type] = STATE(2576),
    [sym_generic_type] = STATE(2576),
    [sym_type_predicate] = STATE(2597),
    [sym_type_query] = STATE(2576),
    [sym_index_type_query] = STATE(2576),
    [sym_lookup_type] = STATE(2576),
    [sym_literal_type] = STATE(2576),
    [sym__number] = STATE(2623),
    [sym_existential_type] = STATE(2576),
    [sym_flow_maybe_type] = STATE(2576),
    [sym_parenthesized_type] = STATE(2576),
    [sym_predefined_type] = STATE(2576),
    [sym_object_type] = STATE(2576),
    [sym_type_parameters] = STATE(3950),
    [sym_array_type] = STATE(2576),
    [sym_tuple_type] = STATE(2576),
    [sym_readonly_type] = STATE(2598),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2598),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_typeof] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(2608),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_null] = ACTIONS(1296),
    [sym_undefined] = ACTIONS(1296),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
    [anon_sym_infer] = ACTIONS(747),
    [anon_sym_keyof] = ACTIONS(749),
    [anon_sym_unknown] = ACTIONS(751),
    [anon_sym_never] = ACTIONS(751),
    [anon_sym_object] = ACTIONS(751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(753),
  },
  [839] = {
    [sym_nested_identifier] = STATE(4118),
    [sym_string] = STATE(2721),
    [sym_formal_parameters] = STATE(4200),
    [sym_nested_type_identifier] = STATE(2607),
    [sym__type] = STATE(2735),
    [sym_constructor_type] = STATE(2735),
    [sym__primary_type] = STATE(2701),
    [sym_template_literal_type] = STATE(2700),
    [sym_infer_type] = STATE(2735),
    [sym_conditional_type] = STATE(2700),
    [sym_generic_type] = STATE(2700),
    [sym_type_predicate] = STATE(2736),
    [sym_type_query] = STATE(2700),
    [sym_index_type_query] = STATE(2700),
    [sym_lookup_type] = STATE(2700),
    [sym_literal_type] = STATE(2700),
    [sym__number] = STATE(2699),
    [sym_existential_type] = STATE(2700),
    [sym_flow_maybe_type] = STATE(2700),
    [sym_parenthesized_type] = STATE(2700),
    [sym_predefined_type] = STATE(2700),
    [sym_object_type] = STATE(2700),
    [sym_type_parameters] = STATE(3830),
    [sym_array_type] = STATE(2700),
    [sym_tuple_type] = STATE(2700),
    [sym_readonly_type] = STATE(2735),
    [sym_union_type] = STATE(2700),
    [sym_intersection_type] = STATE(2700),
    [sym_function_type] = STATE(2735),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_typeof] = ACTIONS(2564),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_void] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2588),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_null] = ACTIONS(2590),
    [sym_undefined] = ACTIONS(2590),
    [anon_sym_readonly] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_infer] = ACTIONS(2598),
    [anon_sym_keyof] = ACTIONS(2600),
    [anon_sym_unknown] = ACTIONS(2578),
    [anon_sym_never] = ACTIONS(2578),
    [anon_sym_object] = ACTIONS(2578),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2602),
  },
  [840] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [841] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [842] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [843] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3415),
    [sym_constructor_type] = STATE(3415),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3415),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3415),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3415),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2848),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [844] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2858),
    [anon_sym_readonly] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2862),
    [anon_sym_set] = ACTIONS(2862),
    [anon_sym_declare] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_override] = ACTIONS(2866),
    [anon_sym_module] = ACTIONS(2850),
    [anon_sym_any] = ACTIONS(2850),
    [anon_sym_number] = ACTIONS(2850),
    [anon_sym_boolean] = ACTIONS(2850),
    [anon_sym_string] = ACTIONS(2850),
    [anon_sym_symbol] = ACTIONS(2850),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [845] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2415),
    [sym_constructor_type] = STATE(2415),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2415),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_predicate] = STATE(2394),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2415),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2415),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(2614),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [846] = {
    [sym_nested_identifier] = STATE(4142),
    [sym_string] = STATE(1545),
    [sym_formal_parameters] = STATE(4338),
    [sym_nested_type_identifier] = STATE(1524),
    [sym__type] = STATE(1550),
    [sym_constructor_type] = STATE(1550),
    [sym__primary_type] = STATE(1565),
    [sym_template_literal_type] = STATE(1566),
    [sym_infer_type] = STATE(1550),
    [sym_conditional_type] = STATE(1566),
    [sym_generic_type] = STATE(1566),
    [sym_type_predicate] = STATE(1551),
    [sym_type_query] = STATE(1566),
    [sym_index_type_query] = STATE(1566),
    [sym_lookup_type] = STATE(1566),
    [sym_literal_type] = STATE(1566),
    [sym__number] = STATE(1571),
    [sym_existential_type] = STATE(1566),
    [sym_flow_maybe_type] = STATE(1566),
    [sym_parenthesized_type] = STATE(1566),
    [sym_predefined_type] = STATE(1566),
    [sym_object_type] = STATE(1566),
    [sym_type_parameters] = STATE(3841),
    [sym_array_type] = STATE(1566),
    [sym_tuple_type] = STATE(1566),
    [sym_readonly_type] = STATE(1550),
    [sym_union_type] = STATE(1566),
    [sym_intersection_type] = STATE(1566),
    [sym_function_type] = STATE(1550),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_typeof] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2702),
    [sym_this] = ACTIONS(2704),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_readonly] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2710),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_infer] = ACTIONS(2712),
    [anon_sym_keyof] = ACTIONS(2714),
    [anon_sym_unknown] = ACTIONS(2698),
    [anon_sym_never] = ACTIONS(2698),
    [anon_sym_object] = ACTIONS(2698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2716),
  },
  [847] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [848] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3515),
    [sym_constructor_type] = STATE(3515),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3515),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3515),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3515),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [849] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2872),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [850] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2874),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [851] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [852] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2878),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [853] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3759),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3759),
    [sym_pair] = STATE(3759),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3760),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_readonly] = ACTIONS(2646),
    [anon_sym_get] = ACTIONS(2648),
    [anon_sym_set] = ACTIONS(2648),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_override] = ACTIONS(2652),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [854] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2730),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_readonly] = ACTIONS(2738),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2742),
    [anon_sym_private] = ACTIONS(2742),
    [anon_sym_protected] = ACTIONS(2742),
    [anon_sym_override] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [855] = {
    [sym_nested_identifier] = STATE(4078),
    [sym_string] = STATE(2626),
    [sym_formal_parameters] = STATE(4312),
    [sym_nested_type_identifier] = STATE(2501),
    [sym__type] = STATE(2588),
    [sym_constructor_type] = STATE(2588),
    [sym__primary_type] = STATE(2624),
    [sym_template_literal_type] = STATE(2576),
    [sym_infer_type] = STATE(2588),
    [sym_conditional_type] = STATE(2576),
    [sym_generic_type] = STATE(2576),
    [sym_type_predicate] = STATE(2587),
    [sym_type_query] = STATE(2576),
    [sym_index_type_query] = STATE(2576),
    [sym_lookup_type] = STATE(2576),
    [sym_literal_type] = STATE(2576),
    [sym__number] = STATE(2623),
    [sym_existential_type] = STATE(2576),
    [sym_flow_maybe_type] = STATE(2576),
    [sym_parenthesized_type] = STATE(2576),
    [sym_predefined_type] = STATE(2576),
    [sym_object_type] = STATE(2576),
    [sym_type_parameters] = STATE(3950),
    [sym_array_type] = STATE(2576),
    [sym_tuple_type] = STATE(2576),
    [sym_readonly_type] = STATE(2588),
    [sym_union_type] = STATE(2576),
    [sym_intersection_type] = STATE(2576),
    [sym_function_type] = STATE(2588),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_typeof] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(1276),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1278),
    [anon_sym_AMP] = ACTIONS(723),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(751),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [sym_number] = ACTIONS(1292),
    [sym_this] = ACTIONS(2608),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_null] = ACTIONS(1296),
    [sym_undefined] = ACTIONS(1296),
    [anon_sym_readonly] = ACTIONS(1298),
    [anon_sym_QMARK] = ACTIONS(743),
    [anon_sym_any] = ACTIONS(751),
    [anon_sym_number] = ACTIONS(751),
    [anon_sym_boolean] = ACTIONS(751),
    [anon_sym_string] = ACTIONS(751),
    [anon_sym_symbol] = ACTIONS(751),
    [anon_sym_infer] = ACTIONS(747),
    [anon_sym_keyof] = ACTIONS(749),
    [anon_sym_unknown] = ACTIONS(751),
    [anon_sym_never] = ACTIONS(751),
    [anon_sym_object] = ACTIONS(751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(753),
  },
  [856] = {
    [sym_nested_identifier] = STATE(1257),
    [sym_string] = STATE(1250),
    [sym__module] = STATE(1409),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_STAR] = ACTIONS(114),
    [anon_sym_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(114),
    [anon_sym_COMMA] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(120),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_LPAREN] = ACTIONS(150),
    [anon_sym_RPAREN] = ACTIONS(120),
    [anon_sym_in] = ACTIONS(114),
    [anon_sym_COLON] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(150),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(114),
    [anon_sym_GT] = ACTIONS(114),
    [anon_sym_SLASH] = ACTIONS(114),
    [anon_sym_DOT] = ACTIONS(150),
    [anon_sym_EQ_GT] = ACTIONS(148),
    [anon_sym_QMARK_DOT] = ACTIONS(150),
    [anon_sym_PLUS_EQ] = ACTIONS(154),
    [anon_sym_DASH_EQ] = ACTIONS(154),
    [anon_sym_STAR_EQ] = ACTIONS(154),
    [anon_sym_SLASH_EQ] = ACTIONS(154),
    [anon_sym_PERCENT_EQ] = ACTIONS(154),
    [anon_sym_CARET_EQ] = ACTIONS(154),
    [anon_sym_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(154),
    [anon_sym_LT_LT_EQ] = ACTIONS(154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(154),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(114),
    [anon_sym_PIPE_PIPE] = ACTIONS(114),
    [anon_sym_GT_GT] = ACTIONS(114),
    [anon_sym_GT_GT_GT] = ACTIONS(114),
    [anon_sym_LT_LT] = ACTIONS(114),
    [anon_sym_AMP] = ACTIONS(114),
    [anon_sym_CARET] = ACTIONS(114),
    [anon_sym_PIPE] = ACTIONS(114),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_PERCENT] = ACTIONS(114),
    [anon_sym_STAR_STAR] = ACTIONS(114),
    [anon_sym_LT_EQ] = ACTIONS(150),
    [anon_sym_EQ_EQ] = ACTIONS(114),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(150),
    [anon_sym_BANG_EQ] = ACTIONS(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(150),
    [anon_sym_GT_EQ] = ACTIONS(150),
    [anon_sym_QMARK_QMARK] = ACTIONS(114),
    [anon_sym_instanceof] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(150),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_QMARK] = ACTIONS(635),
    [sym__ternary_qmark] = ACTIONS(150),
  },
  [857] = {
    [sym_nested_identifier] = STATE(4118),
    [sym_string] = STATE(2721),
    [sym_formal_parameters] = STATE(4200),
    [sym_nested_type_identifier] = STATE(2607),
    [sym__type] = STATE(2707),
    [sym_constructor_type] = STATE(2707),
    [sym__primary_type] = STATE(2701),
    [sym_template_literal_type] = STATE(2700),
    [sym_infer_type] = STATE(2707),
    [sym_conditional_type] = STATE(2700),
    [sym_generic_type] = STATE(2700),
    [sym_type_predicate] = STATE(2708),
    [sym_type_query] = STATE(2700),
    [sym_index_type_query] = STATE(2700),
    [sym_lookup_type] = STATE(2700),
    [sym_literal_type] = STATE(2700),
    [sym__number] = STATE(2699),
    [sym_existential_type] = STATE(2700),
    [sym_flow_maybe_type] = STATE(2700),
    [sym_parenthesized_type] = STATE(2700),
    [sym_predefined_type] = STATE(2700),
    [sym_object_type] = STATE(2700),
    [sym_type_parameters] = STATE(3830),
    [sym_array_type] = STATE(2700),
    [sym_tuple_type] = STATE(2700),
    [sym_readonly_type] = STATE(2707),
    [sym_union_type] = STATE(2700),
    [sym_intersection_type] = STATE(2700),
    [sym_function_type] = STATE(2707),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_typeof] = ACTIONS(2564),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_void] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2586),
    [sym_this] = ACTIONS(2588),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_null] = ACTIONS(2590),
    [sym_undefined] = ACTIONS(2590),
    [anon_sym_readonly] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_infer] = ACTIONS(2598),
    [anon_sym_keyof] = ACTIONS(2600),
    [anon_sym_unknown] = ACTIONS(2578),
    [anon_sym_never] = ACTIONS(2578),
    [anon_sym_object] = ACTIONS(2578),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2602),
  },
  [858] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2884),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [859] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_readonly] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [860] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(3506),
    [sym_constructor_type] = STATE(3506),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(3506),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(3506),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(3506),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_RBRACK] = ACTIONS(2886),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
  [861] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_readonly] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [862] = {
    [sym_export_statement] = STATE(2953),
    [sym_object_pattern] = STATE(4264),
    [sym_object_assignment_pattern] = STATE(3758),
    [sym_array_pattern] = STATE(4264),
    [sym__call_signature] = STATE(3102),
    [sym__destructuring_pattern] = STATE(4264),
    [sym_spread_element] = STATE(3603),
    [sym_string] = STATE(2508),
    [sym_decorator] = STATE(1150),
    [sym_formal_parameters] = STATE(2641),
    [sym_rest_pattern] = STATE(3758),
    [sym_method_definition] = STATE(3603),
    [sym_pair] = STATE(3603),
    [sym_pair_pattern] = STATE(3758),
    [sym__property_name] = STATE(2508),
    [sym_computed_property_name] = STATE(2508),
    [sym_method_signature] = STATE(2953),
    [sym_accessibility_modifier] = STATE(2240),
    [sym_override_modifier] = STATE(2271),
    [sym_call_signature] = STATE(2953),
    [sym_property_signature] = STATE(2953),
    [sym_type_parameters] = STATE(3863),
    [sym_construct_signature] = STATE(2953),
    [sym_index_signature] = STATE(2953),
    [aux_sym_export_statement_repeat1] = STATE(3396),
    [aux_sym_object_repeat1] = STATE(3606),
    [aux_sym_object_pattern_repeat1] = STATE(3715),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2642),
    [sym_private_property_identifier] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(91),
    [anon_sym_static] = ACTIONS(2858),
    [anon_sym_readonly] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2862),
    [anon_sym_set] = ACTIONS(2862),
    [anon_sym_declare] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_override] = ACTIONS(2866),
    [anon_sym_module] = ACTIONS(2850),
    [anon_sym_any] = ACTIONS(2850),
    [anon_sym_number] = ACTIONS(2850),
    [anon_sym_boolean] = ACTIONS(2850),
    [anon_sym_string] = ACTIONS(2850),
    [anon_sym_symbol] = ACTIONS(2850),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2654),
  },
  [863] = {
    [sym_nested_identifier] = STATE(4052),
    [sym_string] = STATE(1321),
    [sym_formal_parameters] = STATE(4244),
    [sym_nested_type_identifier] = STATE(1216),
    [sym__type] = STATE(1229),
    [sym_constructor_type] = STATE(1229),
    [sym__primary_type] = STATE(1251),
    [sym_template_literal_type] = STATE(1254),
    [sym_infer_type] = STATE(1229),
    [sym_conditional_type] = STATE(1254),
    [sym_generic_type] = STATE(1254),
    [sym_type_predicate] = STATE(1232),
    [sym_type_query] = STATE(1254),
    [sym_index_type_query] = STATE(1254),
    [sym_lookup_type] = STATE(1254),
    [sym_literal_type] = STATE(1254),
    [sym__number] = STATE(1255),
    [sym_existential_type] = STATE(1254),
    [sym_flow_maybe_type] = STATE(1254),
    [sym_parenthesized_type] = STATE(1254),
    [sym_predefined_type] = STATE(1254),
    [sym_object_type] = STATE(1254),
    [sym_type_parameters] = STATE(4033),
    [sym_array_type] = STATE(1254),
    [sym_tuple_type] = STATE(1254),
    [sym_readonly_type] = STATE(1229),
    [sym_union_type] = STATE(1254),
    [sym_intersection_type] = STATE(1254),
    [sym_function_type] = STATE(1229),
    [sym_identifier] = ACTIONS(2798),
    [anon_sym_STAR] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2806),
    [anon_sym_LBRACK] = ACTIONS(2808),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2810),
    [anon_sym_AMP] = ACTIONS(2812),
    [anon_sym_PIPE] = ACTIONS(2814),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_void] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(173),
    [anon_sym_SQUOTE] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [sym_null] = ACTIONS(2826),
    [sym_undefined] = ACTIONS(2826),
    [anon_sym_readonly] = ACTIONS(2828),
    [anon_sym_QMARK] = ACTIONS(2830),
    [anon_sym_any] = ACTIONS(2818),
    [anon_sym_number] = ACTIONS(2818),
    [anon_sym_boolean] = ACTIONS(2818),
    [anon_sym_string] = ACTIONS(2818),
    [anon_sym_symbol] = ACTIONS(2818),
    [anon_sym_infer] = ACTIONS(2832),
    [anon_sym_keyof] = ACTIONS(2834),
    [anon_sym_unknown] = ACTIONS(2818),
    [anon_sym_never] = ACTIONS(2818),
    [anon_sym_object] = ACTIONS(2818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2836),
  },
  [864] = {
    [sym_nested_identifier] = STATE(4196),
    [sym_string] = STATE(2384),
    [sym_formal_parameters] = STATE(4195),
    [sym_nested_type_identifier] = STATE(2352),
    [sym__type] = STATE(2942),
    [sym_constructor_type] = STATE(2942),
    [sym__primary_type] = STATE(2369),
    [sym_template_literal_type] = STATE(2371),
    [sym_infer_type] = STATE(2942),
    [sym_conditional_type] = STATE(2371),
    [sym_generic_type] = STATE(2371),
    [sym_type_query] = STATE(2371),
    [sym_index_type_query] = STATE(2371),
    [sym_lookup_type] = STATE(2371),
    [sym_literal_type] = STATE(2371),
    [sym__number] = STATE(2393),
    [sym_existential_type] = STATE(2371),
    [sym_flow_maybe_type] = STATE(2371),
    [sym_parenthesized_type] = STATE(2371),
    [sym_predefined_type] = STATE(2371),
    [sym_object_type] = STATE(2371),
    [sym_type_parameters] = STATE(4043),
    [sym_array_type] = STATE(2371),
    [sym_tuple_type] = STATE(2371),
    [sym_readonly_type] = STATE(2942),
    [sym_union_type] = STATE(2371),
    [sym_intersection_type] = STATE(2371),
    [sym_function_type] = STATE(2942),
    [sym_identifier] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1227),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(591),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_true] = ACTIONS(1245),
    [sym_false] = ACTIONS(1245),
    [sym_null] = ACTIONS(1245),
    [sym_undefined] = ACTIONS(1245),
    [anon_sym_readonly] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(607),
    [anon_sym_any] = ACTIONS(199),
    [anon_sym_number] = ACTIONS(199),
    [anon_sym_boolean] = ACTIONS(199),
    [anon_sym_string] = ACTIONS(199),
    [anon_sym_symbol] = ACTIONS(199),
    [anon_sym_infer] = ACTIONS(195),
    [anon_sym_keyof] = ACTIONS(197),
    [anon_sym_unknown] = ACTIONS(199),
    [anon_sym_never] = ACTIONS(199),
    [anon_sym_object] = ACTIONS(199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(201),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2732), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [131] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3444), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [262] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2710), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [393] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3447), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [524] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3125), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [655] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1552), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [786] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3118), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [917] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3446), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1048] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1689), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1179] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1743), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1310] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2373), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1441] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2753), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1572] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2384), 1,
      sym_string,
    STATE(2386), 1,
      sym__primary_type,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3537), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1703] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1555), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1834] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2442), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [1965] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2763), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2096] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3082), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2227] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2384), 1,
      sym_string,
    STATE(2386), 1,
      sym__primary_type,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3769), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2358] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3452), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2489] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3454), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2709] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3455), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2840] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2685), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [2971] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1278), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3102] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3054), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3233] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1291), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3364] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1223), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3733), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3495] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3112), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3626] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3445), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3757] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3161), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [3888] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2579), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4019] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3487), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4150] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2357), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4281] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2582), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4412] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2686), 1,
      sym__primary_type,
    STATE(2699), 1,
      sym__number,
    STATE(2721), 1,
      sym_string,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3526), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4543] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3428), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4674] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3448), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4805] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2373), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [4936] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2982), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5067] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2403), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5198] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2681), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5329] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(1619), 1,
      sym_template_literal_type,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1622), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 15,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5462] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2391), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5593] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1318), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5724] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1301), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5855] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2647), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [5986] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1242), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6117] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1312), 1,
      sym_template_literal_type,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1310), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 15,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6250] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2689), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6381] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1255), 1,
      sym__number,
    STATE(1298), 1,
      sym__primary_type,
    STATE(1321), 1,
      sym_string,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3733), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6512] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2380), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3537), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6643] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1317), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6774] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2990), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [6905] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2609), 1,
      sym__primary_type,
    STATE(2623), 1,
      sym__number,
    STATE(2626), 1,
      sym_string,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3561), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7036] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2750), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7167] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3514), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7298] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1262), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7429] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2611), 1,
      sym__primary_type,
    STATE(2623), 1,
      sym__number,
    STATE(2626), 1,
      sym_string,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3561), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7560] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2612), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7691] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3435), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7822] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(3153), 1,
      sym__primary_type,
    STATE(3412), 1,
      sym_infer_type,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3537), 4,
      sym__type,
      sym_constructor_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [7955] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2931), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8086] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1270), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8217] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2981), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8348] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3439), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8479] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2595), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8610] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2392), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8741] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3433), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [8872] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3197), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9003] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2401), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9134] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2688), 1,
      sym__primary_type,
    STATE(2699), 1,
      sym__number,
    STATE(2721), 1,
      sym_string,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3526), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9265] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2616), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9396] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2617), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9527] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2357), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9658] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2444), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9789] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2709), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [9920] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3056), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10051] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3431), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10182] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3203), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10313] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2798), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10444] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2584), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10575] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3505), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10706] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3434), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10837] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1717), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [10968] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2391), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11099] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1571), 1,
      sym__number,
    STATE(1652), 1,
      sym__primary_type,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3674), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11230] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1571), 1,
      sym__number,
    STATE(1639), 1,
      sym__primary_type,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4195), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3674), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11361] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1540), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11492] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1623), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11623] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1607), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11754] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2925), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [11885] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2942), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12016] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2392), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12147] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2481), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12278] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3413), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12409] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2560), 1,
      anon_sym_STAR,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2564), 1,
      anon_sym_typeof,
    ACTIONS(2566), 1,
      anon_sym_LPAREN,
    ACTIONS(2568), 1,
      anon_sym_LBRACK,
    ACTIONS(2570), 1,
      anon_sym_new,
    ACTIONS(2572), 1,
      anon_sym_AMP,
    ACTIONS(2574), 1,
      anon_sym_PIPE,
    ACTIONS(2580), 1,
      anon_sym_DQUOTE,
    ACTIONS(2582), 1,
      anon_sym_SQUOTE,
    ACTIONS(2584), 1,
      anon_sym_BQUOTE,
    ACTIONS(2586), 1,
      sym_number,
    ACTIONS(2592), 1,
      anon_sym_readonly,
    ACTIONS(2594), 1,
      anon_sym_QMARK,
    ACTIONS(2598), 1,
      anon_sym_infer,
    ACTIONS(2600), 1,
      anon_sym_keyof,
    ACTIONS(2602), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2894), 1,
      sym_identifier,
    ACTIONS(2896), 1,
      sym_this,
    STATE(2607), 1,
      sym_nested_type_identifier,
    STATE(2699), 1,
      sym__number,
    STATE(2701), 1,
      sym__primary_type,
    STATE(2721), 1,
      sym_string,
    STATE(3830), 1,
      sym_type_parameters,
    STATE(4118), 1,
      sym_nested_identifier,
    STATE(4200), 1,
      sym_formal_parameters,
    ACTIONS(2576), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2590), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2682), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2578), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2700), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12540] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3073), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12671] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3089), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12802] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3072), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [12933] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2800), 1,
      anon_sym_STAR,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2804), 1,
      anon_sym_typeof,
    ACTIONS(2806), 1,
      anon_sym_LPAREN,
    ACTIONS(2808), 1,
      anon_sym_LBRACK,
    ACTIONS(2810), 1,
      anon_sym_new,
    ACTIONS(2812), 1,
      anon_sym_AMP,
    ACTIONS(2814), 1,
      anon_sym_PIPE,
    ACTIONS(2820), 1,
      anon_sym_BQUOTE,
    ACTIONS(2822), 1,
      sym_number,
    ACTIONS(2828), 1,
      anon_sym_readonly,
    ACTIONS(2830), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_infer,
    ACTIONS(2834), 1,
      anon_sym_keyof,
    ACTIONS(2836), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2902), 1,
      sym_identifier,
    ACTIONS(2904), 1,
      sym_this,
    STATE(1216), 1,
      sym_nested_type_identifier,
    STATE(1251), 1,
      sym__primary_type,
    STATE(1255), 1,
      sym__number,
    STATE(1321), 1,
      sym_string,
    STATE(4033), 1,
      sym_type_parameters,
    STATE(4052), 1,
      sym_nested_identifier,
    STATE(4244), 1,
      sym_formal_parameters,
    ACTIONS(2816), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2826), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1313), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2818), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1254), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13064] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3451), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13195] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3181), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13326] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3173), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13457] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3050), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13588] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2380), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3769), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13719] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [13808] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2590), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [13939] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2748), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_typeof,
    ACTIONS(2752), 1,
      anon_sym_new,
    ACTIONS(2754), 1,
      anon_sym_AMP,
    ACTIONS(2756), 1,
      anon_sym_PIPE,
    ACTIONS(2758), 1,
      anon_sym_DQUOTE,
    ACTIONS(2760), 1,
      anon_sym_SQUOTE,
    ACTIONS(2764), 1,
      anon_sym_readonly,
    ACTIONS(2766), 1,
      anon_sym_QMARK,
    ACTIONS(2768), 1,
      anon_sym_keyof,
    ACTIONS(2770), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4004), 1,
      sym_type_parameters,
    STATE(4143), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2922), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14070] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 1,
      anon_sym_infer,
    ACTIONS(197), 1,
      anon_sym_keyof,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(559), 1,
      anon_sym_STAR,
    ACTIONS(589), 1,
      anon_sym_AMP,
    ACTIONS(591), 1,
      anon_sym_PIPE,
    ACTIONS(607), 1,
      anon_sym_QMARK,
    ACTIONS(1217), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(1223), 1,
      anon_sym_typeof,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_new,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1239), 1,
      anon_sym_BQUOTE,
    ACTIONS(1241), 1,
      sym_number,
    ACTIONS(1243), 1,
      sym_this,
    ACTIONS(1247), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2352), 1,
      sym_nested_type_identifier,
    STATE(2369), 1,
      sym__primary_type,
    STATE(2384), 1,
      sym_string,
    STATE(2393), 1,
      sym__number,
    STATE(4043), 1,
      sym_type_parameters,
    STATE(4195), 1,
      sym_formal_parameters,
    STATE(4196), 1,
      sym_nested_identifier,
    ACTIONS(2476), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1245), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(3015), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(199), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2371), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14201] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2680), 1,
      anon_sym_STAR,
    ACTIONS(2682), 1,
      anon_sym_LBRACE,
    ACTIONS(2684), 1,
      anon_sym_typeof,
    ACTIONS(2686), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      anon_sym_LBRACK,
    ACTIONS(2690), 1,
      anon_sym_new,
    ACTIONS(2692), 1,
      anon_sym_AMP,
    ACTIONS(2694), 1,
      anon_sym_PIPE,
    ACTIONS(2700), 1,
      anon_sym_BQUOTE,
    ACTIONS(2702), 1,
      sym_number,
    ACTIONS(2708), 1,
      anon_sym_readonly,
    ACTIONS(2710), 1,
      anon_sym_QMARK,
    ACTIONS(2712), 1,
      anon_sym_infer,
    ACTIONS(2714), 1,
      anon_sym_keyof,
    ACTIONS(2716), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(2900), 1,
      sym_this,
    STATE(1524), 1,
      sym_nested_type_identifier,
    STATE(1545), 1,
      sym_string,
    STATE(1565), 1,
      sym__primary_type,
    STATE(1571), 1,
      sym__number,
    STATE(3841), 1,
      sym_type_parameters,
    STATE(4142), 1,
      sym_nested_identifier,
    STATE(4338), 1,
      sym_formal_parameters,
    ACTIONS(2696), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2706), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(1561), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(2698), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(1566), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14332] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2797), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14463] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_STAR,
    ACTIONS(723), 1,
      anon_sym_AMP,
    ACTIONS(725), 1,
      anon_sym_PIPE,
    ACTIONS(743), 1,
      anon_sym_QMARK,
    ACTIONS(747), 1,
      anon_sym_infer,
    ACTIONS(749), 1,
      anon_sym_keyof,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1266), 1,
      sym_identifier,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(1272), 1,
      anon_sym_typeof,
    ACTIONS(1274), 1,
      anon_sym_LPAREN,
    ACTIONS(1276), 1,
      anon_sym_LBRACK,
    ACTIONS(1278), 1,
      anon_sym_new,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1290), 1,
      anon_sym_BQUOTE,
    ACTIONS(1292), 1,
      sym_number,
    ACTIONS(1294), 1,
      sym_this,
    ACTIONS(1298), 1,
      anon_sym_readonly,
    ACTIONS(2472), 1,
      anon_sym_LT,
    STATE(2501), 1,
      sym_nested_type_identifier,
    STATE(2623), 1,
      sym__number,
    STATE(2624), 1,
      sym__primary_type,
    STATE(2626), 1,
      sym_string,
    STATE(3950), 1,
      sym_type_parameters,
    STATE(4078), 1,
      sym_nested_identifier,
    STATE(4312), 1,
      sym_formal_parameters,
    ACTIONS(2606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1296), 4,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
    STATE(2596), 5,
      sym__type,
      sym_constructor_type,
      sym_infer_type,
      sym_readonly_type,
      sym_function_type,
    ACTIONS(751), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
    STATE(2576), 16,
      sym_template_literal_type,
      sym_conditional_type,
      sym_generic_type,
      sym_type_query,
      sym_index_type_query,
      sym_lookup_type,
      sym_literal_type,
      sym_existential_type,
      sym_flow_maybe_type,
      sym_parenthesized_type,
      sym_predefined_type,
      sym_object_type,
      sym_array_type,
      sym_tuple_type,
      sym_union_type,
      sym_intersection_type,
  [14594] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(1261), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14686] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1900), 1,
      anon_sym_COLON,
    ACTIONS(2906), 1,
      sym_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    STATE(3437), 1,
      sym_nested_identifier,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14776] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1906), 1,
      anon_sym_COLON,
    ACTIONS(2550), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14866] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_COLON,
    ACTIONS(2908), 1,
      sym_identifier,
    STATE(1211), 1,
      sym_string,
    STATE(1217), 1,
      sym_nested_identifier,
    STATE(1418), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14956] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_COLON,
    ACTIONS(2550), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15046] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1251), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15134] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1900), 1,
      anon_sym_COLON,
    ACTIONS(2908), 1,
      sym_identifier,
    STATE(1211), 1,
      sym_string,
    STATE(1217), 1,
      sym_nested_identifier,
    STATE(1418), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15224] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    ACTIONS(1251), 1,
      anon_sym_EQ_GT,
    ACTIONS(2908), 1,
      sym_identifier,
    STATE(1211), 1,
      sym_string,
    STATE(1217), 1,
      sym_nested_identifier,
    STATE(1418), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15312] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1906), 1,
      anon_sym_COLON,
    ACTIONS(2552), 1,
      sym_identifier,
    ACTIONS(2554), 1,
      anon_sym_DQUOTE,
    ACTIONS(2556), 1,
      anon_sym_SQUOTE,
    STATE(127), 1,
      sym_nested_identifier,
    STATE(131), 1,
      sym_string,
    STATE(155), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15402] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(2020), 1,
      anon_sym_in,
    ACTIONS(2023), 1,
      anon_sym_of,
    ACTIONS(2908), 1,
      sym_identifier,
    STATE(1211), 1,
      sym_string,
    STATE(1217), 1,
      sym_nested_identifier,
    STATE(1418), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15494] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15582] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(2908), 1,
      sym_identifier,
    STATE(1211), 1,
      sym_string,
    STATE(1217), 1,
      sym_nested_identifier,
    STATE(1418), 1,
      sym__module,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15670] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1697), 1,
      anon_sym_LT,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(1872), 1,
      anon_sym_EQ,
    ACTIONS(2910), 1,
      sym_identifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15761] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1304), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [15848] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15935] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1697), 1,
      anon_sym_LT,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1872), 1,
      anon_sym_EQ,
    ACTIONS(2910), 1,
      sym_identifier,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16026] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1302), 1,
      anon_sym_EQ,
    ACTIONS(1304), 1,
      anon_sym_EQ_GT,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [16113] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1697), 1,
      anon_sym_LT,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(1872), 1,
      anon_sym_EQ,
    ACTIONS(2910), 1,
      sym_identifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16204] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16291] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2051), 1,
      anon_sym_EQ,
    ACTIONS(2054), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16384] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(2914), 1,
      anon_sym_EQ,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2930), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2934), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16608] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(2914), 1,
      anon_sym_EQ,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2938), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [16764] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(2940), 1,
      sym_identifier,
    STATE(2795), 1,
      sym_nested_identifier,
    STATE(2914), 1,
      sym_string,
    STATE(3271), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16850] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(2550), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16936] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(2908), 1,
      sym_identifier,
    STATE(1211), 1,
      sym_string,
    STATE(1217), 1,
      sym_nested_identifier,
    STATE(1418), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17022] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17108] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2622), 1,
      anon_sym_STAR,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(2944), 1,
      anon_sym_export,
    ACTIONS(2949), 1,
      anon_sym_async,
    ACTIONS(2951), 1,
      anon_sym_static,
    ACTIONS(2953), 1,
      anon_sym_readonly,
    ACTIONS(2959), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2240), 1,
      sym_accessibility_modifier,
    STATE(2271), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(2642), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2946), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2955), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2957), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2508), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3939), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3941), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(2927), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2942), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17238] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1697), 1,
      anon_sym_LT,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(1872), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17326] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(2906), 1,
      sym_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    STATE(3437), 1,
      sym_nested_identifier,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2963), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [17480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(2967), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [17548] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2054), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17636] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2051), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17726] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1697), 1,
      anon_sym_LT,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1872), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17814] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2622), 1,
      anon_sym_STAR,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_LBRACK,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(2944), 1,
      anon_sym_export,
    ACTIONS(2949), 1,
      anon_sym_async,
    ACTIONS(2951), 1,
      anon_sym_static,
    ACTIONS(2953), 1,
      anon_sym_readonly,
    ACTIONS(2959), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2240), 1,
      sym_accessibility_modifier,
    STATE(2271), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(2642), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2946), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2955), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2957), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2508), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3939), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3941), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    STATE(3024), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(2942), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [17944] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1691), 1,
      anon_sym_LPAREN,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1697), 1,
      anon_sym_LT,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(1872), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18032] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2064), 1,
      anon_sym_COLON,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18120] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1694), 1,
      anon_sym_COLON,
    ACTIONS(1706), 1,
      anon_sym_QMARK,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(2914), 1,
      anon_sym_EQ,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2921), 1,
      anon_sym_LT,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18208] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(2552), 1,
      sym_identifier,
    ACTIONS(2554), 1,
      anon_sym_DQUOTE,
    ACTIONS(2556), 1,
      anon_sym_SQUOTE,
    STATE(127), 1,
      sym_nested_identifier,
    STATE(131), 1,
      sym_string,
    STATE(155), 1,
      sym__module,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18294] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2992), 1,
      anon_sym_QMARK,
    ACTIONS(2995), 1,
      anon_sym_extends,
    STATE(2379), 1,
      sym_type_arguments,
    STATE(3911), 1,
      sym_type_annotation,
    ACTIONS(2972), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2532), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18454] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2978), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18539] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(1314), 1,
      anon_sym_EQ_GT,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18624] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2999), 1,
      anon_sym_LT,
    ACTIONS(3002), 1,
      anon_sym_DOT,
    STATE(2613), 1,
      sym_type_arguments,
    ACTIONS(2972), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2995), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18782] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1264), 1,
      anon_sym_COLON,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2524), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [18936] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    ACTIONS(3011), 1,
      anon_sym_LBRACK,
    ACTIONS(3013), 1,
      anon_sym_DOT,
    ACTIONS(3015), 1,
      anon_sym_QMARK_DOT,
    STATE(2499), 1,
      sym_arguments,
    ACTIONS(3017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3007), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2916), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19023] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2020), 1,
      anon_sym_in,
    ACTIONS(2023), 1,
      anon_sym_of,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [19112] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19199] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1312), 1,
      anon_sym_EQ,
    ACTIONS(1314), 1,
      anon_sym_EQ_GT,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [19284] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3007), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1550), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19448] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19532] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3037), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19608] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(635), 1,
      anon_sym_QMARK,
    ACTIONS(120), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19684] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(635), 1,
      anon_sym_QMARK,
    ACTIONS(206), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19760] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19836] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(1550), 1,
      anon_sym_extends,
    ACTIONS(3027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19914] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20000] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2014), 1,
      anon_sym_QMARK,
    ACTIONS(1264), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20076] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(3050), 1,
      anon_sym_EQ,
    ACTIONS(3052), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2978), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20160] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(173), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2776), 1,
      sym_identifier,
    STATE(1250), 1,
      sym_string,
    STATE(1257), 1,
      sym_nested_identifier,
    STATE(1409), 1,
      sym__module,
    ACTIONS(150), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [20244] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3054), 1,
      anon_sym_RPAREN,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3046), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20334] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20420] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(2972), 1,
      anon_sym_RPAREN,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3059), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20510] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3050), 1,
      anon_sym_EQ,
    ACTIONS(3052), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20596] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3059), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20672] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2978), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20756] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3037), 1,
      anon_sym_COLON,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2995), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    ACTIONS(1251), 1,
      anon_sym_EQ_GT,
    ACTIONS(1550), 1,
      anon_sym_extends,
    ACTIONS(3027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1550), 1,
      anon_sym_extends,
    ACTIONS(3027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21066] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(635), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(206), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1550), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21147] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3059), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_EQ,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(635), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(120), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1550), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21301] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(3064), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2978), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21384] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1906), 1,
      anon_sym_COLON,
    ACTIONS(2910), 1,
      sym_identifier,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [21459] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21532] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_COLON,
    ACTIONS(2910), 1,
      sym_identifier,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [21607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3037), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21893] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3037), 1,
      anon_sym_COLON,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(3064), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22065] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3070), 1,
      anon_sym_EQ,
    ACTIONS(3072), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22150] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(2916), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22235] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1900), 1,
      anon_sym_COLON,
    ACTIONS(2910), 1,
      sym_identifier,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [22310] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(1550), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22387] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3070), 1,
      anon_sym_EQ,
    ACTIONS(3072), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22470] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1906), 1,
      anon_sym_COLON,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22542] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3074), 1,
      anon_sym_EQ,
    ACTIONS(3076), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22624] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3074), 1,
      anon_sym_EQ,
    ACTIONS(3076), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_COLON,
    ACTIONS(1550), 1,
      anon_sym_extends,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3078), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22858] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(1550), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [22934] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(203), 1,
      anon_sym_EQ,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1552), 1,
      anon_sym_QMARK,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1550), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23012] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1900), 1,
      anon_sym_COLON,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2967), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2963), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23212] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3007), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2916), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_COLON,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23438] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1900), 1,
      anon_sym_COLON,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23510] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_EQ,
    ACTIONS(3052), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2930), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23644] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1302), 1,
      anon_sym_EQ,
    ACTIONS(1304), 1,
      anon_sym_EQ_GT,
    ACTIONS(1550), 1,
      anon_sym_extends,
    ACTIONS(3027), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1249), 1,
      anon_sym_EQ,
    ACTIONS(1251), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23790] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23860] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      anon_sym_COLON,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [23932] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1264), 1,
      anon_sym_COLON,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1550), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24010] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(2020), 1,
      anon_sym_in,
    ACTIONS(3082), 1,
      anon_sym_of,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24154] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(3084), 1,
      anon_sym_in,
    ACTIONS(3087), 1,
      anon_sym_of,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2524), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      anon_sym_EQ_GT,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24430] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_EQ,
    ACTIONS(1255), 1,
      anon_sym_EQ_GT,
    ACTIONS(1910), 1,
      anon_sym_COLON,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2938), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24566] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24634] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(1264), 1,
      anon_sym_COLON,
    ACTIONS(1261), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2934), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24772] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2995), 1,
      anon_sym_extends,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2978), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(2989), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2532), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3052), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [24988] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3093), 1,
      anon_sym_DOT,
    STATE(1151), 1,
      sym_arguments,
    ACTIONS(3091), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3089), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [25057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2051), 1,
      anon_sym_EQ,
    ACTIONS(2054), 1,
      anon_sym_COLON,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25132] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3037), 1,
      anon_sym_COLON,
    ACTIONS(3095), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25203] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3017), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25286] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_EQ_GT,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3095), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3064), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25426] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1302), 1,
      anon_sym_EQ,
    ACTIONS(1304), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25564] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25633] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_EQ,
    ACTIONS(1314), 1,
      anon_sym_EQ_GT,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(1550), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25708] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(209), 1,
      anon_sym_EQ_GT,
    ACTIONS(1219), 1,
      anon_sym_EQ,
    ACTIONS(1550), 1,
      anon_sym_extends,
    ACTIONS(3027), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3030), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25783] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3017), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [25866] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(3098), 1,
      sym_identifier,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [25937] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2978), 1,
      anon_sym_LBRACK,
    ACTIONS(2981), 1,
      anon_sym_LT,
    ACTIONS(2984), 1,
      anon_sym_DOT,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(2989), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2916), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(2910), 1,
      sym_identifier,
    ACTIONS(150), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [26089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(3064), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_AT,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
    ACTIONS(3102), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3100), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [26296] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(3084), 1,
      anon_sym_in,
    ACTIONS(3087), 1,
      anon_sym_of,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    ACTIONS(3046), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RBRACK,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(3110), 1,
      anon_sym_in,
    ACTIONS(3112), 1,
      anon_sym_COLON,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26716] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    ACTIONS(3110), 1,
      anon_sym_in,
    ACTIONS(3114), 1,
      anon_sym_COLON,
    ACTIONS(2916), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26788] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_AT,
    ACTIONS(3116), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
    ACTIONS(3102), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3100), 37,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [26858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [26924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3119), 40,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [26986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 1,
      anon_sym_EQ,
    ACTIONS(1308), 1,
      anon_sym_EQ_GT,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(150), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_EQ,
    ACTIONS(3072), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27190] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    ACTIONS(3046), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RBRACK,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2054), 1,
      anon_sym_COLON,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27332] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3035), 1,
      anon_sym_EQ_GT,
    ACTIONS(3110), 1,
      anon_sym_in,
    ACTIONS(3112), 1,
      anon_sym_COLON,
    ACTIONS(2916), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27404] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_EQ,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2064), 1,
      anon_sym_COLON,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27474] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(3027), 1,
      anon_sym_LBRACK,
    ACTIONS(1550), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3030), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(150), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3072), 1,
      anon_sym_EQ_GT,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27682] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(120), 1,
      anon_sym_COMMA,
    ACTIONS(206), 1,
      anon_sym_RBRACK,
    ACTIONS(1259), 1,
      anon_sym_EQ_GT,
    ACTIONS(2051), 1,
      anon_sym_EQ,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27754] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3076), 1,
      anon_sym_EQ_GT,
    ACTIONS(2916), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RBRACK,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(1314), 1,
      anon_sym_EQ_GT,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [27957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_EQ,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2916), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3089), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [28083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3125), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3123), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [28144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3127), 39,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_await,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [28205] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    ACTIONS(3084), 1,
      anon_sym_in,
    ACTIONS(3087), 1,
      anon_sym_of,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28276] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(2020), 1,
      anon_sym_in,
    ACTIONS(3082), 1,
      anon_sym_of,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_EQ,
    ACTIONS(1314), 1,
      anon_sym_EQ_GT,
    ACTIONS(150), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_EQ,
    ACTIONS(3076), 1,
      anon_sym_EQ_GT,
    ACTIONS(2916), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1264), 1,
      anon_sym_COLON,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28550] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3039), 1,
      anon_sym_EQ_GT,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28616] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3084), 1,
      anon_sym_in,
    ACTIONS(3087), 1,
      anon_sym_of,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28684] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3037), 1,
      anon_sym_COLON,
    ACTIONS(2916), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_EQ,
    ACTIONS(2916), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(2926), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(2912), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(148), 1,
      anon_sym_EQ_GT,
    ACTIONS(1310), 1,
      anon_sym_EQ,
    ACTIONS(150), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(154), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(114), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [28880] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3137), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3139), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3071), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [28993] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(2724), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2726), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2962), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29106] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3157), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3159), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3086), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29219] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3161), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3163), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3049), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29332] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3165), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3167), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3059), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29445] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(2632), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2654), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2953), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [29558] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3175), 1,
      anon_sym_EQ,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(3187), 1,
      anon_sym_module,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29676] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3175), 1,
      anon_sym_EQ,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_module,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29794] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3175), 1,
      anon_sym_EQ,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_module,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [29912] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3175), 1,
      anon_sym_EQ,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_module,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [30030] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3175), 1,
      anon_sym_EQ,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_module,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [30148] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3201), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30257] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3203), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30366] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3205), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30475] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3207), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30584] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30693] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3211), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30802] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3213), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [30911] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31020] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3217), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31129] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3219), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31238] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31347] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3223), 1,
      sym_identifier,
    ACTIONS(3225), 1,
      anon_sym_STAR,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    STATE(3784), 1,
      sym_import_clause,
    STATE(3785), 1,
      sym_string,
    STATE(3786), 1,
      sym_import_require_clause,
    ACTIONS(3227), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4348), 2,
      sym_namespace_import_export,
      sym_named_imports,
    ACTIONS(3229), 14,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3233), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [31424] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3235), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31533] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3237), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31642] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3239), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31751] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3241), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31860] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3243), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [31969] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3245), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32078] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3247), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32187] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3175), 1,
      anon_sym_EQ,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3187), 1,
      anon_sym_module,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [32297] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3169), 1,
      anon_sym_STAR,
    ACTIONS(3171), 1,
      anon_sym_default,
    ACTIONS(3173), 1,
      anon_sym_type,
    ACTIONS(3177), 1,
      anon_sym_as,
    ACTIONS(3187), 1,
      anon_sym_module,
    ACTIONS(3253), 1,
      anon_sym_EQ,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3269), 1,
      sym_declaration,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3486), 1,
      sym_export_clause,
    STATE(3921), 1,
      sym_namespace_import_export,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [32405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1522), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [32460] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3024), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32565] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3070), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32670] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3048), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32775] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3080), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32880] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(2927), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [32985] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3172), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33090] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(2638), 1,
      anon_sym_new,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3133), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_STAR,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3143), 1,
      anon_sym_async,
    ACTIONS(3147), 1,
      anon_sym_static,
    ACTIONS(3149), 1,
      anon_sym_readonly,
    ACTIONS(3155), 1,
      anon_sym_override,
    STATE(1150), 1,
      sym_decorator,
    STATE(2245), 1,
      sym_accessibility_modifier,
    STATE(2259), 1,
      sym_override_modifier,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3102), 1,
      sym__call_signature,
    STATE(3396), 1,
      aux_sym_export_statement_repeat1,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(3145), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3151), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3094), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1568), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [33250] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3257), 1,
      anon_sym_RBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3261), 1,
      anon_sym_async,
    ACTIONS(3263), 1,
      anon_sym_static,
    ACTIONS(3265), 1,
      anon_sym_readonly,
    ACTIONS(3271), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3760), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3267), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3269), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3759), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3255), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33348] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3275), 1,
      anon_sym_RBRACE,
    ACTIONS(3277), 1,
      anon_sym_async,
    ACTIONS(3279), 1,
      anon_sym_static,
    ACTIONS(3281), 1,
      anon_sym_readonly,
    ACTIONS(3287), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3760), 1,
      aux_sym_object_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3283), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3285), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(3759), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3273), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 1,
      anon_sym_LT,
    ACTIONS(3293), 1,
      anon_sym_DOT,
    ACTIONS(3295), 1,
      anon_sym_is,
    STATE(1247), 1,
      sym_type_arguments,
    ACTIONS(3289), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2995), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33508] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3299), 1,
      anon_sym_RBRACE,
    ACTIONS(3301), 1,
      anon_sym_async,
    ACTIONS(3303), 1,
      anon_sym_static,
    ACTIONS(3305), 1,
      anon_sym_readonly,
    ACTIONS(3311), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3606), 1,
      aux_sym_object_repeat1,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3307), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3309), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3603), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3297), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33606] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3315), 1,
      anon_sym_RBRACE,
    ACTIONS(3317), 1,
      anon_sym_async,
    ACTIONS(3319), 1,
      anon_sym_static,
    ACTIONS(3321), 1,
      anon_sym_readonly,
    ACTIONS(3327), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3606), 1,
      aux_sym_object_repeat1,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3323), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3325), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3603), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3313), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33704] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3331), 1,
      anon_sym_RBRACE,
    ACTIONS(3333), 1,
      anon_sym_async,
    ACTIONS(3335), 1,
      anon_sym_static,
    ACTIONS(3337), 1,
      anon_sym_readonly,
    ACTIONS(3343), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3606), 1,
      aux_sym_object_repeat1,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3339), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3341), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3603), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3329), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33802] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3347), 1,
      anon_sym_RBRACE,
    ACTIONS(3349), 1,
      anon_sym_async,
    ACTIONS(3351), 1,
      anon_sym_static,
    ACTIONS(3353), 1,
      anon_sym_readonly,
    ACTIONS(3359), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3606), 1,
      aux_sym_object_repeat1,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3355), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3357), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3603), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3345), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33900] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3363), 1,
      anon_sym_RBRACE,
    ACTIONS(3365), 1,
      anon_sym_async,
    ACTIONS(3367), 1,
      anon_sym_static,
    ACTIONS(3369), 1,
      anon_sym_readonly,
    ACTIONS(3375), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    STATE(3606), 1,
      aux_sym_object_repeat1,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3371), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3373), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3603), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3361), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [33998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1392), 1,
      sym_statement_block,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1324), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [34055] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 1,
      anon_sym_LT,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3389), 1,
      anon_sym_QMARK_DOT,
    STATE(1302), 1,
      sym_type_arguments,
    STATE(1344), 1,
      sym_arguments,
    ACTIONS(3379), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3381), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3295), 1,
      anon_sym_is,
    ACTIONS(3391), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3393), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1568), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1522), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 1,
      anon_sym_LT,
    STATE(1303), 1,
      sym_type_arguments,
    ACTIONS(3395), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3397), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    ACTIONS(3399), 1,
      anon_sym_DOT,
    STATE(1392), 1,
      sym_statement_block,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1324), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [34399] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3401), 1,
      anon_sym_LBRACK,
    ACTIONS(3403), 1,
      anon_sym_DOT,
    ACTIONS(3405), 1,
      anon_sym_QMARK_DOT,
    STATE(1231), 1,
      sym_arguments,
    ACTIONS(3017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3007), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3407), 1,
      sym__automatic_semicolon,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34519] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3413), 1,
      anon_sym_LBRACK,
    ACTIONS(3415), 1,
      anon_sym_DOT,
    ACTIONS(3417), 1,
      anon_sym_QMARK_DOT,
    STATE(1236), 1,
      sym_arguments,
    ACTIONS(3409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3411), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3291), 1,
      anon_sym_LT,
    ACTIONS(3293), 1,
      anon_sym_DOT,
    STATE(1247), 1,
      sym_type_arguments,
    ACTIONS(3289), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2995), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34641] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3423), 1,
      anon_sym_LBRACK,
    ACTIONS(3425), 1,
      anon_sym_DOT,
    ACTIONS(3427), 1,
      anon_sym_QMARK_DOT,
    STATE(1233), 1,
      sym_arguments,
    ACTIONS(3419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3421), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(3435), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3429), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [34762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34814] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(229), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3445), 1,
      anon_sym_async,
    ACTIONS(3447), 1,
      anon_sym_static,
    ACTIONS(3449), 1,
      anon_sym_readonly,
    ACTIONS(3455), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    ACTIONS(233), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2946), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3451), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3453), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2888), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3939), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(3941), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3443), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [34904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1982), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2548), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3459), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35060] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3469), 1,
      anon_sym_extends,
    ACTIONS(3461), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3463), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3393), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3463), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3477), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1978), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3481), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3483), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3485), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1988), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1986), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3493), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35742] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3469), 1,
      anon_sym_extends,
    ACTIONS(3495), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3497), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [35800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3505), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3509), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [35956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3513), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3493), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3515), 1,
      sym__automatic_semicolon,
    ACTIONS(1488), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1486), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1425), 1,
      sym_statement_block,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1324), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_LBRACK,
    ACTIONS(3435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3437), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3521), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3509), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3397), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3525), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3529), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36536] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    ACTIONS(3531), 1,
      anon_sym_DOT,
    STATE(1425), 1,
      sym_statement_block,
    ACTIONS(1326), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1324), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3535), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3541), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3543), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3547), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3551), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [36960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3547), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3559), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1996), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1994), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1380), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [37376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3567), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3551), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3571), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3575), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3579), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3583), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3595), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2540), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1990), 1,
      anon_sym_extends,
    ACTIONS(3597), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1348), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3605), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3609), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38324] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3611), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3613), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3617), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3621), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3627), 1,
      anon_sym_LBRACK,
    ACTIONS(3629), 1,
      anon_sym_DOT,
    ACTIONS(3631), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3623), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3625), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1992), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1990), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3635), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3605), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_LBRACK,
    ACTIONS(3637), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3639), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3605), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      anon_sym_extends,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3650), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3641), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3655), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    STATE(1375), 1,
      sym_arguments,
    ACTIONS(3657), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3659), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [38970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3663), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3667), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3671), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3667), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3407), 1,
      sym__automatic_semicolon,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3675), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3469), 1,
      anon_sym_extends,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 1,
      anon_sym_DOT,
    ACTIONS(3681), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3683), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_extends,
    ACTIONS(3677), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3690), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3667), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39660] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3469), 1,
      anon_sym_extends,
    ACTIONS(3673), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3675), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3469), 1,
      anon_sym_extends,
    ACTIONS(3692), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3694), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3465), 1,
      anon_sym_AMP,
    ACTIONS(3467), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3702), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3529), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3706), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39992] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3712), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3758), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3768), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3771), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40262] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3778), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [40329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3783), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1390), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40482] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [40563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40614] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3791), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [40719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1494), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [40823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3791), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [40874] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [40969] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3795), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41074] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LT,
    ACTIONS(3799), 1,
      anon_sym_DOT,
    ACTIONS(3801), 1,
      anon_sym_is,
    STATE(1641), 1,
      sym_type_arguments,
    ACTIONS(3289), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2995), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [41133] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [41230] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3803), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41409] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3785), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [41498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3810), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41549] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [41640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41691] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [41784] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3803), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41859] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3803), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3816), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41979] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [42064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3820), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42115] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [42214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1554), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [42265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3824), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3828), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3832), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3836), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3844), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42571] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3844), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42676] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3846), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [42781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3854), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1554), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1564), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3858), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3389), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43144] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3860), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3862), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3868), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3870), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3872), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3876), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 1,
      sym__automatic_semicolon,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [43608] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3880), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43764] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3888), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [43871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ,
    ACTIONS(3890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43924] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3902), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3880), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1490), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3904), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3909), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3911), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3913), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3915), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3641), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1546), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1456), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [44499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3918), 1,
      sym__automatic_semicolon,
    ACTIONS(1488), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1486), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [44552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3920), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3922), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44654] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3924), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [44759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1486), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [44810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3924), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3930), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3932), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3937), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45018] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3939), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3943), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45225] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3945), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3949), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1482), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3953), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45585] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3955), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [45690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3957), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3959), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3961), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3945), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1494), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3963), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3965), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45945] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3803), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1484), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1482), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [46067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1488), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1486), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46118] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3971), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3974), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3976), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3978), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3980), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3984), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3229), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3233), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3988), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1380), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3990), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3992), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3641), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3996), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1492), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1490), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [46805] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3998), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [46910] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4004), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1442), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47081] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47171] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4047), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47245] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4056), 1,
      anon_sym_RBRACE,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1497), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [47339] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4078), 1,
      anon_sym_COMMA,
    ACTIONS(4082), 1,
      anon_sym_LT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    STATE(2810), 1,
      sym_type_arguments,
    STATE(3395), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4076), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47447] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3860), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [47551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4130), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3641), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4132), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4134), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47713] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3945), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47817] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4166), 1,
      anon_sym_COMMA,
    ACTIONS(4169), 1,
      anon_sym_RBRACE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47925] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4171), 1,
      anon_sym_COMMA,
    ACTIONS(4174), 1,
      anon_sym_RBRACE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4176), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48033] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3939), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [48137] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3860), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [48241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3801), 1,
      anon_sym_is,
    ACTIONS(3391), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3393), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [48293] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3998), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [48397] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3795), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [48501] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3791), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [48605] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4047), 1,
      anon_sym_LT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48675] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4136), 1,
      anon_sym_GT,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    ACTIONS(4180), 1,
      anon_sym_in,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4178), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [48781] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    STATE(2260), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [48863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3046), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [48919] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3795), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49023] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4197), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1463), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(3621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3650), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3641), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(1990), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1348), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49233] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49313] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4199), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1497), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49407] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3791), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(3650), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3621), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3641), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [49571] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4205), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49641] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4208), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [49709] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4211), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [49813] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [49907] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    STATE(2260), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [49989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3059), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50045] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4213), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(4229), 1,
      sym_type_annotation,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3706), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50213] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4171), 1,
      anon_sym_COMMA,
    ACTIONS(4174), 1,
      anon_sym_RBRACE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3939), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50321] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4215), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50393] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [50489] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4047), 1,
      anon_sym_LT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [50565] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3955), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [50669] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50757] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [50847] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4218), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(4331), 1,
      sym_type_annotation,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [50957] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4220), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1497), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51051] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [51143] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4222), 1,
      anon_sym_LBRACK,
    ACTIONS(4224), 1,
      anon_sym_DOT,
    ACTIONS(4226), 1,
      anon_sym_QMARK_DOT,
    STATE(1559), 1,
      sym_arguments,
    ACTIONS(3409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3411), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(3600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4228), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1990), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1348), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [51263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4232), 1,
      anon_sym_LBRACK,
    ACTIONS(4234), 1,
      anon_sym_DOT,
    ACTIONS(4236), 1,
      anon_sym_QMARK_DOT,
    STATE(1560), 1,
      sym_arguments,
    ACTIONS(3419), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3421), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4238), 1,
      anon_sym_LBRACK,
    ACTIONS(4240), 1,
      anon_sym_DOT,
    ACTIONS(4242), 1,
      anon_sym_QMARK_DOT,
    STATE(1563), 1,
      sym_arguments,
    ACTIONS(3017), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3007), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [51383] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4047), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [51451] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4174), 1,
      anon_sym_RBRACE,
    ACTIONS(4244), 1,
      anon_sym_COMMA,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [51559] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [51643] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [51741] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    STATE(2260), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [51823] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [51921] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3998), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [52025] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4247), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1439), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52119] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4249), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1497), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52213] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4254), 1,
      anon_sym_STAR,
    ACTIONS(4257), 1,
      anon_sym_RBRACE,
    ACTIONS(4259), 1,
      anon_sym_LBRACK,
    ACTIONS(4262), 1,
      anon_sym_async,
    ACTIONS(4265), 1,
      anon_sym_DASH,
    ACTIONS(4268), 1,
      anon_sym_DQUOTE,
    ACTIONS(4271), 1,
      anon_sym_SQUOTE,
    ACTIONS(4277), 1,
      anon_sym_AT,
    ACTIONS(4280), 1,
      anon_sym_static,
    ACTIONS(4283), 1,
      anon_sym_readonly,
    ACTIONS(4289), 1,
      anon_sym_declare,
    ACTIONS(4295), 1,
      anon_sym_override,
    ACTIONS(4298), 1,
      anon_sym_abstract,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4274), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4286), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1497), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(4292), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(4251), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52307] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LT,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4301), 1,
      anon_sym_QMARK_DOT,
    STATE(1632), 1,
      sym_type_arguments,
    STATE(1810), 1,
      sym_arguments,
    ACTIONS(3379), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3381), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52371] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4303), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [52437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52495] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4306), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52563] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3844), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [52667] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4309), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52739] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3955), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [52843] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    STATE(2260), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [52925] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3846), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [53029] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3846), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53133] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3844), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53237] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4174), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4312), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53343] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4314), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [53409] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4317), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1496), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53503] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(4250), 1,
      sym_type_annotation,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53613] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4321), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1497), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [53707] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [53791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      anon_sym_extends,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3650), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3641), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [53849] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4205), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [53917] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3939), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54021] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4323), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(4319), 1,
      sym_type_annotation,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54131] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4325), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1513), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54225] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54305] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3945), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3041), 1,
      anon_sym_QMARK,
    ACTIONS(3037), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54465] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    STATE(2260), 1,
      sym_override_modifier,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [54547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LT,
    STATE(1672), 1,
      sym_type_arguments,
    ACTIONS(3395), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3397), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54601] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [54695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1990), 1,
      anon_sym_extends,
    ACTIONS(3597), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1348), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54753] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [54849] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4205), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [54925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_LT,
    ACTIONS(3799), 1,
      anon_sym_DOT,
    STATE(1641), 1,
      sym_type_arguments,
    ACTIONS(3289), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2995), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [54981] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [55069] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3712), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55173] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [55265] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3712), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [55369] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3880), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55473] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3924), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [55577] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(2640), 1,
      anon_sym_DASH,
    ACTIONS(3141), 1,
      anon_sym_LBRACK,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4054), 1,
      anon_sym_STAR,
    ACTIONS(4058), 1,
      anon_sym_async,
    ACTIONS(4062), 1,
      anon_sym_AT,
    ACTIONS(4064), 1,
      anon_sym_static,
    ACTIONS(4066), 1,
      anon_sym_readonly,
    ACTIONS(4070), 1,
      anon_sym_declare,
    ACTIONS(4072), 1,
      anon_sym_abstract,
    ACTIONS(4327), 1,
      anon_sym_RBRACE,
    STATE(2191), 1,
      sym_method_definition,
    STATE(2217), 1,
      sym_accessibility_modifier,
    STATE(2256), 1,
      sym_override_modifier,
    STATE(3502), 1,
      sym_method_signature,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1482), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2476), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3571), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3131), 10,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [55671] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3880), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [55775] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4205), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [55849] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4050), 1,
      anon_sym_PERCENT,
    ACTIONS(4052), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4138), 1,
      anon_sym_LT,
    ACTIONS(4140), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4142), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4144), 1,
      anon_sym_GT_GT,
    ACTIONS(4148), 1,
      anon_sym_AMP,
    ACTIONS(4150), 1,
      anon_sym_CARET,
    ACTIONS(4152), 1,
      anon_sym_PIPE,
    ACTIONS(4162), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4164), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4045), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4136), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4146), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4154), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4158), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4160), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4156), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3924), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [55953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(4331), 1,
      anon_sym_PIPE,
    ACTIONS(4333), 1,
      anon_sym_extends,
    ACTIONS(3495), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3497), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1354), 1,
      sym__automatic_semicolon,
    ACTIONS(1344), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3579), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3567), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3706), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3591), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3685), 1,
      anon_sym_DOT,
    ACTIONS(3681), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3683), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56359] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3939), 1,
      anon_sym_COMMA,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4176), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56464] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4335), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3711), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(4331), 1,
      anon_sym_PIPE,
    ACTIONS(4333), 1,
      anon_sym_extends,
    ACTIONS(3673), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3675), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3675), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3655), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      sym_regex_flags,
    ACTIONS(4337), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4339), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [56775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [56870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(3611), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3613), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3609), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [56970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3393), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3702), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3483), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3485), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3477), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57166] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(4331), 1,
      anon_sym_PIPE,
    ACTIONS(4333), 1,
      anon_sym_extends,
    ACTIONS(3692), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3694), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57221] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4377), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3473), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LBRACK,
    ACTIONS(3435), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3437), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3397), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57500] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [57575] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3768), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3771), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57685] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3521), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3758), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3525), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1982), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57838] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3548), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57998] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1990), 1,
      anon_sym_extends,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(4228), 1,
      anon_sym_RPAREN,
    ACTIONS(1350), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3904), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1348), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58059] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3896), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3706), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ,
    ACTIONS(3890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58165] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      anon_sym_extends,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(4201), 1,
      anon_sym_RPAREN,
    ACTIONS(3643), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3650), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3915), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3641), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3529), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_extends,
    ACTIONS(3762), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3758), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58334] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3529), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3046), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3706), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58502] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(4391), 1,
      anon_sym_RPAREN,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4389), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58563] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4377), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58636] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3505), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58760] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [58835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3706), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2544), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [58939] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3945), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1992), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1990), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 1,
      anon_sym_LBRACK,
    ACTIONS(4402), 1,
      anon_sym_DOT,
    ACTIONS(4404), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3623), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3625), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [59195] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4406), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3640), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59302] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4408), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3640), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(4413), 1,
      anon_sym_RPAREN,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4410), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59470] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4417), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [59535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3641), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59586] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3059), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3706), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59647] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4420), 1,
      anon_sym_COMMA,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59752] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4420), 1,
      anon_sym_COMMA,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59857] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      anon_sym_extends,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(4426), 1,
      anon_sym_RPAREN,
    ACTIONS(3643), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3650), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4130), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3641), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59918] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3955), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60021] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3939), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60124] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3621), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3583), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60297] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4377), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [60370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1990), 1,
      anon_sym_extends,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(4429), 1,
      anon_sym_RPAREN,
    ACTIONS(1350), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4134), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1348), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60431] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4432), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 17,
      sym__ternary_qmark,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [60502] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60605] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3795), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60708] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4435), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [60775] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4438), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3620), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60882] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4420), 1,
      anon_sym_COMMA,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3888), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3617), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61036] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_EQ,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61093] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3791), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_extends,
    ACTIONS(3677), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61247] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3706), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61304] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3998), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61407] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(4331), 1,
      anon_sym_PIPE,
    ACTIONS(4333), 1,
      anon_sym_extends,
    ACTIONS(3677), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3679), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(3541), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3543), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61564] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [61633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3529), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61733] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4445), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [61836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3521), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [61885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3529), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3521), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3758), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    STATE(1883), 1,
      sym_arguments,
    ACTIONS(3657), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3659), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62046] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62121] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4377), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [62194] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3554), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62301] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3712), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62404] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3880), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62507] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3924), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_extends,
    ACTIONS(4379), 1,
      anon_sym_LBRACK,
    ACTIONS(3435), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3429), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3431), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1988), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1986), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3513), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62763] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3768), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3393), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3595), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2540), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3571), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2548), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3635), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63063] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3493), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63191] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [63284] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LBRACK,
    ACTIONS(3637), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3639), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63402] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63477] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [63564] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [63653] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [63744] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4442), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63817] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3844), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63920] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64017] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(3393), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3771), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64155] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [64222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3509), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64271] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [64344] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64435] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3493), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64573] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [64660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3509), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64709] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_QMARK,
    ACTIONS(3621), 1,
      anon_sym_extends,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_COLON,
    ACTIONS(3650), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4201), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3641), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64772] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3663), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64924] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1990), 1,
      anon_sym_extends,
    ACTIONS(1992), 1,
      anon_sym_QMARK,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(4134), 1,
      anon_sym_COLON,
    ACTIONS(3600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4228), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1348), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [64987] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65082] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [65175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3547), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3551), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3547), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3551), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3555), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3441), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65618] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [65701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3671), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65750] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    ACTIONS(4420), 1,
      anon_sym_COMMA,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65855] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4178), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [65958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3690), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66007] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [66086] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [66183] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4082), 1,
      anon_sym_LT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    STATE(2845), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4454), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [66286] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4456), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [66353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3459), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66402] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3844), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4459), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3570), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(4331), 1,
      anon_sym_PIPE,
    ACTIONS(4333), 1,
      anon_sym_extends,
    ACTIONS(3461), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3463), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66667] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4377), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [66740] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [66809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3463), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66858] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3791), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66961] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3795), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67064] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4461), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [67135] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4019), 1,
      anon_sym_LT,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4025), 1,
      anon_sym_GT_GT,
    ACTIONS(4029), 1,
      anon_sym_AMP,
    ACTIONS(4033), 1,
      anon_sym_PERCENT,
    ACTIONS(4035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4118), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4120), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4122), 1,
      anon_sym_CARET,
    ACTIONS(4124), 1,
      anon_sym_PIPE,
    ACTIONS(4126), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4128), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4011), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4015), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4027), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4039), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4041), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4037), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4178), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [67238] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4464), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [67341] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3860), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3535), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67493] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3939), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67596] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3955), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67699] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4466), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3737), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67806] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4084), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4086), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4088), 1,
      anon_sym_GT_GT,
    ACTIONS(4092), 1,
      anon_sym_AMP,
    ACTIONS(4094), 1,
      anon_sym_CARET,
    ACTIONS(4096), 1,
      anon_sym_PIPE,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4110), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4112), 1,
      sym__ternary_qmark,
    ACTIONS(4440), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4080), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4090), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4106), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4108), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3945), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4104), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67909] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4468), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [67974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3878), 1,
      sym__automatic_semicolon,
    ACTIONS(1346), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1344), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1978), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68076] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3846), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3481), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_AMP,
    ACTIONS(4331), 1,
      anon_sym_PIPE,
    ACTIONS(3696), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3698), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68379] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3924), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68482] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(4471), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(3594), 1,
      aux_sym_array_repeat1,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68589] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3880), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3667), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68741] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3712), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68844] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3998), 3,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3667), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3489), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3667), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3605), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3605), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69192] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(4477), 1,
      anon_sym_RPAREN,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4473), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4475), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3605), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3587), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3575), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1996), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1994), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69596] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4100), 1,
      anon_sym_PERCENT,
    ACTIONS(4102), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4074), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [69671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3501), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3563), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3559), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3539), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      sym_regex_flags,
    ACTIONS(4337), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4339), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70065] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4484), 1,
      anon_sym_static,
    ACTIONS(4486), 1,
      anon_sym_readonly,
    ACTIONS(4488), 1,
      anon_sym_abstract,
    STATE(2238), 1,
      sym_accessibility_modifier,
    STATE(2282), 1,
      sym_override_modifier,
    ACTIONS(4482), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3153), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2746), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [70137] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3955), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70239] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4526), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4529), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4531), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70361] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4533), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [70427] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3896), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3990), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3992), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70529] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3939), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70631] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4536), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [70695] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4539), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3037), 1,
      anon_sym_COLON,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3706), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70855] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4312), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70957] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71059] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3791), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1442), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      sym__automatic_semicolon,
    ACTIONS(1460), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71359] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4541), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [71427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1404), 1,
      sym__automatic_semicolon,
    ACTIONS(1396), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3856), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3858), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3961), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3945), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71625] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(4134), 1,
      anon_sym_of,
    ACTIONS(4544), 1,
      anon_sym_in,
    ACTIONS(1348), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3850), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4301), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4473), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4475), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71833] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4547), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [71991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1440), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1442), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ,
    ACTIONS(4132), 1,
      anon_sym_of,
    ACTIONS(4549), 1,
      anon_sym_in,
    ACTIONS(3890), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_EQ,
    ACTIONS(3084), 1,
      anon_sym_in,
    ACTIONS(3087), 1,
      anon_sym_of,
    ACTIONS(2912), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72197] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [72275] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4552), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4556), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1520), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(4130), 1,
      anon_sym_of,
    ACTIONS(4558), 1,
      anon_sym_in,
    ACTIONS(3641), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1458), 1,
      sym__automatic_semicolon,
    ACTIONS(1450), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1456), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3862), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3864), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_QMARK,
    ACTIONS(3706), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3896), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72691] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [72773] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3712), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72875] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3880), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72977] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    STATE(2260), 1,
      sym_override_modifier,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [73051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3840), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73099] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3998), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3832), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4563), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3943), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3820), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3756), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym_LPAREN,
    ACTIONS(4568), 1,
      anon_sym_COLON,
    ACTIONS(4570), 1,
      anon_sym_LT,
    ACTIONS(4573), 1,
      anon_sym_QMARK,
    ACTIONS(2912), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4389), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73697] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3937), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4563), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3882), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3884), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4561), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4563), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3810), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3812), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74037] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [74131] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4575), 1,
      anon_sym_RBRACE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4577), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4579), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74287] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74391] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3806), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3808), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74593] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4589), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1546), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74799] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4591), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3793), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3791), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74951] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3924), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_EQ,
    ACTIONS(3704), 1,
      anon_sym_QMARK,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3706), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1478), 1,
      sym__automatic_semicolon,
    ACTIONS(1470), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 1,
      sym__automatic_semicolon,
    ACTIONS(1408), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4589), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4587), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4589), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1456), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1546), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4009), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75559] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4541), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [75633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3920), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3922), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [75767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4593), 1,
      sym__automatic_semicolon,
    ACTIONS(1450), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1454), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1456), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75819] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4169), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75921] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4174), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3814), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3816), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3986), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3988), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76119] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [76187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3529), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3854), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3868), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76335] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_QMARK,
    ACTIONS(3521), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3758), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76441] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    ACTIONS(4595), 1,
      anon_sym_SEMI,
    ACTIONS(4597), 1,
      sym__automatic_semicolon,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3984), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76593] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4599), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76747] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [76835] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [76925] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4541), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [76997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3229), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3233), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77045] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(1990), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3600), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1348), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77101] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4601), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77205] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(3621), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3650), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3641), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3963), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3965), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 1,
      sym__automatic_semicolon,
    ACTIONS(1384), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1388), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1390), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 1,
      sym__automatic_semicolon,
    ACTIONS(1558), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1564), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77413] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77481] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4541), 1,
      anon_sym_LT,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [77547] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    ACTIONS(4603), 1,
      anon_sym_SEMI,
    ACTIONS(4605), 1,
      sym__automatic_semicolon,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 1,
      sym__automatic_semicolon,
    ACTIONS(1558), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1564), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77703] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      sym__automatic_semicolon,
    ACTIONS(1384), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1388), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1390), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4410), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77857] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [77925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77973] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4611), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4613), 1,
      anon_sym_LPAREN,
    ACTIONS(4616), 1,
      anon_sym_COLON,
    ACTIONS(4618), 1,
      anon_sym_LT,
    ACTIONS(4621), 1,
      anon_sym_QMARK,
    ACTIONS(3856), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3858), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3951), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3953), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_EQ,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3706), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1564), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78335] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3597), 1,
      anon_sym_LBRACK,
    ACTIONS(4134), 1,
      anon_sym_COLON,
    ACTIONS(3600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1990), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1348), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 1,
      anon_sym_LBRACK,
    ACTIONS(4130), 1,
      anon_sym_COLON,
    ACTIONS(3650), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3621), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3641), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1548), 1,
      sym__automatic_semicolon,
    ACTIONS(1540), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1544), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1546), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      sym__automatic_semicolon,
    ACTIONS(1530), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1414), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78603] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [78671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3870), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3872), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3876), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1474), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1476), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78815] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4623), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78919] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4625), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3789), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3712), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79071] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4627), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3902), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3880), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79221] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3037), 1,
      anon_sym_COLON,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4629), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3911), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3913), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79329] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4633), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3926), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3924), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1390), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3930), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79577] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4635), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79681] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4637), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      sym__automatic_semicolon,
    ACTIONS(1436), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1440), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1442), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79837] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4639), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3781), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3783), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79989] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [80057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4641), 1,
      sym__automatic_semicolon,
    ACTIONS(1396), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1400), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1402), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4480), 1,
      sym_regex_flags,
    ACTIONS(4337), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4339), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80255] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3945), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1464), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4643), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4645), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3949), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80507] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4647), 1,
      anon_sym_RPAREN,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3909), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3957), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3959), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3994), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3996), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80755] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 5,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [80851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      sym__automatic_semicolon,
    ACTIONS(1366), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1370), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1372), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3974), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3976), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80999] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4649), 1,
      anon_sym_RBRACE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1512), 1,
      sym__automatic_semicolon,
    ACTIONS(1504), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1508), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1510), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3978), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3980), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3824), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3828), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81299] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3860), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81401] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3846), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81503] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4114), 1,
      anon_sym_as,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4494), 1,
      anon_sym_LT,
    ACTIONS(4496), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4498), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4500), 1,
      anon_sym_GT_GT,
    ACTIONS(4504), 1,
      anon_sym_AMP,
    ACTIONS(4506), 1,
      anon_sym_CARET,
    ACTIONS(4508), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 1,
      anon_sym_PERCENT,
    ACTIONS(4514), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4522), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4524), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3844), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4043), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4490), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4492), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4502), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4510), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4516), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3844), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81653] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3718), 1,
      anon_sym_LT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3722), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3724), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3726), 1,
      anon_sym_GT_GT,
    ACTIONS(3730), 1,
      anon_sym_AMP,
    ACTIONS(3732), 1,
      anon_sym_CARET,
    ACTIONS(3734), 1,
      anon_sym_PIPE,
    ACTIONS(3738), 1,
      anon_sym_PERCENT,
    ACTIONS(3740), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3748), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(3752), 1,
      sym__ternary_qmark,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3708), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3716), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(3728), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3736), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3744), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3746), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3742), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3836), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81805] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 1,
      anon_sym_extends,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3762), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3758), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3529), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81910] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
  [82005] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [82086] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3844), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82187] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3846), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82288] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4689), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82353] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3924), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82454] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82533] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(4698), 1,
      anon_sym_RBRACE,
    STATE(3616), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3602), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4694), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82602] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4689), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82673] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4708), 1,
      anon_sym_readonly,
    STATE(2267), 1,
      sym_override_modifier,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [82742] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [82831] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [82918] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3880), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83019] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 1,
      anon_sym_extends,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3647), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3650), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3641), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83074] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [83159] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4689), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83232] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3712), 1,
      anon_sym_of,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83333] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3998), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83434] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4720), 1,
      anon_sym_abstract,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4718), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2468), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83499] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4722), 1,
      anon_sym_readonly,
    STATE(2264), 1,
      sym_override_modifier,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4718), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2468), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [83568] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [83661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(1990), 1,
      anon_sym_extends,
    ACTIONS(3597), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3600), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1348), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83716] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [83807] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83884] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4724), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83985] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4726), 1,
      anon_sym_RBRACK,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84086] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4689), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [84153] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4728), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84254] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4730), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [84319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_QMARK,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3768), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84374] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3791), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84475] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4733), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [84544] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3955), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(3393), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3771), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84698] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4736), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [84761] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4178), 1,
      anon_sym_of,
    ACTIONS(4655), 1,
      anon_sym_GT,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    ACTIONS(4739), 1,
      anon_sym_in,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84864] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [84943] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3795), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85044] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3860), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85145] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3939), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85246] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3945), 1,
      anon_sym_of,
    ACTIONS(4657), 1,
      anon_sym_LT,
    ACTIONS(4659), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4661), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4663), 1,
      anon_sym_GT_GT,
    ACTIONS(4667), 1,
      anon_sym_AMP,
    ACTIONS(4669), 1,
      anon_sym_CARET,
    ACTIONS(4671), 1,
      anon_sym_PIPE,
    ACTIONS(4675), 1,
      anon_sym_PERCENT,
    ACTIONS(4677), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4685), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4687), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4653), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4655), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4665), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4673), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4681), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4683), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4679), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85347] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4742), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ,
    ACTIONS(4132), 1,
      anon_sym_COLON,
    ACTIONS(3932), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85501] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4744), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85602] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4746), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3095), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85803] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4748), 1,
      anon_sym_STAR,
    ACTIONS(4750), 1,
      anon_sym_async,
    ACTIONS(4754), 1,
      anon_sym_readonly,
    STATE(2268), 1,
      sym_override_modifier,
    ACTIONS(4752), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4756), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [85872] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4758), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85973] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86052] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(4762), 1,
      anon_sym_RBRACE,
    STATE(3715), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3758), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4760), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86121] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_EQ,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3706), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86243] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4764), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86344] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4377), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86409] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86488] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3521), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3765), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3758), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86541] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3706), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86594] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4211), 1,
      anon_sym_RBRACE,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      sym_regex_flags,
    ACTIONS(4337), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(4339), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86744] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3062), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [86872] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [86951] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4772), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87052] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4347), 1,
      anon_sym_LT,
    ACTIONS(4349), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4351), 1,
      anon_sym_GT_GT,
    ACTIONS(4355), 1,
      anon_sym_AMP,
    ACTIONS(4357), 1,
      anon_sym_CARET,
    ACTIONS(4359), 1,
      anon_sym_PIPE,
    ACTIONS(4363), 1,
      anon_sym_PERCENT,
    ACTIONS(4365), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4396), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4398), 1,
      sym__ternary_qmark,
    ACTIONS(4774), 1,
      anon_sym_COLON,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4343), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4345), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4353), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4361), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4369), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4367), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      anon_sym_EQ,
    ACTIONS(3706), 1,
      anon_sym_extends,
    ACTIONS(3896), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87208] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(2263), 1,
      sym_override_modifier,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87287] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4778), 1,
      anon_sym_STAR,
    ACTIONS(4780), 1,
      anon_sym_async,
    ACTIONS(4784), 1,
      anon_sym_readonly,
    STATE(2270), 1,
      sym_override_modifier,
    ACTIONS(4782), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4786), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2507), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87356] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4790), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      anon_sym_readonly,
    STATE(2258), 1,
      sym_override_modifier,
    ACTIONS(4792), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2404), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87425] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4790), 1,
      anon_sym_async,
    ACTIONS(4798), 1,
      anon_sym_abstract,
    ACTIONS(4792), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2404), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87490] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87560] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4800), 1,
      anon_sym_STAR,
    ACTIONS(4802), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4804), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [87668] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4806), 1,
      anon_sym_STAR,
    ACTIONS(4808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4810), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3002), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [87728] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4814), 1,
      anon_sym_LT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87798] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(3915), 1,
      anon_sym_RBRACK,
    ACTIONS(4130), 1,
      anon_sym_COMMA,
    ACTIONS(3641), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87850] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4814), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3816), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4821), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4824), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [87962] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 1,
      anon_sym_extends,
    ACTIONS(3768), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88014] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(3904), 1,
      anon_sym_RBRACK,
    ACTIONS(4134), 1,
      anon_sym_COMMA,
    ACTIONS(1348), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4827), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4830), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88114] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88172] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 1,
      anon_sym_STAR,
    ACTIONS(4835), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4837), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88232] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4839), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3967), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3969), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88300] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4718), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2468), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88362] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4844), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88422] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4806), 1,
      anon_sym_STAR,
    ACTIONS(4846), 1,
      anon_sym_async,
    ACTIONS(4848), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4850), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2511), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88484] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4852), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4000), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4002), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88548] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      sym_identifier,
    ACTIONS(3229), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3233), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4778), 1,
      anon_sym_STAR,
    ACTIONS(4780), 1,
      anon_sym_async,
    ACTIONS(4782), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4786), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2507), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [88716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      sym_identifier,
    ACTIONS(3229), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3233), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88764] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3909), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4889), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4892), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [88910] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3787), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [88990] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3785), 3,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89084] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_async,
    ACTIONS(4899), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4901), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89146] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4903), 1,
      anon_sym_STAR,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4907), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3012), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89206] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ,
    ACTIONS(3932), 1,
      anon_sym_RBRACK,
    ACTIONS(4132), 1,
      anon_sym_COMMA,
    ACTIONS(3890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89356] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4778), 1,
      anon_sym_STAR,
    ACTIONS(4909), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4911), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2973), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89416] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4748), 1,
      anon_sym_STAR,
    ACTIONS(4913), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4915), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89476] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89534] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1414), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4917), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4920), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1476), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4923), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4926), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89702] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4929), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4931), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89762] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4933), 1,
      anon_sym_STAR,
    ACTIONS(4935), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4937), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89822] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89894] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [89952] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [90028] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90098] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4939), 1,
      anon_sym_STAR,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4943), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90158] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3065), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90218] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90290] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4939), 1,
      anon_sym_STAR,
    ACTIONS(4949), 1,
      anon_sym_async,
    ACTIONS(4951), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4953), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2495), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90352] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4955), 1,
      anon_sym_STAR,
    ACTIONS(4957), 1,
      anon_sym_async,
    ACTIONS(4959), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4961), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90414] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [90502] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4955), 1,
      anon_sym_STAR,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4965), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [90562] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90660] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(4017), 1,
      anon_sym_LBRACK,
    ACTIONS(4021), 1,
      anon_sym_DOT,
    ACTIONS(4023), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4116), 1,
      anon_sym_BANG,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3488), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1921), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90758] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4814), 1,
      anon_sym_LT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [90824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3854), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4967), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4970), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3868), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4973), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4976), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(4979), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4982), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90968] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91066] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91164] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91262] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91320] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(3787), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [91406] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91504] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91602] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(4700), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4987), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3941), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4239), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4264), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4985), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91666] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [91750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    STATE(2499), 1,
      sym_arguments,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3070), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91848] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 1,
      anon_sym_STAR,
    ACTIONS(4989), 1,
      anon_sym_async,
    ACTIONS(4991), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4993), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2409), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91910] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [91968] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92066] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92136] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92208] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3521), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3758), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3760), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92260] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4995), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4997), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2930), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92320] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92378] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4381), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92440] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3899), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3706), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92492] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92564] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4748), 1,
      anon_sym_STAR,
    ACTIONS(4750), 1,
      anon_sym_async,
    ACTIONS(4752), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4756), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92626] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4800), 1,
      anon_sym_STAR,
    ACTIONS(4999), 1,
      anon_sym_async,
    ACTIONS(5001), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5003), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2493), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92688] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92748] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RBRACK,
    ACTIONS(3107), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92870] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [92940] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3896), 1,
      anon_sym_LBRACK,
    ACTIONS(3706), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3899), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2912), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92994] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5005), 1,
      anon_sym_LT,
    STATE(3463), 1,
      sym_type_arguments,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3774), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3776), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [93056] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93154] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93224] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93296] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93394] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93492] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5008), 1,
      anon_sym_STAR,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5012), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93552] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93622] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [93712] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3393), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(2912), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93822] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3710), 1,
      anon_sym_as,
    ACTIONS(3714), 1,
      anon_sym_BANG,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4865), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    ACTIONS(4885), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4887), 1,
      sym__ternary_qmark,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93920] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [93978] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94050] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3787), 1,
      anon_sym_BANG,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4861), 1,
      anon_sym_LT,
    ACTIONS(4863), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4867), 1,
      anon_sym_GT_GT,
    ACTIONS(4871), 1,
      anon_sym_AMP,
    ACTIONS(4873), 1,
      anon_sym_CARET,
    ACTIONS(4875), 1,
      anon_sym_PIPE,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4859), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4869), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4881), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4883), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4879), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(3785), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [94142] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(3385), 1,
      anon_sym_LBRACK,
    ACTIONS(3387), 1,
      anon_sym_DOT,
    ACTIONS(3720), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4814), 1,
      anon_sym_LT,
    ACTIONS(4817), 1,
      anon_sym_PERCENT,
    ACTIONS(4819), 1,
      anon_sym_STAR_STAR,
    STATE(3463), 1,
      sym_type_arguments,
    ACTIONS(3750), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4812), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4877), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1422), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(3787), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3785), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [94214] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94272] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94337] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94392] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5016), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2933), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94502] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3065), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94557] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94612] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 1,
      anon_sym_STAR,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1627), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5024), 1,
      anon_sym_async,
    ACTIONS(5028), 1,
      anon_sym_static,
    ACTIONS(5030), 1,
      anon_sym_readonly,
    ACTIONS(5036), 1,
      anon_sym_override,
    STATE(2244), 1,
      sym_accessibility_modifier,
    STATE(2266), 1,
      sym_override_modifier,
    ACTIONS(5022), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5026), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5032), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5034), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2860), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3939), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(5020), 11,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94689] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2973), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94799] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3012), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94854] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94919] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [94984] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4802), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_EQ,
    ACTIONS(3084), 1,
      anon_sym_in,
    ACTIONS(3087), 1,
      anon_sym_of,
    ACTIONS(2912), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95090] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(2263), 1,
      sym_override_modifier,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_EQ,
    ACTIONS(2912), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2916), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4835), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95318] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4341), 1,
      sym_regex_flags,
    ACTIONS(4337), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(4339), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95420] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95485] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95540] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95605] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4808), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3002), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95660] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_EQ,
    ACTIONS(4130), 1,
      anon_sym_of,
    ACTIONS(4558), 1,
      anon_sym_in,
    ACTIONS(3641), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3645), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95711] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4929), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95813] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [95878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3892), 1,
      anon_sym_EQ,
    ACTIONS(4132), 1,
      anon_sym_of,
    ACTIONS(4549), 1,
      anon_sym_in,
    ACTIONS(3890), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3894), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 1,
      anon_sym_EQ,
    ACTIONS(4134), 1,
      anon_sym_of,
    ACTIONS(4544), 1,
      anon_sym_in,
    ACTIONS(1348), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1352), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96045] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4935), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96100] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5041), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2741), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96155] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2930), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96210] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96310] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5043), 1,
      anon_sym_readonly,
    STATE(2276), 1,
      sym_override_modifier,
    ACTIONS(5041), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2741), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3131), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5045), 1,
      anon_sym_abstract,
    ACTIONS(5041), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2741), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96426] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    STATE(2263), 1,
      sym_override_modifier,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96494] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96558] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96620] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_readonly,
    STATE(2274), 1,
      sym_override_modifier,
    ACTIONS(5018), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3131), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96680] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4720), 1,
      anon_sym_abstract,
    ACTIONS(5018), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96736] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96791] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96848] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96903] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [96958] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97013] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97068] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97123] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97178] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97233] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97288] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97398] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5051), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2779), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97451] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97506] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97561] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97620] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97675] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97736] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5053), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2727), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [97843] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1948), 1,
      anon_sym_type,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    ACTIONS(3187), 1,
      anon_sym_module,
    ACTIONS(5055), 1,
      anon_sym_default,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3286), 1,
      sym_declaration,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [97922] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1677), 1,
      anon_sym_namespace,
    ACTIONS(1683), 1,
      anon_sym_import,
    ACTIONS(1685), 1,
      anon_sym_var,
    ACTIONS(1687), 1,
      anon_sym_let,
    ACTIONS(1689), 1,
      anon_sym_const,
    ACTIONS(1700), 1,
      anon_sym_class,
    ACTIONS(1702), 1,
      anon_sym_async,
    ACTIONS(1704), 1,
      anon_sym_function,
    ACTIONS(1708), 1,
      anon_sym_declare,
    ACTIONS(1712), 1,
      anon_sym_abstract,
    ACTIONS(1714), 1,
      anon_sym_interface,
    ACTIONS(1716), 1,
      anon_sym_enum,
    ACTIONS(1870), 1,
      anon_sym_type,
    ACTIONS(1874), 1,
      anon_sym_module,
    ACTIONS(1876), 1,
      anon_sym_global,
    STATE(632), 1,
      sym_declaration,
    STATE(653), 1,
      sym_internal_module,
    STATE(1150), 1,
      sym_decorator,
    STATE(3183), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [98001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1683), 1,
      anon_sym_import,
    ACTIONS(1685), 1,
      anon_sym_var,
    ACTIONS(1687), 1,
      anon_sym_let,
    ACTIONS(1689), 1,
      anon_sym_const,
    ACTIONS(1700), 1,
      anon_sym_class,
    ACTIONS(1702), 1,
      anon_sym_async,
    ACTIONS(1704), 1,
      anon_sym_function,
    ACTIONS(1712), 1,
      anon_sym_abstract,
    ACTIONS(1714), 1,
      anon_sym_interface,
    ACTIONS(1716), 1,
      anon_sym_enum,
    ACTIONS(1870), 1,
      anon_sym_type,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1902), 1,
      anon_sym_declare,
    ACTIONS(1904), 1,
      anon_sym_module,
    ACTIONS(5057), 1,
      anon_sym_default,
    STATE(653), 1,
      sym_internal_module,
    STATE(670), 1,
      sym_declaration,
    STATE(1150), 1,
      sym_decorator,
    STATE(3183), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [98080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5059), 1,
      anon_sym_LPAREN,
    ACTIONS(5061), 1,
      anon_sym_DOT,
    STATE(2249), 1,
      sym_arguments,
    ACTIONS(3091), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3089), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98221] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1683), 1,
      anon_sym_import,
    ACTIONS(1685), 1,
      anon_sym_var,
    ACTIONS(1687), 1,
      anon_sym_let,
    ACTIONS(1689), 1,
      anon_sym_const,
    ACTIONS(1700), 1,
      anon_sym_class,
    ACTIONS(1702), 1,
      anon_sym_async,
    ACTIONS(1704), 1,
      anon_sym_function,
    ACTIONS(1712), 1,
      anon_sym_abstract,
    ACTIONS(1714), 1,
      anon_sym_interface,
    ACTIONS(1716), 1,
      anon_sym_enum,
    ACTIONS(1870), 1,
      anon_sym_type,
    ACTIONS(1876), 1,
      anon_sym_global,
    ACTIONS(1898), 1,
      anon_sym_namespace,
    ACTIONS(1902), 1,
      anon_sym_declare,
    ACTIONS(1936), 1,
      anon_sym_module,
    STATE(632), 1,
      sym_declaration,
    STATE(653), 1,
      sym_internal_module,
    STATE(1150), 1,
      sym_decorator,
    STATE(3183), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [98300] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1948), 1,
      anon_sym_type,
    ACTIONS(1950), 1,
      anon_sym_namespace,
    ACTIONS(1952), 1,
      anon_sym_import,
    ACTIONS(1954), 1,
      anon_sym_var,
    ACTIONS(1956), 1,
      anon_sym_let,
    ACTIONS(1958), 1,
      anon_sym_const,
    ACTIONS(1960), 1,
      anon_sym_class,
    ACTIONS(1962), 1,
      anon_sym_async,
    ACTIONS(1964), 1,
      anon_sym_function,
    ACTIONS(1966), 1,
      anon_sym_declare,
    ACTIONS(1968), 1,
      anon_sym_module,
    ACTIONS(1970), 1,
      anon_sym_abstract,
    ACTIONS(1972), 1,
      anon_sym_global,
    ACTIONS(1974), 1,
      anon_sym_interface,
    ACTIONS(1976), 1,
      anon_sym_enum,
    STATE(1150), 1,
      sym_decorator,
    STATE(3235), 1,
      aux_sym_export_statement_repeat1,
    STATE(3270), 1,
      sym_internal_module,
    STATE(3277), 1,
      sym_declaration,
    STATE(3268), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [98379] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1677), 1,
      anon_sym_namespace,
    ACTIONS(1683), 1,
      anon_sym_import,
    ACTIONS(1685), 1,
      anon_sym_var,
    ACTIONS(1687), 1,
      anon_sym_let,
    ACTIONS(1689), 1,
      anon_sym_const,
    ACTIONS(1700), 1,
      anon_sym_class,
    ACTIONS(1702), 1,
      anon_sym_async,
    ACTIONS(1704), 1,
      anon_sym_function,
    ACTIONS(1708), 1,
      anon_sym_declare,
    ACTIONS(1710), 1,
      anon_sym_module,
    ACTIONS(1712), 1,
      anon_sym_abstract,
    ACTIONS(1714), 1,
      anon_sym_interface,
    ACTIONS(1716), 1,
      anon_sym_enum,
    ACTIONS(1870), 1,
      anon_sym_type,
    ACTIONS(5063), 1,
      anon_sym_default,
    STATE(653), 1,
      sym_internal_module,
    STATE(670), 1,
      sym_declaration,
    STATE(1150), 1,
      sym_decorator,
    STATE(3183), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [98458] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5065), 1,
      anon_sym_STAR,
    ACTIONS(5067), 1,
      anon_sym_async,
    ACTIONS(5071), 1,
      anon_sym_readonly,
    STATE(2269), 1,
      sym_override_modifier,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5073), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 15,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98521] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(1677), 1,
      anon_sym_namespace,
    ACTIONS(1683), 1,
      anon_sym_import,
    ACTIONS(1685), 1,
      anon_sym_var,
    ACTIONS(1687), 1,
      anon_sym_let,
    ACTIONS(1689), 1,
      anon_sym_const,
    ACTIONS(1700), 1,
      anon_sym_class,
    ACTIONS(1702), 1,
      anon_sym_async,
    ACTIONS(1704), 1,
      anon_sym_function,
    ACTIONS(1708), 1,
      anon_sym_declare,
    ACTIONS(1710), 1,
      anon_sym_module,
    ACTIONS(1712), 1,
      anon_sym_abstract,
    ACTIONS(1714), 1,
      anon_sym_interface,
    ACTIONS(1716), 1,
      anon_sym_enum,
    ACTIONS(1870), 1,
      anon_sym_type,
    ACTIONS(5075), 1,
      anon_sym_default,
    STATE(653), 1,
      sym_internal_module,
    STATE(670), 1,
      sym_declaration,
    STATE(1150), 1,
      sym_decorator,
    STATE(3183), 1,
      aux_sym_export_statement_repeat1,
    STATE(651), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [98600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5077), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3119), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5081), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5085), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5089), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98800] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5093), 1,
      anon_sym_EQ_GT,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [98852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5095), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5099), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5103), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [98972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5107), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99012] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5111), 1,
      anon_sym_STAR,
    ACTIONS(5113), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2960), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5117), 1,
      sym__automatic_semicolon,
    ACTIONS(1486), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1488), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1490), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1492), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99148] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5119), 1,
      anon_sym_STAR,
    ACTIONS(5121), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5123), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2978), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5127), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5125), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5131), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5135), 1,
      sym__automatic_semicolon,
    ACTIONS(1344), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1346), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99370] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5111), 1,
      anon_sym_STAR,
    ACTIONS(5137), 1,
      anon_sym_async,
    ACTIONS(5113), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2960), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1615), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1613), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5107), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5139), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5143), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5147), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5153), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5151), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5155), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5103), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5077), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99790] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5065), 1,
      anon_sym_STAR,
    ACTIONS(5067), 1,
      anon_sym_async,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5073), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5065), 1,
      anon_sym_STAR,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5073), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1486), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(1488), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [99940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5159), 1,
      anon_sym_STAR,
    ACTIONS(5161), 1,
      anon_sym_async,
    ACTIONS(5163), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5165), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [99996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5089), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [100036] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5159), 1,
      anon_sym_STAR,
    ACTIONS(5163), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5165), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5147), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [100130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5131), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [100170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5139), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [100210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5081), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [100250] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5167), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3051), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100348] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4790), 1,
      anon_sym_async,
    ACTIONS(5169), 1,
      anon_sym_static,
    ACTIONS(5171), 1,
      anon_sym_readonly,
    ACTIONS(5173), 1,
      anon_sym_abstract,
    STATE(2258), 1,
      sym_override_modifier,
    ACTIONS(4792), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2404), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100411] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4802), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3065), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100509] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4835), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100558] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5163), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100607] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100656] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100705] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3002), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100803] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5121), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2978), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100852] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3012), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100901] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100950] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5113), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2960), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [100999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(2973), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101048] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3032), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5177), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3004), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4935), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101244] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5179), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101293] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5181), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101343] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5185), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101393] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5187), 1,
      anon_sym_static,
    ACTIONS(5189), 1,
      anon_sym_readonly,
    ACTIONS(5191), 1,
      anon_sym_abstract,
    STATE(2274), 1,
      sym_override_modifier,
    ACTIONS(5018), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2538), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [101487] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    ACTIONS(5193), 1,
      anon_sym_static,
    STATE(2260), 1,
      sym_override_modifier,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5195), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101597] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5197), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4257), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5199), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [101685] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(5201), 1,
      anon_sym_static,
    STATE(2263), 1,
      sym_override_modifier,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101745] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3155), 1,
      anon_sym_override,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4708), 1,
      anon_sym_readonly,
    ACTIONS(5203), 1,
      anon_sym_static,
    STATE(2267), 1,
      sym_override_modifier,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 14,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101805] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5205), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2542), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [101893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5207), 1,
      anon_sym_RBRACE,
    STATE(3613), 1,
      sym_enum_assignment,
    ACTIONS(5209), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3136), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [101943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3127), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [101981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(2546), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [102019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3089), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_abstract,
  [102057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5211), 1,
      anon_sym_RBRACE,
    STATE(3546), 1,
      sym_enum_assignment,
    ACTIONS(5213), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3106), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102107] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5215), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102157] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5217), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102207] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5219), 1,
      anon_sym_RBRACE,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102257] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4788), 1,
      anon_sym_STAR,
    ACTIONS(4790), 1,
      anon_sym_async,
    ACTIONS(4794), 1,
      anon_sym_readonly,
    ACTIONS(4792), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4796), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2404), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102310] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    STATE(3809), 1,
      sym_enum_assignment,
    ACTIONS(5183), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3441), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102357] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4712), 1,
      anon_sym_STAR,
    ACTIONS(4714), 1,
      anon_sym_async,
    ACTIONS(4722), 1,
      anon_sym_readonly,
    ACTIONS(4716), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4718), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2468), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102410] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4702), 1,
      anon_sym_STAR,
    ACTIONS(4704), 1,
      anon_sym_async,
    ACTIONS(4708), 1,
      anon_sym_readonly,
    ACTIONS(4706), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4710), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102463] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4748), 1,
      anon_sym_STAR,
    ACTIONS(4750), 1,
      anon_sym_async,
    ACTIONS(4754), 1,
      anon_sym_readonly,
    ACTIONS(4752), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4756), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102516] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_readonly,
    ACTIONS(5221), 1,
      anon_sym_STAR,
    ACTIONS(5223), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5225), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2483), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102567] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5227), 1,
      anon_sym_STAR,
    ACTIONS(5231), 1,
      anon_sym_readonly,
    ACTIONS(5229), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5233), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2405), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102618] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5065), 1,
      anon_sym_STAR,
    ACTIONS(5067), 1,
      anon_sym_async,
    ACTIONS(5071), 1,
      anon_sym_readonly,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5073), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4955), 1,
      anon_sym_STAR,
    ACTIONS(4957), 1,
      anon_sym_async,
    ACTIONS(5235), 1,
      anon_sym_readonly,
    ACTIONS(4959), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4961), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2479), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1635), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1633), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(1940), 1,
      anon_sym_async,
    ACTIONS(1942), 1,
      anon_sym_readonly,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4692), 1,
      anon_sym_STAR,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1944), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102816] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4778), 1,
      anon_sym_STAR,
    ACTIONS(4780), 1,
      anon_sym_async,
    ACTIONS(4784), 1,
      anon_sym_readonly,
    ACTIONS(4782), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4786), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2507), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102869] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4895), 1,
      anon_sym_STAR,
    ACTIONS(4897), 1,
      anon_sym_async,
    ACTIONS(5237), 1,
      anon_sym_readonly,
    ACTIONS(4899), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4901), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102922] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5159), 1,
      anon_sym_STAR,
    ACTIONS(5161), 1,
      anon_sym_async,
    ACTIONS(5239), 1,
      anon_sym_readonly,
    ACTIONS(5163), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5165), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [102975] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4806), 1,
      anon_sym_STAR,
    ACTIONS(4846), 1,
      anon_sym_async,
    ACTIONS(5241), 1,
      anon_sym_readonly,
    ACTIONS(4848), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4850), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2511), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103028] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4183), 1,
      anon_sym_STAR,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(4189), 1,
      anon_sym_async,
    ACTIONS(4193), 1,
      anon_sym_readonly,
    ACTIONS(4191), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4195), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2512), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 16,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103081] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5113), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2960), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103125] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5069), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103169] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5043), 1,
      anon_sym_readonly,
    ACTIONS(5041), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2741), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5243), 1,
      anon_sym_readonly,
    ACTIONS(5053), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2727), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5016), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2933), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5053), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2727), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4913), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3093), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4945), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3065), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4905), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3012), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103525] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5049), 1,
      anon_sym_readonly,
    ACTIONS(5018), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103571] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5018), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2704), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5121), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2978), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103659] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4842), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2946), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103703] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5167), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3051), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103747] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4941), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3025), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(1932), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3022), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103835] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5010), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3036), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4935), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3053), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103923] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(4187), 1,
      anon_sym_LBRACK,
    ACTIONS(5041), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2741), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3131), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [103967] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5163), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2948), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4835), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2995), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104055] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5177), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3004), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104099] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5179), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3041), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4995), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2930), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4802), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3055), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5014), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2974), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4375), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3057), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(5175), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3032), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4929), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2928), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4808), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3002), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104451] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(4373), 1,
      anon_sym_LBRACK,
    ACTIONS(4909), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(2973), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1938), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5245), 1,
      sym_identifier,
    STATE(4100), 1,
      sym_mapped_type_clause,
    ACTIONS(5247), 19,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
  [104526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3489), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104552] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5251), 1,
      anon_sym_EQ,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5255), 1,
      anon_sym_COMMA,
    ACTIONS(5257), 1,
      anon_sym_COLON,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5261), 1,
      anon_sym_GT,
    ACTIONS(5264), 1,
      anon_sym_SLASH,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      anon_sym_extends,
    STATE(2769), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2788), 1,
      sym_type_arguments,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3483), 1,
      sym_constraint,
    STATE(3952), 1,
      sym_default_type,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104608] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5251), 1,
      anon_sym_EQ,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5255), 1,
      anon_sym_COMMA,
    ACTIONS(5257), 1,
      anon_sym_COLON,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5261), 1,
      anon_sym_GT,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5270), 1,
      anon_sym_extends,
    ACTIONS(5272), 1,
      anon_sym_SLASH,
    STATE(2693), 1,
      sym_type_arguments,
    STATE(2787), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3483), 1,
      sym_constraint,
    STATE(3952), 1,
      sym_default_type,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [104664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3667), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3667), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_EQ,
    ACTIONS(5274), 1,
      anon_sym_LT,
    ACTIONS(5276), 1,
      anon_sym_DOT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [104748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3702), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3571), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3667), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3493), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3605), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3509), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3493), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3605), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3441), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [104982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3509), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3605), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3555), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3481), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3489), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(5278), 1,
      anon_sym_LBRACK,
    ACTIONS(5280), 1,
      anon_sym_DOT,
    ACTIONS(5282), 1,
      anon_sym_QMARK_DOT,
    STATE(2351), 1,
      sym_arguments,
    ACTIONS(3409), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3411), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105148] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5286), 1,
      anon_sym_DOT,
    ACTIONS(5288), 1,
      anon_sym_QMARK_DOT,
    STATE(2353), 1,
      sym_arguments,
    ACTIONS(3419), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3421), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_EQ,
    ACTIONS(3505), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_implements,
  [105210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3587), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3441), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_EQ,
    ACTIONS(3617), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_implements,
  [105288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_EQ,
    ACTIONS(3535), 17,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_implements,
  [105314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3555), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3489), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105366] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3017), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3007), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105428] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_EQ,
    ACTIONS(5274), 1,
      anon_sym_LT,
    ACTIONS(5276), 1,
      anon_sym_DOT,
    ACTIONS(5290), 1,
      anon_sym_is,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [105462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3501), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3551), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3547), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3551), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3587), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3587), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3575), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3539), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3539), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3539), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3547), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5292), 1,
      anon_sym_LBRACK,
    ACTIONS(5294), 1,
      anon_sym_DOT,
    ACTIONS(5296), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3623), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3625), 12,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 1,
      anon_sym_DOT,
    ACTIONS(3681), 1,
      anon_sym_EQ,
    ACTIONS(3683), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [105832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3483), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3485), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_EQ,
    ACTIONS(5274), 1,
      anon_sym_LT,
    STATE(2387), 1,
      sym_type_arguments,
    ACTIONS(3397), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [105886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3477), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3473), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [105936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 1,
      anon_sym_PIPE,
    ACTIONS(1522), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 1,
      anon_sym_PIPE,
    ACTIONS(1568), 15,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [105984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_EQ,
    ACTIONS(3583), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_EQ,
    ACTIONS(3521), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106030] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    ACTIONS(3419), 1,
      anon_sym_PIPE,
    ACTIONS(5298), 1,
      anon_sym_LBRACK,
    ACTIONS(5300), 1,
      anon_sym_DOT,
    ACTIONS(5302), 1,
      anon_sym_QMARK_DOT,
    STATE(2498), 1,
      sym_arguments,
    ACTIONS(3421), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5304), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 1,
      anon_sym_EQ,
    ACTIONS(3459), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    ACTIONS(3011), 1,
      anon_sym_LBRACK,
    ACTIONS(3013), 1,
      anon_sym_DOT,
    ACTIONS(3015), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3017), 1,
      anon_sym_PIPE,
    STATE(2499), 1,
      sym_arguments,
    ACTIONS(3007), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_EQ,
    ACTIONS(3591), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_EQ,
    ACTIONS(3567), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_EQ,
    ACTIONS(3579), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_EQ,
    ACTIONS(5290), 1,
      anon_sym_is,
    ACTIONS(3393), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5306), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5308), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_EQ,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_EQ,
    ACTIONS(3595), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_EQ,
    ACTIONS(3397), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_EQ,
    ACTIONS(3621), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_EQ,
    ACTIONS(3563), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5312), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 1,
      anon_sym_EQ,
    ACTIONS(3671), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_EQ,
    ACTIONS(3609), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    ACTIONS(3409), 1,
      anon_sym_PIPE,
    ACTIONS(5314), 1,
      anon_sym_LBRACK,
    ACTIONS(5316), 1,
      anon_sym_DOT,
    ACTIONS(5318), 1,
      anon_sym_QMARK_DOT,
    STATE(2502), 1,
      sym_arguments,
    ACTIONS(3411), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      anon_sym_EQ,
    ACTIONS(3513), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3429), 1,
      anon_sym_EQ,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3431), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [106566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_EQ,
    ACTIONS(3635), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5320), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_EQ,
    ACTIONS(1550), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_EQ,
    ACTIONS(3706), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5322), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 1,
      anon_sym_EQ,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(3639), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 1,
      anon_sym_EQ,
    ACTIONS(3663), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_EQ,
    ACTIONS(3393), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_EQ,
    ACTIONS(3463), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_EQ,
    ACTIONS(3690), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_EQ,
    ACTIONS(3655), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(3525), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 1,
      anon_sym_EQ,
    ACTIONS(3675), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106884] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_PIPE,
    ACTIONS(5326), 1,
      anon_sym_LT,
    ACTIONS(5328), 1,
      anon_sym_DOT,
    ACTIONS(5330), 1,
      anon_sym_is,
    STATE(2613), 1,
      sym_type_arguments,
    ACTIONS(2995), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [106915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 1,
      anon_sym_EQ,
    ACTIONS(3559), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [106938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5332), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5336), 1,
      sym_number,
    STATE(4257), 1,
      sym_predefined_type,
    STATE(4258), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [106989] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5338), 1,
      sym_number,
    STATE(4172), 1,
      sym_predefined_type,
    STATE(4173), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107019] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5340), 1,
      sym_number,
    STATE(4095), 1,
      sym_predefined_type,
    STATE(4141), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(3543), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [107073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5344), 1,
      sym_number,
    STATE(4364), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3495), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(3497), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [107129] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5354), 1,
      anon_sym_BANG,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5360), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2939), 1,
      sym__call_signature,
    STATE(3141), 1,
      sym_type_annotation,
    STATE(3679), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5352), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107171] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5354), 1,
      anon_sym_BANG,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5362), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3141), 1,
      sym_type_annotation,
    STATE(3646), 1,
      sym__call_signature,
    STATE(3650), 1,
      sym__initializer,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5352), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(3463), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [107241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5364), 1,
      sym_number,
    STATE(4254), 1,
      sym_predefined_type,
    STATE(4255), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107271] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5366), 1,
      sym_number,
    STATE(4260), 1,
      sym_predefined_type,
    STATE(4262), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107301] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5370), 1,
      anon_sym_BANG,
    ACTIONS(5372), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3021), 1,
      sym__call_signature,
    STATE(3228), 1,
      sym_type_annotation,
    STATE(3714), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5368), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [107343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5374), 1,
      sym_number,
    STATE(4266), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107371] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5376), 1,
      sym_number,
    STATE(4207), 1,
      sym_string,
    STATE(4267), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107401] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5378), 1,
      sym_number,
    STATE(4275), 1,
      sym_predefined_type,
    STATE(4276), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5380), 1,
      sym_number,
    STATE(4272), 1,
      sym_predefined_type,
    STATE(4281), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5382), 1,
      sym_number,
    STATE(4286), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(3675), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [107517] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_PIPE,
    ACTIONS(5326), 1,
      anon_sym_LT,
    ACTIONS(5328), 1,
      anon_sym_DOT,
    STATE(2613), 1,
      sym_type_arguments,
    ACTIONS(2995), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 1,
      anon_sym_extends,
    ACTIONS(5274), 1,
      anon_sym_LT,
    ACTIONS(5276), 1,
      anon_sym_DOT,
    ACTIONS(5388), 1,
      anon_sym_GT,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(5384), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5386), 2,
      anon_sym_LBRACE,
      sym_jsx_identifier,
    ACTIONS(2995), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [107579] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5391), 1,
      sym_number,
    STATE(4189), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107607] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5393), 1,
      sym_number,
    STATE(4371), 1,
      sym_predefined_type,
    STATE(4372), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5395), 1,
      sym_number,
    STATE(4127), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [107665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 1,
      anon_sym_PIPE,
    ACTIONS(3702), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_PIPE,
    ACTIONS(3571), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3493), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(3509), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3491), 1,
      anon_sym_PIPE,
    ACTIONS(3493), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3507), 1,
      anon_sym_PIPE,
    ACTIONS(3509), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 1,
      anon_sym_PIPE,
    ACTIONS(3547), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 1,
      anon_sym_PIPE,
    ACTIONS(3551), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3545), 1,
      anon_sym_PIPE,
    ACTIONS(3547), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3549), 1,
      anon_sym_PIPE,
    ACTIONS(3551), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_PIPE,
    ACTIONS(3555), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PIPE,
    ACTIONS(3441), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_PIPE,
    ACTIONS(3555), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_PIPE,
    ACTIONS(3441), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [107973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5397), 1,
      sym_number,
    STATE(4186), 1,
      sym_predefined_type,
    STATE(4187), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108003] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5399), 1,
      sym_number,
    STATE(4376), 1,
      sym_predefined_type,
    STATE(4383), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108033] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5401), 1,
      sym_number,
    STATE(4182), 1,
      sym_predefined_type,
    STATE(4183), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5403), 1,
      sym_number,
    STATE(4179), 1,
      sym_predefined_type,
    STATE(4180), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108093] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5405), 1,
      sym_number,
    STATE(4115), 1,
      sym_string,
    STATE(4116), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108123] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5407), 1,
      sym_number,
    STATE(4111), 1,
      sym_string,
    STATE(4113), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5409), 1,
      sym_number,
    STATE(4130), 1,
      sym_string,
    STATE(4131), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(3694), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [108211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5411), 1,
      sym_number,
    STATE(4178), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(3698), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [108265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_PIPE,
    ACTIONS(3481), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_PIPE,
    ACTIONS(3489), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_PIPE,
    ACTIONS(3489), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3487), 1,
      anon_sym_PIPE,
    ACTIONS(3489), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3499), 1,
      anon_sym_PIPE,
    ACTIONS(3501), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      anon_sym_PIPE,
    ACTIONS(3539), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      anon_sym_PIPE,
    ACTIONS(3539), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3537), 1,
      anon_sym_PIPE,
    ACTIONS(3539), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5413), 1,
      sym_number,
    STATE(4226), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5415), 1,
      sym_number,
    STATE(4168), 1,
      sym_predefined_type,
    STATE(4170), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108543] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5417), 1,
      sym_number,
    STATE(4106), 1,
      sym_string,
    STATE(4107), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3573), 1,
      anon_sym_PIPE,
    ACTIONS(3575), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    ACTIONS(3587), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    ACTIONS(3587), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    ACTIONS(3587), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_PIPE,
    ACTIONS(3605), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_PIPE,
    ACTIONS(3605), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3603), 1,
      anon_sym_PIPE,
    ACTIONS(3605), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      anon_sym_PIPE,
    ACTIONS(3667), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      anon_sym_PIPE,
    ACTIONS(3667), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3665), 1,
      anon_sym_PIPE,
    ACTIONS(3667), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [108793] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5421), 1,
      anon_sym_BANG,
    ACTIONS(5423), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2969), 1,
      sym__call_signature,
    STATE(3164), 1,
      sym_type_annotation,
    STATE(3701), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5419), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [108835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5425), 1,
      sym_number,
    STATE(4102), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5427), 1,
      sym_number,
    STATE(4163), 1,
      sym_predefined_type,
    STATE(4164), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108893] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5429), 1,
      sym_number,
    STATE(4157), 1,
      sym_string,
    STATE(4206), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108923] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5431), 1,
      sym_number,
    STATE(4213), 1,
      sym_predefined_type,
    STATE(4214), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108953] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5433), 1,
      sym_number,
    STATE(4388), 1,
      sym_predefined_type,
    STATE(4389), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [108983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5435), 1,
      sym_number,
    STATE(4216), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5437), 1,
      sym_number,
    STATE(4133), 1,
      sym_string,
    STATE(4134), 1,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109041] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5441), 1,
      anon_sym_BANG,
    ACTIONS(5443), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2923), 1,
      sym__call_signature,
    STATE(3101), 1,
      sym_type_annotation,
    STATE(3519), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5439), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5445), 1,
      sym_number,
    STATE(4392), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5447), 1,
      sym_number,
    STATE(4223), 1,
      sym_predefined_type,
    STATE(4224), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109141] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5451), 1,
      anon_sym_BANG,
    ACTIONS(5453), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2998), 1,
      sym__call_signature,
    STATE(3190), 1,
      sym_type_annotation,
    STATE(3778), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109183] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5455), 1,
      sym_number,
    STATE(4209), 1,
      sym_predefined_type,
    STATE(4210), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_EQ,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(3613), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [109237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5457), 1,
      sym_number,
    STATE(4217), 1,
      sym_predefined_type,
    STATE(4218), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109267] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5421), 1,
      anon_sym_BANG,
    ACTIONS(5459), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3164), 1,
      sym_type_annotation,
    STATE(3730), 1,
      sym__call_signature,
    STATE(3731), 1,
      sym__initializer,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5419), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [109309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5461), 1,
      sym_number,
    STATE(4220), 1,
      sym_predefined_type,
    STATE(4221), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5463), 1,
      sym_number,
    STATE(4360), 1,
      sym_predefined_type,
    STATE(4362), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109369] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5465), 1,
      sym_number,
    STATE(4353), 1,
      sym_predefined_type,
    STATE(4354), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109399] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5467), 1,
      sym_number,
    STATE(4356), 1,
      sym_predefined_type,
    STATE(4358), 1,
      sym_string,
    ACTIONS(5334), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [109429] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5471), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2892), 1,
      sym__call_signature,
    STATE(3240), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5469), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109464] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5475), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2883), 1,
      sym__call_signature,
    STATE(3207), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109499] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5479), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3146), 1,
      sym__call_signature,
    STATE(3147), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109534] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5483), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3170), 1,
      sym__call_signature,
    STATE(3171), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5481), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109569] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_SLASH,
    STATE(2667), 1,
      sym_type_arguments,
    STATE(2692), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [109610] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5493), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2897), 1,
      sym__call_signature,
    STATE(3254), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5491), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      anon_sym_LPAREN,
    ACTIONS(5497), 1,
      anon_sym_LBRACK,
    ACTIONS(5499), 1,
      anon_sym_DOT,
    ACTIONS(5501), 1,
      anon_sym_QMARK_DOT,
    STATE(2605), 1,
      sym_arguments,
    ACTIONS(3007), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5503), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3253), 1,
      sym__call_signature,
    STATE(3254), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5491), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [109709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      anon_sym_LPAREN,
    ACTIONS(5505), 1,
      anon_sym_LBRACK,
    ACTIONS(5507), 1,
      anon_sym_DOT,
    ACTIONS(5509), 1,
      anon_sym_QMARK_DOT,
    STATE(2606), 1,
      sym_arguments,
    ACTIONS(3421), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_LT,
    ACTIONS(5513), 1,
      anon_sym_DOT,
    ACTIONS(5515), 1,
      anon_sym_is,
    STATE(2784), 1,
      sym_type_arguments,
    ACTIONS(2995), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3475), 1,
      anon_sym_PIPE,
    ACTIONS(3477), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3471), 1,
      anon_sym_PIPE,
    ACTIONS(3473), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_PIPE,
    ACTIONS(2540), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_PIPE,
    ACTIONS(5326), 1,
      anon_sym_LT,
    STATE(2608), 1,
      sym_type_arguments,
    ACTIONS(3397), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3483), 1,
      anon_sym_PIPE,
    ACTIONS(3485), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109874] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      anon_sym_LPAREN,
    ACTIONS(5517), 1,
      anon_sym_LBRACK,
    ACTIONS(5519), 1,
      anon_sym_DOT,
    ACTIONS(5521), 1,
      anon_sym_QMARK_DOT,
    STATE(2621), 1,
      sym_arguments,
    ACTIONS(3411), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [109903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_PIPE,
    ACTIONS(2548), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_PIPE,
    ACTIONS(2544), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [109945] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5523), 1,
      anon_sym_SLASH,
    STATE(2669), 1,
      sym_type_arguments,
    STATE(2738), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [109986] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5525), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3206), 1,
      sym__call_signature,
    STATE(3207), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110021] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5527), 1,
      anon_sym_COLON,
    ACTIONS(5529), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2864), 1,
      sym__call_signature,
    STATE(3147), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 1,
      anon_sym_DOT,
    ACTIONS(3681), 1,
      anon_sym_PIPE,
    ACTIONS(3683), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3623), 1,
      anon_sym_PIPE,
    ACTIONS(5531), 1,
      anon_sym_LBRACK,
    ACTIONS(5533), 1,
      anon_sym_DOT,
    ACTIONS(5535), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3625), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110106] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5537), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3239), 1,
      sym__call_signature,
    STATE(3240), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5469), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110141] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5539), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2872), 1,
      sym__call_signature,
    STATE(3171), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5481), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110176] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5264), 1,
      anon_sym_SLASH,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5487), 1,
      anon_sym_GT,
    STATE(2756), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(2788), 1,
      sym_type_arguments,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [110214] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3192), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [110242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_PIPE,
    ACTIONS(5330), 1,
      anon_sym_is,
    ACTIONS(3393), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [110300] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5523), 1,
      anon_sym_SLASH,
    STATE(2669), 1,
      sym_type_arguments,
    STATE(2712), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [110338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3489), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110392] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5272), 1,
      anon_sym_SLASH,
    ACTIONS(5487), 1,
      anon_sym_GT,
    STATE(2693), 1,
      sym_type_arguments,
    STATE(2786), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [110430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110466] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(5274), 1,
      anon_sym_LT,
    ACTIONS(5276), 1,
      anon_sym_DOT,
    ACTIONS(5541), 1,
      anon_sym_QMARK,
    STATE(2379), 1,
      sym_type_arguments,
    STATE(3911), 1,
      sym_type_annotation,
    ACTIONS(2995), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3539), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110514] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2970), 1,
      sym__call_signature,
    STATE(3165), 1,
      sym_type_annotation,
    STATE(3707), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5544), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110550] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2891), 1,
      sym__call_signature,
    STATE(3237), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5546), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3575), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3587), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110672] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3165), 1,
      sym_type_annotation,
    STATE(3728), 1,
      sym__call_signature,
    STATE(3772), 1,
      sym__initializer,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5544), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3605), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110762] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2884), 1,
      sym__call_signature,
    STATE(3209), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5548), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110812] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [110840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110858] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2932), 1,
      sym__call_signature,
    STATE(3143), 1,
      sym_type_annotation,
    STATE(3655), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5550), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3702), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110912] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3174), 1,
      sym__call_signature,
    STATE(3175), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5552), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [110944] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2997), 1,
      sym__call_signature,
    STATE(3189), 1,
      sym_type_annotation,
    STATE(3517), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [110980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3667), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [110998] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_SLASH,
    STATE(2667), 1,
      sym_type_arguments,
    STATE(2691), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [111036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3501), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111054] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3262), 1,
      sym__call_signature,
    STATE(3263), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5556), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_LT,
    ACTIONS(5513), 1,
      anon_sym_DOT,
    STATE(2784), 1,
      sym_type_arguments,
    ACTIONS(2995), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111110] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3189), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [111138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3571), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111156] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2904), 1,
      sym__call_signature,
    STATE(3263), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5556), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111206] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [111234] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2896), 1,
      sym__call_signature,
    STATE(3252), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5558), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3493), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3509), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3547), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111374] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      anon_sym_COMMA,
    ACTIONS(3195), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [111402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3551), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3555), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111456] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3189), 1,
      sym_type_annotation,
    STATE(3763), 1,
      sym__initializer,
    STATE(3764), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111492] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3251), 1,
      sym__call_signature,
    STATE(3252), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5558), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3555), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111560] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3034), 1,
      sym__call_signature,
    STATE(3245), 1,
      sym_type_annotation,
    STATE(3687), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5560), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111596] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2873), 1,
      sym__call_signature,
    STATE(3175), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5552), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111628] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3208), 1,
      sym__call_signature,
    STATE(3209), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5548), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111660] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3014), 1,
      sym__call_signature,
    STATE(3224), 1,
      sym_type_annotation,
    STATE(3516), 1,
      sym__initializer,
    STATE(3959), 1,
      sym_type_parameters,
    ACTIONS(5562), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [111696] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3233), 1,
      sym__call_signature,
    STATE(3237), 1,
      sym_type_annotation,
    STATE(3863), 1,
      sym_type_parameters,
    ACTIONS(5546), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [111728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3395), 1,
      anon_sym_PIPE,
    ACTIONS(3397), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_PIPE,
    ACTIONS(1982), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_PIPE,
    ACTIONS(3505), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111785] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(3694), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [111808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(1978), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [111844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(3698), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1996), 1,
      anon_sym_PIPE,
    ACTIONS(1994), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_PIPE,
    ACTIONS(3563), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3557), 1,
      anon_sym_PIPE,
    ACTIONS(3559), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_PIPE,
    ACTIONS(1550), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3461), 1,
      anon_sym_PIPE,
    ACTIONS(3463), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [111960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(3463), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [111983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3457), 1,
      anon_sym_PIPE,
    ACTIONS(3459), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_PIPE,
    ACTIONS(3690), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3669), 1,
      anon_sym_PIPE,
    ACTIONS(3671), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1988), 1,
      anon_sym_PIPE,
    ACTIONS(1986), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5570), 1,
      anon_sym_LBRACK,
    ACTIONS(5572), 1,
      anon_sym_DOT,
    ACTIONS(5574), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3625), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_PIPE,
    ACTIONS(3609), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_PIPE,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(3613), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_PIPE,
    ACTIONS(3655), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3673), 1,
      anon_sym_PIPE,
    ACTIONS(3675), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(3675), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [112183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3589), 1,
      anon_sym_PIPE,
    ACTIONS(3591), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_PIPE,
    ACTIONS(3535), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3577), 1,
      anon_sym_PIPE,
    ACTIONS(3579), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    ACTIONS(3567), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3473), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3477), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5511), 1,
      anon_sym_LT,
    STATE(2785), 1,
      sym_type_arguments,
    ACTIONS(3397), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 1,
      anon_sym_PIPE,
    ACTIONS(3663), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3637), 1,
      anon_sym_PIPE,
    ACTIONS(5576), 1,
      anon_sym_LBRACK,
    ACTIONS(3639), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_PIPE,
    ACTIONS(3635), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_PIPE,
    ACTIONS(5576), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(3431), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [112430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(3497), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [112453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      anon_sym_PIPE,
    ACTIONS(3513), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3519), 1,
      anon_sym_PIPE,
    ACTIONS(3521), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_PIPE,
    ACTIONS(3529), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3541), 1,
      anon_sym_PIPE,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(3543), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3581), 1,
      anon_sym_PIPE,
    ACTIONS(3583), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_PIPE,
    ACTIONS(3621), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1992), 1,
      anon_sym_PIPE,
    ACTIONS(1990), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 1,
      anon_sym_DOT,
    ACTIONS(3683), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4616), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [112641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_PIPE,
    ACTIONS(3525), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_PIPE,
    ACTIONS(5576), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_PIPE,
    ACTIONS(3393), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 1,
      anon_sym_PIPE,
    ACTIONS(3706), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3593), 1,
      anon_sym_PIPE,
    ACTIONS(3595), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_PIPE,
    ACTIONS(3617), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [112757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [112774] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5578), 1,
      sym_identifier,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    STATE(1912), 1,
      sym_class_body,
    STATE(2849), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3926), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [112808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_LBRACK,
    ACTIONS(3023), 1,
      anon_sym_DOT,
    ACTIONS(3025), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5586), 1,
      anon_sym_LPAREN,
    STATE(2354), 1,
      sym_arguments,
    ACTIONS(3007), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112834] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5590), 1,
      anon_sym_BANG,
    STATE(3389), 1,
      sym_type_annotation,
    STATE(3688), 1,
      sym__initializer,
    ACTIONS(5592), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [112862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5286), 1,
      anon_sym_DOT,
    ACTIONS(5288), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5586), 1,
      anon_sym_LPAREN,
    STATE(2353), 1,
      sym_arguments,
    ACTIONS(3421), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112888] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5594), 1,
      sym_identifier,
    STATE(1912), 1,
      sym_class_body,
    STATE(2849), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3926), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [112922] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5264), 1,
      anon_sym_SLASH,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    STATE(2789), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [112954] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5598), 1,
      anon_sym_LT,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    STATE(1358), 1,
      sym_jsx_closing_element,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [112980] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5604), 1,
      sym_identifier,
    STATE(1912), 1,
      sym_class_body,
    STATE(2849), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3926), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_COLON,
    STATE(3098), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5606), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113034] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5610), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_class_body,
    STATE(2841), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3947), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113068] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5612), 1,
      anon_sym_LT,
    ACTIONS(5614), 1,
      anon_sym_DQUOTE,
    ACTIONS(5616), 1,
      anon_sym_SQUOTE,
    STATE(2665), 1,
      sym_jsx_opening_element,
    STATE(3134), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [113094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5608), 1,
      anon_sym_COLON,
    STATE(3090), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5618), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5612), 1,
      anon_sym_LT,
    ACTIONS(5614), 1,
      anon_sym_DQUOTE,
    ACTIONS(5616), 1,
      anon_sym_SQUOTE,
    STATE(2665), 1,
      sym_jsx_opening_element,
    STATE(3135), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [113140] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5620), 1,
      anon_sym_LT,
    STATE(1929), 1,
      sym_jsx_closing_element,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [113186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5272), 1,
      anon_sym_SLASH,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    STATE(2718), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [113218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5515), 1,
      anon_sym_is,
    ACTIONS(3393), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(5622), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [113258] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5624), 1,
      sym_identifier,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1386), 1,
      sym_class_body,
    STATE(2833), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3810), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113292] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5598), 1,
      anon_sym_LT,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5628), 1,
      sym_jsx_text,
    STATE(1421), 1,
      sym_jsx_closing_element,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2636), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113318] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5630), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_class_body,
    STATE(2841), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3947), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113352] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_SLASH,
    STATE(2694), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [113384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5632), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_class_body,
    STATE(2841), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3947), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5274), 1,
      anon_sym_LT,
    ACTIONS(5276), 1,
      anon_sym_DOT,
    ACTIONS(5634), 1,
      anon_sym_is,
    STATE(2379), 1,
      sym_type_arguments,
    ACTIONS(2995), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113442] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5620), 1,
      anon_sym_LT,
    ACTIONS(5636), 1,
      sym_jsx_text,
    STATE(1918), 1,
      sym_jsx_closing_element,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2643), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5278), 1,
      anon_sym_LBRACK,
    ACTIONS(5280), 1,
      anon_sym_DOT,
    ACTIONS(5282), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5586), 1,
      anon_sym_LPAREN,
    STATE(2351), 1,
      sym_arguments,
    ACTIONS(3411), 5,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113494] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LT,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(3683), 1,
      sym_jsx_closing_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113520] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5590), 1,
      anon_sym_BANG,
    ACTIONS(5640), 1,
      anon_sym_EQ,
    STATE(3123), 1,
      sym__initializer,
    STATE(3389), 1,
      sym_type_annotation,
    ACTIONS(5592), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [113548] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5638), 1,
      anon_sym_LT,
    ACTIONS(5642), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(3675), 1,
      sym_jsx_closing_element,
    STATE(2656), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113574] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5644), 1,
      sym_identifier,
    STATE(1912), 1,
      sym_class_body,
    STATE(2849), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3926), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5646), 1,
      sym_identifier,
    STATE(1328), 1,
      sym_class_body,
    STATE(2898), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3929), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113642] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5648), 1,
      sym_identifier,
    STATE(2025), 1,
      sym_class_body,
    STATE(2911), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3907), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113676] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5523), 1,
      anon_sym_SLASH,
    STATE(2670), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [113708] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_extends,
    ACTIONS(5584), 1,
      anon_sym_implements,
    ACTIONS(5650), 1,
      sym_identifier,
    STATE(1901), 1,
      sym_class_body,
    STATE(2841), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3947), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [113742] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(3387), 1,
      sym_jsx_closing_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113768] = 7,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5652), 1,
      anon_sym_LT,
    ACTIONS(5654), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(3378), 1,
      sym_jsx_closing_element,
    STATE(2664), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113794] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    ACTIONS(5656), 1,
      sym_identifier,
    ACTIONS(5658), 1,
      anon_sym_STAR,
    STATE(3945), 1,
      sym_import_require_clause,
    STATE(4016), 1,
      sym_string,
    STATE(4022), 1,
      sym_import_clause,
    STATE(4348), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [113826] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5660), 1,
      anon_sym_GT,
    ACTIONS(5662), 1,
      anon_sym_SLASH,
    STATE(2678), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [113855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5660), 1,
      anon_sym_GT,
    ACTIONS(5664), 1,
      anon_sym_SLASH,
    STATE(2730), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [113899] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5666), 1,
      anon_sym_GT,
    ACTIONS(5668), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [113928] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5670), 1,
      anon_sym_LT,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113951] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5672), 1,
      anon_sym_LT,
    ACTIONS(5674), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2671), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [113974] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1778), 1,
      sym_class_body,
    STATE(2880), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3949), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [114005] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5523), 1,
      anon_sym_SLASH,
    STATE(2719), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114034] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5680), 1,
      anon_sym_GT,
    ACTIONS(5682), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114063] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(728), 1,
      sym_class_body,
    STATE(2858), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3889), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [114094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1990), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114109] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5680), 1,
      anon_sym_GT,
    ACTIONS(5686), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114138] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5688), 1,
      anon_sym_GT,
    ACTIONS(5690), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3621), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3583), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(3543), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [114214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3529), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3521), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_extends,
    ACTIONS(3497), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [114265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(3431), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3635), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 1,
      anon_sym_LBRACK,
    ACTIONS(3639), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114316] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_extends,
    ACTIONS(3694), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [114337] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(2895), 1,
      sym_type_parameters,
    STATE(3306), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3938), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [114368] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5702), 1,
      anon_sym_GT,
    ACTIONS(5704), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5706), 1,
      anon_sym_GT,
    ACTIONS(5708), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114426] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5660), 1,
      anon_sym_GT,
    ACTIONS(5710), 1,
      anon_sym_SLASH,
    STATE(2747), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114455] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5666), 1,
      anon_sym_GT,
    ACTIONS(5712), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114484] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1732), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [114509] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5714), 1,
      anon_sym_LT,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [114532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3505), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1982), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3525), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5698), 1,
      anon_sym_LBRACK,
    ACTIONS(3437), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3567), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3579), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114639] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3164), 1,
      sym_type_annotation,
    STATE(3709), 1,
      sym__initializer,
    ACTIONS(5421), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5419), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [114664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3591), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114679] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5487), 1,
      anon_sym_GT,
    ACTIONS(5489), 1,
      anon_sym_SLASH,
    STATE(2679), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114708] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_extends,
    ACTIONS(3675), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [114729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3675), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3655), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(3613), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [114776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3609), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114791] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5702), 1,
      anon_sym_GT,
    ACTIONS(5716), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114820] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1899), 1,
      sym_class_body,
    STATE(2836), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3847), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [114851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3617), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3393), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1986), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114896] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_LT,
    ACTIONS(5720), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2696), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [114919] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5666), 1,
      anon_sym_GT,
    ACTIONS(5722), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114948] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5688), 1,
      anon_sym_GT,
    ACTIONS(5724), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [114977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [114992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115007] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1847), 1,
      sym_class_body,
    STATE(2818), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4034), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115038] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1435), 1,
      sym_class_body,
    STATE(2819), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3798), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5726), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [115099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [115114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3228), 1,
      sym_type_annotation,
    STATE(3639), 1,
      sym__initializer,
    ACTIONS(5370), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5368), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115139] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1395), 1,
      sym_class_body,
    STATE(2910), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3996), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115170] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5730), 1,
      anon_sym_LT,
    ACTIONS(5732), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2739), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [115193] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5680), 1,
      anon_sym_GT,
    ACTIONS(5734), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3671), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115252] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1829), 1,
      sym_class_body,
    STATE(2879), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3978), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3459), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_extends,
    ACTIONS(3463), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [115319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3463), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3535), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115349] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5706), 1,
      anon_sym_GT,
    ACTIONS(5736), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115378] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5738), 1,
      anon_sym_LT,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [115401] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(626), 1,
      sym_class_body,
    STATE(2882), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3989), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115432] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3190), 1,
      sym_type_annotation,
    STATE(3771), 1,
      sym__initializer,
    ACTIONS(5451), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5449), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3595), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5688), 1,
      anon_sym_GT,
    ACTIONS(5740), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1734), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [115526] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(162), 1,
      sym_class_body,
    STATE(2869), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4002), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3141), 1,
      sym_type_annotation,
    STATE(3645), 1,
      sym__initializer,
    ACTIONS(5354), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5352), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5680), 1,
      anon_sym_GT,
    ACTIONS(5744), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_COLON,
    STATE(3285), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5606), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3559), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3563), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1994), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [115675] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5272), 1,
      anon_sym_SLASH,
    ACTIONS(5487), 1,
      anon_sym_GT,
    STATE(2777), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115704] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(5748), 1,
      anon_sym_EQ,
    ACTIONS(5622), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [115727] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5750), 1,
      anon_sym_LT,
    ACTIONS(5752), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2770), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [115750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5746), 1,
      anon_sym_COLON,
    STATE(3272), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(5618), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5702), 1,
      anon_sym_GT,
    ACTIONS(5754), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115798] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5756), 1,
      sym_identifier,
    ACTIONS(5759), 1,
      anon_sym_LBRACE,
    ACTIONS(5762), 1,
      anon_sym_GT,
    ACTIONS(5764), 1,
      anon_sym_SLASH,
    ACTIONS(5766), 1,
      sym_jsx_identifier,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [115827] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(149), 1,
      sym_class_body,
    STATE(2827), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3981), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115858] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(2921), 1,
      sym_type_parameters,
    STATE(3325), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4012), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115889] = 6,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5769), 1,
      anon_sym_LBRACE,
    ACTIONS(5772), 1,
      anon_sym_LT,
    ACTIONS(5775), 1,
      sym_jsx_text,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [115912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [115927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [115942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(3698), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [115961] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(660), 1,
      sym_class_body,
    STATE(2887), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4023), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [115992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4768), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [116017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [116042] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5264), 1,
      anon_sym_SLASH,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5487), 1,
      anon_sym_GT,
    STATE(2743), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116071] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1920), 1,
      sym_class_body,
    STATE(2915), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4026), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [116102] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5706), 1,
      anon_sym_GT,
    ACTIONS(5782), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116131] = 6,
    ACTIONS(5596), 1,
      anon_sym_LBRACE,
    ACTIONS(5600), 1,
      sym_jsx_text,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(5784), 1,
      anon_sym_LT,
    STATE(2658), 1,
      sym_jsx_opening_element,
    STATE(2760), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [116154] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4770), 1,
      anon_sym_RBRACE,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [116179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116194] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(2056), 1,
      sym_class_body,
    STATE(2876), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3957), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [116225] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(2874), 1,
      sym_type_parameters,
    STATE(3348), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3923), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [116256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3389), 1,
      sym_type_annotation,
    STATE(3693), 1,
      sym__initializer,
    ACTIONS(5592), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(630), 1,
      sym_class_body,
    STATE(2852), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3817), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [116312] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5688), 1,
      anon_sym_GT,
    ACTIONS(5786), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5788), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [116356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3246), 1,
      sym_type_annotation,
    STATE(3689), 1,
      sym__initializer,
    ACTIONS(5792), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(5790), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4766), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    STATE(3698), 1,
      aux_sym_object_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [116406] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5640), 1,
      anon_sym_EQ,
    STATE(3124), 1,
      sym__initializer,
    STATE(3389), 1,
      sym_type_annotation,
    ACTIONS(5592), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      anon_sym_COMMA,
    ACTIONS(1681), 1,
      anon_sym_RBRACE,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(3608), 1,
      aux_sym_object_repeat1,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [116456] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1764), 1,
      sym_class_body,
    STATE(2894), 1,
      sym_type_parameters,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3812), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [116487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3513), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3663), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116517] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5702), 1,
      anon_sym_GT,
    ACTIONS(5794), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5706), 1,
      anon_sym_GT,
    ACTIONS(5796), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116575] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5660), 1,
      anon_sym_GT,
    ACTIONS(5798), 1,
      anon_sym_SLASH,
    STATE(2675), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5249), 1,
      sym_identifier,
    ACTIONS(5253), 1,
      anon_sym_LBRACE,
    ACTIONS(5266), 1,
      sym_jsx_identifier,
    ACTIONS(5666), 1,
      anon_sym_GT,
    ACTIONS(5800), 1,
      anon_sym_SLASH,
    STATE(2757), 1,
      aux_sym__jsx_start_opening_element_repeat1,
    STATE(3000), 1,
      sym_jsx_namespace_name,
    STATE(3362), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [116633] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(2842), 1,
      sym_type_parameters,
    STATE(3293), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3800), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [116664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym_escape_sequence,
    ACTIONS(5804), 1,
      anon_sym_BQUOTE,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [116702] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5816), 1,
      anon_sym_enum,
    STATE(3450), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [116726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_extends,
    ACTIONS(5622), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    ACTIONS(5820), 1,
      anon_sym_DOT,
    STATE(3353), 1,
      sym_statement_block,
    ACTIONS(1324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116766] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(5590), 1,
      anon_sym_BANG,
    STATE(3389), 1,
      sym_type_annotation,
    STATE(3688), 1,
      sym__initializer,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(5822), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116810] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5566), 1,
      anon_sym_PIPE,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(5824), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116830] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5826), 1,
      sym_escape_sequence,
    ACTIONS(5828), 1,
      anon_sym_BQUOTE,
    STATE(3033), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [116854] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5810), 1,
      sym_identifier,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5830), 1,
      anon_sym_enum,
    STATE(3479), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [116878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym_escape_sequence,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5832), 1,
      anon_sym_BQUOTE,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3316), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [116902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym_escape_sequence,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5834), 1,
      anon_sym_BQUOTE,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [116926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym_escape_sequence,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5836), 1,
      anon_sym_BQUOTE,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [116950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 3,
      anon_sym_while,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1380), 5,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
  [116966] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym_escape_sequence,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5838), 1,
      anon_sym_BQUOTE,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [116990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5826), 1,
      sym_escape_sequence,
    ACTIONS(5840), 1,
      anon_sym_BQUOTE,
    STATE(3033), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [117028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 8,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117042] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5802), 1,
      sym_escape_sequence,
    ACTIONS(5806), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(5808), 1,
      sym__template_chars,
    ACTIONS(5842), 1,
      anon_sym_BQUOTE,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [117066] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(4078), 1,
      anon_sym_COMMA,
    STATE(3410), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(5844), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(1355), 2,
      sym_template_string,
      sym_arguments,
  [117090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3828), 1,
      sym_statement_block,
    ACTIONS(5846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 1,
      anon_sym_is,
    ACTIONS(3393), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(5850), 1,
      anon_sym_EQ,
    ACTIONS(5848), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5852), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [117141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3691), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4130), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5856), 1,
      sym_identifier,
    STATE(3507), 1,
      sym_variable_declarator,
    STATE(2781), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5858), 1,
      sym_identifier,
    STATE(3450), 1,
      sym_variable_declarator,
    STATE(2775), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1747), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3973), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1390), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4008), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3224), 1,
      sym_type_annotation,
    STATE(3722), 1,
      sym__initializer,
    ACTIONS(5562), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117288] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      sym_private_property_identifier,
    STATE(1923), 1,
      sym_arguments,
    STATE(3848), 1,
      sym_type_arguments,
  [117313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5866), 1,
      sym_identifier,
    ACTIONS(5868), 1,
      anon_sym_STAR,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4039), 1,
      sym__call_signature,
  [117338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3245), 1,
      sym_type_annotation,
    STATE(3692), 1,
      sym__initializer,
    ACTIONS(5560), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
  [117372] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5872), 1,
      sym_identifier,
    ACTIONS(5874), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3839), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [117397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4134), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117410] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(170), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4045), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [117452] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(5876), 1,
      anon_sym_LT,
    ACTIONS(5878), 1,
      anon_sym_extends,
    STATE(644), 1,
      sym_object_type,
    STATE(3315), 1,
      sym_type_parameters,
    STATE(3563), 1,
      sym_extends_type_clause,
  [117477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5880), 1,
      anon_sym_EQ,
    ACTIONS(3037), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [117492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3257), 1,
      sym_type_annotation,
    STATE(3668), 1,
      sym__initializer,
    ACTIONS(5882), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5884), 1,
      sym_identifier,
    ACTIONS(5886), 1,
      anon_sym_DOT,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
  [117538] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1364), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4020), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117563] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5888), 1,
      sym_identifier,
    ACTIONS(5890), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3918), 1,
      sym__call_signature,
  [117588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3205), 1,
      sym_type_annotation,
    ACTIONS(5892), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117605] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1879), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3833), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117630] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5894), 1,
      sym_identifier,
    ACTIONS(5896), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4039), 1,
      sym__call_signature,
  [117655] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5251), 1,
      anon_sym_EQ,
    STATE(3483), 1,
      sym_constraint,
    STATE(3952), 1,
      sym_default_type,
    ACTIONS(5255), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(5898), 2,
      anon_sym_COLON,
      anon_sym_extends,
  [117676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3535), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [117691] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5900), 1,
      sym_identifier,
    ACTIONS(5902), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4039), 1,
      sym__call_signature,
  [117716] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1793), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4042), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3324), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4017), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3480), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [117808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    STATE(1355), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5904), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [117827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3617), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [117842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5788), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5886), 1,
      anon_sym_DOT,
    ACTIONS(5906), 1,
      sym_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    STATE(3437), 1,
      sym_nested_identifier,
  [117880] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1844), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(4001), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5908), 1,
      sym_identifier,
    ACTIONS(5910), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3963), 1,
      sym__call_signature,
  [117930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3189), 1,
      sym_type_annotation,
    STATE(3773), 1,
      sym__initializer,
    ACTIONS(5554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117951] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(615), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3993), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [117976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [117989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [118002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5728), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [118015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5726), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [118028] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    ACTIONS(5918), 1,
      anon_sym_QMARK,
    STATE(3465), 1,
      sym_type_annotation,
    STATE(3861), 1,
      sym__initializer,
    ACTIONS(5916), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [118051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(737), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3807), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3046), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [118089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5920), 1,
      anon_sym_COLON,
    ACTIONS(5922), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3914), 1,
      sym__call_signature,
  [118114] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5924), 1,
      sym_identifier,
    ACTIONS(5926), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3963), 1,
      sym__call_signature,
  [118139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [118152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5928), 1,
      anon_sym_EQ,
    ACTIONS(3046), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [118167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3804), 1,
      sym_statement_block,
    ACTIONS(5931), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118184] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5933), 1,
      sym_identifier,
    ACTIONS(5935), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4039), 1,
      sym__call_signature,
  [118209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3169), 1,
      sym_type_annotation,
    ACTIONS(5937), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3389), 1,
      sym_type_annotation,
    STATE(3693), 1,
      sym__initializer,
    ACTIONS(5588), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3165), 1,
      sym_type_annotation,
    STATE(3704), 1,
      sym__initializer,
    ACTIONS(5544), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118268] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(153), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3890), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3507), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [118314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3986), 1,
      sym_statement_block,
    ACTIONS(5939), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3971), 1,
      sym_statement_block,
    ACTIONS(5939), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3983), 1,
      sym_statement_block,
    ACTIONS(5941), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118365] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3366), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3832), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5943), 1,
      sym_identifier,
    ACTIONS(5945), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3963), 1,
      sym__call_signature,
  [118415] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(2037), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3866), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3883), 1,
      sym_statement_block,
    ACTIONS(5947), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_statement_block,
    ACTIONS(5949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118474] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1885), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3872), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118499] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1820), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3969), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4616), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [118537] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(623), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3884), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3878), 1,
      sym_statement_block,
    ACTIONS(5949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3876), 1,
      sym_statement_block,
    ACTIONS(5947), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3505), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_BQUOTE,
  [118611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 1,
      anon_sym_LBRACE,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(5955), 1,
      anon_sym_LT,
    ACTIONS(5957), 1,
      anon_sym_DOT,
    ACTIONS(5959), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3417), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3579), 1,
      sym_type_arguments,
  [118636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(712), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3899), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5922), 1,
      anon_sym_QMARK,
    ACTIONS(5961), 1,
      anon_sym_COLON,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3914), 1,
      sym__call_signature,
  [118686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3806), 1,
      sym_statement_block,
    ACTIONS(5963), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3803), 1,
      sym_statement_block,
    ACTIONS(5965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3837), 1,
      sym_statement_block,
    ACTIONS(5963), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3868), 1,
      sym_statement_block,
    ACTIONS(5965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3826), 1,
      sym_statement_block,
    ACTIONS(5967), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118771] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1831), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3982), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118796] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3339), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3942), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3895), 1,
      sym_statement_block,
    ACTIONS(5967), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3896), 1,
      sym_statement_block,
    ACTIONS(5846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118855] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1359), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3840), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [118880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3854), 1,
      sym_statement_block,
    ACTIONS(5969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3143), 1,
      sym_type_annotation,
    STATE(3653), 1,
      sym__initializer,
    ACTIONS(5550), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3857), 1,
      sym_statement_block,
    ACTIONS(5971), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(5973), 1,
      sym_identifier,
    ACTIONS(5975), 1,
      anon_sym_DOT,
    STATE(2795), 1,
      sym_nested_identifier,
    STATE(2914), 1,
      sym_string,
    STATE(3271), 1,
      sym__module,
  [118960] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(5876), 1,
      anon_sym_LT,
    ACTIONS(5878), 1,
      anon_sym_extends,
    STATE(3216), 1,
      sym_type_parameters,
    STATE(3280), 1,
      sym_object_type,
    STATE(3738), 1,
      sym_extends_type_clause,
  [118985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3897), 1,
      sym_statement_block,
    ACTIONS(5969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3901), 1,
      sym_statement_block,
    ACTIONS(5977), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3903), 1,
      sym_statement_block,
    ACTIONS(5979), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3931), 1,
      sym_statement_block,
    ACTIONS(5981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    ACTIONS(5259), 1,
      anon_sym_LT,
    ACTIONS(5983), 1,
      sym_identifier,
    ACTIONS(5985), 1,
      anon_sym_LBRACK,
    ACTIONS(5987), 1,
      sym_private_property_identifier,
    STATE(1356), 1,
      sym_arguments,
    STATE(3811), 1,
      sym_type_arguments,
  [119078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [119091] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1407), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3906), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [119116] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(2054), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3956), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [119141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [119154] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(5993), 1,
      sym_identifier,
    ACTIONS(5995), 1,
      anon_sym_STAR,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3963), 1,
      sym__call_signature,
  [119179] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    STATE(3353), 1,
      sym_statement_block,
    ACTIONS(1324), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    STATE(1825), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3924), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [119221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5812), 1,
      anon_sym_LBRACE,
    ACTIONS(5814), 1,
      anon_sym_LBRACK,
    ACTIONS(5854), 1,
      sym_identifier,
    STATE(3450), 1,
      sym_variable_declarator,
    STATE(2867), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [119242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [119255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5330), 1,
      anon_sym_is,
    ACTIONS(5999), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6001), 1,
      anon_sym_EQ,
    ACTIONS(3046), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [119285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4132), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [119298] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 1,
      anon_sym_extends,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3351), 1,
      sym_class_body,
    STATE(3612), 1,
      sym_extends_clause,
    STATE(3781), 1,
      sym_class_heritage,
    STATE(4311), 1,
      sym_implements_clause,
  [119323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(6008), 1,
      anon_sym_extends,
    ACTIONS(3497), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [119341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2201), 1,
      sym_statement_block,
    ACTIONS(5931), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119357] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6016), 1,
      anon_sym_SLASH,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [119379] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6020), 1,
      anon_sym_COMMA,
    ACTIONS(6022), 1,
      anon_sym_GT,
    STATE(3549), 1,
      aux_sym_implements_clause_repeat1,
  [119401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6026), 1,
      anon_sym_BQUOTE,
    ACTIONS(6028), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6024), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2985), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [119419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2972), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6030), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119435] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(6032), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2949), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [119457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(5955), 1,
      anon_sym_LT,
    ACTIONS(6034), 1,
      anon_sym_LBRACE,
    ACTIONS(6036), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3418), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(3576), 1,
      sym_type_arguments,
  [119479] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6038), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3168), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [119501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6040), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [119519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2180), 1,
      sym_statement_block,
    ACTIONS(5941), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119535] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6042), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3726), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [119557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 1,
      sym_identifier,
    ACTIONS(6046), 1,
      anon_sym_import,
    STATE(2359), 1,
      sym__type_query_member_expression,
    STATE(2378), 1,
      sym__type_query_subscript_expression,
    STATE(2510), 1,
      sym__type_query_call_expression,
    STATE(3972), 1,
      sym_import,
  [119579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5384), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(5386), 4,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [119593] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6048), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [119615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(5973), 1,
      sym_identifier,
    STATE(2795), 1,
      sym_nested_identifier,
    STATE(2914), 1,
      sym_string,
    STATE(3364), 1,
      sym__module,
  [119637] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6050), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [119659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym_statement_block,
    ACTIONS(5939), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(6052), 1,
      sym_identifier,
    ACTIONS(6054), 1,
      anon_sym_LBRACK,
    STATE(3623), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [119693] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6056), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [119715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6058), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [119733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(6054), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      sym_identifier,
    STATE(3962), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [119751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    ACTIONS(6054), 1,
      anon_sym_LBRACK,
    ACTIONS(6062), 1,
      sym_identifier,
    STATE(3406), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [119769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_default,
    ACTIONS(6067), 1,
      anon_sym_RBRACE,
    ACTIONS(6069), 1,
      anon_sym_case,
    STATE(2945), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [119787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(6072), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2964), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [119809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3221), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6030), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6074), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3874), 1,
      sym__call_signature,
  [119847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2179), 1,
      sym_statement_block,
    ACTIONS(5939), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6076), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [119885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    ACTIONS(5973), 1,
      sym_identifier,
    STATE(2795), 1,
      sym_nested_identifier,
    STATE(2914), 1,
      sym_string,
    STATE(3271), 1,
      sym__module,
  [119907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6080), 1,
      anon_sym_QMARK,
    ACTIONS(6078), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [119927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2947), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6084), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6082), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6086), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym__call_signature,
  [119965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_default,
    ACTIONS(6090), 1,
      anon_sym_RBRACE,
    ACTIONS(6092), 1,
      anon_sym_case,
    STATE(2945), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [119983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3194), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [120001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3185), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [120015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3162), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [120033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6098), 1,
      anon_sym_BQUOTE,
    ACTIONS(5802), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2926), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [120051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6100), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3797), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [120073] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6102), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3984), 1,
      sym__call_signature,
  [120095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3064), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6106), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6104), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2213), 1,
      sym_statement_block,
    ACTIONS(5947), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2211), 1,
      sym_statement_block,
    ACTIONS(5949), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 1,
      sym_identifier,
    ACTIONS(6110), 1,
      anon_sym_GT,
    ACTIONS(6112), 1,
      sym_jsx_identifier,
    STATE(2513), 1,
      sym_nested_identifier,
    STATE(2767), 1,
      sym_jsx_namespace_name,
    STATE(3634), 1,
      sym_type_parameter,
  [120165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(6114), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2994), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [120187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5906), 1,
      sym_identifier,
    STATE(624), 1,
      sym_string,
    STATE(650), 1,
      sym__module,
    STATE(3437), 1,
      sym_nested_identifier,
  [120209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5906), 1,
      sym_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
    STATE(3437), 1,
      sym_nested_identifier,
  [120231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2200), 1,
      sym_statement_block,
    ACTIONS(5949), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2198), 1,
      sym_statement_block,
    ACTIONS(5947), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [120275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3237), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6116), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120291] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6118), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3202), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [120313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6120), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3765), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [120335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6125), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6122), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6127), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4014), 1,
      sym__call_signature,
  [120373] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5955), 1,
      anon_sym_LT,
    ACTIONS(5957), 1,
      anon_sym_DOT,
    ACTIONS(6129), 1,
      anon_sym_LBRACE,
    STATE(3579), 1,
      sym_type_arguments,
    ACTIONS(6131), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [120393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6133), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3834), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [120415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6135), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [120437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_import,
    ACTIONS(6137), 1,
      sym_identifier,
    STATE(1484), 1,
      sym__type_query_subscript_expression,
    STATE(1486), 1,
      sym__type_query_member_expression,
    STATE(1593), 1,
      sym__type_query_call_expression,
    STATE(3835), 1,
      sym_import,
  [120459] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6139), 1,
      anon_sym_COMMA,
    ACTIONS(6141), 1,
      anon_sym_GT,
    STATE(3553), 1,
      aux_sym_implements_clause_repeat1,
  [120481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(3543), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [120495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3218), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [120513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3221), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [120531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6146), 1,
      anon_sym_BQUOTE,
    ACTIONS(6148), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6143), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2985), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [120549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2203), 1,
      sym_statement_block,
    ACTIONS(5963), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120565] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_import,
    ACTIONS(6151), 1,
      sym_identifier,
    STATE(2349), 1,
      sym__type_query_call_expression,
    STATE(2633), 1,
      sym__type_query_member_expression,
    STATE(2655), 1,
      sym__type_query_subscript_expression,
    STATE(3783), 1,
      sym_import,
  [120587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6153), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym__call_signature,
  [120609] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6155), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym__call_signature,
  [120631] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6157), 1,
      anon_sym_LBRACE,
    ACTIONS(6159), 1,
      anon_sym_COMMA,
    STATE(3539), 1,
      aux_sym_implements_clause_repeat1,
  [120653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_import,
    ACTIONS(6161), 1,
      sym_identifier,
    STATE(2325), 1,
      sym__type_query_subscript_expression,
    STATE(2326), 1,
      sym__type_query_member_expression,
    STATE(2349), 1,
      sym__type_query_call_expression,
    STATE(4040), 1,
      sym_import,
  [120675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3222), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [120693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2204), 1,
      sym_statement_block,
    ACTIONS(5965), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(6163), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3007), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [120743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2185), 1,
      sym_statement_block,
    ACTIONS(5963), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2177), 1,
      sym_statement_block,
    ACTIONS(5965), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6165), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [120809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_EQ,
    ACTIONS(6167), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6171), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [120825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6173), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3930), 1,
      sym__call_signature,
  [120847] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6175), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3232), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [120869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6177), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [120891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6179), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3859), 1,
      sym__call_signature,
  [120913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2186), 1,
      sym_statement_block,
    ACTIONS(5967), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    STATE(3421), 1,
      sym_type_annotation,
    STATE(3880), 1,
      sym__initializer,
    ACTIONS(6181), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [120949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2181), 1,
      sym_statement_block,
    ACTIONS(5846), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1994), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120977] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6088), 1,
      anon_sym_default,
    ACTIONS(6092), 1,
      anon_sym_case,
    ACTIONS(6183), 1,
      anon_sym_RBRACE,
    STATE(2955), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [120995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1978), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1986), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121019] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(6185), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3031), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [121041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1982), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2197), 1,
      sym_statement_block,
    ACTIONS(5967), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6187), 1,
      anon_sym_COMMA,
    ACTIONS(6189), 1,
      anon_sym_GT,
    STATE(3601), 1,
      aux_sym_implements_clause_repeat1,
  [121091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6191), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4014), 1,
      sym__call_signature,
  [121113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6193), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [121135] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3244), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [121153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1990), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6195), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3838), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [121187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2209), 1,
      sym_statement_block,
    ACTIONS(5846), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121203] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6197), 1,
      anon_sym_QMARK,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3789), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [121225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [121237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3092), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3243), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6199), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121253] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6201), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3249), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(5606), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3927), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [121291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3255), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [121309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6205), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [121331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3256), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [121349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_statement_block,
    ACTIONS(5969), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2202), 1,
      sym_statement_block,
    ACTIONS(5971), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121381] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    ACTIONS(6207), 1,
      anon_sym_QMARK,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3038), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [121403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6209), 1,
      anon_sym_BQUOTE,
    ACTIONS(6024), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(2985), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [121421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2212), 1,
      sym_statement_block,
    ACTIONS(5969), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121437] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6211), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4014), 1,
      sym__call_signature,
  [121459] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6213), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3261), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2184), 1,
      sym_statement_block,
    ACTIONS(5977), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2183), 1,
      sym_statement_block,
    ACTIONS(5979), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6215), 1,
      anon_sym_export,
    ACTIONS(6217), 1,
      anon_sym_class,
    ACTIONS(6219), 1,
      anon_sym_abstract,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [121535] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6217), 1,
      anon_sym_class,
    ACTIONS(6219), 1,
      anon_sym_abstract,
    ACTIONS(6221), 1,
      anon_sym_export,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [121557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6223), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3266), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_LBRACE,
    STATE(2199), 1,
      sym_statement_block,
    ACTIONS(5981), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    ACTIONS(6094), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6096), 1,
      anon_sym_QMARK_COLON,
    STATE(3243), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [121613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [121625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [121637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3219), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6225), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3205), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6227), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3046), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3205), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6227), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3047), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6231), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6229), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(3698), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [121717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6233), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2906), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [121751] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6235), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2901), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121773] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6237), 1,
      anon_sym_COMMA,
    ACTIONS(6239), 1,
      anon_sym_GT,
    STATE(3596), 1,
      aux_sym_implements_clause_repeat1,
  [121795] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6241), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2811), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6243), 1,
      anon_sym_COMMA,
    ACTIONS(6245), 1,
      anon_sym_GT,
    STATE(3622), 1,
      aux_sym_implements_clause_repeat1,
  [121839] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6247), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2871), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [121861] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6249), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4014), 1,
      sym__call_signature,
  [121883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3088), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6253), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6251), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(6008), 1,
      anon_sym_extends,
    ACTIONS(3463), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [121917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5515), 1,
      anon_sym_is,
    ACTIONS(5999), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121931] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6255), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [121953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3203), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6257), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3243), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6199), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6259), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2890), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [122007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [122035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      sym_identifier,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4027), 1,
      sym__call_signature,
  [122057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    ACTIONS(6269), 1,
      anon_sym_COMMA,
    ACTIONS(6271), 1,
      anon_sym_RBRACE,
    STATE(3768), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [122077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3075), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3209), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6261), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3066), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6275), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6273), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(6008), 1,
      anon_sym_extends,
    ACTIONS(3694), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [122127] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6277), 1,
      anon_sym_COMMA,
    ACTIONS(6279), 1,
      anon_sym_GT,
    STATE(3531), 1,
      aux_sym_implements_clause_repeat1,
  [122149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_import,
    ACTIONS(6281), 1,
      sym_identifier,
    STATE(2496), 1,
      sym__type_query_member_expression,
    STATE(2503), 1,
      sym__type_query_subscript_expression,
    STATE(2593), 1,
      sym__type_query_call_expression,
    STATE(4044), 1,
      sym_import,
  [122171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3201), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6283), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5884), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(624), 1,
      sym_string,
    STATE(640), 1,
      sym__module,
  [122209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    ACTIONS(6285), 1,
      anon_sym_SLASH,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [122231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3247), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6287), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    ACTIONS(6289), 1,
      anon_sym_COMMA,
    ACTIONS(6291), 1,
      anon_sym_RBRACE,
    STATE(3589), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [122267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3091), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3247), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6287), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    ACTIONS(5884), 1,
      sym_identifier,
    STATE(609), 1,
      sym_nested_identifier,
    STATE(624), 1,
      sym_string,
    STATE(650), 1,
      sym__module,
  [122305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(3613), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [122319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(6008), 1,
      anon_sym_extends,
    ACTIONS(3675), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [122337] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6219), 1,
      anon_sym_abstract,
    ACTIONS(6293), 1,
      anon_sym_export,
    ACTIONS(6295), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [122359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(5618), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(3998), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [122375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3078), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6299), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6297), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6301), 1,
      anon_sym_BQUOTE,
    ACTIONS(5826), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3033), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [122409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3211), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6303), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122425] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6305), 1,
      anon_sym_COMMA,
    ACTIONS(6307), 1,
      anon_sym_GT,
    STATE(3740), 1,
      aux_sym_implements_clause_repeat1,
  [122447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3215), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6311), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2975), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3207), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6313), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    ACTIONS(6315), 1,
      anon_sym_QMARK,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2878), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [122513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3063), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3211), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6303), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6317), 1,
      sym_identifier,
    ACTIONS(6319), 1,
      anon_sym_GT,
    ACTIONS(6321), 1,
      sym_jsx_identifier,
    STATE(2522), 1,
      sym_nested_identifier,
    STATE(2752), 1,
      sym_jsx_namespace_name,
    STATE(3634), 1,
      sym_type_parameter,
  [122551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 1,
      anon_sym_import,
    ACTIONS(6323), 1,
      sym_identifier,
    STATE(1220), 1,
      sym__type_query_subscript_expression,
    STATE(1222), 1,
      sym__type_query_member_expression,
    STATE(1294), 1,
      sym__type_query_call_expression,
    STATE(3865), 1,
      sym_import,
  [122573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3823), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [122627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3656), 1,
      sym__initializer,
    ACTIONS(6329), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6331), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6333), 1,
      anon_sym_BQUOTE,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6337), 1,
      sym__template_chars,
    STATE(3154), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [122670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3900), 1,
      sym__call_signature,
  [122689] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 1,
      anon_sym_LBRACE,
    ACTIONS(6339), 1,
      anon_sym_SEMI,
    ACTIONS(6341), 1,
      sym__automatic_semicolon,
    ACTIONS(6343), 1,
      sym__function_signature_automatic_semicolon,
    STATE(174), 1,
      sym_statement_block,
  [122708] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    ACTIONS(6345), 1,
      anon_sym_COMMA,
    ACTIONS(6347), 1,
      anon_sym_RBRACE,
    STATE(3678), 1,
      aux_sym_enum_body_repeat1,
    STATE(3894), 1,
      sym__initializer,
  [122727] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    STATE(3911), 1,
      sym_type_annotation,
    ACTIONS(3046), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [122742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6349), 1,
      anon_sym_EQ_GT,
    STATE(3927), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [122757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    ACTIONS(6352), 1,
      anon_sym_SEMI,
    ACTIONS(6354), 1,
      sym__automatic_semicolon,
    ACTIONS(6356), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3150), 1,
      sym_statement_block,
  [122776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4593), 1,
      sym__automatic_semicolon,
    ACTIONS(1450), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [122789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6358), 1,
      anon_sym_EQ_GT,
    STATE(3998), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [122804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
    ACTIONS(6361), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6012), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_GT,
    ACTIONS(6018), 1,
      sym_jsx_identifier,
    STATE(2547), 1,
      sym_nested_identifier,
    STATE(2706), 1,
      sym_jsx_namespace_name,
  [122840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6365), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [122851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    ACTIONS(6367), 1,
      anon_sym_RBRACE,
    STATE(3997), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [122868] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3885), 1,
      sym__call_signature,
  [122887] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    ACTIONS(6339), 1,
      anon_sym_SEMI,
    ACTIONS(6341), 1,
      sym__automatic_semicolon,
    ACTIONS(6343), 1,
      sym__function_signature_automatic_semicolon,
    STATE(621), 1,
      sym_statement_block,
  [122906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
    ACTIONS(6369), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [122923] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2877), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [122942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3879), 1,
      sym__call_signature,
  [122961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3873), 1,
      sym__call_signature,
  [122980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    ACTIONS(6371), 1,
      anon_sym_RBRACE,
    STATE(3976), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [122997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      anon_sym_in,
    ACTIONS(6377), 1,
      anon_sym_of,
    ACTIONS(6373), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6379), 1,
      anon_sym_in,
    ACTIONS(6381), 1,
      anon_sym_of,
    ACTIONS(6373), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6383), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [123044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3974), 1,
      sym__call_signature,
  [123063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4579), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123074] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4011), 1,
      sym__call_signature,
  [123093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6385), 1,
      anon_sym_EQ_GT,
    STATE(3998), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [123130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3321), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [123149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4563), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6388), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6390), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [123173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6394), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [123186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    ACTIONS(6396), 1,
      anon_sym_COMMA,
    ACTIONS(6398), 1,
      anon_sym_RBRACE,
    STATE(3627), 1,
      aux_sym_enum_body_repeat1,
    STATE(3894), 1,
      sym__initializer,
  [123205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6400), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [123227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6402), 1,
      anon_sym_class,
    ACTIONS(6404), 1,
      anon_sym_abstract,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [123246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2963), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [123265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3708), 1,
      sym__initializer,
    ACTIONS(6406), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3729), 1,
      sym__initializer,
    ACTIONS(6408), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6410), 1,
      anon_sym_EQ_GT,
    STATE(3927), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [123321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    ACTIONS(6339), 1,
      anon_sym_SEMI,
    ACTIONS(6341), 1,
      sym__automatic_semicolon,
    ACTIONS(6343), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1861), 1,
      sym_statement_block,
  [123340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5931), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6413), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123362] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3291), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [123381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6415), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [123398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4607), 1,
      sym__automatic_semicolon,
    ACTIONS(1558), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      sym__automatic_semicolon,
    ACTIONS(1384), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4589), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5310), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      anon_sym_RBRACE,
    ACTIONS(3437), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [123450] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 1,
      anon_sym_BQUOTE,
    ACTIONS(6421), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6424), 1,
      sym__template_chars,
    STATE(3154), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6427), 1,
      anon_sym_EQ_GT,
    STATE(3927), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [123482] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2889), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [123501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123512] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6337), 1,
      sym__template_chars,
    ACTIONS(6430), 1,
      anon_sym_BQUOTE,
    STATE(3154), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123529] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3805), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [123548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4645), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [123559] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(6008), 1,
      anon_sym_extends,
    ACTIONS(6432), 1,
      anon_sym_as,
    ACTIONS(6434), 1,
      anon_sym_RBRACK,
  [123578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6436), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(2986), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [123608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3780), 1,
      sym__initializer,
    ACTIONS(6438), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3779), 1,
      sym__initializer,
    ACTIONS(6440), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3767), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [123657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3200), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [123676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5939), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6442), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5939), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6444), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
    ACTIONS(6446), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5941), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    ACTIONS(6450), 1,
      anon_sym_RBRACE,
    STATE(3976), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [123787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4641), 1,
      sym__automatic_semicolon,
    ACTIONS(1396), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2893), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [123819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3979), 1,
      sym__call_signature,
  [123838] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3980), 1,
      sym__call_signature,
  [123857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
    ACTIONS(6452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [123874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5955), 1,
      anon_sym_LT,
    ACTIONS(6454), 1,
      anon_sym_LBRACE,
    STATE(3576), 1,
      sym_type_arguments,
    ACTIONS(6456), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [123891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6219), 1,
      anon_sym_abstract,
    ACTIONS(6458), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [123910] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3908), 1,
      sym__call_signature,
  [123929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6460), 1,
      sym_identifier,
    ACTIONS(6462), 1,
      anon_sym_GT,
    ACTIONS(6464), 1,
      sym_jsx_identifier,
    STATE(2518), 1,
      sym_nested_identifier,
    STATE(2674), 1,
      sym_jsx_namespace_name,
  [123948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3827), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [123967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3944), 1,
      sym__call_signature,
  [123986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3987), 1,
      sym__call_signature,
  [124005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3723), 1,
      sym__initializer,
    ACTIONS(6466), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3719), 1,
      sym__initializer,
    ACTIONS(6468), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4000), 1,
      sym__call_signature,
  [124054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2899), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4005), 1,
      sym__call_signature,
  [124092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2905), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3109), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
    ACTIONS(6472), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [124158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(2907), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3713), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5947), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124207] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3005), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
    ACTIONS(6474), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [124254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    ACTIONS(6476), 1,
      anon_sym_SEMI,
    ACTIONS(6478), 1,
      sym__automatic_semicolon,
    ACTIONS(6480), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3110), 1,
      sym_statement_block,
  [124273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6482), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6484), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5947), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6486), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    ACTIONS(6488), 1,
      anon_sym_SEMI,
    ACTIONS(6490), 1,
      sym__automatic_semicolon,
    ACTIONS(6492), 1,
      sym__function_signature_automatic_semicolon,
    STATE(625), 1,
      sym_statement_block,
  [124347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3990), 1,
      sym__call_signature,
  [124366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6494), 1,
      anon_sym_EQ_GT,
    STATE(3998), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [124381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3117), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    ACTIONS(6497), 1,
      anon_sym_RBRACE,
    STATE(3997), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [124417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3855), 1,
      sym__call_signature,
  [124436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    ACTIONS(5878), 1,
      anon_sym_extends,
    STATE(3308), 1,
      sym_object_type,
    STATE(3626), 1,
      sym_extends_type_clause,
  [124455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3935), 1,
      sym__call_signature,
  [124474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6499), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    ACTIONS(6488), 1,
      anon_sym_SEMI,
    ACTIONS(6490), 1,
      sym__automatic_semicolon,
    ACTIONS(6492), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1786), 1,
      sym_statement_block,
  [124504] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3145), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6503), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3030), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3695), 1,
      sym__initializer,
    ACTIONS(6505), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6507), 1,
      anon_sym_BQUOTE,
    ACTIONS(6509), 1,
      sym__template_chars,
    STATE(3158), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [124596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3229), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3794), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [124634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3690), 1,
      sym__initializer,
    ACTIONS(6511), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5963), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [124671] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3247), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5963), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3204), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6404), 1,
      anon_sym_abstract,
    ACTIONS(6513), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [124750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6217), 1,
      anon_sym_class,
    ACTIONS(6219), 1,
      anon_sym_abstract,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [124769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6515), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124780] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(6517), 1,
      anon_sym_RBRACE,
    STATE(3617), 1,
      aux_sym_object_pattern_repeat1,
  [124799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5965), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6519), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(3902), 1,
      sym__call_signature,
  [124840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3037), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6523), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3669), 1,
      sym__initializer,
    ACTIONS(6525), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3666), 1,
      sym__initializer,
    ACTIONS(6527), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5967), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3259), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [124941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124952] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3219), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [124971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5967), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5846), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6531), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3652), 1,
      sym__initializer,
    ACTIONS(6537), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125052] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3042), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [125071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3264), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [125101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5971), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5969), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5977), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2641), 1,
      sym_formal_parameters,
    STATE(3267), 1,
      sym__call_signature,
    STATE(3863), 1,
      sym_type_parameters,
  [125164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5979), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5981), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2170), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1514), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4134), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [125274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4130), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [125285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2110), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2326), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2338), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6541), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6543), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [125364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6545), 1,
      anon_sym_BQUOTE,
    ACTIONS(6547), 1,
      sym__template_chars,
    STATE(3316), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [125425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125447] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    ACTIONS(6476), 1,
      anon_sym_SEMI,
    ACTIONS(6478), 1,
      sym__automatic_semicolon,
    ACTIONS(6480), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1837), 1,
      sym_statement_block,
  [125466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4132), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [125543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3320), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [125606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2194), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2190), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2186), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6549), 1,
      anon_sym_EQ_GT,
    STATE(3998), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [125731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    ACTIONS(5878), 1,
      anon_sym_extends,
    STATE(658), 1,
      sym_object_type,
    STATE(3545), 1,
      sym_extends_type_clause,
  [125750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6337), 1,
      sym__template_chars,
    ACTIONS(6552), 1,
      anon_sym_BQUOTE,
    STATE(3154), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [125767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1380), 1,
      anon_sym_DOT,
    ACTIONS(3681), 1,
      anon_sym_LBRACE,
    ACTIONS(3683), 3,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_LBRACE_PIPE,
  [125804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 1,
      anon_sym_LBRACE,
    ACTIONS(6488), 1,
      anon_sym_SEMI,
    ACTIONS(6490), 1,
      sym__automatic_semicolon,
    ACTIONS(6492), 1,
      sym__function_signature_automatic_semicolon,
    STATE(151), 1,
      sym_statement_block,
  [125823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    ACTIONS(6352), 1,
      anon_sym_SEMI,
    ACTIONS(6354), 1,
      sym__automatic_semicolon,
    ACTIONS(6356), 1,
      sym__function_signature_automatic_semicolon,
    STATE(1865), 1,
      sym_statement_block,
  [125842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3801), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [125861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3815), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [125880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2122), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3851), 1,
      sym_type_parameters,
    STATE(4025), 1,
      sym__call_signature,
  [125932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6219), 1,
      anon_sym_abstract,
    ACTIONS(6295), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [126006] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3105), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [126025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1522), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1568), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6337), 1,
      sym__template_chars,
    ACTIONS(6554), 1,
      anon_sym_BQUOTE,
    STATE(3154), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [126068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2286), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2294), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2298), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6556), 1,
      anon_sym_BQUOTE,
    ACTIONS(6558), 1,
      sym__template_chars,
    STATE(3103), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [126151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3949), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6560), 1,
      anon_sym_BQUOTE,
    ACTIONS(6562), 1,
      sym__template_chars,
    STATE(3337), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [126181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6564), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6566), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1470), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2374), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2755), 1,
      sym_formal_parameters,
    STATE(3210), 1,
      sym__call_signature,
    STATE(3959), 1,
      sym_type_parameters,
  [126323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2410), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [126356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(6572), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2402), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1482), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3957), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3959), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4531), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [126426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 1,
      anon_sym_EQ,
    ACTIONS(3037), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [126461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126483] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3085), 1,
      sym_formal_parameters,
    STATE(3795), 1,
      sym__call_signature,
    STATE(3851), 1,
      sym_type_parameters,
  [126502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4475), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [126524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4007), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4009), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3974), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3976), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3756), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3756), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3756), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3941), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3943), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3756), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3935), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3937), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3982), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3984), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6337), 1,
      sym__template_chars,
    ACTIONS(6576), 1,
      anon_sym_BQUOTE,
    STATE(3154), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [126669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3836), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [126682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6203), 1,
      anon_sym_COLON,
    ACTIONS(6578), 1,
      anon_sym_EQ_GT,
    STATE(3927), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [126697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5350), 1,
      anon_sym_EQ,
    STATE(3699), 1,
      sym__initializer,
    ACTIONS(6581), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(6583), 1,
      anon_sym_RBRACE,
    STATE(3702), 1,
      aux_sym_object_pattern_repeat1,
  [126731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6585), 1,
      anon_sym_BQUOTE,
    ACTIONS(6587), 1,
      sym__template_chars,
    STATE(3386), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [126748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6589), 1,
      anon_sym_LBRACE,
    ACTIONS(6591), 1,
      anon_sym_COMMA,
    ACTIONS(6594), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3393), 1,
      aux_sym_extends_type_clause_repeat1,
  [126775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6596), 1,
      anon_sym_RPAREN,
  [126791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_COMMA,
    STATE(3411), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6598), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [126805] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6600), 1,
      anon_sym_export,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [126821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6602), 1,
      anon_sym_RPAREN,
  [126837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6604), 1,
      sym_identifier,
    ACTIONS(6606), 1,
      sym_jsx_identifier,
    STATE(4037), 1,
      sym_nested_identifier,
    STATE(4231), 1,
      sym_jsx_namespace_name,
  [126853] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6608), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [126867] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6608), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [126881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3782), 1,
      sym_type_parameters,
    STATE(4234), 1,
      sym_formal_parameters,
  [126897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6614), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [126907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(6034), 1,
      anon_sym_LBRACE,
    ACTIONS(6036), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3419), 1,
      aux_sym_extends_type_clause_repeat1,
  [126923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2866), 1,
      sym_formal_parameters,
    STATE(3925), 1,
      sym_type_parameters,
  [126939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6616), 1,
      sym_escape_sequence,
    ACTIONS(6618), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [126951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_EQ,
    STATE(3867), 1,
      sym__initializer,
    ACTIONS(5592), 2,
      anon_sym_in,
      anon_sym_of,
  [126965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6623), 1,
      sym_identifier,
    ACTIONS(6625), 1,
      sym_jsx_identifier,
    STATE(4021), 1,
      sym_nested_identifier,
    STATE(4292), 1,
      sym_jsx_namespace_name,
  [126981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3964), 1,
      sym_type_parameters,
    STATE(4295), 1,
      sym_formal_parameters,
  [126997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6627), 1,
      anon_sym_RBRACK,
  [127013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_COMMA,
    STATE(3411), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6629), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [127027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_COMMA,
    STATE(3411), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6631), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [127041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6417), 1,
      anon_sym_RBRACE,
    ACTIONS(3437), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [127053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6636), 1,
      anon_sym_QMARK,
  [127069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(6058), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [127083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6641), 1,
      anon_sym_RBRACK,
  [127099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      sym_identifier,
    STATE(3182), 1,
      sym_nested_type_identifier,
    STATE(3752), 1,
      sym_generic_type,
    STATE(4101), 1,
      sym_nested_identifier,
  [127115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(6645), 1,
      anon_sym_LBRACE,
    ACTIONS(6647), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3393), 1,
      aux_sym_extends_type_clause_repeat1,
  [127131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3393), 1,
      aux_sym_extends_type_clause_repeat1,
  [127147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      anon_sym_COMMA,
    ACTIONS(6649), 1,
      anon_sym_LBRACE,
    ACTIONS(6651), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3393), 1,
      aux_sym_extends_type_clause_repeat1,
  [127163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    STATE(3997), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [127177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    STATE(3958), 1,
      sym__initializer,
    ACTIONS(6653), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      sym_identifier,
    STATE(3976), 1,
      sym__import_export_specifier,
    ACTIONS(6267), 2,
      anon_sym_type,
      anon_sym_typeof,
  [127205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6658), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127219] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_SQUOTE,
    STATE(3400), 1,
      aux_sym_string_repeat2,
    ACTIONS(6662), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [127233] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_DQUOTE,
    STATE(3399), 1,
      aux_sym_string_repeat1,
    ACTIONS(6664), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6668), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127261] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6670), 1,
      anon_sym_DQUOTE,
    STATE(3490), 1,
      aux_sym_string_repeat1,
    ACTIONS(6672), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6674), 1,
      anon_sym_RBRACK,
  [127291] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6676), 1,
      anon_sym_RPAREN,
  [127307] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6670), 1,
      anon_sym_SQUOTE,
    STATE(3491), 1,
      aux_sym_string_repeat2,
    ACTIONS(6678), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [127321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6680), 1,
      anon_sym_RBRACK,
  [127337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6682), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6684), 1,
      anon_sym_QMARK,
  [127367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6686), 1,
      anon_sym_QMARK,
  [127383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6688), 1,
      anon_sym_QMARK,
  [127399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6690), 1,
      anon_sym_RPAREN,
  [127415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 1,
      anon_sym_while,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    STATE(652), 1,
      sym_statement_block,
  [127431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3829), 1,
      sym_type_parameters,
    STATE(4194), 1,
      sym_formal_parameters,
  [127447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6692), 1,
      anon_sym_COLON,
  [127463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3961), 1,
      sym__from_clause,
    ACTIONS(6696), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    STATE(3894), 1,
      sym__initializer,
    ACTIONS(6698), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    ACTIONS(6700), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [127505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6702), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [127521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6704), 1,
      anon_sym_COLON,
  [127537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6706), 1,
      anon_sym_COLON,
  [127553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6708), 1,
      anon_sym_RBRACK,
  [127569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6710), 1,
      anon_sym_RBRACK,
  [127585] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6712), 1,
      anon_sym_QMARK,
  [127601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      sym_identifier,
    ACTIONS(6716), 1,
      sym_jsx_identifier,
    STATE(4031), 1,
      sym_nested_identifier,
    STATE(4399), 1,
      sym_jsx_namespace_name,
  [127617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3432), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6718), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6720), 1,
      anon_sym_COLON,
  [127647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6722), 1,
      anon_sym_RBRACK,
  [127663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3787), 1,
      sym_type_parameters,
    STATE(4393), 1,
      sym_formal_parameters,
  [127679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6724), 1,
      anon_sym_RBRACK,
  [127695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6726), 1,
      anon_sym_RBRACK,
  [127711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6728), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3423), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6730), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127739] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_DQUOTE,
    STATE(3471), 1,
      aux_sym_string_repeat1,
    ACTIONS(6734), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127753] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_SQUOTE,
    STATE(3472), 1,
      aux_sym_string_repeat2,
    ACTIONS(6736), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [127767] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6738), 1,
      anon_sym_DQUOTE,
    STATE(3469), 1,
      aux_sym_string_repeat1,
    ACTIONS(6740), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6742), 1,
      anon_sym_RBRACK,
  [127797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3808), 1,
      sym__from_clause,
    ACTIONS(4312), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [127811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 1,
      anon_sym_BQUOTE,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    STATE(1355), 2,
      sym_template_string,
      sym_arguments,
  [127825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6744), 1,
      anon_sym_EQ_GT,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [127837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5914), 1,
      anon_sym_EQ,
    STATE(3882), 1,
      sym__initializer,
    ACTIONS(6746), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 1,
      anon_sym_EQ_GT,
    ACTIONS(3185), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [127863] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6748), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [127877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(91), 1,
      anon_sym_AT,
    ACTIONS(6750), 1,
      anon_sym_class,
    STATE(1123), 1,
      aux_sym_export_statement_repeat1,
    STATE(1150), 1,
      sym_decorator,
  [127893] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6748), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(6752), 1,
      anon_sym_EQ,
    ACTIONS(6754), 1,
      anon_sym_RBRACK,
    STATE(3636), 1,
      aux_sym_array_pattern_repeat1,
  [127923] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6756), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127937] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6756), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [127951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(6752), 1,
      anon_sym_EQ,
    ACTIONS(6758), 1,
      anon_sym_RBRACK,
    STATE(3712), 1,
      aux_sym_array_pattern_repeat1,
  [127967] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6760), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [127981] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6760), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [127995] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6762), 1,
      anon_sym_SQUOTE,
    STATE(3474), 1,
      aux_sym_string_repeat2,
    ACTIONS(6764), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_array_repeat1,
    ACTIONS(4464), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [128023] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6762), 1,
      anon_sym_DQUOTE,
    STATE(3475), 1,
      aux_sym_string_repeat1,
    ACTIONS(6769), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3456), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6771), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3457), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6773), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128065] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6775), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128079] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6775), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5251), 1,
      anon_sym_EQ,
    STATE(3970), 1,
      sym_default_type,
    ACTIONS(6777), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [128107] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_SQUOTE,
    STATE(3481), 1,
      aux_sym_string_repeat2,
    ACTIONS(6781), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128121] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6779), 1,
      anon_sym_DQUOTE,
    STATE(3482), 1,
      aux_sym_string_repeat1,
    ACTIONS(6783), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3852), 1,
      sym__from_clause,
    ACTIONS(6785), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6787), 1,
      anon_sym_COLON,
  [128165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      anon_sym_BQUOTE,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    STATE(1922), 2,
      sym_template_string,
      sym_arguments,
  [128179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6789), 1,
      sym_identifier,
    ACTIONS(6791), 1,
      sym_jsx_identifier,
    STATE(4007), 1,
      sym_nested_identifier,
    STATE(4064), 1,
      sym_jsx_namespace_name,
  [128195] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128209] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6793), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128223] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6795), 1,
      anon_sym_DQUOTE,
    STATE(3499), 1,
      aux_sym_string_repeat1,
    ACTIONS(6797), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128237] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6795), 1,
      anon_sym_SQUOTE,
    STATE(3500), 1,
      aux_sym_string_repeat2,
    ACTIONS(6799), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128251] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6738), 1,
      anon_sym_SQUOTE,
    STATE(3467), 1,
      aux_sym_string_repeat2,
    ACTIONS(6801), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128265] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128279] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6803), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_LBRACE,
    ACTIONS(5658), 1,
      anon_sym_STAR,
    STATE(4103), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [128307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [128317] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6610), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128331] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6805), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6612), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128345] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_SQUOTE,
    STATE(3495), 1,
      aux_sym_string_repeat2,
    ACTIONS(6809), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128369] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6807), 1,
      anon_sym_DQUOTE,
    STATE(3496), 1,
      aux_sym_string_repeat1,
    ACTIONS(6811), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6813), 1,
      anon_sym_RPAREN,
  [128399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6815), 1,
      anon_sym_COLON,
  [128415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6817), 1,
      anon_sym_RBRACK,
  [128431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6666), 1,
      anon_sym_COMMA,
    STATE(3426), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(6819), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3869), 1,
      sym__from_clause,
    ACTIONS(4176), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [128459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4035), 1,
      sym_type_parameters,
    STATE(4056), 1,
      sym_formal_parameters,
  [128475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6821), 1,
      sym_identifier,
    STATE(2929), 1,
      sym_nested_type_identifier,
    STATE(3403), 1,
      sym_generic_type,
    STATE(4101), 1,
      sym_nested_identifier,
  [128491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4013), 1,
      sym_type_parameters,
    STATE(4125), 1,
      sym_formal_parameters,
  [128507] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6823), 1,
      anon_sym_SQUOTE,
    STATE(3512), 1,
      aux_sym_string_repeat2,
    ACTIONS(6825), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [128521] = 4,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6828), 1,
      anon_sym_DQUOTE,
    STATE(3513), 1,
      aux_sym_string_repeat1,
    ACTIONS(6830), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [128535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6833), 1,
      anon_sym_QMARK,
  [128551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
    ACTIONS(6835), 1,
      anon_sym_RBRACK,
  [128567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6837), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6841), 1,
      sym_identifier,
    ACTIONS(6843), 1,
      anon_sym_LBRACK,
    ACTIONS(6845), 1,
      sym_private_property_identifier,
  [128598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6849), 1,
      anon_sym_COMMA,
    ACTIONS(6852), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [128620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [128629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6854), 1,
      anon_sym_COMMA,
    ACTIONS(6856), 1,
      anon_sym_RBRACK,
    STATE(3544), 1,
      aux_sym_tuple_type_repeat1,
  [128642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(6858), 1,
      anon_sym_GT,
  [128655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 1,
      sym_identifier,
    ACTIONS(6862), 1,
      anon_sym_LBRACK,
    ACTIONS(6864), 1,
      sym_private_property_identifier,
  [128668] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3754), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [128677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5692), 1,
      anon_sym_AMP,
    ACTIONS(5694), 1,
      anon_sym_PIPE,
    ACTIONS(5696), 1,
      anon_sym_extends,
  [128690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_LBRACE,
    ACTIONS(3505), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [128701] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3754), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [128710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(6866), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [128723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6868), 1,
      anon_sym_COMMA,
    ACTIONS(6870), 1,
      anon_sym_RBRACK,
    STATE(3671), 1,
      aux_sym_tuple_type_repeat1,
  [128736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 1,
      anon_sym_GT,
    ACTIONS(6872), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [128749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3615), 1,
      anon_sym_LBRACE,
    ACTIONS(3617), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [128760] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3754), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [128769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6874), 1,
      anon_sym_LBRACE,
    ACTIONS(6400), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [128780] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3941), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [128789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6876), 1,
      sym_identifier,
    ACTIONS(6878), 1,
      anon_sym_LBRACK,
    ACTIONS(6880), 1,
      sym_private_property_identifier,
  [128802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_AMP,
    ACTIONS(5346), 1,
      anon_sym_PIPE,
    ACTIONS(5348), 1,
      anon_sym_extends,
  [128815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6882), 1,
      sym_identifier,
    ACTIONS(6884), 1,
      anon_sym_LBRACK,
    ACTIONS(6886), 1,
      sym_private_property_identifier,
  [128828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6159), 1,
      anon_sym_COMMA,
    ACTIONS(6888), 1,
      anon_sym_LBRACE,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [128841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6890), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_LBRACK,
    ACTIONS(6894), 1,
      sym_private_property_identifier,
  [128854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6896), 1,
      anon_sym_LPAREN,
    ACTIONS(6898), 1,
      anon_sym_await,
    STATE(43), 1,
      sym__for_header,
  [128867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6900), 1,
      sym_identifier,
    ACTIONS(6902), 1,
      anon_sym_LBRACK,
    ACTIONS(6904), 1,
      sym_private_property_identifier,
  [128880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6906), 1,
      anon_sym_EQ,
    ACTIONS(6908), 1,
      anon_sym_COMMA,
    ACTIONS(6910), 1,
      anon_sym_from,
  [128893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      anon_sym_RBRACK,
    ACTIONS(6912), 1,
      anon_sym_COMMA,
    STATE(3748), 1,
      aux_sym_tuple_type_repeat1,
  [128906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    STATE(713), 1,
      sym_object_type,
  [128919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6914), 1,
      anon_sym_COMMA,
    ACTIONS(6916), 1,
      anon_sym_RBRACE,
    STATE(3680), 1,
      aux_sym_enum_body_repeat1,
  [128932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(6918), 1,
      anon_sym_GT,
  [128945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(6920), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [128958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_GT,
    ACTIONS(6922), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [128971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      sym_identifier,
    ACTIONS(6926), 1,
      anon_sym_LBRACK,
    ACTIONS(6928), 1,
      sym_private_property_identifier,
  [128984] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3754), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [128993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3533), 1,
      anon_sym_LBRACE,
    ACTIONS(3535), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [129004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_GT,
    ACTIONS(6930), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [129017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(6932), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    ACTIONS(6936), 1,
      anon_sym_GT,
    STATE(4006), 1,
      sym_type_parameter,
  [129043] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6564), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5290), 1,
      anon_sym_is,
    ACTIONS(5999), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [129076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(3529), 1,
      aux_sym_array_repeat1,
  [129089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6938), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [129098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 1,
      anon_sym_AMP,
    ACTIONS(5568), 1,
      anon_sym_extends,
    ACTIONS(6363), 1,
      anon_sym_PIPE,
  [129111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 1,
      sym_identifier,
    ACTIONS(6942), 1,
      anon_sym_LBRACK,
    ACTIONS(6944), 1,
      sym_private_property_identifier,
  [129124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1221), 1,
      anon_sym_LBRACE,
    STATE(659), 1,
      sym_object_type,
  [129137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 1,
      anon_sym_RBRACK,
    ACTIONS(6946), 1,
      anon_sym_COMMA,
    STATE(3748), 1,
      aux_sym_tuple_type_repeat1,
  [129150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6938), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [129159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(3548), 1,
      aux_sym_array_repeat1,
  [129172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6948), 1,
      anon_sym_COMMA,
    ACTIONS(6951), 1,
      anon_sym_RBRACE,
    STATE(3567), 1,
      aux_sym_export_clause_repeat1,
  [129185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5862), 1,
      anon_sym_LBRACK,
    ACTIONS(5864), 1,
      sym_private_property_identifier,
  [129211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(6953), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      sym_identifier,
    ACTIONS(6957), 1,
      anon_sym_LBRACK,
    ACTIONS(6959), 1,
      sym_private_property_identifier,
  [129246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6961), 1,
      anon_sym_COMMA,
    ACTIONS(6963), 1,
      anon_sym_RBRACK,
    STATE(3564), 1,
      aux_sym_tuple_type_repeat1,
  [129259] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6965), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129268] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6965), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3661), 1,
      anon_sym_LBRACE,
    ACTIONS(3663), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [129288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6970), 1,
      anon_sym_RBRACE,
    STATE(3577), 1,
      aux_sym_named_imports_repeat1,
  [129301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_DQUOTE,
    ACTIONS(1237), 1,
      anon_sym_SQUOTE,
    STATE(4066), 1,
      sym_string,
  [129314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3511), 1,
      anon_sym_LBRACE,
    ACTIONS(3513), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [129325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6972), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [129334] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6965), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6974), 1,
      anon_sym_as,
    ACTIONS(6976), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [129354] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6541), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6978), 1,
      sym_identifier,
    ACTIONS(6980), 1,
      anon_sym_LBRACK,
    ACTIONS(6982), 1,
      sym_private_property_identifier,
  [129376] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6984), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4471), 1,
      anon_sym_RPAREN,
    STATE(3594), 1,
      aux_sym_array_repeat1,
  [129398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4471), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6986), 1,
      sym_identifier,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6990), 1,
      sym_private_property_identifier,
  [129424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      anon_sym_COMMA,
    ACTIONS(6994), 1,
      anon_sym_RBRACE,
    STATE(3747), 1,
      aux_sym_export_clause_repeat1,
  [129437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 1,
      anon_sym_DQUOTE,
    ACTIONS(1288), 1,
      anon_sym_SQUOTE,
    STATE(3905), 1,
      sym_string,
  [129450] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3935), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 1,
      anon_sym_LBRACE,
    ACTIONS(6365), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [129470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5912), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [129479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(6998), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7000), 1,
      sym_identifier,
    STATE(2169), 1,
      sym_decorator_member_expression,
    STATE(2251), 1,
      sym_decorator_call_expression,
  [129505] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_GT,
    ACTIONS(7002), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [129518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7004), 1,
      anon_sym_LPAREN,
    ACTIONS(7006), 1,
      anon_sym_await,
    STATE(56), 1,
      sym__for_header,
  [129531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3045), 1,
      sym_type_predicate,
    ACTIONS(7008), 2,
      sym_identifier,
      sym_this,
  [129542] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3982), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7010), 1,
      sym_identifier,
    ACTIONS(7012), 1,
      anon_sym_LBRACK,
    ACTIONS(7014), 1,
      sym_private_property_identifier,
  [129564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      anon_sym_GT,
    ACTIONS(7016), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [129577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7018), 1,
      anon_sym_RBRACE,
    STATE(3703), 1,
      aux_sym_object_pattern_repeat1,
  [129590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7022), 1,
      anon_sym_RBRACE,
    STATE(3611), 1,
      aux_sym_object_repeat1,
  [129603] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4447), 1,
      anon_sym_RPAREN,
    STATE(3554), 1,
      aux_sym_array_repeat1,
  [129629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7022), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [129642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7024), 1,
      anon_sym_COMMA,
    ACTIONS(7026), 1,
      anon_sym_GT,
    STATE(3753), 1,
      aux_sym_type_parameters_repeat1,
  [129655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7028), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [129668] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      anon_sym_RBRACK,
    ACTIONS(7030), 1,
      anon_sym_COMMA,
    STATE(3748), 1,
      aux_sym_tuple_type_repeat1,
  [129681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    ACTIONS(7026), 1,
      anon_sym_GT,
    STATE(4006), 1,
      sym_type_parameter,
  [129694] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7032), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [129707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 1,
      anon_sym_implements,
    ACTIONS(7034), 1,
      anon_sym_LBRACE,
    STATE(4193), 1,
      sym_implements_clause,
  [129720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7036), 1,
      anon_sym_COMMA,
    ACTIONS(7038), 1,
      anon_sym_RBRACE,
    STATE(3642), 1,
      aux_sym_enum_body_repeat1,
  [129733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4438), 1,
      anon_sym_RPAREN,
    STATE(3620), 1,
      aux_sym_array_repeat1,
  [129746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4438), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7018), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [129772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7040), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [129785] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(7042), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7044), 1,
      anon_sym_COMMA,
    ACTIONS(7046), 1,
      anon_sym_RPAREN,
    STATE(3710), 1,
      aux_sym_formal_parameters_repeat1,
  [129807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(7048), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [129820] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(6965), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_GT,
    ACTIONS(7050), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [129842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    ACTIONS(7052), 1,
      anon_sym_RPAREN,
    STATE(4098), 1,
      sym_type_annotation,
  [129855] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(7054), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [129864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 1,
      anon_sym_COMMA,
    ACTIONS(7059), 1,
      anon_sym_RBRACK,
    STATE(3625), 1,
      aux_sym_array_pattern_repeat1,
  [129877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    STATE(3340), 1,
      sym_object_type,
  [129890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 1,
      anon_sym_COMMA,
    ACTIONS(7063), 1,
      anon_sym_RBRACE,
    STATE(3757), 1,
      aux_sym_enum_body_repeat1,
  [129903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_while,
    ACTIONS(7065), 1,
      anon_sym_else,
    STATE(773), 1,
      sym_else_clause,
  [129916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7067), 1,
      anon_sym_LBRACE,
    ACTIONS(6568), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [129927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5880), 1,
      anon_sym_EQ,
    ACTIONS(3087), 2,
      anon_sym_in,
      anon_sym_of,
  [129938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1358), 1,
      anon_sym_RPAREN,
    ACTIONS(7069), 1,
      anon_sym_COMMA,
    STATE(3685), 1,
      aux_sym_formal_parameters_repeat1,
  [129951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(6758), 1,
      anon_sym_RBRACK,
    STATE(3712), 1,
      aux_sym_array_pattern_repeat1,
  [129964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(7071), 1,
      anon_sym_GT,
  [129977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 1,
      anon_sym_COMMA,
    ACTIONS(7075), 1,
      anon_sym_GT,
    STATE(3607), 1,
      aux_sym_type_parameters_repeat1,
  [129990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACK,
    STATE(3711), 1,
      aux_sym_array_repeat1,
  [130003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(7077), 1,
      anon_sym_RBRACK,
    STATE(3625), 1,
      aux_sym_array_pattern_repeat1,
  [130016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACK,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [130029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(6758), 1,
      anon_sym_RBRACK,
    STATE(3625), 1,
      aux_sym_array_pattern_repeat1,
  [130042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(7081), 1,
      anon_sym_RBRACK,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [130064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 1,
      anon_sym_EQ,
    ACTIONS(7059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [130075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7083), 1,
      anon_sym_COMMA,
    ACTIONS(7085), 1,
      anon_sym_RBRACE,
    STATE(3757), 1,
      aux_sym_enum_body_repeat1,
  [130088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7087), 1,
      anon_sym_LPAREN,
    ACTIONS(7089), 1,
      anon_sym_await,
    STATE(38), 1,
      sym__for_header,
  [130101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7091), 1,
      anon_sym_COMMA,
    ACTIONS(7093), 1,
      anon_sym_GT,
    STATE(3716), 1,
      aux_sym_type_parameters_repeat1,
  [130114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7095), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7097), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4003), 1,
      sym_type_predicate,
    ACTIONS(7099), 2,
      sym_identifier,
      sym_this,
  [130143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(6754), 1,
      anon_sym_RBRACK,
    STATE(3625), 1,
      aux_sym_array_pattern_repeat1,
  [130156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4406), 1,
      anon_sym_RBRACK,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [130169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7095), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4464), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [130187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7101), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7103), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7105), 1,
      anon_sym_COMMA,
    ACTIONS(7107), 1,
      anon_sym_RPAREN,
    STATE(3631), 1,
      aux_sym_formal_parameters_repeat1,
  [130218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7103), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7109), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130236] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3957), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [130245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4406), 1,
      anon_sym_RBRACK,
    STATE(3640), 1,
      aux_sym_array_repeat1,
  [130258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    ACTIONS(7111), 1,
      anon_sym_as,
    STATE(3886), 1,
      sym__from_clause,
  [130271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(7113), 1,
      sym_identifier,
    STATE(3462), 1,
      sym_export_clause,
  [130284] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(4007), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [130293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(6754), 1,
      anon_sym_RBRACK,
    STATE(3636), 1,
      aux_sym_array_pattern_repeat1,
  [130306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 1,
      sym_identifier,
    ACTIONS(7117), 1,
      anon_sym_LBRACK,
    ACTIONS(7119), 1,
      sym_private_property_identifier,
  [130319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    ACTIONS(7121), 1,
      anon_sym_GT,
    STATE(4006), 1,
      sym_type_parameter,
  [130332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7123), 1,
      sym_identifier,
    ACTIONS(7125), 1,
      anon_sym_LBRACK,
    ACTIONS(7127), 1,
      sym_private_property_identifier,
  [130345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7129), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7131), 1,
      sym_identifier,
    ACTIONS(7133), 1,
      anon_sym_LBRACK,
    ACTIONS(7135), 1,
      sym_private_property_identifier,
  [130367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7137), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7139), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7141), 1,
      sym_identifier,
    ACTIONS(7143), 1,
      anon_sym_LBRACK,
    ACTIONS(7145), 1,
      sym_private_property_identifier,
  [130398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_RBRACK,
    ACTIONS(7147), 1,
      anon_sym_COMMA,
    STATE(3748), 1,
      aux_sym_tuple_type_repeat1,
  [130411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      sym_identifier,
    ACTIONS(7151), 1,
      anon_sym_require,
    STATE(3739), 1,
      sym_nested_identifier,
  [130424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(7153), 1,
      anon_sym_LPAREN,
    STATE(614), 1,
      sym_statement_block,
  [130437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4333), 1,
      anon_sym_extends,
    ACTIONS(7155), 1,
      anon_sym_AMP,
    ACTIONS(7157), 1,
      anon_sym_PIPE,
  [130450] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3974), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [130459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4466), 1,
      anon_sym_RPAREN,
    STATE(3737), 1,
      aux_sym_array_repeat1,
  [130472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4466), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [130485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7159), 1,
      anon_sym_COMMA,
    ACTIONS(7161), 1,
      anon_sym_RBRACE,
    STATE(3757), 1,
      aux_sym_enum_body_repeat1,
  [130498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7095), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7163), 1,
      anon_sym_COMMA,
    ACTIONS(7165), 1,
      anon_sym_RBRACE,
    STATE(3757), 1,
      aux_sym_enum_body_repeat1,
  [130520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym_identifier,
    ACTIONS(5985), 1,
      anon_sym_LBRACK,
    ACTIONS(5987), 1,
      sym_private_property_identifier,
  [130533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7167), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [130542] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3834), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [130551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7169), 1,
      sym_identifier,
    ACTIONS(7171), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [130562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7173), 1,
      anon_sym_COMMA,
    ACTIONS(7176), 1,
      anon_sym_RPAREN,
    STATE(3685), 1,
      aux_sym_formal_parameters_repeat1,
  [130575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(7178), 1,
      anon_sym_EQ,
    STATE(4169), 1,
      sym_type_parameters,
  [130588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6373), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6658), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6373), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    ACTIONS(7188), 1,
      anon_sym_RBRACK,
    STATE(3696), 1,
      aux_sym_tuple_type_repeat1,
  [130664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_RBRACK,
    ACTIONS(7192), 1,
      anon_sym_COMMA,
    STATE(3748), 1,
      aux_sym_tuple_type_repeat1,
  [130686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 1,
      sym_identifier,
    STATE(1106), 1,
      sym_decorator_member_expression,
    STATE(1149), 1,
      sym_decorator_call_expression,
  [130699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7196), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [130712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7200), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7204), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [130752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7206), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [130765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7210), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [130787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 1,
      sym_identifier,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    ACTIONS(7216), 1,
      sym_private_property_identifier,
  [130800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 1,
      anon_sym_RPAREN,
    ACTIONS(7220), 1,
      anon_sym_COMMA,
    STATE(3685), 1,
      aux_sym_formal_parameters_repeat1,
  [130840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(7222), 1,
      anon_sym_RBRACK,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [130853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1580), 1,
      anon_sym_COMMA,
    ACTIONS(7224), 1,
      anon_sym_RBRACK,
    STATE(3625), 1,
      aux_sym_array_pattern_repeat1,
  [130866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7079), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7228), 1,
      anon_sym_RBRACE,
    STATE(3520), 1,
      aux_sym_object_pattern_repeat1,
  [130897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7121), 1,
      anon_sym_GT,
    ACTIONS(7230), 1,
      anon_sym_COMMA,
    STATE(3753), 1,
      aux_sym_type_parameters_repeat1,
  [130910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_while,
    ACTIONS(7232), 1,
      anon_sym_else,
    STATE(773), 1,
      sym_else_clause,
  [130923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    ACTIONS(7111), 1,
      anon_sym_as,
    STATE(4036), 1,
      sym__from_clause,
  [130936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7234), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130945] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(3947), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [130954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 1,
      anon_sym_COMMA,
    ACTIONS(7238), 1,
      anon_sym_RPAREN,
    STATE(3777), 1,
      aux_sym_formal_parameters_repeat1,
  [130967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6837), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [130994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 1,
      anon_sym_EQ,
    ACTIONS(3046), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [131005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7247), 1,
      sym_identifier,
    ACTIONS(7249), 1,
      anon_sym_LBRACK,
    ACTIONS(7251), 1,
      sym_private_property_identifier,
  [131027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7253), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7245), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 1,
      anon_sym_LBRACE,
    ACTIONS(7257), 1,
      sym_identifier,
    STATE(3508), 1,
      sym_export_clause,
  [131076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3469), 1,
      anon_sym_extends,
    ACTIONS(7259), 1,
      anon_sym_AMP,
    ACTIONS(7261), 1,
      anon_sym_PIPE,
  [131089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7263), 1,
      sym_identifier,
    ACTIONS(7265), 1,
      anon_sym_LBRACK,
    ACTIONS(7267), 1,
      sym_private_property_identifier,
  [131102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7269), 1,
      anon_sym_COMMA,
    ACTIONS(7271), 1,
      anon_sym_RBRACK,
    STATE(3609), 1,
      aux_sym_tuple_type_repeat1,
  [131115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_EQ,
    ACTIONS(3087), 2,
      anon_sym_in,
      anon_sym_of,
  [131126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(7275), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [131139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1270), 1,
      anon_sym_LBRACE,
    STATE(3307), 1,
      sym_object_type,
  [131152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_DOT,
    ACTIONS(7277), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_GT,
    ACTIONS(7279), 1,
      anon_sym_COMMA,
    STATE(3414), 1,
      aux_sym_implements_clause_repeat1,
  [131176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7281), 1,
      anon_sym_COMMA,
    ACTIONS(7283), 1,
      anon_sym_RBRACE,
    STATE(3577), 1,
      aux_sym_named_imports_repeat1,
  [131189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    ACTIONS(7285), 1,
      anon_sym_GT,
    STATE(4006), 1,
      sym_type_parameter,
  [131202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7287), 1,
      anon_sym_as,
    ACTIONS(7289), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7291), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [131222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_RPAREN,
    STATE(3570), 1,
      aux_sym_array_repeat1,
  [131235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7293), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [131244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7295), 1,
      anon_sym_COMMA,
    ACTIONS(7297), 1,
      anon_sym_RBRACE,
    STATE(3567), 1,
      aux_sym_export_clause_repeat1,
  [131257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7299), 1,
      anon_sym_COMMA,
    ACTIONS(7302), 1,
      anon_sym_RBRACK,
    STATE(3748), 1,
      aux_sym_tuple_type_repeat1,
  [131270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [131279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_LT,
    ACTIONS(7306), 1,
      anon_sym_EQ,
    STATE(4242), 1,
      sym_type_parameters,
  [131292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 1,
      anon_sym_COMMA,
    ACTIONS(4459), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_array_repeat1,
  [131305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_LBRACE,
    ACTIONS(6456), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [131316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7308), 1,
      anon_sym_COMMA,
    ACTIONS(7311), 1,
      anon_sym_GT,
    STATE(3753), 1,
      aux_sym_type_parameters_repeat1,
  [131329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      sym_identifier,
    ACTIONS(7315), 1,
      anon_sym_LBRACK,
    ACTIONS(7317), 1,
      sym_private_property_identifier,
  [131342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3310), 1,
      sym_type_predicate,
    ACTIONS(7319), 2,
      sym_identifier,
      sym_this,
  [131353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(7321), 1,
      anon_sym_GT,
  [131366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7323), 1,
      anon_sym_COMMA,
    ACTIONS(7326), 1,
      anon_sym_RBRACE,
    STATE(3757), 1,
      aux_sym_enum_body_repeat1,
  [131379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_COMMA,
    ACTIONS(7228), 1,
      anon_sym_RBRACE,
    STATE(3705), 1,
      aux_sym_object_pattern_repeat1,
  [131392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7328), 1,
      anon_sym_RBRACE,
    STATE(3774), 1,
      aux_sym_object_repeat1,
  [131405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7328), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [131418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 1,
      anon_sym_EQ,
    ACTIONS(7330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7332), 1,
      sym_identifier,
    ACTIONS(7334), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7338), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5820), 1,
      anon_sym_DOT,
    ACTIONS(7340), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7342), 1,
      anon_sym_COMMA,
    ACTIONS(7344), 1,
      anon_sym_RBRACE,
    STATE(3741), 1,
      aux_sym_named_imports_repeat1,
  [131500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      anon_sym_AMP,
    ACTIONS(6006), 1,
      anon_sym_PIPE,
    ACTIONS(6008), 1,
      anon_sym_extends,
  [131513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5991), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [131522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7020), 1,
      anon_sym_COMMA,
    ACTIONS(7348), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [131562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6908), 1,
      anon_sym_COMMA,
    ACTIONS(6910), 1,
      anon_sym_from,
    ACTIONS(7350), 1,
      anon_sym_EQ,
  [131575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7352), 1,
      anon_sym_COMMA,
    ACTIONS(7355), 1,
      anon_sym_RBRACE,
    STATE(3776), 1,
      aux_sym_object_repeat1,
  [131588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 1,
      anon_sym_RPAREN,
    ACTIONS(7357), 1,
      anon_sym_COMMA,
    STATE(3685), 1,
      aux_sym_formal_parameters_repeat1,
  [131601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7359), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7361), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3368), 1,
      sym_class_body,
  [131638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4227), 1,
      sym_formal_parameters,
  [131648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5586), 1,
      anon_sym_LPAREN,
    STATE(2354), 1,
      sym_arguments,
  [131658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3898), 1,
      sym__from_clause,
  [131668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7363), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7365), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4396), 1,
      sym_formal_parameters,
  [131694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(628), 1,
      sym_statement_block,
  [131704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3986), 1,
      sym_statement_block,
  [131714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      sym_identifier,
    STATE(3766), 1,
      sym_nested_identifier,
  [131724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(51), 1,
      sym_parenthesized_expression,
  [131734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7313), 1,
      sym_identifier,
    ACTIONS(7317), 1,
      sym_private_property_identifier,
  [131752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1391), 1,
      sym_statement_block,
  [131762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3983), 1,
      sym_statement_block,
  [131772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3828), 1,
      sym_statement_block,
  [131790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1389), 1,
      sym_class_body,
  [131800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7373), 1,
      sym_identifier,
    ACTIONS(7375), 1,
      sym_private_property_identifier,
  [131810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3318), 1,
      sym_class_body,
  [131820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    STATE(3151), 1,
      sym_statement_block,
  [131830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7377), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5153), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3826), 1,
      sym_statement_block,
  [131864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(716), 1,
      sym_class_body,
  [131882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7379), 1,
      anon_sym_SEMI,
    ACTIONS(7381), 1,
      sym__automatic_semicolon,
  [131892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7383), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [131900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1373), 1,
      sym_class_body,
  [131910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    STATE(1379), 1,
      sym_arguments,
  [131920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1832), 1,
      sym_class_body,
  [131930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7385), 1,
      anon_sym_LBRACE,
    STATE(718), 1,
      sym_switch_body,
  [131940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3388), 1,
      sym_formal_parameters,
  [131950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    STATE(3177), 1,
      sym_statement_block,
  [131960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3955), 1,
      sym__from_clause,
  [131970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(618), 1,
      sym_class_body,
  [131980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7387), 1,
      sym_identifier,
    STATE(3739), 1,
      sym_nested_identifier,
  [131990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7302), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [131998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [132006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(7321), 1,
      anon_sym_GT,
  [132016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7391), 1,
      sym_identifier,
    ACTIONS(7393), 1,
      anon_sym_STAR,
  [132026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1830), 1,
      sym_statement_block,
  [132036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_SEMI,
    ACTIONS(7397), 1,
      sym__automatic_semicolon,
  [132046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7399), 1,
      sym_identifier,
    ACTIONS(7401), 1,
      sym_private_property_identifier,
  [132056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3854), 1,
      sym_statement_block,
  [132074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4190), 1,
      sym_formal_parameters,
  [132092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4191), 1,
      sym_formal_parameters,
  [132102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3376), 1,
      sym_class_body,
  [132120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1917), 1,
      sym_class_body,
  [132130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3857), 1,
      sym_statement_block,
  [132140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    STATE(1563), 1,
      sym_arguments,
  [132150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7403), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym__for_header,
  [132160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1376), 1,
      sym_statement_block,
  [132178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1387), 1,
      sym_statement_block,
  [132188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1399), 1,
      sym_class_body,
  [132198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4395), 1,
      sym_formal_parameters,
  [132208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7405), 1,
      sym_identifier,
    ACTIONS(7407), 1,
      anon_sym_STAR,
  [132218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7409), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7411), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7413), 1,
      sym_identifier,
    ACTIONS(7415), 1,
      sym_private_property_identifier,
  [132244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      sym_identifier,
    ACTIONS(7419), 1,
      sym_private_property_identifier,
  [132254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1880), 1,
      sym_class_body,
  [132264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4013), 1,
      anon_sym_LPAREN,
    STATE(1808), 1,
      sym_arguments,
  [132274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7421), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_LBRACE,
    STATE(3301), 1,
      sym_enum_body,
  [132292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3026), 1,
      sym_formal_parameters,
  [132302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7425), 1,
      anon_sym_SEMI,
    ACTIONS(7427), 1,
      sym__automatic_semicolon,
  [132312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3901), 1,
      sym_statement_block,
  [132338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7429), 1,
      anon_sym_in,
    ACTIONS(7431), 1,
      anon_sym_COLON,
  [132348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5157), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LBRACE,
    STATE(771), 1,
      sym_enum_body,
  [132366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3903), 1,
      sym_statement_block,
  [132376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7435), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [132392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2638), 1,
      sym_formal_parameters,
  [132410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym_statement_block,
  [132420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_LPAREN,
    STATE(1231), 1,
      sym_arguments,
  [132430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(2012), 1,
      sym_class_body,
  [132440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      anon_sym_in,
    ACTIONS(6377), 1,
      anon_sym_of,
  [132450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 1,
      anon_sym_SEMI,
    ACTIONS(7441), 1,
      sym__automatic_semicolon,
  [132468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7443), 1,
      anon_sym_SEMI,
    ACTIONS(7445), 1,
      sym__automatic_semicolon,
  [132478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7176), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [132486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1903), 1,
      sym_class_body,
  [132496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1904), 1,
      sym_statement_block,
  [132506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3803), 1,
      sym_statement_block,
  [132516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7447), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3806), 1,
      sym_statement_block,
  [132558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7449), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [132566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5358), 1,
      anon_sym_COLON,
    STATE(3700), 1,
      sym_type_annotation,
  [132576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7451), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [132584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5141), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_class_body,
  [132602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_statement_block,
  [132612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7453), 1,
      anon_sym_SEMI,
    ACTIONS(7455), 1,
      sym__automatic_semicolon,
  [132622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7457), 1,
      anon_sym_LPAREN,
    STATE(3946), 1,
      sym_parenthesized_expression,
  [132632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5983), 1,
      sym_identifier,
    ACTIONS(5987), 1,
      sym_private_property_identifier,
  [132642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(738), 1,
      sym_class_body,
  [132652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(152), 1,
      sym_class_body,
  [132662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [132672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_LBRACE,
    STATE(3281), 1,
      sym_enum_body,
  [132682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    STATE(3279), 1,
      sym_statement_block,
  [132692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7459), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5091), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5133), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7461), 1,
      anon_sym_SEMI,
    ACTIONS(7463), 1,
      sym__automatic_semicolon,
  [132734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(762), 1,
      sym_class_body,
  [132744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      sym_statement_block,
  [132754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5101), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3931), 1,
      sym_statement_block,
  [132772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5097), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [132780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7403), 1,
      anon_sym_LPAREN,
    STATE(48), 1,
      sym__for_header,
  [132790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1371), 1,
      sym_class_body,
  [132808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(2055), 1,
      sym_class_body,
  [132818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1374), 1,
      sym_statement_block,
  [132828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(732), 1,
      sym_statement_block,
  [132838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7467), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [132846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7469), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [132854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    STATE(3820), 1,
      sym_type_annotation,
  [132864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3144), 1,
      sym_formal_parameters,
  [132874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3804), 1,
      sym_statement_block,
  [132884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    STATE(3644), 1,
      sym_type_parameter,
  [132894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [132902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7471), 1,
      sym_identifier,
    ACTIONS(7473), 1,
      sym_private_property_identifier,
  [132912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1357), 1,
      sym_statement_block,
  [132922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7475), 1,
      sym_identifier,
    ACTIONS(7477), 1,
      sym_private_property_identifier,
  [132932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(3813), 1,
      sym_parenthesized_expression,
  [132942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3870), 1,
      sym__from_clause,
  [132952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7115), 1,
      sym_identifier,
    ACTIONS(7119), 1,
      sym_private_property_identifier,
  [132962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3099), 1,
      sym_class_body,
  [132972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_class_body,
  [132982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_LPAREN,
    STATE(2835), 1,
      sym_formal_parameters,
  [132992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1845), 1,
      sym_class_body,
  [133002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [133010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [133018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1363), 1,
      sym_class_body,
  [133028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1372), 1,
      sym_statement_block,
  [133038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5145), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7479), 1,
      sym_identifier,
    ACTIONS(7481), 1,
      sym_private_property_identifier,
  [133056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(47), 1,
      sym_parenthesized_expression,
  [133066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym_parenthesized_expression,
  [133076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1860), 1,
      sym_statement_block,
  [133086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
  [133096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    STATE(3634), 1,
      sym_type_parameter,
  [133106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3338), 1,
      sym_class_body,
  [133116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7355), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 1,
      sym_identifier,
    STATE(4006), 1,
      sym_type_parameter,
  [133134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6852), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3356), 1,
      sym_class_body,
  [133152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      sym_jsx_identifier,
    ACTIONS(7483), 1,
      sym_identifier,
  [133162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1767), 1,
      sym_statement_block,
  [133172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1772), 1,
      sym_class_body,
  [133198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      sym_identifier,
    ACTIONS(7491), 1,
      anon_sym_STAR,
  [133208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1817), 1,
      sym_class_body,
  [133218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4293), 1,
      sym_formal_parameters,
  [133228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7403), 1,
      anon_sym_LPAREN,
    STATE(53), 1,
      sym__for_header,
  [133238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7493), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [133246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [133256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym_parenthesized_expression,
  [133266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7495), 1,
      anon_sym_SEMI,
    ACTIONS(7497), 1,
      sym__automatic_semicolon,
  [133276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(2009), 1,
      sym_class_body,
  [133286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(2036), 1,
      sym_class_body,
  [133296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7499), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [133304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5356), 1,
      anon_sym_LPAREN,
    STATE(2748), 1,
      sym_formal_parameters,
  [133314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_parenthesized_expression,
  [133324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7501), 1,
      anon_sym_SEMI,
    ACTIONS(7503), 1,
      sym__automatic_semicolon,
  [133334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 2,
      anon_sym_in,
      anon_sym_of,
  [133342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1795), 1,
      sym_statement_block,
  [133352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4287), 1,
      sym_formal_parameters,
  [133362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7505), 1,
      sym_identifier,
    ACTIONS(7507), 1,
      sym_private_property_identifier,
  [133372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(634), 1,
      sym_statement_block,
  [133382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7433), 1,
      anon_sym_LBRACE,
    STATE(633), 1,
      sym_enum_body,
  [133392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7509), 1,
      sym_identifier,
    ACTIONS(7511), 1,
      sym_private_property_identifier,
  [133402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1851), 1,
      sym_class_body,
  [133412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7513), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [133420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    STATE(2499), 1,
      sym_arguments,
  [133438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1908), 1,
      sym_class_body,
  [133448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1905), 1,
      sym_statement_block,
  [133458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7515), 1,
      sym_identifier,
    ACTIONS(7517), 1,
      sym_private_property_identifier,
  [133468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7519), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5860), 1,
      sym_identifier,
    ACTIONS(5864), 1,
      sym_private_property_identifier,
  [133486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1881), 1,
      sym_class_body,
  [133496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1895), 1,
      sym_statement_block,
  [133506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1876), 1,
      sym_statement_block,
  [133516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_class_body,
  [133526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1870), 1,
      sym_class_body,
  [133536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5087), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3877), 1,
      sym_statement_block,
  [133554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6955), 1,
      sym_identifier,
    ACTIONS(6959), 1,
      sym_private_property_identifier,
  [133564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(3883), 1,
      sym_statement_block,
  [133582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3108), 1,
      sym_formal_parameters,
  [133592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(629), 1,
      sym_class_body,
  [133602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      anon_sym_LBRACE,
    STATE(619), 1,
      sym_statement_block,
  [133612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(585), 1,
      sym_statement_block,
  [133622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
  [133632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(622), 1,
      sym_class_body,
  [133642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      sym_identifier,
    ACTIONS(7523), 1,
      anon_sym_STAR,
  [133652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1424), 1,
      sym_class_body,
  [133670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7525), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [133686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [133694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1329), 1,
      sym_statement_block,
  [133704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1840), 1,
      sym_class_body,
  [133714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(147), 1,
      sym_class_body,
  [133724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5999), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [133732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4123), 1,
      sym_formal_parameters,
  [133742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_LBRACE,
    STATE(1366), 1,
      sym_statement_block,
  [133752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [133760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(7071), 1,
      anon_sym_GT,
  [133770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1342), 1,
      sym_class_body,
  [133780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(7071), 1,
      anon_sym_GT,
  [133790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      sym_identifier,
    ACTIONS(7531), 1,
      sym_private_property_identifier,
  [133800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1866), 1,
      sym_statement_block,
  [133810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3350), 1,
      sym_class_body,
  [133820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4117), 1,
      sym_formal_parameters,
  [133830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1884), 1,
      sym_statement_block,
  [133840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(3155), 1,
      sym_formal_parameters,
  [133850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5700), 1,
      anon_sym_LBRACE,
    STATE(3354), 1,
      sym_class_body,
  [133868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(6918), 1,
      anon_sym_GT,
  [133878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [133886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 1,
      anon_sym_LBRACE,
    STATE(1350), 1,
      sym_class_body,
  [133896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(6918), 1,
      anon_sym_GT,
  [133906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6694), 1,
      anon_sym_from,
    STATE(3824), 1,
      sym__from_clause,
  [133916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 1,
      anon_sym_LBRACE,
    STATE(711), 1,
      sym_class_body,
  [133926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 1,
      anon_sym_LBRACE,
    STATE(142), 1,
      sym_statement_block,
  [133944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1826), 1,
      sym_class_body,
  [133954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1787), 1,
      sym_statement_block,
  [133964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_identifier,
    ACTIONS(7537), 1,
      sym_private_property_identifier,
  [133974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7539), 1,
      sym_identifier,
    ACTIONS(7541), 1,
      sym_private_property_identifier,
  [133984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7543), 1,
      sym_identifier,
    ACTIONS(7545), 1,
      sym_private_property_identifier,
  [133994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(6858), 1,
      anon_sym_GT,
  [134004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6876), 1,
      sym_identifier,
    ACTIONS(6880), 1,
      sym_private_property_identifier,
  [134014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4232), 1,
      sym_formal_parameters,
  [134024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1872), 1,
      sym_class_body,
  [134034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4083), 1,
      sym_formal_parameters,
  [134044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_SEMI,
    ACTIONS(7549), 1,
      sym__automatic_semicolon,
  [134054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5268), 1,
      anon_sym_DOT,
    ACTIONS(7321), 1,
      anon_sym_GT,
  [134064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COLON,
    STATE(3911), 1,
      sym_type_annotation,
  [134074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3377), 1,
      anon_sym_LBRACE,
    STATE(1892), 1,
      sym_statement_block,
  [134084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LPAREN,
    STATE(2354), 1,
      sym_arguments,
  [134094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6860), 1,
      sym_identifier,
    ACTIONS(6864), 1,
      sym_private_property_identifier,
  [134104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    STATE(1896), 1,
      sym_class_body,
  [134114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LPAREN,
    STATE(4055), 1,
      sym_formal_parameters,
  [134124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      anon_sym_LPAREN,
    STATE(2605), 1,
      sym_arguments,
  [134134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5742), 1,
      anon_sym_LBRACE,
    STATE(139), 1,
      sym_class_body,
  [134144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5485), 1,
      anon_sym_COLON,
    ACTIONS(6858), 1,
      anon_sym_GT,
  [134154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7551), 1,
      sym_identifier,
    ACTIONS(7553), 1,
      sym_private_property_identifier,
  [134164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 1,
      anon_sym_GT,
  [134171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6870), 1,
      anon_sym_RBRACK,
  [134178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7557), 1,
      anon_sym_EQ_GT,
  [134185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7559), 1,
      anon_sym_EQ_GT,
  [134192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 1,
      anon_sym_DOT,
  [134199] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_regex_pattern,
  [134206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7563), 1,
      anon_sym_EQ_GT,
  [134213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7565), 1,
      anon_sym_EQ_GT,
  [134220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7567), 1,
      anon_sym_EQ_GT,
  [134227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7569), 1,
      anon_sym_COLON,
  [134234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7571), 1,
      anon_sym_EQ_GT,
  [134241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7573), 1,
      anon_sym_LBRACK,
  [134248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7575), 1,
      anon_sym_RBRACK,
  [134255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7577), 1,
      sym_identifier,
  [134262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7579), 1,
      sym_identifier,
  [134269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      anon_sym_RBRACK,
  [134276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7071), 1,
      anon_sym_GT,
  [134283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7581), 1,
      anon_sym_GT,
  [134290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_RPAREN,
  [134297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      anon_sym_GT,
  [134304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7587), 1,
      anon_sym_from,
  [134311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7589), 1,
      anon_sym_GT,
  [134318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7587), 1,
      anon_sym_from,
  [134325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4591), 1,
      anon_sym_COLON,
  [134332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7591), 1,
      anon_sym_GT,
  [134339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
  [134346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
  [134353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7593), 1,
      anon_sym_GT,
  [134360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
  [134367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7595), 1,
      anon_sym_GT,
  [134374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 1,
      anon_sym_DOT,
  [134381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7597), 1,
      anon_sym_GT,
  [134388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7599), 1,
      anon_sym_GT,
  [134395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7601), 1,
      anon_sym_RBRACK,
  [134402] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(7603), 1,
      sym_regex_pattern,
  [134409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7605), 1,
      anon_sym_EQ_GT,
  [134416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7607), 1,
      anon_sym_EQ_GT,
  [134423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7609), 1,
      anon_sym_EQ_GT,
  [134430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7611), 1,
      anon_sym_EQ_GT,
  [134437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6574), 1,
      anon_sym_EQ,
  [134444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7613), 1,
      anon_sym_EQ_GT,
  [134451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7615), 1,
      anon_sym_from,
  [134458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7617), 1,
      anon_sym_EQ_GT,
  [134465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7619), 1,
      anon_sym_COLON,
  [134472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7621), 1,
      anon_sym_EQ_GT,
  [134479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7623), 1,
      anon_sym_EQ_GT,
  [134486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7625), 1,
      anon_sym_EQ_GT,
  [134493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7627), 1,
      anon_sym_RBRACK,
  [134500] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(7629), 1,
      sym_regex_pattern,
  [134507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_RPAREN,
  [134514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7631), 1,
      anon_sym_RPAREN,
  [134521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7633), 1,
      anon_sym_COLON,
  [134528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7635), 1,
      anon_sym_RBRACK,
  [134535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5957), 1,
      anon_sym_DOT,
  [134542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7637), 1,
      anon_sym_RBRACK,
  [134549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7639), 1,
      anon_sym_from,
  [134556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 1,
      anon_sym_RBRACK,
  [134563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      anon_sym_LPAREN,
  [134570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 1,
      anon_sym_RBRACK,
  [134577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7647), 1,
      anon_sym_RBRACK,
  [134584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym_from,
  [134591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_RBRACK,
  [134598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 1,
      anon_sym_from,
  [134605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 1,
      anon_sym_RBRACK,
  [134612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7657), 1,
      anon_sym_require,
  [134619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7659), 1,
      anon_sym_RBRACK,
  [134626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7661), 1,
      anon_sym_RBRACK,
  [134633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_RBRACK,
  [134640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7665), 1,
      anon_sym_RBRACK,
  [134647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_EQ_GT,
  [134654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5513), 1,
      anon_sym_DOT,
  [134661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4647), 1,
      anon_sym_RPAREN,
  [134668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7669), 1,
      anon_sym_RPAREN,
  [134675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7671), 1,
      anon_sym_RPAREN,
  [134682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7673), 1,
      anon_sym_RPAREN,
  [134689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 1,
      anon_sym_EQ_GT,
  [134696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7677), 1,
      anon_sym_RPAREN,
  [134703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7679), 1,
      anon_sym_EQ_GT,
  [134710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7681), 1,
      sym_identifier,
  [134717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7683), 1,
      anon_sym_RBRACK,
  [134724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7685), 1,
      anon_sym_RBRACK,
  [134731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7687), 1,
      sym_identifier,
  [134738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7689), 1,
      anon_sym_RBRACK,
  [134745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7691), 1,
      anon_sym_RBRACK,
  [134752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7693), 1,
      anon_sym_RBRACK,
  [134759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7695), 1,
      anon_sym_RBRACK,
  [134766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_RBRACK,
  [134773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7699), 1,
      anon_sym_class,
  [134780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7701), 1,
      sym_identifier,
  [134787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7703), 1,
      anon_sym_EQ_GT,
  [134794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7705), 1,
      anon_sym_RBRACK,
  [134801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7707), 1,
      anon_sym_EQ,
  [134808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7709), 1,
      anon_sym_namespace,
  [134815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7711), 1,
      anon_sym_RBRACK,
  [134822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3799), 1,
      anon_sym_DOT,
  [134829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7713), 1,
      anon_sym_EQ_GT,
  [134836] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(7715), 1,
      sym_regex_pattern,
  [134843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7717), 1,
      sym_identifier,
  [134850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7719), 1,
      sym_identifier,
  [134857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7721), 1,
      sym_identifier,
  [134864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7723), 1,
      anon_sym_from,
  [134871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7725), 1,
      sym_identifier,
  [134878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7727), 1,
      sym_identifier,
  [134885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7729), 1,
      sym_identifier,
  [134892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7731), 1,
      sym_identifier,
  [134899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_EQ_GT,
  [134906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      sym_identifier,
  [134913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7737), 1,
      anon_sym_EQ_GT,
  [134920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7739), 1,
      anon_sym_EQ_GT,
  [134927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7741), 1,
      anon_sym_RBRACK,
  [134934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4651), 1,
      anon_sym_RBRACE,
  [134941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7113), 1,
      sym_identifier,
  [134948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7743), 1,
      sym_identifier,
  [134955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      sym_identifier,
  [134962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      anon_sym_class,
  [134969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7749), 1,
      anon_sym_RBRACK,
  [134976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_RBRACK,
  [134983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4601), 1,
      anon_sym_RBRACK,
  [134990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7753), 1,
      anon_sym_RBRACK,
  [134997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 1,
      anon_sym_EQ,
  [135004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7757), 1,
      anon_sym_RBRACK,
  [135011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7759), 1,
      anon_sym_EQ,
  [135018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7761), 1,
      anon_sym_RBRACK,
  [135025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 1,
      anon_sym_RBRACK,
  [135032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7765), 1,
      anon_sym_RBRACK,
  [135039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7767), 1,
      anon_sym_RBRACK,
  [135046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7769), 1,
      anon_sym_RBRACK,
  [135053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7771), 1,
      sym_identifier,
  [135060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7773), 1,
      sym_identifier,
  [135067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4575), 1,
      anon_sym_RBRACE,
  [135074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7775), 1,
      anon_sym_RBRACK,
  [135081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7777), 1,
      anon_sym_RBRACK,
  [135088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7779), 1,
      anon_sym_RBRACK,
  [135095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7781), 1,
      anon_sym_RBRACK,
  [135102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7783), 1,
      anon_sym_RBRACK,
  [135109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7785), 1,
      anon_sym_RBRACK,
  [135116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7787), 1,
      anon_sym_RBRACK,
  [135123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 1,
      anon_sym_COLON,
  [135130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7791), 1,
      anon_sym_RBRACK,
  [135137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7793), 1,
      anon_sym_RBRACK,
  [135144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7795), 1,
      anon_sym_RBRACK,
  [135151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7797), 1,
      anon_sym_RBRACK,
  [135158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7799), 1,
      anon_sym_EQ_GT,
  [135165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7801), 1,
      anon_sym_EQ_GT,
  [135172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7803), 1,
      sym_identifier,
  [135179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7805), 1,
      anon_sym_LBRACE,
  [135186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7807), 1,
      anon_sym_EQ_GT,
  [135193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7809), 1,
      anon_sym_EQ_GT,
  [135200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5276), 1,
      anon_sym_DOT,
  [135207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7811), 1,
      sym_identifier,
  [135214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6856), 1,
      anon_sym_RBRACK,
  [135221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7813), 1,
      sym_number,
  [135228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7815), 1,
      anon_sym_EQ_GT,
  [135235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7817), 1,
      sym_identifier,
  [135242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7819), 1,
      sym_number,
  [135249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7821), 1,
      sym_identifier,
  [135256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 1,
      anon_sym_readonly,
  [135263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7825), 1,
      anon_sym_SLASH2,
  [135270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7827), 1,
      anon_sym_RBRACK,
  [135277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7829), 1,
      anon_sym_RBRACK,
  [135284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7831), 1,
      anon_sym_RBRACK,
  [135291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_RBRACK,
  [135298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7835), 1,
      anon_sym_RBRACK,
  [135305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7837), 1,
      anon_sym_GT,
  [135312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7839), 1,
      anon_sym_RBRACK,
  [135319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7841), 1,
      anon_sym_RBRACK,
  [135326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7843), 1,
      anon_sym_RBRACK,
  [135333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7845), 1,
      anon_sym_RBRACK,
  [135340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_RBRACK,
  [135347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7849), 1,
      anon_sym_RBRACK,
  [135354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7851), 1,
      anon_sym_RBRACK,
  [135361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7853), 1,
      anon_sym_RBRACK,
  [135368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7855), 1,
      anon_sym_RBRACK,
  [135375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7857), 1,
      anon_sym_RBRACK,
  [135382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7859), 1,
      anon_sym_RBRACK,
  [135389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7861), 1,
      anon_sym_RBRACK,
  [135396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7863), 1,
      anon_sym_RBRACK,
  [135403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7865), 1,
      anon_sym_RBRACK,
  [135410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7867), 1,
      anon_sym_RBRACK,
  [135417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7869), 1,
      anon_sym_EQ_GT,
  [135424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_GT,
  [135431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7873), 1,
      anon_sym_RPAREN,
  [135438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7875), 1,
      anon_sym_GT,
  [135445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7321), 1,
      anon_sym_GT,
  [135452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7877), 1,
      anon_sym_EQ_GT,
  [135459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7879), 1,
      sym_identifier,
  [135466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7881), 1,
      anon_sym_EQ_GT,
  [135473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7188), 1,
      anon_sym_RBRACK,
  [135480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7883), 1,
      anon_sym_GT,
  [135487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_GT,
  [135494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7887), 1,
      anon_sym_GT,
  [135501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7889), 1,
      anon_sym_COLON,
  [135508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_GT,
  [135515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 1,
      anon_sym_GT,
  [135522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7895), 1,
      anon_sym_EQ,
  [135529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3233), 1,
      anon_sym_LPAREN,
  [135536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7897), 1,
      anon_sym_EQ_GT,
  [135543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7899), 1,
      anon_sym_from,
  [135550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7901), 1,
      anon_sym_RBRACE,
  [135557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7903), 1,
      sym_identifier,
  [135564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7905), 1,
      sym_number,
  [135571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7907), 1,
      anon_sym_GT,
  [135578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_RPAREN,
  [135585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      sym_identifier,
  [135592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7913), 1,
      anon_sym_SLASH2,
  [135599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4319), 1,
      anon_sym_RPAREN,
  [135606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 1,
      anon_sym_RBRACK,
  [135613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7917), 1,
      anon_sym_RBRACK,
  [135620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 1,
      anon_sym_RBRACK,
  [135627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7921), 1,
      anon_sym_RBRACK,
  [135634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7923), 1,
      anon_sym_RBRACK,
  [135641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7925), 1,
      anon_sym_RBRACK,
  [135648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 1,
      anon_sym_RBRACK,
  [135655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7929), 1,
      anon_sym_EQ_GT,
  [135662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7931), 1,
      anon_sym_RBRACK,
  [135669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7933), 1,
      anon_sym_EQ,
  [135676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7935), 1,
      anon_sym_EQ,
  [135683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7937), 1,
      anon_sym_RBRACK,
  [135690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7939), 1,
      anon_sym_RBRACK,
  [135697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7941), 1,
      anon_sym_RBRACK,
  [135704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7943), 1,
      sym_identifier,
  [135711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7945), 1,
      anon_sym_EQ_GT,
  [135718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7947), 1,
      anon_sym_EQ_GT,
  [135725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7949), 1,
      anon_sym_EQ_GT,
  [135732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7951), 1,
      anon_sym_RBRACK,
  [135739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7953), 1,
      sym_identifier,
  [135746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7955), 1,
      anon_sym_RBRACK,
  [135753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7957), 1,
      anon_sym_RBRACK,
  [135760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7959), 1,
      anon_sym_RBRACK,
  [135767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7961), 1,
      sym_identifier,
  [135774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7963), 1,
      anon_sym_RBRACK,
  [135781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7965), 1,
      anon_sym_EQ,
  [135788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 1,
      anon_sym_GT,
  [135795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7969), 1,
      anon_sym_RBRACK,
  [135802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 1,
      anon_sym_RBRACK,
  [135809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7973), 1,
      anon_sym_RBRACE,
  [135816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 1,
      sym_identifier,
  [135823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7977), 1,
      sym_identifier,
  [135830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 1,
      anon_sym_RBRACK,
  [135837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7981), 1,
      anon_sym_EQ_GT,
  [135844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7983), 1,
      anon_sym_GT,
  [135851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7985), 1,
      anon_sym_GT,
  [135858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7987), 1,
      sym_identifier,
  [135865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7989), 1,
      anon_sym_class,
  [135872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6918), 1,
      anon_sym_GT,
  [135879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7991), 1,
      anon_sym_EQ_GT,
  [135886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7993), 1,
      sym_identifier,
  [135893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7995), 1,
      anon_sym_EQ_GT,
  [135900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6963), 1,
      anon_sym_RBRACK,
  [135907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      sym_identifier,
  [135914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7999), 1,
      anon_sym_GT,
  [135921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7257), 1,
      sym_identifier,
  [135928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8001), 1,
      anon_sym_GT,
  [135935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8003), 1,
      anon_sym_GT,
  [135942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 1,
      anon_sym_target,
  [135949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8007), 1,
      anon_sym_GT,
  [135956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8009), 1,
      anon_sym_GT,
  [135963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_GT,
  [135970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8013), 1,
      anon_sym_EQ_GT,
  [135977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5880), 1,
      anon_sym_EQ,
  [135984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8015), 1,
      anon_sym_EQ_GT,
  [135991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6744), 1,
      anon_sym_EQ_GT,
  [135998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 1,
      anon_sym_EQ_GT,
  [136005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7034), 1,
      anon_sym_LBRACE,
  [136012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_EQ_GT,
  [136019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8019), 1,
      sym_identifier,
  [136026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8021), 1,
      sym_number,
  [136033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4218), 1,
      anon_sym_RPAREN,
  [136040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 1,
      anon_sym_GT,
  [136047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8025), 1,
      anon_sym_SLASH2,
  [136054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4623), 1,
      anon_sym_RPAREN,
  [136061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8027), 1,
      anon_sym_RPAREN,
  [136068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8029), 1,
      sym_identifier,
  [136075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8031), 1,
      anon_sym_SLASH2,
  [136082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      anon_sym_SLASH2,
  [136089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4323), 1,
      anon_sym_RPAREN,
  [136096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8035), 1,
      anon_sym_EQ_GT,
  [136103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 1,
      anon_sym_EQ_GT,
  [136110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8039), 1,
      anon_sym_EQ,
  [136117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8041), 1,
      anon_sym_EQ_GT,
  [136124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8043), 1,
      anon_sym_target,
  [136131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8045), 1,
      sym_identifier,
  [136138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8047), 1,
      anon_sym_while,
  [136145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8049), 1,
      anon_sym_RPAREN,
  [136152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4213), 1,
      anon_sym_RPAREN,
  [136159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8051), 1,
      anon_sym_EQ_GT,
  [136166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4611), 1,
      anon_sym_RBRACK,
  [136173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 1,
      anon_sym_EQ,
  [136180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8055), 1,
      sym_number,
  [136187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8057), 1,
      sym_identifier,
  [136194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8059), 1,
      anon_sym_EQ_GT,
  [136201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8061), 1,
      anon_sym_EQ_GT,
  [136208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8063), 1,
      sym_identifier,
  [136215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8065), 1,
      anon_sym_EQ_GT,
  [136222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8067), 1,
      anon_sym_EQ_GT,
  [136229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8069), 1,
      sym_identifier,
  [136236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4552), 1,
      anon_sym_RBRACK,
  [136243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4649), 1,
      anon_sym_RBRACE,
  [136250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8071), 1,
      anon_sym_GT,
  [136257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8073), 1,
      anon_sym_GT,
  [136264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_from,
  [136271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8075), 1,
      anon_sym_GT,
  [136278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8077), 1,
      anon_sym_GT,
  [136285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8079), 1,
      anon_sym_GT,
  [136292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7111), 1,
      anon_sym_as,
  [136299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8081), 1,
      anon_sym_RBRACK,
  [136306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8083), 1,
      anon_sym_RBRACK,
  [136313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8085), 1,
      anon_sym_RBRACK,
  [136320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8087), 1,
      anon_sym_RBRACK,
  [136327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8089), 1,
      anon_sym_EQ,
  [136334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8091), 1,
      anon_sym_RBRACK,
  [136341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_RBRACK,
  [136348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_RBRACK,
  [136355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8097), 1,
      anon_sym_EQ,
  [136362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8099), 1,
      anon_sym_RBRACK,
  [136369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8101), 1,
      anon_sym_RBRACK,
  [136376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8103), 1,
      anon_sym_RBRACK,
  [136383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8105), 1,
      anon_sym_GT,
  [136390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8107), 1,
      anon_sym_function,
  [136397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8109), 1,
      sym_identifier,
  [136404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8111), 1,
      sym_identifier,
  [136411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7271), 1,
      anon_sym_RBRACK,
  [136418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8113), 1,
      anon_sym_namespace,
  [136425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8115), 1,
      anon_sym_RBRACK,
  [136432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8117), 1,
      anon_sym_RBRACK,
  [136439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8119), 1,
      anon_sym_RBRACK,
  [136446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8121), 1,
      sym_identifier,
  [136453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8123), 1,
      anon_sym_function,
  [136460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8125), 1,
      anon_sym_RBRACK,
  [136467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_EQ,
  [136474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8127), 1,
      anon_sym_EQ_GT,
  [136481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8129), 1,
      sym_identifier,
  [136488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8131), 1,
      sym_identifier,
  [136495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8133), 1,
      sym_identifier,
  [136502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8135), 1,
      ts_builtin_sym_end,
  [136509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8137), 1,
      anon_sym_RBRACK,
  [136516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8139), 1,
      sym_identifier,
  [136523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8141), 1,
      sym_identifier,
  [136530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_class,
  [136537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8145), 1,
      anon_sym_RBRACK,
  [136544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8147), 1,
      anon_sym_RBRACK,
  [136551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8149), 1,
      anon_sym_RBRACK,
  [136558] = 2,
    ACTIONS(5602), 1,
      sym_comment,
    ACTIONS(8151), 1,
      sym_regex_pattern,
  [136565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8153), 1,
      anon_sym_RBRACK,
  [136572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8155), 1,
      anon_sym_RBRACK,
  [136579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8157), 1,
      anon_sym_EQ_GT,
  [136586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8159), 1,
      sym_identifier,
  [136593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8161), 1,
      anon_sym_EQ_GT,
  [136600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8163), 1,
      anon_sym_EQ_GT,
  [136607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_GT,
  [136614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8167), 1,
      anon_sym_GT,
  [136621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6858), 1,
      anon_sym_GT,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(865)] = 0,
  [SMALL_STATE(866)] = 131,
  [SMALL_STATE(867)] = 262,
  [SMALL_STATE(868)] = 393,
  [SMALL_STATE(869)] = 524,
  [SMALL_STATE(870)] = 655,
  [SMALL_STATE(871)] = 786,
  [SMALL_STATE(872)] = 917,
  [SMALL_STATE(873)] = 1048,
  [SMALL_STATE(874)] = 1179,
  [SMALL_STATE(875)] = 1310,
  [SMALL_STATE(876)] = 1441,
  [SMALL_STATE(877)] = 1572,
  [SMALL_STATE(878)] = 1703,
  [SMALL_STATE(879)] = 1834,
  [SMALL_STATE(880)] = 1965,
  [SMALL_STATE(881)] = 2096,
  [SMALL_STATE(882)] = 2227,
  [SMALL_STATE(883)] = 2358,
  [SMALL_STATE(884)] = 2489,
  [SMALL_STATE(885)] = 2620,
  [SMALL_STATE(886)] = 2709,
  [SMALL_STATE(887)] = 2840,
  [SMALL_STATE(888)] = 2971,
  [SMALL_STATE(889)] = 3102,
  [SMALL_STATE(890)] = 3233,
  [SMALL_STATE(891)] = 3364,
  [SMALL_STATE(892)] = 3495,
  [SMALL_STATE(893)] = 3626,
  [SMALL_STATE(894)] = 3757,
  [SMALL_STATE(895)] = 3888,
  [SMALL_STATE(896)] = 4019,
  [SMALL_STATE(897)] = 4150,
  [SMALL_STATE(898)] = 4281,
  [SMALL_STATE(899)] = 4412,
  [SMALL_STATE(900)] = 4543,
  [SMALL_STATE(901)] = 4674,
  [SMALL_STATE(902)] = 4805,
  [SMALL_STATE(903)] = 4936,
  [SMALL_STATE(904)] = 5067,
  [SMALL_STATE(905)] = 5198,
  [SMALL_STATE(906)] = 5329,
  [SMALL_STATE(907)] = 5462,
  [SMALL_STATE(908)] = 5593,
  [SMALL_STATE(909)] = 5724,
  [SMALL_STATE(910)] = 5855,
  [SMALL_STATE(911)] = 5986,
  [SMALL_STATE(912)] = 6117,
  [SMALL_STATE(913)] = 6250,
  [SMALL_STATE(914)] = 6381,
  [SMALL_STATE(915)] = 6512,
  [SMALL_STATE(916)] = 6643,
  [SMALL_STATE(917)] = 6774,
  [SMALL_STATE(918)] = 6905,
  [SMALL_STATE(919)] = 7036,
  [SMALL_STATE(920)] = 7167,
  [SMALL_STATE(921)] = 7298,
  [SMALL_STATE(922)] = 7429,
  [SMALL_STATE(923)] = 7560,
  [SMALL_STATE(924)] = 7691,
  [SMALL_STATE(925)] = 7822,
  [SMALL_STATE(926)] = 7955,
  [SMALL_STATE(927)] = 8086,
  [SMALL_STATE(928)] = 8217,
  [SMALL_STATE(929)] = 8348,
  [SMALL_STATE(930)] = 8479,
  [SMALL_STATE(931)] = 8610,
  [SMALL_STATE(932)] = 8741,
  [SMALL_STATE(933)] = 8872,
  [SMALL_STATE(934)] = 9003,
  [SMALL_STATE(935)] = 9134,
  [SMALL_STATE(936)] = 9265,
  [SMALL_STATE(937)] = 9396,
  [SMALL_STATE(938)] = 9527,
  [SMALL_STATE(939)] = 9658,
  [SMALL_STATE(940)] = 9789,
  [SMALL_STATE(941)] = 9920,
  [SMALL_STATE(942)] = 10051,
  [SMALL_STATE(943)] = 10182,
  [SMALL_STATE(944)] = 10313,
  [SMALL_STATE(945)] = 10444,
  [SMALL_STATE(946)] = 10575,
  [SMALL_STATE(947)] = 10706,
  [SMALL_STATE(948)] = 10837,
  [SMALL_STATE(949)] = 10968,
  [SMALL_STATE(950)] = 11099,
  [SMALL_STATE(951)] = 11230,
  [SMALL_STATE(952)] = 11361,
  [SMALL_STATE(953)] = 11492,
  [SMALL_STATE(954)] = 11623,
  [SMALL_STATE(955)] = 11754,
  [SMALL_STATE(956)] = 11885,
  [SMALL_STATE(957)] = 12016,
  [SMALL_STATE(958)] = 12147,
  [SMALL_STATE(959)] = 12278,
  [SMALL_STATE(960)] = 12409,
  [SMALL_STATE(961)] = 12540,
  [SMALL_STATE(962)] = 12671,
  [SMALL_STATE(963)] = 12802,
  [SMALL_STATE(964)] = 12933,
  [SMALL_STATE(965)] = 13064,
  [SMALL_STATE(966)] = 13195,
  [SMALL_STATE(967)] = 13326,
  [SMALL_STATE(968)] = 13457,
  [SMALL_STATE(969)] = 13588,
  [SMALL_STATE(970)] = 13719,
  [SMALL_STATE(971)] = 13808,
  [SMALL_STATE(972)] = 13939,
  [SMALL_STATE(973)] = 14070,
  [SMALL_STATE(974)] = 14201,
  [SMALL_STATE(975)] = 14332,
  [SMALL_STATE(976)] = 14463,
  [SMALL_STATE(977)] = 14594,
  [SMALL_STATE(978)] = 14686,
  [SMALL_STATE(979)] = 14776,
  [SMALL_STATE(980)] = 14866,
  [SMALL_STATE(981)] = 14956,
  [SMALL_STATE(982)] = 15046,
  [SMALL_STATE(983)] = 15134,
  [SMALL_STATE(984)] = 15224,
  [SMALL_STATE(985)] = 15312,
  [SMALL_STATE(986)] = 15402,
  [SMALL_STATE(987)] = 15494,
  [SMALL_STATE(988)] = 15582,
  [SMALL_STATE(989)] = 15670,
  [SMALL_STATE(990)] = 15761,
  [SMALL_STATE(991)] = 15848,
  [SMALL_STATE(992)] = 15935,
  [SMALL_STATE(993)] = 16026,
  [SMALL_STATE(994)] = 16113,
  [SMALL_STATE(995)] = 16204,
  [SMALL_STATE(996)] = 16291,
  [SMALL_STATE(997)] = 16384,
  [SMALL_STATE(998)] = 16472,
  [SMALL_STATE(999)] = 16540,
  [SMALL_STATE(1000)] = 16608,
  [SMALL_STATE(1001)] = 16696,
  [SMALL_STATE(1002)] = 16764,
  [SMALL_STATE(1003)] = 16850,
  [SMALL_STATE(1004)] = 16936,
  [SMALL_STATE(1005)] = 17022,
  [SMALL_STATE(1006)] = 17108,
  [SMALL_STATE(1007)] = 17238,
  [SMALL_STATE(1008)] = 17326,
  [SMALL_STATE(1009)] = 17412,
  [SMALL_STATE(1010)] = 17480,
  [SMALL_STATE(1011)] = 17548,
  [SMALL_STATE(1012)] = 17636,
  [SMALL_STATE(1013)] = 17726,
  [SMALL_STATE(1014)] = 17814,
  [SMALL_STATE(1015)] = 17944,
  [SMALL_STATE(1016)] = 18032,
  [SMALL_STATE(1017)] = 18120,
  [SMALL_STATE(1018)] = 18208,
  [SMALL_STATE(1019)] = 18294,
  [SMALL_STATE(1020)] = 18387,
  [SMALL_STATE(1021)] = 18454,
  [SMALL_STATE(1022)] = 18539,
  [SMALL_STATE(1023)] = 18624,
  [SMALL_STATE(1024)] = 18711,
  [SMALL_STATE(1025)] = 18782,
  [SMALL_STATE(1026)] = 18869,
  [SMALL_STATE(1027)] = 18936,
  [SMALL_STATE(1028)] = 19023,
  [SMALL_STATE(1029)] = 19112,
  [SMALL_STATE(1030)] = 19199,
  [SMALL_STATE(1031)] = 19284,
  [SMALL_STATE(1032)] = 19370,
  [SMALL_STATE(1033)] = 19448,
  [SMALL_STATE(1034)] = 19532,
  [SMALL_STATE(1035)] = 19608,
  [SMALL_STATE(1036)] = 19684,
  [SMALL_STATE(1037)] = 19760,
  [SMALL_STATE(1038)] = 19836,
  [SMALL_STATE(1039)] = 19914,
  [SMALL_STATE(1040)] = 20000,
  [SMALL_STATE(1041)] = 20076,
  [SMALL_STATE(1042)] = 20160,
  [SMALL_STATE(1043)] = 20244,
  [SMALL_STATE(1044)] = 20334,
  [SMALL_STATE(1045)] = 20420,
  [SMALL_STATE(1046)] = 20510,
  [SMALL_STATE(1047)] = 20596,
  [SMALL_STATE(1048)] = 20672,
  [SMALL_STATE(1049)] = 20756,
  [SMALL_STATE(1050)] = 20841,
  [SMALL_STATE(1051)] = 20918,
  [SMALL_STATE(1052)] = 20989,
  [SMALL_STATE(1053)] = 21066,
  [SMALL_STATE(1054)] = 21147,
  [SMALL_STATE(1055)] = 21220,
  [SMALL_STATE(1056)] = 21301,
  [SMALL_STATE(1057)] = 21384,
  [SMALL_STATE(1058)] = 21459,
  [SMALL_STATE(1059)] = 21532,
  [SMALL_STATE(1060)] = 21607,
  [SMALL_STATE(1061)] = 21678,
  [SMALL_STATE(1062)] = 21751,
  [SMALL_STATE(1063)] = 21822,
  [SMALL_STATE(1064)] = 21893,
  [SMALL_STATE(1065)] = 21980,
  [SMALL_STATE(1066)] = 22065,
  [SMALL_STATE(1067)] = 22150,
  [SMALL_STATE(1068)] = 22235,
  [SMALL_STATE(1069)] = 22310,
  [SMALL_STATE(1070)] = 22387,
  [SMALL_STATE(1071)] = 22470,
  [SMALL_STATE(1072)] = 22542,
  [SMALL_STATE(1073)] = 22624,
  [SMALL_STATE(1074)] = 22708,
  [SMALL_STATE(1075)] = 22778,
  [SMALL_STATE(1076)] = 22858,
  [SMALL_STATE(1077)] = 22934,
  [SMALL_STATE(1078)] = 23012,
  [SMALL_STATE(1079)] = 23084,
  [SMALL_STATE(1080)] = 23148,
  [SMALL_STATE(1081)] = 23212,
  [SMALL_STATE(1082)] = 23296,
  [SMALL_STATE(1083)] = 23366,
  [SMALL_STATE(1084)] = 23438,
  [SMALL_STATE(1085)] = 23510,
  [SMALL_STATE(1086)] = 23580,
  [SMALL_STATE(1087)] = 23644,
  [SMALL_STATE(1088)] = 23720,
  [SMALL_STATE(1089)] = 23790,
  [SMALL_STATE(1090)] = 23860,
  [SMALL_STATE(1091)] = 23932,
  [SMALL_STATE(1092)] = 24010,
  [SMALL_STATE(1093)] = 24084,
  [SMALL_STATE(1094)] = 24154,
  [SMALL_STATE(1095)] = 24228,
  [SMALL_STATE(1096)] = 24292,
  [SMALL_STATE(1097)] = 24362,
  [SMALL_STATE(1098)] = 24430,
  [SMALL_STATE(1099)] = 24502,
  [SMALL_STATE(1100)] = 24566,
  [SMALL_STATE(1101)] = 24634,
  [SMALL_STATE(1102)] = 24708,
  [SMALL_STATE(1103)] = 24772,
  [SMALL_STATE(1104)] = 24854,
  [SMALL_STATE(1105)] = 24918,
  [SMALL_STATE(1106)] = 24988,
  [SMALL_STATE(1107)] = 25057,
  [SMALL_STATE(1108)] = 25132,
  [SMALL_STATE(1109)] = 25203,
  [SMALL_STATE(1110)] = 25286,
  [SMALL_STATE(1111)] = 25357,
  [SMALL_STATE(1112)] = 25426,
  [SMALL_STATE(1113)] = 25495,
  [SMALL_STATE(1114)] = 25564,
  [SMALL_STATE(1115)] = 25633,
  [SMALL_STATE(1116)] = 25708,
  [SMALL_STATE(1117)] = 25783,
  [SMALL_STATE(1118)] = 25866,
  [SMALL_STATE(1119)] = 25937,
  [SMALL_STATE(1120)] = 26018,
  [SMALL_STATE(1121)] = 26089,
  [SMALL_STATE(1122)] = 26158,
  [SMALL_STATE(1123)] = 26227,
  [SMALL_STATE(1124)] = 26296,
  [SMALL_STATE(1125)] = 26365,
  [SMALL_STATE(1126)] = 26432,
  [SMALL_STATE(1127)] = 26499,
  [SMALL_STATE(1128)] = 26568,
  [SMALL_STATE(1129)] = 26639,
  [SMALL_STATE(1130)] = 26716,
  [SMALL_STATE(1131)] = 26788,
  [SMALL_STATE(1132)] = 26858,
  [SMALL_STATE(1133)] = 26924,
  [SMALL_STATE(1134)] = 26986,
  [SMALL_STATE(1135)] = 27054,
  [SMALL_STATE(1136)] = 27122,
  [SMALL_STATE(1137)] = 27190,
  [SMALL_STATE(1138)] = 27262,
  [SMALL_STATE(1139)] = 27332,
  [SMALL_STATE(1140)] = 27404,
  [SMALL_STATE(1141)] = 27474,
  [SMALL_STATE(1142)] = 27548,
  [SMALL_STATE(1143)] = 27616,
  [SMALL_STATE(1144)] = 27682,
  [SMALL_STATE(1145)] = 27754,
  [SMALL_STATE(1146)] = 27821,
  [SMALL_STATE(1147)] = 27890,
  [SMALL_STATE(1148)] = 27957,
  [SMALL_STATE(1149)] = 28022,
  [SMALL_STATE(1150)] = 28083,
  [SMALL_STATE(1151)] = 28144,
  [SMALL_STATE(1152)] = 28205,
  [SMALL_STATE(1153)] = 28276,
  [SMALL_STATE(1154)] = 28347,
  [SMALL_STATE(1155)] = 28414,
  [SMALL_STATE(1156)] = 28481,
  [SMALL_STATE(1157)] = 28550,
  [SMALL_STATE(1158)] = 28616,
  [SMALL_STATE(1159)] = 28684,
  [SMALL_STATE(1160)] = 28750,
  [SMALL_STATE(1161)] = 28814,
  [SMALL_STATE(1162)] = 28880,
  [SMALL_STATE(1163)] = 28993,
  [SMALL_STATE(1164)] = 29106,
  [SMALL_STATE(1165)] = 29219,
  [SMALL_STATE(1166)] = 29332,
  [SMALL_STATE(1167)] = 29445,
  [SMALL_STATE(1168)] = 29558,
  [SMALL_STATE(1169)] = 29676,
  [SMALL_STATE(1170)] = 29794,
  [SMALL_STATE(1171)] = 29912,
  [SMALL_STATE(1172)] = 30030,
  [SMALL_STATE(1173)] = 30148,
  [SMALL_STATE(1174)] = 30257,
  [SMALL_STATE(1175)] = 30366,
  [SMALL_STATE(1176)] = 30475,
  [SMALL_STATE(1177)] = 30584,
  [SMALL_STATE(1178)] = 30693,
  [SMALL_STATE(1179)] = 30802,
  [SMALL_STATE(1180)] = 30911,
  [SMALL_STATE(1181)] = 31020,
  [SMALL_STATE(1182)] = 31129,
  [SMALL_STATE(1183)] = 31238,
  [SMALL_STATE(1184)] = 31347,
  [SMALL_STATE(1185)] = 31424,
  [SMALL_STATE(1186)] = 31533,
  [SMALL_STATE(1187)] = 31642,
  [SMALL_STATE(1188)] = 31751,
  [SMALL_STATE(1189)] = 31860,
  [SMALL_STATE(1190)] = 31969,
  [SMALL_STATE(1191)] = 32078,
  [SMALL_STATE(1192)] = 32187,
  [SMALL_STATE(1193)] = 32297,
  [SMALL_STATE(1194)] = 32405,
  [SMALL_STATE(1195)] = 32460,
  [SMALL_STATE(1196)] = 32565,
  [SMALL_STATE(1197)] = 32670,
  [SMALL_STATE(1198)] = 32775,
  [SMALL_STATE(1199)] = 32880,
  [SMALL_STATE(1200)] = 32985,
  [SMALL_STATE(1201)] = 33090,
  [SMALL_STATE(1202)] = 33195,
  [SMALL_STATE(1203)] = 33250,
  [SMALL_STATE(1204)] = 33348,
  [SMALL_STATE(1205)] = 33446,
  [SMALL_STATE(1206)] = 33508,
  [SMALL_STATE(1207)] = 33606,
  [SMALL_STATE(1208)] = 33704,
  [SMALL_STATE(1209)] = 33802,
  [SMALL_STATE(1210)] = 33900,
  [SMALL_STATE(1211)] = 33998,
  [SMALL_STATE(1212)] = 34055,
  [SMALL_STATE(1213)] = 34122,
  [SMALL_STATE(1214)] = 34177,
  [SMALL_STATE(1215)] = 34230,
  [SMALL_STATE(1216)] = 34283,
  [SMALL_STATE(1217)] = 34340,
  [SMALL_STATE(1218)] = 34399,
  [SMALL_STATE(1219)] = 34462,
  [SMALL_STATE(1220)] = 34519,
  [SMALL_STATE(1221)] = 34582,
  [SMALL_STATE(1222)] = 34641,
  [SMALL_STATE(1223)] = 34704,
  [SMALL_STATE(1224)] = 34762,
  [SMALL_STATE(1225)] = 34814,
  [SMALL_STATE(1226)] = 34904,
  [SMALL_STATE(1227)] = 34956,
  [SMALL_STATE(1228)] = 35008,
  [SMALL_STATE(1229)] = 35060,
  [SMALL_STATE(1230)] = 35118,
  [SMALL_STATE(1231)] = 35170,
  [SMALL_STATE(1232)] = 35222,
  [SMALL_STATE(1233)] = 35274,
  [SMALL_STATE(1234)] = 35326,
  [SMALL_STATE(1235)] = 35378,
  [SMALL_STATE(1236)] = 35430,
  [SMALL_STATE(1237)] = 35482,
  [SMALL_STATE(1238)] = 35534,
  [SMALL_STATE(1239)] = 35586,
  [SMALL_STATE(1240)] = 35638,
  [SMALL_STATE(1241)] = 35690,
  [SMALL_STATE(1242)] = 35742,
  [SMALL_STATE(1243)] = 35800,
  [SMALL_STATE(1244)] = 35852,
  [SMALL_STATE(1245)] = 35904,
  [SMALL_STATE(1246)] = 35956,
  [SMALL_STATE(1247)] = 36008,
  [SMALL_STATE(1248)] = 36060,
  [SMALL_STATE(1249)] = 36112,
  [SMALL_STATE(1250)] = 36166,
  [SMALL_STATE(1251)] = 36222,
  [SMALL_STATE(1252)] = 36276,
  [SMALL_STATE(1253)] = 36328,
  [SMALL_STATE(1254)] = 36380,
  [SMALL_STATE(1255)] = 36432,
  [SMALL_STATE(1256)] = 36484,
  [SMALL_STATE(1257)] = 36536,
  [SMALL_STATE(1258)] = 36594,
  [SMALL_STATE(1259)] = 36646,
  [SMALL_STATE(1260)] = 36698,
  [SMALL_STATE(1261)] = 36750,
  [SMALL_STATE(1262)] = 36802,
  [SMALL_STATE(1263)] = 36856,
  [SMALL_STATE(1264)] = 36908,
  [SMALL_STATE(1265)] = 36960,
  [SMALL_STATE(1266)] = 37012,
  [SMALL_STATE(1267)] = 37064,
  [SMALL_STATE(1268)] = 37116,
  [SMALL_STATE(1269)] = 37168,
  [SMALL_STATE(1270)] = 37220,
  [SMALL_STATE(1271)] = 37272,
  [SMALL_STATE(1272)] = 37324,
  [SMALL_STATE(1273)] = 37376,
  [SMALL_STATE(1274)] = 37428,
  [SMALL_STATE(1275)] = 37480,
  [SMALL_STATE(1276)] = 37532,
  [SMALL_STATE(1277)] = 37584,
  [SMALL_STATE(1278)] = 37636,
  [SMALL_STATE(1279)] = 37688,
  [SMALL_STATE(1280)] = 37740,
  [SMALL_STATE(1281)] = 37792,
  [SMALL_STATE(1282)] = 37844,
  [SMALL_STATE(1283)] = 37896,
  [SMALL_STATE(1284)] = 37948,
  [SMALL_STATE(1285)] = 38000,
  [SMALL_STATE(1286)] = 38052,
  [SMALL_STATE(1287)] = 38104,
  [SMALL_STATE(1288)] = 38164,
  [SMALL_STATE(1289)] = 38216,
  [SMALL_STATE(1290)] = 38272,
  [SMALL_STATE(1291)] = 38324,
  [SMALL_STATE(1292)] = 38378,
  [SMALL_STATE(1293)] = 38430,
  [SMALL_STATE(1294)] = 38482,
  [SMALL_STATE(1295)] = 38540,
  [SMALL_STATE(1296)] = 38592,
  [SMALL_STATE(1297)] = 38644,
  [SMALL_STATE(1298)] = 38696,
  [SMALL_STATE(1299)] = 38750,
  [SMALL_STATE(1300)] = 38802,
  [SMALL_STATE(1301)] = 38862,
  [SMALL_STATE(1302)] = 38914,
  [SMALL_STATE(1303)] = 38970,
  [SMALL_STATE(1304)] = 39022,
  [SMALL_STATE(1305)] = 39074,
  [SMALL_STATE(1306)] = 39126,
  [SMALL_STATE(1307)] = 39178,
  [SMALL_STATE(1308)] = 39232,
  [SMALL_STATE(1309)] = 39284,
  [SMALL_STATE(1310)] = 39338,
  [SMALL_STATE(1311)] = 39396,
  [SMALL_STATE(1312)] = 39450,
  [SMALL_STATE(1313)] = 39504,
  [SMALL_STATE(1314)] = 39556,
  [SMALL_STATE(1315)] = 39608,
  [SMALL_STATE(1316)] = 39660,
  [SMALL_STATE(1317)] = 39718,
  [SMALL_STATE(1318)] = 39776,
  [SMALL_STATE(1319)] = 39832,
  [SMALL_STATE(1320)] = 39884,
  [SMALL_STATE(1321)] = 39940,
  [SMALL_STATE(1322)] = 39992,
  [SMALL_STATE(1323)] = 40097,
  [SMALL_STATE(1324)] = 40148,
  [SMALL_STATE(1325)] = 40205,
  [SMALL_STATE(1326)] = 40262,
  [SMALL_STATE(1327)] = 40329,
  [SMALL_STATE(1328)] = 40380,
  [SMALL_STATE(1329)] = 40431,
  [SMALL_STATE(1330)] = 40482,
  [SMALL_STATE(1331)] = 40563,
  [SMALL_STATE(1332)] = 40614,
  [SMALL_STATE(1333)] = 40719,
  [SMALL_STATE(1334)] = 40772,
  [SMALL_STATE(1335)] = 40823,
  [SMALL_STATE(1336)] = 40874,
  [SMALL_STATE(1337)] = 40969,
  [SMALL_STATE(1338)] = 41074,
  [SMALL_STATE(1339)] = 41133,
  [SMALL_STATE(1340)] = 41230,
  [SMALL_STATE(1341)] = 41307,
  [SMALL_STATE(1342)] = 41358,
  [SMALL_STATE(1343)] = 41409,
  [SMALL_STATE(1344)] = 41498,
  [SMALL_STATE(1345)] = 41549,
  [SMALL_STATE(1346)] = 41640,
  [SMALL_STATE(1347)] = 41691,
  [SMALL_STATE(1348)] = 41784,
  [SMALL_STATE(1349)] = 41859,
  [SMALL_STATE(1350)] = 41928,
  [SMALL_STATE(1351)] = 41979,
  [SMALL_STATE(1352)] = 42064,
  [SMALL_STATE(1353)] = 42115,
  [SMALL_STATE(1354)] = 42214,
  [SMALL_STATE(1355)] = 42265,
  [SMALL_STATE(1356)] = 42316,
  [SMALL_STATE(1357)] = 42367,
  [SMALL_STATE(1358)] = 42418,
  [SMALL_STATE(1359)] = 42469,
  [SMALL_STATE(1360)] = 42520,
  [SMALL_STATE(1361)] = 42571,
  [SMALL_STATE(1362)] = 42676,
  [SMALL_STATE(1363)] = 42781,
  [SMALL_STATE(1364)] = 42832,
  [SMALL_STATE(1365)] = 42883,
  [SMALL_STATE(1366)] = 42934,
  [SMALL_STATE(1367)] = 42985,
  [SMALL_STATE(1368)] = 43036,
  [SMALL_STATE(1369)] = 43093,
  [SMALL_STATE(1370)] = 43144,
  [SMALL_STATE(1371)] = 43249,
  [SMALL_STATE(1372)] = 43300,
  [SMALL_STATE(1373)] = 43351,
  [SMALL_STATE(1374)] = 43402,
  [SMALL_STATE(1375)] = 43453,
  [SMALL_STATE(1376)] = 43504,
  [SMALL_STATE(1377)] = 43555,
  [SMALL_STATE(1378)] = 43608,
  [SMALL_STATE(1379)] = 43713,
  [SMALL_STATE(1380)] = 43764,
  [SMALL_STATE(1381)] = 43871,
  [SMALL_STATE(1382)] = 43924,
  [SMALL_STATE(1383)] = 43981,
  [SMALL_STATE(1384)] = 44032,
  [SMALL_STATE(1385)] = 44083,
  [SMALL_STATE(1386)] = 44138,
  [SMALL_STATE(1387)] = 44189,
  [SMALL_STATE(1388)] = 44240,
  [SMALL_STATE(1389)] = 44295,
  [SMALL_STATE(1390)] = 44346,
  [SMALL_STATE(1391)] = 44397,
  [SMALL_STATE(1392)] = 44448,
  [SMALL_STATE(1393)] = 44499,
  [SMALL_STATE(1394)] = 44552,
  [SMALL_STATE(1395)] = 44603,
  [SMALL_STATE(1396)] = 44654,
  [SMALL_STATE(1397)] = 44759,
  [SMALL_STATE(1398)] = 44810,
  [SMALL_STATE(1399)] = 44861,
  [SMALL_STATE(1400)] = 44912,
  [SMALL_STATE(1401)] = 44967,
  [SMALL_STATE(1402)] = 45018,
  [SMALL_STATE(1403)] = 45123,
  [SMALL_STATE(1404)] = 45174,
  [SMALL_STATE(1405)] = 45225,
  [SMALL_STATE(1406)] = 45330,
  [SMALL_STATE(1407)] = 45381,
  [SMALL_STATE(1408)] = 45432,
  [SMALL_STATE(1409)] = 45483,
  [SMALL_STATE(1410)] = 45534,
  [SMALL_STATE(1411)] = 45585,
  [SMALL_STATE(1412)] = 45690,
  [SMALL_STATE(1413)] = 45741,
  [SMALL_STATE(1414)] = 45792,
  [SMALL_STATE(1415)] = 45843,
  [SMALL_STATE(1416)] = 45894,
  [SMALL_STATE(1417)] = 45945,
  [SMALL_STATE(1418)] = 46016,
  [SMALL_STATE(1419)] = 46067,
  [SMALL_STATE(1420)] = 46118,
  [SMALL_STATE(1421)] = 46191,
  [SMALL_STATE(1422)] = 46242,
  [SMALL_STATE(1423)] = 46293,
  [SMALL_STATE(1424)] = 46344,
  [SMALL_STATE(1425)] = 46395,
  [SMALL_STATE(1426)] = 46446,
  [SMALL_STATE(1427)] = 46497,
  [SMALL_STATE(1428)] = 46548,
  [SMALL_STATE(1429)] = 46599,
  [SMALL_STATE(1430)] = 46650,
  [SMALL_STATE(1431)] = 46703,
  [SMALL_STATE(1432)] = 46754,
  [SMALL_STATE(1433)] = 46805,
  [SMALL_STATE(1434)] = 46910,
  [SMALL_STATE(1435)] = 46979,
  [SMALL_STATE(1436)] = 47030,
  [SMALL_STATE(1437)] = 47081,
  [SMALL_STATE(1438)] = 47171,
  [SMALL_STATE(1439)] = 47245,
  [SMALL_STATE(1440)] = 47339,
  [SMALL_STATE(1441)] = 47447,
  [SMALL_STATE(1442)] = 47551,
  [SMALL_STATE(1443)] = 47605,
  [SMALL_STATE(1444)] = 47659,
  [SMALL_STATE(1445)] = 47713,
  [SMALL_STATE(1446)] = 47817,
  [SMALL_STATE(1447)] = 47925,
  [SMALL_STATE(1448)] = 48033,
  [SMALL_STATE(1449)] = 48137,
  [SMALL_STATE(1450)] = 48241,
  [SMALL_STATE(1451)] = 48293,
  [SMALL_STATE(1452)] = 48397,
  [SMALL_STATE(1453)] = 48501,
  [SMALL_STATE(1454)] = 48605,
  [SMALL_STATE(1455)] = 48675,
  [SMALL_STATE(1456)] = 48781,
  [SMALL_STATE(1457)] = 48863,
  [SMALL_STATE(1458)] = 48919,
  [SMALL_STATE(1459)] = 49023,
  [SMALL_STATE(1460)] = 49117,
  [SMALL_STATE(1461)] = 49175,
  [SMALL_STATE(1462)] = 49233,
  [SMALL_STATE(1463)] = 49313,
  [SMALL_STATE(1464)] = 49407,
  [SMALL_STATE(1465)] = 49511,
  [SMALL_STATE(1466)] = 49571,
  [SMALL_STATE(1467)] = 49641,
  [SMALL_STATE(1468)] = 49709,
  [SMALL_STATE(1469)] = 49813,
  [SMALL_STATE(1470)] = 49907,
  [SMALL_STATE(1471)] = 49989,
  [SMALL_STATE(1472)] = 50045,
  [SMALL_STATE(1473)] = 50155,
  [SMALL_STATE(1474)] = 50213,
  [SMALL_STATE(1475)] = 50321,
  [SMALL_STATE(1476)] = 50393,
  [SMALL_STATE(1477)] = 50489,
  [SMALL_STATE(1478)] = 50565,
  [SMALL_STATE(1479)] = 50669,
  [SMALL_STATE(1480)] = 50757,
  [SMALL_STATE(1481)] = 50847,
  [SMALL_STATE(1482)] = 50957,
  [SMALL_STATE(1483)] = 51051,
  [SMALL_STATE(1484)] = 51143,
  [SMALL_STATE(1485)] = 51203,
  [SMALL_STATE(1486)] = 51263,
  [SMALL_STATE(1487)] = 51323,
  [SMALL_STATE(1488)] = 51383,
  [SMALL_STATE(1489)] = 51451,
  [SMALL_STATE(1490)] = 51559,
  [SMALL_STATE(1491)] = 51643,
  [SMALL_STATE(1492)] = 51741,
  [SMALL_STATE(1493)] = 51823,
  [SMALL_STATE(1494)] = 51921,
  [SMALL_STATE(1495)] = 52025,
  [SMALL_STATE(1496)] = 52119,
  [SMALL_STATE(1497)] = 52213,
  [SMALL_STATE(1498)] = 52307,
  [SMALL_STATE(1499)] = 52371,
  [SMALL_STATE(1500)] = 52437,
  [SMALL_STATE(1501)] = 52495,
  [SMALL_STATE(1502)] = 52563,
  [SMALL_STATE(1503)] = 52667,
  [SMALL_STATE(1504)] = 52739,
  [SMALL_STATE(1505)] = 52843,
  [SMALL_STATE(1506)] = 52925,
  [SMALL_STATE(1507)] = 53029,
  [SMALL_STATE(1508)] = 53133,
  [SMALL_STATE(1509)] = 53237,
  [SMALL_STATE(1510)] = 53343,
  [SMALL_STATE(1511)] = 53409,
  [SMALL_STATE(1512)] = 53503,
  [SMALL_STATE(1513)] = 53613,
  [SMALL_STATE(1514)] = 53707,
  [SMALL_STATE(1515)] = 53791,
  [SMALL_STATE(1516)] = 53849,
  [SMALL_STATE(1517)] = 53917,
  [SMALL_STATE(1518)] = 54021,
  [SMALL_STATE(1519)] = 54131,
  [SMALL_STATE(1520)] = 54225,
  [SMALL_STATE(1521)] = 54305,
  [SMALL_STATE(1522)] = 54409,
  [SMALL_STATE(1523)] = 54465,
  [SMALL_STATE(1524)] = 54547,
  [SMALL_STATE(1525)] = 54601,
  [SMALL_STATE(1526)] = 54695,
  [SMALL_STATE(1527)] = 54753,
  [SMALL_STATE(1528)] = 54849,
  [SMALL_STATE(1529)] = 54925,
  [SMALL_STATE(1530)] = 54981,
  [SMALL_STATE(1531)] = 55069,
  [SMALL_STATE(1532)] = 55173,
  [SMALL_STATE(1533)] = 55265,
  [SMALL_STATE(1534)] = 55369,
  [SMALL_STATE(1535)] = 55473,
  [SMALL_STATE(1536)] = 55577,
  [SMALL_STATE(1537)] = 55671,
  [SMALL_STATE(1538)] = 55775,
  [SMALL_STATE(1539)] = 55849,
  [SMALL_STATE(1540)] = 55953,
  [SMALL_STATE(1541)] = 56008,
  [SMALL_STATE(1542)] = 56063,
  [SMALL_STATE(1543)] = 56112,
  [SMALL_STATE(1544)] = 56161,
  [SMALL_STATE(1545)] = 56210,
  [SMALL_STATE(1546)] = 56259,
  [SMALL_STATE(1547)] = 56308,
  [SMALL_STATE(1548)] = 56359,
  [SMALL_STATE(1549)] = 56464,
  [SMALL_STATE(1550)] = 56571,
  [SMALL_STATE(1551)] = 56626,
  [SMALL_STATE(1552)] = 56675,
  [SMALL_STATE(1553)] = 56724,
  [SMALL_STATE(1554)] = 56775,
  [SMALL_STATE(1555)] = 56870,
  [SMALL_STATE(1556)] = 56921,
  [SMALL_STATE(1557)] = 56970,
  [SMALL_STATE(1558)] = 57019,
  [SMALL_STATE(1559)] = 57068,
  [SMALL_STATE(1560)] = 57117,
  [SMALL_STATE(1561)] = 57166,
  [SMALL_STATE(1562)] = 57221,
  [SMALL_STATE(1563)] = 57294,
  [SMALL_STATE(1564)] = 57343,
  [SMALL_STATE(1565)] = 57400,
  [SMALL_STATE(1566)] = 57451,
  [SMALL_STATE(1567)] = 57500,
  [SMALL_STATE(1568)] = 57575,
  [SMALL_STATE(1569)] = 57630,
  [SMALL_STATE(1570)] = 57685,
  [SMALL_STATE(1571)] = 57740,
  [SMALL_STATE(1572)] = 57789,
  [SMALL_STATE(1573)] = 57838,
  [SMALL_STATE(1574)] = 57945,
  [SMALL_STATE(1575)] = 57998,
  [SMALL_STATE(1576)] = 58059,
  [SMALL_STATE(1577)] = 58114,
  [SMALL_STATE(1578)] = 58165,
  [SMALL_STATE(1579)] = 58226,
  [SMALL_STATE(1580)] = 58279,
  [SMALL_STATE(1581)] = 58334,
  [SMALL_STATE(1582)] = 58441,
  [SMALL_STATE(1583)] = 58502,
  [SMALL_STATE(1584)] = 58563,
  [SMALL_STATE(1585)] = 58636,
  [SMALL_STATE(1586)] = 58711,
  [SMALL_STATE(1587)] = 58760,
  [SMALL_STATE(1588)] = 58835,
  [SMALL_STATE(1589)] = 58890,
  [SMALL_STATE(1590)] = 58939,
  [SMALL_STATE(1591)] = 59042,
  [SMALL_STATE(1592)] = 59091,
  [SMALL_STATE(1593)] = 59140,
  [SMALL_STATE(1594)] = 59195,
  [SMALL_STATE(1595)] = 59302,
  [SMALL_STATE(1596)] = 59409,
  [SMALL_STATE(1597)] = 59470,
  [SMALL_STATE(1598)] = 59535,
  [SMALL_STATE(1599)] = 59586,
  [SMALL_STATE(1600)] = 59647,
  [SMALL_STATE(1601)] = 59752,
  [SMALL_STATE(1602)] = 59857,
  [SMALL_STATE(1603)] = 59918,
  [SMALL_STATE(1604)] = 60021,
  [SMALL_STATE(1605)] = 60124,
  [SMALL_STATE(1606)] = 60199,
  [SMALL_STATE(1607)] = 60248,
  [SMALL_STATE(1608)] = 60297,
  [SMALL_STATE(1609)] = 60370,
  [SMALL_STATE(1610)] = 60431,
  [SMALL_STATE(1611)] = 60502,
  [SMALL_STATE(1612)] = 60605,
  [SMALL_STATE(1613)] = 60708,
  [SMALL_STATE(1614)] = 60775,
  [SMALL_STATE(1615)] = 60882,
  [SMALL_STATE(1616)] = 60987,
  [SMALL_STATE(1617)] = 61036,
  [SMALL_STATE(1618)] = 61093,
  [SMALL_STATE(1619)] = 61196,
  [SMALL_STATE(1620)] = 61247,
  [SMALL_STATE(1621)] = 61304,
  [SMALL_STATE(1622)] = 61407,
  [SMALL_STATE(1623)] = 61462,
  [SMALL_STATE(1624)] = 61513,
  [SMALL_STATE(1625)] = 61564,
  [SMALL_STATE(1626)] = 61633,
  [SMALL_STATE(1627)] = 61684,
  [SMALL_STATE(1628)] = 61733,
  [SMALL_STATE(1629)] = 61836,
  [SMALL_STATE(1630)] = 61885,
  [SMALL_STATE(1631)] = 61938,
  [SMALL_STATE(1632)] = 61993,
  [SMALL_STATE(1633)] = 62046,
  [SMALL_STATE(1634)] = 62121,
  [SMALL_STATE(1635)] = 62194,
  [SMALL_STATE(1636)] = 62301,
  [SMALL_STATE(1637)] = 62404,
  [SMALL_STATE(1638)] = 62507,
  [SMALL_STATE(1639)] = 62610,
  [SMALL_STATE(1640)] = 62665,
  [SMALL_STATE(1641)] = 62714,
  [SMALL_STATE(1642)] = 62763,
  [SMALL_STATE(1643)] = 62818,
  [SMALL_STATE(1644)] = 62867,
  [SMALL_STATE(1645)] = 62916,
  [SMALL_STATE(1646)] = 62965,
  [SMALL_STATE(1647)] = 63014,
  [SMALL_STATE(1648)] = 63063,
  [SMALL_STATE(1649)] = 63142,
  [SMALL_STATE(1650)] = 63191,
  [SMALL_STATE(1651)] = 63284,
  [SMALL_STATE(1652)] = 63351,
  [SMALL_STATE(1653)] = 63402,
  [SMALL_STATE(1654)] = 63477,
  [SMALL_STATE(1655)] = 63564,
  [SMALL_STATE(1656)] = 63653,
  [SMALL_STATE(1657)] = 63744,
  [SMALL_STATE(1658)] = 63817,
  [SMALL_STATE(1659)] = 63920,
  [SMALL_STATE(1660)] = 64017,
  [SMALL_STATE(1661)] = 64100,
  [SMALL_STATE(1662)] = 64155,
  [SMALL_STATE(1663)] = 64222,
  [SMALL_STATE(1664)] = 64271,
  [SMALL_STATE(1665)] = 64344,
  [SMALL_STATE(1666)] = 64435,
  [SMALL_STATE(1667)] = 64524,
  [SMALL_STATE(1668)] = 64573,
  [SMALL_STATE(1669)] = 64660,
  [SMALL_STATE(1670)] = 64709,
  [SMALL_STATE(1671)] = 64772,
  [SMALL_STATE(1672)] = 64875,
  [SMALL_STATE(1673)] = 64924,
  [SMALL_STATE(1674)] = 64987,
  [SMALL_STATE(1675)] = 65082,
  [SMALL_STATE(1676)] = 65175,
  [SMALL_STATE(1677)] = 65224,
  [SMALL_STATE(1678)] = 65273,
  [SMALL_STATE(1679)] = 65322,
  [SMALL_STATE(1680)] = 65371,
  [SMALL_STATE(1681)] = 65420,
  [SMALL_STATE(1682)] = 65471,
  [SMALL_STATE(1683)] = 65520,
  [SMALL_STATE(1684)] = 65569,
  [SMALL_STATE(1685)] = 65618,
  [SMALL_STATE(1686)] = 65701,
  [SMALL_STATE(1687)] = 65750,
  [SMALL_STATE(1688)] = 65855,
  [SMALL_STATE(1689)] = 65958,
  [SMALL_STATE(1690)] = 66007,
  [SMALL_STATE(1691)] = 66086,
  [SMALL_STATE(1692)] = 66183,
  [SMALL_STATE(1693)] = 66286,
  [SMALL_STATE(1694)] = 66353,
  [SMALL_STATE(1695)] = 66402,
  [SMALL_STATE(1696)] = 66505,
  [SMALL_STATE(1697)] = 66612,
  [SMALL_STATE(1698)] = 66667,
  [SMALL_STATE(1699)] = 66740,
  [SMALL_STATE(1700)] = 66809,
  [SMALL_STATE(1701)] = 66858,
  [SMALL_STATE(1702)] = 66961,
  [SMALL_STATE(1703)] = 67064,
  [SMALL_STATE(1704)] = 67135,
  [SMALL_STATE(1705)] = 67238,
  [SMALL_STATE(1706)] = 67341,
  [SMALL_STATE(1707)] = 67444,
  [SMALL_STATE(1708)] = 67493,
  [SMALL_STATE(1709)] = 67596,
  [SMALL_STATE(1710)] = 67699,
  [SMALL_STATE(1711)] = 67806,
  [SMALL_STATE(1712)] = 67909,
  [SMALL_STATE(1713)] = 67974,
  [SMALL_STATE(1714)] = 68027,
  [SMALL_STATE(1715)] = 68076,
  [SMALL_STATE(1716)] = 68179,
  [SMALL_STATE(1717)] = 68228,
  [SMALL_STATE(1718)] = 68281,
  [SMALL_STATE(1719)] = 68330,
  [SMALL_STATE(1720)] = 68379,
  [SMALL_STATE(1721)] = 68482,
  [SMALL_STATE(1722)] = 68589,
  [SMALL_STATE(1723)] = 68692,
  [SMALL_STATE(1724)] = 68741,
  [SMALL_STATE(1725)] = 68844,
  [SMALL_STATE(1726)] = 68947,
  [SMALL_STATE(1727)] = 68996,
  [SMALL_STATE(1728)] = 69045,
  [SMALL_STATE(1729)] = 69094,
  [SMALL_STATE(1730)] = 69143,
  [SMALL_STATE(1731)] = 69192,
  [SMALL_STATE(1732)] = 69253,
  [SMALL_STATE(1733)] = 69302,
  [SMALL_STATE(1734)] = 69351,
  [SMALL_STATE(1735)] = 69400,
  [SMALL_STATE(1736)] = 69449,
  [SMALL_STATE(1737)] = 69498,
  [SMALL_STATE(1738)] = 69547,
  [SMALL_STATE(1739)] = 69596,
  [SMALL_STATE(1740)] = 69671,
  [SMALL_STATE(1741)] = 69720,
  [SMALL_STATE(1742)] = 69769,
  [SMALL_STATE(1743)] = 69818,
  [SMALL_STATE(1744)] = 69867,
  [SMALL_STATE(1745)] = 69916,
  [SMALL_STATE(1746)] = 69965,
  [SMALL_STATE(1747)] = 70015,
  [SMALL_STATE(1748)] = 70065,
  [SMALL_STATE(1749)] = 70137,
  [SMALL_STATE(1750)] = 70239,
  [SMALL_STATE(1751)] = 70309,
  [SMALL_STATE(1752)] = 70361,
  [SMALL_STATE(1753)] = 70427,
  [SMALL_STATE(1754)] = 70481,
  [SMALL_STATE(1755)] = 70529,
  [SMALL_STATE(1756)] = 70631,
  [SMALL_STATE(1757)] = 70695,
  [SMALL_STATE(1758)] = 70797,
  [SMALL_STATE(1759)] = 70855,
  [SMALL_STATE(1760)] = 70957,
  [SMALL_STATE(1761)] = 71059,
  [SMALL_STATE(1762)] = 71161,
  [SMALL_STATE(1763)] = 71209,
  [SMALL_STATE(1764)] = 71259,
  [SMALL_STATE(1765)] = 71307,
  [SMALL_STATE(1766)] = 71359,
  [SMALL_STATE(1767)] = 71427,
  [SMALL_STATE(1768)] = 71479,
  [SMALL_STATE(1769)] = 71527,
  [SMALL_STATE(1770)] = 71577,
  [SMALL_STATE(1771)] = 71625,
  [SMALL_STATE(1772)] = 71679,
  [SMALL_STATE(1773)] = 71727,
  [SMALL_STATE(1774)] = 71781,
  [SMALL_STATE(1775)] = 71833,
  [SMALL_STATE(1776)] = 71935,
  [SMALL_STATE(1777)] = 71991,
  [SMALL_STATE(1778)] = 72039,
  [SMALL_STATE(1779)] = 72089,
  [SMALL_STATE(1780)] = 72143,
  [SMALL_STATE(1781)] = 72197,
  [SMALL_STATE(1782)] = 72275,
  [SMALL_STATE(1783)] = 72379,
  [SMALL_STATE(1784)] = 72431,
  [SMALL_STATE(1785)] = 72481,
  [SMALL_STATE(1786)] = 72535,
  [SMALL_STATE(1787)] = 72587,
  [SMALL_STATE(1788)] = 72635,
  [SMALL_STATE(1789)] = 72691,
  [SMALL_STATE(1790)] = 72773,
  [SMALL_STATE(1791)] = 72875,
  [SMALL_STATE(1792)] = 72977,
  [SMALL_STATE(1793)] = 73051,
  [SMALL_STATE(1794)] = 73099,
  [SMALL_STATE(1795)] = 73201,
  [SMALL_STATE(1796)] = 73249,
  [SMALL_STATE(1797)] = 73301,
  [SMALL_STATE(1798)] = 73349,
  [SMALL_STATE(1799)] = 73397,
  [SMALL_STATE(1800)] = 73445,
  [SMALL_STATE(1801)] = 73493,
  [SMALL_STATE(1802)] = 73541,
  [SMALL_STATE(1803)] = 73589,
  [SMALL_STATE(1804)] = 73645,
  [SMALL_STATE(1805)] = 73697,
  [SMALL_STATE(1806)] = 73789,
  [SMALL_STATE(1807)] = 73837,
  [SMALL_STATE(1808)] = 73889,
  [SMALL_STATE(1809)] = 73937,
  [SMALL_STATE(1810)] = 73989,
  [SMALL_STATE(1811)] = 74037,
  [SMALL_STATE(1812)] = 74131,
  [SMALL_STATE(1813)] = 74235,
  [SMALL_STATE(1814)] = 74287,
  [SMALL_STATE(1815)] = 74391,
  [SMALL_STATE(1816)] = 74495,
  [SMALL_STATE(1817)] = 74543,
  [SMALL_STATE(1818)] = 74593,
  [SMALL_STATE(1819)] = 74697,
  [SMALL_STATE(1820)] = 74749,
  [SMALL_STATE(1821)] = 74799,
  [SMALL_STATE(1822)] = 74903,
  [SMALL_STATE(1823)] = 74951,
  [SMALL_STATE(1824)] = 75053,
  [SMALL_STATE(1825)] = 75111,
  [SMALL_STATE(1826)] = 75163,
  [SMALL_STATE(1827)] = 75215,
  [SMALL_STATE(1828)] = 75267,
  [SMALL_STATE(1829)] = 75319,
  [SMALL_STATE(1830)] = 75367,
  [SMALL_STATE(1831)] = 75415,
  [SMALL_STATE(1832)] = 75463,
  [SMALL_STATE(1833)] = 75511,
  [SMALL_STATE(1834)] = 75559,
  [SMALL_STATE(1835)] = 75633,
  [SMALL_STATE(1836)] = 75681,
  [SMALL_STATE(1837)] = 75767,
  [SMALL_STATE(1838)] = 75819,
  [SMALL_STATE(1839)] = 75921,
  [SMALL_STATE(1840)] = 76023,
  [SMALL_STATE(1841)] = 76071,
  [SMALL_STATE(1842)] = 76119,
  [SMALL_STATE(1843)] = 76187,
  [SMALL_STATE(1844)] = 76239,
  [SMALL_STATE(1845)] = 76287,
  [SMALL_STATE(1846)] = 76335,
  [SMALL_STATE(1847)] = 76391,
  [SMALL_STATE(1848)] = 76441,
  [SMALL_STATE(1849)] = 76545,
  [SMALL_STATE(1850)] = 76593,
  [SMALL_STATE(1851)] = 76697,
  [SMALL_STATE(1852)] = 76747,
  [SMALL_STATE(1853)] = 76835,
  [SMALL_STATE(1854)] = 76925,
  [SMALL_STATE(1855)] = 76997,
  [SMALL_STATE(1856)] = 77045,
  [SMALL_STATE(1857)] = 77101,
  [SMALL_STATE(1858)] = 77205,
  [SMALL_STATE(1859)] = 77261,
  [SMALL_STATE(1860)] = 77309,
  [SMALL_STATE(1861)] = 77361,
  [SMALL_STATE(1862)] = 77413,
  [SMALL_STATE(1863)] = 77481,
  [SMALL_STATE(1864)] = 77547,
  [SMALL_STATE(1865)] = 77651,
  [SMALL_STATE(1866)] = 77703,
  [SMALL_STATE(1867)] = 77755,
  [SMALL_STATE(1868)] = 77807,
  [SMALL_STATE(1869)] = 77857,
  [SMALL_STATE(1870)] = 77925,
  [SMALL_STATE(1871)] = 77973,
  [SMALL_STATE(1872)] = 78077,
  [SMALL_STATE(1873)] = 78127,
  [SMALL_STATE(1874)] = 78183,
  [SMALL_STATE(1875)] = 78231,
  [SMALL_STATE(1876)] = 78287,
  [SMALL_STATE(1877)] = 78335,
  [SMALL_STATE(1878)] = 78393,
  [SMALL_STATE(1879)] = 78451,
  [SMALL_STATE(1880)] = 78503,
  [SMALL_STATE(1881)] = 78555,
  [SMALL_STATE(1882)] = 78603,
  [SMALL_STATE(1883)] = 78671,
  [SMALL_STATE(1884)] = 78719,
  [SMALL_STATE(1885)] = 78767,
  [SMALL_STATE(1886)] = 78815,
  [SMALL_STATE(1887)] = 78919,
  [SMALL_STATE(1888)] = 79023,
  [SMALL_STATE(1889)] = 79071,
  [SMALL_STATE(1890)] = 79173,
  [SMALL_STATE(1891)] = 79221,
  [SMALL_STATE(1892)] = 79281,
  [SMALL_STATE(1893)] = 79329,
  [SMALL_STATE(1894)] = 79433,
  [SMALL_STATE(1895)] = 79481,
  [SMALL_STATE(1896)] = 79529,
  [SMALL_STATE(1897)] = 79577,
  [SMALL_STATE(1898)] = 79681,
  [SMALL_STATE(1899)] = 79785,
  [SMALL_STATE(1900)] = 79837,
  [SMALL_STATE(1901)] = 79941,
  [SMALL_STATE(1902)] = 79989,
  [SMALL_STATE(1903)] = 80057,
  [SMALL_STATE(1904)] = 80105,
  [SMALL_STATE(1905)] = 80153,
  [SMALL_STATE(1906)] = 80205,
  [SMALL_STATE(1907)] = 80255,
  [SMALL_STATE(1908)] = 80357,
  [SMALL_STATE(1909)] = 80407,
  [SMALL_STATE(1910)] = 80459,
  [SMALL_STATE(1911)] = 80507,
  [SMALL_STATE(1912)] = 80611,
  [SMALL_STATE(1913)] = 80659,
  [SMALL_STATE(1914)] = 80707,
  [SMALL_STATE(1915)] = 80755,
  [SMALL_STATE(1916)] = 80851,
  [SMALL_STATE(1917)] = 80899,
  [SMALL_STATE(1918)] = 80951,
  [SMALL_STATE(1919)] = 80999,
  [SMALL_STATE(1920)] = 81103,
  [SMALL_STATE(1921)] = 81155,
  [SMALL_STATE(1922)] = 81203,
  [SMALL_STATE(1923)] = 81251,
  [SMALL_STATE(1924)] = 81299,
  [SMALL_STATE(1925)] = 81401,
  [SMALL_STATE(1926)] = 81503,
  [SMALL_STATE(1927)] = 81605,
  [SMALL_STATE(1928)] = 81653,
  [SMALL_STATE(1929)] = 81757,
  [SMALL_STATE(1930)] = 81805,
  [SMALL_STATE(1931)] = 81859,
  [SMALL_STATE(1932)] = 81910,
  [SMALL_STATE(1933)] = 82005,
  [SMALL_STATE(1934)] = 82086,
  [SMALL_STATE(1935)] = 82187,
  [SMALL_STATE(1936)] = 82288,
  [SMALL_STATE(1937)] = 82353,
  [SMALL_STATE(1938)] = 82454,
  [SMALL_STATE(1939)] = 82533,
  [SMALL_STATE(1940)] = 82602,
  [SMALL_STATE(1941)] = 82673,
  [SMALL_STATE(1942)] = 82742,
  [SMALL_STATE(1943)] = 82831,
  [SMALL_STATE(1944)] = 82918,
  [SMALL_STATE(1945)] = 83019,
  [SMALL_STATE(1946)] = 83074,
  [SMALL_STATE(1947)] = 83159,
  [SMALL_STATE(1948)] = 83232,
  [SMALL_STATE(1949)] = 83333,
  [SMALL_STATE(1950)] = 83434,
  [SMALL_STATE(1951)] = 83499,
  [SMALL_STATE(1952)] = 83568,
  [SMALL_STATE(1953)] = 83661,
  [SMALL_STATE(1954)] = 83716,
  [SMALL_STATE(1955)] = 83807,
  [SMALL_STATE(1956)] = 83884,
  [SMALL_STATE(1957)] = 83985,
  [SMALL_STATE(1958)] = 84086,
  [SMALL_STATE(1959)] = 84153,
  [SMALL_STATE(1960)] = 84254,
  [SMALL_STATE(1961)] = 84319,
  [SMALL_STATE(1962)] = 84374,
  [SMALL_STATE(1963)] = 84475,
  [SMALL_STATE(1964)] = 84544,
  [SMALL_STATE(1965)] = 84645,
  [SMALL_STATE(1966)] = 84698,
  [SMALL_STATE(1967)] = 84761,
  [SMALL_STATE(1968)] = 84864,
  [SMALL_STATE(1969)] = 84943,
  [SMALL_STATE(1970)] = 85044,
  [SMALL_STATE(1971)] = 85145,
  [SMALL_STATE(1972)] = 85246,
  [SMALL_STATE(1973)] = 85347,
  [SMALL_STATE(1974)] = 85448,
  [SMALL_STATE(1975)] = 85501,
  [SMALL_STATE(1976)] = 85602,
  [SMALL_STATE(1977)] = 85703,
  [SMALL_STATE(1978)] = 85752,
  [SMALL_STATE(1979)] = 85803,
  [SMALL_STATE(1980)] = 85872,
  [SMALL_STATE(1981)] = 85973,
  [SMALL_STATE(1982)] = 86052,
  [SMALL_STATE(1983)] = 86121,
  [SMALL_STATE(1984)] = 86188,
  [SMALL_STATE(1985)] = 86243,
  [SMALL_STATE(1986)] = 86344,
  [SMALL_STATE(1987)] = 86409,
  [SMALL_STATE(1988)] = 86488,
  [SMALL_STATE(1989)] = 86541,
  [SMALL_STATE(1990)] = 86594,
  [SMALL_STATE(1991)] = 86695,
  [SMALL_STATE(1992)] = 86744,
  [SMALL_STATE(1993)] = 86823,
  [SMALL_STATE(1994)] = 86872,
  [SMALL_STATE(1995)] = 86951,
  [SMALL_STATE(1996)] = 87052,
  [SMALL_STATE(1997)] = 87153,
  [SMALL_STATE(1998)] = 87208,
  [SMALL_STATE(1999)] = 87287,
  [SMALL_STATE(2000)] = 87356,
  [SMALL_STATE(2001)] = 87425,
  [SMALL_STATE(2002)] = 87490,
  [SMALL_STATE(2003)] = 87560,
  [SMALL_STATE(2004)] = 87620,
  [SMALL_STATE(2005)] = 87668,
  [SMALL_STATE(2006)] = 87728,
  [SMALL_STATE(2007)] = 87798,
  [SMALL_STATE(2008)] = 87850,
  [SMALL_STATE(2009)] = 87914,
  [SMALL_STATE(2010)] = 87962,
  [SMALL_STATE(2011)] = 88014,
  [SMALL_STATE(2012)] = 88066,
  [SMALL_STATE(2013)] = 88114,
  [SMALL_STATE(2014)] = 88172,
  [SMALL_STATE(2015)] = 88232,
  [SMALL_STATE(2016)] = 88300,
  [SMALL_STATE(2017)] = 88362,
  [SMALL_STATE(2018)] = 88422,
  [SMALL_STATE(2019)] = 88484,
  [SMALL_STATE(2020)] = 88548,
  [SMALL_STATE(2021)] = 88606,
  [SMALL_STATE(2022)] = 88654,
  [SMALL_STATE(2023)] = 88716,
  [SMALL_STATE(2024)] = 88764,
  [SMALL_STATE(2025)] = 88862,
  [SMALL_STATE(2026)] = 88910,
  [SMALL_STATE(2027)] = 88990,
  [SMALL_STATE(2028)] = 89084,
  [SMALL_STATE(2029)] = 89146,
  [SMALL_STATE(2030)] = 89206,
  [SMALL_STATE(2031)] = 89304,
  [SMALL_STATE(2032)] = 89356,
  [SMALL_STATE(2033)] = 89416,
  [SMALL_STATE(2034)] = 89476,
  [SMALL_STATE(2035)] = 89534,
  [SMALL_STATE(2036)] = 89606,
  [SMALL_STATE(2037)] = 89654,
  [SMALL_STATE(2038)] = 89702,
  [SMALL_STATE(2039)] = 89762,
  [SMALL_STATE(2040)] = 89822,
  [SMALL_STATE(2041)] = 89894,
  [SMALL_STATE(2042)] = 89952,
  [SMALL_STATE(2043)] = 90028,
  [SMALL_STATE(2044)] = 90098,
  [SMALL_STATE(2045)] = 90158,
  [SMALL_STATE(2046)] = 90218,
  [SMALL_STATE(2047)] = 90290,
  [SMALL_STATE(2048)] = 90352,
  [SMALL_STATE(2049)] = 90414,
  [SMALL_STATE(2050)] = 90502,
  [SMALL_STATE(2051)] = 90562,
  [SMALL_STATE(2052)] = 90660,
  [SMALL_STATE(2053)] = 90758,
  [SMALL_STATE(2054)] = 90824,
  [SMALL_STATE(2055)] = 90872,
  [SMALL_STATE(2056)] = 90920,
  [SMALL_STATE(2057)] = 90968,
  [SMALL_STATE(2058)] = 91066,
  [SMALL_STATE(2059)] = 91164,
  [SMALL_STATE(2060)] = 91262,
  [SMALL_STATE(2061)] = 91320,
  [SMALL_STATE(2062)] = 91406,
  [SMALL_STATE(2063)] = 91504,
  [SMALL_STATE(2064)] = 91602,
  [SMALL_STATE(2065)] = 91666,
  [SMALL_STATE(2066)] = 91750,
  [SMALL_STATE(2067)] = 91800,
  [SMALL_STATE(2068)] = 91848,
  [SMALL_STATE(2069)] = 91910,
  [SMALL_STATE(2070)] = 91968,
  [SMALL_STATE(2071)] = 92066,
  [SMALL_STATE(2072)] = 92136,
  [SMALL_STATE(2073)] = 92208,
  [SMALL_STATE(2074)] = 92260,
  [SMALL_STATE(2075)] = 92320,
  [SMALL_STATE(2076)] = 92378,
  [SMALL_STATE(2077)] = 92440,
  [SMALL_STATE(2078)] = 92492,
  [SMALL_STATE(2079)] = 92564,
  [SMALL_STATE(2080)] = 92626,
  [SMALL_STATE(2081)] = 92688,
  [SMALL_STATE(2082)] = 92748,
  [SMALL_STATE(2083)] = 92818,
  [SMALL_STATE(2084)] = 92870,
  [SMALL_STATE(2085)] = 92940,
  [SMALL_STATE(2086)] = 92994,
  [SMALL_STATE(2087)] = 93056,
  [SMALL_STATE(2088)] = 93154,
  [SMALL_STATE(2089)] = 93224,
  [SMALL_STATE(2090)] = 93296,
  [SMALL_STATE(2091)] = 93394,
  [SMALL_STATE(2092)] = 93492,
  [SMALL_STATE(2093)] = 93552,
  [SMALL_STATE(2094)] = 93622,
  [SMALL_STATE(2095)] = 93712,
  [SMALL_STATE(2096)] = 93770,
  [SMALL_STATE(2097)] = 93822,
  [SMALL_STATE(2098)] = 93920,
  [SMALL_STATE(2099)] = 93978,
  [SMALL_STATE(2100)] = 94050,
  [SMALL_STATE(2101)] = 94142,
  [SMALL_STATE(2102)] = 94214,
  [SMALL_STATE(2103)] = 94272,
  [SMALL_STATE(2104)] = 94337,
  [SMALL_STATE(2105)] = 94392,
  [SMALL_STATE(2106)] = 94447,
  [SMALL_STATE(2107)] = 94502,
  [SMALL_STATE(2108)] = 94557,
  [SMALL_STATE(2109)] = 94612,
  [SMALL_STATE(2110)] = 94689,
  [SMALL_STATE(2111)] = 94744,
  [SMALL_STATE(2112)] = 94799,
  [SMALL_STATE(2113)] = 94854,
  [SMALL_STATE(2114)] = 94919,
  [SMALL_STATE(2115)] = 94984,
  [SMALL_STATE(2116)] = 95039,
  [SMALL_STATE(2117)] = 95090,
  [SMALL_STATE(2118)] = 95161,
  [SMALL_STATE(2119)] = 95208,
  [SMALL_STATE(2120)] = 95263,
  [SMALL_STATE(2121)] = 95318,
  [SMALL_STATE(2122)] = 95373,
  [SMALL_STATE(2123)] = 95420,
  [SMALL_STATE(2124)] = 95485,
  [SMALL_STATE(2125)] = 95540,
  [SMALL_STATE(2126)] = 95605,
  [SMALL_STATE(2127)] = 95660,
  [SMALL_STATE(2128)] = 95711,
  [SMALL_STATE(2129)] = 95766,
  [SMALL_STATE(2130)] = 95813,
  [SMALL_STATE(2131)] = 95878,
  [SMALL_STATE(2132)] = 95929,
  [SMALL_STATE(2133)] = 95980,
  [SMALL_STATE(2134)] = 96045,
  [SMALL_STATE(2135)] = 96100,
  [SMALL_STATE(2136)] = 96155,
  [SMALL_STATE(2137)] = 96210,
  [SMALL_STATE(2138)] = 96260,
  [SMALL_STATE(2139)] = 96310,
  [SMALL_STATE(2140)] = 96370,
  [SMALL_STATE(2141)] = 96426,
  [SMALL_STATE(2142)] = 96494,
  [SMALL_STATE(2143)] = 96558,
  [SMALL_STATE(2144)] = 96620,
  [SMALL_STATE(2145)] = 96680,
  [SMALL_STATE(2146)] = 96736,
  [SMALL_STATE(2147)] = 96791,
  [SMALL_STATE(2148)] = 96848,
  [SMALL_STATE(2149)] = 96903,
  [SMALL_STATE(2150)] = 96958,
  [SMALL_STATE(2151)] = 97013,
  [SMALL_STATE(2152)] = 97068,
  [SMALL_STATE(2153)] = 97123,
  [SMALL_STATE(2154)] = 97178,
  [SMALL_STATE(2155)] = 97233,
  [SMALL_STATE(2156)] = 97288,
  [SMALL_STATE(2157)] = 97343,
  [SMALL_STATE(2158)] = 97398,
  [SMALL_STATE(2159)] = 97451,
  [SMALL_STATE(2160)] = 97506,
  [SMALL_STATE(2161)] = 97561,
  [SMALL_STATE(2162)] = 97620,
  [SMALL_STATE(2163)] = 97675,
  [SMALL_STATE(2164)] = 97736,
  [SMALL_STATE(2165)] = 97789,
  [SMALL_STATE(2166)] = 97843,
  [SMALL_STATE(2167)] = 97922,
  [SMALL_STATE(2168)] = 98001,
  [SMALL_STATE(2169)] = 98080,
  [SMALL_STATE(2170)] = 98127,
  [SMALL_STATE(2171)] = 98174,
  [SMALL_STATE(2172)] = 98221,
  [SMALL_STATE(2173)] = 98300,
  [SMALL_STATE(2174)] = 98379,
  [SMALL_STATE(2175)] = 98458,
  [SMALL_STATE(2176)] = 98521,
  [SMALL_STATE(2177)] = 98600,
  [SMALL_STATE(2178)] = 98640,
  [SMALL_STATE(2179)] = 98680,
  [SMALL_STATE(2180)] = 98720,
  [SMALL_STATE(2181)] = 98760,
  [SMALL_STATE(2182)] = 98800,
  [SMALL_STATE(2183)] = 98852,
  [SMALL_STATE(2184)] = 98892,
  [SMALL_STATE(2185)] = 98932,
  [SMALL_STATE(2186)] = 98972,
  [SMALL_STATE(2187)] = 99012,
  [SMALL_STATE(2188)] = 99066,
  [SMALL_STATE(2189)] = 99108,
  [SMALL_STATE(2190)] = 99148,
  [SMALL_STATE(2191)] = 99202,
  [SMALL_STATE(2192)] = 99244,
  [SMALL_STATE(2193)] = 99288,
  [SMALL_STATE(2194)] = 99328,
  [SMALL_STATE(2195)] = 99370,
  [SMALL_STATE(2196)] = 99426,
  [SMALL_STATE(2197)] = 99470,
  [SMALL_STATE(2198)] = 99510,
  [SMALL_STATE(2199)] = 99550,
  [SMALL_STATE(2200)] = 99590,
  [SMALL_STATE(2201)] = 99630,
  [SMALL_STATE(2202)] = 99670,
  [SMALL_STATE(2203)] = 99710,
  [SMALL_STATE(2204)] = 99750,
  [SMALL_STATE(2205)] = 99790,
  [SMALL_STATE(2206)] = 99846,
  [SMALL_STATE(2207)] = 99900,
  [SMALL_STATE(2208)] = 99940,
  [SMALL_STATE(2209)] = 99996,
  [SMALL_STATE(2210)] = 100036,
  [SMALL_STATE(2211)] = 100090,
  [SMALL_STATE(2212)] = 100130,
  [SMALL_STATE(2213)] = 100170,
  [SMALL_STATE(2214)] = 100210,
  [SMALL_STATE(2215)] = 100250,
  [SMALL_STATE(2216)] = 100299,
  [SMALL_STATE(2217)] = 100348,
  [SMALL_STATE(2218)] = 100411,
  [SMALL_STATE(2219)] = 100460,
  [SMALL_STATE(2220)] = 100509,
  [SMALL_STATE(2221)] = 100558,
  [SMALL_STATE(2222)] = 100607,
  [SMALL_STATE(2223)] = 100656,
  [SMALL_STATE(2224)] = 100705,
  [SMALL_STATE(2225)] = 100754,
  [SMALL_STATE(2226)] = 100803,
  [SMALL_STATE(2227)] = 100852,
  [SMALL_STATE(2228)] = 100901,
  [SMALL_STATE(2229)] = 100950,
  [SMALL_STATE(2230)] = 100999,
  [SMALL_STATE(2231)] = 101048,
  [SMALL_STATE(2232)] = 101097,
  [SMALL_STATE(2233)] = 101146,
  [SMALL_STATE(2234)] = 101195,
  [SMALL_STATE(2235)] = 101244,
  [SMALL_STATE(2236)] = 101293,
  [SMALL_STATE(2237)] = 101343,
  [SMALL_STATE(2238)] = 101393,
  [SMALL_STATE(2239)] = 101449,
  [SMALL_STATE(2240)] = 101487,
  [SMALL_STATE(2241)] = 101547,
  [SMALL_STATE(2242)] = 101597,
  [SMALL_STATE(2243)] = 101647,
  [SMALL_STATE(2244)] = 101685,
  [SMALL_STATE(2245)] = 101745,
  [SMALL_STATE(2246)] = 101805,
  [SMALL_STATE(2247)] = 101855,
  [SMALL_STATE(2248)] = 101893,
  [SMALL_STATE(2249)] = 101943,
  [SMALL_STATE(2250)] = 101981,
  [SMALL_STATE(2251)] = 102019,
  [SMALL_STATE(2252)] = 102057,
  [SMALL_STATE(2253)] = 102107,
  [SMALL_STATE(2254)] = 102157,
  [SMALL_STATE(2255)] = 102207,
  [SMALL_STATE(2256)] = 102257,
  [SMALL_STATE(2257)] = 102310,
  [SMALL_STATE(2258)] = 102357,
  [SMALL_STATE(2259)] = 102410,
  [SMALL_STATE(2260)] = 102463,
  [SMALL_STATE(2261)] = 102516,
  [SMALL_STATE(2262)] = 102567,
  [SMALL_STATE(2263)] = 102618,
  [SMALL_STATE(2264)] = 102671,
  [SMALL_STATE(2265)] = 102724,
  [SMALL_STATE(2266)] = 102763,
  [SMALL_STATE(2267)] = 102816,
  [SMALL_STATE(2268)] = 102869,
  [SMALL_STATE(2269)] = 102922,
  [SMALL_STATE(2270)] = 102975,
  [SMALL_STATE(2271)] = 103028,
  [SMALL_STATE(2272)] = 103081,
  [SMALL_STATE(2273)] = 103125,
  [SMALL_STATE(2274)] = 103169,
  [SMALL_STATE(2275)] = 103215,
  [SMALL_STATE(2276)] = 103259,
  [SMALL_STATE(2277)] = 103305,
  [SMALL_STATE(2278)] = 103349,
  [SMALL_STATE(2279)] = 103393,
  [SMALL_STATE(2280)] = 103437,
  [SMALL_STATE(2281)] = 103481,
  [SMALL_STATE(2282)] = 103525,
  [SMALL_STATE(2283)] = 103571,
  [SMALL_STATE(2284)] = 103615,
  [SMALL_STATE(2285)] = 103659,
  [SMALL_STATE(2286)] = 103703,
  [SMALL_STATE(2287)] = 103747,
  [SMALL_STATE(2288)] = 103791,
  [SMALL_STATE(2289)] = 103835,
  [SMALL_STATE(2290)] = 103879,
  [SMALL_STATE(2291)] = 103923,
  [SMALL_STATE(2292)] = 103967,
  [SMALL_STATE(2293)] = 104011,
  [SMALL_STATE(2294)] = 104055,
  [SMALL_STATE(2295)] = 104099,
  [SMALL_STATE(2296)] = 104143,
  [SMALL_STATE(2297)] = 104187,
  [SMALL_STATE(2298)] = 104231,
  [SMALL_STATE(2299)] = 104275,
  [SMALL_STATE(2300)] = 104319,
  [SMALL_STATE(2301)] = 104363,
  [SMALL_STATE(2302)] = 104407,
  [SMALL_STATE(2303)] = 104451,
  [SMALL_STATE(2304)] = 104495,
  [SMALL_STATE(2305)] = 104526,
  [SMALL_STATE(2306)] = 104552,
  [SMALL_STATE(2307)] = 104608,
  [SMALL_STATE(2308)] = 104664,
  [SMALL_STATE(2309)] = 104690,
  [SMALL_STATE(2310)] = 104716,
  [SMALL_STATE(2311)] = 104748,
  [SMALL_STATE(2312)] = 104774,
  [SMALL_STATE(2313)] = 104800,
  [SMALL_STATE(2314)] = 104826,
  [SMALL_STATE(2315)] = 104852,
  [SMALL_STATE(2316)] = 104878,
  [SMALL_STATE(2317)] = 104904,
  [SMALL_STATE(2318)] = 104930,
  [SMALL_STATE(2319)] = 104956,
  [SMALL_STATE(2320)] = 104982,
  [SMALL_STATE(2321)] = 105008,
  [SMALL_STATE(2322)] = 105034,
  [SMALL_STATE(2323)] = 105060,
  [SMALL_STATE(2324)] = 105086,
  [SMALL_STATE(2325)] = 105112,
  [SMALL_STATE(2326)] = 105148,
  [SMALL_STATE(2327)] = 105184,
  [SMALL_STATE(2328)] = 105210,
  [SMALL_STATE(2329)] = 105236,
  [SMALL_STATE(2330)] = 105262,
  [SMALL_STATE(2331)] = 105288,
  [SMALL_STATE(2332)] = 105314,
  [SMALL_STATE(2333)] = 105340,
  [SMALL_STATE(2334)] = 105366,
  [SMALL_STATE(2335)] = 105402,
  [SMALL_STATE(2336)] = 105428,
  [SMALL_STATE(2337)] = 105462,
  [SMALL_STATE(2338)] = 105488,
  [SMALL_STATE(2339)] = 105514,
  [SMALL_STATE(2340)] = 105540,
  [SMALL_STATE(2341)] = 105566,
  [SMALL_STATE(2342)] = 105592,
  [SMALL_STATE(2343)] = 105618,
  [SMALL_STATE(2344)] = 105644,
  [SMALL_STATE(2345)] = 105670,
  [SMALL_STATE(2346)] = 105696,
  [SMALL_STATE(2347)] = 105722,
  [SMALL_STATE(2348)] = 105748,
  [SMALL_STATE(2349)] = 105774,
  [SMALL_STATE(2350)] = 105805,
  [SMALL_STATE(2351)] = 105832,
  [SMALL_STATE(2352)] = 105857,
  [SMALL_STATE(2353)] = 105886,
  [SMALL_STATE(2354)] = 105911,
  [SMALL_STATE(2355)] = 105936,
  [SMALL_STATE(2356)] = 105960,
  [SMALL_STATE(2357)] = 105984,
  [SMALL_STATE(2358)] = 106007,
  [SMALL_STATE(2359)] = 106030,
  [SMALL_STATE(2360)] = 106063,
  [SMALL_STATE(2361)] = 106084,
  [SMALL_STATE(2362)] = 106107,
  [SMALL_STATE(2363)] = 106140,
  [SMALL_STATE(2364)] = 106163,
  [SMALL_STATE(2365)] = 106186,
  [SMALL_STATE(2366)] = 106209,
  [SMALL_STATE(2367)] = 106234,
  [SMALL_STATE(2368)] = 106255,
  [SMALL_STATE(2369)] = 106276,
  [SMALL_STATE(2370)] = 106301,
  [SMALL_STATE(2371)] = 106324,
  [SMALL_STATE(2372)] = 106347,
  [SMALL_STATE(2373)] = 106370,
  [SMALL_STATE(2374)] = 106393,
  [SMALL_STATE(2375)] = 106414,
  [SMALL_STATE(2376)] = 106437,
  [SMALL_STATE(2377)] = 106460,
  [SMALL_STATE(2378)] = 106483,
  [SMALL_STATE(2379)] = 106516,
  [SMALL_STATE(2380)] = 106539,
  [SMALL_STATE(2381)] = 106566,
  [SMALL_STATE(2382)] = 106589,
  [SMALL_STATE(2383)] = 106610,
  [SMALL_STATE(2384)] = 106633,
  [SMALL_STATE(2385)] = 106656,
  [SMALL_STATE(2386)] = 106677,
  [SMALL_STATE(2387)] = 106702,
  [SMALL_STATE(2388)] = 106725,
  [SMALL_STATE(2389)] = 106746,
  [SMALL_STATE(2390)] = 106769,
  [SMALL_STATE(2391)] = 106792,
  [SMALL_STATE(2392)] = 106815,
  [SMALL_STATE(2393)] = 106838,
  [SMALL_STATE(2394)] = 106861,
  [SMALL_STATE(2395)] = 106884,
  [SMALL_STATE(2396)] = 106915,
  [SMALL_STATE(2397)] = 106938,
  [SMALL_STATE(2398)] = 106959,
  [SMALL_STATE(2399)] = 106989,
  [SMALL_STATE(2400)] = 107019,
  [SMALL_STATE(2401)] = 107049,
  [SMALL_STATE(2402)] = 107073,
  [SMALL_STATE(2403)] = 107101,
  [SMALL_STATE(2404)] = 107129,
  [SMALL_STATE(2405)] = 107171,
  [SMALL_STATE(2406)] = 107213,
  [SMALL_STATE(2407)] = 107241,
  [SMALL_STATE(2408)] = 107271,
  [SMALL_STATE(2409)] = 107301,
  [SMALL_STATE(2410)] = 107343,
  [SMALL_STATE(2411)] = 107371,
  [SMALL_STATE(2412)] = 107401,
  [SMALL_STATE(2413)] = 107431,
  [SMALL_STATE(2414)] = 107461,
  [SMALL_STATE(2415)] = 107489,
  [SMALL_STATE(2416)] = 107517,
  [SMALL_STATE(2417)] = 107545,
  [SMALL_STATE(2418)] = 107579,
  [SMALL_STATE(2419)] = 107607,
  [SMALL_STATE(2420)] = 107637,
  [SMALL_STATE(2421)] = 107665,
  [SMALL_STATE(2422)] = 107687,
  [SMALL_STATE(2423)] = 107709,
  [SMALL_STATE(2424)] = 107731,
  [SMALL_STATE(2425)] = 107753,
  [SMALL_STATE(2426)] = 107775,
  [SMALL_STATE(2427)] = 107797,
  [SMALL_STATE(2428)] = 107819,
  [SMALL_STATE(2429)] = 107841,
  [SMALL_STATE(2430)] = 107863,
  [SMALL_STATE(2431)] = 107885,
  [SMALL_STATE(2432)] = 107907,
  [SMALL_STATE(2433)] = 107929,
  [SMALL_STATE(2434)] = 107951,
  [SMALL_STATE(2435)] = 107973,
  [SMALL_STATE(2436)] = 108003,
  [SMALL_STATE(2437)] = 108033,
  [SMALL_STATE(2438)] = 108063,
  [SMALL_STATE(2439)] = 108093,
  [SMALL_STATE(2440)] = 108123,
  [SMALL_STATE(2441)] = 108153,
  [SMALL_STATE(2442)] = 108183,
  [SMALL_STATE(2443)] = 108211,
  [SMALL_STATE(2444)] = 108239,
  [SMALL_STATE(2445)] = 108265,
  [SMALL_STATE(2446)] = 108287,
  [SMALL_STATE(2447)] = 108309,
  [SMALL_STATE(2448)] = 108331,
  [SMALL_STATE(2449)] = 108353,
  [SMALL_STATE(2450)] = 108375,
  [SMALL_STATE(2451)] = 108397,
  [SMALL_STATE(2452)] = 108419,
  [SMALL_STATE(2453)] = 108441,
  [SMALL_STATE(2454)] = 108463,
  [SMALL_STATE(2455)] = 108485,
  [SMALL_STATE(2456)] = 108513,
  [SMALL_STATE(2457)] = 108543,
  [SMALL_STATE(2458)] = 108573,
  [SMALL_STATE(2459)] = 108595,
  [SMALL_STATE(2460)] = 108617,
  [SMALL_STATE(2461)] = 108639,
  [SMALL_STATE(2462)] = 108661,
  [SMALL_STATE(2463)] = 108683,
  [SMALL_STATE(2464)] = 108705,
  [SMALL_STATE(2465)] = 108727,
  [SMALL_STATE(2466)] = 108749,
  [SMALL_STATE(2467)] = 108771,
  [SMALL_STATE(2468)] = 108793,
  [SMALL_STATE(2469)] = 108835,
  [SMALL_STATE(2470)] = 108863,
  [SMALL_STATE(2471)] = 108893,
  [SMALL_STATE(2472)] = 108923,
  [SMALL_STATE(2473)] = 108953,
  [SMALL_STATE(2474)] = 108983,
  [SMALL_STATE(2475)] = 109011,
  [SMALL_STATE(2476)] = 109041,
  [SMALL_STATE(2477)] = 109083,
  [SMALL_STATE(2478)] = 109111,
  [SMALL_STATE(2479)] = 109141,
  [SMALL_STATE(2480)] = 109183,
  [SMALL_STATE(2481)] = 109213,
  [SMALL_STATE(2482)] = 109237,
  [SMALL_STATE(2483)] = 109267,
  [SMALL_STATE(2484)] = 109309,
  [SMALL_STATE(2485)] = 109339,
  [SMALL_STATE(2486)] = 109369,
  [SMALL_STATE(2487)] = 109399,
  [SMALL_STATE(2488)] = 109429,
  [SMALL_STATE(2489)] = 109464,
  [SMALL_STATE(2490)] = 109499,
  [SMALL_STATE(2491)] = 109534,
  [SMALL_STATE(2492)] = 109569,
  [SMALL_STATE(2493)] = 109610,
  [SMALL_STATE(2494)] = 109645,
  [SMALL_STATE(2495)] = 109674,
  [SMALL_STATE(2496)] = 109709,
  [SMALL_STATE(2497)] = 109738,
  [SMALL_STATE(2498)] = 109765,
  [SMALL_STATE(2499)] = 109786,
  [SMALL_STATE(2500)] = 109807,
  [SMALL_STATE(2501)] = 109828,
  [SMALL_STATE(2502)] = 109853,
  [SMALL_STATE(2503)] = 109874,
  [SMALL_STATE(2504)] = 109903,
  [SMALL_STATE(2505)] = 109924,
  [SMALL_STATE(2506)] = 109945,
  [SMALL_STATE(2507)] = 109986,
  [SMALL_STATE(2508)] = 110021,
  [SMALL_STATE(2509)] = 110056,
  [SMALL_STATE(2510)] = 110079,
  [SMALL_STATE(2511)] = 110106,
  [SMALL_STATE(2512)] = 110141,
  [SMALL_STATE(2513)] = 110176,
  [SMALL_STATE(2514)] = 110214,
  [SMALL_STATE(2515)] = 110242,
  [SMALL_STATE(2516)] = 110260,
  [SMALL_STATE(2517)] = 110278,
  [SMALL_STATE(2518)] = 110300,
  [SMALL_STATE(2519)] = 110338,
  [SMALL_STATE(2520)] = 110356,
  [SMALL_STATE(2521)] = 110374,
  [SMALL_STATE(2522)] = 110392,
  [SMALL_STATE(2523)] = 110430,
  [SMALL_STATE(2524)] = 110448,
  [SMALL_STATE(2525)] = 110466,
  [SMALL_STATE(2526)] = 110496,
  [SMALL_STATE(2527)] = 110514,
  [SMALL_STATE(2528)] = 110550,
  [SMALL_STATE(2529)] = 110582,
  [SMALL_STATE(2530)] = 110600,
  [SMALL_STATE(2531)] = 110618,
  [SMALL_STATE(2532)] = 110636,
  [SMALL_STATE(2533)] = 110654,
  [SMALL_STATE(2534)] = 110672,
  [SMALL_STATE(2535)] = 110708,
  [SMALL_STATE(2536)] = 110726,
  [SMALL_STATE(2537)] = 110744,
  [SMALL_STATE(2538)] = 110762,
  [SMALL_STATE(2539)] = 110794,
  [SMALL_STATE(2540)] = 110812,
  [SMALL_STATE(2541)] = 110840,
  [SMALL_STATE(2542)] = 110858,
  [SMALL_STATE(2543)] = 110894,
  [SMALL_STATE(2544)] = 110912,
  [SMALL_STATE(2545)] = 110944,
  [SMALL_STATE(2546)] = 110980,
  [SMALL_STATE(2547)] = 110998,
  [SMALL_STATE(2548)] = 111036,
  [SMALL_STATE(2549)] = 111054,
  [SMALL_STATE(2550)] = 111086,
  [SMALL_STATE(2551)] = 111110,
  [SMALL_STATE(2552)] = 111138,
  [SMALL_STATE(2553)] = 111156,
  [SMALL_STATE(2554)] = 111188,
  [SMALL_STATE(2555)] = 111206,
  [SMALL_STATE(2556)] = 111234,
  [SMALL_STATE(2557)] = 111266,
  [SMALL_STATE(2558)] = 111284,
  [SMALL_STATE(2559)] = 111302,
  [SMALL_STATE(2560)] = 111320,
  [SMALL_STATE(2561)] = 111338,
  [SMALL_STATE(2562)] = 111356,
  [SMALL_STATE(2563)] = 111374,
  [SMALL_STATE(2564)] = 111402,
  [SMALL_STATE(2565)] = 111420,
  [SMALL_STATE(2566)] = 111438,
  [SMALL_STATE(2567)] = 111456,
  [SMALL_STATE(2568)] = 111492,
  [SMALL_STATE(2569)] = 111524,
  [SMALL_STATE(2570)] = 111542,
  [SMALL_STATE(2571)] = 111560,
  [SMALL_STATE(2572)] = 111596,
  [SMALL_STATE(2573)] = 111628,
  [SMALL_STATE(2574)] = 111660,
  [SMALL_STATE(2575)] = 111696,
  [SMALL_STATE(2576)] = 111728,
  [SMALL_STATE(2577)] = 111747,
  [SMALL_STATE(2578)] = 111766,
  [SMALL_STATE(2579)] = 111785,
  [SMALL_STATE(2580)] = 111808,
  [SMALL_STATE(2581)] = 111827,
  [SMALL_STATE(2582)] = 111844,
  [SMALL_STATE(2583)] = 111865,
  [SMALL_STATE(2584)] = 111884,
  [SMALL_STATE(2585)] = 111903,
  [SMALL_STATE(2586)] = 111922,
  [SMALL_STATE(2587)] = 111941,
  [SMALL_STATE(2588)] = 111960,
  [SMALL_STATE(2589)] = 111983,
  [SMALL_STATE(2590)] = 112002,
  [SMALL_STATE(2591)] = 112021,
  [SMALL_STATE(2592)] = 112040,
  [SMALL_STATE(2593)] = 112059,
  [SMALL_STATE(2594)] = 112082,
  [SMALL_STATE(2595)] = 112101,
  [SMALL_STATE(2596)] = 112122,
  [SMALL_STATE(2597)] = 112141,
  [SMALL_STATE(2598)] = 112160,
  [SMALL_STATE(2599)] = 112183,
  [SMALL_STATE(2600)] = 112202,
  [SMALL_STATE(2601)] = 112221,
  [SMALL_STATE(2602)] = 112240,
  [SMALL_STATE(2603)] = 112259,
  [SMALL_STATE(2604)] = 112276,
  [SMALL_STATE(2605)] = 112293,
  [SMALL_STATE(2606)] = 112310,
  [SMALL_STATE(2607)] = 112327,
  [SMALL_STATE(2608)] = 112348,
  [SMALL_STATE(2609)] = 112367,
  [SMALL_STATE(2610)] = 112388,
  [SMALL_STATE(2611)] = 112407,
  [SMALL_STATE(2612)] = 112430,
  [SMALL_STATE(2613)] = 112453,
  [SMALL_STATE(2614)] = 112472,
  [SMALL_STATE(2615)] = 112491,
  [SMALL_STATE(2616)] = 112510,
  [SMALL_STATE(2617)] = 112531,
  [SMALL_STATE(2618)] = 112550,
  [SMALL_STATE(2619)] = 112569,
  [SMALL_STATE(2620)] = 112588,
  [SMALL_STATE(2621)] = 112607,
  [SMALL_STATE(2622)] = 112624,
  [SMALL_STATE(2623)] = 112641,
  [SMALL_STATE(2624)] = 112660,
  [SMALL_STATE(2625)] = 112681,
  [SMALL_STATE(2626)] = 112700,
  [SMALL_STATE(2627)] = 112719,
  [SMALL_STATE(2628)] = 112738,
  [SMALL_STATE(2629)] = 112757,
  [SMALL_STATE(2630)] = 112774,
  [SMALL_STATE(2631)] = 112808,
  [SMALL_STATE(2632)] = 112834,
  [SMALL_STATE(2633)] = 112862,
  [SMALL_STATE(2634)] = 112888,
  [SMALL_STATE(2635)] = 112922,
  [SMALL_STATE(2636)] = 112954,
  [SMALL_STATE(2637)] = 112980,
  [SMALL_STATE(2638)] = 113014,
  [SMALL_STATE(2639)] = 113034,
  [SMALL_STATE(2640)] = 113068,
  [SMALL_STATE(2641)] = 113094,
  [SMALL_STATE(2642)] = 113114,
  [SMALL_STATE(2643)] = 113140,
  [SMALL_STATE(2644)] = 113166,
  [SMALL_STATE(2645)] = 113186,
  [SMALL_STATE(2646)] = 113218,
  [SMALL_STATE(2647)] = 113236,
  [SMALL_STATE(2648)] = 113258,
  [SMALL_STATE(2649)] = 113292,
  [SMALL_STATE(2650)] = 113318,
  [SMALL_STATE(2651)] = 113352,
  [SMALL_STATE(2652)] = 113384,
  [SMALL_STATE(2653)] = 113418,
  [SMALL_STATE(2654)] = 113442,
  [SMALL_STATE(2655)] = 113468,
  [SMALL_STATE(2656)] = 113494,
  [SMALL_STATE(2657)] = 113520,
  [SMALL_STATE(2658)] = 113548,
  [SMALL_STATE(2659)] = 113574,
  [SMALL_STATE(2660)] = 113608,
  [SMALL_STATE(2661)] = 113642,
  [SMALL_STATE(2662)] = 113676,
  [SMALL_STATE(2663)] = 113708,
  [SMALL_STATE(2664)] = 113742,
  [SMALL_STATE(2665)] = 113768,
  [SMALL_STATE(2666)] = 113794,
  [SMALL_STATE(2667)] = 113826,
  [SMALL_STATE(2668)] = 113855,
  [SMALL_STATE(2669)] = 113870,
  [SMALL_STATE(2670)] = 113899,
  [SMALL_STATE(2671)] = 113928,
  [SMALL_STATE(2672)] = 113951,
  [SMALL_STATE(2673)] = 113974,
  [SMALL_STATE(2674)] = 114005,
  [SMALL_STATE(2675)] = 114034,
  [SMALL_STATE(2676)] = 114063,
  [SMALL_STATE(2677)] = 114094,
  [SMALL_STATE(2678)] = 114109,
  [SMALL_STATE(2679)] = 114138,
  [SMALL_STATE(2680)] = 114167,
  [SMALL_STATE(2681)] = 114182,
  [SMALL_STATE(2682)] = 114197,
  [SMALL_STATE(2683)] = 114214,
  [SMALL_STATE(2684)] = 114229,
  [SMALL_STATE(2685)] = 114244,
  [SMALL_STATE(2686)] = 114265,
  [SMALL_STATE(2687)] = 114284,
  [SMALL_STATE(2688)] = 114299,
  [SMALL_STATE(2689)] = 114316,
  [SMALL_STATE(2690)] = 114337,
  [SMALL_STATE(2691)] = 114368,
  [SMALL_STATE(2692)] = 114397,
  [SMALL_STATE(2693)] = 114426,
  [SMALL_STATE(2694)] = 114455,
  [SMALL_STATE(2695)] = 114484,
  [SMALL_STATE(2696)] = 114509,
  [SMALL_STATE(2697)] = 114532,
  [SMALL_STATE(2698)] = 114547,
  [SMALL_STATE(2699)] = 114562,
  [SMALL_STATE(2700)] = 114577,
  [SMALL_STATE(2701)] = 114592,
  [SMALL_STATE(2702)] = 114609,
  [SMALL_STATE(2703)] = 114624,
  [SMALL_STATE(2704)] = 114639,
  [SMALL_STATE(2705)] = 114664,
  [SMALL_STATE(2706)] = 114679,
  [SMALL_STATE(2707)] = 114708,
  [SMALL_STATE(2708)] = 114729,
  [SMALL_STATE(2709)] = 114744,
  [SMALL_STATE(2710)] = 114759,
  [SMALL_STATE(2711)] = 114776,
  [SMALL_STATE(2712)] = 114791,
  [SMALL_STATE(2713)] = 114820,
  [SMALL_STATE(2714)] = 114851,
  [SMALL_STATE(2715)] = 114866,
  [SMALL_STATE(2716)] = 114881,
  [SMALL_STATE(2717)] = 114896,
  [SMALL_STATE(2718)] = 114919,
  [SMALL_STATE(2719)] = 114948,
  [SMALL_STATE(2720)] = 114977,
  [SMALL_STATE(2721)] = 114992,
  [SMALL_STATE(2722)] = 115007,
  [SMALL_STATE(2723)] = 115038,
  [SMALL_STATE(2724)] = 115069,
  [SMALL_STATE(2725)] = 115084,
  [SMALL_STATE(2726)] = 115099,
  [SMALL_STATE(2727)] = 115114,
  [SMALL_STATE(2728)] = 115139,
  [SMALL_STATE(2729)] = 115170,
  [SMALL_STATE(2730)] = 115193,
  [SMALL_STATE(2731)] = 115222,
  [SMALL_STATE(2732)] = 115237,
  [SMALL_STATE(2733)] = 115252,
  [SMALL_STATE(2734)] = 115283,
  [SMALL_STATE(2735)] = 115298,
  [SMALL_STATE(2736)] = 115319,
  [SMALL_STATE(2737)] = 115334,
  [SMALL_STATE(2738)] = 115349,
  [SMALL_STATE(2739)] = 115378,
  [SMALL_STATE(2740)] = 115401,
  [SMALL_STATE(2741)] = 115432,
  [SMALL_STATE(2742)] = 115457,
  [SMALL_STATE(2743)] = 115472,
  [SMALL_STATE(2744)] = 115501,
  [SMALL_STATE(2745)] = 115526,
  [SMALL_STATE(2746)] = 115557,
  [SMALL_STATE(2747)] = 115582,
  [SMALL_STATE(2748)] = 115611,
  [SMALL_STATE(2749)] = 115630,
  [SMALL_STATE(2750)] = 115645,
  [SMALL_STATE(2751)] = 115660,
  [SMALL_STATE(2752)] = 115675,
  [SMALL_STATE(2753)] = 115704,
  [SMALL_STATE(2754)] = 115727,
  [SMALL_STATE(2755)] = 115750,
  [SMALL_STATE(2756)] = 115769,
  [SMALL_STATE(2757)] = 115798,
  [SMALL_STATE(2758)] = 115827,
  [SMALL_STATE(2759)] = 115858,
  [SMALL_STATE(2760)] = 115889,
  [SMALL_STATE(2761)] = 115912,
  [SMALL_STATE(2762)] = 115927,
  [SMALL_STATE(2763)] = 115942,
  [SMALL_STATE(2764)] = 115961,
  [SMALL_STATE(2765)] = 115992,
  [SMALL_STATE(2766)] = 116017,
  [SMALL_STATE(2767)] = 116042,
  [SMALL_STATE(2768)] = 116071,
  [SMALL_STATE(2769)] = 116102,
  [SMALL_STATE(2770)] = 116131,
  [SMALL_STATE(2771)] = 116154,
  [SMALL_STATE(2772)] = 116179,
  [SMALL_STATE(2773)] = 116194,
  [SMALL_STATE(2774)] = 116225,
  [SMALL_STATE(2775)] = 116256,
  [SMALL_STATE(2776)] = 116281,
  [SMALL_STATE(2777)] = 116312,
  [SMALL_STATE(2778)] = 116341,
  [SMALL_STATE(2779)] = 116356,
  [SMALL_STATE(2780)] = 116381,
  [SMALL_STATE(2781)] = 116406,
  [SMALL_STATE(2782)] = 116431,
  [SMALL_STATE(2783)] = 116456,
  [SMALL_STATE(2784)] = 116487,
  [SMALL_STATE(2785)] = 116502,
  [SMALL_STATE(2786)] = 116517,
  [SMALL_STATE(2787)] = 116546,
  [SMALL_STATE(2788)] = 116575,
  [SMALL_STATE(2789)] = 116604,
  [SMALL_STATE(2790)] = 116633,
  [SMALL_STATE(2791)] = 116664,
  [SMALL_STATE(2792)] = 116678,
  [SMALL_STATE(2793)] = 116702,
  [SMALL_STATE(2794)] = 116726,
  [SMALL_STATE(2795)] = 116746,
  [SMALL_STATE(2796)] = 116766,
  [SMALL_STATE(2797)] = 116790,
  [SMALL_STATE(2798)] = 116810,
  [SMALL_STATE(2799)] = 116830,
  [SMALL_STATE(2800)] = 116854,
  [SMALL_STATE(2801)] = 116878,
  [SMALL_STATE(2802)] = 116902,
  [SMALL_STATE(2803)] = 116926,
  [SMALL_STATE(2804)] = 116950,
  [SMALL_STATE(2805)] = 116966,
  [SMALL_STATE(2806)] = 116990,
  [SMALL_STATE(2807)] = 117004,
  [SMALL_STATE(2808)] = 117028,
  [SMALL_STATE(2809)] = 117042,
  [SMALL_STATE(2810)] = 117066,
  [SMALL_STATE(2811)] = 117090,
  [SMALL_STATE(2812)] = 117107,
  [SMALL_STATE(2813)] = 117122,
  [SMALL_STATE(2814)] = 117141,
  [SMALL_STATE(2815)] = 117162,
  [SMALL_STATE(2816)] = 117175,
  [SMALL_STATE(2817)] = 117196,
  [SMALL_STATE(2818)] = 117217,
  [SMALL_STATE(2819)] = 117242,
  [SMALL_STATE(2820)] = 117267,
  [SMALL_STATE(2821)] = 117288,
  [SMALL_STATE(2822)] = 117313,
  [SMALL_STATE(2823)] = 117338,
  [SMALL_STATE(2824)] = 117359,
  [SMALL_STATE(2825)] = 117372,
  [SMALL_STATE(2826)] = 117397,
  [SMALL_STATE(2827)] = 117410,
  [SMALL_STATE(2828)] = 117435,
  [SMALL_STATE(2829)] = 117452,
  [SMALL_STATE(2830)] = 117477,
  [SMALL_STATE(2831)] = 117492,
  [SMALL_STATE(2832)] = 117513,
  [SMALL_STATE(2833)] = 117538,
  [SMALL_STATE(2834)] = 117563,
  [SMALL_STATE(2835)] = 117588,
  [SMALL_STATE(2836)] = 117605,
  [SMALL_STATE(2837)] = 117630,
  [SMALL_STATE(2838)] = 117655,
  [SMALL_STATE(2839)] = 117676,
  [SMALL_STATE(2840)] = 117691,
  [SMALL_STATE(2841)] = 117716,
  [SMALL_STATE(2842)] = 117741,
  [SMALL_STATE(2843)] = 117766,
  [SMALL_STATE(2844)] = 117787,
  [SMALL_STATE(2845)] = 117808,
  [SMALL_STATE(2846)] = 117827,
  [SMALL_STATE(2847)] = 117842,
  [SMALL_STATE(2848)] = 117855,
  [SMALL_STATE(2849)] = 117880,
  [SMALL_STATE(2850)] = 117905,
  [SMALL_STATE(2851)] = 117930,
  [SMALL_STATE(2852)] = 117951,
  [SMALL_STATE(2853)] = 117976,
  [SMALL_STATE(2854)] = 117989,
  [SMALL_STATE(2855)] = 118002,
  [SMALL_STATE(2856)] = 118015,
  [SMALL_STATE(2857)] = 118028,
  [SMALL_STATE(2858)] = 118051,
  [SMALL_STATE(2859)] = 118076,
  [SMALL_STATE(2860)] = 118089,
  [SMALL_STATE(2861)] = 118114,
  [SMALL_STATE(2862)] = 118139,
  [SMALL_STATE(2863)] = 118152,
  [SMALL_STATE(2864)] = 118167,
  [SMALL_STATE(2865)] = 118184,
  [SMALL_STATE(2866)] = 118209,
  [SMALL_STATE(2867)] = 118226,
  [SMALL_STATE(2868)] = 118247,
  [SMALL_STATE(2869)] = 118268,
  [SMALL_STATE(2870)] = 118293,
  [SMALL_STATE(2871)] = 118314,
  [SMALL_STATE(2872)] = 118331,
  [SMALL_STATE(2873)] = 118348,
  [SMALL_STATE(2874)] = 118365,
  [SMALL_STATE(2875)] = 118390,
  [SMALL_STATE(2876)] = 118415,
  [SMALL_STATE(2877)] = 118440,
  [SMALL_STATE(2878)] = 118457,
  [SMALL_STATE(2879)] = 118474,
  [SMALL_STATE(2880)] = 118499,
  [SMALL_STATE(2881)] = 118524,
  [SMALL_STATE(2882)] = 118537,
  [SMALL_STATE(2883)] = 118562,
  [SMALL_STATE(2884)] = 118579,
  [SMALL_STATE(2885)] = 118596,
  [SMALL_STATE(2886)] = 118611,
  [SMALL_STATE(2887)] = 118636,
  [SMALL_STATE(2888)] = 118661,
  [SMALL_STATE(2889)] = 118686,
  [SMALL_STATE(2890)] = 118703,
  [SMALL_STATE(2891)] = 118720,
  [SMALL_STATE(2892)] = 118737,
  [SMALL_STATE(2893)] = 118754,
  [SMALL_STATE(2894)] = 118771,
  [SMALL_STATE(2895)] = 118796,
  [SMALL_STATE(2896)] = 118821,
  [SMALL_STATE(2897)] = 118838,
  [SMALL_STATE(2898)] = 118855,
  [SMALL_STATE(2899)] = 118880,
  [SMALL_STATE(2900)] = 118897,
  [SMALL_STATE(2901)] = 118918,
  [SMALL_STATE(2902)] = 118935,
  [SMALL_STATE(2903)] = 118960,
  [SMALL_STATE(2904)] = 118985,
  [SMALL_STATE(2905)] = 119002,
  [SMALL_STATE(2906)] = 119019,
  [SMALL_STATE(2907)] = 119036,
  [SMALL_STATE(2908)] = 119053,
  [SMALL_STATE(2909)] = 119078,
  [SMALL_STATE(2910)] = 119091,
  [SMALL_STATE(2911)] = 119116,
  [SMALL_STATE(2912)] = 119141,
  [SMALL_STATE(2913)] = 119154,
  [SMALL_STATE(2914)] = 119179,
  [SMALL_STATE(2915)] = 119196,
  [SMALL_STATE(2916)] = 119221,
  [SMALL_STATE(2917)] = 119242,
  [SMALL_STATE(2918)] = 119255,
  [SMALL_STATE(2919)] = 119270,
  [SMALL_STATE(2920)] = 119285,
  [SMALL_STATE(2921)] = 119298,
  [SMALL_STATE(2922)] = 119323,
  [SMALL_STATE(2923)] = 119341,
  [SMALL_STATE(2924)] = 119357,
  [SMALL_STATE(2925)] = 119379,
  [SMALL_STATE(2926)] = 119401,
  [SMALL_STATE(2927)] = 119419,
  [SMALL_STATE(2928)] = 119435,
  [SMALL_STATE(2929)] = 119457,
  [SMALL_STATE(2930)] = 119479,
  [SMALL_STATE(2931)] = 119501,
  [SMALL_STATE(2932)] = 119519,
  [SMALL_STATE(2933)] = 119535,
  [SMALL_STATE(2934)] = 119557,
  [SMALL_STATE(2935)] = 119579,
  [SMALL_STATE(2936)] = 119593,
  [SMALL_STATE(2937)] = 119615,
  [SMALL_STATE(2938)] = 119637,
  [SMALL_STATE(2939)] = 119659,
  [SMALL_STATE(2940)] = 119675,
  [SMALL_STATE(2941)] = 119693,
  [SMALL_STATE(2942)] = 119715,
  [SMALL_STATE(2943)] = 119733,
  [SMALL_STATE(2944)] = 119751,
  [SMALL_STATE(2945)] = 119769,
  [SMALL_STATE(2946)] = 119787,
  [SMALL_STATE(2947)] = 119809,
  [SMALL_STATE(2948)] = 119825,
  [SMALL_STATE(2949)] = 119847,
  [SMALL_STATE(2950)] = 119863,
  [SMALL_STATE(2951)] = 119885,
  [SMALL_STATE(2952)] = 119907,
  [SMALL_STATE(2953)] = 119927,
  [SMALL_STATE(2954)] = 119943,
  [SMALL_STATE(2955)] = 119965,
  [SMALL_STATE(2956)] = 119983,
  [SMALL_STATE(2957)] = 120001,
  [SMALL_STATE(2958)] = 120015,
  [SMALL_STATE(2959)] = 120033,
  [SMALL_STATE(2960)] = 120051,
  [SMALL_STATE(2961)] = 120073,
  [SMALL_STATE(2962)] = 120095,
  [SMALL_STATE(2963)] = 120111,
  [SMALL_STATE(2964)] = 120127,
  [SMALL_STATE(2965)] = 120143,
  [SMALL_STATE(2966)] = 120165,
  [SMALL_STATE(2967)] = 120187,
  [SMALL_STATE(2968)] = 120209,
  [SMALL_STATE(2969)] = 120231,
  [SMALL_STATE(2970)] = 120247,
  [SMALL_STATE(2971)] = 120263,
  [SMALL_STATE(2972)] = 120275,
  [SMALL_STATE(2973)] = 120291,
  [SMALL_STATE(2974)] = 120313,
  [SMALL_STATE(2975)] = 120335,
  [SMALL_STATE(2976)] = 120351,
  [SMALL_STATE(2977)] = 120373,
  [SMALL_STATE(2978)] = 120393,
  [SMALL_STATE(2979)] = 120415,
  [SMALL_STATE(2980)] = 120437,
  [SMALL_STATE(2981)] = 120459,
  [SMALL_STATE(2982)] = 120481,
  [SMALL_STATE(2983)] = 120495,
  [SMALL_STATE(2984)] = 120513,
  [SMALL_STATE(2985)] = 120531,
  [SMALL_STATE(2986)] = 120549,
  [SMALL_STATE(2987)] = 120565,
  [SMALL_STATE(2988)] = 120587,
  [SMALL_STATE(2989)] = 120609,
  [SMALL_STATE(2990)] = 120631,
  [SMALL_STATE(2991)] = 120653,
  [SMALL_STATE(2992)] = 120675,
  [SMALL_STATE(2993)] = 120693,
  [SMALL_STATE(2994)] = 120705,
  [SMALL_STATE(2995)] = 120721,
  [SMALL_STATE(2996)] = 120743,
  [SMALL_STATE(2997)] = 120755,
  [SMALL_STATE(2998)] = 120771,
  [SMALL_STATE(2999)] = 120787,
  [SMALL_STATE(3000)] = 120809,
  [SMALL_STATE(3001)] = 120825,
  [SMALL_STATE(3002)] = 120847,
  [SMALL_STATE(3003)] = 120869,
  [SMALL_STATE(3004)] = 120891,
  [SMALL_STATE(3005)] = 120913,
  [SMALL_STATE(3006)] = 120929,
  [SMALL_STATE(3007)] = 120949,
  [SMALL_STATE(3008)] = 120965,
  [SMALL_STATE(3009)] = 120977,
  [SMALL_STATE(3010)] = 120995,
  [SMALL_STATE(3011)] = 121007,
  [SMALL_STATE(3012)] = 121019,
  [SMALL_STATE(3013)] = 121041,
  [SMALL_STATE(3014)] = 121053,
  [SMALL_STATE(3015)] = 121069,
  [SMALL_STATE(3016)] = 121091,
  [SMALL_STATE(3017)] = 121113,
  [SMALL_STATE(3018)] = 121135,
  [SMALL_STATE(3019)] = 121153,
  [SMALL_STATE(3020)] = 121165,
  [SMALL_STATE(3021)] = 121187,
  [SMALL_STATE(3022)] = 121203,
  [SMALL_STATE(3023)] = 121225,
  [SMALL_STATE(3024)] = 121237,
  [SMALL_STATE(3025)] = 121253,
  [SMALL_STATE(3026)] = 121275,
  [SMALL_STATE(3027)] = 121291,
  [SMALL_STATE(3028)] = 121309,
  [SMALL_STATE(3029)] = 121331,
  [SMALL_STATE(3030)] = 121349,
  [SMALL_STATE(3031)] = 121365,
  [SMALL_STATE(3032)] = 121381,
  [SMALL_STATE(3033)] = 121403,
  [SMALL_STATE(3034)] = 121421,
  [SMALL_STATE(3035)] = 121437,
  [SMALL_STATE(3036)] = 121459,
  [SMALL_STATE(3037)] = 121481,
  [SMALL_STATE(3038)] = 121497,
  [SMALL_STATE(3039)] = 121513,
  [SMALL_STATE(3040)] = 121535,
  [SMALL_STATE(3041)] = 121557,
  [SMALL_STATE(3042)] = 121579,
  [SMALL_STATE(3043)] = 121595,
  [SMALL_STATE(3044)] = 121613,
  [SMALL_STATE(3045)] = 121625,
  [SMALL_STATE(3046)] = 121637,
  [SMALL_STATE(3047)] = 121653,
  [SMALL_STATE(3048)] = 121669,
  [SMALL_STATE(3049)] = 121685,
  [SMALL_STATE(3050)] = 121701,
  [SMALL_STATE(3051)] = 121717,
  [SMALL_STATE(3052)] = 121739,
  [SMALL_STATE(3053)] = 121751,
  [SMALL_STATE(3054)] = 121773,
  [SMALL_STATE(3055)] = 121795,
  [SMALL_STATE(3056)] = 121817,
  [SMALL_STATE(3057)] = 121839,
  [SMALL_STATE(3058)] = 121861,
  [SMALL_STATE(3059)] = 121883,
  [SMALL_STATE(3060)] = 121899,
  [SMALL_STATE(3061)] = 121917,
  [SMALL_STATE(3062)] = 121931,
  [SMALL_STATE(3063)] = 121953,
  [SMALL_STATE(3064)] = 121969,
  [SMALL_STATE(3065)] = 121985,
  [SMALL_STATE(3066)] = 122007,
  [SMALL_STATE(3067)] = 122023,
  [SMALL_STATE(3068)] = 122035,
  [SMALL_STATE(3069)] = 122057,
  [SMALL_STATE(3070)] = 122077,
  [SMALL_STATE(3071)] = 122093,
  [SMALL_STATE(3072)] = 122109,
  [SMALL_STATE(3073)] = 122127,
  [SMALL_STATE(3074)] = 122149,
  [SMALL_STATE(3075)] = 122171,
  [SMALL_STATE(3076)] = 122187,
  [SMALL_STATE(3077)] = 122209,
  [SMALL_STATE(3078)] = 122231,
  [SMALL_STATE(3079)] = 122247,
  [SMALL_STATE(3080)] = 122267,
  [SMALL_STATE(3081)] = 122283,
  [SMALL_STATE(3082)] = 122305,
  [SMALL_STATE(3083)] = 122319,
  [SMALL_STATE(3084)] = 122337,
  [SMALL_STATE(3085)] = 122359,
  [SMALL_STATE(3086)] = 122375,
  [SMALL_STATE(3087)] = 122391,
  [SMALL_STATE(3088)] = 122409,
  [SMALL_STATE(3089)] = 122425,
  [SMALL_STATE(3090)] = 122447,
  [SMALL_STATE(3091)] = 122459,
  [SMALL_STATE(3092)] = 122475,
  [SMALL_STATE(3093)] = 122491,
  [SMALL_STATE(3094)] = 122513,
  [SMALL_STATE(3095)] = 122529,
  [SMALL_STATE(3096)] = 122551,
  [SMALL_STATE(3097)] = 122573,
  [SMALL_STATE(3098)] = 122585,
  [SMALL_STATE(3099)] = 122597,
  [SMALL_STATE(3100)] = 122608,
  [SMALL_STATE(3101)] = 122627,
  [SMALL_STATE(3102)] = 122642,
  [SMALL_STATE(3103)] = 122653,
  [SMALL_STATE(3104)] = 122670,
  [SMALL_STATE(3105)] = 122689,
  [SMALL_STATE(3106)] = 122708,
  [SMALL_STATE(3107)] = 122727,
  [SMALL_STATE(3108)] = 122742,
  [SMALL_STATE(3109)] = 122757,
  [SMALL_STATE(3110)] = 122776,
  [SMALL_STATE(3111)] = 122789,
  [SMALL_STATE(3112)] = 122804,
  [SMALL_STATE(3113)] = 122821,
  [SMALL_STATE(3114)] = 122840,
  [SMALL_STATE(3115)] = 122851,
  [SMALL_STATE(3116)] = 122868,
  [SMALL_STATE(3117)] = 122887,
  [SMALL_STATE(3118)] = 122906,
  [SMALL_STATE(3119)] = 122923,
  [SMALL_STATE(3120)] = 122942,
  [SMALL_STATE(3121)] = 122961,
  [SMALL_STATE(3122)] = 122980,
  [SMALL_STATE(3123)] = 122997,
  [SMALL_STATE(3124)] = 123012,
  [SMALL_STATE(3125)] = 123027,
  [SMALL_STATE(3126)] = 123044,
  [SMALL_STATE(3127)] = 123063,
  [SMALL_STATE(3128)] = 123074,
  [SMALL_STATE(3129)] = 123093,
  [SMALL_STATE(3130)] = 123104,
  [SMALL_STATE(3131)] = 123115,
  [SMALL_STATE(3132)] = 123130,
  [SMALL_STATE(3133)] = 123149,
  [SMALL_STATE(3134)] = 123160,
  [SMALL_STATE(3135)] = 123173,
  [SMALL_STATE(3136)] = 123186,
  [SMALL_STATE(3137)] = 123205,
  [SMALL_STATE(3138)] = 123216,
  [SMALL_STATE(3139)] = 123227,
  [SMALL_STATE(3140)] = 123246,
  [SMALL_STATE(3141)] = 123265,
  [SMALL_STATE(3142)] = 123280,
  [SMALL_STATE(3143)] = 123291,
  [SMALL_STATE(3144)] = 123306,
  [SMALL_STATE(3145)] = 123321,
  [SMALL_STATE(3146)] = 123340,
  [SMALL_STATE(3147)] = 123351,
  [SMALL_STATE(3148)] = 123362,
  [SMALL_STATE(3149)] = 123381,
  [SMALL_STATE(3150)] = 123398,
  [SMALL_STATE(3151)] = 123411,
  [SMALL_STATE(3152)] = 123424,
  [SMALL_STATE(3153)] = 123435,
  [SMALL_STATE(3154)] = 123450,
  [SMALL_STATE(3155)] = 123467,
  [SMALL_STATE(3156)] = 123482,
  [SMALL_STATE(3157)] = 123501,
  [SMALL_STATE(3158)] = 123512,
  [SMALL_STATE(3159)] = 123529,
  [SMALL_STATE(3160)] = 123548,
  [SMALL_STATE(3161)] = 123559,
  [SMALL_STATE(3162)] = 123578,
  [SMALL_STATE(3163)] = 123589,
  [SMALL_STATE(3164)] = 123608,
  [SMALL_STATE(3165)] = 123623,
  [SMALL_STATE(3166)] = 123638,
  [SMALL_STATE(3167)] = 123657,
  [SMALL_STATE(3168)] = 123676,
  [SMALL_STATE(3169)] = 123687,
  [SMALL_STATE(3170)] = 123698,
  [SMALL_STATE(3171)] = 123709,
  [SMALL_STATE(3172)] = 123720,
  [SMALL_STATE(3173)] = 123731,
  [SMALL_STATE(3174)] = 123748,
  [SMALL_STATE(3175)] = 123759,
  [SMALL_STATE(3176)] = 123770,
  [SMALL_STATE(3177)] = 123787,
  [SMALL_STATE(3178)] = 123800,
  [SMALL_STATE(3179)] = 123819,
  [SMALL_STATE(3180)] = 123838,
  [SMALL_STATE(3181)] = 123857,
  [SMALL_STATE(3182)] = 123874,
  [SMALL_STATE(3183)] = 123891,
  [SMALL_STATE(3184)] = 123910,
  [SMALL_STATE(3185)] = 123929,
  [SMALL_STATE(3186)] = 123948,
  [SMALL_STATE(3187)] = 123967,
  [SMALL_STATE(3188)] = 123986,
  [SMALL_STATE(3189)] = 124005,
  [SMALL_STATE(3190)] = 124020,
  [SMALL_STATE(3191)] = 124035,
  [SMALL_STATE(3192)] = 124054,
  [SMALL_STATE(3193)] = 124073,
  [SMALL_STATE(3194)] = 124092,
  [SMALL_STATE(3195)] = 124103,
  [SMALL_STATE(3196)] = 124122,
  [SMALL_STATE(3197)] = 124141,
  [SMALL_STATE(3198)] = 124158,
  [SMALL_STATE(3199)] = 124177,
  [SMALL_STATE(3200)] = 124196,
  [SMALL_STATE(3201)] = 124207,
  [SMALL_STATE(3202)] = 124226,
  [SMALL_STATE(3203)] = 124237,
  [SMALL_STATE(3204)] = 124254,
  [SMALL_STATE(3205)] = 124273,
  [SMALL_STATE(3206)] = 124284,
  [SMALL_STATE(3207)] = 124295,
  [SMALL_STATE(3208)] = 124306,
  [SMALL_STATE(3209)] = 124317,
  [SMALL_STATE(3210)] = 124328,
  [SMALL_STATE(3211)] = 124347,
  [SMALL_STATE(3212)] = 124366,
  [SMALL_STATE(3213)] = 124381,
  [SMALL_STATE(3214)] = 124400,
  [SMALL_STATE(3215)] = 124417,
  [SMALL_STATE(3216)] = 124436,
  [SMALL_STATE(3217)] = 124455,
  [SMALL_STATE(3218)] = 124474,
  [SMALL_STATE(3219)] = 124485,
  [SMALL_STATE(3220)] = 124504,
  [SMALL_STATE(3221)] = 124523,
  [SMALL_STATE(3222)] = 124534,
  [SMALL_STATE(3223)] = 124545,
  [SMALL_STATE(3224)] = 124564,
  [SMALL_STATE(3225)] = 124579,
  [SMALL_STATE(3226)] = 124596,
  [SMALL_STATE(3227)] = 124615,
  [SMALL_STATE(3228)] = 124634,
  [SMALL_STATE(3229)] = 124649,
  [SMALL_STATE(3230)] = 124660,
  [SMALL_STATE(3231)] = 124671,
  [SMALL_STATE(3232)] = 124690,
  [SMALL_STATE(3233)] = 124701,
  [SMALL_STATE(3234)] = 124712,
  [SMALL_STATE(3235)] = 124731,
  [SMALL_STATE(3236)] = 124750,
  [SMALL_STATE(3237)] = 124769,
  [SMALL_STATE(3238)] = 124780,
  [SMALL_STATE(3239)] = 124799,
  [SMALL_STATE(3240)] = 124810,
  [SMALL_STATE(3241)] = 124821,
  [SMALL_STATE(3242)] = 124840,
  [SMALL_STATE(3243)] = 124859,
  [SMALL_STATE(3244)] = 124870,
  [SMALL_STATE(3245)] = 124881,
  [SMALL_STATE(3246)] = 124896,
  [SMALL_STATE(3247)] = 124911,
  [SMALL_STATE(3248)] = 124922,
  [SMALL_STATE(3249)] = 124941,
  [SMALL_STATE(3250)] = 124952,
  [SMALL_STATE(3251)] = 124971,
  [SMALL_STATE(3252)] = 124982,
  [SMALL_STATE(3253)] = 124993,
  [SMALL_STATE(3254)] = 125004,
  [SMALL_STATE(3255)] = 125015,
  [SMALL_STATE(3256)] = 125026,
  [SMALL_STATE(3257)] = 125037,
  [SMALL_STATE(3258)] = 125052,
  [SMALL_STATE(3259)] = 125071,
  [SMALL_STATE(3260)] = 125082,
  [SMALL_STATE(3261)] = 125101,
  [SMALL_STATE(3262)] = 125112,
  [SMALL_STATE(3263)] = 125123,
  [SMALL_STATE(3264)] = 125134,
  [SMALL_STATE(3265)] = 125145,
  [SMALL_STATE(3266)] = 125164,
  [SMALL_STATE(3267)] = 125175,
  [SMALL_STATE(3268)] = 125186,
  [SMALL_STATE(3269)] = 125197,
  [SMALL_STATE(3270)] = 125208,
  [SMALL_STATE(3271)] = 125219,
  [SMALL_STATE(3272)] = 125230,
  [SMALL_STATE(3273)] = 125241,
  [SMALL_STATE(3274)] = 125252,
  [SMALL_STATE(3275)] = 125263,
  [SMALL_STATE(3276)] = 125274,
  [SMALL_STATE(3277)] = 125285,
  [SMALL_STATE(3278)] = 125296,
  [SMALL_STATE(3279)] = 125307,
  [SMALL_STATE(3280)] = 125318,
  [SMALL_STATE(3281)] = 125329,
  [SMALL_STATE(3282)] = 125340,
  [SMALL_STATE(3283)] = 125351,
  [SMALL_STATE(3284)] = 125364,
  [SMALL_STATE(3285)] = 125375,
  [SMALL_STATE(3286)] = 125386,
  [SMALL_STATE(3287)] = 125397,
  [SMALL_STATE(3288)] = 125408,
  [SMALL_STATE(3289)] = 125425,
  [SMALL_STATE(3290)] = 125436,
  [SMALL_STATE(3291)] = 125447,
  [SMALL_STATE(3292)] = 125466,
  [SMALL_STATE(3293)] = 125477,
  [SMALL_STATE(3294)] = 125488,
  [SMALL_STATE(3295)] = 125499,
  [SMALL_STATE(3296)] = 125510,
  [SMALL_STATE(3297)] = 125521,
  [SMALL_STATE(3298)] = 125532,
  [SMALL_STATE(3299)] = 125543,
  [SMALL_STATE(3300)] = 125554,
  [SMALL_STATE(3301)] = 125565,
  [SMALL_STATE(3302)] = 125576,
  [SMALL_STATE(3303)] = 125587,
  [SMALL_STATE(3304)] = 125606,
  [SMALL_STATE(3305)] = 125617,
  [SMALL_STATE(3306)] = 125628,
  [SMALL_STATE(3307)] = 125639,
  [SMALL_STATE(3308)] = 125650,
  [SMALL_STATE(3309)] = 125661,
  [SMALL_STATE(3310)] = 125672,
  [SMALL_STATE(3311)] = 125683,
  [SMALL_STATE(3312)] = 125694,
  [SMALL_STATE(3313)] = 125705,
  [SMALL_STATE(3314)] = 125716,
  [SMALL_STATE(3315)] = 125731,
  [SMALL_STATE(3316)] = 125750,
  [SMALL_STATE(3317)] = 125767,
  [SMALL_STATE(3318)] = 125778,
  [SMALL_STATE(3319)] = 125789,
  [SMALL_STATE(3320)] = 125804,
  [SMALL_STATE(3321)] = 125823,
  [SMALL_STATE(3322)] = 125842,
  [SMALL_STATE(3323)] = 125861,
  [SMALL_STATE(3324)] = 125880,
  [SMALL_STATE(3325)] = 125891,
  [SMALL_STATE(3326)] = 125902,
  [SMALL_STATE(3327)] = 125913,
  [SMALL_STATE(3328)] = 125932,
  [SMALL_STATE(3329)] = 125943,
  [SMALL_STATE(3330)] = 125954,
  [SMALL_STATE(3331)] = 125965,
  [SMALL_STATE(3332)] = 125976,
  [SMALL_STATE(3333)] = 125987,
  [SMALL_STATE(3334)] = 126006,
  [SMALL_STATE(3335)] = 126025,
  [SMALL_STATE(3336)] = 126038,
  [SMALL_STATE(3337)] = 126051,
  [SMALL_STATE(3338)] = 126068,
  [SMALL_STATE(3339)] = 126079,
  [SMALL_STATE(3340)] = 126090,
  [SMALL_STATE(3341)] = 126101,
  [SMALL_STATE(3342)] = 126112,
  [SMALL_STATE(3343)] = 126123,
  [SMALL_STATE(3344)] = 126134,
  [SMALL_STATE(3345)] = 126151,
  [SMALL_STATE(3346)] = 126164,
  [SMALL_STATE(3347)] = 126181,
  [SMALL_STATE(3348)] = 126192,
  [SMALL_STATE(3349)] = 126203,
  [SMALL_STATE(3350)] = 126216,
  [SMALL_STATE(3351)] = 126227,
  [SMALL_STATE(3352)] = 126238,
  [SMALL_STATE(3353)] = 126249,
  [SMALL_STATE(3354)] = 126260,
  [SMALL_STATE(3355)] = 126271,
  [SMALL_STATE(3356)] = 126282,
  [SMALL_STATE(3357)] = 126293,
  [SMALL_STATE(3358)] = 126304,
  [SMALL_STATE(3359)] = 126323,
  [SMALL_STATE(3360)] = 126334,
  [SMALL_STATE(3361)] = 126345,
  [SMALL_STATE(3362)] = 126356,
  [SMALL_STATE(3363)] = 126369,
  [SMALL_STATE(3364)] = 126380,
  [SMALL_STATE(3365)] = 126391,
  [SMALL_STATE(3366)] = 126404,
  [SMALL_STATE(3367)] = 126415,
  [SMALL_STATE(3368)] = 126426,
  [SMALL_STATE(3369)] = 126437,
  [SMALL_STATE(3370)] = 126448,
  [SMALL_STATE(3371)] = 126461,
  [SMALL_STATE(3372)] = 126472,
  [SMALL_STATE(3373)] = 126483,
  [SMALL_STATE(3374)] = 126502,
  [SMALL_STATE(3375)] = 126513,
  [SMALL_STATE(3376)] = 126524,
  [SMALL_STATE(3377)] = 126535,
  [SMALL_STATE(3378)] = 126548,
  [SMALL_STATE(3379)] = 126561,
  [SMALL_STATE(3380)] = 126574,
  [SMALL_STATE(3381)] = 126587,
  [SMALL_STATE(3382)] = 126600,
  [SMALL_STATE(3383)] = 126613,
  [SMALL_STATE(3384)] = 126626,
  [SMALL_STATE(3385)] = 126639,
  [SMALL_STATE(3386)] = 126652,
  [SMALL_STATE(3387)] = 126669,
  [SMALL_STATE(3388)] = 126682,
  [SMALL_STATE(3389)] = 126697,
  [SMALL_STATE(3390)] = 126712,
  [SMALL_STATE(3391)] = 126731,
  [SMALL_STATE(3392)] = 126748,
  [SMALL_STATE(3393)] = 126759,
  [SMALL_STATE(3394)] = 126775,
  [SMALL_STATE(3395)] = 126791,
  [SMALL_STATE(3396)] = 126805,
  [SMALL_STATE(3397)] = 126821,
  [SMALL_STATE(3398)] = 126837,
  [SMALL_STATE(3399)] = 126853,
  [SMALL_STATE(3400)] = 126867,
  [SMALL_STATE(3401)] = 126881,
  [SMALL_STATE(3402)] = 126897,
  [SMALL_STATE(3403)] = 126907,
  [SMALL_STATE(3404)] = 126923,
  [SMALL_STATE(3405)] = 126939,
  [SMALL_STATE(3406)] = 126951,
  [SMALL_STATE(3407)] = 126965,
  [SMALL_STATE(3408)] = 126981,
  [SMALL_STATE(3409)] = 126997,
  [SMALL_STATE(3410)] = 127013,
  [SMALL_STATE(3411)] = 127027,
  [SMALL_STATE(3412)] = 127041,
  [SMALL_STATE(3413)] = 127053,
  [SMALL_STATE(3414)] = 127069,
  [SMALL_STATE(3415)] = 127083,
  [SMALL_STATE(3416)] = 127099,
  [SMALL_STATE(3417)] = 127115,
  [SMALL_STATE(3418)] = 127131,
  [SMALL_STATE(3419)] = 127147,
  [SMALL_STATE(3420)] = 127163,
  [SMALL_STATE(3421)] = 127177,
  [SMALL_STATE(3422)] = 127191,
  [SMALL_STATE(3423)] = 127205,
  [SMALL_STATE(3424)] = 127219,
  [SMALL_STATE(3425)] = 127233,
  [SMALL_STATE(3426)] = 127247,
  [SMALL_STATE(3427)] = 127261,
  [SMALL_STATE(3428)] = 127275,
  [SMALL_STATE(3429)] = 127291,
  [SMALL_STATE(3430)] = 127307,
  [SMALL_STATE(3431)] = 127321,
  [SMALL_STATE(3432)] = 127337,
  [SMALL_STATE(3433)] = 127351,
  [SMALL_STATE(3434)] = 127367,
  [SMALL_STATE(3435)] = 127383,
  [SMALL_STATE(3436)] = 127399,
  [SMALL_STATE(3437)] = 127415,
  [SMALL_STATE(3438)] = 127431,
  [SMALL_STATE(3439)] = 127447,
  [SMALL_STATE(3440)] = 127463,
  [SMALL_STATE(3441)] = 127477,
  [SMALL_STATE(3442)] = 127491,
  [SMALL_STATE(3443)] = 127505,
  [SMALL_STATE(3444)] = 127521,
  [SMALL_STATE(3445)] = 127537,
  [SMALL_STATE(3446)] = 127553,
  [SMALL_STATE(3447)] = 127569,
  [SMALL_STATE(3448)] = 127585,
  [SMALL_STATE(3449)] = 127601,
  [SMALL_STATE(3450)] = 127617,
  [SMALL_STATE(3451)] = 127631,
  [SMALL_STATE(3452)] = 127647,
  [SMALL_STATE(3453)] = 127663,
  [SMALL_STATE(3454)] = 127679,
  [SMALL_STATE(3455)] = 127695,
  [SMALL_STATE(3456)] = 127711,
  [SMALL_STATE(3457)] = 127725,
  [SMALL_STATE(3458)] = 127739,
  [SMALL_STATE(3459)] = 127753,
  [SMALL_STATE(3460)] = 127767,
  [SMALL_STATE(3461)] = 127781,
  [SMALL_STATE(3462)] = 127797,
  [SMALL_STATE(3463)] = 127811,
  [SMALL_STATE(3464)] = 127825,
  [SMALL_STATE(3465)] = 127837,
  [SMALL_STATE(3466)] = 127851,
  [SMALL_STATE(3467)] = 127863,
  [SMALL_STATE(3468)] = 127877,
  [SMALL_STATE(3469)] = 127893,
  [SMALL_STATE(3470)] = 127907,
  [SMALL_STATE(3471)] = 127923,
  [SMALL_STATE(3472)] = 127937,
  [SMALL_STATE(3473)] = 127951,
  [SMALL_STATE(3474)] = 127967,
  [SMALL_STATE(3475)] = 127981,
  [SMALL_STATE(3476)] = 127995,
  [SMALL_STATE(3477)] = 128009,
  [SMALL_STATE(3478)] = 128023,
  [SMALL_STATE(3479)] = 128037,
  [SMALL_STATE(3480)] = 128051,
  [SMALL_STATE(3481)] = 128065,
  [SMALL_STATE(3482)] = 128079,
  [SMALL_STATE(3483)] = 128093,
  [SMALL_STATE(3484)] = 128107,
  [SMALL_STATE(3485)] = 128121,
  [SMALL_STATE(3486)] = 128135,
  [SMALL_STATE(3487)] = 128149,
  [SMALL_STATE(3488)] = 128165,
  [SMALL_STATE(3489)] = 128179,
  [SMALL_STATE(3490)] = 128195,
  [SMALL_STATE(3491)] = 128209,
  [SMALL_STATE(3492)] = 128223,
  [SMALL_STATE(3493)] = 128237,
  [SMALL_STATE(3494)] = 128251,
  [SMALL_STATE(3495)] = 128265,
  [SMALL_STATE(3496)] = 128279,
  [SMALL_STATE(3497)] = 128293,
  [SMALL_STATE(3498)] = 128307,
  [SMALL_STATE(3499)] = 128317,
  [SMALL_STATE(3500)] = 128331,
  [SMALL_STATE(3501)] = 128345,
  [SMALL_STATE(3502)] = 128359,
  [SMALL_STATE(3503)] = 128369,
  [SMALL_STATE(3504)] = 128383,
  [SMALL_STATE(3505)] = 128399,
  [SMALL_STATE(3506)] = 128415,
  [SMALL_STATE(3507)] = 128431,
  [SMALL_STATE(3508)] = 128445,
  [SMALL_STATE(3509)] = 128459,
  [SMALL_STATE(3510)] = 128475,
  [SMALL_STATE(3511)] = 128491,
  [SMALL_STATE(3512)] = 128507,
  [SMALL_STATE(3513)] = 128521,
  [SMALL_STATE(3514)] = 128535,
  [SMALL_STATE(3515)] = 128551,
  [SMALL_STATE(3516)] = 128567,
  [SMALL_STATE(3517)] = 128576,
  [SMALL_STATE(3518)] = 128585,
  [SMALL_STATE(3519)] = 128598,
  [SMALL_STATE(3520)] = 128607,
  [SMALL_STATE(3521)] = 128620,
  [SMALL_STATE(3522)] = 128629,
  [SMALL_STATE(3523)] = 128642,
  [SMALL_STATE(3524)] = 128655,
  [SMALL_STATE(3525)] = 128668,
  [SMALL_STATE(3526)] = 128677,
  [SMALL_STATE(3527)] = 128690,
  [SMALL_STATE(3528)] = 128701,
  [SMALL_STATE(3529)] = 128710,
  [SMALL_STATE(3530)] = 128723,
  [SMALL_STATE(3531)] = 128736,
  [SMALL_STATE(3532)] = 128749,
  [SMALL_STATE(3533)] = 128760,
  [SMALL_STATE(3534)] = 128769,
  [SMALL_STATE(3535)] = 128780,
  [SMALL_STATE(3536)] = 128789,
  [SMALL_STATE(3537)] = 128802,
  [SMALL_STATE(3538)] = 128815,
  [SMALL_STATE(3539)] = 128828,
  [SMALL_STATE(3540)] = 128841,
  [SMALL_STATE(3541)] = 128854,
  [SMALL_STATE(3542)] = 128867,
  [SMALL_STATE(3543)] = 128880,
  [SMALL_STATE(3544)] = 128893,
  [SMALL_STATE(3545)] = 128906,
  [SMALL_STATE(3546)] = 128919,
  [SMALL_STATE(3547)] = 128932,
  [SMALL_STATE(3548)] = 128945,
  [SMALL_STATE(3549)] = 128958,
  [SMALL_STATE(3550)] = 128971,
  [SMALL_STATE(3551)] = 128984,
  [SMALL_STATE(3552)] = 128993,
  [SMALL_STATE(3553)] = 129004,
  [SMALL_STATE(3554)] = 129017,
  [SMALL_STATE(3555)] = 129030,
  [SMALL_STATE(3556)] = 129043,
  [SMALL_STATE(3557)] = 129052,
  [SMALL_STATE(3558)] = 129065,
  [SMALL_STATE(3559)] = 129076,
  [SMALL_STATE(3560)] = 129089,
  [SMALL_STATE(3561)] = 129098,
  [SMALL_STATE(3562)] = 129111,
  [SMALL_STATE(3563)] = 129124,
  [SMALL_STATE(3564)] = 129137,
  [SMALL_STATE(3565)] = 129150,
  [SMALL_STATE(3566)] = 129159,
  [SMALL_STATE(3567)] = 129172,
  [SMALL_STATE(3568)] = 129185,
  [SMALL_STATE(3569)] = 129198,
  [SMALL_STATE(3570)] = 129211,
  [SMALL_STATE(3571)] = 129224,
  [SMALL_STATE(3572)] = 129233,
  [SMALL_STATE(3573)] = 129246,
  [SMALL_STATE(3574)] = 129259,
  [SMALL_STATE(3575)] = 129268,
  [SMALL_STATE(3576)] = 129277,
  [SMALL_STATE(3577)] = 129288,
  [SMALL_STATE(3578)] = 129301,
  [SMALL_STATE(3579)] = 129314,
  [SMALL_STATE(3580)] = 129325,
  [SMALL_STATE(3581)] = 129334,
  [SMALL_STATE(3582)] = 129343,
  [SMALL_STATE(3583)] = 129354,
  [SMALL_STATE(3584)] = 129363,
  [SMALL_STATE(3585)] = 129376,
  [SMALL_STATE(3586)] = 129385,
  [SMALL_STATE(3587)] = 129398,
  [SMALL_STATE(3588)] = 129411,
  [SMALL_STATE(3589)] = 129424,
  [SMALL_STATE(3590)] = 129437,
  [SMALL_STATE(3591)] = 129450,
  [SMALL_STATE(3592)] = 129459,
  [SMALL_STATE(3593)] = 129470,
  [SMALL_STATE(3594)] = 129479,
  [SMALL_STATE(3595)] = 129492,
  [SMALL_STATE(3596)] = 129505,
  [SMALL_STATE(3597)] = 129518,
  [SMALL_STATE(3598)] = 129531,
  [SMALL_STATE(3599)] = 129542,
  [SMALL_STATE(3600)] = 129551,
  [SMALL_STATE(3601)] = 129564,
  [SMALL_STATE(3602)] = 129577,
  [SMALL_STATE(3603)] = 129590,
  [SMALL_STATE(3604)] = 129603,
  [SMALL_STATE(3605)] = 129616,
  [SMALL_STATE(3606)] = 129629,
  [SMALL_STATE(3607)] = 129642,
  [SMALL_STATE(3608)] = 129655,
  [SMALL_STATE(3609)] = 129668,
  [SMALL_STATE(3610)] = 129681,
  [SMALL_STATE(3611)] = 129694,
  [SMALL_STATE(3612)] = 129707,
  [SMALL_STATE(3613)] = 129720,
  [SMALL_STATE(3614)] = 129733,
  [SMALL_STATE(3615)] = 129746,
  [SMALL_STATE(3616)] = 129759,
  [SMALL_STATE(3617)] = 129772,
  [SMALL_STATE(3618)] = 129785,
  [SMALL_STATE(3619)] = 129794,
  [SMALL_STATE(3620)] = 129807,
  [SMALL_STATE(3621)] = 129820,
  [SMALL_STATE(3622)] = 129829,
  [SMALL_STATE(3623)] = 129842,
  [SMALL_STATE(3624)] = 129855,
  [SMALL_STATE(3625)] = 129864,
  [SMALL_STATE(3626)] = 129877,
  [SMALL_STATE(3627)] = 129890,
  [SMALL_STATE(3628)] = 129903,
  [SMALL_STATE(3629)] = 129916,
  [SMALL_STATE(3630)] = 129927,
  [SMALL_STATE(3631)] = 129938,
  [SMALL_STATE(3632)] = 129951,
  [SMALL_STATE(3633)] = 129964,
  [SMALL_STATE(3634)] = 129977,
  [SMALL_STATE(3635)] = 129990,
  [SMALL_STATE(3636)] = 130003,
  [SMALL_STATE(3637)] = 130016,
  [SMALL_STATE(3638)] = 130029,
  [SMALL_STATE(3639)] = 130042,
  [SMALL_STATE(3640)] = 130051,
  [SMALL_STATE(3641)] = 130064,
  [SMALL_STATE(3642)] = 130075,
  [SMALL_STATE(3643)] = 130088,
  [SMALL_STATE(3644)] = 130101,
  [SMALL_STATE(3645)] = 130114,
  [SMALL_STATE(3646)] = 130123,
  [SMALL_STATE(3647)] = 130132,
  [SMALL_STATE(3648)] = 130143,
  [SMALL_STATE(3649)] = 130156,
  [SMALL_STATE(3650)] = 130169,
  [SMALL_STATE(3651)] = 130178,
  [SMALL_STATE(3652)] = 130187,
  [SMALL_STATE(3653)] = 130196,
  [SMALL_STATE(3654)] = 130205,
  [SMALL_STATE(3655)] = 130218,
  [SMALL_STATE(3656)] = 130227,
  [SMALL_STATE(3657)] = 130236,
  [SMALL_STATE(3658)] = 130245,
  [SMALL_STATE(3659)] = 130258,
  [SMALL_STATE(3660)] = 130271,
  [SMALL_STATE(3661)] = 130284,
  [SMALL_STATE(3662)] = 130293,
  [SMALL_STATE(3663)] = 130306,
  [SMALL_STATE(3664)] = 130319,
  [SMALL_STATE(3665)] = 130332,
  [SMALL_STATE(3666)] = 130345,
  [SMALL_STATE(3667)] = 130354,
  [SMALL_STATE(3668)] = 130367,
  [SMALL_STATE(3669)] = 130376,
  [SMALL_STATE(3670)] = 130385,
  [SMALL_STATE(3671)] = 130398,
  [SMALL_STATE(3672)] = 130411,
  [SMALL_STATE(3673)] = 130424,
  [SMALL_STATE(3674)] = 130437,
  [SMALL_STATE(3675)] = 130450,
  [SMALL_STATE(3676)] = 130459,
  [SMALL_STATE(3677)] = 130472,
  [SMALL_STATE(3678)] = 130485,
  [SMALL_STATE(3679)] = 130498,
  [SMALL_STATE(3680)] = 130507,
  [SMALL_STATE(3681)] = 130520,
  [SMALL_STATE(3682)] = 130533,
  [SMALL_STATE(3683)] = 130542,
  [SMALL_STATE(3684)] = 130551,
  [SMALL_STATE(3685)] = 130562,
  [SMALL_STATE(3686)] = 130575,
  [SMALL_STATE(3687)] = 130588,
  [SMALL_STATE(3688)] = 130597,
  [SMALL_STATE(3689)] = 130606,
  [SMALL_STATE(3690)] = 130615,
  [SMALL_STATE(3691)] = 130624,
  [SMALL_STATE(3692)] = 130633,
  [SMALL_STATE(3693)] = 130642,
  [SMALL_STATE(3694)] = 130651,
  [SMALL_STATE(3695)] = 130664,
  [SMALL_STATE(3696)] = 130673,
  [SMALL_STATE(3697)] = 130686,
  [SMALL_STATE(3698)] = 130699,
  [SMALL_STATE(3699)] = 130712,
  [SMALL_STATE(3700)] = 130721,
  [SMALL_STATE(3701)] = 130730,
  [SMALL_STATE(3702)] = 130739,
  [SMALL_STATE(3703)] = 130752,
  [SMALL_STATE(3704)] = 130765,
  [SMALL_STATE(3705)] = 130774,
  [SMALL_STATE(3706)] = 130787,
  [SMALL_STATE(3707)] = 130800,
  [SMALL_STATE(3708)] = 130809,
  [SMALL_STATE(3709)] = 130818,
  [SMALL_STATE(3710)] = 130827,
  [SMALL_STATE(3711)] = 130840,
  [SMALL_STATE(3712)] = 130853,
  [SMALL_STATE(3713)] = 130866,
  [SMALL_STATE(3714)] = 130875,
  [SMALL_STATE(3715)] = 130884,
  [SMALL_STATE(3716)] = 130897,
  [SMALL_STATE(3717)] = 130910,
  [SMALL_STATE(3718)] = 130923,
  [SMALL_STATE(3719)] = 130936,
  [SMALL_STATE(3720)] = 130945,
  [SMALL_STATE(3721)] = 130954,
  [SMALL_STATE(3722)] = 130967,
  [SMALL_STATE(3723)] = 130976,
  [SMALL_STATE(3724)] = 130985,
  [SMALL_STATE(3725)] = 130994,
  [SMALL_STATE(3726)] = 131005,
  [SMALL_STATE(3727)] = 131014,
  [SMALL_STATE(3728)] = 131027,
  [SMALL_STATE(3729)] = 131036,
  [SMALL_STATE(3730)] = 131045,
  [SMALL_STATE(3731)] = 131054,
  [SMALL_STATE(3732)] = 131063,
  [SMALL_STATE(3733)] = 131076,
  [SMALL_STATE(3734)] = 131089,
  [SMALL_STATE(3735)] = 131102,
  [SMALL_STATE(3736)] = 131115,
  [SMALL_STATE(3737)] = 131126,
  [SMALL_STATE(3738)] = 131139,
  [SMALL_STATE(3739)] = 131152,
  [SMALL_STATE(3740)] = 131163,
  [SMALL_STATE(3741)] = 131176,
  [SMALL_STATE(3742)] = 131189,
  [SMALL_STATE(3743)] = 131202,
  [SMALL_STATE(3744)] = 131213,
  [SMALL_STATE(3745)] = 131222,
  [SMALL_STATE(3746)] = 131235,
  [SMALL_STATE(3747)] = 131244,
  [SMALL_STATE(3748)] = 131257,
  [SMALL_STATE(3749)] = 131270,
  [SMALL_STATE(3750)] = 131279,
  [SMALL_STATE(3751)] = 131292,
  [SMALL_STATE(3752)] = 131305,
  [SMALL_STATE(3753)] = 131316,
  [SMALL_STATE(3754)] = 131329,
  [SMALL_STATE(3755)] = 131342,
  [SMALL_STATE(3756)] = 131353,
  [SMALL_STATE(3757)] = 131366,
  [SMALL_STATE(3758)] = 131379,
  [SMALL_STATE(3759)] = 131392,
  [SMALL_STATE(3760)] = 131405,
  [SMALL_STATE(3761)] = 131418,
  [SMALL_STATE(3762)] = 131429,
  [SMALL_STATE(3763)] = 131440,
  [SMALL_STATE(3764)] = 131449,
  [SMALL_STATE(3765)] = 131458,
  [SMALL_STATE(3766)] = 131467,
  [SMALL_STATE(3767)] = 131478,
  [SMALL_STATE(3768)] = 131487,
  [SMALL_STATE(3769)] = 131500,
  [SMALL_STATE(3770)] = 131513,
  [SMALL_STATE(3771)] = 131522,
  [SMALL_STATE(3772)] = 131531,
  [SMALL_STATE(3773)] = 131540,
  [SMALL_STATE(3774)] = 131549,
  [SMALL_STATE(3775)] = 131562,
  [SMALL_STATE(3776)] = 131575,
  [SMALL_STATE(3777)] = 131588,
  [SMALL_STATE(3778)] = 131601,
  [SMALL_STATE(3779)] = 131610,
  [SMALL_STATE(3780)] = 131619,
  [SMALL_STATE(3781)] = 131628,
  [SMALL_STATE(3782)] = 131638,
  [SMALL_STATE(3783)] = 131648,
  [SMALL_STATE(3784)] = 131658,
  [SMALL_STATE(3785)] = 131668,
  [SMALL_STATE(3786)] = 131676,
  [SMALL_STATE(3787)] = 131684,
  [SMALL_STATE(3788)] = 131694,
  [SMALL_STATE(3789)] = 131704,
  [SMALL_STATE(3790)] = 131714,
  [SMALL_STATE(3791)] = 131724,
  [SMALL_STATE(3792)] = 131734,
  [SMALL_STATE(3793)] = 131742,
  [SMALL_STATE(3794)] = 131752,
  [SMALL_STATE(3795)] = 131762,
  [SMALL_STATE(3796)] = 131772,
  [SMALL_STATE(3797)] = 131780,
  [SMALL_STATE(3798)] = 131790,
  [SMALL_STATE(3799)] = 131800,
  [SMALL_STATE(3800)] = 131810,
  [SMALL_STATE(3801)] = 131820,
  [SMALL_STATE(3802)] = 131830,
  [SMALL_STATE(3803)] = 131838,
  [SMALL_STATE(3804)] = 131846,
  [SMALL_STATE(3805)] = 131854,
  [SMALL_STATE(3806)] = 131864,
  [SMALL_STATE(3807)] = 131872,
  [SMALL_STATE(3808)] = 131882,
  [SMALL_STATE(3809)] = 131892,
  [SMALL_STATE(3810)] = 131900,
  [SMALL_STATE(3811)] = 131910,
  [SMALL_STATE(3812)] = 131920,
  [SMALL_STATE(3813)] = 131930,
  [SMALL_STATE(3814)] = 131940,
  [SMALL_STATE(3815)] = 131950,
  [SMALL_STATE(3816)] = 131960,
  [SMALL_STATE(3817)] = 131970,
  [SMALL_STATE(3818)] = 131980,
  [SMALL_STATE(3819)] = 131990,
  [SMALL_STATE(3820)] = 131998,
  [SMALL_STATE(3821)] = 132006,
  [SMALL_STATE(3822)] = 132016,
  [SMALL_STATE(3823)] = 132026,
  [SMALL_STATE(3824)] = 132036,
  [SMALL_STATE(3825)] = 132046,
  [SMALL_STATE(3826)] = 132056,
  [SMALL_STATE(3827)] = 132064,
  [SMALL_STATE(3828)] = 132074,
  [SMALL_STATE(3829)] = 132082,
  [SMALL_STATE(3830)] = 132092,
  [SMALL_STATE(3831)] = 132102,
  [SMALL_STATE(3832)] = 132110,
  [SMALL_STATE(3833)] = 132120,
  [SMALL_STATE(3834)] = 132130,
  [SMALL_STATE(3835)] = 132140,
  [SMALL_STATE(3836)] = 132150,
  [SMALL_STATE(3837)] = 132160,
  [SMALL_STATE(3838)] = 132168,
  [SMALL_STATE(3839)] = 132178,
  [SMALL_STATE(3840)] = 132188,
  [SMALL_STATE(3841)] = 132198,
  [SMALL_STATE(3842)] = 132208,
  [SMALL_STATE(3843)] = 132218,
  [SMALL_STATE(3844)] = 132226,
  [SMALL_STATE(3845)] = 132234,
  [SMALL_STATE(3846)] = 132244,
  [SMALL_STATE(3847)] = 132254,
  [SMALL_STATE(3848)] = 132264,
  [SMALL_STATE(3849)] = 132274,
  [SMALL_STATE(3850)] = 132282,
  [SMALL_STATE(3851)] = 132292,
  [SMALL_STATE(3852)] = 132302,
  [SMALL_STATE(3853)] = 132312,
  [SMALL_STATE(3854)] = 132320,
  [SMALL_STATE(3855)] = 132328,
  [SMALL_STATE(3856)] = 132338,
  [SMALL_STATE(3857)] = 132348,
  [SMALL_STATE(3858)] = 132356,
  [SMALL_STATE(3859)] = 132366,
  [SMALL_STATE(3860)] = 132376,
  [SMALL_STATE(3861)] = 132384,
  [SMALL_STATE(3862)] = 132392,
  [SMALL_STATE(3863)] = 132400,
  [SMALL_STATE(3864)] = 132410,
  [SMALL_STATE(3865)] = 132420,
  [SMALL_STATE(3866)] = 132430,
  [SMALL_STATE(3867)] = 132440,
  [SMALL_STATE(3868)] = 132450,
  [SMALL_STATE(3869)] = 132458,
  [SMALL_STATE(3870)] = 132468,
  [SMALL_STATE(3871)] = 132478,
  [SMALL_STATE(3872)] = 132486,
  [SMALL_STATE(3873)] = 132496,
  [SMALL_STATE(3874)] = 132506,
  [SMALL_STATE(3875)] = 132516,
  [SMALL_STATE(3876)] = 132524,
  [SMALL_STATE(3877)] = 132532,
  [SMALL_STATE(3878)] = 132540,
  [SMALL_STATE(3879)] = 132548,
  [SMALL_STATE(3880)] = 132558,
  [SMALL_STATE(3881)] = 132566,
  [SMALL_STATE(3882)] = 132576,
  [SMALL_STATE(3883)] = 132584,
  [SMALL_STATE(3884)] = 132592,
  [SMALL_STATE(3885)] = 132602,
  [SMALL_STATE(3886)] = 132612,
  [SMALL_STATE(3887)] = 132622,
  [SMALL_STATE(3888)] = 132632,
  [SMALL_STATE(3889)] = 132642,
  [SMALL_STATE(3890)] = 132652,
  [SMALL_STATE(3891)] = 132662,
  [SMALL_STATE(3892)] = 132672,
  [SMALL_STATE(3893)] = 132682,
  [SMALL_STATE(3894)] = 132692,
  [SMALL_STATE(3895)] = 132700,
  [SMALL_STATE(3896)] = 132708,
  [SMALL_STATE(3897)] = 132716,
  [SMALL_STATE(3898)] = 132724,
  [SMALL_STATE(3899)] = 132734,
  [SMALL_STATE(3900)] = 132744,
  [SMALL_STATE(3901)] = 132754,
  [SMALL_STATE(3902)] = 132762,
  [SMALL_STATE(3903)] = 132772,
  [SMALL_STATE(3904)] = 132780,
  [SMALL_STATE(3905)] = 132790,
  [SMALL_STATE(3906)] = 132798,
  [SMALL_STATE(3907)] = 132808,
  [SMALL_STATE(3908)] = 132818,
  [SMALL_STATE(3909)] = 132828,
  [SMALL_STATE(3910)] = 132838,
  [SMALL_STATE(3911)] = 132846,
  [SMALL_STATE(3912)] = 132854,
  [SMALL_STATE(3913)] = 132864,
  [SMALL_STATE(3914)] = 132874,
  [SMALL_STATE(3915)] = 132884,
  [SMALL_STATE(3916)] = 132894,
  [SMALL_STATE(3917)] = 132902,
  [SMALL_STATE(3918)] = 132912,
  [SMALL_STATE(3919)] = 132922,
  [SMALL_STATE(3920)] = 132932,
  [SMALL_STATE(3921)] = 132942,
  [SMALL_STATE(3922)] = 132952,
  [SMALL_STATE(3923)] = 132962,
  [SMALL_STATE(3924)] = 132972,
  [SMALL_STATE(3925)] = 132982,
  [SMALL_STATE(3926)] = 132992,
  [SMALL_STATE(3927)] = 133002,
  [SMALL_STATE(3928)] = 133010,
  [SMALL_STATE(3929)] = 133018,
  [SMALL_STATE(3930)] = 133028,
  [SMALL_STATE(3931)] = 133038,
  [SMALL_STATE(3932)] = 133046,
  [SMALL_STATE(3933)] = 133056,
  [SMALL_STATE(3934)] = 133066,
  [SMALL_STATE(3935)] = 133076,
  [SMALL_STATE(3936)] = 133086,
  [SMALL_STATE(3937)] = 133096,
  [SMALL_STATE(3938)] = 133106,
  [SMALL_STATE(3939)] = 133116,
  [SMALL_STATE(3940)] = 133124,
  [SMALL_STATE(3941)] = 133134,
  [SMALL_STATE(3942)] = 133142,
  [SMALL_STATE(3943)] = 133152,
  [SMALL_STATE(3944)] = 133162,
  [SMALL_STATE(3945)] = 133172,
  [SMALL_STATE(3946)] = 133180,
  [SMALL_STATE(3947)] = 133188,
  [SMALL_STATE(3948)] = 133198,
  [SMALL_STATE(3949)] = 133208,
  [SMALL_STATE(3950)] = 133218,
  [SMALL_STATE(3951)] = 133228,
  [SMALL_STATE(3952)] = 133238,
  [SMALL_STATE(3953)] = 133246,
  [SMALL_STATE(3954)] = 133256,
  [SMALL_STATE(3955)] = 133266,
  [SMALL_STATE(3956)] = 133276,
  [SMALL_STATE(3957)] = 133286,
  [SMALL_STATE(3958)] = 133296,
  [SMALL_STATE(3959)] = 133304,
  [SMALL_STATE(3960)] = 133314,
  [SMALL_STATE(3961)] = 133324,
  [SMALL_STATE(3962)] = 133334,
  [SMALL_STATE(3963)] = 133342,
  [SMALL_STATE(3964)] = 133352,
  [SMALL_STATE(3965)] = 133362,
  [SMALL_STATE(3966)] = 133372,
  [SMALL_STATE(3967)] = 133382,
  [SMALL_STATE(3968)] = 133392,
  [SMALL_STATE(3969)] = 133402,
  [SMALL_STATE(3970)] = 133412,
  [SMALL_STATE(3971)] = 133420,
  [SMALL_STATE(3972)] = 133428,
  [SMALL_STATE(3973)] = 133438,
  [SMALL_STATE(3974)] = 133448,
  [SMALL_STATE(3975)] = 133458,
  [SMALL_STATE(3976)] = 133468,
  [SMALL_STATE(3977)] = 133476,
  [SMALL_STATE(3978)] = 133486,
  [SMALL_STATE(3979)] = 133496,
  [SMALL_STATE(3980)] = 133506,
  [SMALL_STATE(3981)] = 133516,
  [SMALL_STATE(3982)] = 133526,
  [SMALL_STATE(3983)] = 133536,
  [SMALL_STATE(3984)] = 133544,
  [SMALL_STATE(3985)] = 133554,
  [SMALL_STATE(3986)] = 133564,
  [SMALL_STATE(3987)] = 133572,
  [SMALL_STATE(3988)] = 133582,
  [SMALL_STATE(3989)] = 133592,
  [SMALL_STATE(3990)] = 133602,
  [SMALL_STATE(3991)] = 133612,
  [SMALL_STATE(3992)] = 133622,
  [SMALL_STATE(3993)] = 133632,
  [SMALL_STATE(3994)] = 133642,
  [SMALL_STATE(3995)] = 133652,
  [SMALL_STATE(3996)] = 133660,
  [SMALL_STATE(3997)] = 133670,
  [SMALL_STATE(3998)] = 133678,
  [SMALL_STATE(3999)] = 133686,
  [SMALL_STATE(4000)] = 133694,
  [SMALL_STATE(4001)] = 133704,
  [SMALL_STATE(4002)] = 133714,
  [SMALL_STATE(4003)] = 133724,
  [SMALL_STATE(4004)] = 133732,
  [SMALL_STATE(4005)] = 133742,
  [SMALL_STATE(4006)] = 133752,
  [SMALL_STATE(4007)] = 133760,
  [SMALL_STATE(4008)] = 133770,
  [SMALL_STATE(4009)] = 133780,
  [SMALL_STATE(4010)] = 133790,
  [SMALL_STATE(4011)] = 133800,
  [SMALL_STATE(4012)] = 133810,
  [SMALL_STATE(4013)] = 133820,
  [SMALL_STATE(4014)] = 133830,
  [SMALL_STATE(4015)] = 133840,
  [SMALL_STATE(4016)] = 133850,
  [SMALL_STATE(4017)] = 133858,
  [SMALL_STATE(4018)] = 133868,
  [SMALL_STATE(4019)] = 133878,
  [SMALL_STATE(4020)] = 133886,
  [SMALL_STATE(4021)] = 133896,
  [SMALL_STATE(4022)] = 133906,
  [SMALL_STATE(4023)] = 133916,
  [SMALL_STATE(4024)] = 133926,
  [SMALL_STATE(4025)] = 133934,
  [SMALL_STATE(4026)] = 133944,
  [SMALL_STATE(4027)] = 133954,
  [SMALL_STATE(4028)] = 133964,
  [SMALL_STATE(4029)] = 133974,
  [SMALL_STATE(4030)] = 133984,
  [SMALL_STATE(4031)] = 133994,
  [SMALL_STATE(4032)] = 134004,
  [SMALL_STATE(4033)] = 134014,
  [SMALL_STATE(4034)] = 134024,
  [SMALL_STATE(4035)] = 134034,
  [SMALL_STATE(4036)] = 134044,
  [SMALL_STATE(4037)] = 134054,
  [SMALL_STATE(4038)] = 134064,
  [SMALL_STATE(4039)] = 134074,
  [SMALL_STATE(4040)] = 134084,
  [SMALL_STATE(4041)] = 134094,
  [SMALL_STATE(4042)] = 134104,
  [SMALL_STATE(4043)] = 134114,
  [SMALL_STATE(4044)] = 134124,
  [SMALL_STATE(4045)] = 134134,
  [SMALL_STATE(4046)] = 134144,
  [SMALL_STATE(4047)] = 134154,
  [SMALL_STATE(4048)] = 134164,
  [SMALL_STATE(4049)] = 134171,
  [SMALL_STATE(4050)] = 134178,
  [SMALL_STATE(4051)] = 134185,
  [SMALL_STATE(4052)] = 134192,
  [SMALL_STATE(4053)] = 134199,
  [SMALL_STATE(4054)] = 134206,
  [SMALL_STATE(4055)] = 134213,
  [SMALL_STATE(4056)] = 134220,
  [SMALL_STATE(4057)] = 134227,
  [SMALL_STATE(4058)] = 134234,
  [SMALL_STATE(4059)] = 134241,
  [SMALL_STATE(4060)] = 134248,
  [SMALL_STATE(4061)] = 134255,
  [SMALL_STATE(4062)] = 134262,
  [SMALL_STATE(4063)] = 134269,
  [SMALL_STATE(4064)] = 134276,
  [SMALL_STATE(4065)] = 134283,
  [SMALL_STATE(4066)] = 134290,
  [SMALL_STATE(4067)] = 134297,
  [SMALL_STATE(4068)] = 134304,
  [SMALL_STATE(4069)] = 134311,
  [SMALL_STATE(4070)] = 134318,
  [SMALL_STATE(4071)] = 134325,
  [SMALL_STATE(4072)] = 134332,
  [SMALL_STATE(4073)] = 134339,
  [SMALL_STATE(4074)] = 134346,
  [SMALL_STATE(4075)] = 134353,
  [SMALL_STATE(4076)] = 134360,
  [SMALL_STATE(4077)] = 134367,
  [SMALL_STATE(4078)] = 134374,
  [SMALL_STATE(4079)] = 134381,
  [SMALL_STATE(4080)] = 134388,
  [SMALL_STATE(4081)] = 134395,
  [SMALL_STATE(4082)] = 134402,
  [SMALL_STATE(4083)] = 134409,
  [SMALL_STATE(4084)] = 134416,
  [SMALL_STATE(4085)] = 134423,
  [SMALL_STATE(4086)] = 134430,
  [SMALL_STATE(4087)] = 134437,
  [SMALL_STATE(4088)] = 134444,
  [SMALL_STATE(4089)] = 134451,
  [SMALL_STATE(4090)] = 134458,
  [SMALL_STATE(4091)] = 134465,
  [SMALL_STATE(4092)] = 134472,
  [SMALL_STATE(4093)] = 134479,
  [SMALL_STATE(4094)] = 134486,
  [SMALL_STATE(4095)] = 134493,
  [SMALL_STATE(4096)] = 134500,
  [SMALL_STATE(4097)] = 134507,
  [SMALL_STATE(4098)] = 134514,
  [SMALL_STATE(4099)] = 134521,
  [SMALL_STATE(4100)] = 134528,
  [SMALL_STATE(4101)] = 134535,
  [SMALL_STATE(4102)] = 134542,
  [SMALL_STATE(4103)] = 134549,
  [SMALL_STATE(4104)] = 134556,
  [SMALL_STATE(4105)] = 134563,
  [SMALL_STATE(4106)] = 134570,
  [SMALL_STATE(4107)] = 134577,
  [SMALL_STATE(4108)] = 134584,
  [SMALL_STATE(4109)] = 134591,
  [SMALL_STATE(4110)] = 134598,
  [SMALL_STATE(4111)] = 134605,
  [SMALL_STATE(4112)] = 134612,
  [SMALL_STATE(4113)] = 134619,
  [SMALL_STATE(4114)] = 134626,
  [SMALL_STATE(4115)] = 134633,
  [SMALL_STATE(4116)] = 134640,
  [SMALL_STATE(4117)] = 134647,
  [SMALL_STATE(4118)] = 134654,
  [SMALL_STATE(4119)] = 134661,
  [SMALL_STATE(4120)] = 134668,
  [SMALL_STATE(4121)] = 134675,
  [SMALL_STATE(4122)] = 134682,
  [SMALL_STATE(4123)] = 134689,
  [SMALL_STATE(4124)] = 134696,
  [SMALL_STATE(4125)] = 134703,
  [SMALL_STATE(4126)] = 134710,
  [SMALL_STATE(4127)] = 134717,
  [SMALL_STATE(4128)] = 134724,
  [SMALL_STATE(4129)] = 134731,
  [SMALL_STATE(4130)] = 134738,
  [SMALL_STATE(4131)] = 134745,
  [SMALL_STATE(4132)] = 134752,
  [SMALL_STATE(4133)] = 134759,
  [SMALL_STATE(4134)] = 134766,
  [SMALL_STATE(4135)] = 134773,
  [SMALL_STATE(4136)] = 134780,
  [SMALL_STATE(4137)] = 134787,
  [SMALL_STATE(4138)] = 134794,
  [SMALL_STATE(4139)] = 134801,
  [SMALL_STATE(4140)] = 134808,
  [SMALL_STATE(4141)] = 134815,
  [SMALL_STATE(4142)] = 134822,
  [SMALL_STATE(4143)] = 134829,
  [SMALL_STATE(4144)] = 134836,
  [SMALL_STATE(4145)] = 134843,
  [SMALL_STATE(4146)] = 134850,
  [SMALL_STATE(4147)] = 134857,
  [SMALL_STATE(4148)] = 134864,
  [SMALL_STATE(4149)] = 134871,
  [SMALL_STATE(4150)] = 134878,
  [SMALL_STATE(4151)] = 134885,
  [SMALL_STATE(4152)] = 134892,
  [SMALL_STATE(4153)] = 134899,
  [SMALL_STATE(4154)] = 134906,
  [SMALL_STATE(4155)] = 134913,
  [SMALL_STATE(4156)] = 134920,
  [SMALL_STATE(4157)] = 134927,
  [SMALL_STATE(4158)] = 134934,
  [SMALL_STATE(4159)] = 134941,
  [SMALL_STATE(4160)] = 134948,
  [SMALL_STATE(4161)] = 134955,
  [SMALL_STATE(4162)] = 134962,
  [SMALL_STATE(4163)] = 134969,
  [SMALL_STATE(4164)] = 134976,
  [SMALL_STATE(4165)] = 134983,
  [SMALL_STATE(4166)] = 134990,
  [SMALL_STATE(4167)] = 134997,
  [SMALL_STATE(4168)] = 135004,
  [SMALL_STATE(4169)] = 135011,
  [SMALL_STATE(4170)] = 135018,
  [SMALL_STATE(4171)] = 135025,
  [SMALL_STATE(4172)] = 135032,
  [SMALL_STATE(4173)] = 135039,
  [SMALL_STATE(4174)] = 135046,
  [SMALL_STATE(4175)] = 135053,
  [SMALL_STATE(4176)] = 135060,
  [SMALL_STATE(4177)] = 135067,
  [SMALL_STATE(4178)] = 135074,
  [SMALL_STATE(4179)] = 135081,
  [SMALL_STATE(4180)] = 135088,
  [SMALL_STATE(4181)] = 135095,
  [SMALL_STATE(4182)] = 135102,
  [SMALL_STATE(4183)] = 135109,
  [SMALL_STATE(4184)] = 135116,
  [SMALL_STATE(4185)] = 135123,
  [SMALL_STATE(4186)] = 135130,
  [SMALL_STATE(4187)] = 135137,
  [SMALL_STATE(4188)] = 135144,
  [SMALL_STATE(4189)] = 135151,
  [SMALL_STATE(4190)] = 135158,
  [SMALL_STATE(4191)] = 135165,
  [SMALL_STATE(4192)] = 135172,
  [SMALL_STATE(4193)] = 135179,
  [SMALL_STATE(4194)] = 135186,
  [SMALL_STATE(4195)] = 135193,
  [SMALL_STATE(4196)] = 135200,
  [SMALL_STATE(4197)] = 135207,
  [SMALL_STATE(4198)] = 135214,
  [SMALL_STATE(4199)] = 135221,
  [SMALL_STATE(4200)] = 135228,
  [SMALL_STATE(4201)] = 135235,
  [SMALL_STATE(4202)] = 135242,
  [SMALL_STATE(4203)] = 135249,
  [SMALL_STATE(4204)] = 135256,
  [SMALL_STATE(4205)] = 135263,
  [SMALL_STATE(4206)] = 135270,
  [SMALL_STATE(4207)] = 135277,
  [SMALL_STATE(4208)] = 135284,
  [SMALL_STATE(4209)] = 135291,
  [SMALL_STATE(4210)] = 135298,
  [SMALL_STATE(4211)] = 135305,
  [SMALL_STATE(4212)] = 135312,
  [SMALL_STATE(4213)] = 135319,
  [SMALL_STATE(4214)] = 135326,
  [SMALL_STATE(4215)] = 135333,
  [SMALL_STATE(4216)] = 135340,
  [SMALL_STATE(4217)] = 135347,
  [SMALL_STATE(4218)] = 135354,
  [SMALL_STATE(4219)] = 135361,
  [SMALL_STATE(4220)] = 135368,
  [SMALL_STATE(4221)] = 135375,
  [SMALL_STATE(4222)] = 135382,
  [SMALL_STATE(4223)] = 135389,
  [SMALL_STATE(4224)] = 135396,
  [SMALL_STATE(4225)] = 135403,
  [SMALL_STATE(4226)] = 135410,
  [SMALL_STATE(4227)] = 135417,
  [SMALL_STATE(4228)] = 135424,
  [SMALL_STATE(4229)] = 135431,
  [SMALL_STATE(4230)] = 135438,
  [SMALL_STATE(4231)] = 135445,
  [SMALL_STATE(4232)] = 135452,
  [SMALL_STATE(4233)] = 135459,
  [SMALL_STATE(4234)] = 135466,
  [SMALL_STATE(4235)] = 135473,
  [SMALL_STATE(4236)] = 135480,
  [SMALL_STATE(4237)] = 135487,
  [SMALL_STATE(4238)] = 135494,
  [SMALL_STATE(4239)] = 135501,
  [SMALL_STATE(4240)] = 135508,
  [SMALL_STATE(4241)] = 135515,
  [SMALL_STATE(4242)] = 135522,
  [SMALL_STATE(4243)] = 135529,
  [SMALL_STATE(4244)] = 135536,
  [SMALL_STATE(4245)] = 135543,
  [SMALL_STATE(4246)] = 135550,
  [SMALL_STATE(4247)] = 135557,
  [SMALL_STATE(4248)] = 135564,
  [SMALL_STATE(4249)] = 135571,
  [SMALL_STATE(4250)] = 135578,
  [SMALL_STATE(4251)] = 135585,
  [SMALL_STATE(4252)] = 135592,
  [SMALL_STATE(4253)] = 135599,
  [SMALL_STATE(4254)] = 135606,
  [SMALL_STATE(4255)] = 135613,
  [SMALL_STATE(4256)] = 135620,
  [SMALL_STATE(4257)] = 135627,
  [SMALL_STATE(4258)] = 135634,
  [SMALL_STATE(4259)] = 135641,
  [SMALL_STATE(4260)] = 135648,
  [SMALL_STATE(4261)] = 135655,
  [SMALL_STATE(4262)] = 135662,
  [SMALL_STATE(4263)] = 135669,
  [SMALL_STATE(4264)] = 135676,
  [SMALL_STATE(4265)] = 135683,
  [SMALL_STATE(4266)] = 135690,
  [SMALL_STATE(4267)] = 135697,
  [SMALL_STATE(4268)] = 135704,
  [SMALL_STATE(4269)] = 135711,
  [SMALL_STATE(4270)] = 135718,
  [SMALL_STATE(4271)] = 135725,
  [SMALL_STATE(4272)] = 135732,
  [SMALL_STATE(4273)] = 135739,
  [SMALL_STATE(4274)] = 135746,
  [SMALL_STATE(4275)] = 135753,
  [SMALL_STATE(4276)] = 135760,
  [SMALL_STATE(4277)] = 135767,
  [SMALL_STATE(4278)] = 135774,
  [SMALL_STATE(4279)] = 135781,
  [SMALL_STATE(4280)] = 135788,
  [SMALL_STATE(4281)] = 135795,
  [SMALL_STATE(4282)] = 135802,
  [SMALL_STATE(4283)] = 135809,
  [SMALL_STATE(4284)] = 135816,
  [SMALL_STATE(4285)] = 135823,
  [SMALL_STATE(4286)] = 135830,
  [SMALL_STATE(4287)] = 135837,
  [SMALL_STATE(4288)] = 135844,
  [SMALL_STATE(4289)] = 135851,
  [SMALL_STATE(4290)] = 135858,
  [SMALL_STATE(4291)] = 135865,
  [SMALL_STATE(4292)] = 135872,
  [SMALL_STATE(4293)] = 135879,
  [SMALL_STATE(4294)] = 135886,
  [SMALL_STATE(4295)] = 135893,
  [SMALL_STATE(4296)] = 135900,
  [SMALL_STATE(4297)] = 135907,
  [SMALL_STATE(4298)] = 135914,
  [SMALL_STATE(4299)] = 135921,
  [SMALL_STATE(4300)] = 135928,
  [SMALL_STATE(4301)] = 135935,
  [SMALL_STATE(4302)] = 135942,
  [SMALL_STATE(4303)] = 135949,
  [SMALL_STATE(4304)] = 135956,
  [SMALL_STATE(4305)] = 135963,
  [SMALL_STATE(4306)] = 135970,
  [SMALL_STATE(4307)] = 135977,
  [SMALL_STATE(4308)] = 135984,
  [SMALL_STATE(4309)] = 135991,
  [SMALL_STATE(4310)] = 135998,
  [SMALL_STATE(4311)] = 136005,
  [SMALL_STATE(4312)] = 136012,
  [SMALL_STATE(4313)] = 136019,
  [SMALL_STATE(4314)] = 136026,
  [SMALL_STATE(4315)] = 136033,
  [SMALL_STATE(4316)] = 136040,
  [SMALL_STATE(4317)] = 136047,
  [SMALL_STATE(4318)] = 136054,
  [SMALL_STATE(4319)] = 136061,
  [SMALL_STATE(4320)] = 136068,
  [SMALL_STATE(4321)] = 136075,
  [SMALL_STATE(4322)] = 136082,
  [SMALL_STATE(4323)] = 136089,
  [SMALL_STATE(4324)] = 136096,
  [SMALL_STATE(4325)] = 136103,
  [SMALL_STATE(4326)] = 136110,
  [SMALL_STATE(4327)] = 136117,
  [SMALL_STATE(4328)] = 136124,
  [SMALL_STATE(4329)] = 136131,
  [SMALL_STATE(4330)] = 136138,
  [SMALL_STATE(4331)] = 136145,
  [SMALL_STATE(4332)] = 136152,
  [SMALL_STATE(4333)] = 136159,
  [SMALL_STATE(4334)] = 136166,
  [SMALL_STATE(4335)] = 136173,
  [SMALL_STATE(4336)] = 136180,
  [SMALL_STATE(4337)] = 136187,
  [SMALL_STATE(4338)] = 136194,
  [SMALL_STATE(4339)] = 136201,
  [SMALL_STATE(4340)] = 136208,
  [SMALL_STATE(4341)] = 136215,
  [SMALL_STATE(4342)] = 136222,
  [SMALL_STATE(4343)] = 136229,
  [SMALL_STATE(4344)] = 136236,
  [SMALL_STATE(4345)] = 136243,
  [SMALL_STATE(4346)] = 136250,
  [SMALL_STATE(4347)] = 136257,
  [SMALL_STATE(4348)] = 136264,
  [SMALL_STATE(4349)] = 136271,
  [SMALL_STATE(4350)] = 136278,
  [SMALL_STATE(4351)] = 136285,
  [SMALL_STATE(4352)] = 136292,
  [SMALL_STATE(4353)] = 136299,
  [SMALL_STATE(4354)] = 136306,
  [SMALL_STATE(4355)] = 136313,
  [SMALL_STATE(4356)] = 136320,
  [SMALL_STATE(4357)] = 136327,
  [SMALL_STATE(4358)] = 136334,
  [SMALL_STATE(4359)] = 136341,
  [SMALL_STATE(4360)] = 136348,
  [SMALL_STATE(4361)] = 136355,
  [SMALL_STATE(4362)] = 136362,
  [SMALL_STATE(4363)] = 136369,
  [SMALL_STATE(4364)] = 136376,
  [SMALL_STATE(4365)] = 136383,
  [SMALL_STATE(4366)] = 136390,
  [SMALL_STATE(4367)] = 136397,
  [SMALL_STATE(4368)] = 136404,
  [SMALL_STATE(4369)] = 136411,
  [SMALL_STATE(4370)] = 136418,
  [SMALL_STATE(4371)] = 136425,
  [SMALL_STATE(4372)] = 136432,
  [SMALL_STATE(4373)] = 136439,
  [SMALL_STATE(4374)] = 136446,
  [SMALL_STATE(4375)] = 136453,
  [SMALL_STATE(4376)] = 136460,
  [SMALL_STATE(4377)] = 136467,
  [SMALL_STATE(4378)] = 136474,
  [SMALL_STATE(4379)] = 136481,
  [SMALL_STATE(4380)] = 136488,
  [SMALL_STATE(4381)] = 136495,
  [SMALL_STATE(4382)] = 136502,
  [SMALL_STATE(4383)] = 136509,
  [SMALL_STATE(4384)] = 136516,
  [SMALL_STATE(4385)] = 136523,
  [SMALL_STATE(4386)] = 136530,
  [SMALL_STATE(4387)] = 136537,
  [SMALL_STATE(4388)] = 136544,
  [SMALL_STATE(4389)] = 136551,
  [SMALL_STATE(4390)] = 136558,
  [SMALL_STATE(4391)] = 136565,
  [SMALL_STATE(4392)] = 136572,
  [SMALL_STATE(4393)] = 136579,
  [SMALL_STATE(4394)] = 136586,
  [SMALL_STATE(4395)] = 136593,
  [SMALL_STATE(4396)] = 136600,
  [SMALL_STATE(4397)] = 136607,
  [SMALL_STATE(4398)] = 136614,
  [SMALL_STATE(4399)] = 136621,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4386),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(329),
  [114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(390),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(4144),
  [142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 1),
  [156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(327),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(490),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1083),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(533),
  [317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1057),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(985),
  [325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(335),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1184),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2870),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2916),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2793),
  [343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(335),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3791),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3920),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3541),
  [355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(125),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(371),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3992),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3991),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3953),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3762),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3684),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3875),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(233),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(303),
  [388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(610),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(97),
  [394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(140),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3095),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4390),
  [403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2652),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(573),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2913),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(292),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(382),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3427),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3430),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3087),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1762),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1762),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1769),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3697),
  [439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1071),
  [442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(540),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(979),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4386),
  [451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4385),
  [454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4384),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 49),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 49),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 53),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 53),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 200),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 200),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3597),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3934),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(126),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(143),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2965),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2959),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4313),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4053),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4082),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2844),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4154),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4152),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4199),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4314),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2626),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 5),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 5),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 140),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 140),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 140),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 140),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 150),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 150),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 150),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 150),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 189),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 189),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 189),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 189),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 158),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 158),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 158),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 158),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 48),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 48),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 48),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 48),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 24),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 24),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 115),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 115),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 115),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 115),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 195),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 195),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 195),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 195),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 159),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 159),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 159),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 159),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 123),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 123),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 123),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 123),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [1518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 98),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 98),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 98),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 98),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 99),
  [1542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 99),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 99),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 99),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 150),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 150),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 150),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 150),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [1590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1593] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2365),
  [1597] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2601),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2661),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [1691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(50),
  [1697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [1706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [1720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2116),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4302),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [1886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [1916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2273),
  [1919] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(135),
  [1923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(336),
  [1926] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(3937),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2265),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [1978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [2002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(135),
  [2005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3937),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4085),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4086),
  [2014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4309),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [2020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(273),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2822),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4341),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4339),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4270),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4269),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4054),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3673),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(404),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4155),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4153),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 40),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 40),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4093),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 203),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 203),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 32),
  [2098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 32),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 224),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 224),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 34),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 34),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 128),
  [2124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 128),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 126),
  [2128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 126),
  [2130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 6),
  [2140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 6),
  [2142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 122),
  [2152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 122),
  [2154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 48),
  [2156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 48),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 133),
  [2164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 133),
  [2166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 149),
  [2168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 149),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 99),
  [2180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 99),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 99),
  [2188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 99),
  [2190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 98),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 98),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 117),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 117),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 114),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 114),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 43),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 43),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 43),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 43),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 42),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 42),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 41),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 41),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 39),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 39),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 20),
  [2240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 20),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 48),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 48),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 74),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 84),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 84),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 115),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 115),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 151),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 151),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 152),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 152),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 140),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 140),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 44),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 44),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 220),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 220),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 195),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 195),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 33),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 33),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 194),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 194),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 192),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 192),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 31),
  [2328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 31),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 219),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 219),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 189),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 189),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 157),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 157),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 123),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 161),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 161),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 28),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 28),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 91),
  [2364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 91),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 22),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 22),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 163),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 163),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 202),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 202),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 167),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 167),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 197),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 197),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 196),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 196),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 159),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 159),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 158),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 158),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 194),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 194),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 192),
  [2412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 192),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 78),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 78),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 44),
  [2424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 44),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 71),
  [2428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 71),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 190),
  [2432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 190),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 150),
  [2436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 150),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 31),
  [2444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 31),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 83),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 83),
  [2454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 150),
  [2456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 150),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 223),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 223),
  [2518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 166),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 166),
  [2522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 85),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 85),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 201),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 201),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 165),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 165),
  [2538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [2540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [2542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [2544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [2546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4201),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [2610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3598),
  [2612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [2616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [2618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [2620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [2646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [2662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [2666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [2668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [2670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [2674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [2676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4337),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2514),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4247),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [2850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2715),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3750),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [2918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [2928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 156),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 156),
  [2932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [2934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [2936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 120),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 120),
  [2940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [2946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [2951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [2953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 62),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 62),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 63),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 63),
  [2969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(413),
  [2972] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [2981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(962),
  [2984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4061),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [2992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 50), SHIFT(3912),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 50),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(961),
  [3002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4294),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [3017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [3027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(339),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 50),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [3059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3066] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 50), REDUCE(sym_rest_pattern, 2),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3078] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 27),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(279),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [3095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3686),
  [3100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19),
  [3102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19),
  [3104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19), SHIFT_REPEAT(3697),
  [3107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(379),
  [3110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 19), SHIFT(2648),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 62),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 62),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 15),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 15),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4140),
  [3179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1225),
  [3182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1443),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [3189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1577),
  [3192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1974),
  [3195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1400),
  [3198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1381),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4352),
  [3227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [3229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3249] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 25), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 26),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 50),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [3351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [3353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [3355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [3357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [3359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [3361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [3371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [3373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 13),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 13),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 51),
  [3393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 51),
  [3395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [3397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 104),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 104),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 103),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 103),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [3429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [3431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 186),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 186),
  [3443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [3455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [3457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [3459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [3461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 188),
  [3463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 188),
  [3465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 15),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 15),
  [3475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 144),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 144),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 120),
  [3481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 120),
  [3483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 145),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 145),
  [3487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 215),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 215),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 181),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 181),
  [3495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [3499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 216),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 216),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 182),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 182),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 106),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 106),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 52),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 52),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 8),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 8),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [3533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [3535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [3537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 217),
  [3539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 217),
  [3541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 183),
  [3547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 183),
  [3549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 184),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 184),
  [3553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 185),
  [3555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 185),
  [3557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [3559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [3561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 218),
  [3563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 218),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [3569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 63),
  [3571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 63),
  [3573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 156),
  [3575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 156),
  [3577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [3579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [3581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 238),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 238),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [3593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [3597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 239),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 239),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [3623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 105),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 105),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 107),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 107),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [3647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [3661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 108),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 108),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 240),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 240),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 147),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 147),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 146),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 146),
  [3685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 146),
  [3688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 187),
  [3690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 187),
  [3692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 80),
  [3694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 80),
  [3696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 253),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 253),
  [3700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 62),
  [3702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 62),
  [3704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [3706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [3712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 113),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [3716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 92),
  [3756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 92),
  [3758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [3760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [3762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [3765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [3768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 51),
  [3771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 51),
  [3774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(90),
  [3781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11),
  [3783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 113),
  [3791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 58),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(90),
  [3806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [3808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [3810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [3814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 160),
  [3816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 160),
  [3818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [3820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [3822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 64),
  [3824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 64),
  [3826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 65),
  [3828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 65),
  [3830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 55),
  [3832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 55),
  [3834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [3836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [3838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 54),
  [3840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 54),
  [3842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 61),
  [3848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 53),
  [3850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 53),
  [3852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 125),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 125),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [3862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 148),
  [3864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 148),
  [3866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 124),
  [3868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 124),
  [3870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 116),
  [3872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 116),
  [3874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 111),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 111),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [3880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 121),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 121),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 58),
  [3890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 25),
  [3892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 26),
  [3894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 25),
  [3896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [3902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 112),
  [3904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [3907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 70),
  [3909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 70),
  [3911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 111),
  [3913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 111),
  [3915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [3922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [3924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 110),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 110),
  [3928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 109),
  [3930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 109),
  [3932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 25), REDUCE(sym_object_pattern, 3, .production_id = 26),
  [3935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 5),
  [3937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 5),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 21),
  [3941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 94),
  [3943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .dynamic_precedence = -1, .production_id = 94),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 23),
  [3947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 6),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 6),
  [3951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 25),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 25),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [3957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 6, .dynamic_precedence = -1, .production_id = 134),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 6, .dynamic_precedence = -1, .production_id = 134),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 23),
  [3963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 96),
  [3965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 96),
  [3967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [3971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(90),
  [3974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, .production_id = 16),
  [3976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, .production_id = 16),
  [3978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 15),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 15),
  [3982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, .dynamic_precedence = -1, .production_id = 44),
  [3984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, .dynamic_precedence = -1, .production_id = 44),
  [3986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [3988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [3990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [3992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [3994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [3998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 155),
  [4000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [4002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [4004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(90),
  [4007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 135),
  [4009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 135),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [4047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(88),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 49),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 26),
  [4134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [4166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58), REDUCE(sym_assignment_expression, 3, .production_id = 58),
  [4169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 58),
  [4171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 75), REDUCE(sym_assignment_expression, 3, .production_id = 21),
  [4174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 75),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 49),
  [4180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 49), SHIFT(513),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [4193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [4201] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(86),
  [4208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(86),
  [4211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(86),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [4228] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [4244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 75), REDUCE(sym_assignment_expression, 3, .production_id = 58),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [4251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2629),
  [4254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2301),
  [4257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(274),
  [4262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2038),
  [4265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4204),
  [4268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3458),
  [4271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3459),
  [4274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2476),
  [4277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3595),
  [4280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2000),
  [4283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2001),
  [4286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2128),
  [4289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1748),
  [4292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2004),
  [4295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2129),
  [4298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2262),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [4303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(86),
  [4306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(88),
  [4309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(88),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [4314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(88),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [4331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 35),
  [4339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 35),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [4345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [4355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [4387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 51),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [4410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9),
  [4413] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 9), REDUCE(sym__primary_type, 1, .production_id = 51),
  [4417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(95),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(95),
  [4435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(95),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [4442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(95),
  [4445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 58),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [4449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(92),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 49),
  [4456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(92),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [4461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(92),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [4468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(92),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [4473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 35),
  [4475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 35),
  [4477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 51), REDUCE(sym__parameter_name, 2, .production_id = 35),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [4486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [4526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(85),
  [4529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [4531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [4533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(85),
  [4536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(85),
  [4539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 76),
  [4541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(85),
  [4544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [4549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 25), REDUCE(sym_object_pattern, 3, .production_id = 26),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [4558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 132),
  [4563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 132),
  [4565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [4570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [4573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [4577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 130),
  [4579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 130),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 90),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [4618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [4629] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [4643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 168),
  [4645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 168),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [4653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [4657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [4673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(89),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [4694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3390),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(89),
  [4733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(89),
  [4736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(89),
  [4739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 49), SHIFT(431),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [4814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(94),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 109), REDUCE(sym_class, 5, .production_id = 160),
  [4824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 109), REDUCE(sym_class, 5, .production_id = 160),
  [4827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 140), REDUCE(sym_class, 6, .production_id = 195),
  [4830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 140), REDUCE(sym_class, 6, .production_id = 195),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [4839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(94),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [4852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(94),
  [4855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [4857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [4859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [4861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [4889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 70),
  [4892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 11), REDUCE(sym_class, 3, .production_id = 70),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [4897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [4901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [4917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 98), REDUCE(sym_class, 5, .production_id = 158),
  [4920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 98), REDUCE(sym_class, 5, .production_id = 158),
  [4923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 99), REDUCE(sym_class, 5, .production_id = 159),
  [4926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 99), REDUCE(sym_class, 5, .production_id = 159),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [4931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [4937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [4949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [4953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [4957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [4967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 54), REDUCE(sym_class, 4, .production_id = 125),
  [4970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 54), REDUCE(sym_class, 4, .production_id = 125),
  [4973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 53), REDUCE(sym_class, 4, .production_id = 124),
  [4976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 53), REDUCE(sym_class, 4, .production_id = 124),
  [4979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 48), REDUCE(sym_class, 4, .production_id = 123),
  [4982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 48), REDUCE(sym_class, 4, .production_id = 123),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [4993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [4997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [4999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [5003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [5005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 8), SHIFT(94),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [5022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [5024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [5036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [5038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 25), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 26),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [5043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [5045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 25),
  [5049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4340),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [5067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [5071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [5077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 189),
  [5079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 189),
  [5081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 115),
  [5083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 115),
  [5085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 129),
  [5087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 129),
  [5089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 222),
  [5091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 222),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [5095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 255),
  [5097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 255),
  [5099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 254),
  [5101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 254),
  [5103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 198),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 198),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 221),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 221),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [5125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 241),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 241),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [5137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [5139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 164),
  [5141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 164),
  [5143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 264),
  [5145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 264),
  [5147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 150),
  [5149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 150),
  [5151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 77),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 77),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 242),
  [5157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 242),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [5163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [5167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [5169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [5173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [5199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [5207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [5223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [5225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [5233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [5235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [5237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [5245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [5247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [5251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [5253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [5255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 12),
  [5257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 12), SHIFT(3618),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4211),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 44),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [5368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 213),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [5384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3),
  [5386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3),
  [5388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 50), REDUCE(sym_jsx_namespace_name, 3),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 135),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [5439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [5449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 177),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 177),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [5473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 135),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [5477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 44),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [5489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 213),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [5541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 50), SHIFT(3912),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 44),
  [5546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 135),
  [5548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 44),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 135),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 213),
  [5558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 177),
  [5560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 213),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 177),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [5588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [5618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [5622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [5638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [5642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4303),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [5674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4397),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [5686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4288),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4298),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4300),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4072),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4304),
  [5714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2941),
  [5716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [5726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [5728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 26),
  [5730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [5732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [5734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [5738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [5740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4080),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [5752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [5754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [5756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93), SHIFT_REPEAT(2813),
  [5759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93), SHIFT_REPEAT(211),
  [5762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93),
  [5764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93),
  [5766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 2, .production_id = 93), SHIFT_REPEAT(2813),
  [5769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(207),
  [5772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(3113),
  [5775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2760),
  [5778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [5780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [5782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [5784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4065),
  [5788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [5790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 237),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4067),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4349),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4347),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [5810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [5822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [5824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [5830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [5844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 100),
  [5846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 230),
  [5848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [5852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 237),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [5892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 180),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 100),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [5912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [5916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 10),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [5928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(413),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 97),
  [5933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [5937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 143),
  [5939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 114),
  [5941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 139),
  [5943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [5947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 169),
  [5949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 149),
  [5951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [5959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 118),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [5963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 204),
  [5965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 205),
  [5967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 229),
  [5969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 243),
  [5971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 244),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [5975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [5977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 258),
  [5979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 263),
  [5981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 266),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [5985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [5987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [5989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [5991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [5993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [5995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [5997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [5999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [6001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(339),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [6034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 119),
  [6036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 119),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [6040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4243),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4079),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [6058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4091),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(271),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [6076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [6078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [6122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1200),
  [6125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [6129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 118),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [6135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [6143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2985),
  [6146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [6148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(239),
  [6151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [6165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [6167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [6171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4077),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [6181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 10),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [6193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4346),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [6309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 17),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [6325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [6327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 68),
  [6329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [6331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 102),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [6349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(819),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [6358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(907),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [6365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [6373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [6385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(971),
  [6388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [6390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [6392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [6400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [6406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 137),
  [6408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 80),
  [6410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(945),
  [6413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [6415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [6419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [6421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(925),
  [6424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3154),
  [6427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(875),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [6434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 170),
  [6436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 171),
  [6438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 173),
  [6440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 175),
  [6442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 179),
  [6444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 137),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [6448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 80),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [6454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 119),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 119),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [6460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [6466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 207),
  [6468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 211),
  [6470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 212),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [6482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 214),
  [6484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 173),
  [6486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 175),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [6494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(838),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 225),
  [6501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 227),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 228),
  [6505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 233),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 236),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [6515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 207),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [6519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 211),
  [6521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 246),
  [6523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 247),
  [6525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 249),
  [6527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 252),
  [6529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 233),
  [6531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 236),
  [6533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 256),
  [6535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 257),
  [6537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 261),
  [6539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 249),
  [6541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2),
  [6543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 2),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [6549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(845),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [6564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3),
  [6566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 3),
  [6568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [6570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, .production_id = 45),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__jsx_start_opening_element_repeat1, 1, .production_id = 45),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [6578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 18), SHIFT(855),
  [6581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [6589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 191),
  [6591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 191), SHIFT_REPEAT(3416),
  [6594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 191),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [6598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 101),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3756),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [6614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [6616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [6618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [6629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 141),
  [6631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 142),
  [6633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 142), SHIFT_REPEAT(450),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(956),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [6645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 153),
  [6647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 153),
  [6649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 154),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 154),
  [6653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 88),
  [6655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2814),
  [6658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [6698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 44),
  [6700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 26),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [6714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [6722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 226),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [6738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [6746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 37),
  [6748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [6756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [6760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [6762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [6766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(200),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [6775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [6777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 47),
  [6779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [6793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [6803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [6805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [6807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [6823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [6825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3512),
  [6828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [6830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3513),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [6837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 232),
  [6839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 206),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [6847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [6849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(2064),
  [6852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [6874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [6888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [6910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [6938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 73),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [6948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(3420),
  [6951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [6965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 92),
  [6967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(3422),
  [6970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [6976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 94),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [6996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [7008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [7034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [7042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 44),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [7054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 134),
  [7056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(185),
  [7059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [7067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [7079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 235),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [7095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 136),
  [7097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 114),
  [7099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [7101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 265),
  [7103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 138),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [7107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [7109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 81),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [7125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [7129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 262),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [7137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 260),
  [7139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 259),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [7149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [7151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [7167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 73),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [7173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(172),
  [7176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [7180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 248),
  [7182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 251),
  [7184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 250),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [7190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 245),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [7198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [7200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 80),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 172),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [7208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 174),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [7218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 176),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [7226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 229),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [7234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 234),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [7240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 231),
  [7242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(379),
  [7245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 149),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [7253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 169),
  [7255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 178),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [7289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 44),
  [7291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [7293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 73),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [7299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(804),
  [7302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [7304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [7308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(3940),
  [7311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [7319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [7323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 193), SHIFT_REPEAT(2257),
  [7326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 193),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [7330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 76),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [7336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 204),
  [7338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 205),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [7346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 210),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [7352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(2109),
  [7355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [7359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 209),
  [7361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 208),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [7371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, .production_id = 199),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [7383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [7389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 80),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [7397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [7411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 162),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [7435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 36),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [7449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [7451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 89),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [7459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 29),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [7465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 28),
  [7467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [7469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 30),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [7483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [7493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 46),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [7499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 131),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [7513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 95),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [7519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 79),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [7525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 73),
  [7527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 127),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [7555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4252),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [7569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [7571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [7575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [7577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [7587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 79),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [7591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [7593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [7595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [7603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [7615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 79),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [7629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [7639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [7649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 79),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [7653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [7699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [7715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [7723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import_export, 3),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [7763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [7767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [7771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [7805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [7899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [8025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [8033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [8135] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [8151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
